<?php
namespace SistemaQualidade\Repositories;

class Tiporesu extends \Doctrine\ORM\EntityRepository
{
    public static function retornaFaixaCriteriosRepository($arrayNravaliacao){
        // Retorna as faixas de criterios que pertencem a avaliacao informada
        // leonardocarvalho - 10/12/2014 - Adicionado parâmentro de NRORG
        $sqlFaixaCrit = "SELECT TIPORESU.CDTIPORESU, FAIXA.IDFAIXACRIRESUL, FAIXA.VRINIFAIXARESUL, FAIXA.VRFINFAIXARESUL,
                                CRITERIORESULT.NRCRITERIORESUL
                           FROM CRITERIORESULT, FAIXACRITRESULT FAIXA, AVALIACAOGERAL, TIPORESU
                          WHERE CRITERIORESULT.NRCRITERIORESUL   = AVALIACAOGERAL.NRCRITERIORESUL
                            AND CRITERIORESULT.NRCRITERIORESUL   = FAIXA.NRCRITERIORESUL
                            AND TIPORESU.CDTIPORESU              = FAIXA.CDTIPORESU
                            AND (AVALIACAOGERAL.NRORG            = FAIXA.NRORG          OR FAIXA.NRORG = 0)
                            AND (AVALIACAOGERAL.NRORG            = TIPORESU.NRORG       OR FAIXA.NRORG = 0)
                            AND (AVALIACAOGERAL.NRORG            = CRITERIORESULT.NRORG OR FAIXA.NRORG = 0)
                            AND AVALIACAOGERAL.NRAVALIACAO       = :P_NRAVALIACAO
                            AND AVALIACAOGERAL.NRORG             = :P_NRORG";
        $resultFaixaCrit = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlFaixaCrit, $arrayNravaliacao);
        return $resultFaixaCrit;
    }

    public static function retornaFaixaCriterios2014Repository($arrayNravaliacao){
        //Retorna as faixas de criterios que pertencem a avaliacao informada PARA 2014
        $sqlFaixaCrit = "SELECT TIPORESU.CDTIPORESU, 
                                FAIXACRITRESULT.IDFAIXACRIRESUL, FAIXACRITRESULT.VRINIFAIXARESUL, FAIXACRITRESULT.VRFINFAIXARESUL,
                                CRITERIORESULT.NRCRITERIORESUL
                            FROM CRITERIORESULT
                            INNER JOIN FAIXACRITRESULT
                             ON CRITERIORESULT.NRCRITERIORESUL   = FAIXACRITRESULT.NRCRITERIORESUL
                            INNER JOIN TMP_TABULACAO_TEK
                             ON CRITERIORESULT.NRCRITERIORESUL   = TMP_TABULACAO_TEK.NRCRITERIORESUL
                            INNER JOIN TIPORESU
                             ON TIPORESU.CDTIPORESU              = FAIXACRITRESULT.CDTIPORESU
                            INNER JOIN FAIXA_CARGO
                             ON FAIXA_CARGO.NRFAIXACARGO         = TMP_TABULACAO_TEK.NRFAIXACARGO
                            WHERE TMP_TABULACAO_TEK.NMAGRUPAMENTO = TRIM((SELECT NMAVALIACAO 
                                                                    FROM AVALIACAOGERAL 
                                                                    WHERE NRAVALIACAO = :P_NRAVALIACAO))
                            AND TMP_TABULACAO_TEK.NRFAIXACARGO    = :P_NRFAIXACARGO
                            AND TMP_TABULACAO_TEK.CDCARGO = :P_CDCARGO";
        $resultFaixaCrit = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlFaixaCrit, $arrayNravaliacao);
        return $resultFaixaCrit;
    }
    
    public static function retornaFaixaCriteriosAgrupamentoRepository($arrayNragrupquestava){
    //Retorna as faixas de criterios que pertencem ao agrupamento informado
    $sqlFaixaCrit = "SELECT TIPORESU.CDTIPORESU, 
                            FAIXACRITRESULT.IDFAIXACRIRESUL, FAIXACRITRESULT.VRINIFAIXARESUL, FAIXACRITRESULT.VRFINFAIXARESUL  ,
                            CRITERIORESULT.NRCRITERIORESUL
                       FROM CRITERIORESULT
                      INNER JOIN FAIXACRITRESULT
                         ON CRITERIORESULT.NRCRITERIORESUL   = FAIXACRITRESULT.NRCRITERIORESUL
                      INNER JOIN AGRUPQUESTAVAL
                         ON CRITERIORESULT.NRCRITERIORESUL   = AGRUPQUESTAVAL.NRCRITERIORESUL
                      INNER JOIN TIPORESU
                         ON TIPORESU.CDTIPORESU              = FAIXACRITRESULT.CDTIPORESU
                      WHERE AGRUPQUESTAVAL.NRAGRUPQUESTAVA   = :P_NRAGRUPQUESTAVA
                        AND AGRUPQUESTAVAL.NRAVALIACAO       = :P_NRAVALIACAO";
    $resultFaixaCrit = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlFaixaCrit, $arrayNragrupquestava);
    return $resultFaixaCrit;
    }
    
    public static function retornaFaixaCriteriosAgrupamento2014Repository($arrayNragrupquestava){
    //Retorna as faixas de criterios que pertencem ao agrupamento informado
    $sqlFaixaCrit = "SELECT TIPORESU.CDTIPORESU, 
                            FAIXACRITRESULT.IDFAIXACRIRESUL, FAIXACRITRESULT.VRINIFAIXARESUL, FAIXACRITRESULT.VRFINFAIXARESUL  ,
                            CRITERIORESULT.NRCRITERIORESUL
                        FROM CRITERIORESULT
                        INNER JOIN FAIXACRITRESULT
                         ON CRITERIORESULT.NRCRITERIORESUL   = FAIXACRITRESULT.NRCRITERIORESUL
                        INNER JOIN TMP_TABULACAO_TEK
                         ON CRITERIORESULT.NRCRITERIORESUL   = TMP_TABULACAO_TEK.NRCRITERIORESUL
                        INNER JOIN TIPORESU
                         ON TIPORESU.CDTIPORESU              = FAIXACRITRESULT.CDTIPORESU
                        INNER JOIN FAIXA_CARGO
                         ON FAIXA_CARGO.NRFAIXACARGO         = TMP_TABULACAO_TEK.NRFAIXACARGO
                        WHERE TMP_TABULACAO_TEK.NMAGRUPAMENTO = (SELECT NMAGRUPQUESTAVA 
                                                                FROM AGRUPQUESTAVAL 
                                                               WHERE NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA 
                                                                 AND NRAVALIACAO     = :P_NRAVALIACAO)
                        AND TMP_TABULACAO_TEK.NRFAIXACARGO    = :P_NRFAIXACARGO
                        AND TMP_TABULACAO_TEK.CDCARGO = :P_CDCARGO";
    $resultFaixaCrit = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlFaixaCrit, $arrayNragrupquestava);
    return $resultFaixaCrit;
    }
    
    public static function retornaFaixaCriteriosQuestaoRepository($arrayNrquestavalia){
    //Retorna as faixas de criterios que pertencem a questao informada
    $sqlFaixaCrit = "SELECT TIPORESU.CDTIPORESU, 
                            FAIXACRITRESULT.IDFAIXACRIRESUL, FAIXACRITRESULT.VRINIFAIXARESUL, FAIXACRITRESULT.VRFINFAIXARESUL,
                            CRITERIORESULT.NRCRITERIORESUL
                       FROM CRITERIORESULT
                      INNER JOIN FAIXACRITRESULT
                         ON CRITERIORESULT.NRCRITERIORESUL   = FAIXACRITRESULT.NRCRITERIORESUL
                      INNER JOIN QUESTAVALIACAO
                         ON CRITERIORESULT.NRCRITERIORESUL   = QUESTAVALIACAO.NRCRITERIORESUL
                      INNER JOIN TIPORESU
                         ON TIPORESU.CDTIPORESU              = FAIXACRITRESULT.CDTIPORESU
                      WHERE QUESTAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                        AND QUESTAVALIACAO.NRQUESTAVALIA   = :P_NRQUESTAVALIA";
    $resultFaixaCrit = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sqlFaixaCrit, $arrayNrquestavalia);
    return $resultFaixaCrit;
    }
}