<?php
/**
 * CalculoAbstract.
 *
 * @package Logic
 * @author  alessandrobartels
 */
abstract class CalculoAbstract {

    /* @todo variaveis de ambiente */
    protected $_nrorg; /* Organizacao de Trabalho */
    protected $_nrOrgPadrao; /* Organizacao Padrao */

    protected $_mes_competencia;
    protected $_mes_competencia_int; // somente o mes.
    protected $_ult_dia_mes;
    protected $_dt_pagamento; /* Sera usado posteriormente */
    protected $_ultPagamento;
    protected $_simulacao;
    protected $_parcial;
    protected $_idDebug;
    protected $_id_retrocesso;
    protected $_ambiente_salario_operador;
    protected $_tp_modalidade_salario_operador;
    protected $_baseCorrespPeriodoIntegral;
    protected $_nr_tipo_calculo;
    protected $_listaProcessos; // Processos a serem calculados para cada tipo de vinculo
    protected $_listaDireitos; // Direito a serem calculados para cada tipo de rescisao

    protected $_recalculo = false;
    protected $_salario;
    protected $_tipoSalario;
    protected $_dias_trabalhados; /* pode ser marretado para os mensalista com salario hora */
    protected $_dias_remuneracao; /* 30 para ferias, adiantamento e 13 - 30 ou menos para Folha, Rescisão e Res. complementar BORBA 12/04/2013*/
    protected $_dias_normais; /* dias uteis + dias rsr */
    protected $_dias_uteis; /* dias uteis */
    protected $_dias_rsr; /* dias de repouso semanal remunerado */
    protected $_dias_afastados;
    protected $_dias_ferias;
    protected $_dias_feriado;
    protected $_jornada_diaria;
    protected $_sit_func_resumo = array();
    protected $_primeiroDiaAno;
    protected $_inicio_periodo;
    protected $_fim_periodo;

    protected $_dia_fecha_apuracao; /*BORBA 09/01/2015 Para atender a solicitação 155798 */
    protected $_ini_periodo_apura;  /*BORBA 09/01/2015 Para atender a solicitação 155798 */
    protected $_fim_periodo_apura;  /*BORBA 09/01/2015 Para atender a solicitação 155798 */

    protected $_fechamento;

    /* Pessoa */
    protected $_pessoa;
    protected $_pessoah;


    /* Vinculo */
    protected $_vinculo;
    protected $_nrTpVinculoAnterior;
    protected $_escalam;
    protected $_situacao_funcional;
    /** @var $_alteracao_situacao_funcional GpealtesitufuncEntity*/
    protected $_alteracao_situacao_funcional;
    protected $_alteracaoSalario;
    protected $_alteracaoOcupacao;
    protected $_movimentosVinculo;

    /* Calculo */
    protected $_tipo_calculo;
    protected $_obj_tipo_calculo;
    protected $_tpCalcMov;
    protected $_nrTipoModalidadeCalculo;
    protected $_nrOcorrenciaCalculo;
    protected $_movimentoPrincipal;
    protected $_movimentoAuxiliar;

    /* Itens de calculo */
    /** @var  $_itens_calculo_principal FpaitecalcfolhaEntity*/
    protected $_itens_calculo_principal;
    /*BORBA 27/11/2014 Para atender a solicitação 153873 */
    protected $_itens_salario_maternidade;
    protected $_itens_adiantamento_demonstra;
    protected $_itens_adiantamento_ma; /* Adiantamento do mes anterior */
    protected $_itens_ferias_mc; /* Ferias do mes corrente */
    protected $_itens_ferias_ma; /* Ferias do mes anterior */
    protected $_itens_ferias_maa; /* Ferias do mes anterior ao anterior */
    protected $_itens_provisao_mes_anterior;
    protected $_itens_aviso_previo;
    protected $_itens_ferias_vencidas_rescisao;
    /** @var $_itens_ferias_proporcionais_rescisao FpaitecalcfolhaEntity*/
    protected $_itens_ferias_proporcionais_rescisao;
    protected $_itens_13sal_resc;
    protected $_itens_13sal_demonstra;
    protected $_itens_origem;

    protected $_media;

    /* Ferias */
    protected $_valores_referencia;
    /** @var $_ferias FpaferiasEntity */
    protected $_ferias;
    /** @var $_gozo_ferias FpagozoferiasEntity */
    protected $_gozo_ferias;
    protected $_tpFeriasVinc;
    protected $_demonstraFeriasResumo = array();

    protected $_faltas_intervalo;

    /* Evento */
    /*BORBA 27/11/2014 Para atender a solicitação 153873 */
    protected $_eventomMedia;
    protected $_eventom;
    protected $_eventoRelacionado;  // Receberá os eventos relacionados ao vínculo, estrutura e ocupação
    /** @var $_assoc_eventos \FpaassoceventoEntity */
    protected $_assoc_eventos;
    protected $_sit_evento;
    protected $_itemGrupo; // Relacionado com Grupo de Incidencias
    protected $_vincEvento; // Relacionado com Associacao Vinculo Evento - (Fpavincevento)
    protected $_ocupacaoEvento; // Relacionado com Associacao Ocupacao Evento - (Fpaocupaevento)
    protected $_estruturaEvento; // Relacionado com Associacao Estrutura Evento - (Fpaestruturaevento)    BORBA 07/03/2013

    /* Regra */
    protected $_regram;
    /** @var $_calculo_regra CalculoRegra */      //BORBA 12/03/2013
    protected $_calculo_regra;
    protected $_tpCalcRegra;

    /* Estrutura */
    protected $_estrutura;

    /* Parametros */
    protected $_paramCalculo;

    protected $_idTipoArredonda;
    protected $_nrDigitoArredonda;
    protected $_nrLimiteArredonda;
    protected $_nrGrupoIncidencia;
    protected $_nrControleAdmissao;
    protected $_idIRAcumulaRecMinimo;
    protected $_percentualAdiantamento;
    protected $_nrDiasMinAdiantamento;
    protected $_idRecAdianPriMes; //BORBA 30/07/2013
    protected $_nrControleFerias; //BORBA 04/08/2014
    protected $_nrControleAfastamento; //BORBA 04/08/2014

    protected $_vrPercentualProvisao;
    protected $_nrDiasFeriaProv;  //BORBA 06/11/2013

    /* Calendario */
    protected $_nrCalendario;
    protected $_nrCalendarioAnterior;
    protected $_calendario;

    /**
     * @author: Matheus Silva
     * Cálculo na ocorrência diferente de 1
     */
    protected $_ocorrencia;


    /**
     * Construtor.
     *
     * @param Parametros $parametro       Instancia de Parametros.
     * @param TkEntity   $formulario      Instancia de TkEntity (Pode variar em FpaFormcalculoEntity ou FormFeriasEntity).
     * @param integer    $nr_tipo_calculo Numero do Tipo de calculo.
     * @param boolean    $simulacao       Flag de Simulacao de Calculo.
     * @param boolean    $parcial         Flag de calculo parcial.
     */
    public function __construct(Parametros $parametro, TkEntity $formulario, $nr_tipo_calculo, $simulacao, $parcial){

        $this->_nrorg = $parametro->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $parametro->getNrOrgPadrao();
        $this->_mes_competencia = $parametro->getMesCompetencia(); // $mes_competencia;.
        $this->_mes_competencia_int = $parametro->getMesCompetencia()->toValue(TkDateTime::MONTH);
        $this->_idDebug = $parametro->getIdDebug();
        $this->_ambiente_salario_operador = $parametro->ambienteSalarioOperador();
        $this->_tp_modalidade_salario_operador = $parametro->getTipoModalidadeSalario();


        $this->_nr_tipo_calculo = $nr_tipo_calculo;
        $this->_nrTipoModalidadeCalculo = $parametro->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalculo = $parametro->getNrOcorrenciaCalculo();
        $this->_simulacao = $simulacao;
        $this->_parcial = $parcial;

        $this->_dt_pagamento = $formulario->getDtpagamento(); // $dt_pagamento; /* Usado futuramente */
        $this->_ultPagamento = $formulario->getIdultpgtomes(); // ultPagamento;
        $this->_id_retrocesso = $formulario->getIdretrocesso(); // id_retrocesso;.
        $this->_ult_dia_mes = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
        $this->_ult_dia_mes->addMonth(1)->subDay(1); /* ultimo dia do mes de competencia*/

        $this->_primeiroDiaAno = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
        $this->_primeiroDiaAno->setMonth(1)->setDay(1);

        $this->_inicio_periodo = new TkDateTime($this->_mes_competencia, TkDateTime::FORMAT_DATE);
        $this->_fim_periodo =  new TkDateTime($this->_ult_dia_mes, TkDateTime::FORMAT_DATE);

        /*BORBA 27/11/2014 Para atender a solicitação 153873 */
        $this->_itens_salario_maternidade = new FpaitecalcfolhaEntity;
        $this->_itens_origem = new FpaitecalcfolhaEntity;
        $this->_itens_aviso_previo = new FpaitecalcfolhaEntity;
        $this->_itens_ferias_vencidas_rescisao = new FpaitecalcfolhaEntity;
        $this->_itens_13sal_resc = new FpaitecalcfolhaEntity;
        $this->_itens_ferias_proporcionais_rescisao = new FpaitecalcfolhaEntity;
        $this->_itens_provisao_mes_anterior = new FpaitecalcfolhaEntity;

        // Relacionamento Tipo Ferias x Tipo Vinculo.
        $this->_tpFeriasVinc = new FpaTpferiasvincEntity();

//        $this->_valores_referencia = new FpavalorrefeEntity;
        $this->_valores_referencia = new FpaValorreferenciamEntity($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia);
        $this->_sit_evento = new GpesiteventoEntity;
        $this->_fechamento = new Fechamento($this->_nrorg, $this->_nr_tipo_calculo, $this->_mes_competencia);

        /* Pessoa */
        $this->_pessoa = TkDI::getContainer()->pessoa;
        /* $this->_pessoah = new GpepessoahEntity(null, $this->_nrorg, $this->_mes_competencia); */

        /* Vinculo */
        $this->_nrTpVinculoAnterior = -1;
        $this->_alteracaoSalario = new GpealtesalarioEntity(null, $this->_nrorg);
        $this->_alteracaoOcupacao = new GpeAlteocupacaoEntity();
        $this->_movimentosVinculo = new GpemovimentacaoEntity();   //BORBA 07/03/2013

        /* Media */
        $this->_media = new MediaEventosIntervalo(
            $this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_dt_pagamento
        );

        /*BORBA 27/11/2014 Para atender a solicitação 153873 */
        /* Itens da média */
        $this->_eventomMedia = new FpaeventomEntity(
            null, $this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_dtPagamento
        );

        /* Container*/
        $this->_vinculo = TkDI::getContainer()->vinculom;
        $this->_assoc_eventos = TkDI::getContainer()->assoc_eventos;
        $this->_eventom = TkDI::getContainer()->eventom;
        $this->_escalam = TkDI::getContainer()->escalam;
        $this->_situacao_funcional = TkDI::getContainer()->situacao_funcional;
        $this->_alteracao_situacao_funcional = TkDI::getContainer()->alteracao_situacao_funcional;
        $this->_ferias = TkDI::getContainer()->ferias;
        $this->_gozo_ferias = TkDI::getContainer()->gozo_ferias;
        $this->_faltas_intervalo = TkDI::getContainer()->faltas_intervalo;
        $this->_tipo_calculo = TkDI::getContainer()->tipo_calculo;
        $this->_obj_tipo_calculo = $this->_tipo_calculo->retornaTipoCalculo($this->_nr_tipo_calculo);
        $this->_paramCalculo = TkDI::getContainer()->param_calculo;

        /* Itens de Grupo */
        $this->_itemGrupo = new FpaGrpitemEntity();

        /* Associacoes de Eventos Relacionados */
        $this->_vincEvento = new FpaVinceventoEntity();
        $this->_ocupacaoEvento = new FpaOcupaeventoEntity();
        $this->_estruturaEvento = new FpaEstruteventoEntity(); // BORBA 06/02/2013

        /* Estrutura */
        $this->_estrutura = new EstruturamEntity(null, $this->_nrorg, $this->_mes_competencia);

        /* Parametros */
        /*  $this->_nrParamEstruturaAnterior = -1;
        $this->_nrParamFolhaAnterior = -1;
        $this->_paramEstrutura = new GpeParamestrutmEntity();
        $this->_paramFolha = new FpaParamfolhamEntity();
        */



        /* Calendario */
        $this->_nrCalendarioAnterior = -1;
        $this->_calendario = new CalendarioLogic($this->_nrorg, $this->_nrOrgPadrao);

        $this->_ocorrencia = \FPA::getOcorrenciaCalculo();

    }


    /**
     * Retorna vinculo.
     *
     * @return GpevinculomEntity
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getVinculo(){
        return $this->_vinculo;
    }


    /**
     * Enter description here ...
     *
     * @return GpealtesalarioEntity
     */
    public function getAlteracaoSalario(){
        return $this->_alteracaoSalario;
    }


    /**
     * Retorna evento.
     *
     * @return FpaeventomEntity
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getEventom(){
        return $this->_eventom;
    }


    /**
     * Retorna item Calculo.
     *
     * @return FpaitecalcfolhaEntity
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getItensCalculoPrincipal(){
        return $this->_itens_calculo_principal;
    }


    /**
     * Retorna Tipo de Movimento Calculo.
     *
     * @return FpatpcalcmovEntity
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getTpCalcMov(){
        return $this->_tpCalcMov;
    }


    /**
     * Retorna Regra.
     *
     * @return FpaRegramEntity
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getRegram(){
        return $this->_regram;
    }


    /**
     * Enter description here ...
     *
     * @return FpaTpcalcregraEntity
     */
    public function getTpCalcRegra(){
        return $this->_tpCalcRegra;
    }


    /**
     * Retorna Numero da Organizacao de trabalho.
     *
     * @return integer
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getNrorg(){
        return $this->_nrorg;
    }


    /**
     * Retorna Numero da Organizacao de trabalho.
     *
     * @return string
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getMesCompetencia(){
        return $this->_mes_competencia->toString(TkDateTime::FORMAT_DATE);
    }


    /**
     * Retorna valor da jornada diaria de trabalho.
     *
     * @return float
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getJornadaDiaria(){
        return $this->_jornada_diaria;
    }

    /**
     * Retorna numero de dias remunerados.
     *
     * @return integer
     *
     * @author  brunoborba - 12/04/2013
     * 30 para ferias, adiantamento e 13 - 30 ou menos para Folha, Rescisão e Res. complementar BORBA 12/04/2013
     */
    public function getDiasRemuneracao(){
        return $this->_dias_remuneracao;
    }

    /**
     * Retorna numero de dias trabalhados.
     *
     * @return integer
     *
     * @author  leandroafonso
     */
    public function getDiasTrabalhados(){
        return (int)$this->_dias_trabalhados;
    }


    /**
     * Retorna numero de dias trabalhados.
     *
     * @return integer
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getDiasNormais(){
        return $this->_dias_normais;
    }

    /**
     * Retorna numero de dias DSR.
     *
     * @return integer
     *
     * @author  marcelosilva - 20-01-2015
     */
    public function getDiasDSR(){
        return $this->_dias_rsr;
    }		

    /**
     * Retorna numero de dias de ferias.
     *
     * @return integer
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getDiasFerias(){
        return $this->_dias_ferias;
    }


    /**
     * Retorna numero de dias afastados.
     *
     * @return integer
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getDiasAfastados(){
        return $this->_dias_afastados;
    }

    /**
     * Retorna numero do tipo de calculo.
     *
     * @return integer
     *
     * @author  alessandrobartels / brunofeliciano - 12/08/2011
     */
    public function getNrTipoCalculo(){
        return $this->_nr_tipo_calculo;
    }


    /**
     * Enter description here ...
     *
     * @return float
     *
     * @author  alessandrobartels - 26/12/2011
     */
    public function getSalario(){
        return $this->_salario;
    }


    /**
     * Enter description here ...
     *
     * @param array $listaProcessos Lista de processos a serem calculados
     *
     * @return void
     */
    public function setListaProcessos($listaProcessos){
        $this->_listaProcessos = $listaProcessos;
    }


    /**
     * Enter description here ...
     *
     * @param array $listaDireitos Lista de direitos a serem calculados (no caso de rescisao)
     *
     * @return void
     */
    public function setListaDireitos($listaDireitos){
        $this->_listaDireitos = $listaDireitos;
    }
}