/* Tabela TPDOCTRANSAP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela TPDOCTRANSAP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela TPDOCTRANSAP utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_ADM_TPDOCTRANSAP
AFTER DELETE OR INSERT OR UPDATE
ON TPDOCTRANSAP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN

      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || 'E/S=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOperacao=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Produto=' || :OLD.CDPRODUTO;
      END IF;

      IF :OLD.CDTIPDOCUSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Doc=' || :OLD.CDTIPDOCUSAP;
      END IF;

      IF :OLD.CDTIPTRANSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Trans=' || :OLD.CDTIPTRANSAP;
      END IF;

      IF :OLD.IDFORMPGTSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Pag=' || :OLD.IDFORMPGTSAP;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER || :OLD.CDPRODUTO || :OLD.IDFORMPGTSAP;
/*      V_CDFILLOGOPER := :OLD.CDFILIAL; */
   ELSE
      IF UPDATING THEN

         IF (:OLD.IDENTRSAIDOP <> :NEW.IDENTRSAIDOP) OR
            (:OLD.CDTIPOOPER   <> :NEW.CDTIPOOPER)   OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO)    OR
            (:OLD.CDTIPDOCUSAP <> :NEW.CDTIPDOCUSAP) OR
            (:OLD.CDTIPTRANSAP <> :NEW.CDTIPTRANSAP) OR
            (:OLD.IDFORMPGTSAP <> :NEW.IDFORMPGTSAP) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER || :OLD.CDPRODUTO || :OLD.IDFORMPGTSAP;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.IDENTRSAIDOP || :NEW.CDTIPOOPER || :NEW.CDPRODUTO || :NEW.IDFORMPGTSAP;
      END IF;

      IF :NEW.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || 'E/S=' || :NEW.IDENTRSAIDOP;
      END IF;

      IF :NEW.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOperacao=' || :NEW.CDTIPOOPER;
      END IF;

      IF :NEW.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Produto=' || :NEW.CDPRODUTO;
      END IF;

      IF :NEW.CDTIPDOCUSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Doc=' || :NEW.CDTIPDOCUSAP;
      END IF;

      IF :NEW.CDTIPTRANSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Trans=' || :NEW.CDTIPTRANSAP;
      END IF;

      IF :NEW.IDFORMPGTSAP IS NOT NULL THEN
         V_DESC := V_DESC || ' Pag=' || :NEW.IDFORMPGTSAP;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('TPDOCTRANSAP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ADM_TPDOCTRANSAP','4.09.060'); END;
/

