var NecessidadeDeComprasController = function (ScreenService, General, restEngine, templateManager, ZHPromise, CalculoDaNecessidadeDeComprasController, MessageService) {
    
    var self = this;
    var boAltNece;
    
    const permissionsArray = {
        "INCLUIR_PRODUTO"       : false,
        "EXCLUIR_PRODUTO"       : false,
        "ALTERAR_PRODUTO"       : false,
        "AUMENTAR_QUANTIDADE"   : false,
        "DIMINUIR_QUANTIDADE"   : false,
        "INCLUIR_DTENTREGA"     : false,
        "EXCLUIR_DTENTREGA"     : false,
        "ALTERAR_DTENTREGA"     : false,
        "percentAumentar"       : undefined,
        "percentDiminuir"       : undefined
    };
    
    var parasupri;
    
    this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS = "_CHECK_ALL_ROWS";
    
    this.voltar = function(widget) {
        General.backOrCancel(widget);
    };
    
    this.back = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.setCheckedRows = function(widget) {
        widget.updateCheckedRows();
    };
    
    this.defineNivelProduto = function(widgetProduto) {
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = widgetProduto.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        var nivelProduto = mascaraProduto.length;
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });
        
    };
   
    
    /**
     * Cria um parâmetro no templateManger e atribui o valor recebido
     * como parâmetro.
     * 
     * @param {string} parameterName - nome do parâmetro que será
     * criado no templateManager.
     * 
     * @param {*} value - valor que será atribuido ao parâmetro criado
     * no templateManager.
    */
    this.setParameterOnTemplateManager = function(parameterName, value) {
        templateManager[parameterName] = value;
    };
    
    /**
     * Marca todas as linhas da widget recebida
     * como parâmetro.
     * 
     * @param {object} widget - widget que terá
     * todas as linhas marcadas.
    */
    this.checkAllRowsOnWidget = function(widget) {
        var widgetDataSource = widget.dataSource;
        
        widgetDataSource.addCheckedRows(widgetDataSource.data);
        widgetDataSource.updateCheckedRows();
        
        this.verifyPermissionsAfterSelect(widget);
    };
    
    function insereProduto(rowProduto, produtosNecessidade) {
        produtosNecessidade.push(rowProduto);
    }
    
    this.openSwipeProduto = function(widget) {
        var widgetProduto = widget.container.getWidget("insereProduto");
        const checkedRows = widget.getCheckedRows();
        
        ScreenService.openSwipe(widgetProduto);
        
        widgetProduto.newRow();
        widgetProduto.currentRow.__is_new = true;
        
        if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
            if(permissionsArray.INCLUIR_PRODUTO) {
                widgetProduto.getField("NMPRODUTO").readOnly = false;
            } else {
                widgetProduto.getField("NMPRODUTO").readOnly = true;
                
                if(checkedRows.length == 1) {
                    widgetProduto.currentRow.CDPRODUTO = checkedRows[0].CDPRODUTO;
                    widgetProduto.currentRow.CDARVPROD = checkedRows[0].CDARVPROD;
                    widgetProduto.currentRow.NMPRODUTO = checkedRows[0].NMPRODUTO;
                } else if(widget.dataSource.data[0]) {
                    widgetProduto.currentRow.CDPRODUTO = widget.dataSource.data[0].CDPRODUTO;
                    widgetProduto.currentRow.CDARVPROD = widget.dataSource.data[0].CDARVPROD;
                    widgetProduto.currentRow.NMPRODUTO = widget.dataSource.data[0].NMPRODUTO;
                }
            }
            if(permissionsArray.INCLUIR_DTENTREGA) {
                widgetProduto.getField("DTENTRNECCMP").readOnly = false;
            } else {
                widgetProduto.getField("DTENTRNECCMP").readOnly = true;
                
                if(checkedRows.length == 1) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(checkedRows[0].DTENTRNECCMP, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.dataSource.data[0]) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.dataSource.data[0].DTENTRNECCMP, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.DTINI) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.DTINI, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.DTFIM) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.DTFIM, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else {
                    widgetProduto.currentRow.DTENTRNECCMP = moment().format("DD/MM/YYYY");
                }
            }
        } else {
            widgetProduto.getField("NMPRODUTO").readOnly = false;
            widgetProduto.getField("DTENTRNECCMP").readOnly = false;
        }
        
        widgetProduto.activate();
    };
    
    function checkProdAtivo(row) {
        var deferred = ZHPromise.defer();
        
        General.callRestEngine('cmp_necessidadeCompras#/checkProdAtivo','Row',row).then(function(calback) {
            if(calback.dataset.resposta.length != 0){
                if(calback.dataset.resposta[0].IDPRODATIV !== 'A'){
                    deferred.reject(ScreenService.i18n("O produto está inativo para a unidade."));
                } else if(calback.dataset.resposta[0].IDPRODATIVPR !== 'S'){
                    deferred.reject(ScreenService.i18n("O produto está inativo!"));
                } else {
                    deferred.resolve();
                }
            } else {
                deferred.reject(ScreenService.i18n("O produto está inativo!"));
            }
        });
        
        return deferred;
    }
    
    function checkProdNeceComp(rowProduto, produtosNecessidade) {
        var cdproduto = rowProduto.CDPRODUTO;
        var dtentrneccmp = rowProduto.DTENTRNECCMP;
        var existeProduto = produtosNecessidade.filter(function(produto) {
            return cdproduto === produto.CDPRODUTO && dtentrneccmp.substr(0,10) === produto.DTENTRNECCMP.substr(0,10);
        });
        
        if(existeProduto.length) {
            throw ScreenService.i18n("O Produto já foi incluído para a data informada!");
        }
    }
    
    function validaData(dtini, dtfim, dtentrega) {
        dtini = moment(dtini, 'DD/MM/YYYY');
        dtfim = moment(dtfim, 'DD/MM/YYYY');
        dtentrega = moment(dtentrega, 'DD/MM/YYYY');
        
        return dtentrega.isBetween(dtini, dtfim, undefined, '[]');
    }
    
    this.salvaProduto = function(widgetProduto) {
        var widgetNecessidade = widgetProduto.container.getWidget('gridNeceComp');
        var produtosNecessidade = widgetNecessidade.dataSource.data;
        var rowProduto = widgetProduto.currentRow;
        
        rowProduto.CDFILIAL         = widgetNecessidade.CDFILIAL;
        rowProduto.NRNECECOMP       = widgetNecessidade.NECECOMP;
        rowProduto.DTPRIUTIPROD     = rowProduto.DTENTRNECCMP;
        rowProduto.QTPRCNVCOMPRBKP  = rowProduto.QTPRCNVCOMPR;
        
        if(widgetProduto.isValid() && validaData(widgetNecessidade.DTINI, widgetNecessidade.DTFIM, rowProduto.DTENTRNECCMP)) {
            checkProdAtivo(rowProduto).then(function() {
                
                checkProdNeceComp(rowProduto, produtosNecessidade);
                
                insereProduto(rowProduto, produtosNecessidade);
                
                ScreenService.closeSwipe();
                
                widgetNecessidade.activate();
                widgetNecessidade.dataSource.addCheckedRows(produtosNecessidade);
                widgetNecessidade.updateCheckedRows();
                
                self.verifyPermissionsAfterSelect(widgetNecessidade);
                
            }).catch(function(error) {
                ScreenService.showMessage(error);
            });
        } else {
            MessageService.showMessageByCode("DT_FORA_PER");
        }
    };
    
    this.salvaQuantidade = function(widgetNecessidade) {
        widgetNecessidade.commitInlineEdit();
        widgetNecessidade.ALTERADO = true;
    };
    
    /**
     * Verifica se o parâmetro, referente a widget recebida como
     * parâmetro, no templateManager permite que todas as linhas da
     * widget sejam marcadas, se permitir, todas as linhas são marcadas
     * e logo após, o parâmetro é definido como "false", pois pela regra
     * de negócio, está rotina é realizada apenas uma vez.
     * 
     * @param {object} widget - widget que terá suas linhas marcadas.
    */
    this.checkAllWidgetRowsByTemplateManagerParam = function(widget){
        
        var parameterName = widget.name + this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS;
        
        if(Boolean(templateManager[parameterName])){
            
            this.checkAllRowsOnWidget(widget);
            this.setParameterOnTemplateManager(parameterName, false);
            
        }    
        
    };
    
    /**
     * define "true" para os parâmetros que indicam se as widgets
     * de detalhes terão todas as linhas selecionadas.
    */
    this.defineParamToCheckAllDetailsWidgetsRows = function(){
        
        var widget =  this.getWidgetOnCurrentContainerByName("gridNeceComp");
        var parameterName = widget.name + this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS;
        this.setParameterOnTemplateManager(parameterName, true);

    };
    
    /**
     * Retorna a widget com o nome recebido como parâmetro do container
     * ativo.
     * 
     * @param {string} widgetName - nome da widget a ser retornada.
     * 
     * @param {object} widget encontrada.
    */
    this.getWidgetOnCurrentContainerByName = function(widgetName){
        return templateManager.container.getWidget(widgetName);
    };
    
    this.openDetalhesProduto = function(widget){
        ScreenService.openSwipe(widget.container.getWidget("detalhesProduto"));
        if(widget.container.getWidget("detalhesProduto").dataSourceFilter[3] == undefined){
            widget.container.getWidget("detalhesProduto").dataSourceFilter.push(    			
                    {
        				'name': 'CDPRODNECCMP',
        				'operator': '=',
        				'value': widget.currentRow.CDARVPROD
        			}
        	);
        }else{
            widget.container.getWidget("detalhesProduto").dataSourceFilter.pop();
            widget.container.getWidget("detalhesProduto").dataSourceFilter.push(    			
                    {
        				'name': 'CDPRODNECCMP',
        				'operator': '=',
        				'value': widget.currentRow.CDARVPROD
        			}
        	);
        }
        widget.container.getWidget("detalhesProduto").reload();
        widget.container.getWidget("detalhesProduto").activate();
    };
    
    this.voltarCalculo = function(widget) {
        
        var widgetData = widget.dataSource.data;
        var calculationWindowName = "cmp_necessidadeCompras#calculo_da_necessidade_de_compras";
        
        this.defineParamToCheckAllDetailsWidgetsRows();
        
        if(widgetData.length){
            
            var row = [widgetData[0].NRNECECOMP];
            
            General.callRestEngine('cmp_necessidadeCompras#/deleteNececomp','Row',row).then(function(calback) {
                ScreenService.openWindow(calculationWindowName).then(function() {
                    delete templateManager.containers['cmp_necessidadeCompras#necessidade_de_compras'];
                });
            });
            
        } else {
            ScreenService.openWindow(calculationWindowName).then(function() {
                delete templateManager.containers['cmp_necessidadeCompras#necessidade_de_compras'];
            });
        }
        
	};
    
    this.gerarSolicitacao = function(widget) {
        var produtosSelecionados = widget.getCheckedRows();
        
        if(produtosSelecionados.length > 0 ) {
            var produtosNaoZerados = produtosSelecionados.filter(value => value.QTPRCNVCOMPR === "0,000");
            
            if(produtosNaoZerados.length > 0) {
                ScreenService.confirmMessage('Concluir processo\n Obs.: Produtos com quantidades zeradas serão excluídos, deseja continuar?', 'question', function() {
                    ScreenService.confirmMessage('Deseja gerar a solicitação?', 'question', function(success) {
                        var extra = CalculoDaNecessidadeDeComprasController.getExtra();
                        var nececomp = widget.dataSource.data[0].NRNECECOMP;
                        var msg = ScreenService.i18n('Cálculo da Necessidade de Compras-Extra');
                        var filnececomp = widget.CDFILIAL;
                        var row = {'PRODUTOS': produtosNaoZerados, 'NRNECECOMP': nececomp, 'CDFILNECECMP': filnececomp, 'EXTRA': extra, 'MENSAGEM': msg};
                       
                       General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp', 'Row', row).then(function(response) {
                           MessageService.showMessageByCode("SOLCMP_SUCCESS").then(() => {
                               self.openPreviaCalculoNecessidadeCompras(nececomp);
                           });
                        }.bind()).catch(function(error) {
                            MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
                        });
                    });
                });
            } else {
                ScreenService.confirmMessage('Deseja gerar a solicitação?', 'question', function(success) {
                    var extra = CalculoDaNecessidadeDeComprasController.getExtra();
                    var nececomp = widget.dataSource.data[0].NRNECECOMP;
                    var msg = ScreenService.i18n('Cálculo da Necessidade de Compras-Extra');
                    var filnececomp = widget.CDFILIAL;
                    var allProducts = widget.dataSource.data;
                    var row = {'PRODUTOS': allProducts, 'NRNECECOMP': nececomp, 'CDFILNECECMP': filnececomp, 'EXTRA': extra, 'MENSAGEM': msg};
                   
                   General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp', 'Row', row).then(function(response) {
                       MessageService.showMessageByCode("SOLCMP_SUCCESS").then(() => {
                           self.openPreviaCalculoNecessidadeCompras(nececomp);
                       });
                    }.bind()).catch(function(error) {
                        MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
                    });
                });
            }
        } else{
            MessageService.showMessageByCode("NO_DATA_GER_SOL");
        }
        
    };
    
    this.setVisibilidade = function(args) {
       var widgetNeceComp = args.owner.getWidget('gridNeceComp');
       
       General.callRestEngine('cmp_necessidadeCompras#/getPermissoes', 'Row', {}).then(function(callback) {
            const permissoes = callback.dataset.permissoes;
            
            if(permissoes) {
                permissoes.forEach(function (value) {
                    permissionsArray[value.IDAUTNECECOMP] = true;
                    
                    if(value.IDAUTNECECOMP === 'AUMENTAR_QUANTIDADE') {
                        permissionsArray.percentAumentar = value.PEALTEQTDESOLI;
                    }
                    if(value.IDAUTNECECOMP === 'DIMINUIR_QUANTIDADE') {
                        permissionsArray.percentDiminuir = value.PEALTEQTDESOLI;
                    }
                });
            }
            
            General.callRestEngine('cmp_necessidadeCompras#/retornaParasupriNececomp', 'Row', []).then(function(response) {
                parasupri = response.dataset.parasupri.length ? response.dataset.parasupri[0] : false;
                
                if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                    widgetNeceComp.getField('QTPRCNVCOMPR').inlineEditable = permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE;
                    if(permissionsArray.INCLUIR_PRODUTO && permissionsArray.INCLUIR_DTENTREGA) {
                        widgetNeceComp.getAction('incluir').isVisible = true;
                    } else {
                        widgetNeceComp.getAction('incluir').isVisible = false;
                    }
                    widgetNeceComp.getAction('excluir').isVisible = permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA;
                } else {
                    widgetNeceComp.getField('QTPRCNVCOMPR').inlineEditable = true;
                    widgetNeceComp.getAction('incluir').isVisible = true;
                    widgetNeceComp.getAction('excluir').isVisible = true;
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.openPreviaCalculoNecessidadeCompras = function(numeroPrevia) {
        ScreenService.openWindow('cmp_necessidadeCompras#cmp03800_previa_do_calculo_da_necessidade_de_compras').then(function() {
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').setValue(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').value(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').defaultValue = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').NRNECECOMP = numeroPrevia;
            
            General.callRestEngine('cmp_necessidadeCompras#/crud/numPrevia', 'FilterData', {}).then(function(response) {
                const dataNumPrevia = response.dataset.numPrevia;
                let dadosPrevia = dataNumPrevia.filter(function(previa) {
                    return previa.NRNECECOMP === numeroPrevia;
                });
                dadosPrevia = dadosPrevia.length ? dadosPrevia[0] : dadosPrevia;
                
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').setValue({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').value({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').defaultValue = {
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                };
                templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = dadosPrevia.NRNECECOMP;
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.start = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.end = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedStart = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedEnd = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTINI = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTFIN = dadosPrevia.DTFIN.substr(0, 10);
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODINICIAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODFINAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMFILIAL').validations;
            });
        });
    };
    
    this.onQuantityChangeVerifyPermissions = function(args) {
        const widget = args.owner.field.widget;
        
        if((permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA) && widget.currentRow.QTPRCNVCOMPR_inline === "0,000") {
            widget.commitInlineEdit();
            widget.list();
        } else if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
            if(!widget.currentRow.QTPRCNVCOMPRBKP)
                widget.currentRow.QTPRCNVCOMPRBKP = widget.currentRow.QTPRCNVCOMPR.toString();
                
            if(typeof(widget.currentRow.QTPRCNVCOMPRBKP) != "string")
                widget.currentRow.QTPRCNVCOMPRBKP = widget.currentRow.QTPRCNVCOMPRBKP.toString();
            
            var percentToBlock;
            var newQTPRCNVCOMPR = widget.currentRow.QTPRCNVCOMPR_inline.replaceAll('.', '').replaceAll(',', '.');
            var oldQTPRCNVCOMPR = widget.currentRow.QTPRCNVCOMPRBKP.replaceAll('.', '').replaceAll(',', '.');
            
            newQTPRCNVCOMPR = parseFloat(newQTPRCNVCOMPR);
            oldQTPRCNVCOMPR = parseFloat(oldQTPRCNVCOMPR);
            
            if(permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE) {
                if((newQTPRCNVCOMPR > oldQTPRCNVCOMPR) && permissionsArray.AUMENTAR_QUANTIDADE) {
                    if(permissionsArray.percentAumentar != null || permissionsArray.percentAumentar != undefined) {
                        percentToBlock = oldQTPRCNVCOMPR + (oldQTPRCNVCOMPR * (parseFloat(permissionsArray.percentAumentar) / 100));
                        
                        if(newQTPRCNVCOMPR > percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MAIOR_PERCENT");
                            widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                        }
                    }
                } else if((newQTPRCNVCOMPR < oldQTPRCNVCOMPR) && permissionsArray.DIMINUIR_QUANTIDADE) {
                    if(permissionsArray.percentDiminuir != null || permissionsArray.percentDiminuir != undefined) {
                        percentToBlock = oldQTPRCNVCOMPR - (oldQTPRCNVCOMPR * (parseFloat(permissionsArray.percentDiminuir) / 100));
                        
                        if(newQTPRCNVCOMPR < percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MENOR_PERCENT");
                            widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                        }
                    }
                } else if(newQTPRCNVCOMPR == oldQTPRCNVCOMPR) {
                    return;
                } else {
                    MessageService.showMessageByCode("WITHOUT_PERMISSION");
                    widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                }
            } else {
                MessageService.showMessageByCode("WITHOUT_PERMISSION");
                widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                widget.rollbackInlineEdit();
                widget.list();
            }
        }
    };
    
    this.excluirProduto = function(widget) {
        if(parasupri.IDBLOQALTNEC === 'S') {
            if(permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA) {
                MessageService.confirmMessageByCode("DELETE_ITEMS").then(confirmed => {
                    var listaProdutos = widget.dataSource.data.filter(function(row) {
                        return row.__isSelected != true;
                    });
                    
                    widget.dataSource.clearCheckedRows();
                    widget.dataSource.data = listaProdutos;
                });
            } else {
                MessageService.showMessageByCode("WITHOUT_PERMISSION");
            }
        } else {
            MessageService.confirmMessageByCode("DELETE_ITEMS").then(confirmed => {
                var listaProdutos = widget.dataSource.data.filter(function(row) {
                    return row.__isSelected != true;
                });
                
                widget.dataSource.clearCheckedRows();
                widget.dataSource.data = listaProdutos;
            });
        }
    };
    
    this.verifyPermissionsAfterSelect = function(widget) {
        const checkedRows = widget.getCheckedRows();
        
        if(checkedRows.length == 1) {
            if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                widget.getAction('incluir').isVisible = permissionsArray.INCLUIR_PRODUTO || permissionsArray.INCLUIR_DTENTREGA;
            } else {
                widget.getAction('incluir').isVisible = true;
            }
        } else {
            if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                widget.getAction('incluir').isVisible = false;
            } else {
                widget.getAction('incluir').isVisible = true;
            }
        }
    };
};

Configuration(function (ContextRegister) {
	ContextRegister.register('NecessidadeDeComprasController', NecessidadeDeComprasController);
});