function cmp09500_acompanhamento_de_solicitacao_de_comprasController(validateEngine, General, ScreenService, templateManager, restEngine, ZhFilterPreferences, ZhUtil, maskEngine, MessageService) {
    let self = this;
    
    
    this.geraRelatorio = function(widget){
        ScreenService.openWindow('cmp_fornecimento_emissaoAutorizacaoFornecimento#sup00700_emissao_de_solicitacao_cotacao_af').then(function() {
            var widAlteracao = templateManager.container.getWidget('sup00700_emissao_de_solicitacao_cotacao_af_widget');
            widAlteracao.ABERTA_POR = 'Acompanhamento de Solicitação de Compras';
        });
    };
    
    
    this.filtrar = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;

        if (self.validaProduto(filterRow.CDARVPRODINI, filterRow.CDARVPRODFIN)) {
            const widget = args.owner;
            const row = {};
            
            if (filterRow.CDARVPRODFIN) {
                const pad = 'ZZZZZZZZZZ';
                const str = filterRow.CDARVPRODFIN;
                filterRow.CDARVPRODFIN = str + pad.substr(0, pad.length - str.length);
            }
        
            row.CDFILSOLI = filterRow.CDFILSOLI;
            row.CDPRODINI = filterRow.CDARVPRODINI ? filterRow.CDARVPRODINI : null;
            row.CDPRODFIN = filterRow.CDARVPRODFIN ? filterRow.CDARVPRODFIN : null;
            row.DTENTRINI = (!Util.isEmptyOrBlank(filterRow.DTPROGENTR.start)) ? filterRow.DTPROGENTR.start : null;
            row.DTENTRFIN = (!Util.isEmptyOrBlank(filterRow.DTPROGENTR.end)) ? filterRow.DTPROGENTR.end : null;
            row.DTSOLIINI = (!Util.isEmptyOrBlank(filterRow.DTHRLANCSOL.start)) ? filterRow.DTHRLANCSOL.start : null;
            row.DTSOLIFIN = (!Util.isEmptyOrBlank(filterRow.DTHRLANCSOL.end)) ? filterRow.DTHRLANCSOL.end : null;
            row.NRORG     = getLocalVar('NRORG');
            row.NRSOLI    = filterRow.NRSOLICMP ? filterRow.NRSOLICMP.join("_") : null;
            row.TCDPROD   = !filterRow.CDARVPRODINI && !filterRow.CDARVPRODFIN ? "T" : null;
            row.TDTENTR   = (row.DTENTRINI && row.DTENTRFIN) ? null : 'T';
            row.TDTSOLI   = (row.DTSOLIINI && row.DTSOLIFIN) ? null : 'T';
            row.TNRSOLI   = (!filterRow.NRSOLICMP) || (Util.isEmptyObject(filterRow.NRSOLICMP)) ? "T" : null;
            
            args.e.preference.CUSTOM_FILTER_ROW = {};
            widget.dataSourceFilter = [
                {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILSOLI  },
                {  'name': 'P_CDPRODINI',	'operator': '=',  'value': row.CDPRODINI  },
                {  'name': 'P_CDPRODFIN',	'operator': '=',  'value': row.CDPRODFIN  },
                {  'name': 'P_DTENTRINI',	'operator': '=',  'value': row.DTENTRINI  },
                {  'name': 'P_DTENTRFIN',	'operator': '=',  'value': row.DTENTRFIN  },
                {  'name': 'P_DTSOLIINI',   'operator': '=',  'value': row.DTSOLIINI  },
                {  'name': 'P_DTSOLIFIN',   'operator': '=',  'value': row.DTSOLIFIN  },
                {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG      },
                {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI     },
                {  'name': 'P_TCDPROD',	    'operator': '=',  'value': row.TCDPROD    },
                {  'name': 'P_TDTENTR',	    'operator': '=',  'value': row.TDTENTR    },
                {  'name': 'P_TDTSOLI',	    'operator': '=',  'value': row.TDTSOLI    },
                {  'name': 'P_TNRSOLI',	    'operator': '=',  'value': row.TNRSOLI    }
            ];
            
            widget.activate();
        }
        
        args.owner.activate();
    }; 
    
    this.setStripe = function(widget) {
        const appliedFilterRow = widget.appliedFilter.FILTER_ROW;
        
        widget._filterInfo = [
            {"label": ScreenService.i18n("Unidade "), "value": appliedFilterRow.NMFILIAL},
            {"label": ScreenService.i18n("Produto Inicial "), "value": appliedFilterRow.NMPRODINI},
            {"label": ScreenService.i18n("Produto Final "), "value": appliedFilterRow.NMPRODFIN}
        ];
        
        widget.container.getWidget("STRIPE").currentRow.UNIDADE = appliedFilterRow.CDFILSOLI + " - " + appliedFilterRow.NMFILIAL;
    };
    
    this.abrirDetalhes = function() {
        const widTabSwipe = templateManager.container.getWidget('tabSwipe');
        
        ScreenService.openSwipe(widTabSwipe).then(function(success) {
            const widItens = templateManager.container.getWidget("itens");
            widItens.activate();
            self.buscaItensSolicitacao(widItens);
        });
    };
    
    this.abrirSituacaoCotacao = function(widget) {
        const widCotacao = templateManager.container.getWidget('cotacao');
        
        ScreenService.openSwipe(widCotacao).then(function(success) {
            widCotacao.activate();
            self.buscaSituacaoCotacao(widCotacao);
        });
    };
    
    this.buscaItensSolicitacao = function(widget) {
        const currentRowWidget = widget.getParent().getParent().currentRow;
        const row = {};
        
        row.CDFILSOLI   = currentRowWidget.CDFILSOLI;
        row.CDFILLAN    = currentRowWidget.CDFILLAN;
        row.NRAUTOFORN  = currentRowWidget.NRAUTOFORN ? currentRowWidget.NRAUTOFORN : '';
        row.CDPRODINI   = currentRowWidget.CDPRODINI ? currentRowWidget.CDPRODINI : '';
        row.CDPRODFIN   = currentRowWidget.CDPRODFIN ? currentRowWidget.CDPRODFIN : '';
        row.DTENTR      = currentRowWidget.DTPROGENTR;
        row.DTSOLIINI   = currentRowWidget.DTSOLIINI ? currentRowWidget.DTSOLIINI : '';
        row.DTSOLIFIN   = currentRowWidget.DTSOLIFIN ? currentRowWidget.DTSOLIINI : '';
        row.DTSOLI      = (currentRowWidget.DTSOLIINI && currentRowWidget.DTSOLIFIN) ? '' : 'T';
        row.NRCOMPRA    = currentRowWidget.NRCOMPRA ? currentRowWidget.NRCOMPRA :  '';
        row.NRORG       = getLocalVar('NRORG');
        row.NRSOLI      = currentRowWidget.NRSOLICMP;
        row.TCDPROD     = (currentRowWidget.CDPRODINI && currentRowWidget.CDPRODFIN) ? '' : 'T';
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILSOLI   },
            {  'name': 'P_CDFILLAN',	'operator': '=',  'value': row.CDFILLAN    },
            {  'name': 'P_NRAUTOFORN',	'operator': '=',  'value': row.NRAUTOFORN  },
            {  'name': 'P_CDPRODINI',	'operator': '=',  'value': row.CDPRODINI   },
            {  'name': 'P_CDPRODFIN',	'operator': '=',  'value': row.CDPRODFIN   },
            {  'name': 'P_DTENTR',	    'operator': '=',  'value': row.DTENTR      },
            {  'name': 'P_DTSOLI',      'operator': '=',  'value': row.DTSOLI      },
            {  'name': 'P_DTSOLIINI',   'operator': '=',  'value': row.DTSOLIINI   },
            {  'name': 'P_DTSOLIFIN',   'operator': '=',  'value': row.DTSOLIFIN   },
            {  'name': 'P_NRCOMPRA',    'operator': '=',  'value': row.NRCOMPRA    },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       },
            {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI      },
            {  'name': 'P_TCDPROD',	    'operator': '=',  'value': row.TCDPROD     }
        ];
        
        widget.reload();
    };
    
    this.buscaSituacaoSolicitacao = function(widget) {
        const currentRowWidget = widget.getParent().getParent().currentRow;
        const row = {};
        
        row.CDDESTSOLI = currentRowWidget.CDDESTSOLI;
        row.CDFILLAN   = currentRowWidget.CDFILLAN;
        row.CDFILSOLI  = currentRowWidget.CDFILSOLI;
        row.NRORG      = getLocalVar('NRORG');
        row.NRSOLI     = currentRowWidget.NRSOLICMP;
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDDESTSOLI',	'operator': '=',  'value': row.CDDESTSOLI  },
            {  'name': 'P_CDFILLAN',	'operator': '=',  'value': row.CDFILLAN    },
            {  'name': 'P_CDFILSOLI',	'operator': '=',  'value': row.CDFILSOLI   },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       },
            {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI      }
        ];
        
        widget.reload();
    };
    
    this.buscaSituacaoCotacao = function(widget) {
        const currentRowWidget = widget.getParent().currentRow;
        const row = {};
        
        row.CDFILIAL     = currentRowWidget.CDFILLANC;
        row.CDPRODUTO    = currentRowWidget.CDPRODUTO;
        row.NRCOLEPRECO  = currentRowWidget.NRNOTAFISC;
        row.NRORG        = getLocalVar('NRORG');
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILIAL    },
            {  'name': 'P_CDPRODUTO',	'operator': '=',  'value': row.CDPRODUTO   },
            {  'name': 'P_NRCOLEPRECO',	'operator': '=',  'value': row.NRCOLEPRECO },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       }
        ];
        
        widget.reload();
    };
    
    this.filtrarSolicitacao = function(widget) {
        const fieldNrSoliCmp = widget.getField("NRSOLICMP");
        const currentRowWidget = widget.currentRow;
        
        if (currentRowWidget.NMFILIAL && currentRowWidget.NMFILIAL.length !== 0) {
            const tdtSoli = !currentRowWidget.DTINI_SOL && !currentRowWidget.DTFIN_SOL ? "T" : null;
            const tdtEntr = !currentRowWidget.DTINI_ENT && !currentRowWidget.DTFIN_ENT ? "T" : null;

            currentRowWidget.NRSOLICMP = "";
            
            fieldNrSoliCmp.dataSourceFilter = [
                {  'name': 'P_DTSOLIINI',	'operator': '=',    'value': widget.currentRow.DTINI_SOL  },
                {  'name': 'P_DTSOLIFIN',	'operator': '=',    'value': widget.currentRow.DTFIN_SOL  },
                {  'name': 'P_TDTSOLI',		'operator': '=',    'value': tdtSoli                      },
                {  'name': 'P_DTENTRINI',	'operator': '=',    'value': widget.currentRow.DTINI_ENT  },
                {  'name': 'P_DTENTRFIN',	'operator': '=',    'value': widget.currentRow.DTFIN_ENT  },
                {  'name': 'P_TDTENTR',		'operator': '=',    'value': tdtEntr                      },
                {  'name': 'P_CDFILIAL',	'operator': '=',    'value': widget.currentRow.CDFILSOLI  }
            ];
            
            fieldNrSoliCmp.reload();
            fieldNrSoliCmp.readOnly = false;
        } else {
            fieldNrSoliCmp.validations  = {};
            fieldNrSoliCmp.readOnly = true;
            
            currentRowWidget.NRSOLICMP = "";
        }
    };
    
    this.readOnlyData = function(dtInicial, dtFinal) {
        if (!dtInicial.value() && !dtFinal.value()) {
            dtInicial.validations = {};
            dtFinal.validations   = {};
        } else {
            dtInicial.validations = {"required": true};
            dtFinal.validations   = {"required": true};
        }
    };
    
    this.filtrarDatasSolicitacaoEntrega = function(field) {
        if (field.name == 'DTHRLANCSOL' && field.value()) {
            if (field.value().formattedStart > field.value().formattedEnd) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                field.value().formattedStart = "";
                field.value().formattedEnd = "";
            }
        } else if (field.name == 'DTPROGENTR' && field.value()) {
            if(field.value().formattedStart > field.value().formattedEnd) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                field.value().formattedStart = "";
                field.value().formattedEnd = "";
            }    
        }
    };
    
    this.voltar = function(widget) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("itens").activate();
    };
    
    this.closeSwipe = function() {
        ScreenService.closeSwipe();
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };
    
    // var registeredValidations = validateEngine.getMappedValidations();
    
    // if (!registeredValidations.hasOwnProperty('validaProduto')) {
    //     validateEngine.registerValidation('validaProduto', validaProduto);
    // }

}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp09500_acompanhamento_de_solicitacao_de_comprasController', cmp09500_acompanhamento_de_solicitacao_de_comprasController);
});