// FILE: ./assets/templates/controllers/zRegisterCmpComponents.js
var zRegisterCmpComponents = function(decodeTemplateFieldService, eventAggregator) {
    eventAggregator.subscribe('beforeProjectStartup', function register() {
        decodeTemplateFieldService.registerViewTemplate('pebbian-component#widget/pebbian-grid.html', 'pebbian#widget/pebbian-grid.html');
    });
};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('zRegisterCmpComponents', zRegisterCmpComponents);
});


(function registerTemplates() {
    window.templateUrls = window.templateUrls || [];
    window.templateUrls.push(
        {
            'package': 'pebbian-component',
            'baseUrl': './assets/templates/'
        }
    );
})();

// FILE: ./assets/js/services/Cmp03100_lancamento_de_solicitacao_de_compras.js
function Cmp03100_lancamento_de_solicitacao_de_compras(DecodeValueFieldService) {
    function addThousandSeparators(value) {
        value += '';
        var x = value.split(',');
        var x1 = x[0];
        var x2 = x.length > 1 ? ',' + x[1] : '';
        var rgx = /(\d+)(\d{3})/;
        while (rgx.test(x1)) {
            x1 = x1.replace(rgx, '$1.$2');
        }

        return x1 + x2;
    }

    function decodeTextViewFloat(field, fieldRow) {
    	if(typeof fieldRow === 'string') {
            fieldRow = fieldRow.replace(/\./g, '');
            fieldRow = fieldRow.replace(',', '.');
    	}
    	
        var viewRow = parseFloat(fieldRow);
    	viewRow = isNaN(viewRow) ? "" : viewRow.toFixed(3).replace('.', ',');
        return addThousandSeparators(viewRow);
    }

    DecodeValueFieldService.register('text-edit-view-float.html', decodeTextViewFloat);
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp03100_lancamento_de_solicitacao_de_compras', Cmp03100_lancamento_de_solicitacao_de_compras);
});

// FILE: ./assets/js/services/Constants.js

if (typeof Constants === "undefined") {
	var Constants = {
		successNotification: {
			type: "success"
		}, 

		successMessage: {
			type: "success",
			icon: "checked"
		},

		errorNotification: {
			type: "error"
		},

		errorMessage: {
			type: "error",
			icon: "error"
		},

		alertMessage: {
			type: "alert",
			icon: "exclamation"
		},

		infoMessage: {
			type: "information",
			icon: "information"
		},

		confirmationMessage: {
			type: "question",
			icon: "question"
		}
	};
}

// FILE: ./assets/js/services/Parametros.js
function Parametros(localStorageEngine, restEngine) {

	this.paramgeral = function() {

		return restEngine.post('cmp#/crud/paramgeral', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				}				
			]
		});

	};

    this.parasupri = function(cdfilial){

        return restEngine.post('cmp#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

    this.parcmpsup = function(cdfilial){

        return restEngine.post('cmp#/crud/parcmpsup', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

	this.paramplaneja = function() {

		return restEngine.post('cmp#/crud/paramplaneja', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("CDFILIAL")
				}				
			]
		});

	};

	this.retornaNivelMaxProduto = function(){
        mascaraProduto = getLocalVar('CDPICTPROD');
        nivelMax = mascaraProduto.split('.').length;

        return nivelMax;
    };

    this.retornaNivelMaxPrato = function(){
        mascaraPrato = getLocalVar('CDPICTPRAT');
        nivelMax = mascaraPrato.split('.').length;

        return nivelMax;
    };

	this.paramfilial = function() {
		var nrorg = arguments[0] || localStorageEngine.getLocalVar("NRORG");
		var cdfilial = arguments[1] || localStorageEngine.getLocalVar("CDFILIAL");
		return restEngine.post('cmp#/crud/paramfilial', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": nrorg
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": cdfilial
				}				
			]
		});

	};

	this.retornaDataProcessamento = function(cdfilial, nrorg) {

		return this.paramfilial(nrorg, cdfilial).then(function(callback) {

			var dtprocessa = callback.dataset.paramfilial[0].DTPROCESSA;

			if(dtprocessa) {
				return moment(dtprocessa,'DD/MM/YYYY HH:mm:ss').format('L');
			} else {
				return moment().format('L');
			}

		});

	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Parametros', Parametros);
});


// FILE: ./assets/modules/V1/assets/js/services/AlteracaoAprovacaoAfService.js
function AlteracaoAprovacaoAfService(restEngine) {

    this.salvaValorTotalReal = function(currentRow) {
        return restEngine.post('\/cmp07600_autoforne_af\/save', {
            "requestType": "DataSet",
            "dataset": [
                currentRow
            ]
        });
    };

    this.verificaProdutoFornecedor = function(nrorg, cdFornecedor, cdProduto){
        return restEngine.post('\/verificaProdutoFornecedor', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDFORNECED": cdFornecedor,
                "CDPRODUTO": cdProduto
            }
        });
    };

    this.verificaQualificacaoMarca = function(nrorg, cdProduto, cdMarca, cdFilial, dtAutoForn){
        return restEngine.post('\/verificaQualificacaoMarca', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDMARCA": cdMarca,
                "CDFILIAL": cdFilial,
                "DTAUTOFORN": dtAutoForn
            }
        });
    };

    this.verificaProdQualificadoForn = function(nrorg, cdProduto, cdFornecedor, cdFilial, dtAutoForn){
        return restEngine.post('\/verificaProdQualificadoForn', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDFORNECED": cdFornecedor,
                "CDFILIAL": cdFilial,
                "DTAUTOFORN": dtAutoForn
            }
        });
    };

    this.verificaProdutoInativo = function(nrorg, cdProduto, cdFilial){
        return restEngine.post('\/verificaProdutoInativo', {
            "requestType": "Row",
            "row": {
                "NRORG": nrorg,
                "CDPRODUTO": cdProduto,
                "CDFILIAL": cdFilial
            }
        });
    };

    this.verificaPrazoPagamento = function(nrorg, cdFilDest, cdFilLanc, nrAutoForn){
        return restEngine.post('\/prazopgtaf', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "value": nrorg, "operator": "="},
                {"name": "CDFILDEST", "value": cdFilDest, "operator": "="},
                {"name": "CDFILLANC", "value": cdFilLanc, "operator": "="},
                {"name": "NRAUTOFORN", "value": nrAutoForn, "operator": "="}
            ]
        });
    };

    this.proceVerificaInconsAfs = function(paramProcedure){
        return restEngine.post('\/proceVerificaInconsAfs', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceImpostoItemAf = function(paramProcedure){
        return restEngine.post('\/proceImpostoItemAf', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceExcluiContaPagarPrevista = function(paramProcedure){
        return restEngine.post('\/proceExcluiContaPagarPrevista', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceGeraContaPagarPrevista = function(paramProcedure){
        return restEngine.post('\/proceGeraContaPagarPrevista', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceFechamentoAf = function(paramProcedure){
        return restEngine.post('\/proceFechamentoAf', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

    this.proceConsisteOrcamento = function(paramProcedure){
        return restEngine.post('\/proceConsisteOrcamento', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 99999);
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('AlteracaoAprovacaoAfService', AlteracaoAprovacaoAfService);
});

// FILE: ./assets/modules/V1/assets/js/services/NecessidadeCompraService.js
function NecessidadeCompraService(restEngine) {
    this.excluiNecessidadeCompra = function(rowsNecessidade, nomeWidget) {
        return restEngine.post('\/excluiNecessidadeCompra', {
            "requestType": "Row",
            "row": {
                "rowsNecessidade": rowsNecessidade,
                "nomeWidget": nomeWidget
            }
        });
    };

    this.excluiTrabnececomp = function(nrnececomp, nrorg) {
        return restEngine.post('\/excluiTrabnececomp', {
            "requestType": "Row",
            "row": {
                "nrnececomp": nrnececomp,
                "nrorg": nrorg
            }
        });
    };

    this.proceCalculaPrevconsFiliais = function(paramProcedure) {
        return restEngine.post('\/proceCalculaPrevconsFiliais', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.procePeriodicidadeNaoCalculada = function(paramProcedure) {
        return restEngine.post('\/procePeriodicidadeNaoCalculada', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.proceNecessidadeDeCompras = function(paramProcedure) {
        return restEngine.post('\/proceNecessidadeDeCompras', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.proceGeraSolicitacao = function(paramProcedure) {
        return restEngine.post('\/proceGeraSolicitacao', {
            "requestType": "Row",
            "row": {
                "paramProcedure": paramProcedure
            }
        }, null, null, null, null, 999999);
    };

    this.dataPrevisaoConsumo = function(params){
        return restEngine.post('\/dataPrevisaoConsumo', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRORG", "value": params.NRORG, "operator": "="},
                {"name": "CDFILIAL", "value": params.CDFILIAL, "operator": "="},
                {"name": "CDGRUPFILI", "value": params.CDGRUPFILI, "operator": "="},
                {"name": "CDPRODUTOINI", "value": params.CDPRODINI, "operator": "="},
                {"name": "CDPRODUTOFIN", "value": params.CDPRODFIN, "operator": "="}
            ]
        });
    };

    this.listaUnidades = function(nrnececomp, nrorg){
        return restEngine.post('\/trabnececompDistinct', {
            "requestType": "FilterData",
            "filter": [
                {"name": "NRNECECOMP", "value": nrnececomp, "operator": "="},
                {"name": "NRORG", "value": nrorg, "operator": "="}
            ]
        });
    };

    this.openReportSemMensagem = function(route, reportName, params) {
        params.__report_name = reportName;
        params.QR2TYPE = 'pdf';
        return restEngine.post(route, {
            "requestType": "Row",
            "row": params
        }, null, null, null, null, 30000).then(function(response) {
            if (response && response.messages) {
                var report = response.messages.pop();
                window.open(report.message);
            }
        }).catch(function(response) {
            if (response.data && response.data.error) {
                console.log(response.data.error);
            }
        });
    };

}

Configuration(function(ContextRegister) {
	ContextRegister.register('NecessidadeCompraService', NecessidadeCompraService);
});

// FILE: ./assets/modules/V1/assets/js/services/SolicitacaoComprasService.js
function SolicitacaoComprasService(restEngine) {
    this.save = function (currentRow) {
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        if(typeof currentRow.CDFILLAN === 'undefined')
            currentRow.CDFILLAN = getLocalVar('CDFILIAL');
        if(typeof currentRow.CDFILSOLI === 'undefined')
            currentRow.CDFILSOLI = getLocalVar('CDFILIAL');
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa/save",
            {
                "requestType": "Row",
                "row": currentRow
            }
        );
    };
    this.delete = function (currentRow) {
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa/remove",
            {
                "requestType": "Row",
                "row": currentRow
            }
        );
    };

    this.getRegras = function () {
        return restEngine.post("cmp_V1#/solicitacao_compras_regras",
            {
                "requestType": "FilterData"
            }
        );
    };
    this.getItemSoli = function (filterArray) {
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "DTPROGENTR",
                        "operator": "=",
                        "value": filterArray.DTPROGENTR
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": filterArray.CDPRODUTO
                    },
                    {
                        "name": "CDFILLAN",
                        "operator": "=",
                        "value": filterArray.CDFILLAN
                    },
                    {
                        "name": "IDTIPLAN",
                        "operator": "=",
                        "value": filterArray.IDTIPLAN
                    },
                    {
                        "name": "CDDESTSOLI",
                        "operator": filterArray.CDDESTSOLI ? "=" : "IS_NULL",
                        "value": filterArray.CDDESTSOLI ? filterArray.CDDESTSOLI : ""
                    },
                    {
                        "name": "CDCOMPRADOR",
                        "operator": filterArray.CDCOMPRADOR ? "=" : "IS_NULL",
                        "value": filterArray.CDCOMPRADOR ? filterArray.CDCOMPRADOR : ""
                    }
                ]
            }
        );
    };
    this.getFilialData = function (cdFilial, nrorg) {
        return restEngine.post("cmp_V1#/cmp_V1_filial",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": cdFilial
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": nrorg
                    }
                ]
            }
        );
    };
    this.getPeriodicidade = function (filterArray) {
        return restEngine.post("cmp_V1#/periodicidade",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "DTPROGENTR",
                        "operator": "=",
                        "value": filterArray.DTPROGENTR
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": filterArray.CDPRODUTO
                    }
                ]
            }
        );
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SolicitacaoComprasService', SolicitacaoComprasService);
});

// FILE: ./assets/modules/cadastros/assets/js/services/PercentAjustmentService.js
function PercentAjustmentService(restEngine) {
    
    this.updatePercentAdjustments = function(row) {
        return restEngine.post('cmp_cadastros#/updatePercentAdjustments', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.deletePercentAdjustments = function(dataset) {
        return restEngine.post('cmp_cadastros#/deletePercentAdjustments', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.addPercentAdjustments = function(row) {
        return restEngine.post('cmp_cadastros#/addPercentAdjustments', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('PercentAjustmentService', PercentAjustmentService);
});

// FILE: ./assets/modules/simplificada/assets/js/services/CompraSimplificadaService.js
function CompraSimplificadaService(restEngine) {
    
    this.saveFilterCompraSimplificada = function(filter) {
        return restEngine.post('cmp_compra_simplificada#/compra_simplificada/save', {
            "requestType": "FilterData",
            "filter": [
                {"name": "P_CDFILSOLI",     "operator": "=", "value": filter.CDFILSOLI},
                {"name": "P_CDNVPRODUTO",   "operator": "=", "value": filter.CDNVPRODUTO},
    		    {"name": "P_CDPRODUTO",     "operator": "=", "value": filter.CDPRODUTO},
    		    {"name": "P_DTENTRINI",     "operator": "=", "value": filter.DTENTREGA.start},
    		    {"name": "P_DTENTRFIM",     "operator": "=", "value": filter.DTENTREGA.end} 
            ]
        });
    };
    
    this.deleteFilterCompraSimplificada = function(row) {
        return restEngine.post('cmp_compra_simplificada#/compra_simplificada/delete', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.getParametrosNecessidadeCompra = function(row) {
        return restEngine.post('cmp#/parametros_calculo_necessidade_compras', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('CompraSimplificadaService', CompraSimplificadaService);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/services/Cmp03900_LancamentoAutorizacaoDeFornecimento_Service.js
function Cmp03900_LancamentoAutorizacaoDeFornecimento_Service(restEngine){
    
    this.validacoesIniciais = function() {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validacoesIniciais', {
            "requestType": "Row",
            "row": {}
        });
    };
    
    this.retornaComprador = function() {
        return restEngine.post('cmp#/crud/comprador_operador', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDOPERADOR",  "value": getLocalVar('CDOPERADOR'),    "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="}
            ]
        });
    };
    
    this.infoAF = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/infoAF', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,    "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,    "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,   "operator": "="}
            ]
        });
    };
    
    this.parasupri = function() {
        return restEngine.post('cmp#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": getLocalVar('CDFILCENTCMP'),    "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),           "operator": "="}
            ]
        });
    };
    
    this.salvarProduto = function(produto, oldProduto, dadosAF) {
        oldProduto = oldProduto ? oldProduto : {};
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarProduto', {
            "requestType": "DataSet",
            "dataset": [produto, oldProduto, dadosAF]
        });
    };
    
    this.salvarImposto = function(impostos) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarImposto', {
            "requestType": "DataSet",
            "dataset": impostos
        });
    };
    
    this.itemautf = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,    "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,    "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,   "operator": "="},
                {"name": "CDMARCA",      "value": dados.CDMARCA,      "operator": "="},
                {"name": "CDPRODUTO",    "value": dados.CDPRODUTO,    "operator": "="}
            ]
        });
    };
    
    this.itemautfSave = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf/save', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.formaPagamento = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/af_formaPagamento', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,       "operator": "="},
                {"name": "CDFILIAL",     "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,      "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.salvarDadosAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarEdicaoAF', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.salvarFormaPagamento = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarFormaPagamento', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.salvarEncargo = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarEncargo', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.editarJustificativa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/editarJustificativa', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.excluirProduto = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirProduto', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaFornecedor = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaFornecedor', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.insereImpostos = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/insereImpostos', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.empresasPorUnidade = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/empresasPorUnidade', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",       "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.empresaClientePrincipal = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/empresaClientePrincipal', {
            "requestType": "FilterData",
            "filter": [
                {"name": "IDCLIENPRIN",  "value": "S",                   "operator": "="},
                {"name": "CDFILIAL",     "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.parametrosCompras = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/parametrosCompras', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRORG",       "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.atualizarInconsistencias = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizarInconsistencias', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.dadosFornecedor = function (dados) {
        return restEngine.post('cmp#/crud/fornecedor', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFORNECED",    "value": dados.CDFORNECED,      "operator": "="},
                {"name": "NRORG",         "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.excluirAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirAF', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.consisteOrcamento = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteOrcamento', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.consisteDsincons = function(row, produtos, dsinconsitaf) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteDsincons', {
            "requestType": "DataSet",
            "dataset": [row, produtos, dsinconsitaf]
        });
    };
    
    this.atualizaProdutosTipoBaixa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizaProdutosTipoBaixa', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.atualizaItemBaixa = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/atualizaItemBaixa', {
            "requestType": "DataSet",
            "dataset": row
        });
    };
    
    this.salvarJustificativas = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarJustificativas', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaFilial = function(cdfilial) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaFilial', {
            "requestType": "Row",
            "row": {"CDFILIAL": cdfilial}
        });
    };
    
    this.validaComprador = function (comprador, operador) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaComprador', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDCOMPRADOR",   "value": comprador,             "operator": "="},
                {"name": "CDOPERADOR",    "value": operador,              "operator": "="},
                {"name": "NRORG",         "value": getLocalVar("NRORG"),  "operator": "="}
            ]
        });
    };
    
    this.confirmaSenhaComprador = function(dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/confirmaSenhaComprador', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.retornaDadosFornecedor = function (dados) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/retornaDadosFornecedor', {
            "requestType": "Row",
            "row": dados
        });
    };
    
    this.validaDataLancamento = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaDataLancamento', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.retornaFormpgto = function(cdformpgto) {
        return restEngine.post('cmp#/crud/formpgto', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFORMPGTO",    "value": cdformpgto,              "operator": "="},
                {"name": "NRORG",         "value": getLocalVar('NRORG'),    "operator": "="}
            ]
        });
    };
    
    this.salvarAdicaoAF = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarAdicaoAF', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.finalizaAdicaoAF = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/finalizaAdicaoAF', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.validaDataEntrega = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaDataEntrega', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validaProduto = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaProduto', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validaProdMarca = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validaProdMarca', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.salvarMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvarMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.excluirMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/excluirMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.novoCodigoMensagem = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/novoCodigoMensagem', {
            "requestType": "Row",
            "row": row
        });
    };
    
    
    this.utilizaWorkflow = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', {
            "requestType": "Row",
            "row": row
        });
    };

    this.retornaParametroCotacao = function (centralCompras) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/retornaParametroCotacao';
        var payload = {
            "requestType": "Row",
            "row": { "CDFILCENTCMP": centralCompras }
        };
        return restEngine.post(route, payload);
    };
    
    this.retornaCotacaoProduto = function (row) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/retornaCotacaoProduto';
        var payload = {
            "requestType": "Row",
            "row": row
        };
        return restEngine.post(route, payload);
    };
    
    this.getFormPgtoFornecedor = function (row) {
        var route = 'cmp_fornecimento_autorizacaoFornecimento#/AF/getFormPgtoFornecedor';
        var payload = {
            "requestType": "Row",
            "row": row
        };
        return restEngine.post(route, payload);
    };
    
    this.salvaJustLancAf = function (cdfildest, cdfillanc, nrautoforn, dsmotvafalcada) {
        
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaJustLancAf', {
            "requestType": "Row",
            "row": {
                "CDFILDEST": cdfildest,
                "CDFILLANC": cdfillanc,
                "NRAUTOFORN": nrautoforn,
                "DSMOTVAFALCADA": dsmotvafalcada
            }
        });
        
    };
    
    this.proceConsisteOrcamentoGopWorkflow = function (cdfildest, cdfillanc, nrautoforn) {
        
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/consisteOrcamentoGopWorkflow', {
            "requestType": "Row",
            "row": {
                "CDFILDEST": cdfildest,
                "CDFILLANC": cdfillanc,
                "NRAUTOFORN": nrautoforn
            }
        });
        
    };
    
    this.validateAllProducts = function(saveProducts) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/validateAllProducts', {
            "requestType": "DataSet",
            "dataset": saveProducts
        });
    };
    
    this.saveAllProduct = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/saveAllProduct', {
            "requestType": "Row",
            "row": row
        });
    };

    this.retornaDataLancamento = function (codigoFilialDestino) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/retornaDataLancamento', {
            'requestType': 'Row',
            'row': {
                CDFILDEST: codigoFilialDestino
            }
        });
        
    };
    
    /**
     * [INÍCIO] ANEXO
     */
    
    /**
     * Adição de AF
     */
    
    this.saveAnexoLocal = function(currentRow){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaAnexoLocalAF', {
          "requestType": "Row",
          "row": currentRow
      });
    };
    
    this.deleteAnexoLocal = function(dataSet){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/deletaAnexoLocalAF', {
          "requestType": "DataSet",
          "dataset": dataSet
      });
    };
    
    /**
     * Visualização da AF
     */
    
    this.salvaAnexoGrid = function(currentRow){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/salvaAnexoGridAF', {
          "requestType": "Row",
          "row": currentRow
      });
    };
    
    this.deleteAnexoGrid = function(dataSet){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/deleteAnexoGridAF', {
          "requestType": "DataSet",
          "dataset": dataSet
      });
    };
    
    this.getFileServerUrl = function(){
      return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/getFileServerUrlAF', {
          "requestType": "Row",
          "row": {}
      });
    };
    
    /**
     * [FIM] ANEXO
     */
    
    this.verificaStatusAprovacaoWorkflow = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/verificaStatusAprovacaoWorkflow', {
            'requestType': 'Row',
            'row': row
        });
        
    };
    
    this.indiceJoinMovindice = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/indiceJoinMovindice', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDINDICE",    "value": row.CDINDICEAF,        "operator": "="},
                {"name": "DTREFIND",    "value": row.DTREFINDAF ? row.DTREFINDAF.split(' ').shift() : row.DTREFINDAF,        "operator": "="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),  "operator": "="},
            ]
        });
    };
    
    this.getAdjustments = function (row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/AF/getAdjustments', {
            'requestType': 'Row',
            'row': row
        });
        
    };
    
    this.retornaCookieEmail = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/retornaCookieEmail', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendEmailAFPosicionada = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sendEmailAFPosicionada', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.sendEmailAFSelecionada = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sendEmailAFSelecionada', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp03900_LancamentoAutorizacaoDeFornecimento_Service', Cmp03900_LancamentoAutorizacaoDeFornecimento_Service);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/services/CMP03905ImportacaoSolicitacaoComprasService.js
function CMP03905ImportacaoSolicitacaoComprasService(restEngine) {
    
    this.confirmaSenhaGerente = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/AF/confirmaSenhaGerente', {
            "requestType": "Row",
            "row": row
        });
    };
    
}

    Configuration(function (ContextRegister) {
    ContextRegister.register('CMP03905ImportacaoSolicitacaoComprasService', CMP03905ImportacaoSolicitacaoComprasService);
});
    
    


// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/services/Cmp04200_LiberacaoAfInconsistenteForaLimite_Service.js
function Cmp04200_LiberacaoAfInconsistenteForaLimite_Service(restEngine) {
    
    this.confirmaSenhaGerente = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/AF/confirmaSenhaGerente', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.considerarAFsTodosCompradoresNaValidacaoDoLimiteGerente = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/cmp04200liberacaoaf/verificaIDAFCOMPLIMGER', {
            "requestType": "Row",
            "row": row
        });
    };

    this.enviarEmailAosResponsaveisPelaAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/enviarEmailParaOperadoresResponsaveisPelaAf', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.liberarAutorizacaoFornecimento = function(dataset) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/cmp04200liberacaoaf/liberar', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };
    
    this.verificaUtilizaWorkflow = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/cmp04200liberacaoaf/verificaUtilizaWorkflow', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp04200_LiberacaoAfInconsistenteForaLimite_Service', Cmp04200_LiberacaoAfInconsistenteForaLimite_Service);
});
    
    


// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/services/Sup03600PedidoColetaService.js
function Sup03600PedidoColetaService(restEngine) {

    this.filtroPedido = function (parametrosFilter) {
        return restEngine.post('sup_cotacao_pedido#/controlePedidoColeta', {
            "requestType": "FilterData",
            "filter": parametrosFilter
        });
    };

    this.swipeProduto = function (parametrosSwipe){
    	return restEngine.post('sup_cotacao_pedido#/produtoPedcol', {
    		"requestType" : "FilterData",
    		"filter": parametrosSwipe
    	});
    };

    this.atualizaPrecObj = function(produtos){
        return restEngine.post('sup_cotacao_pedido#/savePrecObj', {
            "requestType" : "Row",
            "row" : produtos
        });
    };

    this.retornaEmAberto = function(pedidos, dtexpirapedcol){
        return restEngine.post('sup_cotacao_pedido#/updataSituPed', {
            "requestType" : "Row",
            "row" : {
                "PEDIDOS": pedidos,
                "DTEXPIRAPEDCOL": dtexpirapedcol
            }
        });
    };

    this.gravaCotWeb = function(pedidosValidos, entraLista){
        return restEngine.post('sup_cotacao_pedido#/geraCotacaoWeb', {
            "requestType" : "Row",
            "row" : {
                "PEDIDOS": pedidosValidos,
                "LISTAPREC": entraLista
            }
        });
    };
    
    this.enviaEmailFornecedor = function(assunto, mensagem, fornecedores, emailOperador, nmOperador){
        return restEngine.post('sup_cotacao_pedido#/enviaEmailFornecedor', {
            "requestType": "Row",
            "row": {
                "ASSUNTO": assunto,
                "MENSAGEM": mensagem,
                "FORNECEDORES": fornecedores,
                "EMAIL": getLocalVar("EMAIL")
            }
        });
    };
    
    this.defineCookieEmail = function(nome, mensagem) {
        return restEngine.post('sup_cotacao_pedido#/defineCookieEmail', {
            "requestType": "Row",
            "row": {
                "NOME": nome,
                "MENSAGEM": mensagem
            }
        });
    };
    
    this.retornaCookieEmail = function(nome) {
        return restEngine.post('sup_cotacao_pedido#/retornaCookieEmail', {
            "requestType": "Row",
            "row": {
                "NOME": nome
            }
        });
    };
    
    this.retornaMenorMaiorProdutoPedido = function(listaNrpedidocol) {
        return restEngine.post('sup_cotacao_pedido#/retornaMenorMaiorProdutoPedido', {
            "requestType": "Row",
            "row": {
                "FILIALNRPEDIDOCOL": listaNrpedidocol
            }
        });
    };
    
    this.calculaPrecoObjetivo = function(listaNrpedidocol, consideraMarca) {
        return restEngine.post('sup_cotacao_pedido#/calculaPrecoObjetivo', {
            "requestType": "Row",
            "row": {
                "LISTAPEDIDOS": listaNrpedidocol,
                "CONSIDERAMARCA": consideraMarca
            }
        });
    };
    
    this.salvaPrecoObjetivoMinimo = function(listaNrpedidocol, listaProdutos) {
        return restEngine.post('sup_cotacao_pedido#/salvaPrecoObjetivoMinimo', {
            "requestType": "Row",
            "row": {
                "LISTAPEDIDOS": listaNrpedidocol,
                "PRODUTOS": listaProdutos
            }
        });
    };
    
    this.deletaLista = function(nrlista) {
        return restEngine.post('sup_cotacao_pedido#/deletaLista', {
            "requestType": "Row",
            "row": {
                "NRLISTA": nrlista
            }
        });
    };
    
    this.salvarComentario = function(row, info) {
        row.COMPRADOR         = info.COMPRADOR;
        row.EMAIL_RESPONSAVEL = info.EMAIL;
        row.EMAIL_LOGADO      = getLocalVar("EMAIL");
        row.NRPEDIDOCOL       = info.NRPEDIDOCOL;
        row.CDFILIAL          = info.CDFILIAL;
        return restEngine.post("sup_cotacao_pedido#/salvarComentario", {
          	"requestType": "Row",
			"row": row
		});
	};
	
	
	this.deletePedido = function(dataset) {
        return restEngine.post('sup_cotacao_pedido#/deletePedido', {
            "requestType": "DataSet",
            "dataset": dataset
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup03600PedidoColetaService', Sup03600PedidoColetaService);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/services/sup05100_analise_AF_Service.js
function sup05100_analise_AF_Service(restEngine){
    
    this.retornaCentralCompras = function(cdfilial) {
        return restEngine.post('cmp#/crud/central_compras', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            }]
        });
    };
    
    this.retornaParaSupriCentralCompras = function(cdfilial) {
        return restEngine.post('cmp#/crud/parasupri_central_compras', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            }]
        });
    };
    
    this.retornaCountAF = function(cdfildest, cdfillanc, nrseqapuraf) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/crud/sup05100_afs_count', {
            "requestType": "FilterData",
            "filter": [
                { "name": "CDFILDEST", "operator": "=", "value": cdfildest },
                { "name": "CDFILLANC", "operator": "=", "value": cdfillanc },
                { "name": "NRSEQAPURAF", "operator": "=", "value": nrseqapuraf }]
        });
        
    };
    
    this.remanejarItensAF = function(prodSelecionados, afDestino, currentRowRemanejo, idSituacaoApuPrec) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_remanejarItensAF', {
            "requestType": "Row",
            "row": {
                "AF_ORIGEM": prodSelecionados,
                "AF_DESTINO": afDestino,
                "REMANEJO": currentRowRemanejo,
                "IDSITAPUPREC": idSituacaoApuPrec
            }
        });
    };
    
    this.remanejarAF = function(afsSelecionadas, afDestino, currentRowRemanejo, idSituacaoApuPrec) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_remanejarAF', {
            "requestType": "Row",
            "row": {
                "AF_ORIGEM": afsSelecionadas,
                "AF_DESTINO": afDestino,
                "REMANEJO": currentRowRemanejo,
                "IDSITAPUPREC": idSituacaoApuPrec
            }
        });
    };
    
    this.remanejarAFTrocaProd = function(afDestino, prodDestino, afOrigem, idSituacaoApuPrec) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_remanejarTrocarProduto', {
            "requestType": "Row",
            "row": {
                "AF_ORIGEM": afOrigem,
                "AF_DESTINO": afDestino,
                "ITEM_DESTINO": prodDestino,
                "IDSITAPUPREC": idSituacaoApuPrec
            }
        });
    };
    
    this.concluirAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_concluirAF', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.salvaEdicaoProduto = function(currentRow) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_salvaEdicaoProduto', {
            "requestType": "Row",
            "row": {
                "NRAPURPREC": currentRow.NRAPURPREC,
                "CDFILCENTCMP": currentRow.CDFILCENTCMP,
                "CDFILDEST": currentRow.CDFILDEST,
                "CDFILLANC": currentRow.CDFILLANC,
                "CDPRODUTO": currentRow.CDPRODUTO,
                "VRFATOCONV": currentRow.VRFATOCONV,
                "DTPROGENTAF": currentRow.DTPROGENTAF,
                "CDFORNECED": currentRow.CDFORNECED,
                "QTPROGENTAF": currentRow.QTPROGENTAF,
                "NRAUTOFORN": currentRow.NRAUTOFORN,
                "CDMARCA": currentRow.CDMARCA,
                "DTPROGENTAF_OLD": currentRow.DTPROGENTAF_OLD,
                "QTPROGENTAF_OLD": currentRow.QTPROGENTAF_OLD,
                "IDGERAFDTENT": currentRow.IDGERAFDTENT,
                "ATUSOLICITACMP": currentRow.ATUSOLICITACMP,
                "ALTERADTENTREGA": currentRow.ALTERADTENTREGA,
                "IDSITAPUPREC": currentRow.IDSITAPUPREC,
                "IDFUNCAOFILI": currentRow.IDFUNCAOFILI,
                "IDCONSOLAPUEFET": currentRow.IDCONSOLAPUEFET
            }
        });
    };
    
    this.verificaOperadorRelacionado = function(apuracao) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_verificaOperadorRelacionado', {
            "requestType": "Row",
            "row": apuracao
        });
    };
    
    this.validarBeforeLiberarAF = function(currentRow) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_validar_before_liberar_af', {
            "requestType": "Row",
            "row": currentRow
        });
    };
    
    this.liberarAFInconsistente = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_liberar_af_inconsistente', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.verificarGerenteComprador = function(currentRow) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_verificar_gerente_comprador', {
            "requestType": "Row",
            "row": {
                "CDCOMPRADOR": currentRow.CDCOMPRADOR
            }
        });
    };
    
    this.validarSenhaGerente = function(currentRow) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_validar_senha_gerente', {
            "requestType": "Row",
            "row": currentRow
        });
    };
    
    this.excluirAF = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_excluir_af', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.defineCookieEmail = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_define_cookie_email', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.retornaCookieEmail = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/sup05100_retorna_cookie_email', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.resendEmail = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/resendEmailandSaveFile', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.concluiRemanejamentoApuracao = function(row) {
        return restEngine.post('cmp_fornecimento_autorizacaoFornecimento#/concluiRemanejamentoApuracao', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('sup05100_analise_AF_Service', sup05100_analise_AF_Service);
});

// FILE: ./assets/modules/fornecimento/assets/modules/listaPreco/assets/js/services/Sup03000Service.js
function Sup03000Service(restEngine) {

    this.retornaPrazoPagamento = function (cdfilial, nrcolepreco, cdproduto, cdmarca, cdregiao, cdfornecedor) {
        return restEngine.post('cmp_fornecimento_listaPreco#/sup03000pagamento', {
            "requestType": "FilterData",
            "filter": [
                {"name": "P_CDFILIAL",      "value": cdfilial,      "operator": "="},
                {"name": "P_NRCOLEPRECO",   "value": nrcolepreco,   "operator": "="},
                {"name": "P_CDPRODUTO",     "value": cdproduto,     "operator": "="},
                {"name": "P_CDMARCA",       "value": cdmarca,       "operator": "="},
                {"name": "P_CDREGIAO",      "value": cdregiao,      "operator": "="},
                {"name": "P_CDFORNECED",    "value": cdfornecedor,  "operator": "="},
            ]
        });
    };

    this.retornaAjuste = function (cdfilial, nrorg) {
        return restEngine.post('cmp_fornecimento_listaPreco#/sup03000Ajuste', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",      "value": cdfilial,      "operator": "="},
                {"name": "NRORG",    "value": nrorg,  "operator": "="},
            ]
        });
    };

    this.retornaFilial = function () {
        return restEngine.post('cmp#/crud/filial', {
            "requestType": "FilterData",
            "filter": [
                {"name": "CDFILIAL",      "value": "FILIAL_LOGADA",      "operator": "="}
            ]
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup03000Service', Sup03000Service);
});

// FILE: ./assets/js/controllers/TestConfigurationController.js
var TestConfigurationController = function(General, templateManager){
	
	this.sendMail = function() {
		
		let widget = templateManager.container.getActiveWidget();
		let row = widget.currentRow;
		
		row.action = 'sendMail';
		
		General.callRestEngine("cmp#/testConfiguration", "Row", row);
		
	};
	
	this.generateQrd = function() {
		
		let widget = templateManager.container.getActiveWidget();
		let row = widget.currentRow;
		
		row.action = 'generateQrd';
		
		General.openReportPopup(widget, function() {General.openReport('cmp#/testConfiguration', 'GER01300', row);}); 
		
	};
	
	this.generateBirt = function() {
		
		let widget = templateManager.container.getActiveWidget();
		let row = widget.currentRow;
		
		row.action = 'generateBirt';
		
		General.openReportPopup(widget, function() {General.openReport('cmp#/testConfiguration', 'testConfiguration', row);});
		
	};
	
};

Configuration(function(ContextRegister) {
	ContextRegister.register('TestConfigurationController', TestConfigurationController);
});


// FILE: ./assets/js/controllers/Utilities.js
function Utilities(ScreenService, ZhPreferences, Query, ZhFilterPreferences, validateEngine, templateManager, maskEngine, ZhUtil, LibUtilities, MessageService) {

    this.changeTagRichText = function(fieldValue) {
        if (typeof(fieldValue) === 'string') {
            var newFieldValue;

            if (fieldValue.substr(0, 3) == '<p>') {
                newFieldValue = fieldValue.replace(/<p>/g, '').replace(/<\/p>/g, '<br>');
            }
            else if (fieldValue.substr(0, 3) == '<p ') {
                newFieldValue = fieldValue.replace(/<p/g, '<span').replace(/<\/p>/g, '</span><br>');
            }
            else {
                newFieldValue = fieldValue;
            }

            if (fieldValue.substr(-4) == '</p>') {
                newFieldValue = newFieldValue.slice('', -4);
            }

            return newFieldValue;
        }
        else {
            return fieldValue; 
        }
    };
    
    this.startFilter = function(widget, currentRow) {
        return ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function(filters) {
                    var defaultFilter = filters.filter(function(filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };
                    currentRow = filter.FILTER_ROW;

                    ZhFilterPreferences.applyFilter(widget, filter).then(function() {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if (defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            }
            else {
                if (Util.isUndefinedOrNull(currentRow) || Util.isEmptyObject(currentRow)) {
                    currentRow = buildFilterCurrentRow(widget);
                }
            }
            ZhFilterPreferences.openFilterWidget(widget, currentRow);
        });
    };

    var buildFilterCurrentRow = function(widget) {
        return getFilterRowWithDefaultValues(widget.fields);
    };

    var getFilterRowWithDefaultValues = function(filterFields) {
        let filterRow = {};
        filterFields.forEach(field => {
            let defaultValue = Util.getNestedProperty(field, ["filterProperties", "defaultValue"]) || field.defaultValue;
            if (!Util.isUndefinedOrNull(defaultValue)) {
                filterRow[field.name] = Util.evaluate(defaultValue);
            }
        });
        return filterRow;
    };

    function validaProduto(value, validationAttrs, field) {

        var filtro = templateManager.container.getActiveWidget();
        var retorno = {
            "valid": true
        };
        field = validationAttrs.field;
        let fieldProduto;
        const final = filtro.currentRow.CDPRODFIN;
        const inicial = filtro.currentRow.CDPRODINI;

        if (value) {
            fieldProduto = field == "NMPRODFIN" ? inicial : final;
            if (fieldProduto) {
                if (inicial > final) {
                    return {
                        "valid": false,
                        "message": ScreenService.i18n(validationAttrs.message) || ScreenService.i18n('Produto inicial deve ser menor ou igual ao produto final')
                    };
                }
            }
        }
        else if (field == "NMPRODFIN" && filtro.currentRow.CDPRODINI || field == "NMPRODINI" && filtro.currentRow.CDPRODFIN) {
            let msg = field == "NMPRODFIN" ? 'Produto final obrigatório' : 'Produto inicial obrigatório';
            return {
                "valid": false,
                "message": ScreenService.i18n(validationAttrs.message) || ScreenService.i18n(msg)
            };
        }

        return retorno;
    }

    var registeredValidations = validateEngine.getMappedValidations();

    if (!registeredValidations.hasOwnProperty('validaProduto')) {
        validateEngine.registerValidation('validaProduto', validaProduto);
    }
    
    /* Cria máscara para o campo 'CDNMPRODUTO', onde é recebido o nome e o código
     * do produto concatenados.
     */
    var maskCodigoNomeProduto = function(value) {
        if (value) {
            var mascara = getLocalVar('CDPICTPROD');
            var tamanhoCodigo = mascara.replace(/\./g, '').length;
            var cdProduto = value.substring(0, tamanhoCodigo);
            var mask = {
                type: "fix",
                params: {
                    mask: mascara
                }
            };
            var cdProdutoFormatado = Util.applyMask(cdProduto, mask, maskEngine, ZhUtil);
            return value.replace(cdProduto, cdProdutoFormatado);
        }
    };

    maskEngine.registerMask('CDNMPROD',
        function() {},
        maskCodigoNomeProduto
    );
    
    let stateDoubleClick = {
        clicks: 0,
        lastRowIndex: 0,
        currentRowIndex: 0,
    };
    
    let intervalId;
    
    /**
     * Permite utilizar duplo clique no grid para acionar uma determinada função.
     * 
     * @param {function} execFunction - Função a ser executada no clique duplo.
     * @param {array} params - Array contendo os parâmetros a serem passados.
     */
    this.onDoubleClick = function(execFunction, params) {
        const actualWidget = templateManager.container.getActiveWidget();
        
        stateDoubleClick.currentRowIndex = actualWidget.currentRow.__index;
        
        if (stateDoubleClick.clicks == 0) {
            stateDoubleClick.lastRowIndex = actualWidget.currentRow.__index;
            
            intervalId = setInterval(() => {
                clearInterval(intervalId);
                
                if (stateDoubleClick.clicks > 1 && stateDoubleClick.lastRowIndex == stateDoubleClick.currentRowIndex) {
                    execFunction(...params);
                }
                
                stateDoubleClick.clicks = 0;
            }, 500);
        }
        
        stateDoubleClick.clicks++;
    };
    
    this.saveCollectedDataGeneric = function(widget, description = undefined, fromFilter = false, ids = undefined) {
        let collectionIds;
        let valuesWidget = widget;
        
        if(fromFilter) {
            valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {
                return widget._filteredWidgetId == valuesWidget.id;
            })[0];
        }
        
        if(valuesWidget) {
        	if(valuesWidget.currentRow) {
        		if(valuesWidget.currentRow.CDFILSOLI)
        			collectionIds = valuesWidget.currentRow.CDFILSOLI;
        		else if(valuesWidget.currentRow.CDFILIAL)
        			collectionIds = valuesWidget.currentRow.CDFILIAL;
        		else if(valuesWidget.currentRow.LISTAFILIAL)
        			collectionIds = valuesWidget.currentRow.LISTAFILIAL;
        		else if(valuesWidget.currentRow.CDFILDEST)
        			collectionIds = valuesWidget.currentRow.CDFILDEST;
        		else
        		    return null;
        	} else {
        		return null;
        	}
        } else {
        	return null;
        }
        
        //widget instanceof Container
    	let operationId = '';
    	
    	MessageService.getMessageByCode("UTLTELA").then( fraseComParametro => {
    	    operationId = ScreenService.i18n(fraseComParametro, { NMTELA: description });
    	    
    	    /*
        	* Lista de descriptions utilizadas para tentar padronizar chamadas:
        	* ContainerAfterinit
        	*/
        	/*
    	    * @param $collectionIds  => ID ou ARRAY da(s) coleta(s) (Cod Filial, Cod Operador, Cod da Loja, ...)
    	    * @param $operationId    => ID da operação (Retirada, Cardápio, Login, ...)
    	    * @param $productId      => Código do Produto (opcional).
    	    * @param $operatorCode   => Código do Operador (opcional).
    	    * @param $operatorName   => Nome do Operador (opcional).
    	    * @param $organizationId => Código do organização (opcional).
    	    */
        	LibUtilities.saveCollectedData(collectionIds, operationId);
    	});
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Utilities', Utilities);
});

// FILE: ./assets/modules/solicitacao/assets/js/controllers/cmp06900alteracao_solicitacao_comprasController.js
var cmp06900alteracao_solicitacao_comprasController = function(General, ScreenService, MessageService) {
	
	this.filterUnit = function (field) {
		field.dataSourceFilter = [
			{
				'name': 'CDOPERADOR',
				'operator': '=',
				'value': getLocalVar('CDOPERADOR')
			},
			{
				'name': 'CDGRUPFILI',
				'operator': '=',
				'value': field.widget.currentRow.CDGRUPFILI
			}
		];
		field.reload();
	};
	
	this.filterNumb = function(field){ 
	    field.dataSourceFilter = [
			{
				'name': 'CDAGRUPFILI',
				'operator': '=',
				'value': field.widget.currentRow.CDGRUPFILI
			},
			{
				'name': 'CDFILSOLI',
				'operator': '=',
				'value': field.widget.currentRow.NMFILIAL
			},
			{
				'name': 'TCDFILSOLI',
				'operator': '=',
				'value': 'T'
			}
		];
		field.reload();
	};
	
	this.selectTodosLista = function (field) {
		if(field.checked) {
			field.widget.getField(field.name.substring(2,field.name.length)).clearValue();
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = true;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = {};
		} else {
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = false;
			if (field.name != 'T_NMGRUPFILI') 
				field.widget.getField(field.name.substring(2,field.name.length)).validations = { "required": {} };
		}
	};
	
	this.notApply = function (field) {
		if(field.checked) {
			field.widget.getField(field.name.substring(2,field.name.length)).clearValue();
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = true;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = {};
		} else {
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = false;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = { "required": {} };
		}
	};
	
	this.validateDtiniDtfim = function(field) {
		var fieldName = field.name === 'DTSOLINI' ? 'DTSOLFIM': 'DTENTRFIM';
		if(field.value()!== "") {
			field.widget.getField(fieldName).validations = { "required" : {} };
			field.widget.getField(fieldName).readOnly = false;
			field.widget.getField(fieldName).minDate = field.value();
		} else {
			field.widget.getField(fieldName).validations = {};
			field.widget.getField(fieldName).readOnly = true;
		}
	};
	
	this.verifyProdOrder = function(field){
		var row = field.widget.currentRow;
		if (!(General.comparaPratoProduto(row.INI_CDPROD, row.FIM_CDPROD, getLocalVar('CDPICTPROD')))){
			MessageService.shoeMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", "ERROR");
			row.FIM_PROD = "";
		}
	};
	
};

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp06900alteracao_solicitacao_comprasController', cmp06900alteracao_solicitacao_comprasController);
});

// FILE: ./assets/modules/V1/assets/js/controllers/AlteracaoAprovacaoAfController.js
function AlteracaoAprovacaoAfController(ScreenService, maskEngine, ZhUtil, General, Parametros, AlteracaoAprovacaoAfService, ZHPromise, MessageService) {

    var self = this;
    var maskProd = '';
    var acrescimo = 0;

    this.defineParametros = function(){
        maskProd = {
            "type": "fix",
            "params": {
                "mask": getLocalVar('CDPICTPROD')
            }
        };
        
        return Parametros.parcmpsup(getLocalVar('CDFILIAL')).then(function(callback){
            if (callback.dataset.parcmpsup.length) {
                acrescimo = callback.dataset.parcmpsup[0].VRACRESCIMOAF ? _toFloat(callback.dataset.parcmpsup[0].VRACRESCIMOAF) : null;
            }
        });

    };

    this.defaultFiltro = function(widgetFiltro) {
        if (!widgetFiltro.currentRow.TIPOAF) {
            widgetFiltro.newRow();
        }
        widgetFiltro.getField('TFORNECEDOR').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TFORNECEDOR'),widgetFiltro.getField('FORNECEDOR'));
        widgetFiltro.getField('TNMCOMPRADOR').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMCOMPRADOR'),widgetFiltro.getField('NMCOMPRADOR'));
        widgetFiltro.getField('TNMFILIALLANC').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMFILIALLANC'),widgetFiltro.getField('NMFILIALLANC'));
        widgetFiltro.getField('TNMFILIALDEST').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TNMFILIALDEST'),widgetFiltro.getField('NMFILIALDEST'));
        widgetFiltro.getField('TAUTOFORNE').checked = true;
        General.toggleReadOnlySelect(widgetFiltro.getField('TAUTOFORNE'),widgetFiltro.getField('AUTOFORNE'));
    };

    this.filtraAF = function(widgetAF, widgetFiltro){
        var rowFiltro = widgetFiltro.currentRow;
        if(widgetFiltro.isValid() && this.validaFiltro(rowFiltro)) {
            var dataSourceFilter = [];
            dataSourceFilter = [
                {
                    "name": "FORNECEDOR",
                    "value": this.montaLista(rowFiltro.TFORNECEDOR, rowFiltro.FORNECEDOR),
                    "operator": "="
                },
                {
                    "name": "COMPRADOR",
                    "value": this.montaLista(rowFiltro.TNMCOMPRADOR, rowFiltro.NMCOMPRADOR),
                    "operator": "="
                },
                {
                    "name": "CDFILLANC",
                    "value": this.montaLista(rowFiltro.TNMFILIALLANC, rowFiltro.NMFILIALLANC),
                    "operator": "="
                },
                {
                    "name": "CDFILDEST",
                    "value": this.montaLista(rowFiltro.TNMFILIALDEST, rowFiltro.NMFILIALDEST),
                    "operator": "="
                },
                {
                    "name": "IDSITUACAO",
                    "value": this.montaTipoAf(rowFiltro.TIPOAF),
                    "operator": "="
                },
                {
                    "name": "DTAFINI",
                    "value": rowFiltro.DTAFINI,
                    "operator": "="
                },
                {
                    "name": "DTAFFIN",
                    "value": rowFiltro.DTAFFIN,
                    "operator": "="
                },
                {
                    "name": "DTENTINI",
                    "value": rowFiltro.DTENTREGAINI,
                    "operator": "="
                },
                {
                    "name": "DTENTFIN",
                    "value": rowFiltro.DTENTREGAFIN,
                    "operator": "="
                },
                {
                    "name": "PRODINI",
                    "value": rowFiltro.CDPRODINICIAL ? rowFiltro.CDPRODINICIAL : '',
                    "operator": "="
                },
                {
                    "name": "PRODFIN",
                    "value": (rowFiltro.CDPRODFINAL?rowFiltro.CDPRODFINAL:'')+"ZZZZZZZZZZ".substr(0,10-(rowFiltro.CDPRODFINAL?rowFiltro.CDPRODFINAL.length:0)),
                    "operator": "="
                },
                {
                    "name": "AUTOFORNE",
                    "value": this.montaLista(rowFiltro.TAUTOFORNE, rowFiltro.AUTOFORNE),
                    "operator": "="
                },
                {
                    "name": "NRORG",
                    "value": getLocalVar('NRORG'),
                    "operator": "="
                }
            ];

            widgetAF.dataSourceFilter = dataSourceFilter;
            widgetAF.reload().then(function(){
                self.defineParametros().then(function(){
                    ScreenService.closePopup();
                    widgetAF.activate();
                });
            });
        }
    };

    this.retiraHoraData = function(widgetAF) {
        var dataSourceWidget = widgetAF.dataSource.data;

        for (var posicao in dataSourceWidget) {
            dataSourceWidget[posicao].DTAUTOFORN = dataSourceWidget[posicao].DTAUTOFORN ? dataSourceWidget[posicao].DTAUTOFORN.split(" ")[0] : dataSourceWidget[posicao].DTAUTOFORN;
            dataSourceWidget[posicao].DTPROGENTAF = dataSourceWidget[posicao].DTPROGENTAF ? dataSourceWidget[posicao].DTPROGENTAF.split(" ")[0] : dataSourceWidget[posicao].DTPROGENTAF;
        }
    };

    this.montaStripe = function(widgetStripe, rowFiltro){
        var produto = widgetStripe.getField('NMPRODUTO');
        var dataAf = widgetStripe.getField('DTAF');
        var dataEntrega = widgetStripe.getField('DTENTREGA');

        if(rowFiltro.NMPRODINICIAL){
            var inicial = Util.applyMask(rowFiltro.CDPRODINICIAL, maskProd, maskEngine, ZhUtil);
            var final = Util.applyMask(rowFiltro.CDPRODFINAL, maskProd, maskEngine, ZhUtil);

            produto.label = ScreenService.i18n('Produto: ')+inicial+' a '+final;
            produto.isVisible = true;
        } else{
            produto.isVisible = false;
        }

        if(rowFiltro.DTENTREGAINI){
            dataEntrega.label = ScreenService.i18n('Período Entrega: ')+rowFiltro.DTENTREGAINI+' a '+rowFiltro.DTENTREGAFIN;
            dataEntrega.isVisible = true;
        } else{
            dataEntrega.isVisible = false;
        }

        if(rowFiltro.DTAFINI){
            dataAf.label = ScreenService.i18n('Período AF: ')+rowFiltro.DTAFINI+' a '+rowFiltro.DTAFFIN;
            dataAf.isVisible = true;
        } else{
            dataAf.isVisible = false;
        }
    };

    this.montaLista = function(fieldTodos, fieldSelect){
        if(fieldTodos == 'T'){
            return 'T';
        } else{
            return fieldSelect.join();
        }
    };

    this.montaTipoAf = function(selectTipoAf){
        var tipoAf = '';
        tipoAf += selectTipoAf.join('_');
        return tipoAf;
    };

    this.validaFiltro = function(currentRow){
        var tipoAf = verificaTipoAf(currentRow.TPAFAUTOMATICA, currentRow.TPAFMANUAL);
        var dataAf = verificaData(currentRow.DTAFINI, currentRow.DTAFFIN, 'da AF');
        var dataEntrega = verificaData(currentRow.DTENTREGAINI, currentRow.DTENTREGAFIN, 'de entrega');
        var produto = verificaProduto(currentRow.CDPRODINICIAL, currentRow.CDPRODFINAL);

        if(!tipoAf || !dataAf || !dataEntrega || !produto){
            return false;
        } else{
            return true;
        }
    };

    function verificaTipoAf(automatica, manual){
        if(automatica == 'N' && manual == 'N'){
            MessageService.showMessageByCode("TIPO_AF_REQUIRED");
            return false;
        } else{
            return true;
        }
    }

    function verificaData(inicial, _final, mensagem) {

        if(inicial || _final) {
            if(!inicial) {
                MessageService.showMessageByCode("DTA_INICIAL_REQUIRED");
                return false;
            }
            if(!_final) {
                MessageService.showMessageByCode("DTA_FINAL_REQUIRED");
                return false;
            }
            if(moment(inicial, 'DD/MM/YYYY') > moment(_final, 'DD/MM/YYYY')) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                return false;
            }
        }

        return true;
    }

    function verificaProduto(inicial, _final) {
        if(inicial || _final) {
            if(!inicial) {
                MessageService.showMessageByCode("PROD_INICIAL_REQUIRED");
                return false;
            }
            if(!_final) {
                MessageService.showMessageByCode("PROD_FINAL_REQUIRED");
                return false;
            }
			if(!General.comparaPratoProduto(inicial, _final, getLocalVar('CDPICTPROD'))) {
			    MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
				return false;
			}
        }

        return true;
    }

    this.filtraUnidadeAgrupamento = function(fieldUnidades, stringUnidades){
        if(stringUnidades) {
            var unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "value": "",
                    "operator": "IN"
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
        } else{
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.filtraAfUnidade = function(fieldAf, unidadesLanc, unidadesDest){
        if(unidadesLanc.length && unidadesDest.length) {
            fieldAf.dataSourceFilter = [
                {
                    "name": "CDFILDEST",
                    "value": "",
                    "operator": "IN"
                },
                {
                    "name": "CDFILLANC",
                    "value": "",
                    "operator": "IN"
                },
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldAf);
            General.onClickDependentField(fieldAf, {'CDFILDEST': unidadesDest, 'CDFILLANC': unidadesLanc, 'NRORG': getLocalVar('NRORG')});
        } else{
            if(unidadesLanc.length){
                fieldAf.dataSourceFilter = [
                    {
                        "name": "CDFILLANC",
                        "value": "",
                        "operator": "IN"
                    },
                    {
                        "name": "NRORG",
                        "value": "",
                        "operator": "="
                    }
                ];
                this.defineSelectWidget(fieldAf);
                General.onClickDependentField(fieldAf, {'CDFILLANC': unidadesLanc, 'NRORG': getLocalVar('NRORG')});
            } else{
                if(unidadesDest.length){
                    fieldAf.dataSourceFilter = [
                        {
                            "name": "CDFILDEST",
                            "value": "",
                            "operator": "IN"
                        },
                        {
                            "name": "NRORG",
                            "value": "",
                            "operator": "="
                        }
                    ];
                    this.defineSelectWidget(fieldAf);
                    General.onClickDependentField(fieldAf, {'CDFILDEST': unidadesDest, 'NRORG': getLocalVar('NRORG')});
                } else{
                    fieldAf.dataSourceFilter = [
                        {
                            "name": "NRORG",
                            "value": "",
                            "operator": "="
                        }
                    ];
                    this.defineSelectWidget(fieldAf);
                    General.onClickDependentField(fieldAf, {'NRORG': getLocalVar('NRORG')});
                }
            }
        }
    };

    this.filtraMarcaProduto = function(fieldMarca, produto){
        if(produto){
            fieldMarca.dataSourceFilter = [
                {
                    "name": "CDPRODUTO",
                    "value": "",
                    "operator": "="
                },
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
        }
        General.onClickDependentField(fieldMarca, {'CDPRODUTO': produto, 'NRORG': getLocalVar('NRORG')});
    };

    this.limpaUnidade = function(currentRow){
        currentRow.NMFILIALLANC = '';
        currentRow.NMFILIALDEST = '';
        this.limpaAf(currentRow);
    };

    this.limpaAf = function(currentRow){
        currentRow.AUTOFORNE = '';
    };

    this.limpaMarca = function(fieldMarca, produto){
        fieldMarca.setValue('');
        fieldMarca.readOnly = !produto;
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.abreItemAf = function(widgetProduto, currentRowAf){
        var dataSourceFilter = [];
        dataSourceFilter = [
            {
                "name": "NRAUTOFORN",
                "value": currentRowAf.NRAUTOFORN,
                "operator": "="
            },
            {
                "name": "CDFILDEST",
                "value": currentRowAf.CDFILDEST,
                "operator": "="
            },
            {
                "name": "CDFILLANC",
                "value": currentRowAf.CDFILLANC,
                "operator": "="
            },
            {
                "name": "NRORG",
                "value": currentRowAf.NRORG,
                "operator": "="
            }
        ];

        widgetProduto.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widgetProduto);
        widgetProduto.activate();
        widgetProduto.reload();
    };

    this.retiraHoraDataProduto = function(widgetProduto) {
        var dataSourceWidgetProd = widgetProduto.dataSource.data;

        for (var posicao in dataSourceWidgetProd) {
            dataSourceWidgetProd[posicao].DTPROGENTAF = dataSourceWidgetProd[posicao].DTPROGENTAF ? dataSourceWidgetProd[posicao].DTPROGENTAF.split(" ")[0] : dataSourceWidgetProd[posicao].DTPROGENTAF;
        }
    };

    this.cancelaEdicaoItemAf = function(widget, fechaSwipe){
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        self.voltaModoListItem(widget, fechaSwipe);
    };

    this.voltaModoListItem = function(widget, fechaSwipe) {
        widget.currentRow.__is_new = false;
        widget.currentRow.changed = false;
        widget.list(fechaSwipe);
        widget.formTemplate = widget.template;
        widget.container.getWidget('produto_af').activate();
    };

    this.excluiItemAf = function(widget){
        var itemAf = widget.dataSource.data;
        var checkItemAf = widget.dataSource.checkedRows;
        var widgetAf = widget.container.getWidget('autorizacao_fornecimento');

        if (itemAf.length == checkItemAf.length) {
            MessageService.showMessageByCode("AF_ITENS_REQUIRED");
        } else {
            var msg = "Confirma exclusão do(s) item(ns) selecionado(s)?";
            ScreenService.confirmMessage(msg, 'INFORMATION', function() {
                widget.removeCheckedRows().then(function(){
                    widget.currentRow.CDFILDEST = widgetAf.currentRow.CDFILDEST;
                    widget.currentRow.CDFILLANC = widgetAf.currentRow.CDFILLANC;
                    widget.currentRow.NRAUTOFORN = widgetAf.currentRow.NRAUTOFORN;
                    widget.currentRow.NRORG = widgetAf.currentRow.NRORG;
                    widget.currentRow.CDEMPRESA = widgetAf.currentRow.CDEMPRESA;
                    widget.currentRow.NRINSJURFORN = widgetAf.currentRow.NRINSJURFORN;
                    widget.currentRow.CDFORNECED = widgetAf.currentRow.CDFORNECED;
                    widget.currentRow.DTAUTOFORN = widgetAf.currentRow.DTAUTOFORN;
                    concluiFechamentoAf(widget.currentRow);
                    atualizaAutoForne(widget.dataSource.data, widgetAf);
                });
            }, function() {
                widget.unSelectAll();
                templateManager.updateTemplate();
            });
        }
    };

    this.salvaItemAf = function(widget){
        blurFields([$("#QTPROGENTAF"), $("#VRPREUNIAF")]);
        if(widget.isValid()) {
            var widgetAf = widget.container.getWidget('autorizacao_fornecimento');
            var currentRowAf = widgetAf.currentRow;
            var currentRowItemAf = widget.currentRow;
            var dadosItemAf = widget.container.getWidget('produto_af');
            var fechaSwipe = false;
            var representacoes = {
                "NRAUTOFORN": currentRowAf.NRAUTOFORN
            };

            if(!currentRowAf.IDBAIXAAF) {
                this.validaNovoItemAf(widget).then(function () {
                    currentRowItemAf.CDEMPRESA = currentRowAf.CDEMPRESA;
                    currentRowItemAf.NRINSJURFORN = currentRowAf.NRINSJURFORN;
                    currentRowItemAf.DTAUTOFORN = currentRowAf.DTAUTOFORN;
                    currentRowItemAf.CDFORNECED = currentRowAf.CDFORNECED;
                    currentRowItemAf.DTULTATU = moment();

                    if (widget.name == 'insere_produto_af') {
                        currentRowItemAf.CDFILDEST = currentRowAf.CDFILDEST;
                        currentRowItemAf.CDFILLANC = currentRowAf.CDFILLANC;
                        currentRowItemAf.NRAUTOFORN = currentRowAf.NRAUTOFORN;
                        currentRowItemAf.DTPROGENTAF = retornaDataProgEntregaAf(dadosItemAf.dataSource.data);
                        currentRowItemAf.IDITAFMIGRADA = 'N';
                        currentRowItemAf.IDBAIXITMFUTURA = 'X';
                        currentRowItemAf.IDDEVOLUCAONFIT = 'N';
                        currentRowItemAf.CDOPERINCLUSAO = getLocalVar('CDOPERADOR');
                        currentRowItemAf.DTINCLUSAO = moment();
                        currentRowItemAf.IDATIVO = 'S';
                        currentRowItemAf.NRORG = getLocalVar('NRORG');
                        fechaSwipe = true;
                    }

                    widget.saveRow().then(function () {
                        concluiFechamentoAf(currentRowItemAf);
                        self.voltaModoListItem(widget, fechaSwipe);

                        if(widget.name == 'insere_produto_af'){
                            dadosItemAf.reload().then(function(){
                                atualizaAutoForne(widget.container.getWidget('produto_af').dataSource.data, widgetAf);
                            });
                        } else{
                            atualizaAutoForne(widget.dataSource.data, widgetAf);
                        }
                    });
                });
            } else {
                MessageService.showMessageByCode("AF_STATUS_BLOCK", { "NRAUTOFORN": currentRowAf.NRAUTOFORN });
            }
        }
    };

    function concluiFechamentoAf(currentRowItemAf){
        AlteracaoAprovacaoAfService.proceVerificaInconsAfs(currentRowItemAf).then(function () {
            AlteracaoAprovacaoAfService.proceImpostoItemAf(currentRowItemAf).then(function () {
                AlteracaoAprovacaoAfService.proceExcluiContaPagarPrevista(currentRowItemAf).then(function() {
                    AlteracaoAprovacaoAfService.proceGeraContaPagarPrevista(currentRowItemAf).then(function(){
                        AlteracaoAprovacaoAfService.proceFechamentoAf(currentRowItemAf).then(function(){
                            MessageService.successNotificationByCode("FECHAMENTO_AF", { "NRAUTOFORN": currentRowItemAf.NRAUTOFORN });
                            AlteracaoAprovacaoAfService.proceConsisteOrcamento(currentRowItemAf);
                        });
                    });
                });
            });
        });
    }

    function retornaDataProgEntregaAf(dadosItemAf){
        var maiorData = '';
        dadosItemAf.forEach(function (linha) {
            var dataProgEnt = moment(linha.DTPROGENTAF, 'DD/MM/YYYY');
            if(maiorData < dataProgEnt){
                maiorData = dataProgEnt;
            }
        });

        return maiorData._i;
    }

    function atualizaAutoForne(dadosItemAf, widgetAF){
        var soma = 0;

        dadosItemAf.forEach(function(itemAf){
            soma += _toFloat(itemAf.PRECOTOTAL);
        });

        widgetAF.getField('VRTOTALAF').setValue(soma.toString().replace('.', ','));
    }

    this.validaNovoItemAf = function(widget){
        var deferred = ZHPromise.defer();

        var currentRowItemAf = widget.currentRow;
        var currentRowAf = widget.container.getWidget('autorizacao_fornecimento').currentRow;
        var dadosItemAf = widget.container.getWidget('produto_af').dataSource.data;

        if(verificaValorNegativo(currentRowItemAf) && verificaValorTotalReal(dadosItemAf, currentRowAf, widget)) {
            if (widget.name == 'insere_produto_af') {

                var promises = [];

                var nrorg = currentRowAf.NRORG;
                var nrAutoForn = currentRowAf.NRAUTOFORN;
                var cdFornecedor = currentRowAf.CDFORNECED;
                var cdProduto = currentRowItemAf.CDPRODUTO;
                var nmProduto = currentRowItemAf.NMPRODUTO;
                var dtAutoForn = currentRowAf.DTAUTOFORN;
                var cdFilDest = currentRowAf.CDFILDEST;
                var cdFilLanc = currentRowAf.CDFILLANC;
                var cdMarca = currentRowItemAf.CDMARCA;
                var nmMarca = currentRowItemAf.NMMARCA;
                var tpFormPagamento = currentRowAf.IDTPFORPGTAF;

                promises.push(AlteracaoAprovacaoAfService.verificaProdutoFornecedor(nrorg, cdFornecedor, cdProduto));
                promises.push(AlteracaoAprovacaoAfService.verificaQualificacaoMarca(nrorg, cdProduto, cdMarca, cdFilDest, dtAutoForn));
                promises.push(AlteracaoAprovacaoAfService.verificaProdQualificadoForn(nrorg, cdProduto, cdFornecedor, cdFilDest, dtAutoForn));
                promises.push(AlteracaoAprovacaoAfService.verificaProdutoInativo(nrorg, cdProduto, cdFilDest));

                if (tpFormPagamento == 'V') {
                    promises.push(AlteracaoAprovacaoAfService.verificaPrazoPagamento(nrorg, cdFilDest,cdFilLanc, nrAutoForn));
                }

                ZHPromise.all(promises).then(function (callback) {
                    var itemAfRepetido = verificaExiteItemAf(dadosItemAf, currentRowItemAf);
                    var produtoFornecedor = verificaProdutoFornecedor(callback[0], nmProduto);
                    var qualificacaoMarca = verificaQualificacaoMarca(callback[1], nmProduto, nmMarca);
                    var prodQualificadoForn = verificaProdQualificadoForn(callback[2], nmProduto);
                    var produtoInativo  = verificaProdutoInativo(callback[3], nmProduto);
                    var formaPagamento = verificaFormaPagamento(callback[4], nrAutoForn);

                    if(!itemAfRepetido || !produtoFornecedor || !qualificacaoMarca || !prodQualificadoForn || !produtoInativo ||!formaPagamento){
                        deferred.reject();
                    } else {
                        deferred.resolve();
                    }
                });
            } else {
                deferred.resolve();
            }
        } else{
            deferred.reject();
        }

        return deferred;
    };

    function verificaValorTotalReal(dadosItemAf, currentRowAf, widget){
        if (acrescimo) {
            toFloatArray(currentRowAf, ['VRTOTALAF', 'VRTOTALAFORG']);
            var somaItemAf = 0;
            var valorTotalAntigo = currentRowAf.VRTOTALAF;
            var valorTotalReal = currentRowAf.VRTOTALAFORG;
            var representacoes = {
                "valorTotalReal": valorTotalReal.toFixed(2).toString().replace('.', ',')
            };

            if (!valorTotalReal) {
                valorTotalReal = valorTotalAntigo + valorTotalAntigo * acrescimo / 100;
                currentRowAf.VRTOTALAFORG = valorTotalReal;
                AlteracaoAprovacaoAfService.salvaValorTotalReal(currentRowAf);
            } 

            dadosItemAf.forEach(function (linha) {
                somaItemAf += _toFloat(linha.PRECOTOTAL);
            });

            if(widget.name == 'insere_produto_af'){
                somaItemAf += _toFloat(widget.getField('PRECOTOTAL').value());
            }

            if (somaItemAf > valorTotalReal) {
                MessageService.showMessageByCode("VLR_TOTAL_AF_SUPERIOR", { "VALORTOTALREAL": valorTotalReal.toFixed(2).toString().replace('.', ',') });
                return false;
            } else {
                return true;
            }
        } else {
            MessageService.showMessageByCode("PARAM_VLR_ACRS_AF_REQUIRED");
            return false;
        }
    }

    function verificaValorNegativo(currentRow) {
        toFloatArray(currentRow, ['QTPROGENTAF', 'VRPREUNIAF']);
        if (currentRow.QTPROGENTAF <= 0) {
            MessageService.showMessageByCode("QTD_MAIOR_ZERO");
            return false;
        }
        if (currentRow.VRPREUNIAF <= 0) {
            MessageService.showMessageByCode("PRECO_UNIT_MAIOR_ZERO");
            return false;
        }
        return true;
    }

    function verificaProdutoFornecedor(produtoFornecedor, nmProduto){
        var fornecedor = produtoFornecedor.dataset.fornecedor[0].FORNECEDOR;

        if(fornecedor == '0') {
            MessageService.showMessageByCode("PRODUTO_NAO_VINCULADO", { "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaQualificacaoMarca(qualificacaoMarca, nmProduto, nmMarca) {
        var marca = qualificacaoMarca.dataset.qualificacao.length;
        if(marca) {
            MessageService.showMessageByCode("MARCA_QUALIFICACAO_VENCIDA", { "NMMARCA": nmMarca, "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaProdQualificadoForn(prodQualificadoForn, nmProduto) {

        var prodForn = prodQualificadoForn.dataset.prodForn.length;
        if(prodForn) {
            MessageService.showMessageByCode("PRODUTO_NAO_QUALIFICADO", { "NMPRODUTO": nmProduto });
            return false;
        } else {
            return true;
        }
    }

    function verificaExiteItemAf(dadosItemAf, currentRowItemAf) {
        for(var i = 0; i < dadosItemAf.length; i ++) {
            if(dadosItemAf[i].CDMARCA == currentRowItemAf.CDMARCA && dadosItemAf[i].CDPRODUTO == currentRowItemAf.CDPRODUTO) {
                MessageService.showMessageByCode("AF_JA_EXISTENTE", { "NMPRODUTO": currentRowItemAf.NMPRODUTO, "NMMARCA": currentRowItemAf.NMMARCA });
                return false;
            }
        }
        return true;
    }

    function verificaProdutoInativo(produtoInativo, nmProduto) {
        var prodInativo = produtoInativo.dataset.produto.length;
        if(prodInativo) {
            MessageService.showMessageByCode("PRODUTO_IVATIVO", { "NMPRODUTO": nmProduto });
            return false;
        } else{
            return true;
        }
    }

    function verificaFormaPagamento(formaPagamento, nrAutoForn) {
        if(formaPagamento) {
            if (formaPagamento.dataset.prazopgtaf.length === 0) {
                MessageService.showMessageByCode("AF_SEM_PRAZO_PAGTO", { "NRAUTOFORN": nrAutoForn });
                return false;
            }
        }
        return true;
    }

    this.atualizaTotalProd = function(row) {
        var quantidade = _toFloat(row.QTPROGENTAF);
        var preco = _toFloat(row.VRPREUNIAF);
        row.PRECOTOTAL = quantidade * preco;
    };

    var toFloatArray = function (row, fields) {
        fields.forEach(function(field){
            row[field] = _toFloat(row[field]);
        });
    };

    var _toFloat = function(val) {
        var _float = (typeof val === "number") && !isNaN(val) ? val : parseFloat(val.replace(/\./g, '').replace(',', '.')); 
        return _float;
    }; 

    var blurFields = function(fields) {
        fields.forEach(function(field){
            field.blur();
        });
    }; 
}

Configuration(function (ContextRegister) {
    ContextRegister.register('AlteracaoAprovacaoAfController', AlteracaoAprovacaoAfController);
});

// FILE: ./assets/modules/V1/assets/js/controllers/CalcNecessidadeCompraController.js
function CalcNecessidadeCompraController(ScreenService, NecessidadeCompraService, Parametros, ZHPromise, General, localStorageEngine, MessageService) {

    var self = this;
    var params = [];
    var todasUnidades;
    var dtentrneccmp;
    var cdGrupoProd;
    var dataUtilizacao;
    var calcPrevConsumo;
    var dataProcessamento;
    var onEnterOnce = true;
    var onEnterOnceHist = true;

    this.parametros = function (widget) {

        var cdfilial = getLocalVar('CDFILIAL');
        var centralCompras;
        var promises = [];
        todasUnidades = '';

        localStorageEngine.getDataSource('/unidades').then(function(unidades) {
            unidades.forEach(function(unidade){
                todasUnidades += unidade.CDFILIAL+'_';
                if(unidade.CDFILIAL == cdfilial){
                    centralCompras = unidade.CDFILCENTCMP;
                }
            });

            promises.push(Parametros.parasupri(centralCompras));

            promises.push(Parametros.parcmpsup(getLocalVar('CDFILIAL')));

            promises.push(Parametros.paramgeral());

            ZHPromise.all(promises).then(function (callback) {
                cdGrupoProd = callback[0].dataset.parasupri.length ? callback[0].dataset.parasupri[0].CDGRUPPROD : 'N';
                dataUtilizacao = callback[0].dataset.parasupri.length ? callback[0].dataset.parasupri[0].IDULTIDTULTI : 'N';
                calcPrevConsumo = callback[1].dataset.parcmpsup[0].IDCALPREVCON;

                var infoPerAcrescimo = callback[1].dataset.parcmpsup[0].IDPERACRNEC;
                var calcPeriodicidade = callback[2].dataset.paramgeral[0].IDSISDOS;

                self.controlaAcrescimo(widget, infoPerAcrescimo);
                self.controlaPeriodicidade(widget, calcPeriodicidade);
                widget.getField('NMSUBGRPROD').reload();
            });

        });

    };


    //CALCULO DA NECESSIDADE DE COMPRAS

    this.valorDefaultRelatorios = function(widget){
        if(onEnterOnce) {
            widget.currentRow.CD_REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().valor;
            widget.currentRow.REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().nome;
            onEnterOnce = false;
        }
    };

    this.valorDefaultCalcNeceComp = function(widget){
        Parametros.retornaDataProcessamento().then(function(callback){
            dataProcessamento = callback;
            widget.currentRow.NMGRUPFILI = '';
            widget.currentRow.TCDFILIAL = '';
            //widget.getField('TCDFILIAL').checked = true;
            widget.getField('DTENTREGAINI').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.currentRow.NMSUBGRPROD = '';
            widget.currentRow.NMPRODINICIAL = '';
            widget.currentRow.NMPRODFINAL = '';
            widget.currentRow.PEACRESCIMO = '0';
            widget.getField('SOLIEXTRA').checked = false;
            //General.toggleReadOnlySelect(widget.getField('TCDFILIAL'), widget.getField('CDFILIAL'));
        });
    };

    this.valorDefaultHistNeceComp = function(widget){
        if(onEnterOnceHist) {
            widget.currentRow.CD_REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().valor;
            widget.currentRow.REPORT_NAME = widget.getField('REPORT_NAME').dataSource.getFirstRow().nome;
            widget.getField('TNMFILIAL').checked = true;
            General.toggleReadOnlySelect(widget.getField('TNMFILIAL'), widget.getField('NMFILIAL'));
            widget.getField('TNMOPERADOR').checked = true;
            General.toggleReadOnlySelect(widget.getField('TNMOPERADOR'), widget.getField('NMOPERADOR'));
            widget.getField('DTENTREGAINI').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTGERACAOINI').setValue(moment().format('DD/MM/YYYY'));
            widget.getField('DTGERACAOFIN').setValue(moment().format('DD/MM/YYYY'));
            onEnterOnceHist = false;
        }
    };

    this.calculaNecessidade = function (widget) {
        if (widget.isValid() && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN) && self.verificaDtProcessamento(widget.currentRow.DTENTREGAINI) && self.validaProduto(widget.currentRow.CDPRODINICIAL, widget.currentRow.CDPRODFINAL) && self.limitaNumeroFilial(widget.currentRow.CDFILIAL)) {
            params = {
                "CDFILIAL": self.montaLista(widget.currentRow.CDFILIAL, '', widget.currentRow.UNIDADES),
                "TCDFILIAL": '',
                "CDGRUPFILI": '',
                "DTINICIAL": widget.currentRow.DTENTREGAINI,
                "DTFINAL": widget.currentRow.DTENTREGAFIN,
                "CDPRODINI": widget.currentRow.CDPRODINICIAL,
                "CDPRODFIN": widget.currentRow.CDPRODFINAL,
                "PEACRESCIMO": widget.currentRow.PEACRESCIMO,
                "CDOPERADOR": getLocalVar('CDOPERADOR'),
                "EXTRA": widget.currentRow.SOLIEXTRA,
                "NRORG": getLocalVar('NRORG'),
                "CDGRUPPROD": cdGrupoProd,
                "CDSUBGRUPO": self.montaListaSubgrupo(widget.currentRow.NMSUBGRPROD),
                "IDQTDEZERO": 'S',
                "DTHRCALCNC": '',
                "DTCALCULO": '',
                "GERASOLICITA": ''
            };

            if (calcPrevConsumo == 'S') {
                this.calculaDataPrevisaoConsumo().then(function (data) {
                    params.DTCALCULO = data;
                    var mensagem = ScreenService.i18n("Deseja calcular a previsão de consumo no período entre as datas de processamento de cada unidade e o dia ");
					mensagem += ' ' + data + '?';
                    if (widget.currentRow.CDFILIAL.length == 1) {
                        var widgetCalcPrevisao = widget.container.getWidget('tab_cmp03000_calcular_previsao_consumo');
                        widgetCalcPrevisao.getField('CALCPREVCONSUMO').label = mensagem;
                        ScreenService.openPopup(widgetCalcPrevisao);
                        params.GERASOLICITA = 'N';
                    } else {
                        var widgetRelatorio = widget.container.getWidget('tab_cmp03001_relatorio_previa_necessidade_compra');
                        widgetRelatorio.getField('CALCPREVCONSUMO').label = mensagem;
                        ScreenService.openPopup(widgetRelatorio);
                        params.GERASOLICITA = 'S';
                    }
                });
            } else {
                if (widget.currentRow.CDFILIAL.length == 1) {
                    params.GERASOLICITA = 'N';
                    self.confirmaCalculoNecessidade(widget, widget);
                } else {
                    params.GERASOLICITA = 'S';
                    var widgetRelatorio = widget.container.getWidget('tab_cmp03001_relatorio_previa_necessidade_compra');
                    widgetRelatorio.getField('CALCPREVCONSUMO').isVisible = false;
                    ScreenService.openPopup(widgetRelatorio);
                }
            }
        }
    };

    var proceCalculaPrevconsFiliais = function (prevConsumo) {
        var deferred = ZHPromise.defer();

        if (prevConsumo == 1) {
            NecessidadeCompraService.proceCalculaPrevconsFiliais(params).then(function () {
                deferred.resolve();
            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    var procePeriodicidadeNaoCalculada = function (periodicidade) {
        var deferred = ZHPromise.defer();

        if (periodicidade == 'S') {
            NecessidadeCompraService.procePeriodicidadeNaoCalculada(params).then(function () {
                deferred.resolve();
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    var proceGeraSolicitacao = function (geraSoli) {
        var deferred = ZHPromise.defer();

        if (geraSoli == 'S') {
            NecessidadeCompraService.proceGeraSolicitacao(params).then(function () {
                deferred.resolve();
            });
        } else {
            deferred.reject();
        }

        return deferred;
    };

    this.relatorioPreviaNecessidadeCompra = function (widget, geraSoli) {
        var deferred = ZHPromise.defer();
        var promises = [];

        if (geraSoli == 'S') {
            NecessidadeCompraService.listaUnidades(params.NRNECECOMP, params.NRORG).then(function (listaUnidades) {
                var reportName = widget.currentRow.CD_REPORT_NAME;
                if (reportName == 'cmp03800') {
                    for (i = 0; i < listaUnidades.dataset.trabnececomp_distinct.length; i++) {
                        row = {
                            "DATAINI": params.DTINICIAL,
                            "DATAFIN": params.DTFINAL,
                            "FILIPROC": getLocalVar('CDFILIAL'),
                            "NRNECECOMP": params.NRNECECOMP,
                            "CDFILIAL": listaUnidades.dataset.trabnececomp_distinct[i].CDFILNECECMP
                        };
                        promises.push(NecessidadeCompraService.openReportSemMensagem('/cmp03800', reportName, row));
                    }
                } else {
                    for (i = 0; i < listaUnidades.dataset.trabnececomp_distinct.length; i++) {
                        row = {
                            "NRNECECOMP": params.NRNECECOMP,
                            "CDFILIAL": listaUnidades.dataset.trabnececomp_distinct[i].CDFILNECECMP
                        };
                        promises.push(NecessidadeCompraService.openReportSemMensagem('/cmp03800', reportName, row));
                    }
                }
                ZHPromise.all(promises).then(function(){
                    deferred.resolve();
                    ScreenService.closePopup();
                });
            });
        } else {
            deferred.resolve();
        }

        return deferred;
    };

    this.confirmaCalculoNecessidade = function (widgetPopup, widgetCalc) {
        if (widgetPopup.isValid()) {
            params.DTHRCALCNC = moment().format('DD/MM/YYYY hh:mm:ss');
            proceCalculaPrevconsFiliais(widgetPopup.currentRow.CALCPREVCONSUMO).then(function () {
                procePeriodicidadeNaoCalculada(widgetCalc.currentRow.CALCPERIODICIDADE).then(function () {
                    NecessidadeCompraService.proceNecessidadeDeCompras(params).then(function (callback) {
                        params.NRNECECOMP = callback.dataset.nrnececomp[0];
                        self.relatorioPreviaNecessidadeCompra(widgetPopup, params.GERASOLICITA).then(function () {
                            proceGeraSolicitacao(params.GERASOLICITA).then(function(){
                                self.excluiTrabnececomp();
                                MessageService.successNotificationByCode("SOL_CMP_SUCCESS_INSERT");
                            }, function () {
                                if(params.GERASOLICITA == 'N') {
                                    ScreenService.openWindow('cmp_V1#cmp03001');
                                }
                            });
                        });
                    });
                });
            });
        }
    };

    this.calculaDataPrevisaoConsumo = function () {
        var paramsQuery = Util.clone(params);
        var pad ='ZZZZZZZZZZ';
        var str = paramsQuery.CDPRODFIN;
        paramsQuery.CDPRODFIN = str + pad.substr(0,pad.length-str.length);
        return NecessidadeCompraService.dataPrevisaoConsumo(paramsQuery).then(function (callback) {
            var data = paramsQuery.DTFINAL;
            data = moment(data, 'DD/MM/YYYY').add(1, 'month');
            data = moment(data, 'DD/MM/YYYY').add(callback.dataset.cmp03000_calculodata[0].MAXLIMISEG, 'day').format('DD/MM/YYYY');

            return data;
        });
    };

    this.controlaAcrescimo = function (widget, infoPerAcrescimo) {
        if (infoPerAcrescimo == 'N') {
            widget.getField('PEACRESCIMO').readOnly = true;
        } else {
            widget.getField('PEACRESCIMO').readOnly = false;
        }
    };

    this.controlaPeriodicidade = function (widget, calcPeriodicidade) {
        if (calcPeriodicidade == 3) {
            widget.getField('CALCPERIODICIDADE').readOnly = true;
            widget.getField('CALCPERIODICIDADE').setValue('S');
        } else {
            widget.getField('CALCPERIODICIDADE').readOnly = false;
        }
    };

    this.verificaDtProcessamento = function(dtinicial) {
        if(moment(dtinicial, 'DD/MM/YYYY') >= moment(dataProcessamento, 'L')) {
            return true;
        } else {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
    };

    this.limitaNumeroFilial = function(unidades) {
        if(unidades.length > 70) {
            MessageService.showMessageByCode("AJUSTE_FILTRO_MENOR_UNIDADE");
            return false;
        } else {
            return true;
        }
    };

    this.relatorioHistoricoNecessidadeCompra = function (widget) {
        if (widget.isValid() && self.validaData(widget.currentRow.DTGERACAOINI, widget.currentRow.DTGERACAOFIN) && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN)) {
            var reportName = widget.currentRow.CD_REPORT_NAME;
            var row = {
                "CDFILIAL": self.montaLista(widget.currentRow.NMFILIAL, widget.currentRow.TNMFILIAL, widget.currentRow.UNIDADES),
                "CDFILIAL2": self.montaLista(widget.currentRow.NMFILIAL, widget.currentRow.TNMFILIAL, widget.currentRow.UNIDADES),
                "CDGRUPFILI": '',
                "CDOPERADOR": self.montaListaOperador(widget.currentRow.NMOPERADOR, widget.currentRow.TNMOPERADOR),
                "DTINI": widget.currentRow.DTGERACAOINI,
                "DTFIN": widget.currentRow.DTGERACAOFIN,
                "DTENTRINICIAL": widget.currentRow.DTENTREGAINI,
                "DTENTRFINAL": widget.currentRow.DTENTREGAFIN
            };

            if(reportName == 'cmp03004'){
                row.CDOPERADOR1 = self.montaListaOperador(widget.currentRow.NMOPERADOR, widget.currentRow.TNMOPERADOR);
            }

            General.openReport('/cmp03000', reportName, row);
        }
    };


    //NECESSIDADE DE COMPRAS

    this.abreListaProduto = function (currentRow, widget) {
        var dataSourceFilter = [];
        dataSourceFilter = [
            {"name": "NRNECECOMP",      "value": params.NRNECECOMP,         "operator": "="},
            {"name": "DTENTRNECCMP",    "value": currentRow.DTENTRNECCMP,   "operator": "="},
            {"name": "CDFILNECECMP",    "value": currentRow.CDFILNECECMP,   "operator": "="},
            {"name": "NRORG",           "value": currentRow.NRORG,          "operator": "="},
            {"name": "QTPRACOMPRAR",    "value": 0,                         "operator": ">" }
        ];

        widget.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widget);
        widget.activate();
        widget.reload();
    };

    this.abreListaData = function (currentRow, widget) {
        var dataSourceFilter = [];
        dataSourceFilter = [
            {"name": "NRNECECOMP",      "value": params.NRNECECOMP,         "operator": "=" },
            {"name": "CDPRODNECCMP",    "value": currentRow.CDPRODNECCMP,   "operator": "=" },
            {"name": "CDFILNECECMP",    "value": currentRow.CDFILNECECMP,   "operator": "=" },
            {"name": "NRORG",           "value": currentRow.NRORG,          "operator": "=" },
            {"name": "QTPRACOMPRAR",    "value": 0,                         "operator": ">" },
            {"name": "DTINICIAL",       "value": params.DTINICIAL,          "operator": "=" }
        ];

        widget.dataSourceFilter = dataSourceFilter;
        ScreenService.openSwipe(widget);
        widget.activate();
        widget.reload();
        widget.restoreDefaultMode();
    };

    function aplicaDistinct(dados, nomeField) {
        var dadosDistinct = [];
        if (dados && dados.length) {
            dados.forEach(function (linha) {
                var filtered = dadosDistinct.filter(function (linhaFilter) {
                    return linhaFilter[nomeField] == linha[nomeField];
                });
                if (!filtered.length) dadosDistinct.push(linha);
            });
        }
        return dadosDistinct;
    }

    this.carregarNecessidade = function (widget, nomeField) {
        widget.reload().then(function () {
            widget.dataSource.data = aplicaDistinct(widget.dataSource.data, nomeField);
        });
    };

    this.insereNecessidadeCompra = function (widget) {
        widget.newRow = function () {
            var event;
            if (this.beforeNewRow) {
                event = this.beforeNewRow();
            }
            if (!event || !event.isDefaultPrevented()) {

                var _oldValuesToRepeat = this.getRepeatOnNewValues();
                var row = {};
                if (this.dataSource) {
                    this.dataSource.newRow();
                    row = this.dataSource.data[this.dataSource.data.length - 1];
                }
                this.currentRow = row;
                this.applyDefaultValue();
                Util.extend(this.currentRow, _oldValuesToRepeat);
                this.edit();
                this.formTemplate = this.templateToForm;
                if (this.onNewRow) {
                    this.onNewRow();
                }
            }
        };

        widget.newRow();
        ScreenService.openSwipe(widget);
    };

    this.insereProdutoData = function (widget) {
        widget.edit();
        widget.formTemplate = widget.templateToForm;
        ScreenService.openSwipe(widget);
    };

    this.salvaNecessidadeCompra = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.dataSource.data, widget.currentRow, widget.name) && self.validaDataPeriodo(widget.currentRow.DTENTRNECCMP)) {
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow();
            ScreenService.closeSwipe();
            widget.list();
            widget.activate();
        }
    };

    this.salvaProdutoNecessidade = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos').dataSource.data, widget.currentRow, widget.name)) {
            rowCalcNecessidadeData = widget.container.getWidget('tab_cmp03001_calculo_necessidade_por_data').currentRow;
            widget.currentRow.DTENTRNECCMP = rowCalcNecessidadeData.DTENTRNECCMP;
            widget.currentRow.NRNECECOMP = rowCalcNecessidadeData.NRNECECOMP;
            widget.currentRow.CDFILNECECMP = rowCalcNecessidadeData.CDFILNECECMP;
            widget.currentRow.IDMARCNECCMP = rowCalcNecessidadeData.IDMARCNECCMP;
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                widget.currentRow.__is_new = false;
                widget.currentRow.changed = false;
                widget.list(true);
                widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos').activate();
                self.carregarNecessidade(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_produtos'), 'CDARVPROD');
            });
        }
    };

    this.salvaDataNecessidade = function (widget) {
        if (widget.isValid() && self.validaNovoItem(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data').dataSource.data, widget.currentRow, widget.name) && self.validaDataPeriodo(widget.currentRow.DTENTRNECCMP)) {
            rowCalcNecessidadeProd = widget.container.getWidget('tab_cmp03001_calculo_necessidade_por_produto').currentRow;
            widget.currentRow.CDPRODNECCMP = rowCalcNecessidadeProd.CDPRODNECCMP;
            widget.currentRow.NRNECECOMP = rowCalcNecessidadeProd.NRNECECOMP;
            widget.currentRow.CDFILNECECMP = rowCalcNecessidadeProd.CDFILNECECMP;
            widget.currentRow.IDMARCNECCMP = rowCalcNecessidadeProd.IDMARCNECCMP;
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                widget.currentRow.__is_new = false;
                widget.currentRow.changed = false;
                widget.list(true);
                widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data').activate();
                self.carregarNecessidade(widget.container.getWidget('tab_cmp03001_calculo_necessidade_lista_data'), 'DTENTRNECCMP');
            });
        }
    };

    this.salvaEdicaoNecessidade = function (widget){
        if (widget.isValid() && self.validaNovoItem(widget.dataSource.data, widget.currentRow, widget.name)) {
            widget.currentRow.QTPRCNVCOMPR = parseFloat(widget.currentRow.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.'));
            widget.currentRow.QTPRACOMPRAR = widget.currentRow.QTPRCNVCOMPR;
            widget.saveRow().then(function () {
                self.cancelaEdicaoNecessidade(widget);
            });
        }
    };

    this.cancelaEdicaoNecessidade = function (widget){
        widget.currentRow.__is_new = false;
        widget.currentRow.changed = false;
        widget.list();
        widget.formTemplate = widget.template;
        widget.activate();
        if(widget.name == 'tab_cmp03001_calculo_necessidade_lista_data'){
            self.carregarNecessidade(widget, 'DTENTRNECCMP');
        } else {
            self.carregarNecessidade(widget, 'CDARVPROD');
        }
    };

    this.excluiNecessidadeCompra = function (widget) {
        nomeWidget = widget.name;
        rowsNecessidade = widget.getCheckedRows();
        NecessidadeCompraService.excluiNecessidadeCompra(rowsNecessidade, nomeWidget).then(function (callback) {
            if (nomeWidget == 'tab_cmp03001_calculo_necessidade_por_data') {
                self.carregarNecessidade(widget, 'DTENTRNECCMP');
            } else {
                self.carregarNecessidade(widget, 'CDARVPROD');
            }
            MessageService.showMessageByCode("REG_SUCCESS_DELETE");
        });
    };

    this.editaNecessidadeCompra = function(widget){
        widget.edit();
        widget.getField('NMPRODUTO').readOnly = true;
        widget.getField('SGUNIDADE').readOnly = true;
        widget.getField('DTPRIUTIPROD').readOnly = true;
        widget.getField('DTENTRNECCMP').readOnly = true;
    };

    this.geraSolicitacao = function(widget){
        params.GERASOLICITA = 'S';
        if(widget.isValid()) {
            self.relatorioPreviaNecessidadeCompra(widget, params.GERASOLICITA).then(function () {
                proceGeraSolicitacao(params.GERASOLICITA).then(function(){
                    self.excluiTrabnececomp();
                    ScreenService.goBack();
                    MessageService.successNotificationByCode("SOL_CMP_SUCCESS_INSERT");
                });
            });
        }
    };

    this.fechaSwipe = function (widget) {
        if (widget.lastActiveWidget) {
            if (widget.name != widget.lastActiveWidget.name) {
                ScreenService.closeSwipe();
                widget.activate();
            }
        }
    };

    this.setDataUtilizacao = function (widget){
        var data = widget.getField('DTENTRNECCMP').value();
        widget.getField('DTPRIUTIPROD').setValue(data);
    };

    this.controlaDataUtilizacao = function (widget) {
        if (dataUtilizacao == 'S') {
            widget.getField('DTPRIUTIPROD').isVisible = true;
        } else {
            widget.getField('DTPRIUTIPROD').isVisible = false;
        }
    };

    this.validaNovoItem = function(dataSet, item, widgetName){
        var dataSetExistente, existe, mensagem;
        switch (widgetName) {
            case 'tab_cmp03001_calculo_necessidade_por_data':
            case 'tab_cmp03001_insere_datas':
                dataSetExistente = dataSet.map(function (datas) {
                    return datas.DTENTRNECCMP;
                });
                existe = dataSetExistente.indexOf(item.DTENTRNECCMP);
                mensagem = 'Data já cadastrada.';
                break;
            case 'tab_cmp03001_calculo_necessidade_por_produto':
            case 'tab_cmp03001_insere_produtos':
                dataSetExistente = dataSet.map(function (datas) {
                    return datas.CDPRODNECCMP;
                });
                existe = dataSetExistente.indexOf(item.CDPRODNECCMP);
                mensagem = 'Produto já cadastrado.';
                break;
            default:
                existe = '-1';
                break;
        }

        if(existe == '-1'){
            var quantidade = item.QTPRCNVCOMPR.replace(/\./g, '').replace(',', '.');
            if(quantidade > 0){
                return true;
            } else {
                MessageService.showMessageByCode("QTD_MAIOR_ZERO");
                return false;
            }
        } else{
            ScreenService.showMessage(ScreenService.i18n(mensagem));
            return false;
        }
    };

    this.validaDataPeriodo = function(dtNecessidade){
        var dtInicial = params.DTINICIAL;
        var dtFinal = params.DTFINAL;

        var representacoes = {
            "dtInicial": dtInicial,
            "dtFinal": dtFinal
        };

        if(moment(dtNecessidade, 'DD/MM/YYYY') >= moment(dtInicial, 'DD/MM/YYYY') && moment(dtNecessidade, 'DD/MM/YYYY') <= moment(dtFinal, 'DD/MM/YYYY')) {
            return true;
        } else {
            MessageService.showMessageByCode("DTA_ENTRE_DTINICIAL_DTFINAL", { "DTINICIAL": dtInicial, "DTFINAL": dtFinal });
            return false;
        }
    };

    this.controlaUnidade = function(widget) {
        var fieldFilial = widget.getField('CDFILIAL');
        fieldFilial.setValue('');
        widget.currentRow.CDFILIAL = '';

        if(widget.currentRow.NMGRUPFILI) {
            fieldFilial.validations = {};
        } else {
            fieldFilial.validations = { required: true };
        }
    };


    //PREVIA DO CALCULO DA NECESSIDADE DE COMPRA

    this.parametrosPreviaCalcNeceComp = function(widget) {
        Parametros.parasupri(getLocalVar('CDFILIAL')).then(function(callback){
            cdGrupoProd = callback.dataset.parasupri.length ? callback.dataset.parasupri[0].CDGRUPPROD : 'N';
            widget.getField('NMSUBGRPROD').reload();
        });
    };

    this.valorDefaultPreviaCalcNeceComp = function(widget){
        Parametros.retornaDataProcessamento().then(function(callback){
            dataProcessamento = callback;
            widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
            widget.getField('NMFILIAL').setValue(getLocalVar('NMFILIAL'));
            widget.getField('DTENTREGAINI').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('DTENTREGAFIN').setValue(moment(dataProcessamento,'L').format('DD/MM/YYYY'));
            widget.getField('NMSUBGRPROD').setValue('');
            widget.getField('NMPRODINICIAL').setValue('');
            widget.getField('NMPRODFINAL').setValue('');
            widget.getField('PEACRESCIMO').setValue('0');
            widget.getField('MANTERPRODQTZERO').setValue('S');
            self.valorDefaultRelatorios(widget);
        });
    };

    this.geraRelatorioPreviaCalcNeceComp = function (widget, args) {

        var reportName = widget.currentRow.CD_REPORT_NAME;

        if(widget.isValid() && self.validaData(widget.currentRow.DTENTREGAINI, widget.currentRow.DTENTREGAFIN) && self.verificaDtProcessamento(widget.currentRow.DTENTREGAINI) && self.validaProduto(widget.currentRow.CDPRODINICIAL, widget.currentRow.CDPRODFINAL)) {

            General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, args, reportName]);
        }
    };

    this.abreRelatorio = function(widget, currentRow, args, reportName) {

        var paramProcedure = {
            "CDFILIAL": widget.currentRow.CDFILIAL,
            "TCDFILIAL": '',
            "CDGRUPFILI": '',
            "DTINICIAL": widget.currentRow.DTENTREGAINI,
            "DTFINAL": widget.currentRow.DTENTREGAFIN,
            "CDPRODINI": widget.currentRow.CDPRODINICIAL,
            "CDPRODFIN": widget.currentRow.CDPRODFINAL,
            "PEACRESCIMO": widget.currentRow.PEACRESCIMO,
            "CDOPERADOR": getLocalVar('CDOPERADOR'),
            "DTHRCALCNC": moment().format('DD/MM/YYYY hh:mm:ss'),
            "IDQTDEZERO": 'S',
            "EXTRA": '',
            "NRORG": getLocalVar('NRORG'),
            "CDGRUPPROD": cdGrupoProd,
            "CDSUBGRUPO": self.montaListaSubgrupo(widget.currentRow.NMSUBGRPROD)
        };

        NecessidadeCompraService.proceNecessidadeDeCompras(paramProcedure).then(function (callback) {
        
            params = {
                "DATAINI": widget.currentRow.DTENTREGAINI,
                "DATAFIN": widget.currentRow.DTENTREGAFIN,
                "FILIPROC": getLocalVar('CDFILIAL'),
                "NRNECECOMP": callback.dataset.nrnececomp[0],
                "CDFILIAL": widget.currentRow.CDFILIAL,
                "NRORG": getLocalVar('NRORG'),
                "QR2TYPE": widget.currentRow.QR2TYPE
            };

            General.openReport('/cmp03800', reportName, params).then(function () {
                self.excluiTrabnececomp();
            });
        });

    }.bind(this);


    //GERAIS

    this.excluiTrabnececomp = function(){
        NecessidadeCompraService.excluiTrabnececomp(params.NRNECECOMP, params.NRORG);
    };

    this.montaLista = function(fieldSelect, fieldTodos, unidadeAgrup){
        if (fieldSelect) {
            if(Array.isArray(fieldSelect)){
                return fieldSelect.join('_');
            } else{
                return fieldSelect;
            }
        } else {
            if(unidadeAgrup){
                var agrupamento = unidadeAgrup.split('_');
                var unidades = todasUnidades.split('_');
                return agrupamento.map(function(unidade){
                    if(unidades.indexOf(unidade) != -1){
                        return unidade;
                    }
                }).join('_');
            } else{
                return todasUnidades;
            }
        }
    };

    this.montaListaOperador = function(fieldSelect, fieldTodos){
        if (fieldTodos == 'T') {
            return fieldTodos;
        } else {
            return fieldSelect.join('_');
        }
    };

    this.montaListaSubgrupo = function(fieldSelect){
        if(Array.isArray(fieldSelect)){
            return fieldSelect.join('_');
        } else{
            return fieldSelect;
        }
    };

    this.filtraUnidadeAgrupamento = function(fieldUnidades, stringUnidades){
        if(stringUnidades) {
            var unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "CDFILIAL",
                    "value": "",
                    "operator": "IN"
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
        } else{
            fieldUnidades.dataSourceFilter = [
                {
                    "name": "NRORG",
                    "value": "",
                    "operator": "="
                }
            ];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.validaData = function(dtInicial, dtFinal) {
        var dataInicial = dtInicial ? moment(dtInicial, 'DD/MM/YYYY')._d : null;
        var dataFinal = dtFinal ? moment(dtFinal, 'DD/MM/YYYY')._d : null;

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        
        if(!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        } 

        return true;
    };

    this.getCdGrupoProd = function () {
        return cdGrupoProd;
    };

    this.getNrnececomp = function () {
        return params.NRNECECOMP;
    };

    this.getDtinicial = function () {
        return params.DTINICIAL;
    };

    this.getDtfinal = function () {
        return params.DTFINAL;
    };

    this.setDtentrneccmp = function(field) {
        dtentrneccmp = field;
    };

    this.getDtentrneccmp = function(widget) {
        widget.getField('DTPRIUTIPROD').setValue(dtentrneccmp);
    };

    this.getCdfilial = function() {
        return params.CDFILIAL;
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('CalcNecessidadeCompraController', CalcNecessidadeCompraController);
});

// FILE: ./assets/modules/V1/assets/js/controllers/Cmp05000Controller.js
function Cmp05000Controller(ScreenService, General, localStorageEngine, MessageService) {

    var todasUnidades = [];

    this.setInitialValues = function (widget) {
        
        var widgetCurrentRow;
        var reportField         = widget.getField('REPORT_NAME');
        var tipoCustoField      = widget.getField('NMTIPOCUSTO');

        if (!widget.currentRow.NRORG) {
            widget.newRow();
        }

        widgetCurrentRow = widget.currentRow;

        tipoCustoField.reload().then(function(){
            widgetCurrentRow.CDTIPOCUSTO    = tipoCustoField.dataSource.getFirstRow().CDTIPOCUSTO;
            widgetCurrentRow.NMTIPOCUSTO    = tipoCustoField.dataSource.getFirstRow().NMTIPOCUSTO;
        });

        widgetCurrentRow.CD_REPORT_NAME = reportField.dataSource.getFirstRow().value;
        widgetCurrentRow.REPORT_NAME    = reportField.dataSource.getFirstRow().name;

        this.montaListaTodasUnidades();
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };
    this.montaListaTodasUnidades = function(){
        localStorageEngine.getDataSource('/unidades').then(function(unidades){
            unidades.forEach(function(unidade){
                todasUnidades.push(unidade.CDFILIAL);
            });
        });
    };
    this.filtraUnidadeSolicitante = function(fieldUnidades, stringUnidades, cdRegiao){
        
        var unidades = '';
        
        if(stringUnidades && cdRegiao.length) {
            unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {"name": "CDFILIAL", "value": "", "operator": "IN"},
                {"name": "CDREGIAO", "value": "", "operator": "IN"}
            ];

            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades, 'CDREGIAO': cdRegiao});
        
        } else {
            if(stringUnidades){
                unidades = stringUnidades.split('_');
                
                fieldUnidades.dataSourceFilter = [{"name": "CDFILIAL","value": "","operator": "IN"}];
                this.defineSelectWidget(fieldUnidades);
                General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
            
            } else{
                if(cdRegiao.length){
                    fieldUnidades.dataSourceFilter = [{"name": "CDREGIAO","value": "","operator": "IN"}];
                    this.defineSelectWidget(fieldUnidades);
                    General.onClickDependentField(fieldUnidades, {'CDREGIAO': cdRegiao});
                } else{
                    fieldUnidades.dataSourceFilter = [{"name": "NRORG","value": "","operator": "="}];
                    this.defineSelectWidget(fieldUnidades);
                    General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
                }
            }
        }
    };

    this.filtraUnidadeLancamento = function(fieldUnidades, cdRegiao){
        
        if(cdRegiao.length) {
            fieldUnidades.dataSourceFilter = [{"name": "CDREGIAO","value": "","operator": "IN"}];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDREGIAO': cdRegiao});
        } else {
            fieldUnidades.dataSourceFilter = [{"name": "NRORG", "value": "", "operator": "="}];
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.filtraSolicita = function (widget) {
        
        var solicitaDataSourceFilter    = [];
        var cdFilialSoliField           = widget.getField('CDFILSOLI').value();
        var todasFiliaisSoli            = widget.getField('CDFILSOLI_checkbox').checked;
        var cdFilialLanField            = widget.getField('CDFILLAN').value();
        var todasFiliaisLanc            = widget.getField('CDFILLAN_checkbox').checked;
        var nrSoliField                 = widget.getField('NRSOLI');
        var cdfillanca                  = '';
        var cdfilsoli                   = '';

        if(cdFilialSoliField) {
            cdfilsoli = cdFilialSoliField;
        }
        else {
            if(todasFiliaisSoli){
                cdfilsoli = todasUnidades;
            }
        }

        solicitaDataSourceFilter.push({"name": "CDFILSOLI", "operator": "IN", "value": ""});

        if(cdFilialLanField) {
            cdfillanca = cdFilialLanField;
        }
        else {
            if(todasFiliaisLanc) {
                cdfillanca = todasUnidades;
            }
        }

        solicitaDataSourceFilter.push({"name": "CDFILLANCA", "operator": "IN", "value": ""});

        nrSoliField.dataSourceFilter = solicitaDataSourceFilter;
        this.defineSelectWidget(nrSoliField);
        General.onClickDependentField(nrSoliField, {'CDFILSOLI': cdfilsoli, 'CDFILLANCA': cdfillanca});
    };

    this.criaRelatorio = function (widget, currentRow) {
        var reportName = widget.currentRow.CD_REPORT_NAME;

        if (widget.isValid() && this.validaData(currentRow) && this.validaProduto(currentRow.CDPRODINI, currentRow.CDPRODFIN)) {

            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, reportName]);    
        }
    };
            
    this.abreRelatorio = function(widget, currentRow, reportName) {

        if (widget.getField('CDREGIAO_checkbox').checked) {
            currentRow.CDREGIAO = "T";
        } else {
            currentRow.CDREGIAO = currentRow.CDREGIAO.join("_");
        }
        if (widget.getField('CDFILSOLI_checkbox').checked) {
            currentRow.CDFILSOLI = todasUnidades.join('_');
        } else {
            currentRow.CDFILSOLI = currentRow.CDFILSOLI.join("_");
        }
        if (widget.getField('CDFILLAN_checkbox').checked) {
            currentRow.CDFILLAN = todasUnidades.join('_');
        } else {
            currentRow.CDFILLAN = currentRow.CDFILLAN.join("_");
        }
        if (widget.getField('NRSOLI_checkbox').checked) {
            currentRow.NRSOLI = "T";
        } else {
            currentRow.NRSOLI = currentRow.NRSOLI.join("_");
        }
        if (!currentRow.CDGRUPFILI) {
            currentRow.CDGRUPFILI = "T";
        }
        var pad ='ZZZZZZZZZZ';
        var str = currentRow.CDPRODFIN;
        currentRow.CDPRODFIN    = widget.getField('CDPRODFIN').value() ? str + pad.substr(0,pad.length-str.length) : widget.getField('CDPRODFIN').value();
        currentRow.TDTINI       = currentRow.DTINI;
        currentRow.TDTFIM       = currentRow.DTFIM;

        General.openReport("/cmp05000_relatorio", reportName, currentRow).then(function() {
            
            if (!widget.getField('CDREGIAO_checkbox').checked) {
                currentRow.CDREGIAO = currentRow.CDREGIAO.split("_");
            } else {
                currentRow.CDREGIAO = '';
            } if (!widget.getField('CDFILSOLI_checkbox').checked) {
                currentRow.CDFILSOLI = currentRow.CDFILSOLI.split("_");
            } else {
                currentRow.CDFILSOLI = '';
            } if (!widget.getField('CDFILLAN_checkbox').checked) {
                currentRow.CDFILLAN = currentRow.CDFILLAN.split("_");
            } else {
                currentRow.CDFILLAN = '';
            } if (!widget.getField('NRSOLI_checkbox').checked) {
                currentRow.NRSOLI = currentRow.NRSOLI.split("_");
            } else {
                currentRow.NRSOLI = '';
            }
        });
    };

    this.atualizaAgrupamento = function(args){
        
        args.row.CDFILSOLI  = '';
        args.row.NRSOLI     = '';
    };

    this.atualizaRegiao = function(args){
        
        args.row.CDFILSOLI  = '';
        args.row.CDFILLAN   = '';
        args.row.NRSOLI     = '';
    };

    this.atualizaUnidade = function(args){
        
        args.row.NRSOLI = '';
    };

    this.validaData = function(currentRow, field) {

        var dataInicial = currentRow.DTINI ? moment(currentRow.DTINI, 'DD/MM/YYYY')._d : null;
        var dataFinal   = currentRow.DTFIM ? moment(currentRow.DTFIM, 'DD/MM/YYYY')._d : null;
 
        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.validaProduto = function(prodInicial, prodFinal){
        if(prodInicial || prodFinal){
            if(!prodInicial){
                MessageService.showMessageByCode("PRODINICIAL_NULO");
                return false;
            }
            if(!prodFinal){
                MessageService.showMessageByCode("PRODFINAL_NULO");
                return false;
            }
            if(!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    };
}


Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp05000Controller', Cmp05000Controller);
});

// FILE: ./assets/modules/V1/assets/js/controllers/ParametrosComprasSuprimentosController.js
var ParametrosComprasSuprimentosController = function (ScreenService, General, MessageService) {
    this.defineCurrentRow = function(widget){
        widget.currentRow = widget.dataSource.data[0];
        widget.currentRow.DTULTATU = widget.currentRow.DTULTATU.substring(0, 10);
        widget.currentRow.DTINCLUSAO = widget.currentRow.DTINCLUSAO.substring(0, 10);
    };

    this.salvaParametros = function(widget){
        if(widget.isValid() && validaValorAcrescimo(widget.currentRow.VRACRESCIMOAF)){
            widget.currentRow.VRACRESCIMOAF = General.valueToFloat(widget.currentRow.VRACRESCIMOAF);
            widget.saveRow().then(function(){
                widget.reload();
            });
        }
    };

    function validaValorAcrescimo (valor){
        valor = parseFloat(valor.replace(/\./g, '').replace(',', '.'));
        if(valor <= 0) {
            MessageService.showMessageByCode("VLR_ACRESCIMO_AF");
            return false;
        } else{
            return true;
        }
    }
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ParametrosComprasSuprimentosController', ParametrosComprasSuprimentosController);
});

// FILE: ./assets/modules/V1/assets/js/controllers/SolicitacaoComprasController.js
function SolicitacaoComprasController(ScreenService, SolicitacaoComprasService, templateManager, Parametros, General, MessageService) {

    var self = this;

    var stripeWidget;
    var stripeWidgetFilter              = [];
    var onEnterOnce                     = true;
    var habilitaAddProdSoli             = true;
    var bloqueiaEditEmSoliAuto          = null;
    var bloqueiaFiltroPorProdutoCompra  = null;
    var isJutificativaExtraObrigatoria  = null;
    var isJustificativaObrigatoria      = null;
    var habilitaComprador               = null;
    var habilitaDestino                 = null;
    var gravaDataUtiliza                = null;
    var habilitaStatus                  = null;
    var verificarPeriodicidade          = null;
    var pesquisaPorModuloProd           = null;
    var isContratoRescindido            = null;
    var hasRegiao                       = null;
    var utilizaAprovSoli                = null;

    self.setRegras = function (widget) {

        stripeWidget = widget;
        var cdFilial = getLocalVar('CDFILIAL');
        var nrorg = getLocalVar('NRORG');
        
        SolicitacaoComprasService.getRegras().then(function (callback) {
            var regras = callback.dataset.solicitacao_compras_regras[0];
            if (regras.IDBLOQALTNEC == 'N') {
                bloqueiaEditEmSoliAuto = false;
            } else {
                bloqueiaEditEmSoliAuto = true;
            } if (regras.IDUTPRODPREF == 'S') {
                bloqueiaFiltroPorProdutoCompra = false;
            } else {
                bloqueiaFiltroPorProdutoCompra = true;
            } if (regras.IDJUSSOLEXT == 'S') {
                isJutificativaExtraObrigatoria = true;
            } else {
                isJutificativaExtraObrigatoria = false;
            } if (regras.IDAUDALTSOL == 'S') {
                isJustificativaObrigatoria = true;
            } else {
                isJustificativaObrigatoria = false;
            } if (regras.IDULTCOMPSOL == 'S') {
                habilitaComprador = true;
            } else {
                habilitaComprador = false;
            } if (regras.IDULTDESTSOL == 'S') {
                habilitaDestino = true;
            } else {
                habilitaDestino = false;
            } if (regras.IDULTIDTULTI == 'S') {
                gravaDataUtiliza = true;
            } else {
                gravaDataUtiliza = false;
            } if (regras.IDBAIXSOLDFS == 'S') {
                habilitaStatus = true;
            } else {
                habilitaStatus = false;
            } if (regras.IDPERISOLMANUAL == 'S') {
                verificarPeriodicidade = true;
            } else {
                verificarPeriodicidade = false;
            } if (regras.IDUTMODPRODFIL == 'S') {
                pesquisaPorModuloProd = true;
            } else {
                pesquisaPorModuloProd = false;
            } if(regras.IDUTAPROVSOL == 'S'){
                utilizaAprovSoli = true;
            } else{
                utilizaAprovSoli = false;
            }

            self.controlaFieldSolicitacao(widget, utilizaAprovSoli);
            self.setVisibleFilterFields(widget.container.getWidget('cmp03100_solicitacao_FILTER'));

            SolicitacaoComprasService.getFilialData(cdFilial, nrorg).then(function (callback) {
                if (callback.dataset.filial) {
                    var filialData = callback.dataset.filial[0];
                    if (filialData.IDCNTRRESC == 'S') {
                        isContratoRescindido = true;
                    } else {
                        isContratoRescindido = false;
                    } if (filialData.CDREGIAO !== null) {
                        hasRegiao = true;
                    } else {
                        hasRegiao = false;
                    }
                }
            });
        });
    };
    self.reloadSolicitacaoOnEnter = function (widget) {
        if (onEnterOnce) {
            onEnterOnce = false;
        } else {
            widget.reload();
        }
    };

    //EXCLUIR MÉTODO APÓS ATUALIZAÇÃO DO BOWER.
    self.controlaFieldSolicitacao = function (widget, param){
        var widgetSolicita = widget.container.getWidget('cmp03100_solicitacao');

        if(param){
            widgetSolicita.getField('IDSOLIAPROV').isVisible = true;
        } else {
            widgetSolicita.getField('IDSOLIAPROV').isVisible = false;
        }
    };

    self.controlaSoliAprov = function(field){
        if(utilizaAprovSoli){
            if(field == 'S'){
                return true;
            } else{
                return false;
            }
        } else{
            return false;
        }
    };

    self.controlaSoliReprov = function(field){
        if(utilizaAprovSoli){
            if(field != 'S'){
                return true;
            } else{
                return false;
            }
        } else{
            return false;
        }
    };

    self.openFilter = function(widget) {
        var stripeWidget = widget.container.getWidget(widget.name + '_FILTER');
        if (!stripeWidget.currentRow.START) {
            stripeWidget.newRow();
        }
        ScreenService.openPopup(widget);
    };

    self.filter = function (filterWidget) {
        if(filterWidget.isValid()) {
            stripeWidget = filterWidget.getParent().container.getWidget('cmp03100_stripe');
            var parentWidget = filterWidget.getParent();
            var filterCurrentRow = filterWidget.currentRow;
            var compradorField = filterWidget.getField('COMPRADOR');
            var destinoField = filterWidget.getField('DESTINO');
            var operadorField = filterWidget.getField('OPERADOR');
            var dataInicial = filterCurrentRow.START ? moment(filterCurrentRow.START, 'DD/MM/YYYY')._d : null;
            var dataFinal = filterCurrentRow.END ? moment(filterCurrentRow.END, 'DD/MM/YYYY')._d : null;

            if (dataInicial && dataFinal && dataFinal < dataInicial) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                return false;
            }

            stripeDataSourceFilter = [];

            stripeWidget.getField('DTPROGENTR').setValue("");

            stripeDataSourceFilter.push(
                {
                    "name": "DTPROGENTR",
                    "value": [filterWidget.currentRow.START, filterWidget.currentRow.END],
                    "operator": "BETWEEN"
                }
            );

            if (compradorField.value() !== "" && compradorField.isVisible) {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDCOMPRADOR",
                        "value": filterCurrentRow.CDCOMPRADOR,
                        "operator": "="
                    }
                );
            }

            if (destinoField.value() !== "" && destinoField.isVisible) {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDDESTSOLI",
                        "value": filterCurrentRow.CDDESTSOLI,
                        "operator": "="
                    }
                );
            }

            if (operadorField.value() !== "") {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDOPERLANC",
                        "value": filterCurrentRow.OPERADOR,
                        "operator": "IN"
                    }
                );
            }

            stripeWidgetFilter = angular.copy(stripeDataSourceFilter);
            stripeWidget.dataSourceFilter = stripeDataSourceFilter;
            stripeWidget.reload().then(function () {
                var dados = stripeWidget.dataSource.data;

                if (dados.length > 0) {
                    var todasDatas = [];
                    var dadosFiltrados = [];

                    for (i = 0; i < dados.length; i++) {
                        todasDatas.push(dados[i].DTPROGENTR.substring(0, 10));
                    }
                    var distinctDatas = todasDatas.filter(self.getUnique);

                    for (i = 0; i < distinctDatas.length; i++) {
                        dadosFiltrados.push({"DTPROGENTR": distinctDatas[i]});
                    }

                    stripeWidget.dataSource.data = dadosFiltrados;
                    stripeWidget.moveToFirst();
                    self.setStripeValues(stripeWidget);
                }
                else {
                    self.setStripeValues(stripeWidget);
                    self.stripeNavigation(stripeWidget, parentWidget);
                }
            });
            ScreenService.closePopup();
            parentWidget.activate();
        }
    };
    self.filterProds = function (filterWidget) {
        if (filterWidget.isValid()) {
            var filterCurrentRow        = filterWidget.currentRow;
            var parentDataSourceName    = filterWidget.getParent().dataSource.name;
            var parentDataSourceFilter  = [];

            if(pesquisaPorModuloProd){
                parentDataSourceName = "/produtos_modulados";
            }
            else {
                parentDataSourceName = "/produtos_ordenados";
            }

            if (filterWidget.getField('PRODINI').value() !== "" && filterWidget.getField('PRODFIN').value() !== "") {
                for (i = filterCurrentRow.CDARVPRODFIN.length; i <= 20; i++) {
                    filterCurrentRow.CDARVPRODFIN += "Z";
                }
                parentDataSourceFilter.push(
                    {
                        "name": "CDARVPROD",
                        "value": [filterCurrentRow.CDARVPRODINI, filterCurrentRow.CDARVPRODFIN],
                        "operator": "BETWEEN"
                    }
                );
            } else {
                if (filterWidget.getField('PRODINI').value() !== "") {
                    parentDataSourceFilter.push(
                        {
                            "name": "CDARVPROD",
                            "value": filterCurrentRow.CDARVPRODINI,
                            "operator": ">="
                        }
                    );
                }
                if (filterWidget.getField('PRODFIN').value() !== "") {
                    for (i = filterCurrentRow.CDARVPRODFIN.length; i <= 20; i++) {
                        filterCurrentRow.CDARVPRODFIN += "Z";
                    }
                    parentDataSourceFilter.push(
                        {
                            "name": "CDARVPROD",
                            "value": filterCurrentRow.CDARVPRODFIN,
                            "operator": "<="
                        }
                    );
                }
            }

            if (filterCurrentRow.NRSOLICITA !== "" && filterCurrentRow.NRSOLICITA && habilitaAddProdSoli) {
                parentDataSourceName += "_por_solicitacao";
                parentDataSourceFilter.push(
                    {"name": "NRSOLI",      "operator": "=",    "value": filterCurrentRow.NRSOLICITA},
                    {"name": "CDFILSOLI",   "operator": "=",    "value": filterCurrentRow.CDFILSOLI},
                    {"name": "CDFILLAN",    "operator": "=",    "value": filterCurrentRow.CDFILLAN}
                );
                filterWidget.getParent().getField('DTPROGENTR').isVisible = true;
            } else {
                filterWidget.getParent().getField('DTPROGENTR').isVisible = false;
            }

            parentDataSourceFilter.push(
                {"name": "PRODCMP", "operator": "=", "value": filterCurrentRow.IDPRODCOMPRA}
            );
            
            filterWidget.getParent().dataSource.name = parentDataSourceName;
            filterWidget.getParent().dataSourceFilter = parentDataSourceFilter;
            filterWidget.getParent().reload();
            
            ScreenService.closePopup();
            filterWidget.getParent().activate();

        } else {
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
        }
    };
    self.setVisibleFilterFields = function (filterWidget) {
        
        if (habilitaComprador) {
            filterWidget.getField('COMPRADOR').isVisible = true;
        } else {
            filterWidget.getField('COMPRADOR').isVisible = false;
        }

        if (habilitaDestino) {
            filterWidget.getField('DESTINO').isVisible = true;
        } else {
            filterWidget.getField('DESTINO').isVisible = false;
        }

        filterWidget.getField('TOPERADOR').checked = true;
        General.toggleReadOnlySelect(filterWidget.getField('TOPERADOR'),filterWidget.getField('OPERADOR'));

    };
    self.setVisibleFilterProdsFields = function (filterWidget) {
        filterWidget.applyDefaultValue();
        if (habilitaAddProdSoli) {
            filterWidget.getField('NMFILIAL').isVisible = true;
            filterWidget.getField('NRSOLICITA').isVisible = true;
        } else {
            filterWidget.getField('NMFILIAL').isVisible = false;
            filterWidget.getField('NRSOLICITA').isVisible = false;
        }
    };
    self.gerenciaSolicitaSearch = function (filialField) {
        
        var filterWidget  = filialField.widget;
        var solicitaField = filterWidget.getField('NRSOLICITA');
        
        solicitaField.setValue("");
        
        if (filialField && filialField.value() !== "") {
            solicitaField.dataSourceFilter[0].value = filterWidget.currentRow.CDFILIAL;
            solicitaField.validations = {"required": {}};
            solicitaField.readOnly = false;
            solicitaField.reload();
        } else {
            solicitaField.validations = undefined;
            solicitaField.readOnly = true;
        }
    };

    self.setStripeValues = function (stripeWidget) {
        
        if (!stripeWidget.currentRow.DTPROGENTR) {
            stripeWidget.applyDefaultValue();
        }
        stripeWidget.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
        
        if (stripeWidget.getField('DTPROGENTR').value() === "") {
            var filterWidget = stripeWidget.container.getWidget('cmp03100_solicitacao_FILTER');
            if (!filterWidget.currentRow.START) {
                filterWidget.applyDefaultValue();
            }
            stripeWidget.getField('DTPROGENTR').setValue(filterWidget.currentRow.START);
        } else {
            stripeWidget.getField('DTPROGENTR').setValue(stripeWidget.getField('DTPROGENTR').value().substring(0, 10));
        }
    };

    self.stripeNavigation = function (stripeWidget, widgetToFilter) {
        
        var parentDataSourceFilter = stripeWidget.dataSourceFilter;
        
        parentDataSourceFilter[0].operator  = "=";
        parentDataSourceFilter[0].value     = stripeWidget.currentRow.DTPROGENTR;

        self.setStripeValues(widgetToFilter);
        stripeWidget.dataSourceFilter[0].value = widgetToFilter.currentRow.DTPROGENTR;
        stripeWidget.reload();
    };

    self.openSwipes = function (swipeWidget, parentWidget, stripeWidget) {
        
        var swipeCurrentRow  = swipeWidget.currentRow;
        var stripeCurrentRow = stripeWidget.currentRow;
        var parentCurrentRow = parentWidget.currentRow;

        if (parentCurrentRow.CDFILSOLI === undefined) {
            swipeCurrentRow.CDFILSOLI = stripeCurrentRow.CDFILIAL;
        } else {
            swipeCurrentRow.CDFILSOLI = parentCurrentRow.CDFILSOLI;
        } if (parentCurrentRow.CDFILLAN === undefined) {
            swipeCurrentRow.CDFILLAN = stripeCurrentRow.CDFILIAL;
        } else {
            swipeCurrentRow.CDFILLAN = parentCurrentRow.CDFILLAN;
        } if (parentCurrentRow.CDPRODUTO === undefined) {
            swipeCurrentRow.CDPRODUTO = "";
        } else {
            swipeCurrentRow.CDPRODUTO = parentCurrentRow.CDPRODUTO;
        } if (parentCurrentRow.CDARVPROD === undefined) {
            swipeCurrentRow.CDARVPROD = "";
        } else {
            swipeCurrentRow.CDARVPROD = parentCurrentRow.CDARVPROD;
        } if (parentCurrentRow.NMPRODUTO === undefined) {
            swipeCurrentRow.NMPRODUTO = "";
        } else {
            swipeCurrentRow.NMPRODUTO = parentCurrentRow.NMPRODUTO;
        } if (parentCurrentRow.SGUNIDADE === undefined) {
            swipeCurrentRow.SGUNIDADE = "";
        } else {
            swipeCurrentRow.SGUNIDADE = parentCurrentRow.SGUNIDADE;
        } if (!parentCurrentRow.DTPROGENTR) {
            swipeCurrentRow.DTPROGENTR = "";
            swipeCurrentRow.DTPROGENTR_old = "";
            swipeCurrentRow.DTPROGENTR_compare = "";
        } else {
            swipeCurrentRow.DTPROGENTR_old = parentCurrentRow.DTPROGENTR.substring(0, 10);
            swipeCurrentRow.DTPROGENTR_compare = parentCurrentRow.DTPROGENTR.substring(0, 10);
        }
        swipeWidget.getField('QTSOLIPROD_compare').label =
            swipeWidget.getField('QTSOLIPROD_compare').label.substring(0, 36) + swipeCurrentRow.DTPROGENTR_compare; if (parentCurrentRow.QTSOLIPROD === undefined) {
            swipeCurrentRow.QTSOLIPROD = 0;
            swipeCurrentRow.QTSOLIPROD_compare = 0;
            swipeCurrentRow.QTSOLIPROD_old = 0;
        } else {
            swipeCurrentRow.QTSOLIPROD_old = parentCurrentRow.QTSOLIPROD;
            swipeCurrentRow.QTSOLIPROD_compare = parentCurrentRow.QTSOLIPROD;
            self.comparaItemSoli(swipeWidget);
        } if (parentCurrentRow.IDTIPLAN === undefined) {
            swipeCurrentRow.IDTIPLAN = "NORMAL";
        } else {
            swipeCurrentRow.IDTIPLAN = parentCurrentRow.IDTIPLAN;
        } if (parentCurrentRow.NRSOLICMP === undefined) {
            swipeCurrentRow.NRSOLICMP = "";
        } else {
            swipeCurrentRow.NRSOLICMP = parentCurrentRow.NRSOLICMP;
        } if (parentCurrentRow.DSJUSTOPER === undefined) {
            swipeCurrentRow.DSJUSTOPER = "";
            self.setEditFieldOutra(swipeWidget.getField('DSJUSTOPER'));
        } else {
            swipeCurrentRow.DSJUSTOPER = parentCurrentRow.DSJUSTOPER;
            self.setEditFieldOutra(swipeWidget.getField('DSJUSTOPER'));
            self.isJustificativaAlternativa(swipeWidget.getField('DSJUSTOPER').dataSource.data, swipeWidget);
        } if (parentCurrentRow.CDCOMPRADOR === undefined) {
            swipeCurrentRow.CDCOMPRADOR = null;
            swipeCurrentRow.CDCOMPRADOR_old = null;
        } else {
            swipeCurrentRow.CDCOMPRADOR = parentCurrentRow.CDCOMPRADOR;
            swipeCurrentRow.CDCOMPRADOR_old = parentCurrentRow.CDCOMPRADOR;
        } if (parentCurrentRow.CDDESTSOLI === undefined) {
            swipeCurrentRow.CDDESTSOLI = null;
            swipeCurrentRow.CDDESTSOLI_old = null;
        } else {
            swipeCurrentRow.CDDESTSOLI = parentCurrentRow.CDDESTSOLI;
            swipeCurrentRow.CDDESTSOLI_old = parentCurrentRow.CDDESTSOLI;
        } if (parentCurrentRow.NMCOMPRADOR === undefined) {
            swipeCurrentRow.NMCOMPRADOR = null;
        } else {
            swipeCurrentRow.NMCOMPRADOR = parentCurrentRow.NMCOMPRADOR;
        } if (parentCurrentRow.NMDESTSOLI === undefined) {
            swipeCurrentRow.NMDESTSOLI = null;
        } else {
            swipeCurrentRow.NMDESTSOLI = parentCurrentRow.NMDESTSOLI;
        } if (parentCurrentRow.IDBAIXITMSOL === undefined) {
            swipeCurrentRow.IDBAIXITMSOL = null;
        } else {
            swipeCurrentRow.IDBAIXITMSOL = parentCurrentRow.IDBAIXITMSOL;
        } if (!parentCurrentRow.QTTRANSFSOL) {
            swipeCurrentRow.QTTRANSFSOL = "0";
        } else {
            swipeCurrentRow.QTTRANSFSOL = parentCurrentRow.QTTRANSFSOL;
        } if(parentCurrentRow.DTUTILIZA === undefined){
            swipeCurrentRow.DTUTILIZA = null;
        } else{
            swipeCurrentRow.DTUTILIZA = parentCurrentRow.DTUTILIZA.substring(0, 10);
        } if (habilitaComprador) {
            swipeWidget.getField('NMCOMPRADOR').isVisible = true;
        } else {
            swipeWidget.getField('NMCOMPRADOR').isVisible = false;
        } if (habilitaDestino) {
            swipeWidget.getField('NMDESTSOLI').isVisible = true;
        } else {
            swipeWidget.getField('NMDESTSOLI').isVisible = false;
        } if (habilitaStatus) {
            swipeWidget.getField('IDBAIXITMSOL').isVisible = true;
            swipeWidget.getField('QTTRANSFSOL').isVisible = true;
        } else {
            swipeWidget.getField('IDBAIXITMSOL').isVisible = false;
            swipeWidget.getField('QTTRANSFSOL').isVisible = false;
        } if(gravaDataUtiliza && swipeWidget.getField('DTUTILIZA')){
            swipeWidget.getField('DTUTILIZA').isVisible = true;
        } else {
            if(swipeWidget.getField('DTUTILIZA')) {
                swipeWidget.getField('DTUTILIZA').isVisible = false;
            }
        }

        ScreenService.openSwipe(swipeWidget.getParent());
        swipeWidget.activate();
    };

    self.closeSwipes = function (swipeWidget) {
        swipeWidget.container.getWidget('cmp03100_solicitacao').reload().then(function() {
            ScreenService.closeSwipe();
            swipeWidget.parent.parent.activate();
        });
    };

    self.openEdit = function (widget) {
        
        var editWidget = widget.container.getWidget('cmp03100_solicitacao_edit');
        var stripeWidget = widget.container.getWidget('cmp03100_stripe');
        editWidget.newRow();
        
        self.openSwipes(editWidget, widget, stripeWidget);
        
        if (widget.currentRow.IDTIPLAN.toUpperCase() == 'AUTOMÁTICA' && bloqueiaEditEmSoliAuto) {
            editWidget.getAction('DELETE').isVisible            = false;
            editWidget.getAction('SAVE').isVisible              = false;
            editWidget.getField('QTSOLIPROD').readOnly          = true;
            editWidget.getField('DSJUSTOPER').readOnly          = true;
            editWidget.getField('DSOUTRAJUST').readOnly         = true;
            editWidget.getField('DTPROGENTR_compare').readOnly  = true;
            editWidget.getField('NMCOMPRADOR').readOnly         = true;
            editWidget.getField('NMDESTSOLI').readOnly          = true;
        } else {
            editWidget.getAction('DELETE').isVisible            = true;
            editWidget.getAction('SAVE').isVisible              = true;
            editWidget.getField('QTSOLIPROD').readOnly          = false;
            editWidget.getField('DSJUSTOPER').readOnly          = false;
            editWidget.getField('DTPROGENTR_compare').readOnly  = false;
            editWidget.getField('NMCOMPRADOR').readOnly         = false;
            editWidget.getField('NMDESTSOLI').readOnly          = false;
        }
    };
    self.openAddProdSwipe = function (widget) {
        
        var addProdWidget = widget.container.getWidget('cmp03100_add_prod');
        var stripeWidget = widget.container.getWidget('cmp03100_adiciona_prod_stripe');
        
        self.openSwipes(addProdWidget, widget, stripeWidget);
    };

    self.openAddProd = function () {
        if (hasRegiao === true && isContratoRescindido === false) {
            ScreenService.openWindow("cmp_V1#cmp03100_adiciona_produto").then(function () {
                
                var addProdFilterWidget = templateManager.container.getWidget('cmp03100_add_novo_FILTER');
                var addProdWidget = templateManager.container.getWidget('cmp03100_add_novo');
                
                addProdWidget.dataSource.data = null;
                addProdFilterWidget.getField('PRODINI').setValue("");
                addProdFilterWidget.getField('PRODFIN').setValue("");
                
                if (bloqueiaFiltroPorProdutoCompra) {
                    addProdFilterWidget.getField('IDPRODCOMPRA').isVisible = false;
                }
                
                ScreenService.openSwipe(addProdWidget);
            });
        } else {
            
            if (!hasRegiao && isContratoRescindido) {
                MessageService.showMessageByCode("FILIAL_SEM_REGIAO_CONTRATO_RESCINDIDO");
            } else if (!hasRegiao) {
                MessageService.showMessageByCode("FILIAL_SEM_REGIAO");
            } else {
                MessageService.showMessageByCode("FILIAL_CONTRATO_RESCINDIDO");
            }
        }
    };
    self.fechaAddProd = function () {
        ScreenService.openWindow("cmp_V1#cmp03100_solicitacao_de_compras");
    };

    self.isJustificativaAlternativa = function (justificativasData, widget) {
        
        var isJustificativaAlternativa = true;
        var dsJustOperField = widget.getField('DSJUSTOPER');
        var dsOutraJustField = widget.getField('DSOUTRAJUST');
        var dsJustOperFieldLength = 0;

        if(dsJustOperField.value()){
            dsJustOperFieldLength = dsJustOperField.value().length;
        }

        for (i = 0; i < justificativasData.length; i++) {
            if (widget.currentRow.DSJUSTOPER == justificativasData[i].DSJUSTSOL) {
                isJustificativaAlternativa = false;
            }
        }
        
        if (isJustificativaAlternativa && dsJustOperFieldLength > 0) {
            dsOutraJustField.setValue(widget.currentRow.DSJUSTOPER);
            dsJustOperField.setValue("OUTRA");
            dsOutraJustField.readOnly = false;
        } else {
            dsOutraJustField.readOnly = true;
        }

        self.setJustificaValidation(widget);
    };

    self.hasOpcaoOutra = function (field) {
        
        var dados = field.dataSource.data;
        var flagExisteOutra = false;
        
        for (i = 0; i < dados.length; i++) {
            if (dados[i].DSJUSTSOL.toUpperCase() == "OUTRA") {
                flagExisteOutra = true;
            }
        }
        
        if (flagExisteOutra === false) {
            self.addOpcaoOutra(dados);
        }
    };

    self.addOpcaoOutra = function (dados) {
        dados.push({"DSJUSTSOL": "OUTRA"});
    };

    self.setEditFieldOutra = function (field) {
        
        field.widget.getField('DSOUTRAJUST').setValue("");
        var justificativa = field.value();

        if(justificativa){
            justificativa = justificativa.toUpperCase();
        } if (justificativa == "OUTRA") {
            field.widget.getField('DSOUTRAJUST').readOnly = false;
        } else {
            field.widget.getField('DSOUTRAJUST').readOnly = true;
        }

        self.setJustificaValidation(field.widget);
    };
    self.setJustificaValidation = function (swipeWidget) {
        
        var dsJustOperField = swipeWidget.getField('DSJUSTOPER');
        var dsOutraJustField = swipeWidget.getField('DSOUTRAJUST');
        var swipeCurrentRow = swipeWidget.currentRow;
        var dsJustOperFieldUpper = dsJustOperField.value();

        if(dsJustOperFieldUpper){
            dsJustOperFieldUpper = dsJustOperFieldUpper.toUpperCase();
        } if ((swipeCurrentRow.IDTIPLAN.toUpperCase() == 'EXTRA' || swipeCurrentRow.IDTIPLAN.toUpperCase() == 'MANUAL EXTRA') && isJutificativaExtraObrigatoria) {
            dsJustOperField.validations = {"required": {}};

            if (dsJustOperFieldUpper == "OUTRA") {
                dsOutraJustField.validations = {"required": {}};
            } else {
                dsOutraJustField.validations = undefined;
            }
        } else {
            
            if (isJustificativaObrigatoria) {
                dsJustOperField.validations = {"required": {}};

                if (dsJustOperFieldUpper == "OUTRA") {
                    dsOutraJustField.validations = {"required": {}};
                } else {
                    dsOutraJustField.validations = undefined;
                }
            } else {
                dsJustOperField.validations = undefined;
                dsOutraJustField.validations = undefined;
            }
        }
    };

    self.saveProds = function (swipeWidget) {
        var rotinaSalvamento = function (swipeWidget) {
            if (swipeWidget.isValid()) {
                var swipeCurrentRow = swipeWidget.currentRow;
                if (self.quantidadePositiva(swipeCurrentRow.QTSOLIPROD)) {
                    var dsJustOperUpper = swipeCurrentRow.DSJUSTOPER;
                    if(dsJustOperUpper){
                        dsJustOperUpper = dsJustOperUpper.toUpperCase();
                    } if (dsJustOperUpper == "OUTRA") {
                        swipeCurrentRow.DSJUSTOPER = swipeCurrentRow.DSOUTRAJUST;
                        swipeCurrentRow.DSOUTRAJUST = "";
                    } if (gravaDataUtiliza) {
                        swipeCurrentRow.DTUTILIZA = swipeCurrentRow.DTPROGENTR;
                    } else {
                        swipeCurrentRow.DTUTILIZA = null;
                    } if (!habilitaComprador || !swipeCurrentRow.CDCOMPRADOR) {
                        swipeCurrentRow.CDCOMPRADOR = null;
                    } if (!habilitaDestino || !swipeCurrentRow.CDDESTINO) {
                        swipeCurrentRow.CDDESTINO = null;
                    }
                    swipeCurrentRow.CDOPERLANC = getLocalVar('CDOPERADOR');
                    if(typeof swipeCurrentRow.QTSOLIPROD == "string"){
                        swipeCurrentRow.QTSOLIPROD = parseFloat(swipeCurrentRow.QTSOLIPROD.replace(/\./g, '').replace(',', '.'));
                    }
                    SolicitacaoComprasService.save(swipeCurrentRow).then(function () {
                        //swipeWidget.parent.parent.reload();
                        self.atualizaStripeData();
                        self.closeSwipes(swipeWidget);
                    });
                } else {
                    MessageService.showMessageByCode("QTDFINAL_MAIOR_ZERO");
                }
            } else {
                MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            }
        };
        if (verificarPeriodicidade && (swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'MANUAL' ||
            
            swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'AUTOMÁTICA' ||
            swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'NORMAL')) {
            self.existePeriodicidade(swipeWidget.currentRow).then(function (existePeriodicidadeFlag) {
            
                if(!existePeriodicidadeFlag) {
                    MessageService.showMessageByCode("PROD_SEM_PERIODICIDADE_ENTREGA");
                } else {
                    rotinaSalvamento(swipeWidget);
                }
            });
        } else {
            rotinaSalvamento(swipeWidget);
        }
    };

    self.deleteItemSoli = function (swipeWidget) {
        SolicitacaoComprasService.delete(swipeWidget.currentRow).then(function () {
            swipeWidget.parent.parent.reload();
            ScreenService.closeSwipe();
        });
    };

    self.deleteMuitos = function (parentWidget) {
        
        var rowsToDelete = parentWidget.getCheckedRows();
        
        for (i = 0; i < rowsToDelete.length - 1; i++) {
            rowsToDelete[i].DTPROGENTR_old = rowsToDelete[i].DTPROGENTR;
            SolicitacaoComprasService.delete(rowsToDelete[i]);
        }
        
        rowsToDelete[i].DTPROGENTR_old = rowsToDelete[i].DTPROGENTR;
        
        SolicitacaoComprasService.delete(rowsToDelete[i]).then(function () {
            parentWidget.reload();
        });
    };

    self.comparaItemSoli = function (swipeWidget) {
        
        var row = swipeWidget.currentRow;
        
        row.DTPROGENTR = row.DTPROGENTR_compare;
        swipeWidget.getField('QTSOLIPROD_compare').label = swipeWidget.getField('QTSOLIPROD_compare').label.substring(0, 36) + row.DTPROGENTR_compare;
        
        if (row.QTSOLIPROD_old.length === 0) {
            row.QTSOLIPROD_old = 0;
        }
        if (row.DTPROGENTR_old == row.DTPROGENTR_compare && row.CDDESTSOLI_old == row.CDDESTSOLI && row.CDDESTSOLI_old == row.CDDESTSOLI) {
            row.QTSOLIPROD = row.QTSOLIPROD_old;
            row.QTSOLIPROD_compare = row.QTSOLIPROD_old;
            
            if (swipeWidget.getAction('DELETE') !== undefined) {
                swipeWidget.getAction('DELETE').isVisible = true;
            }
        } else {
            var filterArray = [];
            
            filterArray.CDFILLAN = row.CDFILLAN;
            filterArray.DTPROGENTR = row.DTPROGENTR;
            filterArray.CDPRODUTO = row.CDPRODUTO;
            filterArray.CDDESTSOLI = row.CDDESTSOLI;
            filterArray.CDCOMPRADOR = row.CDCOMPRADOR;
            
            if (row.IDTIPLAN.toUpperCase() == 'EXTRA' || row.IDTIPLAN.toUpperCase() == 'MANUAL EXTRA') {
                filterArray.IDTIPLAN = 'MANUAL EXTRA';
            } else {
                filterArray.IDTIPLAN = 'MANUAL';
            }
            
            SolicitacaoComprasService.getItemSoli(filterArray).then(function (callback) {
                var produtoExistente = callback.dataset.solicitacao_compras_justificativa[0];
                
                if (!produtoExistente) {
                    row.QTSOLIPROD_compare  = 0;
                    //row.QTSOLIPROD          = row.QTSOLIPROD_old;
                } else {
                    row.QTSOLIPROD_compare  = produtoExistente.QTSOLIPROD;
                    //row.QTSOLIPROD          = parseFloat(row.QTSOLIPROD_compare) + parseFloat(row.QTSOLIPROD_old);
                }
            });
            if (swipeWidget.getAction('DELETE') !== undefined) {
                swipeWidget.getAction('DELETE').isVisible = false;
            }
        }
        self.setJustificaValidation(swipeWidget);
    };
    self.desativaEdicao = function (tipoSoliField) {
        
        var widget = tipoSoliField.widget;
        
        if (tipoSoliField.value().length === 0) {
            widget.getField('DTPROGENTR_compare').readOnly = true;
            widget.getField('QTSOLIPROD').readOnly         = true;
        } else {
            widget.getField('DTPROGENTR_compare').readOnly = false;
            widget.getField('QTSOLIPROD').readOnly         = false;

            self.comparaItemSoli(widget);
        }
    };

    self.verificaData = function (dataField) {
        
        var data = dataField.value();
        
        data = data.split("/");
        data = data[1] + "," + data[0] + "," + data[2];

        Parametros.retornaDataProcessamento().then(function (callback) {
            var dataProcessamento   = callback;
            dataProcessamento       = dataProcessamento.split("/");
            dataProcessamento       = dataProcessamento[1] + "," + dataProcessamento[0] + "," + dataProcessamento[2];
            
            if (Date.parse(data) < Date.parse(dataProcessamento)) {
                dataField.setValue(callback.substring(0, 10));
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            } else {
                self.comparaItemSoli(dataField.widget);
            }
        });
    };

    self.getUnique = function (value, index, self) {
        return self.indexOf(value) === index;
    };

    self.existePeriodicidade = function (currentRow) {
        var filterArray = [];
        filterArray.DTPROGENTR = currentRow.DTPROGENTR;
        filterArray.CDPRODUTO = currentRow.CDPRODUTO;
        return SolicitacaoComprasService.getPeriodicidade(filterArray).then(function (callback) {
            if(callback.dataset.periodicidade.length === 0) {
                return false;
            } else {
                return true;
            }
        });
    };
    self.quantidadePositiva = function (quantidade){
        var tipo = typeof quantidade;

        if(tipo == 'string'){
            quantidade = parseFloat(quantidade.replace(/\./g, '').replace(',', '.'));
        } else{
            quantidade = parseFloat(quantidade);
        } if(quantidade <= 0){
            return false;
        } else{
            return true;
        }
    };

    self.atualizaStripeData = function(){
        if(!stripeWidgetFilter.length){
            stripeWidgetFilter.push(
                {
                    "name": "DTPROGENTR",
                    "value": moment().format('DD/MM/YYYY'),
                    "operator": "="
                }
            );
        }
        stripeWidget.dataSourceFilter = angular.copy(stripeWidgetFilter);
        stripeWidget.reload().then(function(){
            var dados = stripeWidget.dataSource.data;

            if (dados.length > 0) {
                var todasDatas      = [];
                var dadosFiltrados  = [];

                for (i = 0; i < dados.length; i++) {
                    todasDatas.push(dados[i].DTPROGENTR.substring(0, 10));
                }
                var distinctDatas = todasDatas.filter(self.getUnique);

                for (i = 0; i < distinctDatas.length; i++) {
                    dadosFiltrados.push({"DTPROGENTR": distinctDatas[i]});
                }

                stripeWidget.dataSource.data = dadosFiltrados;
                stripeWidget.moveToFirst();
            }
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SolicitacaoComprasController', SolicitacaoComprasController);
});

// FILE: ./assets/modules/necessidadeCompras/assets/js/controllers/CalculoDaNecessidadeDeComprasController.js
var CalculoDaNecessidadeDeComprasController = function (ScreenService, MessageService, General, restEngine, templateManager, Utilities){
    /*global Constants*/
    var self = this;
    var idutcardpadr;
    var grupo;
    var idcalprevcon;
    var nececomp;
    var extra;
    var calculaSegundoPlano = false;
    
    
    this.validaDtinicial = function() {
        let widget = templateManager.container.getWidget('calculoNecessidadeComprasMerenda');
        let dataInicial = widget.currentRow.PERIENTR.start;
        if(dataInicial) {
            dataInicial = moment(dataInicial, 'DD/MM/YYYY');
            var dataProcessamento = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
            
            if(moment(dataInicial).isBefore(dataProcessamento)) {
                MessageService.showMessageByCode("DTINIC_MENOR_DTPROC");
                return false;
            } else {
                return true;
            }
        }
    };
    
    this.setEstoque = function(field) {
        if(field.getParent().name == 'calculoNecessidadeComprasMerenda'){
            if(field.widget.currentRow.IDSCONESTNEC == 'S') {
    		    field.widget.getField('CONSIDERAESTOQUE').label = ScreenService.i18n('Considera Estoque');
    		} else {
    		    field.widget.getField('CONSIDERAESTOQUE').label = ScreenService.i18n('Não Considera Estoque');
    		}
    		field.widget.getField('PEACRESCIMO').readOnly = field.widget.currentRow.IDPERACRNEC == 'N';
        } else {
            let row = angular.copy(field.widget.currentRow);
            if(field.value().length > 0) {
                if(row.FILIAL.length == 1){
                    row.CDFILIAL = concatArrayForParams(row.FILIAL);
                    General.callRestEngine('cmp_necessidadeCompras#/setEstoque','Row', row).then(function(calback) {
                        let resposta = calback.dataset.resposta[0];
                        if(resposta) {
                            if(resposta.IDSCONESTNEC == 'S') {
                    		    field.widget.getField('estoque').label = ScreenService.i18n('Considera Estoque');
                    		} else {
                    		    field.widget.getField('estoque').label = ScreenService.i18n('Não Considera Estoque');
                    		}
                        }
                        else {
                             field.widget.getField('estoque').label = '';
                        }
                    }).catch(function(error) {
                        ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                    });   
                } else {
                    field.widget.getField('estoque').label = '';
                }
            }
        }
    };
    
    this.onlyNumbers = function(field) {
		if(isNaN(Number(field.value()))) {
			field.value(prevValue);
		} else {
			if(field.value() === "") {
				prevValue = "";
				field.value(0);
				field.value("");
				return false;
			}
			if(parseInt(Number(field.value())) === Number(field.value())) {
				field.value(parseInt(Number(field.value())).toString());
				field.value(Math.abs(field.value()));
				prevValue = field.value();
			} else {
				field.value(prevValue);
			}
		}
	};
	
	this.setPrevValue = function(field) {
		prevValue = field.value();
	};
    
    this.validaAcrecimos = function(field){
        
        if (field < 10000.00){
            return true;
        } else {
            MessageService.showMessageByCode("ACRESCIMO_MENOR_1000");
            return false;
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("INIPRODUCT_MUSTBELESSTHAN_FINPRODUCT");
            return false;
        }

        return true;
    };
    
    this.validaProdutoFinal = function(row) { 
        var aux = 'ZZZZZZZZZZZZZZZZZZZZ';
        var str = row.CDPRODFIN;
        var produto = str + aux.substr(0, aux.length - str.length); 
        return produto;
    };
    
    this.setDadosTela = function (args){
        if(args.getWidget('calculoNecessidadeComprasMerenda')) {
            let widget = args.getWidget('calculoNecessidadeComprasMerenda');
            
            General.callRestEngine('cmp_necessidadeCompras#/getDataProcessamentoFilial', 'Row', {}).then(function(response) {
                const dtProcessa = moment(response.dataset.res[0].DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                
                widget.getField('PERIENTR').defaultValue = {
                    start: dtProcessa,
                    end: dtProcessa
                };
                
                widget.currentRow.PERIENTR = {
                    start: dtProcessa,
                    end: dtProcessa
                };
            });
        } else {
            var widget = args.getWidget('calculoNecessidadeCompras');
            var row =  widget.currentRow;
            
            General.callRestEngine('cmp_necessidadeCompras#/getDataProcessamentoFilial', 'Row', {}).then(function(response) {
                const dtProcessa = moment(response.dataset.res[0].DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                
                widget.getField('PERIENTR').defaultValue = {
                    start: dtProcessa,
                    end: dtProcessa
                };
                
                widget.currentRow.PERIENTR = {
                    start: dtProcessa,
                    end: dtProcessa
                };
            });
            
            
            General.callRestEngine('cmp_necessidadeCompras#/setDadosCalculo','Row',row).then(function(calback) {
                var resposta = calback.dataset.resposta;
                idutcardpadr = resposta.IDUTCARDPADR;
                grupo = resposta.CDGRUPPROD;
                idcalprevcon = resposta.IDCALPREVCON;
        		var filter =  [
        			{
        				'name': 'P_CDGRUPPROD',
        				'operator': '=',
        				'value' : resposta.CDGRUPPROD
        			},
        			{
        				'name': 'NRORG',
        				'operator': '=',
        				'value': getLocalVar('NRORG')
        			}
        		];
        		widget.getField('NMSUBGRPROD').dataSourceFilter = filter;
        			
        		if(resposta.IDPERACRNEC == 'N'){
        		    widget.getField('PEACRESCIMO').readOnly = true;
        		} else {
        		    widget.getField('PEACRESCIMO').readOnly = false;
        		}
        		
        		if(resposta.IDSISDOS == 3){
        		    widget.getField('CALENDARIO').setValue('S');
        		    widget.getField('CALENDARIO').readOnly = true;
        		} else {
        		    widget.getField('CALENDARIO').setValue('N');
        		    widget.getField('CALENDARIO').readOnly = false;
        		}
            }).catch(function(error) {
                ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
            });
        }
    };
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams (arr, defaultValue) {
        if (!Util.isEmptyOrBlank(arr)) {
            return '_' + arr.join('_') + '_';
        } else {
            return defaultValue !== undefined ? defaultValue : 'T';
        }
    }
    
    function montaParametrosPrevisoesAndDataLimiteSeguranca(row) {
        row.DTINI = row.PERIENTR.start;
        row.DTFIM = row.PERIENTR.end;
        row.PRODUTOFIN = self.validaProdutoFinal(row);
        row.GROUPFILI = row.CDGRUPFILI || null;
        row.CDFILIAL = concatArrayForParams(row.FILIAL);
    }
    
    this.abrePopupOperador = function() {
        const popupEnviarOperador = templateManager.container.getWidget('popupEnviarOperador');
        const widgetCalculo = templateManager.container.getWidget('calculoNecessidadeCompras');
        
        if(widgetCalculo.isValid()) {
            ScreenService.openPopup(popupEnviarOperador);
        }
    };
    
    this.confirmaCalcSegundoPlano = function() {
        const widgetCalculo = templateManager.container.getWidget('calculoNecessidadeCompras');
        let cdoperador = templateManager.container.getWidget('popupEnviarOperador').currentRow.CDOPERADOR;
        
        if (!Util.isEmptyOrBlank(cdoperador)) {
            if(Array.isArray(cdoperador)) {
                cdoperador =  '_' + cdoperador.join('_') + '_' + getLocalVar('CDOPERADOR') + '_';
            } else {
                cdoperador = '_' + getLocalVar('CDOPERADOR') + '_'; 
            }
        } else {
            cdoperador = '_' + getLocalVar('CDOPERADOR') + '_';
        }
        
        let listaOperador = cdoperador;
        
        widgetCalculo.currentRow.LISTAOPERADOR = listaOperador;
        
        this.confirmaCalculo(widgetCalculo, true);
    };
    
    function montaParametrosMerenda(row) {
        row.DTINI = row.PERIENTR.start;
        row.DTFIM = row.PERIENTR.end;
        row.PRODUTOFIN = self.validaProdutoFinal(row);
        row.PEACRESCIMO = row.PEACRESCIMO ? row.PEACRESCIMO : 0;
    }
    
    function validaDataPeriodo(row) {
        let dtIni = row.PERIENTR.start;
        let dtProc = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        dtIni = moment(dtIni, "DD/MM/YYYY");
        if(dtIni) {
            if(moment(dtIni).isBefore(dtProc)) {
                MessageService.showMessageByCode("DTINIC_MENOR_DTPROC");
                return false;
            } else {
                return true;
            }
        } else {
            return false;
        }
    }
    
    this.confirmaCalculo = function(widget, segundoPlano) {
        if(widget.name == 'calculoNecessidadeComprasMerenda') {
            let row = widget.currentRow;
            row.TCDFILIAL = "";
            montaParametrosMerenda(row);
            if(widget.isValid() && self.validaDtinicial() && self.validaProduto(row.CDPRODINI, row.CDPRODFIN) && self.validaAcrecimos(row.PEACRESCIMO)) {
                ScreenService.confirmMessage('Confirma o cálculo?', 'question', function(success) {
                    General.callRestEngine('cmp_necessidadeCompras#/existeSolicitacao','Row',row).then(function(calback) {
                        let resposta = calback.dataset.resposta;
                        if(resposta.length != 0 ){
                            widget.container.getWidget('existemSolicitacoes').dataSource.data = resposta;
                            widget.container.getWidget('existemSolicitacoes').reload();
                            ScreenService.openPopup(widget.container.getWidget('existemSolicitacoes'));
                        } else {
                            self.calcula(widget, row);
                        }
                    }).catch(function(error) {
                        ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                    });    
                });   
            }
        } else {
            
            let row = widget.currentRow;
            row.TCDFILIAL = "";
            
            calculaSegundoPlano = segundoPlano;
            
            row.PEACRESCIMO = row.PEACRESCIMO ? row.PEACRESCIMO : 0;
            
            if(widget.isValid() && self.validaProduto(row.CDPRODINI, row.CDPRODFIN) && self.validaAcrecimos(row.PEACRESCIMO) && validaDataPeriodo(row)) {
                
                ScreenService.confirmMessage('Confirma o cálculo?', 'question', function(success) {
                    
                    montaParametrosPrevisoesAndDataLimiteSeguranca(row);
                   
                    if(idutcardpadr == 'D' || idutcardpadr == 'S'){
                        General.callRestEngine('cmp_necessidadeCompras#/previsoes','Row',row).then(function(calback) {
                            var resposta = calback.dataset.resposta;
                            
                            if(resposta.length != 0 ){
    
                                widget.container.getWidget('previsoesbloqueadas').dataSource.data = resposta;
                                widget.container.getWidget('previsoesbloqueadas').reload();
                                ScreenService.openPopup(widget.container.getWidget('previsoesbloqueadas'));
                               
                            } else {
                                self.verificaSolicitacao(widget, row);
                            }
                        }).catch(function(error) {
                            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                        });
                    }else {
                        self.verificaSolicitacao(widget, row);
                    }    
                 
                });
            }
        }
    };
    
    this.previsoesBloqueadas = function(widget){
        let parentWidget = widget.getParent();
        
        ScreenService.confirmMessage('Confirma o cálculo mesmo com previões bloqueadas?', 'question', function(success) {
            ScreenService.closePopup();
            parentWidget.activate();
            //self.verificaSolicitacao(parentWidget, angular.copy(parentWidget.currentRow));
            self.verificaSolicitacao(parentWidget, parentWidget.currentRow);
        }, function(error){
            ScreenService.closePopup();
            parentWidget.activate();
        });
    };
    
    this.verificaSolicitacao = function(widget, row){
        row.SUBGRUPO = concatArrayForParams(row.NMSUBGRPROD, null);
        row.CDGRUPPROD = grupo;
        
        General.callRestEngine('cmp_necessidadeCompras#/existeSolicitacao','Row',row).then(function(calback) {
            let resposta = calback.dataset.resposta;
            if(resposta.length != 0 ){
                widget.container.getWidget('existemSolicitacoes').dataSource.data = resposta;
                widget.container.getWidget('existemSolicitacoes').reload();
                ScreenService.openPopup(widget.container.getWidget('existemSolicitacoes'));
            } else {
                self.calcula(widget, row);
            }
        });
    };
    
    this.existemSolicitacoes = function(widget){
        let parentWidget = widget.getParent();
        let rowParentWidget = parentWidget.currentRow;
        
        rowParentWidget.SUBGRUPO = concatArrayForParams(rowParentWidget.NMSUBGRPROD, null);
        rowParentWidget.CDGRUPPROD = grupo;
        
        ScreenService.closePopup();
        parentWidget.activate();
        //self.calcula(parentWidget, angular.copy(rowParentWidget));
        self.calcula(parentWidget, rowParentWidget);
    };
    
    this.calcula = function(widget, row) {
        row.TCDFILIAL = "";
        if(widget.isValid()) {
            if(widget.name == 'calculoNecessidadeComprasMerenda') {
                General.callRestEngine('cmp_necessidadeCompras#/GetPrxNeceCompMerenda', 'Row', row).then(function(calculo) {
                    if(calculo.dataset.resposta.NECECOMP === 'N') {
                        MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
        			} else {
        			    row.NECECOMP = calculo.dataset.resposta.NECECOMP[0].NRNECECOMP;
        			    General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliMerenda', 'Row', row).then(function(response) {
                            self.openPreviaCalculoNecessidadeCompras(row.NECECOMP);
                            MessageService.showMessageByCode("SOLCMP_SUCCESS");
                        }.bind()).catch(function(error) {
                            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                        });
        			}
                }.bind(row));
                
            } else {
                montaParametrosPrevisoesAndDataLimiteSeguranca(row);
                General.callRestEngine('cmp_necessidadeCompras#/dataLimiteSeguranca','Row',row).then(function(calback) {
                    row.DATFIMSEGU = calback.dataset.resposta.DATSEGU;
                    row.MSGBACK = "Parâmetros default de consumo devem ser informados.";
                    if(idcalprevcon !== 'N') {
                        if(idcalprevcon == 'S') {
                            MessageService.confirmMessageByCode("CONFIRM_CALC_PREV", {DATFIMSEGU: row.DATFIMSEGU}, Constants.confirmationMessage).then(() => {
                                General.callRestEngine('cmp_necessidadeCompras#/GetPrxConsPlan','Row',row).then(function(result) {
                                    if(!result.dataset.resposta.MSG){
                                        self.CalcNecesComp(row);
                                    }else{
                                        ScreenService.showMessage(result.dataset.resposta.MSG);
                                    }
                                    
                                }).catch(function(error) {
                                    ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n("Tempo limite de conexão excedido."), 'error', 'error');
                                }); 
                            }, function(error) {
                                self.CalcNecesComp(row);
                            });
                        } else{
                            General.callRestEngine('cmp_necessidadeCompras#/GetPrxConsPlan','Row',row).then(function(result) {
                                if(!result.dataset.resposta.MSG) {
                                    self.CalcNecesComp(row);
                                }else{
                                    ScreenService.showMessage(result.dataset.resposta.MSG);
                                }
                            }).catch(function(error) {
                                ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'), 'error', 'error');
                            }); 
                        }       
                    } else{
                        self.CalcNecesComp(row);
                    }
                });
            }
        }   
    };

    this.CalcNecesComp = function(row) {
        General.callRestEngine('cmp_necessidadeCompras#/PrxNeceBkg', 'Row', row).then(function(retorno) {
            row.NECECOMP = retorno.dataset.resposta.NRNECECOMP;
            row.IDCALPREVCON = idcalprevcon;
            
            if(calculaSegundoPlano) {
                realizaCalculoSegundoPlano(row);
            } else {
                realizaCalcNeceComp(row);
            }
        }).catch(function(error) {
            ScreenService.showMessage(error.data ? error.data.error : ScreenService.i18n('Tempo limite de conexão excedido.'));
        });
    };
     
    function realizaCalculoSegundoPlano(row) {
        row.EMAILLOGADO = getLocalVar('EMAIL');
        
        return General.callRestEngine('cmp_necessidadeCompras#/calcNeceCompSegundoPlano', 'Row', row).then(function() {
            MessageService.showMessageByCode("CALC_SEG_PLAN", {NECECOMP: row.NECECOMP} , Constants.alertMessage);
            ScreenService.closePopup();
        });
    }

    function realizaCalcNeceComp(row) {
        nececomp = row.NECECOMP;
        extra = row.EXTRA;
        row.TCDFILIAL = "";
            
        return General.callRestEngine('cmp_necessidadeCompras#/GetPrxNeceComp', 'Row', row).then(function(calculo) {
            if(Array.isArray(row.FILIAL) && row.FILIAL.length === 1) {
                ScreenService.openWindow('cmp_necessidadeCompras#necessidade_de_compras').then(function() {
                    var widgetNecessidadeCompras = templateManager.container.getWidget('gridNeceComp');
                    
                    widgetNecessidadeCompras.dataSourceFilter = [
                        {
            				'name': 'P_NRNECECOMP',
            				'operator': '=',
            				'value' : row.NECECOMP
            			},
            			{
            				'name': 'P_DTINICIAL',
            				'operator': '=',
            				'value': row.DTINI
            			}
        			];
        			
        			if(calculo.dataset.resposta.NECECOMP === 'N') {
                        MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
        			}
        			
        			widgetNecessidadeCompras.CDFILIAL   = row.FILIAL[0];
        			widgetNecessidadeCompras.NECECOMP   = row.NECECOMP;
        			widgetNecessidadeCompras.CDPRODINI  = row.CDPRODINI;
        			widgetNecessidadeCompras.CDPRODFIN  = row.CDPRODFIN;
        			widgetNecessidadeCompras.DTINI      = row.PERIENTR.start;
        			widgetNecessidadeCompras.DTFIM      = row.PERIENTR.end;
        			
        			widgetNecessidadeCompras.reload().then(function() {
        			    widgetNecessidadeCompras.activate();
        			    widgetNecessidadeCompras.redraw();
        			});
                });
            } else {
                if(calculo.dataset.resposta.NECECOMP === 'N') {
                    MessageService.showMessageByCode("NECECOMP_N_APUROU_INFOS");
    			} else {
    			    var msg = 'Cálculo da Necessidade de Compras-Extra';
                    var param = {'NRNECECOMP': nececomp, 'EXTRA': extra, 'MENSAGEM': msg};
               
                    return General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp','Row',param).then(function() {
                        self.openPreviaCalculoNecessidadeCompras(nececomp);
                        MessageService.showMessageByCode("SOLCMP_SUCCESS");
                    });
    			}
            }
        }.bind(row));
    }
    
    this.setDataSource = function (fieldAgrupamento) {
        //field.setValue('');
        
        const row = fieldAgrupamento.widget.currentRow;
        const fieldFilial = fieldAgrupamento.widget.getField('FILIAL');
        
        if(!row.NMGRUPFILI) {
            fieldFilial.dataSource.name = "cmp#/crud/filial_ativa_oper";
            fieldFilial.dataSourceFilter = [
                {
    				'name': 'P_CDOPERADOR',
    				'operator': '=',
    				'value' : getLocalVar('CDOPERADOR')
    			},
    			{
    				'name': 'NRORG',
    				'operator': '=',
    				'value': getLocalVar('NRORG')
    			}     
            ];
        } else {
            fieldFilial.dataSource.name = "cmp#/filialgrupfili";
            fieldFilial.dataSourceFilter = [
                {
    				'name': 'CDOPERADOR',
    				'operator': '=',
    				'value' : getLocalVar('CDOPERADOR')
    			},
    			{
    				'name': 'CDGRUPFILI',
    				'operator': '=',
    				'value': row.CDGRUPFILI 
    			},
    			{
    				'name': 'CDREGIAO',
    				'operator': 'IS_NOT_NULL'
    			}
            ];
        }
        
        fieldFilial.reload();
    };
    
    // this.checkProjectCorp =  function(widget){
    //     if(!window.projectId){
    //         widget.getField('NMGRUPFILI').readOnly = true;
    //         widget.getField('NMGRUPFILI').reload();
    //         widget.getField('FILIAL').readOnly = true;
    //         widget.getField('FILIAL').template = "/field/select.html";
    //         widget.getField('FILIAL').setValue([ getLocalVar('CDFILIAL') ]);
    //         widget.getField('FILIAL').reload();
    //     }
    // };

    
    this.getExtra = function(){
        return extra;
    };
    
    this.openPreviaCalculoNecessidadeCompras = function(numeroPrevia) {
        ScreenService.openWindow('cmp_necessidadeCompras#cmp03800_previa_do_calculo_da_necessidade_de_compras').then(function() {
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').setValue(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').value(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').defaultValue = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = numeroPrevia;
            
            General.callRestEngine('cmp_necessidadeCompras#/crud/numPrevia', 'FilterData', {}).then(function(response) {
                const dataNumPrevia = response.dataset.numPrevia;
                let dadosPrevia = dataNumPrevia.filter(function(previa) {
                    return previa.NRNECECOMP === numeroPrevia;
                });
                dadosPrevia = dadosPrevia.length ? dadosPrevia[0] : dadosPrevia;
                
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').setValue({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').value({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').defaultValue = {
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                };
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.start = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.end = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedStart = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedEnd = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTINI = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTFIN = dadosPrevia.DTFIN.substr(0, 10);
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODINICIAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODFINAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMFILIAL').validations;
            });
        });
    };
    
    this.retornaCookieListaOperador = function() {
        const nomeCookie = 'LISTA_OPERADOR_CALCULO_SEGUNDO_PLANO';
        const popupEnviarOperador = templateManager.container.getWidget('popupEnviarOperador');
        const fieldCdoperador = popupEnviarOperador.getField('CDOPERADOR');
        const cdoperador = popupEnviarOperador.currentRow.CDOPERADOR;
        
        if(!cdoperador || !cdoperador.length) {
            General.callRestEngine('cmp_necessidadeCompras#/retornaCookie', 'Row', { 'NOME_COOKIE': nomeCookie } ).then(function(valorCookie) {
                valorCookie = valorCookie.messages[0].message;
                
                if(valorCookie) {
                    valorCookie = valorCookie.split('_');
                    
                    valorCookie = valorCookie.filter(function(cdoperador) {
                        return cdoperador !== getLocalVar('CDOPERADOR') && cdoperador !== "";
                    });
                    
                    fieldCdoperador.setValue(valorCookie);
                    fieldCdoperador.reload();
                }
                
            });
        }
    };
};

Configuration(function (ContextRegister) {
	ContextRegister.register('CalculoDaNecessidadeDeComprasController', CalculoDaNecessidadeDeComprasController);
});

// FILE: ./assets/modules/necessidadeCompras/assets/js/controllers/Cmp03800PreviaDoCalculoDaNecessidadeDeCompras_Controller.js
function Cmp03800PreviaDoCalculoDaNecessidadeDeCompras_Controller(General, ScreenService, MessageService, templateManager, restEngine, ZHPromise, ZhFilterPreferences, Utilities) {

    var self = this;
    var NRNECECOMP;
    var idcalprevcon;
    
    this.widgetOnEnter = function(args) {
        const widgetFiltro = templateManager.container.getWidget('FILIAIS');
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
            
            retornaParametros().then(function(params) {
                const parametrosPrevia = params[0].dataset.parametrosPrevia;
                const parcmpsupPrevia = params[1].dataset.parcmpsupPrevia[0];
    
                const idsisdos = parametrosPrevia.IDSISDOS;
                const cdgrupprod = parametrosPrevia.CDGRUPPROD;
                const idsconestnec = parcmpsupPrevia.IDSCONESTNEC;
                idcalprevcon = parcmpsupPrevia.IDCALPREVCON;
    
                verificaProjectCorp(widgetFiltro);
                aplicaIdsisdos(widgetFiltro, idsisdos);
                defineFiltroSubgrupo(widgetFiltro, cdgrupprod);
                self.onChangeNumPrevia(widgetFiltro);
                aplicaConsideraEstoque(widgetFiltro, idsconestnec);
                const rowsToSet = {};
                
                if(widgetFiltro.NRNECECOMP && widgetFiltro.currentRow.DTINI && widgetFiltro.currentRow.DTFIN) {
                    rowsToSet.NRNECECOMP = widgetFiltro.NRNECECOMP;
                    rowsToSet.DTINI = widgetFiltro.currentRow.DTINI;
                    rowsToSet.DTFIN = widgetFiltro.currentRow.DTFIN;
                    rowsToSet.DTENTREGA = {
                        "start": widgetFiltro.currentRow.DTENTREGA.start,
                        "formattedStart": widgetFiltro.currentRow.DTENTREGA.formattedStart,
                        "end": widgetFiltro.currentRow.DTENTREGA.end,
                        "formattedEnd": widgetFiltro.currentRow.DTENTREGA.formattedEnd
                    };
                    rowsToSet.NMFILIAL = widgetFiltro.currentRow.NMFILIAL = '';
                    rowsToSet.CDFILIAL = widgetFiltro.currentRow.CDFILIAL = '';
                    
                    widgetFiltro.currentRow.NRNECECOMP = widgetFiltro.NRNECECOMP;
                
                    ZhFilterPreferences.openFilterWidget(widgetFiltro, rowsToSet).then(function(opened) {
                        const widgetActive = templateManager.container.getActiveWidget();
                        
                        const fieldProdutoInicial = widgetActive.getField('NMPRODINICIAL');
                        const fieldProdutoFinal = widgetActive.getField('NMPRODFINAL');
                        const fieldUnidade = widgetActive.getField('NMFILIAL');
                        
                        if(fieldProdutoInicial.validations && fieldProdutoFinal.validations && fieldUnidade.validations) {
                            delete fieldProdutoInicial.validations.required;
                            delete fieldProdutoFinal.validations.required;
                            delete fieldUnidade.validations.required;
                        }
                        
                        fieldProdutoInicial.reload();
                        fieldProdutoFinal.reload();
                        fieldUnidade.reload();
                    });
                } else {
                    rowsToSet.DTENTREGA = {
                        "start": moment().format('L'),
                        "formattedStart": moment().format('L'),
                        "end": moment().format('L'),
                        "formattedEnd": moment().format('L')
                    };
                    rowsToSet.NMFILIAL = widgetFiltro.currentRow.NMFILIAL = '';
                    rowsToSet.CDFILIAL = widgetFiltro.currentRow.CDFILIAL = '';
                    
                    ZhFilterPreferences.openFilterWidget(widgetFiltro, rowsToSet).then(function(opened) {
                        return;
                    });
                }
            });
        }, function(error) {
			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
		});
    };

    function verificaProjectCorp(widgetFiltro) {
        /** if (window.projectCorp) {
            widgetFiltro.getField("NMFILIAL").readOnly = false;
        } else {
            widgetFiltro.getField("NMFILIAL").readOnly = true;
        } **/
        widgetFiltro.getField("NMFILIAL").readOnly = false;
        if(widgetFiltro.currentRow.NRNECECOMP && widgetFiltro.currentRow.DTINI && widgetFiltro.currentRow.DTFIN)
            delete widgetFiltro.getField("NMFILIAL").validations;
    }

    function retornaParametros() {
        let promiseParam = [];

        promiseParam.push(General.callRestEngine('cmp_necessidadeCompras#/retornaParametrosPrevia', "Row", []));
        promiseParam.push(General.callRestEngine('cmp_necessidadeCompras#/retornaParcmpsupPrevia', "Row", []));

        return ZHPromise.all(promiseParam);
    }

    function aplicaIdsisdos(widgetFiltro, idsisdos) {
        let fieldCalendario = widgetFiltro.getField('CALENDARIO');
        let fieldRelatorio = widgetFiltro.getField('RELATORIO');

        if (idsisdos == 3) {
            fieldCalendario.setValue('S');
            fieldCalendario.readOnly = true;
            fieldRelatorio.defaultValue = 'CMP03812.BIRT';
        } else {
            fieldCalendario.setValue('N');
            fieldCalendario.readOnly = false;
            fieldRelatorio.dataSource.data.pop();
            fieldRelatorio.value('CMP03800.BIRT');
        }
    }
    
    this.onChangeNumPrevia = function(widget) {
        const fieldProdutoInicial = widget.getField('NMPRODINICIAL');
        const fieldProdutoFinal = widget.getField('NMPRODFINAL');
        const fieldUnidade = widget.getField('NMFILIAL');
        const fieldDataEntrega = widget.getField("DTENTREGA");
        const fieldMantem = widget.getField("MANTERPRODQTZERO");
        const fieldCalendario = widget.getField("CALENDARIO");
        
        if (widget.currentRow.NRNECECOMP) {
            const fieldNumPrevia = widget.getField('NRNECECOMP');
            
            delete fieldProdutoInicial.validations;
            delete fieldProdutoFinal.validations;
            delete fieldUnidade.validations;
    
            const dadosPrevia = retornaDadosPrevia(fieldNumPrevia, widget.currentRow.NRNECECOMP);
                
            fieldNumPrevia.setValue(dadosPrevia.NRNECECOMP);
            fieldNumPrevia.defaultValue = dadosPrevia.NRNECECOMP;
            
            fieldMantem.readOnly = true;
            fieldCalendario.readOnly = true;
            
            fieldMantem.setValue("S");
            fieldCalendario.setValue("N");
                
            widget.currentRow.NRNECECOMP = dadosPrevia.NRNECECOMP;
            widget.currentRow.DTENTREGA.start = widget.currentRow.DTINI ? widget.currentRow.DTINI.substr(0, 10) : dadosPrevia.DTINI.substr(0, 10) ? dadosPrevia.DTINI.substr(0, 10) : '';
            widget.currentRow.DTENTREGA.formattedStart = widget.currentRow.DTINI ? widget.currentRow.DTINI.substr(0, 10) : dadosPrevia.DTINI.substr(0, 10) ? dadosPrevia.DTINI.substr(0, 10) : '';
            widget.currentRow.DTENTREGA.end = widget.currentRow.DTFIN ? widget.currentRow.DTFIN.substr(0, 10) : dadosPrevia.DTFIN.substr(0, 10) ? dadosPrevia.DTFIN.substr(0, 10) : '';
            widget.currentRow.DTENTREGA.formattedEnd = widget.currentRow.DTFIN ? widget.currentRow.DTFIN.substr(0, 10) : dadosPrevia.DTFIN.substr(0, 10) ? dadosPrevia.DTFIN.substr(0, 10) : '';
            widget.currentRow.NMFILIAL = widget.currentRow.NMFILNECECMP ? widget.currentRow.NMFILNECECMP : '';
            widget.currentRow.CDFILIAL = widget.currentRow.CDFILNECECMP ? widget.currentRow.CDFILNECECMP : '';
            widget.currentRow.CDPRODFINAL = '';
            widget.currentRow.NMPRODFINAL = '';
            widget.currentRow.CDARVPRODFINAL = '';
            widget.currentRow.CDPRODINICIAL = '';
            widget.currentRow.NMPRODINICIAL = '';
            widget.currentRow.CDARVPRODINICIAL = '';
        } else {
            fieldDataEntrega.setValue({
               "start": moment().format('L'),
               "end": moment().format('L'),
               "formattedStart": moment().format('L'),
               "formattedEnd": moment().format('L')
            });
            
            widget.currentRow.DTENTREGA = {
                "start": moment().format('L'),
                "formattedStart": moment().format('L'),
                "end": moment().format('L'),
                "formattedEnd": moment().format('L')
            };
            
            fieldDataEntrega.reload();
            
            fieldProdutoInicial.validations = {
                'required': true
            };
            
            fieldProdutoFinal.validations = {
                'required': true
            };
            
            fieldUnidade.validations = {
                'required': true
            };
            
            fieldMantem.readOnly = false;
            fieldCalendario.readOnly = false;
            
            fieldMantem.setValue("S");
            fieldCalendario.setValue("N");
        }
    };
    
    this.setCustomFilter = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = [];
    };
    
    this.setDataSourceFilter = function(args) {
        filtrar(args);
    };

    function filtrar(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = templateManager.container.getWidget('FILIAIS');
        widget.currentRow = row;
        
        if (widget.isValid()) {
            if (row.NRNECECOMP) {
                self.criaDataSourceFiliais(args, row.NRNECECOMP);
            } else {
                if (validaData(row.DTENTREGA.start, row.DTENTREGA.end)) {
                    self.calculaPrevisaoConsumo(widget, row, args);
                }
            }
            setStripeValues(row);
        }
    }

    function retornaDadosPrevia(fieldNumPrevia, numPrevia) {
        const dataNumPrevia = fieldNumPrevia.dataSource.data;
        let dadosPrevia = dataNumPrevia.filter(function(previa) {
            return previa.NRNECECOMP === numPrevia;
        });
    
        return dadosPrevia.length ? dadosPrevia[0] : dadosPrevia;
    }

    function aplicaConsideraEstoque(widgetFiltro, idsconestnec) {
        let fieldConsideraEsoque = widgetFiltro.getField('CONSIDERAEST');

        if (idsconestnec == 'S') {
            fieldConsideraEsoque.label = ScreenService.i18n('Considera Estoque da Unidade');
            fieldConsideraEsoque.setValue(ScreenService.i18n('Considera Estoque da Unidade'));
        } else {
            fieldConsideraEsoque.label = ScreenService.i18n('Não Considera Estoque da Unidade');
            fieldConsideraEsoque.setValue(ScreenService.i18n('Não Considera Estoque da Unidade'));
        }
    }

    function defineFiltroSubgrupo(widgetFiltro, cdgrupprod) {
        widgetFiltro.getField('CDSUBGRPROD').dataSourceFilter = [{
                "operator": "ORDER_BY",
                "name": [{
                    "name": "CDSUBGRPROD",
                    "direction": "ASC"
                }]
            },
            {
                "name": "P_CDGRUPPROD",
                "operator": "=",
                "value": cdgrupprod
            }
        ];
    }
    
    this.retornaParametrosUnidade = function() {
        const widgetFiltro = templateManager.container.getActiveWidget();
        const cdfilial = widgetFiltro.currentRow.CDFILIAL;

        if (cdfilial) {
            General.callRestEngine('cmp_necessidadeCompras#/retornaParcmpsupPrevia', "Row", [{
                'CDFILIAL': cdfilial
            }]).then(function(params) {
                idcalprevcon = params.dataset.parcmpsupPrevia[0].IDCALPREVCON;
                const idsconestnec = params.dataset.parcmpsupPrevia[0].IDSCONESTNEC;

                aplicaConsideraEstoque(widgetFiltro, idsconestnec);
            });
        } else {
            retornaParametros().then(function(params) {
                const parcmpsupPrevia = params[1].dataset.parcmpsupPrevia[0];
                idcalprevcon = parcmpsupPrevia.IDCALPREVCON;
            });
        }
    };

    const nomeRelatorio = {
        'CMP03800': 'Prévia Analítica',
        'CMP03801': 'Prévia Sintética',
        'CMP03812': 'Prévia Analítica-GR'
    };

    function setStripeValues(row) {
        const stripe = templateManager.container.getWidget('FILTERSTRIPE');

        stripe.currentRow.ENTREGASTRIPE = row.DTENTREGA.start + " " + 'à ' + row.DTENTREGA.end;
        stripe.currentRow.PRODUTOINI = row.NMPRODINICIAL || ScreenService.i18n('Todos');
        stripe.currentRow.PRODUTOFIN = row.NMPRODFINAL || ScreenService.i18n('Todos');
        stripe.currentRow.TIPOPREVIA = nomeRelatorio[row.RELATORIO];
        stripe.currentRow.ESTOQUE = row.CONSIDERAEST;

        if (row.MANTERPRODQTZERO == 'S') {
            stripe.getField('MANTEMPROD').label = ScreenService.i18n('Mantém produtos com quantidade zero');
        } else if (row.MANTERPRODQTZERO == 'N') {
            stripe.getField('MANTEMPROD').label = ScreenService.i18n('Não mantém produtos com quantidade zero');
        }
    }

    this.setFooterValues = function(widget) {
        widget.currentRow.QTESTAFPEND = parseFloat(widget.dataSource.data[0].QTESTAFPEND).toFixed(2).replace(".", ",");
        widget.currentRow.ETQINIDTPROCESSA = moment(widget.dataSource.data[0].DATAPROC, 'DD/MM/YYYY').format('DD/MM/YYYY') + ' ' + parseFloat(widget.dataSource.data[0].QTESTOQATUAL).toFixed(2).replace(".", ",");
        widget.currentRow.QTESTAFPANT = parseFloat(widget.dataSource.data[0].QTESTAFPANT).toFixed(2).replace(".", ",");
        widget.currentRow.QTESTAFPDEP = parseFloat(widget.dataSource.data[0].QTESTAFPDEP).toFixed(2).replace(".", ",");
        widget.currentRow.CONSUMOATE = moment(widget.dataSource.data[0].DTCONSATE, 'DD/MM/YYYY').format('DD/MM/YYYY') + ' ' + parseFloat(widget.dataSource.data[0].QTCONATEPREN).toFixed(2).replace(".", ",");
        widget.currentRow.CONSUMOSEG = moment(widget.dataSource.data[0].DTENTRNECCMP, 'DD/MM/YYYY').add(widget.dataSource.data[0].NRDIASEGPROD - 1, 'days').format('DD/MM/YYYY') + ' ' + parseFloat(widget.dataSource.data[0].QTCONSANTECI).toFixed(2).replace(".", ",");
    };

    function validaData(dtInicial, dtFinal) {
        var dataInicial = dtInicial ? moment(dtInicial, 'DD/MM/YYYY')._d : null;
        var dataFinal = dtFinal ? moment(dtFinal, 'DD/MM/YYYY')._d : null;
        var dtProcessamento = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        if (dataInicial < dtProcessamento || dataFinal < dtProcessamento) {
            MessageService.showMessageByCode("DTINIC_MENOR_DTPROC");
            return false;
        }
        return true;
    }

    this.voltarEntrega = function(nomeWidget) {
        const widPrevia = templateManager.container.getWidget(nomeWidget);

        ScreenService.closeSwipe().then(function() {
            widPrevia.activate();
        });
    };

    this.voltarProduto = function() {
        ScreenService.closeSwipe().then(function() {
            templateManager.container.getWidget('FILIAIS').activate();
        });
    };

    this.cancel = function(widget) {
        General.widgetCancelForm(widget);
    };

    function produtoAnalitico(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica) {
        const widgetProdutoAnalitico = templateManager.container.getWidget('PRODUTOS');
        const filialRow = widgetFiliais.currentRow;
        const filterRow = widgetFiliais.appliedFilter.FILTER_ROW;

        widgetProdutoAnalitico.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filialRow.CDFILNECECMP ? filialRow.CDFILNECECMP : null
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filialRow.NRNECECOMP
            },
            {
                "name": "P_CDSUBGRUPO",
                "operator": "=",
                "value": filterRow.CDSUBGRPROD ? filterRow.CDSUBGRPROD : null
            },
            {
                "name": "P_CDPRODINI",
                "operator": "=",
                "value": filterRow.CDPRODINICIAL
            },
            {
                "name": "P_CDPRODFIN",
                "operator": "=",
                "value": filterRow.CDPRODFINAL ? self.validaProdutoFinal(filterRow) : null
            },
            {
                "name": "P_TCDPRODUTO",
                "operator": "=",
                "value": filterRow.CDPRODINICIAL && filterRow.CDPRODFINAL ? null : 'T'
            },
            {
                "name": "P_DTINICIAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_DTFINAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_TDATA",
                "operator": "=",
                "value": 'T'
            },
            {
                "name": "P_CDGRUPPROD",
                "operator": "=",
                "value": filterRow.CDSUBGRPROD ? filterRow.CDSUBGRPROD : null
            }
        ];

        widgetProdutoAnalitico.reload().then(function() {
            ScreenService.openSwipe(tabbedPreviaAnalitica);

            tabbedPreviaSintetica.showAsTab = false;
            tabbedPreviaAnaliticaGR.showAsTab = false;

            tabbedPreviaAnalitica.activate();
            widgetProdutoAnalitico.activate();
        });
    }

    function produtoSintetico(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica) {
        const widgetProdutoSintetico = templateManager.container.getWidget('PRODUTOSINT');
        const filtroRow = widgetFiliais.appliedFilter.FILTER_ROW;
        const filialRow = widgetFiliais.currentRow;

        widgetProdutoSintetico.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filialRow.CDFILNECECMP ? filialRow.CDFILNECECMP : null
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filialRow.NRNECECOMP
            },
            {
                "name": "P_CDSUBGRUPO",
                "operator": "=",
                "value": filtroRow.CDSUBGRPROD ? filtroRow.CDSUBGRPROD : null
            },
            {
                "name": "P_CDPRODINI",
                "operator": "=",
                "value": filtroRow.CDPRODINICIAL
            },
            {
                "name": "P_CDPRODFIN",
                "operator": "=",
                "value": filtroRow.CDPRODFINAL ? self.validaProdutoFinal(filtroRow) : null
            },
            {
                "name": "P_TCDPRODUTO",
                "operator": "=",
                "value": filtroRow.CDPRODINICIAL && filtroRow.CDPRODFINAL ? null : 'T'
            },
            {
                "name": "P_DTINICIAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_DTFINAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_TDATA",
                "operator": "=",
                "value": 'T'
            },
            {
                "name": "P_CDGRUPPROD",
                "operator": "=",
                "value": filtroRow.CDSUBGRPROD ? filtroRow.CDSUBGRPROD : null
            }
        ];

        widgetProdutoSintetico.reload().then(function() {
            ScreenService.openSwipe(tabbedPreviaSintetica);

            tabbedPreviaAnalitica.showAsTab = false;
            tabbedPreviaAnaliticaGR.showAsTab = false;

            tabbedPreviaSintetica.activate();
            widgetProdutoSintetico.activate();
        });
    }

    function produtoAnaliticoGR(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica) {
        const widgetProdutoAnaliticoGR = templateManager.container.getWidget('PRODUTOSGR');
        const filialRow = widgetFiliais.currentRow;

        widgetProdutoAnaliticoGR.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filialRow.CDFILNECECMP ? filialRow.CDFILNECECMP : null
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filialRow.NRNECECOMP
            }
        ];

        widgetProdutoAnaliticoGR.reload().then(function() {
            ScreenService.openSwipe(tabbedPreviaAnaliticaGR);

            tabbedPreviaAnalitica.showAsTab = false;
            tabbedPreviaSintetica.showAsTab = false;

            tabbedPreviaAnaliticaGR.activate();
            widgetProdutoAnaliticoGR.activate();
        });
    }

    this.validaProduto = function(prodInicial, prodFinal) {
        if (prodInicial && prodFinal) {
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    };
    
    this.setProductIntervalFilterOnFilterPopup = function(args, field) {
        var filterPopupCurrentRow = args.row;
        if (!(this.validaProduto(filterPopupCurrentRow.CDARVPRODINICIAL, filterPopupCurrentRow.CDARVPRODFINAL))) {
            filterPopupCurrentRow.CDPRODFINAL = '';
            filterPopupCurrentRow.NMPRODFINAL = '';
            filterPopupCurrentRow.CDARVPRODFINAL = '';
            filterPopupCurrentRow.CDPRODINICIAL = '';
            filterPopupCurrentRow.NMPRODINICIAL = '';
            filterPopupCurrentRow.CDARVPRODINICIAL = '';
        }
    };
    
    this.executaProceNeccesidadeCompras = function(widget, args) {
        widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
        widget.currentRow.TCDFILIAL = "";

        if (widget.currentRow.CALENDARIO == 'S') {
            General.callRestEngine('cmp_necessidadeCompras#/procePeriodicidadeNaoCalculada', "Row", widget.currentRow).then(function() {
                proceNecessidadeCompras(widget, args);
            });
        } else {
            proceNecessidadeCompras(widget, args);
        }
    };

    function proceNecessidadeCompras(widget, args) {
        return General.callRestEngine('cmp_necessidadeCompras#/proceNecessidadeCompras', "Row", widget.appliedFilter.FILTER_ROW).then(function(callback) {
            NRNECECOMP = callback.dataset.response[0];
            self.criaDataSourceFiliais(args, NRNECECOMP);
        });
    }

    this.verifyMaxValue = function(field) {
        var widget = field.widget;
        var maxValue = '999.99';
        var fieldValue = angular.copy(field.value());
        if (typeof(fieldValue) == 'string') {
            fieldValue = fieldValue.split('.').join('');
            fieldValue = fieldValue.replace(',', '.');
        }

        if (fieldValue && parseFloat(fieldValue) > parseFloat(maxValue)) {
            widget.currentRow.PEACRESCIMO = '';
            widget.currentRow.$error.PEACRESCIMO[0] = {
                valid: false,
                message: "Valor máximo: 999,90"
            };
        } 
    };

    this.calculaPrevisaoConsumo = function(widget, row, args) {
        const messageCode = 'PREVIA_MSGBACK';

        General.callRestEngine('cmp_necessidadeCompras#/verifyDataLimiteSeguranca', 'Row', row).then(function(calback) {
            const params = { PARAMETRO: calback.dataset.resposta.DATSEGU};
            
            row.DATFIMSEGU = calback.dataset.resposta.DATSEGU;
            MessageService.getMessageByCode('cmp#' + messageCode).then(function (message) {
                row.MSGBACK = message;
                if (idcalprevcon !== 'N') {
                    if (idcalprevcon == 'S') {
                        MessageService.confirmMessageByCode("cmp#PREVIA_CALC_PREVISAO_ENTRE_DATAS", params, 'question').then(function(success) {
                            General.callRestEngine('cmp_necessidadeCompras#/GetProceConsPlan', 'Row', row).then(function(result) {
                                if (!result.dataset.resposta.MSG) {
                                    self.executaProceNeccesidadeCompras(widget, args);
                                } else {
                                    ScreenService.showMessage(result.dataset.resposta.MSG);
                                }
                            }.bind());
                        }, function(error) {
                            self.executaProceNeccesidadeCompras(widget, args);
                        });
                    } else {
                        General.callRestEngine('cmp_necessidadeCompras#/GetProceConsPlan', 'Row', row).then(function(result) {
                            if (!result.dataset.resposta.MSG) {
                                self.executaProceNeccesidadeCompras(widget, args);
                            } else {
                                ScreenService.showMessage(result.dataset.resposta.MSG);
                            }
                        }.bind());
                    }
                } else {
                    self.executaProceNeccesidadeCompras(widget, args);
                }
            }).catch(function () {
                ScreenService.showMessage(messageCode, 'ERROR', null);
            });
        });
    };
    
    this.criaDataSourceFiliais = function(args, NRNECECOMP) {
        const widgetFiliais = templateManager.container.getWidget('FILIAIS');
        const row = args.e.preference.FILTER_ROW;
        
        widgetFiliais.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL ? row.CDFILIAL : null
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": NRNECECOMP
            },
            {
                "name": "P_CDSUBGRUPO",
                "operator": "=",
                "value": row.CDSUBGRPROD ? row.CDSUBGRPROD : null
            },
            {
                "name": "P_CDPRODINI",
                "operator": "=",
                "value": row.CDPRODINICIAL ? row.CDPRODINICIAL : null
            },
            {
                "name": "P_CDPRODFIN",
                "operator": "=",
                "value": row.CDPRODFINAL ? self.validaProdutoFinal(row) : null
            },
            {
                "name": "P_TCDPRODUTO",
                "operator": "=",
                "value": row.CDPRODINICIAL && row.CDPRODFINAL ? null : 'T'
            },
            {
                "name": "P_DTINICIAL",
                "operator": "=",
                "value": row.DTENTREGA ? row.DTENTREGA.start : null
            },
            {
                "name": "P_DTFINAL",
                "operator": "=",
                "value": row.DTENTREGA ? row.DTENTREGA.end : null
            },
            {
                "name": "P_TDATA",
                "operator": "=",
                "value": row.DTENTREGA ? null : 'T'
            },
            {
                "name": "P_CDGRUPPROD",
                "operator": "=",
                "value": row.CDSUBGRPROD ? row.CDSUBGRPROD : null
            }
        ];

        ScreenService.closePopup();
        widgetFiliais.reload();
        widgetFiliais.activate();
    };

    this.filtrarEntregaAnalit = function() {
        const tabbedEntrega = templateManager.container.getWidget('ENTREGA');

        const widgetEntrega = templateManager.container.getWidget('ENTREGAGRID');
        const widgetFiltro = templateManager.container.getWidget('FILIAIS');

        const filtroRow = widgetFiltro.currentRow;
        const filialRow = templateManager.container.getWidget('FILIAIS').currentRow;
        const produtosRow = templateManager.container.getWidget('PRODUTOS').currentRow;

        widgetEntrega.dataSourceFilter = [{
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filialRow.CDFILNECECMP
            },
            {
                "name": "P_CDPRODNECCMP",
                "operator": "=",
                "value": produtosRow.CDPRODNECCMP
            },
            {
                "name": "FILIPROC",
                "operator": "=",
                "value": filtroRow.CDFILIAL
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filialRow.NRNECECOMP
            },
            {
                "name": "P_DTINICIAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_DTFINAL",
                "operator": "=",
                "value": null
            },
            {
                "name": "P_TDATA",
                "operator": "=",
                "value": 'T'
            }
        ];

        widgetEntrega.reload().then(function() {
            ScreenService.openSwipe(tabbedEntrega);
            tabbedEntrega.activate();
            widgetEntrega.activate();
        });

    };

    this.afterMoveRowProdutosGR = function() {
        filtrarEntregaGR();
        preencheFooterGR();
    };

    function filtrarEntregaGR() {
        const tabbedEntregaGR = templateManager.container.getWidget('ENTREGAGR');

        const widgetEntregaGR = templateManager.container.getWidget('ENTREGAGRIDGR');

        const filialRow = templateManager.container.getWidget('FILIAIS').currentRow;
        const produtosRowGR = templateManager.container.getWidget('PRODUTOSGR').currentRow;

        widgetEntregaGR.dataSourceFilter = [{
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filialRow.CDFILNECECMP
            },
            {
                "name": "P_CDPRODNECCMP",
                "operator": "=",
                "value": produtosRowGR.CDPRODNECCMP
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filialRow.NRNECECOMP
            }
        ];

        widgetEntregaGR.reload().then(function() {
            ScreenService.openSwipe(tabbedEntregaGR);
            tabbedEntregaGR.activate();
            widgetEntregaGR.activate();
        });

    }

    this.openDetalhamento = function(widget) {
        ScreenService.openSwipe(widget.container.getWidget("DETALHAMENTO"));
        widget.container.getWidget("DETALHAMENTO").activate();
    };

    this.openSintetico = function(widget) {
        ScreenService.openSwipe(widget.container.getWidget("SINTETICO"));
        widget.container.getWidget("SINTETICO").activate();
    };

    this.selecionaRelatorio = function(args) {
        const widgetFiliais = templateManager.container.getWidget('FILIAIS');
        const tabbedPreviaAnalitica = templateManager.container.getWidget('previaAnaliticaTabbed');
        const tabbedPreviaAnaliticaGR = templateManager.container.getWidget('previaAnaliticaGrTabbed');
        const tabbedPreviaSintetica = templateManager.container.getWidget('previaSinteticaTabbed');
        const reportName = widgetFiliais.appliedFilter.FILTER_ROW.RELATORIO.split('.').shift();
        
        switch (reportName) {
            case 'CMP03800':
                produtoAnalitico(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica);
                break;

            case 'CMP03801':
                produtoSintetico(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica);
                break;

            case 'CMP03812':
                produtoAnaliticoGR(widgetFiliais, tabbedPreviaAnalitica, tabbedPreviaAnaliticaGR, tabbedPreviaSintetica);
                break;

            default:
                return false;
        }
    };

    function formataQuantidadeAComprar(quantidade, sufixo) {
        return typeof quantidade === 'number' ? quantidade.toFixed(2).replace(".", ",") + ' ' + sufixo : quantidade;
    }

    this.preencheEntregaGridGR = function(widget) {
        widget.dataSource.data.forEach(function(row) {
            if (row.IDENTFORPERI === 'S') {
                row.IDINFODATA = '*';
                row.QTESTNEGATIV = '-';
                row.QTCONSANTECI = '-';
                row.QTASERENTREG = '-';
                row.QTPRCNVCOMPR = '-';
                row.IDINFOCOMPRA = '-';
            } else if (row.IDENTFORPERI === 'N') {
                row.IDINFODATA = '';
                row.QTESTINICIAL = row.QTESTNEGATIV;
                row.QTASERENTREG = row.QTASERENTREG;
                row.QTPRCNVCOMPR = row.QTPRCNVCOMPR;
                row.IDINFOCOMPRA = row.SGUNIDADESTO;
                if ((row.QTESTNEGATIV - row.QTCONSANTECI) < 0) {
                    row.QTCONSANTECI = 0;
                } else {
                    row.QTCONSANTECI = (row.QTESTNEGATIV - row.QTCONSANTECI);
                }
            }
            row.DTENTRNECCMP = moment(row.DTENTRNECCMP, 'DD/MM/YYYY').format('DD/MM/YYYY') + ' ' + row.IDINFODATA;
            row.QTPRCNVCOMPR = formataQuantidadeAComprar(row.QTPRCNVCOMPR, row.IDINFOCOMPRA);
        });
    };

    this.preencheEntregaGrid = function(widget) {
        widget.dataSource.data.forEach(function(row) {
            row.QTPRCNVCOMPR = formataQuantidadeAComprar(row.QTPRCNVCOMPR, row.SGUNIDADESTO);
        });
    };

    self.validaProdutoFinal = function(row) {
        var aux = 'ZZZZZZZZZZZZZZZZZZZZ';
        var str = row.CDPRODFINAL;
        var produto = str + aux.substr(0, aux.length - str.length);
        return produto;
    };

    function preencheFooterGR() {
        const widgetFooterGR = templateManager.container.getWidget('FOOTERGR');

        const cdprodneccmp = templateManager.container.getWidget('PRODUTOSGR').getField('CDPRODNECCMP').value();
        const nrnececomp = templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').value();
        const cdfilial = templateManager.container.getWidget('FILIAIS').getField('CDFILNECECMP').value();

        widgetFooterGR.dataSourceFilter = [{
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": cdfilial
            },
            {
                "name": "P_CDPRODNECCMP",
                "operator": "=",
                "value": cdprodneccmp
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": nrnececomp
            }
        ];

        widgetFooterGR.reload();
    }

    this.criaRelatorio = function(widget) {
        const widFiliais = templateManager.container.getWidget('FILIAIS');
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const reportRow = {};
        const reportFormat = [
            {
				name: "PDF",
				value: "PDF"
			},
			{
				name: "XLS",
				value: "XLSX"
			},
			{
			    name: "RTF",
			    value: "rtf"
			},
			{
				name: "TXT",
				value: "TXT"
			}   
        ];
        
        reportRow.STRATEGY          = filterRow.STRATEGY ? filterRow.STRATEGY : filterRow.RELATORIO.split(".")[1];
        reportRow.DATAINI           = filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null;
        reportRow.DATAFIN           = filterRow.DTENTREGA ? filterRow.DTENTREGA.end : null;
        reportRow.CDFILIAL          = widFiliais.currentRow.CDFILNECECMP;
        reportRow.FILIPROC          = widFiliais.currentRow.CDFILNECECMP;
        reportRow.NRORG             = widget.currentRow.NRORG;
        reportRow.NRNECECOMP        = widget.currentRow.NRNECECOMP;
        reportRow.MANTERPRODQTZERO  = filterRow.MANTERPRODQTZERO;
        
        
        if (widget.isValid()) {
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportRow, filterRow.RELATORIO], reportFormat);
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        const widgetBackup = templateManager.container.getActiveWidget().lastActiveWidget;
        
        /**
         * @workaround
         * A sequencia de 'activate':
         * - FILIAIS
         * - ENTREGAGRID
         * - widgetBackup
         * é para forçar que a lastWidget seja a widget pai do field de 
         * relatório (widget 'FILIAIS'), de forma que a função beforeOpenReport
         * seja acionada corretamente conforme esperado pelo fluxo do ReportDecorator.
         */
        templateManager.container.getWidget('FILIAIS').activate();
        templateManager.container.getWidget('ENTREGAGRID').activate();
        
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        
        General.openReport('cmp_necessidadeCompras#/cmp03800_relatorio', reportName, row);
        
        widgetBackup.activate();
    }.bind(this);
    
    this.backActionOpenFilter = function(args) {
        const widgetFiltro = templateManager.container.getWidget('FILIAIS');
        const rowsToSet = {};
        
        ZhFilterPreferences.openFilterWidget(widgetFiltro, rowsToSet).then(function(opened) {
            return opened;
        });
    };
    
    this.onChangeRelatorio = function(field) {
        const filtro = templateManager.container.getActiveWidget();
        const action = filtro.getAction("never");
        if(action.label === "Apply filter" || action.label === "Exportar relatório") {
            if(filtro.currentRow.RELATORIO) {
                if(filtro.currentRow.RELATORIO.split('.')[1] === "QR2") {
                    action.label = "Exportar relatório";
                    action.events[0].code = "Cmp03800PreviaDoCalculoDaNecessidadeDeCompras_Controller.applyReportExportFilter(args); Utilities.saveCollectedDataGeneric(args.owner, 'Prévia do Cálculo de Necessidade de Compras', false);";
                } else {
                    action.label = "Apply filter";
                    action.events[0].code = "ZhFilterCreateFilterConditionsController.applyFilter(args.owner.widget); Utilities.saveCollectedDataGeneric(args.owner, 'Prévia do Cálculo de Necessidade de Compras', false);";
                }
            }
        }
        filtro.activate();
    };
    
    this.applyReportExportFilter = function(args) {
        const filtroWidget = templateManager.container.getActiveWidget();
        const filtroRow    = filtroWidget.currentRow;
        
        if (filtroWidget.isValid()) {
            if (filtroRow.NRNECECOMP) {
                this.createDatasourcePincipalPreviaCalc(args, filtroRow);
            } else {
                if (validaData(filtroRow.DTENTREGA.start, filtroRow.DTENTREGA.end)) {
                    this.calcPrevConsReport(filtroWidget, filtroRow, args);
                }
            }
        }
    };
    
    this.createDatasourcePincipalPreviaCalc = function(args, filtroRow) {
        const filterData = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filtroRow.CDFILIAL ? filtroRow.CDFILIAL : null
            },
            {
                "name": "P_NRNECECOMP",
                "operator": "=",
                "value": filtroRow.NRNECECOMP
            },
            {
                "name": "P_CDSUBGRUPO",
                "operator": "=",
                "value": filtroRow.CDSUBGRPROD ? filtroRow.CDSUBGRPROD : null
            },
            {
                "name": "P_CDPRODINI",
                "operator": "=",
                "value": filtroRow.CDPRODINICIAL ? filtroRow.CDPRODINICIAL : null
            },
            {
                "name": "P_CDPRODFIN",
                "operator": "=",
                "value": filtroRow.CDPRODFINAL ? self.validaProdutoFinal(filtroRow) : null
            },
            {
                "name": "P_TCDPRODUTO",
                "operator": "=",
                "value": filtroRow.CDPRODINICIAL && filtroRow.CDPRODFINAL ? null : 'T'
            },
            {
                "name": "P_DTINICIAL",
                "operator": "=",
                "value": filtroRow.DTENTREGA ? filtroRow.DTENTREGA.start : null
            },
            {
                "name": "P_DTFINAL",
                "operator": "=",
                "value": filtroRow.DTENTREGA ? filtroRow.DTENTREGA.end : null
            },
            {
                "name": "P_TDATA",
                "operator": "=",
                "value": filtroRow.DTENTREGA ? null : 'T'
            },
            {
                "name": "P_CDGRUPPROD",
                "operator": "=",
                "value": filtroRow.CDSUBGRPROD ? filtroRow.CDSUBGRPROD : null
            }
        ];
        General.callRestEngine("cmp_necessidadeCompras#/crud/gridPrincipalPreviaCalc", "FilterData", filterData).then((success) => {
            if(success.dataset.gridPrincipalPreviaCalc.length == 0) {
                MessageService.showMessageByCode("PREVIA_NAO_RETORNOU_DADOS");
            } else {
                this.createReport(filtroRow, success.dataset.gridPrincipalPreviaCalc[0]);
            }
        }).catch((error) => {
            console.log(error);
        });
    };
    
    this.createReport = function(filterRow, datasetRow) {
        const reportRow = {};
        const widget = templateManager.container.getActiveWidget();
        const filialWidget = templateManager.container.getWidget("FILIAIS");
        const reportFormat = [
            {
				name: "PDF",
				value: "PDF"
			},
			{
				name: "XLS",
				value: "XLSX"
			},
			{
			    name: "RTF",
			    value: "rtf"
			},
			{
				name: "TXT",
				value: "TXT"
			}   
        ];
        
        reportRow.STRATEGY          = filterRow.STRATEGY ? filterRow.STRATEGY : filterRow.RELATORIO.split('.')[1];
        reportRow.DATAINI           = filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null;
        reportRow.DATAFIN           = filterRow.DTENTREGA ? filterRow.DTENTREGA.end : null;
        reportRow.CDFILIAL          = datasetRow.CDFILNECECMP ? datasetRow.CDFILNECECMP : filterRow.CDFILIAL;
        reportRow.FILIPROC          = datasetRow.CDFILNECECMP ? datasetRow.CDFILNECECMP : filterRow.CDFILIAL;
        reportRow.NRORG             = datasetRow.NRORG;
        reportRow.NRNECECOMP        = datasetRow.NRNECECOMP;
        reportRow.MANTERPRODQTZERO  = filterRow.MANTERPRODQTZERO;
        
        if(widget.isValid())
            General.openReportPopup(filialWidget, this.openReport, [filialWidget, reportRow, filterRow.RELATORIO.split('.')[0]], reportFormat);
    };
    
    this.openReport = function(widget, row, reportName) {
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        
        General.openReport('cmp_necessidadeCompras#/cmp03800_relatorio', reportName, row).then(success => {
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NRNECECOMP").setValue("");
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("CALENDARIO").readOnly = false;
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("MANTERPRODQTZERO").readOnly = false;
        }).catch(error => {
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NRNECECOMP").setValue("");
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("CALENDARIO").readOnly = false;
            templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("MANTERPRODQTZERO").readOnly = false;
        });
    };
    
    this.calcPrevConsReport = function(widget, row, args) {
        const messageCode = 'PREVIA_MSGBACK';

        General.callRestEngine('cmp_necessidadeCompras#/verifyDataLimiteSeguranca', 'Row', row).then(function(calback) {
            const params = { PARAMETRO: calback.dataset.resposta.DATSEGU };
            
            row.DATFIMSEGU = calback.dataset.resposta.DATSEGU;
            MessageService.getMessageByCode('cmp#' + messageCode).then(function (message) {
                row.MSGBACK = message;
                if (idcalprevcon !== 'N') {
                    if (idcalprevcon == 'S') {
                        MessageService.confirmMessageByCode("cmp#PREVIA_CALC_PREVISAO_ENTRE_DATAS", params, 'question').then(function(success) {
                            General.callRestEngine('cmp_necessidadeCompras#/GetProceConsPlan', 'Row', row).then(function(result) {
                                if (!result.dataset.resposta.MSG) {
                                    self.proceNeceComReport(widget, args);
                                } else {
                                    ScreenService.showMessage(result.dataset.resposta.MSG);
                                }
                            }.bind());
                        }, function(error) {
                            self.proceNeceComReport(widget, args);
                        });
                    } else {
                        General.callRestEngine('cmp_necessidadeCompras#/GetProceConsPlan', 'Row', row).then(function(result) {
                            if (!result.dataset.resposta.MSG) {
                                self.proceNeceComReport(widget, args);
                            } else {
                                ScreenService.showMessage(result.dataset.resposta.MSG);
                            }
                        }.bind());
                    }
                } else {
                    self.proceNeceComReport(widget, args);
                }
            }).catch(function () {
                ScreenService.showMessage(messageCode, 'ERROR', null);
            });
        });
    };
    
    this.proceNeceComReport = function(widget, args) {
      widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
        widget.currentRow.TCDFILIAL = "";

        if (widget.currentRow.CALENDARIO == 'S') {
            General.callRestEngine('cmp_necessidadeCompras#/procePeriodicidadeNaoCalculada', "Row", widget.currentRow).then(function() {
                funcProceNeceComprasReport(widget, args);
            });
        } else {
            funcProceNeceComprasReport(widget, args);
        }  
    };
    
    function funcProceNeceComprasReport(widget, args) {
        return General.callRestEngine('cmp_necessidadeCompras#/proceNecessidadeCompras', "Row", widget.currentRow).then(function(callback) {
            widget.currentRow.NRNECECOMP = callback.dataset.response[0];
            self.createDatasourcePincipalPreviaCalc(args, widget.currentRow);
        });
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp03800PreviaDoCalculoDaNecessidadeDeCompras_Controller', Cmp03800PreviaDoCalculoDaNecessidadeDeCompras_Controller);
});

// FILE: ./assets/modules/necessidadeCompras/assets/js/controllers/NecessidadeDeComprasController.js
var NecessidadeDeComprasController = function (ScreenService, General, restEngine, templateManager, ZHPromise, CalculoDaNecessidadeDeComprasController, MessageService) {
    
    var self = this;
    var boAltNece;
    
    const permissionsArray = {
        "INCLUIR_PRODUTO"       : false,
        "EXCLUIR_PRODUTO"       : false,
        "ALTERAR_PRODUTO"       : false,
        "AUMENTAR_QUANTIDADE"   : false,
        "DIMINUIR_QUANTIDADE"   : false,
        "INCLUIR_DTENTREGA"     : false,
        "EXCLUIR_DTENTREGA"     : false,
        "ALTERAR_DTENTREGA"     : false,
        "percentAumentar"       : undefined,
        "percentDiminuir"       : undefined
    };
    
    var parasupri;
    
    this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS = "_CHECK_ALL_ROWS";
    
    this.voltar = function(widget) {
        General.backOrCancel(widget);
    };
    
    this.back = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.setCheckedRows = function(widget) {
        widget.updateCheckedRows();
    };
    
    this.defineNivelProduto = function(widgetProduto) {
        
        var mascaraProduto = getLocalVar('CDPICTPROD');
        var fieldProduto = widgetProduto.getField('NMPRODUTO');
        
        mascaraProduto = mascaraProduto.split('.');
        var nivelProduto = mascaraProduto.length;
        
        fieldProduto.dataSourceFilter.forEach(function(filtro) {
            if(filtro.name == 'CDNVPRODUTO')
                filtro.value = nivelProduto;
        });
        
    };
   
    
    /**
     * Cria um parâmetro no templateManger e atribui o valor recebido
     * como parâmetro.
     * 
     * @param {string} parameterName - nome do parâmetro que será
     * criado no templateManager.
     * 
     * @param {*} value - valor que será atribuido ao parâmetro criado
     * no templateManager.
    */
    this.setParameterOnTemplateManager = function(parameterName, value) {
        templateManager[parameterName] = value;
    };
    
    /**
     * Marca todas as linhas da widget recebida
     * como parâmetro.
     * 
     * @param {object} widget - widget que terá
     * todas as linhas marcadas.
    */
    this.checkAllRowsOnWidget = function(widget) {
        var widgetDataSource = widget.dataSource;
        
        widgetDataSource.addCheckedRows(widgetDataSource.data);
        widgetDataSource.updateCheckedRows();
        
        this.verifyPermissionsAfterSelect(widget);
    };
    
    function insereProduto(rowProduto, produtosNecessidade) {
        produtosNecessidade.push(rowProduto);
    }
    
    this.openSwipeProduto = function(widget) {
        var widgetProduto = widget.container.getWidget("insereProduto");
        const checkedRows = widget.getCheckedRows();
        
        ScreenService.openSwipe(widgetProduto);
        
        widgetProduto.newRow();
        widgetProduto.currentRow.__is_new = true;
        
        if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
            if(permissionsArray.INCLUIR_PRODUTO) {
                widgetProduto.getField("NMPRODUTO").readOnly = false;
            } else {
                widgetProduto.getField("NMPRODUTO").readOnly = true;
                
                if(checkedRows.length == 1) {
                    widgetProduto.currentRow.CDPRODUTO = checkedRows[0].CDPRODUTO;
                    widgetProduto.currentRow.CDARVPROD = checkedRows[0].CDARVPROD;
                    widgetProduto.currentRow.NMPRODUTO = checkedRows[0].NMPRODUTO;
                } else if(widget.dataSource.data[0]) {
                    widgetProduto.currentRow.CDPRODUTO = widget.dataSource.data[0].CDPRODUTO;
                    widgetProduto.currentRow.CDARVPROD = widget.dataSource.data[0].CDARVPROD;
                    widgetProduto.currentRow.NMPRODUTO = widget.dataSource.data[0].NMPRODUTO;
                }
            }
            if(permissionsArray.INCLUIR_DTENTREGA) {
                widgetProduto.getField("DTENTRNECCMP").readOnly = false;
            } else {
                widgetProduto.getField("DTENTRNECCMP").readOnly = true;
                
                if(checkedRows.length == 1) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(checkedRows[0].DTENTRNECCMP, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.dataSource.data[0]) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.dataSource.data[0].DTENTRNECCMP, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.DTINI) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.DTINI, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else if(widget.DTFIM) {
                    widgetProduto.currentRow.DTENTRNECCMP = moment(widget.DTFIM, "DD/MM/YYYY").format("DD/MM/YYYY");
                } else {
                    widgetProduto.currentRow.DTENTRNECCMP = moment().format("DD/MM/YYYY");
                }
            }
        } else {
            widgetProduto.getField("NMPRODUTO").readOnly = false;
            widgetProduto.getField("DTENTRNECCMP").readOnly = false;
        }
        
        widgetProduto.activate();
    };
    
    function checkProdAtivo(row) {
        var deferred = ZHPromise.defer();
        
        General.callRestEngine('cmp_necessidadeCompras#/checkProdAtivo','Row',row).then(function(calback) {
            if(calback.dataset.resposta.length != 0){
                if(calback.dataset.resposta[0].IDPRODATIV !== 'A'){
                    deferred.reject(ScreenService.i18n("O produto está inativo para a unidade."));
                } else if(calback.dataset.resposta[0].IDPRODATIVPR !== 'S'){
                    deferred.reject(ScreenService.i18n("O produto está inativo!"));
                } else {
                    deferred.resolve();
                }
            } else {
                deferred.reject(ScreenService.i18n("O produto está inativo!"));
            }
        });
        
        return deferred;
    }
    
    function checkProdNeceComp(rowProduto, produtosNecessidade) {
        var cdproduto = rowProduto.CDPRODUTO;
        var dtentrneccmp = rowProduto.DTENTRNECCMP;
        var existeProduto = produtosNecessidade.filter(function(produto) {
            return cdproduto === produto.CDPRODUTO && dtentrneccmp.substr(0,10) === produto.DTENTRNECCMP.substr(0,10);
        });
        
        if(existeProduto.length) {
            throw ScreenService.i18n("O Produto já foi incluído para a data informada!");
        }
    }
    
    function validaData(dtini, dtfim, dtentrega) {
        dtini = moment(dtini, 'DD/MM/YYYY');
        dtfim = moment(dtfim, 'DD/MM/YYYY');
        dtentrega = moment(dtentrega, 'DD/MM/YYYY');
        
        return dtentrega.isBetween(dtini, dtfim, undefined, '[]');
    }
    
    this.salvaProduto = function(widgetProduto) {
        var widgetNecessidade = widgetProduto.container.getWidget('gridNeceComp');
        var produtosNecessidade = widgetNecessidade.dataSource.data;
        var rowProduto = widgetProduto.currentRow;
        
        rowProduto.CDFILIAL         = widgetNecessidade.CDFILIAL;
        rowProduto.NRNECECOMP       = widgetNecessidade.NECECOMP;
        rowProduto.DTPRIUTIPROD     = rowProduto.DTENTRNECCMP;
        rowProduto.QTPRCNVCOMPRBKP  = rowProduto.QTPRCNVCOMPR;
        
        if(widgetProduto.isValid() && validaData(widgetNecessidade.DTINI, widgetNecessidade.DTFIM, rowProduto.DTENTRNECCMP)) {
            checkProdAtivo(rowProduto).then(function() {
                
                checkProdNeceComp(rowProduto, produtosNecessidade);
                
                insereProduto(rowProduto, produtosNecessidade);
                
                ScreenService.closeSwipe();
                
                widgetNecessidade.activate();
                widgetNecessidade.dataSource.addCheckedRows(produtosNecessidade);
                widgetNecessidade.updateCheckedRows();
                
                self.verifyPermissionsAfterSelect(widgetNecessidade);
                
            }).catch(function(error) {
                ScreenService.showMessage(error);
            });
        } else {
            MessageService.showMessageByCode("DT_FORA_PER");
        }
    };
    
    this.salvaQuantidade = function(widgetNecessidade) {
        widgetNecessidade.commitInlineEdit();
        widgetNecessidade.ALTERADO = true;
    };
    
    /**
     * Verifica se o parâmetro, referente a widget recebida como
     * parâmetro, no templateManager permite que todas as linhas da
     * widget sejam marcadas, se permitir, todas as linhas são marcadas
     * e logo após, o parâmetro é definido como "false", pois pela regra
     * de negócio, está rotina é realizada apenas uma vez.
     * 
     * @param {object} widget - widget que terá suas linhas marcadas.
    */
    this.checkAllWidgetRowsByTemplateManagerParam = function(widget){
        
        var parameterName = widget.name + this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS;
        
        if(Boolean(templateManager[parameterName])){
            
            this.checkAllRowsOnWidget(widget);
            this.setParameterOnTemplateManager(parameterName, false);
            
        }    
        
    };
    
    /**
     * define "true" para os parâmetros que indicam se as widgets
     * de detalhes terão todas as linhas selecionadas.
    */
    this.defineParamToCheckAllDetailsWidgetsRows = function(){
        
        var widget =  this.getWidgetOnCurrentContainerByName("gridNeceComp");
        var parameterName = widget.name + this.PARAM_COMPLEMENT_TO_CHECK_ALL_ROWS;
        this.setParameterOnTemplateManager(parameterName, true);

    };
    
    /**
     * Retorna a widget com o nome recebido como parâmetro do container
     * ativo.
     * 
     * @param {string} widgetName - nome da widget a ser retornada.
     * 
     * @param {object} widget encontrada.
    */
    this.getWidgetOnCurrentContainerByName = function(widgetName){
        return templateManager.container.getWidget(widgetName);
    };
    
    this.openDetalhesProduto = function(widget){
        ScreenService.openSwipe(widget.container.getWidget("detalhesProduto"));
        if(widget.container.getWidget("detalhesProduto").dataSourceFilter[3] == undefined){
            widget.container.getWidget("detalhesProduto").dataSourceFilter.push(    			
                    {
        				'name': 'CDPRODNECCMP',
        				'operator': '=',
        				'value': widget.currentRow.CDARVPROD
        			}
        	);
        }else{
            widget.container.getWidget("detalhesProduto").dataSourceFilter.pop();
            widget.container.getWidget("detalhesProduto").dataSourceFilter.push(    			
                    {
        				'name': 'CDPRODNECCMP',
        				'operator': '=',
        				'value': widget.currentRow.CDARVPROD
        			}
        	);
        }
        widget.container.getWidget("detalhesProduto").reload();
        widget.container.getWidget("detalhesProduto").activate();
    };
    
    this.voltarCalculo = function(widget) {
        
        var widgetData = widget.dataSource.data;
        var calculationWindowName = "cmp_necessidadeCompras#calculo_da_necessidade_de_compras";
        
        this.defineParamToCheckAllDetailsWidgetsRows();
        
        if(widgetData.length){
            
            var row = [widgetData[0].NRNECECOMP];
            
            General.callRestEngine('cmp_necessidadeCompras#/deleteNececomp','Row',row).then(function(calback) {
                ScreenService.openWindow(calculationWindowName).then(function() {
                    delete templateManager.containers['cmp_necessidadeCompras#necessidade_de_compras'];
                });
            });
            
        } else {
            ScreenService.openWindow(calculationWindowName).then(function() {
                delete templateManager.containers['cmp_necessidadeCompras#necessidade_de_compras'];
            });
        }
        
	};
    
    this.gerarSolicitacao = function(widget) {
        var produtosSelecionados = widget.getCheckedRows();
        
        if(produtosSelecionados.length > 0 ) {
            var produtosNaoZerados = produtosSelecionados.filter(value => value.QTPRCNVCOMPR === "0,000");
            
            if(produtosNaoZerados.length > 0) {
                ScreenService.confirmMessage('Concluir processo\n Obs.: Produtos com quantidades zeradas serão excluídos, deseja continuar?', 'question', function() {
                    ScreenService.confirmMessage('Deseja gerar a solicitação?', 'question', function(success) {
                        var extra = CalculoDaNecessidadeDeComprasController.getExtra();
                        var nececomp = widget.dataSource.data[0].NRNECECOMP;
                        var msg = ScreenService.i18n('Cálculo da Necessidade de Compras-Extra');
                        var filnececomp = widget.CDFILIAL;
                        var row = {'PRODUTOS': produtosNaoZerados, 'NRNECECOMP': nececomp, 'CDFILNECECMP': filnececomp, 'EXTRA': extra, 'MENSAGEM': msg};
                       
                       General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp', 'Row', row).then(function(response) {
                           MessageService.showMessageByCode("SOLCMP_SUCCESS").then(() => {
                               self.openPreviaCalculoNecessidadeCompras(nececomp);
                           });
                        }.bind()).catch(function(error) {
                            MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
                        });
                    });
                });
            } else {
                ScreenService.confirmMessage('Deseja gerar a solicitação?', 'question', function(success) {
                    var extra = CalculoDaNecessidadeDeComprasController.getExtra();
                    var nececomp = widget.dataSource.data[0].NRNECECOMP;
                    var msg = ScreenService.i18n('Cálculo da Necessidade de Compras-Extra');
                    var filnececomp = widget.CDFILIAL;
                    var allProducts = widget.dataSource.data;
                    var row = {'PRODUTOS': allProducts, 'NRNECECOMP': nececomp, 'CDFILNECECMP': filnececomp, 'EXTRA': extra, 'MENSAGEM': msg};
                   
                   General.callRestEngine('cmp_necessidadeCompras#/GetPrxSoliComp', 'Row', row).then(function(response) {
                       MessageService.showMessageByCode("SOLCMP_SUCCESS").then(() => {
                           self.openPreviaCalculoNecessidadeCompras(nececomp);
                       });
                    }.bind()).catch(function(error) {
                        MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
                    });
                });
            }
        } else{
            MessageService.showMessageByCode("NO_DATA_GER_SOL");
        }
        
    };
    
    this.setVisibilidade = function(args) {
       var widgetNeceComp = args.owner.getWidget('gridNeceComp');
       
       General.callRestEngine('cmp_necessidadeCompras#/getPermissoes', 'Row', {}).then(function(callback) {
            const permissoes = callback.dataset.permissoes;
            
            if(permissoes) {
                permissoes.forEach(function (value) {
                    permissionsArray[value.IDAUTNECECOMP] = true;
                    
                    if(value.IDAUTNECECOMP === 'AUMENTAR_QUANTIDADE') {
                        permissionsArray.percentAumentar = value.PEALTEQTDESOLI;
                    }
                    if(value.IDAUTNECECOMP === 'DIMINUIR_QUANTIDADE') {
                        permissionsArray.percentDiminuir = value.PEALTEQTDESOLI;
                    }
                });
            }
            
            General.callRestEngine('cmp_necessidadeCompras#/retornaParasupriNececomp', 'Row', []).then(function(response) {
                parasupri = response.dataset.parasupri.length ? response.dataset.parasupri[0] : false;
                
                if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                    widgetNeceComp.getField('QTPRCNVCOMPR').inlineEditable = permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE;
                    if(permissionsArray.INCLUIR_PRODUTO && permissionsArray.INCLUIR_DTENTREGA) {
                        widgetNeceComp.getAction('incluir').isVisible = true;
                    } else {
                        widgetNeceComp.getAction('incluir').isVisible = false;
                    }
                    widgetNeceComp.getAction('excluir').isVisible = permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA;
                } else {
                    widgetNeceComp.getField('QTPRCNVCOMPR').inlineEditable = true;
                    widgetNeceComp.getAction('incluir').isVisible = true;
                    widgetNeceComp.getAction('excluir').isVisible = true;
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("ERROR_FOUND", "ERROR");
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.openPreviaCalculoNecessidadeCompras = function(numeroPrevia) {
        ScreenService.openWindow('cmp_necessidadeCompras#cmp03800_previa_do_calculo_da_necessidade_de_compras').then(function() {
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').setValue(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').value(numeroPrevia);
            templateManager.container.getWidget('FILIAIS').getField('NRNECECOMP').defaultValue = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = numeroPrevia;
            templateManager.container.getWidget('FILIAIS').NRNECECOMP = numeroPrevia;
            
            General.callRestEngine('cmp_necessidadeCompras#/crud/numPrevia', 'FilterData', {}).then(function(response) {
                const dataNumPrevia = response.dataset.numPrevia;
                let dadosPrevia = dataNumPrevia.filter(function(previa) {
                    return previa.NRNECECOMP === numeroPrevia;
                });
                dadosPrevia = dadosPrevia.length ? dadosPrevia[0] : dadosPrevia;
                
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').setValue({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').value({
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                });
                templateManager.container.getWidget('FILIAIS').getField('DTENTREGA').defaultValue = {
                   "start": dadosPrevia.DTINI.substr(0, 10),
                   "end": dadosPrevia.DTFIN.substr(0, 10),
                   "formattedStart": dadosPrevia.DTINI.substr(0, 10),
                   "formattedEnd": dadosPrevia.DTINI.substr(0, 10)
                };
                templateManager.container.getWidget('FILIAIS').currentRow.NRNECECOMP = dadosPrevia.NRNECECOMP;
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.start = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.end = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedStart = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTENTREGA.formattedEnd = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTINI = dadosPrevia.DTINI.substr(0, 10);
                templateManager.container.getWidget('FILIAIS').currentRow.DTFIN = dadosPrevia.DTFIN.substr(0, 10);
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODINICIAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMPRODFINAL').validations;
                delete templateManager.container.getWidget('FILIAIS').getField('NMFILIAL').validations;
            });
        });
    };
    
    this.onQuantityChangeVerifyPermissions = function(args) {
        const widget = args.owner.field.widget;
        
        if((permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA) && widget.currentRow.QTPRCNVCOMPR_inline === "0,000") {
            widget.commitInlineEdit();
            widget.list();
        } else if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
            if(!widget.currentRow.QTPRCNVCOMPRBKP)
                widget.currentRow.QTPRCNVCOMPRBKP = widget.currentRow.QTPRCNVCOMPR.toString();
                
            if(typeof(widget.currentRow.QTPRCNVCOMPRBKP) != "string")
                widget.currentRow.QTPRCNVCOMPRBKP = widget.currentRow.QTPRCNVCOMPRBKP.toString();
            
            var percentToBlock;
            var newQTPRCNVCOMPR = widget.currentRow.QTPRCNVCOMPR_inline.replaceAll('.', '').replaceAll(',', '.');
            var oldQTPRCNVCOMPR = widget.currentRow.QTPRCNVCOMPRBKP.replaceAll('.', '').replaceAll(',', '.');
            
            newQTPRCNVCOMPR = parseFloat(newQTPRCNVCOMPR);
            oldQTPRCNVCOMPR = parseFloat(oldQTPRCNVCOMPR);
            
            if(permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE) {
                if((newQTPRCNVCOMPR > oldQTPRCNVCOMPR) && permissionsArray.AUMENTAR_QUANTIDADE) {
                    if(permissionsArray.percentAumentar != null || permissionsArray.percentAumentar != undefined) {
                        percentToBlock = oldQTPRCNVCOMPR + (oldQTPRCNVCOMPR * (parseFloat(permissionsArray.percentAumentar) / 100));
                        
                        if(newQTPRCNVCOMPR > percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MAIOR_PERCENT");
                            widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                        }
                    }
                } else if((newQTPRCNVCOMPR < oldQTPRCNVCOMPR) && permissionsArray.DIMINUIR_QUANTIDADE) {
                    if(permissionsArray.percentDiminuir != null || permissionsArray.percentDiminuir != undefined) {
                        percentToBlock = oldQTPRCNVCOMPR - (oldQTPRCNVCOMPR * (parseFloat(permissionsArray.percentDiminuir) / 100));
                        
                        if(newQTPRCNVCOMPR < percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MENOR_PERCENT");
                            widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                        }
                    }
                } else if(newQTPRCNVCOMPR == oldQTPRCNVCOMPR) {
                    return;
                } else {
                    MessageService.showMessageByCode("WITHOUT_PERMISSION");
                    widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                }
            } else {
                MessageService.showMessageByCode("WITHOUT_PERMISSION");
                widget.currentRow.QTPRCNVCOMPR_inline = oldQTPRCNVCOMPR;
                widget.rollbackInlineEdit();
                widget.list();
            }
        }
    };
    
    this.excluirProduto = function(widget) {
        if(parasupri.IDBLOQALTNEC === 'S') {
            if(permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA) {
                MessageService.confirmMessageByCode("DELETE_ITEMS").then(confirmed => {
                    var listaProdutos = widget.dataSource.data.filter(function(row) {
                        return row.__isSelected != true;
                    });
                    
                    widget.dataSource.clearCheckedRows();
                    widget.dataSource.data = listaProdutos;
                });
            } else {
                MessageService.showMessageByCode("WITHOUT_PERMISSION");
            }
        } else {
            MessageService.confirmMessageByCode("DELETE_ITEMS").then(confirmed => {
                var listaProdutos = widget.dataSource.data.filter(function(row) {
                    return row.__isSelected != true;
                });
                
                widget.dataSource.clearCheckedRows();
                widget.dataSource.data = listaProdutos;
            });
        }
    };
    
    this.verifyPermissionsAfterSelect = function(widget) {
        const checkedRows = widget.getCheckedRows();
        
        if(checkedRows.length == 1) {
            if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                widget.getAction('incluir').isVisible = permissionsArray.INCLUIR_PRODUTO || permissionsArray.INCLUIR_DTENTREGA;
            } else {
                widget.getAction('incluir').isVisible = true;
            }
        } else {
            if(parasupri && parasupri.IDBLOQALTNEC === 'S') {
                widget.getAction('incluir').isVisible = false;
            } else {
                widget.getAction('incluir').isVisible = true;
            }
        }
    };
};

Configuration(function (ContextRegister) {
	ContextRegister.register('NecessidadeDeComprasController', NecessidadeDeComprasController);
});

// FILE: ./assets/modules/cadastros/assets/js/controllers/cmp00100ProdutoPorFornecedorController.js
function cmp00100ProdutoPorFornecedorController(General, ScreenService,MessageService, metaDataFactory, templateManager, restEngine,ZhFilterPreferences, maskEngine, ZhUtil) {
    /*global Constants*/
    
    var self = this;
    
    this.setDataSourceFilter = function(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": row.CDFORNECED
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		self.setStripeValues(widget);
		
		widget.getAction('CADAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
		widget.getAction('ALTERAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
		
		widget.reload();
		widget.activate();
    };
    
    this.setStripeValues = function(widget) {
        const stripe = templateManager.container.getWidget('stripe');
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const mask = {
			type: "CPFCNPJ",
			params: {}
		};
        
        stripe.currentRow.NRINSJURFORN = Util.applyMask(filterRow.NRINSJURFORN, mask, maskEngine, ZhUtil);
        stripe.currentRow.NMFANTFORN = filterRow.NMFANTFORN;
        
        stripe.reload();
    };
    
    this.setFornecedorValuesWidgetExportar = function(widget) {
        if (widget.getParent().appliedFilter) {
            const widgetExportar = templateManager.container.getWidget("exportWidget");
            const currentRowWidget = widgetExportar.currentRow;
            const filterRow = widget.getParent().appliedFilter.FILTER_ROW;
            
            currentRowWidget.CDFORNECEDORIG   = filterRow.CDFORNECED;
            currentRowWidget.NRINSJURFORNORIG = filterRow.NRINSJURFORN;
            currentRowWidget.NMRAZSOCFORNORIG = filterRow.NMRAZSOCFORN;
            
            self.setFornDestDataFilter(widgetExportar);
        }
    };
    
    this.setReadOnlyFields = function(widget, arrayFields, value) {
        for (let field of arrayFields) {
            widget.getField(field).readOnly = value;
        }
    };
    
    this.setIsVisibleFields = function(widget, arrayFields, value) {
        for (let field of arrayFields) {
            widget.getField(field).isVisible = value;
        }
    };
    
    this.setFornDestDataFilter = function(widget) {
    	const arrayFields = ['NMRAZSOCFORNDEST', 'NMPRODINI', 'NMPRODFIN'];
    	
    	if (widget.currentRow.NMRAZSOCFORNORIG.length > 0) {
    	    self.setReadOnlyFields(widget, arrayFields, false);
    	    
    	    widget.getField('NMRAZSOCFORNDEST').dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    	} else {
    	    self.setReadOnlyFields(widget, arrayFields, true);
    	}
    };
    
    this.openSubGridFilter = function(widget) {
        const subGridwidget = templateManager.container.getWidget('atendidaSubGrid');
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(subGridwidget);
        
        subGridwidget.dataSourceFilter = [
        	{
        		"name": "P_SGESTADO",
		        "operator": "=",
		        "value": currentRowWidget.SGESTADO	
        	},
        	{
        		"name": "P_CDMUNICIPIO",
		        "operator": "=",
		        "value": currentRowWidget.CDMUNICIPIO	
        	},
        	{
        		"name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidget.CDFORNECED	
        	},
        	{
        		"name": "P_CDPAIS",
		        "operator": "=",
		        "value": currentRowWidget.CDPAIS	
        	}
        ];
    };
    
    this.openFormSubGrid = function(widget) {
        const formSubGridwidget = templateManager.container.getWidget('formSubGrid');
        const currentRowSubGridWidget = formSubGridwidget.currentRow;
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(formSubGridwidget).then(function(success) {
        	formSubGridwidget.edit();
        });
        
        currentRowSubGridWidget.CDFILIAL   = currentRowWidget.CDFILIAL;
        currentRowSubGridWidget.NMFILIAL   = currentRowWidget.NMFILIAL;
        currentRowSubGridWidget.CDPERIENTR = currentRowWidget.CDPERIENTR;
        currentRowSubGridWidget.NMPERIENTR = currentRowWidget.NMPERIENTR;
    };
    
    this.saveProduto = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            currentRowWidget.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
            currentRowWidget.NRORG = getLocalVar('NRORG');
            currentRowWidget.CDFORNORIG = null;
            currentRowWidget.CDMARCA = null;
            currentRowWidget.ARRED = 'P';
            
        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveProduto','Row', currentRowWidget).then(function(res) {
        	   currentRowWidget = {};
        	   MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	   ScreenService.closePopup();
        	   widget.getParent().reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.saveProdutoNvlCompleto = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            const currentRowWidProdutos = widget.container.getWidget('produtos').currentRow;
            
            currentRowWidget.VRPERPIPRFO = currentRowWidget.VRPERPIPRFO ? currentRowWidget.VRPERPIPRFO : null;
            currentRowWidget.VRARREDCMPFO = currentRowWidget.VRARREDCMPFO ? currentRowWidget.VRARREDCMPFO : null;
            currentRowWidget.CDEXPRODFORN = currentRowWidget.CDEXPRODFORN ? currentRowWidget.CDEXPRODFORN : null;
            currentRowWidget.VRARREDEMPE = currentRowWidget.VRARREDEMPE ? currentRowWidget.VRARREDEMPE : null;
            currentRowWidget.VRPERVARPREPRFO = currentRowWidget.VRPERVARPREPRFO ? currentRowWidget.VRPERVARPREPRFO : null;
            currentRowWidget.NRDIASVALPRFORN = currentRowWidget.NRDIASVALPRFORN ? currentRowWidget.NRDIASVALPRFORN : null;
            currentRowWidget.CDPRODCOMPL = currentRowWidget.CDPRODUTO;
            
            currentRowWidget.CDFORNECED = currentRowWidProdutos.CDFORNECED;
            currentRowWidget.CDPRODUTO = currentRowWidProdutos.CDPRODUTO;
            currentRowWidget.NRORG = getLocalVar('NRORG');
                        
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveProdutoNvlCompleto','Row', currentRowWidget).then(function(res) {
                currentRowWidget = {};
                ScreenService.closeSwipe().then(function(success){
                    widget.reload();
                    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.deleteProduto = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function(success) {
            let produtoArray = [];
            
            widget.dataSource.data.forEach(function(produto) {
                if (produto.__isSelected) {
                    produtoArray.push(produto);
                }
            });

        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/deleteProduto','Row', produtoArray).then(function(res) {
                widget.unSelectAll();
                widget.reload();
                MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.exportProduto = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.CDFORNECEDDEST = currentRowWidget.CDFORNECEDDEST ? Array.isArray(currentRowWidget.CDFORNECEDDEST) ? currentRowWidget.CDFORNECEDDEST : 'T' : 'T';
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	if (widget.getField('TODOS').checked) {
        	    currentRowWidget.EXPROD = 'T';
        	} else if (widget.getField('INTERPROD').checked) {
        	    currentRowWidget.EXPROD = 'I';
        	} else {
        	    currentRowWidget.EXPROD = null;
        	}
        	
            currentRowWidget.CDARVPRODFIN = self.preencheCaracterDireta(currentRowWidget.CDARVPRODFIN);
            
        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/exportProduto','Row', currentRowWidget).then(function(res) {
        	    ScreenService.closePopup();   
        	    widget.getParent().reload();
        	    MessageService.showMessageByCode("EXPORT_SUCCESS");
        	    
                currentRowWidget.NMPRODFIN = "";
                currentRowWidget.NMPRODINI = "";
                currentRowWidget.NMRAZSOCFORNDEST = "";
                currentRowWidget.NMRAZSOCFORNORIG = "";
                currentRowWidget.TODOS = "N";
                currentRowWidget.ARRENDEMP = "N";
                currentRowWidget.INTERPROD = "N";
                
                MessageService.successNotificationByCode("EXPORT_SUCCESS");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.generateReport = function(widget){
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
        	const reportName = widget.currentRow.REPORT;
        	
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	currentRowWidget.CDFORNECED = currentRowWidget.CDFORNECED ? Array.isArray(currentRowWidget.CDFORNECED) ? currentRowWidget.CDFORNECED : 'T' : 'T';
        	
        	General.openReportPopup(widget, self.abreRelatorio, [widget, currentRowWidget, reportName]);
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/generateReport', reportName, row).then(function(success) {
            row.NMPRODINI = "";
            row.NMPRODFIN = "";
            row.CDARVPRODINI = "";
            row.CDARVPRODFIN = "";
            row.CDPRODINI = "";
            row.CDPRODINI = "";
            row.CDFORNECED = "";
            row.NMRAZSOCFORN = "";
            row.NRINSJURFORN = "";
            row.FORNECEDOR = "";
        });
    };
    
    this.controlaCheckBox = function(field) {
        let otherField = "";
        
        if (field.name == 'TODOS') {
            otherField = field.widget.getField('INTERPROD');
        } else {
            otherField = field.widget.getField('TODOS');
        }
        
        if (field.checked) {
            otherField.checked = false;
        } else {
            field.checked = false;
        }
    };
    
    this.setDataSourceNvlCompleto = function(widget) {
    	const currentRowWidProdutos = widget.container.getWidget('produtos').currentRow;
    	
	    widget.dataSourceFilter = [
		    {
		        "name": "P_CDPRODUTO",
		        "operator": "=",
		        "value": currentRowWidProdutos.CDPRODUTO
		    },
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidProdutos.CDFORNECED
		    }
		];
		
		widget.reload();
    };
    
    this.controlaProdField = function(field) {
        const getFieldProduto = field.widget.getField('NMPRODUTO');
        const currentRowWidget = field.widget.currentRow;
        
        getFieldProduto.readOnly = field.checked ? false : true;
        
        if (getFieldProduto.readOnly == true) {
            currentRowWidget.NMPRODUTO = "";
        } else {
            currentRowWidget.CDPRODUTO = (currentRowWidget.CDPRODUTO && Array.isArray(currentRowWidget.NMPRODUTO)) ? currentRowWidget.NMPRODUTO : 'T';
        }
    };
    
    
    this.addFilial = function(widget) {
        if (widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtendida'));
            MessageService.showMessageByCode("NECE_FORN_FILTER");
        } else {
            self.openChildWidgets(widget, 0);
        }
    };
    
    this.backSwipe = function(args) {
    	args.owner.widget.currentRow = {};
    	ScreenService.closePopup();
    };
    
    this.backPopup = function(widget) {
    	const nameWidget = widget.name;
    	widget.currentRow = {};
    	
    	if (nameWidget == templateManager.container.getWidget('reportWidget').name) {
    	    widget.currentRow.REPORT = "CMP00301";
    	}
    	
    	ScreenService.closePopup();
    };
    
    this.editSwipe = function(widget) {
    	General.widgetEdit(widget);
    };
    
    this.openFormSwipe = function(widget) {
        const widTabSwipe = templateManager.container.getWidget('tabSwipe');
        const widModoPagamento = templateManager.container.getWidget('modopagamento');
        const widProdutoNivelCompleto = templateManager.container.getWidget('produtosNvlCompleto');
        
        const currentRowWidget = widget.currentRow;
        const currentRowWidPagamento = templateManager.container.getWidget('pagamento').currentRow;
        
        widProdutoNivelCompleto.enabled = true;
        widModoPagamento.list();
        
        self.setFieldsOpcaoPagamentoWidPrin(widget);
        
        ScreenService.openSwipe(widTabSwipe).then(function(success) {
            currentRowWidPagamento.QTMINAF = currentRowWidget.QTMINAF;
            currentRowWidPagamento.SGUNIDADE = currentRowWidget.SGUNIDADE;
            currentRowWidPagamento.QTDIASENTR = currentRowWidget.QTDIASENTR;
            currentRowWidPagamento.IDTPFORPGTFO = currentRowWidget.IDTPFORPGPRF;
            currentRowWidPagamento.NRDIAPGFIXFO = currentRowWidget.NRDIAPGFIPRF;
            currentRowWidPagamento.NRPARCPGTOFO = currentRowWidget.NRPARCPGTPRF;
            currentRowWidPagamento.IDUTDIAPGTFO = currentRowWidget.IDUTDIAPGPRF;
            currentRowWidPagamento.NMFORMPGTO = currentRowWidget.NMFORMPGTO;
            
            self.setDataSourceNvlCompleto(widProdutoNivelCompleto);
            self.setFieldsOpcaoPagamento(widget);
            self.setGridPagamento(widget);
            
            widTabSwipe.widgets[0].activate();
        });
    };
    
    this.openChildWidgets = function(widget, widNumber) {
        ScreenService.openPopup(widget.widgets[widNumber]).then(function(success){
        	widget.widgets[widNumber].edit();
        }); 
    };
    
    this.setDefaultFornecedorCadAuto = function (widget) {
        let parentWidgetFilterRow = widget.getParent().appliedFilter.FILTER_ROW;
        let row = widget.currentRow;
        
        row.NMFANTFORN = [parentWidgetFilterRow.NMFANTFORN];
        row.CDFORNECED = [parentWidgetFilterRow.CDFORNECED];
        row.NRINSJURFORN = [parentWidgetFilterRow.NRINSJURFORN];
        row.IDTPIJURFORN = [parentWidgetFilterRow.IDTPIJURFORN];
        row.NMRAZSOCFORN = [parentWidgetFilterRow.NMRAZSOCFORN];
    };
    
    this.cadProduto = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.NRORG = getLocalVar('NRORG');
            
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/cadProdAuto','Row', currentRowWidget).then(function(res){
        	    currentRowWidget.CDFORNECED = "";
        	    currentRowWidget.NMPRODINI = "";
        	    currentRowWidget.NMPRODFIN = "";
        	    
        	    ScreenService.closePopup();
        	    widget.getParent().reload();
        	    MessageService.successNotificationByCode("OPR_SUCCESS");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.alterProduto = function(widget) {
        let currentRowWidget = widget.currentRow;
        const currentRowWidProdutos = widget.container.getWidget('produtos').dataSource.getCheckedRows();
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
            currentRowWidget.VRARREDCMPFO = currentRowWidget.VRARREDCMPFO ? currentRowWidget.VRARREDCMPFO : 0;
            currentRowWidget.PIDSV = currentRowWidget.PIDSV ? currentRowWidget.PIDSV : 0;
            currentRowWidget.EMPENHO = currentRowWidget.EMPENHO ? currentRowWidget.EMPENHO : 0;
            currentRowWidget.VARIAMAXIMO = currentRowWidget.VARIAMAXIMO ? currentRowWidget.VARIAMAXIMO : 0;
            currentRowWidget.VALIDADEDIAS = currentRowWidget.VALIDADEDIAS ? currentRowWidget.VALIDADEDIAS : 0;
            currentRowWidget.CDPRODUTO = (currentRowWidget.CDPRODUTO && widget.getField('NMPRODUTO').readOnly == false && Array.isArray(currentRowWidget.NMPRODUTO)) ? currentRowWidget.NMPRODUTO : 'T'; 
            currentRowWidget.NRORG = getLocalVar('NRORG');
            
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/altProdAuto','Row', currentRowWidget).then(function(res){
        	    if(res.dataset.prodNaoCadastradoForn.prodCadastrado == true){
        	        MessageService.showMessageByCode("PRODNAOCADASTRADO");
        	    } else {
            	    ScreenService.closePopup();   
            	    ScreenService.closePopup();   
            	    MessageService.showMessageByCode("TRANSFERENCIA_ALTER_AUT");
            	    
            	    currentRowWidget.NMPRODINI = "";
            	    currentRowWidget.CDPRODINI = "";
            	    currentRowWidget.CDARVPRODINI = "";
            	    currentRowWidget.NMPRODFIN = "";
            	    currentRowWidget.CDPRODFIN = "";
            	    currentRowWidget.CDARVPRODFIN = "";
            	    currentRowWidget.NMPRODUTO = "";
            	    currentRowWidget.CONSIDERA = "";
                    currentRowWidget.CDFORNECED = "";
                    currentRowWidget.VRARREDCMPFO = "";
                    currentRowWidget.PIDSV = "";
                    currentRowWidget.EMPENHO = "";
                    currentRowWidget.VARIAMAXIMO = "";
                    currentRowWidget.VALIDADEDIAS = "";
                    currentRowWidget.CDPRODUTO = "";
                    currentRowWidget = {};
                    
                    widget.getField('NMPRODUTO').readOnly = true;
            	    widget.getField('CONSIDERA').checked = false;
            	    widget.getParent().reload();
            	    
            	    MessageService.successNotificationByCode("OPR_SUCCESS");
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    }; 
    
    this.saveFormaPagamento = function(widget) {
        if (widget.getParent().isValid()) {
            const currentRowParentWidget = widget.getParent().currentRow;
            let dataArray = [];
            
            dataArray.push(widget.dataSource.data);
            dataArray.push(currentRowParentWidget);
            
            if (currentRowParentWidget.IDTPFORPGTFO == 'V' && !dataArray[0][0]) {
                MessageService.showMessageByCode("INFO_DIAS_PRAZO_PAGMTO");
                self.openFormaPgto(widget);
            } else {
                const widProdutos = widget.container.getWidget('produtos');
                const currentRowWidProdutos = widProdutos.currentRow;
                
                currentRowParentWidget.CDFORNECED = currentRowWidProdutos.CDFORNECED;
                currentRowParentWidget.CDPRODUTO = currentRowWidProdutos.CDPRODUTO;
                currentRowParentWidget.CDFORMPGTO = currentRowParentWidget.CDFORMPGTO || currentRowWidProdutos.CDFORMPGTO;
                currentRowParentWidget.QTDIASENTR = currentRowParentWidget.QTDIASENTR || null;
                currentRowParentWidget.QTMINAF = currentRowParentWidget.QTMINAF || null;
                currentRowParentWidget.NRORG = getLocalVar('NRORG');
            
                if (currentRowParentWidget.IDTPFORPGTFO == null) {
                    currentRowParentWidget.NRPARCPGTOFO = null;
                    currentRowParentWidget.NRDIAPGFIXFO = null;
                    currentRowParentWidget.CDFORMPGTO = null;
                }
                
            	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveFormaPagamento','Row', dataArray).then(function(res){
            	    const widProdutoNivelCompleto = templateManager.container.getWidget('produtosNvlCompleto');
            	    
            	    widget.currentRow = {};
                    widget.list();
            	    widProdutos.reload();
            	    widProdutoNivelCompleto.enabled = true;
            	    
            	    self.controlFields(widget.getParent(), true);
            	    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        }
    };
    
    this.savePrazos = function(widget) {
        if (widget.isValid()) {
            const dataSet = self.montaDataSet(widget.currentRow);
            
            if (self.validaDias(dataSet) && self.validaPercentual(dataSet)) {
                const parentWidget = widget.getParent();
                
                parentWidget.dataSource.data = self.montaDataSet(widget.currentRow);
                parentWidget.edit();
                parentWidget.activate();
                
                self.closeFormaPgto(widget);
            }
        }
    };
    

    this.setCurrentRowForm = function (widget) {
        if (widget.dataSource.data.length) {
            const item = widget.dataSource.data[0];
            
            for (let prop in item) {
                if (prop != 'SGUNIDADE') {
                    widget.currentRow[prop] = item[prop];
                }
            }
        }
    };
    
    this.setFieldsOpcaoPagamento = function(widget) {
        const widgetModoPagamento = widget.container.getWidget('modopagamento');
        const widgetPagamento = widget.container.getWidget('pagamento');
        
        switch (widgetPagamento.currentRow.IDTPFORPGTFO) {
            case "V":
                widgetPagamento.currentRow.IDUTDIAPGTFO = 'E';
                self.habilitaGrid(widgetModoPagamento);
                self.formaPagamento(widgetPagamento);
                break;
                
            case "F": 
                self.initializeFieldsOpcaoPagamentoFixo(widgetPagamento);
                self.desabilitaGrid(widgetModoPagamento);
                self.pagamentoFixo(widgetPagamento);
                break;
                
            default: 
                widgetPagamento.currentRow.IDUTDIAPGTFO = 'E';
                self.desabilitaGrid(widgetModoPagamento);
                self.desabilitaFields(widgetPagamento);
                break;
        }
    };
    
    this.initializeFieldsOpcaoPagamentoFixo = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        currentRowWidget.IDUTDIAPGTFO = (currentRowWidget.IDUTDIAPGTFO != "" && currentRowWidget.IDUTDIAPGTFO != null) ? currentRowWidget.IDUTDIAPGTFO : "E";
        currentRowWidget.NRDIAPGFIXFO = (currentRowWidget.NRDIAPGFIXFO != "" && currentRowWidget.NRDIAPGFIXFO != null) ? currentRowWidget.NRDIAPGFIXFO : "1";
        currentRowWidget.NRPARCPGTOFO = (currentRowWidget.NRPARCPGTOFO != "" && currentRowWidget.NRPARCPGTOFO != null) ? currentRowWidget.NRPARCPGTOFO : "1";
    };
    
    this.setFieldsOpcaoPagamentoWidPrin = function(widget) {
        const widgetModoPagamento = widget.container.getWidget('modopagamento');
        const widgetPagamento = widget.container.getWidget('pagamento');
        
        switch (widget.currentRow.IDTPFORPGPRF) {
            case "V": 
                self.habilitaGrid(widgetModoPagamento);
                self.formaPagamento(widgetPagamento);
                break;
                
            case "F": 
                self.desabilitaGrid(widgetModoPagamento);
                self.pagamentoFixo(widgetPagamento);
                break;
                
            default: 
                self.desabilitaFields(widgetPagamento);
                self.desabilitaGrid(widgetModoPagamento);
                break;
        }
    };
    
    this.desabilitaFields = function(widget) {
        const arrayFields = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO', 'NMFORMPGTO'];
        
        self.setIsVisibleFields(widget, arrayFields, false);
    };
    
    this.habilitaGrid = function(widget) {
        widget.isVisible = true;
        widget.getAction('SAVE').isVisible = true;
        widget.getAction('ADD').isVisible = true;
    };
    
    this.desabilitaGrid = function(widget) {
        widget.isVisible = false;
        widget.getAction('SAVE').isVisible = true;
        widget.getAction('ADD').isVisible = false;
    };
    
    this.formaPagamento = function(widget) {
        const arrayFieldsFalse = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO'];
        const arrayFieldsTrue = ['NMFORMPGTO'];
        
        self.setIsVisibleFields(widget, arrayFieldsFalse, false);
        self.setIsVisibleFields(widget, arrayFieldsTrue, true);
        
        widget.getField("IDTPFORPGTFO").setValue("V");
    };
    
    this.pagamentoFixo = function(widget) {
        const arrayFieldsFalse = ['NMFORMPGTO'];
        const arrayFieldsTrue = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO'];
        
        self.setIsVisibleFields(widget, arrayFieldsFalse, false);
        self.setIsVisibleFields(widget, arrayFieldsTrue, true);
        
        //widget.getField("IDUTDIAPGTFO").setValue("E");
    };
    
    this.setWidgetEdit = function(widget) {
        const parentWidget = widget.getParent();
        
        parentWidget.backupRow = angular.copy(parentWidget.currentRow); 
        templateManager.container.getWidget('produtosNvlCompleto').enabled = false;
        
        self.controlFields(parentWidget, false);
        widget.edit();
    };
    
    this.cancelFormaPgto = function(widget) {
        const parentWidget = widget.getParent();
        
        parentWidget.currentRow = parentWidget.backupRow;
        templateManager.container.getWidget('produtosNvlCompleto').enabled = true;
        
        self.controlFields(parentWidget, true);
        widget.list();
    };
    
    this.controlFields = function(widget, boll) {
        widget.fields.forEach(function(field) {
            field.readOnly = boll;
        }); 
        
        widget.getField('NRDIAPGFIXFO').spin = !boll;
        widget.getField('NRPARCPGTOFO').spin = !boll;
    };
    
    
    this.backWidgetProduto = function(widget, boll) {
       const widProdutos = widget.container.getWidget('produtos');
       ScreenService.closeSwipe();
       widProdutos.activate();
    };
    
    this.openFormaPgto = function(widgetGrid) {
        if (templateManager.container.getWidget('pagamento').getField('NMFORMPGTO').value()) {
            const widgetForm = widgetGrid.widgets[0];
            const data = widgetGrid.dataSource.data;
            
            data.forEach(function () {
                self.createAndAppendFields(widgetForm);
            });
            
            if (widgetForm.fields.length === 0) {
                self.createAndAppendFields(widgetForm);
            }
            
            widgetForm.currentRow = self.montaRow(data, widgetGrid.getParent().currentRow.CDFORNECED);
            ScreenService.openSwipe(widgetForm);
        } else {
            MessageService.showMessageByCode("FORMA_PGTO_INFO");
        }
    };
    
    this.createAndAppendFields = function(widget) {
        widget.fields = widget.fields.concat(self.getFields(self.numRowFormPgto, widget));
        
        self.numRowFormPgto++;
        self.hideDelete(widget);
    };
    
    this.numRowFormPgto = 0;
    
    this.montaRow = function(dataSet, cdForneced) {
        const row = {};
        
        for(var i in dataSet) {
            row['VRPERCPGTOFO' + i] = dataSet[i].VRPERCPGTOFO;
            row['NRDIASPGTOFO' + i] = dataSet[i].NRDIASPGTOFO;
        }
        
        row.CDFORNECED = cdForneced;
        
        return row;
    };
    
    this.hideDelete = function(widget) {
        const field = widget.getField('BTNDELETE0');
        
        if (self.numRowFormPgto <= 1) {
            field.isVisible = false;
        } else {
            field.isVisible = true;
        }
    };
    
    this.mascaraPercentual = function (field) {
        const pos = field.value().indexOf(",");
        const vrPercPgtoCl = field.value().replace(",", ".");
        
        if (vrPercPgtoCl > 100) {
            MessageService.showMessageByCode("VALOR_MENOR_100");
            field.widget.currentRow.VRPERCPGTOCL = field.widget.backupRow.VRPERCPGTOCL;
        } else if (pos != -1) {
            field.widget.currentRow.VRPERCPGTOCL = vrPercPgtoCl;
        }
    };
    
    this.getFields = function(index, widget) {
        let fields = [];
        
        fields.push(self.getFieldDias(index));
        fields.push(self.getFieldPercent(index));
        fields.push(self.getFieldDelete(index));
        
        for(let i in fields) {
            fields[i] = metaDataFactory.factoryField(fields[i], widget);
        }
        
        return fields;
    };
    
    this.getFieldDias = function(index) {
        return {
            name: "NRDIASPGTOFO" + index,
            label: ScreenService.i18n("Número (dias)"),
            template: "field/number.html",
            validations: {
                range: {
                    min: 0,
                    max: 999
                }
            },
            mask: {
                type: "number"
            },
            events: [
                {
                    name:"FieldOnChange",
                    code:"cmp00100ProdutoPorFornecedorController.validaDiaOnChange(args.owner.field.widget)"
                }
            ],
            defaultValue: '',
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 5
        };
    };
    
    this.validaDiaOnChange = function(widget) {
        let dataSet = self.montaDataSet(widget.currentRow);
        //self.validaDias(dataSet);
    };
    
    this.validaDias = function(dataSet) {
        let validacao = self.validaDiasPrazo(dataSet);
        
        if (!validacao) {
            MessageService.showMessageByCode("CADASTRO_PRAZO_UM");
        }
        
        return validacao;
    };

    this.validaDiasPrazo = function(dataSet) {
        let dias = [];
        
        dataSet.forEach(function(row) {
            dias.push(row.NRDIASPGTOFO);
        });
        
        for(let i in dias) {
            for(let j in dias) {
                if (i !== j && dias[i] === dias[j] ) {
                    return false;
                }
            }
        }
        return true;
    };
    
    this.validaPercentual = function(dataSet) {
        let validacao = self.validaPercent(dataSet);
        
        if (!validacao) {
            MessageService.showMessageByCode("SOMA_TOTAIS_PRAZO");
        }
        return validacao;
    };
    
    this.validaPercent = function(dataSet) {
        var percent = 0.0;
        
        dataSet.forEach(function(row) {
            percent += parseFloat(row.VRPERCPGTOFO);
        });
        
        return percent === 100;
    };
    
    
    this.montaDataSet = function(currentRow) {
        let dataSet = [];
        
        for(let i = 0; i < self.numRowFormPgto; i++) {
            dataSet[i] = {};
            dataSet[i].CDFORNECED = currentRow.CDFORNECED;
            dataSet[i].VRPERCPGTOFO = currentRow['VRPERCPGTOFO' + i];
            dataSet[i].NRDIASPGTOFO = currentRow['NRDIASPGTOFO' + i];
            dataSet[i].__is_new = true;
        }
        
        return dataSet;
    };
    
    this.getFieldPercent = function(index) {
        return {
            name: "VRPERCPGTOFO" + index,
            label: ScreenService.i18n("Percentual"),
            template: "field/text-edit.html",
            validations: {
                range: {
                    min: 0,
                    max: 100
                }
            },
            "mask": {
                "type": "viewFloat",
                "params": {
                    "showSymbol": false,
                    "precision": 2,
                    "thousands": ".",
                    "decimal": ","
                }
            },
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 5
        };
    };
    
    this.getFieldDelete = function(index) {
       return {
            name: "BTNDELETE" + index,
            label: ScreenService.i18n("Excluir"),
            template: "field/label-with-icon.html",
            isVisible: true,
            icon: "trash",
            showOnList: true,
            showOnForm: true,
            events: [
                {
                    "name":"FieldOnClick",
                    "code":"cmp00100ProdutoPorFornecedorController.deleteFields(args.owner.field)"
                }
            ],
            class: 2
       }; 
    };
    
    this.deleteFields = function(fieldRemove) {
        const widget = fieldRemove.widget;
        const fields = widget.fields;
        const currentRowWidget = widget.currentRow;
        const indexDelete = Number.parseInt(fieldRemove.name.replace('BTNDELETE',''));
        
        for(let i = 0; i<fields.length; i++) {
            let index = Number.parseInt(fields[i].name.replace(/(BTNDELETE|VRPERCPGTOFO|NRDIASPGTOFO)/g,''));
            
            if (index === indexDelete) {
                Number.parseFloat(currentRowWidget[fields[i].name]);
                
                delete currentRowWidget[fields[i].name];
                
                fields.splice(i,1);
                
                i--;
            } else if (index > indexDelete) {
                let nameFieldAntigo = fields[i].name;
                
                fields[i].name = nameFieldAntigo.replace(index,index-1);
                currentRowWidget[fields[i].name] = currentRowWidget[nameFieldAntigo];
                Number.parseFloat(currentRowWidget[fields[i].name]);
                
                delete currentRowWidget[nameFieldAntigo];
            }
        }
        
        self.numRowFormPgto--;
        self.hideDelete(widget);
    };
    
    this.closeFormaPgto = function(widget) {
        widget.fields = [];
        ScreenService.goBack();
        self.numRowFormPgto = 0;
    };
    
    this.setGridPagamento = function(widget) {
        widget.container.getWidget('modopagamento').dataSourceFilter = [
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": widget.appliedFilter.FILTER_ROW.CDFORNECED
		    },
		    {
		        "name": "P_CDPRODUTO",
		        "operator": "=",
		        "value": widget.currentRow.CDPRODUTO
		    }
		];
		
	    widget.container.getWidget('modopagamento').reload();
    };
    
    /*
     * Campo para alterar a obrigatoriedade do campo de produto ao se adicionar um novo produto. 
     */
    
    this.ativarRequiredProdutos = function(widget, ativar) {
        if (ativar) {
            widget.container.getWidget('adicionaFilial').getField('NMPRODUTO').validations = {
                required: "Campo obrigatório."
            };
        } else {
            widget.container.getWidget('alterAutoWidget').getField('NMPRODUTO').validations = {}; 
        }
    };
    
    /*
     * Função para filtrar os produtos conforme o produto inicial e produto final sejam selecionados. Caso não haja 
     * seleção em ambas as partes, nenhum produto será retornado.
     */
    this.preencheCaracterDireta = function(string) {
        const pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    };
    
    this.limpaFields = function(widget) {
        widget.currentRow = {};
        widget.reload();
    };
    
    this.filtrarProdutosAlteracaoAutomatica = function(field) {
        const currentRowWidget = field.widget.currentRow;
        
        if (currentRowWidget.CDARVPRODINI && currentRowWidget.CDARVPRODFIN){
            field.widget.getField('NMPRODUTO').dataSourceFilter = [
                {
                    name: "CDPRODINI",
                    operator: "=",
                    value: currentRowWidget.CDARVPRODINI
                },
                {
                    name: "CDPRODFIN",
                    operator: "=",
                    value: self.preencheCaracterDireta(currentRowWidget.CDARVPRODFIN)
                }                
            ];
        } else {
            field.widget.getField('NMPRODUTO').dataSourceFilter = [
                {
                    name: "CDPRODINI",
                    operator: "=",
                    value: null
                },
                {
                    name: "CDPRODFIN",
                    operator: "=",
                    value: 'zzzzzzzzzz'
                }                
            ];            
        }
        
        field.reload();
    };
    
    /*
    this.verifyMaxLength = function(field, maxLength) {
        const value = field.value();
        
        if (value.toString().length > maxLength) {
            const newValue = value.toString().substr(0, maxLength);
            field.setValue(newValue);
        }
    };
    */
    
    this.verifyMaxValue = function(widget, name, maxValue) {
        let value = widget.currentRow[name];
        
        if (typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if (value && parseFloat(value) > parseFloat(maxValue)){
            widget.getField(name).clearValue();
            MessageService.showMessageByCode("VALUE_ABOVE_ALLOWED", {MAX_VALUE: maxValue}, Constants.alertMessage);
        }
    };
    
    this.verifyMinValue = function(widget, name, minValue) {
        let value = widget.currentRow[name];
        
        if (typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if (value && parseFloat(value) < parseFloat(minValue)){
            widget.getField(name).clearValue();
            MessageService.showMessageByCode("VALUE_BELOW_ALLOWED", {MIN_VALUE: minValue}, Constants.alertMessage);
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp00100ProdutoPorFornecedorController', cmp00100ProdutoPorFornecedorController);
});

// FILE: ./assets/modules/cadastros/assets/js/controllers/Cmp00500_RegiaoNaoAtendidaPeloFornecedor.js
function Cmp00500_RegiaoNaoAtendidaPeloFornecedor(General, RestEngine, ScreenService, MessageService, templateManager, ZHPromise, ZhFilterPreferences, maskEngine, ZhUtil) {
    /*global Constants*/
    var self = this;
    
    this.setDataSourceFilter = function(args) {
        var row = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        widget.dataSourceFilter = [{
            "name": "P_CDFORNECED",
            "operator": "=",
            "value": row.CDFORNECED
        }];
        self.setStripeValues(widget);

        widget.reload();
        widget.activate();
    };
    this.setValue = function(widget){
        if(!widget.currentRow.REPORT) {
            widget.currentRow.REPORT = "CMP00500";
        }
      
    };
    self.setStripeValues = function(widget) {
         var mask = {
			type: "CPFCNPJ",
			params: {}
		};
	
        var stripe = templateManager.container.getWidget('stripe');
        var filterRow = widget.appliedFilter.FILTER_ROW;

        stripe.currentRow.NRINSJURFORN = Util.applyMask(filterRow.NRINSJURFORN, mask, maskEngine, ZhUtil);
        stripe.currentRow.NMFANTFORN = filterRow.NMFANTFORN;

        stripe.reload();
    };

    this.addRegiao = function(widget) {
        if (widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtendida'));
            MessageService.showMessageByCode("NECE_FORN_FILTER");
        } else {
            ScreenService.openSwipe(widget.widgets[0]).then(function(success) {
                widget.widgets[0].edit();
            });
        }
    };
    this.saveRegiao = function(widget) {
        if (widget.isValid()) {
            const currentRow = angular.copy(widget.currentRow);
            
            currentRow.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;

            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/saveRegiao', 'DataSet', [currentRow]).then(function(res) {
                var resp = res.dataset.verificacao[0];
                if (resp == 'S') {
                    General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/verificaFilialReg', 'DataSet', [currentRow]).then(function(response) {
                        var erro = response.dataset.erro[0];
                        if (erro == 1) {
                            ScreenService.confirmMessage("Atenção! Fornecedor atende a unidades da região informada. Ao confirmar, essas unidades e a região como um todo não serão mais atendidas pelo fornecedor. Confirma a operação?", 'question', function(success) {
                                General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/insertRegiao', 'Row', currentRow).then(function(response) {
                                    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                                    widget.getParent().reload();
                                });
                                
                            }.bind(this), function(error) {});
                        }
                        else{
                            MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                        }
                    });
                }
                self.clearRow(widget);
                ScreenService.closeSwipe().then(function(success) {
                    widget.getParent().reload();
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    this.regiaoDelete = function(widget) {
        var regiaoArray = [];

        widget.dataSource.data.forEach(function(regiao) {
            if (regiao.__isSelected) {
                regiaoArray.push(regiao);
            }
        });
        ScreenService.confirmMessage("Deseja excluir o(s) registro(s) selecionado(s)?", 'question', function (success) {
            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/regiaoDelete', 'Row', regiaoArray).then(function(res) {
                widget.unSelectAll();
                widget.reload();
                MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    this.backSwipe = function(args) {
        args.owner.widget.currentRow = {};
        ScreenService.closeSwipe();
    };
    this.clearRow = function(widget) {
        widget.currentRow = {};
      
    };
    this.backPopup = function(widget) {
        self.clearRow(widget);
        if (widget.name == templateManager.container.getWidget('exportWidget').name) {
            widget.getField('NMRAZSOCFORNDEST').readOnly = true;
            widget.getField('CDREGIAO').readOnly = true;
        }

        ScreenService.closePopup();
    };
    this.openReportWidget = function(widget) {
        var relatorio = widget.container.getWidget('reporttWidget');
        ScreenService.openPopup(relatorio).then(function(success) {
            relatorio.edit();
        });
    };
    this.generateReport = function(widget) {
        if (widget.isValid()) {
            var reportName = widget.currentRow.REPORT;
            widget.currentRow.CDFORNECED2 = widget.currentRow.CDFORNECED ? Array.isArray(widget.currentRow.CDFORNECED) ? widget.currentRow.CDFORNECED.join('_') : 'T' : 'T';
            if(!widget.currentRow.CDFORNECED2 ) {
                widget.currentRow.CDFORNECED1 = ' ';
            }
            else {
                widget.currentRow.CDFORNECED1 =  widget.currentRow.CDFORNECED2;
            }
           
           
            General.openReportPopup(widget, self.abreRelatorio, [widget, widget.currentRow, reportName]);
        }
    };

    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/generateReport', reportName, row);
    };

    this.openExportWidget = function(widget) {
        widget.currentRow = widget.appliedFilter.FILTER_ROW;
        var exportar = widget.container.getWidget('exportWidget');
        if (widget.currentRow.CDFORNECED) {
                exportar.currentRow.NMRAZSOCFORNORIG = widget.currentRow.NMRAZSOCFORN;
                exportar.currentRow.CDFORNECEDORIG = widget.currentRow.CDFORNECED;
                exportar.getField('NMRAZSOCFORNDEST').readOnly = false;
                exportar.getField('CDREGIAO').readOnly = false;
                self.setFornDestDataFilter(exportar);
        }
        ScreenService.openPopup(exportar).then(function(success) {
           
            exportar.edit();


        });
    };
    this.setFornDestDataFilter = function(widget) {
        if (widget.currentRow.NMRAZSOCFORNORIG.length > 0) {

            widget.getField('NMRAZSOCFORNDEST').readOnly = false;
            widget.getField('CDREGIAO').readOnly = false;

            widget.getField('NMRAZSOCFORNDEST').dataSourceFilter = [{
                "name": "P_CDFORNECED",
                "operator": "=",
                "value": widget.currentRow.CDFORNECEDORIG
            },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMRAZSOCFORN",
                        "direction": "ASC"
                    }
                ]
            }];
            

        } else {
            widget.getField('NMRAZSOCFORNDEST').readOnly = true;
            widget.getField('CDREGIAO').readOnly = true;
        }
    };
    this.exportRegiao = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.CDFORNECEDDEST = widget.currentRow.CDFORNECEDDEST ? Array.isArray(widget.currentRow.CDFORNECEDDEST) ? widget.currentRow.CDFORNECEDDEST.join('_') : 'T' : 'T';
            widget.currentRow.CDREGIAO = widget.currentRow.CDREGIAO ? Array.isArray(widget.currentRow.CDREGIAO) ? widget.currentRow.CDREGIAO.join('_') : 'T' : 'T';
            General.callRestEngine('cmp_cadastros#/Cmp00500RegiaoNaoAtendidaPeloFornecedor/verificaExportacao', 'DataSet', [widget.currentRow]).then(function(res) {
                var resp = res.dataset.dados;
                if (Util.isEmptyObject(resp[0])) {
                    ScreenService.closePopup();
                    var widErro = templateManager.container.getWidget('erroExportacao');
                    ScreenService.showMessage('Operação bloqueada! Fornecedores atendem a unidades de uma ou mais regiões escolhidas.').then(function(success) {
                        widErro.dataSource.data = resp[1];
                        ScreenService.openPopup(widErro);
                        self.clearRow(widget);
                    });
                } else if (Util.isEmptyObject(resp[1])) {
                    ScreenService.closePopup();
                    ScreenService.showMessage(resp[0]);
                    self.clearRow(widget);
                }

            }, function(err) {
                ScreenService.showMessage(err.data.error);


            });
        }
    };

    this.editSwipe = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.setDataSourceAux = function(widget) {
        var fornec = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
        var fieldRegiao = widget.getField('CDREGIAO');
        fieldRegiao.dataSourceFilter = [{
            "name": "P_CDFORNECED",
            "operator": "=",
            "value": fornec
        }];

        fieldRegiao.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp00500_RegiaoNaoAtendidaPeloFornecedor', Cmp00500_RegiaoNaoAtendidaPeloFornecedor);
});

// FILE: ./assets/modules/cadastros/assets/js/controllers/cmp04700_fornecedor_nao_atende_atendeController.js
function cmp04700_fornecedor_nao_atende_atendeController(General, RestEngine, ScreenService, MessageService, templateManager, ZHPromise, ZhFilterPreferences){
    /*global Constants*/
    var self = this;
    
    this.concatArrayForParams = function (arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue ;
    };
    
    this.setDataSourceFilter = function(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        let otherWidget;
        
        if (widget.name == templateManager.container.getWidget('atende').name) {
            otherWidget = templateManager.container.getWidget('naoAtende');
        } else {
            otherWidget = templateManager.container.getWidget('atende');
        }
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": row.CDFILIAL
		    },
		    {
		        "name": "P_NRORG",
		        "operator": "=",
		        "value": getLocalVar('NRORG')
		    }   
		];
		
		otherWidget.dataSourceFilter = [
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": row.CDFILIAL
		    },
		    {
		        "name": "P_NRORG",
		        "operator": "=",
		        "value": getLocalVar('NRORG')
		    }    
		];
		
		otherWidget.appliedFilter = widget.appliedFilter;
		
		self.setStripeValues(widget);
		
		widget.reload();
		widget.activate();
    };
    
    this.setStripeValues = function(widget) {
        const stripe = templateManager.container.getWidget('stripe');
        const filterRow = widget.appliedFilter.FILTER_ROW;
        
        stripe.currentRow.CDFILIAL = filterRow.CDFILIAL;
        stripe.currentRow.NMFILIAL = filterRow.NMFILIAL;
        
        stripe.reload();
    };
    
    this.setCustomFilter = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = [];
    };
    
    this.openSubGridFilter = function(widget) {
        const subGridwidget = templateManager.container.getWidget('atendeSubGrid');
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(subGridwidget);
        
        subGridwidget.dataSourceFilter = [
        	{
        		"name": "P_SGESTADO",
		        "operator": "=",
		        "value": currentRowWidget.SGESTADO	
        	},
        	{
        		"name": "P_CDMUNICIPIO",
		        "operator": "=",
		        "value": currentRowWidget.CDMUNICIPIO	
        	},
        	{
        		"name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidget.CDFORNECED	
        	},
        	{
        		"name": "P_CDPAIS",
		        "operator": "=",
		        "value": currentRowWidget.CDPAIS	
        	}
        ];
    };
    
    this.openFormSubGrid = function(widget) {
        const formSubGridwidget = templateManager.container.getWidget('formSubGrid');
        const currentRowSubGridWidget = formSubGridwidget.currentRow;
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(formSubGridwidget).then(function(success) {
            //formSubGridwidget.getField('CDPERIENTR').clearValue();
        	formSubGridwidget.view();
        });
        
        currentRowSubGridWidget.CDFILIAL = currentRowWidget.CDFILIAL;
        currentRowSubGridWidget.NMFILIAL = currentRowWidget.NMFILIAL;
        currentRowSubGridWidget.CDPERIENTR = currentRowWidget.CDPERIENTR;
        currentRowSubGridWidget.NMPERIENTR = currentRowWidget.NMPERIENTR;
        currentRowSubGridWidget.IDUTCALENDCMPGERACAOAF = currentRowWidget.IDUTCALENDCMPGERACAOAF;
    };
    
    this.saveCodPeri = function(widget) {
        if (widget.isValid()) {
            const currentRowWidget = widget.currentRow;
            const parentWidget = widget.getParent();
            
            currentRowWidget.CDPERIENTR = currentRowWidget.CDPERIENTR.trim();
        	currentRowWidget.CDFORNECED = parentWidget.currentRow.CDFORNECED;
        	currentRowWidget.CDFILIAL = parentWidget.appliedFilter.FILTER_ROW.CDFILIAL;
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/saveCodPeri','Row', currentRowWidget).then(function(success) {
    	        MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	    widget.view();
        	}, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.saveFornecedor = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            const parentWidget = widget.getParent();
            
            currentRowWidget.CDFILIAL = parentWidget.appliedFilter.FILTER_ROW.CDFILIAL;
            currentRowWidget.NRORG = getLocalVar('NRORG');
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/saveFornecedor','Row', currentRowWidget).then(function(res) {
        	   currentRowWidget = {};
        	   MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	   ScreenService.closeSwipe().then(function(success){
        	       parentWidget.reload();
        	   });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.fornecedorDelete = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function (success) {
            let fornecedorArray = [];
            
            widget.dataSource.data.forEach(function(fornecedor) {
                if (fornecedor.__isSelected) {
                    fornecedorArray.push(fornecedor);
                }
            });
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/fornecedorDelete','Row', fornecedorArray).then(function(res) {
        	       widget.unSelectAll();
        	       widget.reload();
        	       MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.fornecedorAtendeDelete = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function (success) {
            let fornecedorArray = [];
            
            widget.dataSource.data.forEach(function(fornecedor) {
                if (fornecedor.__isSelected) {
                    fornecedorArray.push(fornecedor);
                }
            });
            
        	General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/fornecedorAtendeDelete','Row', fornecedorArray).then(function(res) {
        	       widget.unSelectAll();
        	       widget.reload();
        	       MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.exportFornecedor = function(widget) {
        if (widget.isValid()) {
            const currentRowWidget = widget.currentRow;
            
            currentRowWidget.CDFILDEST = currentRowWidget.CDFILDEST ? Array.isArray(currentRowWidget.CDFILDEST) ? currentRowWidget.CDFILDEST : 'T' : 'T';
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	ScreenService.confirmMessage("Deseja realizar a exportação do cadastro de fornecedor não atende/atende da unidade origem para as unidades destino selecionadas?", 'question', function(success) {
                ScreenService.confirmMessage("Todos os fornecedores que já atendem à unidade destino serão excluídos. Deseja continuar?", 'question', function(success) {
                    General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/exportFornecedor','Row', currentRowWidget).then(function(res) {
                	    MessageService.showMessageByCode("EXPORT_SUCCESS");
                	    ScreenService.closePopup();
                	    ScreenService.closePopup();
                	    widget.getParent().reload();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });    
                }.bind(this), function(error) {});
            }.bind(this), function(error) {});
        }
    };
    
    this.generateReport = function(widget) {
        if (widget.isValid()) {
        	const reportName = widget.currentRow.REPORT;
        	const currentWidget = widget.currentRow;
        	
        	currentWidget.NRORG = getLocalVar('NRORG');
        	
        	General.openReportPopup(widget, self.abreRelatorio, [widget, currentWidget, reportName]);
        	const widgetReport = templateManager.container.getActiveWidget();
	        widgetReport.fields[0].dataSource.data.length = 2;
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.CDFILIAL = row.CDFILIAL ? row.CDFILIAL : 'T';
        row.CDFORNECED = row.CDFORNECED ? row.CDFORNECED : 'T';
        
        General.openReport('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/generateReport', reportName, row);
    };
    
    /**
     * Redefine o dataSourceFilter da Widget de Cadastramento Automático.
     */
    this.resetFieldUnidade = function() {
        const fieldUnidade = templateManager.container.getWidget('cadAutoWidget').getField('CDFILIAL');
        
        fieldUnidade.dataSource.data = [];
    	fieldUnidade.dataSourceFilter = [
           {
               "operator": "ORDER_BY",
               "name": [
                   {
                       "name": "CDFILIAL",
                       "direction": "ASC"
                   }
                ]
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
                
            },
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": 'T'
            }
        ];
        fieldUnidade.reload();
    };
    
    this.formatForParams = function(value, defaultValue = 'T') {
        return Array.isArray(value) ? value : defaultValue;
    };
    
    this.getWidgetByTipoCadastramentoAutomatico = function(tipoCad) {
        const widgetName = tipoCad === 'N' ? 'naoAtende' : 'atende';
        
        return templateManager.container.getWidget(widgetName);
    };
    
    this.afterEndCadAutoForn = function(widgetAtual) {
        const widgetPai = self.getWidgetByTipoCadastramentoAutomatico(widgetAtual.currentRow.TIPOCAD);
        
        widgetAtual.unSelectAll();
        widgetAtual.currentRow = widgetAtual.backupRow || {};
        self.resetFieldUnidade();
        
        ScreenService.closePopup(true);
        
        widgetPai.reload();
        widgetPai.activate();
        
        MessageService.showMessageByCode("CADASTRO_SUCCESS");
        MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
    };
    
    this.cadAutoForn = function(widgetCadAutoForn) {
        if(widgetCadAutoForn.isValid()) {
            const currentRow = widgetCadAutoForn.currentRow;
            
            currentRow.CDREGIAO = self.formatForParams(currentRow.CDREGIAO);
            currentRow.CDFILIAL = self.formatForParams(currentRow.CDFILIAL);
            currentRow.CDFORNECED = self.formatForParams(currentRow.CDFORNECED);
            currentRow.CDPERIENTR = currentRow.CDPERIENTR || '';
            currentRow.NRORG = getLocalVar('NRORG');
            currentRow.QUEST = 'N';
            
            General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/cadAutoForn','Row', currentRow).then(function(res){
                if(res.length > 0) {
                    const dados = res.dataset.res;
                
                    if(dados[1].length > 0) {
                        ScreenService.confirmMessage("Atenção! Existem unidades atendidas com periodicidade diferenciada. Confirmar operação?", 'question', function(success) {
                            currentRow.QUEST = 'S';
                            General.callRestEngine('cmp_cadastros#/cmp04700_fornecedor_nao_atende_atendeController/cadAuto', 'Row', currentRow).then(function(success) {
                                self.afterEndCadAutoForn(widgetCadAutoForn);
                            });
                        }.bind(this), function(error) {});
                    }
                } else {
                    self.afterEndCadAutoForn(widgetCadAutoForn);
                }
            }).catch(self.logErrosCadAuto);
        }
    };
    
    this.logErrosCadAuto = function (callback) {
        const gruposWidget = templateManager.container.getWidget("naoAtende");
        const errorMessages = Util.getNestedProperty(callback, ["data", "dataset", "errors"]);

        if (Array.isArray(errorMessages)) {
            gruposWidget.reload().then(function() {
                let title = 'Operação bloqueada. Existem unidades cuja região não é atendida pelos fornecedores escolhidos';
                
                if (callback.data && callback.data.error && callback.data.error) {
                    title = messages[callback.data.error] || title;
                }
                
                General.showErrorMessages(gruposWidget, errorMessages, ScreenService.i18n(title));
            });
        } 
    };
    
    this.setDefaultRelatorio = function() {
        const reportField = templateManager.container.getWidget("reportWidget").getField("REPORT");
        
        if(!reportField.value()) {
            reportField.setValue("CMP04700");
        }
    };
    
    this.setFornDestDataFilter = function(widget) {
    	const fieldRazSocDest = widget.getField("NMRAZSOCFORNDEST");
	    const fieldCdFilial = widget.getField("CDFILIAL");
    	
    	if(widget.currentRow.NMRAZSOCFORNORIG.length > 0) {
    	    fieldRazSocDest.readOnly = false;
    	    fieldCdFilial.readOnly = false;
    	    
    	    fieldRazSocDest.dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    		
    		fieldCdFilial.dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    		
    	} else {
    	    fieldRazSocDest.readOnly = true;
    	    fieldCdFilial.readOnly = true;
    	}
    };
    
    this.setReadOnlyFieldsReport = function(widget) {
    	if(widget.currentRow.REPORT.length > 0) {
    	    widget.getField('CDFORNECED').readOnly = false;
    	    widget.getField('CDFILIAL').readOnly = false;

    	} else {
    	    widget.getField('CDFORNECED').readOnly = true;
    	    widget.getField('CDFILIAL').readOnly = true;
    	}
    };
    
    this.setVisibleFields = function(widget) {
    	if(widget.currentRow.TIPOCAD == 'A') {
    	    widget.getField('CDPERIENTR').isVisible = true;
    	    widget.getField('NMPERIENTR').isVisible = true;
    	} else {
    	    widget.getField('CDPERIENTR').isVisible = false;
    	    widget.getField('NMPERIENTR').isVisible = false;
    	}
    	widget.reload();
    };
    
    
    this.addFornecedor = function(widget) {
        if(widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtende'));
            MessageService.showMessageByCode("NECE_FILIAL_FILTER");
        } else {
        	ScreenService.openSwipe(widget.widgets[0]).then(function(success) {
            	widget.widgets[0].edit();
            });
        }
    };
    
    this.edit = function() {
        templateManager.container.getWidget('formSubGrid').edit();
    };
    
    this.backSwipe = function(args) {
        const widget = args.owner.widget;
    	
    	if(widget.mode == "edit" && widget.name == "formSubGrid") {
    	    widget.view();
    	} else {
    	    widget.currentRow = {};
    	    ScreenService.closeSwipe();
    	}
    };
    
    this.backPopup = function(widget) {
    	widget.currentRow = {};
    	
    	if(widget.name == templateManager.container.getWidget('exportWidget').name) {
    	    widget.getField('CDFILDEST').readOnly = true;
    	}
    	
    	ScreenService.closePopup();
    };
    
    this.controlFildest = function(widget) {
    	if(widget.currentRow.NMFILIALORIG) {
    	    widget.getField('CDFILDEST').readOnly = false;
    	} else {
    	    widget.getField('CDFILDEST').readOnly = true;
    	}
    };
    
    this.editSwipe = function(widget) {
    	General.widgetEdit(widget);
    };
    
    this.openExportWidget = function(widget) {
    	ScreenService.openPopup(widget.widgets[1]).then(function(success){
        	widget.widgets[1].edit();
        });
    };
    
    this.openReportWidget = function() {
        const widget = templateManager.container.getWidget('naoAtende');
    	ScreenService.openPopup(widget.widgets[2]).then(function(success) {
        	widget.widgets[2].edit();
        });
    };
    
    this.openCadAutoWidget = function(widget) {
    	ScreenService.openPopup(widget.widgets[3]).then(function(success) {
    	    widget.widgets[3].backupRow = angular.copy(widget.widgets[3].currentRow);
        	widget.widgets[3].edit();
        });
    };
    
    this.setDataSourceFilterRegiao = function() {
        const widget = templateManager.container.getWidget('cadAutoWidget');
        const regiao = self.concatArrayForParams(widget.currentRow.CDREGIAO, 'T');
        const field = widget.getField('CDFILIAL');
        
        field.dataSourceFilter = [
           {
               "operator": "ORDER_BY",
               "name": [
                   {
                       "name": "CDFILIAL",
                       "direction": "ASC"
                   }
                ]
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
                
            },
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
                
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": regiao
            }
        ];
        
        field.clearValue();
        field.reload();
    };
    
    this.backPopupCadastramentoAutomatico = function() {
        templateManager.container.getWidget('cadAutoWidget').currentRow = {};
    	self.resetFieldUnidade();
    	ScreenService.closePopup();
    };
    
    
    var messages = {
        levelExists: "Impossível adicionar. Nível de pratos já cadastrado.",
        registerExists: "Impossível adicionar. Registro já existe.",
        timeout: "Tempo limite de conexão excedido.",
        unfilteredWidget: "Filtre antes de realizar esta ação.",
        addServico: "Adicione um serviço ao grupo para prosseguir.",
        addPrato: "Adicione um prato ao serviço para prosseguir.",
        duplicatedTitleOnSave: "Pratos não inseridos",
        duplicatedMessageOnSave: "__nmprato__, pois já está cadastrado para esta unidade e serviço.",
        noReceita: "Prato selecionado não possui receita.",
        noSelection: "Selecione pelo menos um registro.",
        confirmServicosExport: "Os serviços e pratos do grupo origem serão excluídos. Deseja continuar?",
        servicosExportSuccess: "Serviços exportados com sucesso.",
        confirmPratosExport: "Deseja excluir os pratos do grupo de prato no serviço de origem? (Se o serviço de origem estiver selecionado como destino, o prato será excluído no serviço de origem obrigatoriamente.)",
        pratosExportSuccess: "Pratos exportados com sucesso.",
        duplicatedMessageOnExport: "__nmprato__, pois já existe no serviço __cdservfili__ - __nmservico__, no grupo __nmgrupoprato__.",
        duplicatedTitleOnExport: "Pratos não exportados",
        sheetErrors: "Erros na planilha",
        procedureErrors: "Itens não importados",
        invalidSheetColumnsLabels: "Colunas da planilha inválidas. Certifique-se de que usou o modelo de planilha para importação.",
        invalidSheetColumnsNumber: "Número de colunas da planilha inválido. Certifique-se de que usou o modelo de planilha para importação.",
        invalidSheet: "Planilha inválida. Certifique-se de que usou o modelo de planilha para importação.",
        emptySheet: "Planilha sem dados.",
        errorOpeningSheet: "Erro ao carregar planilha. Certifique-se de que usou o modelo de planilha para importação.",
        serverPermissionError: "Não foi possível carregar a planilha no servidor: Permissão negada. Por favor, contate um administrador do sistema.",
        importSheetSuccess: "Planilha importada com sucesso."
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('cmp04700_fornecedor_nao_atende_atendeController',cmp04700_fornecedor_nao_atende_atendeController);
});

// FILE: ./assets/modules/cadastros/assets/js/controllers/PercentAjustmentController.js
function PercentAjustmentController(General, MessageService, ScreenService, PercentAjustmentService, templateManager) {
    
    this.setDataSourceFilter = function(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        if(widget.isValid() && isValidFilterProducts(row.CDARVPRODINI, row.CDARVPRODFIN)) {
            widget.dataSourceFilter = [
    		    {
    		        "name": "P_CDFILIAL",
    		        "operator": "=",
    		        "value": row.CDFILIAL
    		    },
    		    {
    		        "name": "P_CDARVPRODINI",
    		        "operator": "=",
    		        "value": row.CDARVPRODINI
    		    },
    		    {
    		        "name": "P_CDARVPRODFIN",
    		        "operator": "=",
    		        "value": row.CDARVPRODFIN
    		    },
    		    {
                    "operator": "ORDER_BY",
                    "name": [
                        {
                            "name": "CDARVPROD",
                            "direction": "ASC"
                        }
                    ]
                }
    		];
    		
    		setStripeValues(row);
    		
    		//widget.getAction('CADAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
    		//widget.getAction('ALTERAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
    		
    		widget.activate();
        }
    };
    
    function isValidFilterProducts(productStart, productEnd) {
        if (!General.comparaPratoProduto(productStart, productEnd, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("INIPRODUCT_MUSTBELESSTHAN_FINPRODUCT", null, Constants.infoMessage);
            return false;
        }

        return true;
    }
    
    function setStripeValues(row) {
        const stripeWidget = templateManager.container.getWidget('stripe');
        
        stripeWidget.currentRow.CDFILIAL  = row.CDFILIAL.concat(' - ').concat(row.NMFILIAL);
        stripeWidget.currentRow.CDPRODINI = row.CDARVPRODINI.concat(' - ').concat(row.NMPRODINI);
        stripeWidget.currentRow.CDPRODFIN = row.CDARVPRODFIN.concat(' - ').concat(row.NMPRODFIN);
        stripeWidget.currentRow.FILTER_CDFILIAL = row.CDFILIAL;
        stripeWidget.currentRow.FILTER_NMFILIAL = row.NMFILIAL;
    }
    
    this.updatePercentAdjustments = function() {
    	const widgetProducts = templateManager.container.getWidget('products');
    	const row = widgetProducts.currentRow;
    	
		vrDescValidation(row);
		
		MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(function(success) {
    		PercentAjustmentService.updatePercentAdjustments(row).then(function() {
    		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
                widgetProducts.reload();
                widgetProducts.list();
            }).catch(function(error) {
            	showErrorMessage(error);
            });
        }.bind(this));
    };
    
    function showErrorMessage(error) {
    	var errorMessage = "TIMEOUT";
        let textContentError = '';
        
        if (error.data){
            errorMessage = "ERR_GENERICO";
            textContentError = error.data.error;
        }
        
        MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError}, Constants.errorMessage);
    }
    
    this.cancelInlineEdit = function() {
        const widgetProducts = templateManager.container.getWidget('products');
        
        widgetProducts.rollbackInlineEdit();
        widgetProducts.list();
    };
    
    this.deleteAdjustment = function(args) {
        const widgetProducts = templateManager.container.getWidget('products');
        
        MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
            let produtoArray = [];
            
            widgetProducts.dataSource.data.forEach(function(row) {
                if (row.__isSelected) {
                    produtoArray.push(row);
                }
            });
	
            PercentAjustmentService.deletePercentAdjustments(produtoArray).then(function() {
                MessageService.successNotificationByCode('SUCCESS_OPERATION');
                widgetProducts.unSelectAll();
                widgetProducts.reload();
                widgetProducts.activate();
            }).catch(function(error) {
            	showErrorMessage(error);
            });
        });
    };
    
    this.openPopupWidget = function(widgetName) {
        const widget = templateManager.container.getWidget(widgetName);
        const stripeWidget = templateManager.container.getWidget('stripe');
        
        ScreenService.openPopup(widget).then(function(success){
            widget.currentRow.CDFILIAL = stripeWidget.currentRow.FILTER_CDFILIAL;
            widget.currentRow.NMFILIAL = stripeWidget.currentRow.FILTER_NMFILIAL;
        	widget.edit();
        }); 
    };
    
    this.addAdjustment = function(args) {
        const widgetProducts = templateManager.container.getWidget('products');
    	const row = args.owner.widget.currentRow;
    	
		vrDescValidation(row);
		
		if(widgetProducts.dataSource.data.filter(data => data.CDFILIAL == row.CDFILIAL && data.CDPRODUTO == row.CDPRODUTO).length) {
			MessageService.showMessageByCode('ALREADY_REGISTERED', null, Constants.infoMessage);
		} else {
		    PercentAjustmentService.addPercentAdjustments(row).then(function() {
				ScreenService.closePopup();
				MessageService.successNotificationByCode('SUCCESS_OPERATION');
				widgetProducts.reload();
				widgetProducts.activate();
			}).catch(function(error) {
				showErrorMessage(error);
			});	
		}
    };
    
    function vrDescValidation(row) {
        if(parseFloat(row.VRPERCENTDESCONTO) >= 100) {
			return MessageService.showMessageByCode("VALID_VRPERCENTDESCONTO", null, Constants.infoMessage);		
		}
    }
    
    this.backSwipe = function(args) {
    	args.owner.widget.currentRow = {};
    	ScreenService.closePopup();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('PercentAjustmentController', PercentAjustmentController);
});

// FILE: ./assets/modules/simplificada/assets/js/controllers/CompraSimplificadaController.js
var CompraSimplificadaController = function (CompraSimplificadaService, ScreenService, General, restEngine, templateManager, Utilities) {
    
    const serviceCompraSimplificada = CompraSimplificadaService;
    
    let widgetCompra;
    let widgetUnidades;
    let widgetProdutos;
    let widgetAddFiltro;
    let widgetCalcNeceCompra;
    
    let parasupri;
    let centralCompras;
    let parcmpsup;
    let paramgeral;
    
    const messages = {
        "defaulNInf": "Parâmetros default de consumo devem ser informados.",
        "questionCalcPrevisao": "Deseja calcular a previsão de consumo no período entre as datas de processamento de cada unidade e o dia ",
        "confirmCalculo": "Confirma o cálculo?",
        "validaAcrescimo": "Acréscimo deve ser menor que 10000%",
        "exceptTempoLimite": "Tempo limite de conexão excedido."
    };
    
    this.setWidgets = function() {
        widgetCompra = templateManager.container.getWidget('compra_simplificada');
        widgetUnidades = templateManager.container.getWidget('filial_swipe');
        widgetProdutos = templateManager.container.getWidget('produto_swipe');
        widgetAddFiltro = templateManager.container.getWidget('adiciona_filtro_swipe');
        widgetCalcNeceCompra = templateManager.container.getWidget('opcoes_necessidadecompras_swipe');   
    };
    
    this.filterUnidadesProdutos = function() {
        widgetUnidades.dataSourceFilter = [
    	    {"name": "P_NRFILTROCOMPSFDA", "operator": "=", "value": widgetCompra.currentRow.NRFILTROCOMPSFDA}
    	];
    	
    	widgetProdutos.dataSourceFilter = [
    	    {"name": "P_NRFILTROCOMPSFDA", "operator": "=", "value": widgetCompra.currentRow.NRFILTROCOMPSFDA}
    	];
    	
    	widgetUnidades.reload();
    	widgetProdutos.reload();
    	
    	widgetUnidades.activate();
    };
    
    this.backCompraSimplificada = function() {
        ScreenService.closeSwipe();
        widgetCompra.activate();
    };
    
    this.backCancelNewFilter = function() {
        ScreenService.closePopup();
        widgetCompra.activate();
    };
    
    this.newFiltro = function() {
        widgetAddFiltro.newRow();
        ScreenService.openPopup(widgetAddFiltro).then(function() {
            widgetAddFiltro.getField('DTENTREGA').defaultValue.start = moment().format('DD/MM/YYYY');
            widgetAddFiltro.getField('DTENTREGA').defaultValue.end = moment().format('DD/MM/YYYY');
            widgetAddFiltro.getField('DTENTREGA').readOnly = true;
        });
    };
    
    this.saveFilter = function() {
        const filterRow = widgetAddFiltro.currentRow;
        
        serviceCompraSimplificada.saveFilterCompraSimplificada(filterRow).then(function(callback) {
            widgetAddFiltro.currentRow = {};
            widgetCompra.reload();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.changeNivelProduto = function() {
        const fieldProduto = widgetAddFiltro.getField('CDPRODUTO');
        const row = widgetAddFiltro.currentRow;
        
        fieldProduto.readOnly = row.CDNVPRODUTO ? false : true;
        fieldProduto.clearValue(fieldProduto);
    };
    
    this.setFilterProdutos = function(){
        const fieldProduto = widgetAddFiltro.getField('CDPRODUTO');
        const row = widgetAddFiltro.currentRow;

        fieldProduto.dataSourceFilter = [
            {"name": "P_CDNVPRODUTO", "operator": "=", "value": row.CDNVPRODUTO},
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        fieldProduto.reload();
    };
    
    this.deleteCompraSimplificada = function() {
        ScreenService.confirmMessage('Deletar registro?', 'question', function(success) {
            let compraArray = [];
            
            widgetCompra.dataSource.data.forEach(function(row) {
                if (row.__isSelected) {
                    compraArray.push(row);
                }
            });
            
            serviceCompraSimplificada.deleteFilterCompraSimplificada(compraArray).then(function(callback) {
                widgetCompra.unSelectAll();
                widgetCompra.reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    function getParametrosNecessidadeCompra() {
        serviceCompraSimplificada.getParametrosNecessidadeCompra(widgetCompra.currentRow).then(function(callback) {
            parasupri       = callback.dataset.parasupri;
            parcmpsup       = callback.dataset.parcmpsup;
            paramgeral      = callback.dataset.paramgeral;
            centralCompras  = callback.dataset.central_compras;
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    }
    
    this.openWidgetOpcoesCalculo = function() {
        ScreenService.openPopup(widgetCalcNeceCompra).then(function() {
            getParametrosNecessidadeCompra(); 
        });
    };
    
    function validaAcrecimos(row) {
        if (row.PEACRESCIMO < 10000.00) {
            return true;
        } else {
            ScreenService.showMessage(messages.validaAcrescimo);
            return false;
        }
    }
    
    this.confirmaCalculo = function() {
        const idutcardpadr = parcmpsup.IDUTCARDPADR;
        
        let row = widgetCalcNeceCompra.currentRow;
            
        row.PEACRESCIMO = row.PEACRESCIMO ? row.PEACRESCIMO : 0;
        if(widgetCalcNeceCompra.isValid() && validaAcrecimos(row)) {
            ScreenService.confirmMessage(messages.confirmCalculo, 'question', function(success) {
                /*if(idutcardpadr == 'D' || idutcardpadr == 'S'){
                    
                    General.callRestEngine('cmp_necessidadeCompras#/previsoes','Row',row).then(function(calback) {
                        var resposta = calback.dataset.resposta;
                        
                        if(resposta.length != 0 ){
    
                            widget.container.getWidget('previsoesbloqueadas').dataSource.data = resposta;
                            widget.container.getWidget('previsoesbloqueadas').reload();
                            ScreenService.openPopup(widget.container.getWidget('previsoesbloqueadas'));
                           
                        } else {
                            self.verificaSolicitacao(widget, row);
                        }
                    }).catch(function(error) {
                        ScreenService.showMessage(error.data ? error.data.error : messages.exceptTempoLimite, 'error', 'error');
                    });
                }else {
                    self.verificaSolicitacao(widget, row);
                }   */   
             
            });
        }
    };
    
    
    /*
     *
     * To Do
     *
     *
     */
     
     /*this.validaAcrecimos = function(field){
        var mensagem = "Acréscimo deve ser menor que 10000%";
        
        if (field < 10000.00){
            return true;
        } else {
            ScreenService.showMessage(mensagem);
            return false;
        }
    };
    
    field.widget.getField('PEACRESCIMO').readOnly = field.widget.currentRow.IDPERACRNEC == 'N';*/ 
};

Configuration(function (ContextRegister) {
	ContextRegister.register('CompraSimplificadaController', CompraSimplificadaController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/apuracaoEfetivacao/assets/js/controllers/ApuracaoEfetivacaoController.js
function ApuracaoEfetivacaoController(General, ScreenService, MessageService, templateManager, maskEngine, ZhUtil, ZHPromise, Utilities, Cmp03900_LancamentoAutorizacaoDeFornecimento_Service) {
     /*global Constants*/
    var ServiceLancamentoAF = Cmp03900_LancamentoAutorizacaoDeFornecimento_Service;
    let param;
    let index;
    let produtos = [];
    let idjustificativa;
    let podeAbrirInformacao;
    let messages = {
        errosApuracao: "Erros na Apuração",
        timeout: "Tempo limite de conexão excedido."
    };
    let allEntregas;

    /*************************************************************************************/
    /*                           FUNÇÕES GERAIS E DE VALIDAÇÃO                           */
    /*************************************************************************************/

    /*
     * Define a "Central de Filial" e os parâmetros para visualizção de componentes da tela.
     * A visualização campo 'SCCOMPRAS' do filtro e as informações de 'Produtos' 
     * no Stripe.
     */
    this.getParams = function() {
        General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getParams", "Row", {
            "CDFILIAL": getLocalVar("CDFILIAL")
        }).then(function(response) {

            this.idjustificativa = response.dataset.getParams[1][0].IDEXJUSTESCM;
            var idsisdos = response.dataset.getParams[1][0].IDSISDOS;
            var paramApurExtra = response.dataset.getParams[1][0].IDAPUREFESOLEXT;
            var paramProd = response.dataset.getParams[2][0].IDCONSPRSOL;

            var widgetFilter = templateManager.container.getWidget('FILTER');
            var vrunitario = templateManager.container.getWidget('widgetOldCot').getField('VRPRECUNIAP');
            var widgetStripe = templateManager.container.getWidget('STRIPE');

            setLocalVar('NMFILCENTCMP', response.dataset.getParams[0][0].NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.getParams[0][0].CDFILCENTCMP);

            if (paramApurExtra == 'N') {
                widgetFilter.getField('EXTRA').isVisible = false;
                widgetFilter.getField('EXTRA').validations = {
                    'required': false
                };
            }

            if (idsisdos == 3) {
                vrunitario.inlineEditable = false;
            }

            this.openFilter();
        }.bind(this));
    };

    this.getRow = function(widget) {
        return angular.copy(widget.currentRow);
    };

    this.removeClass = function(element, className) {
        $(element).removeClass(className);
    };

    this.removeColor = function(args) {
        var row = this.getRow(args);
        args.owner.widget.setCurrentRow(row);
        this.removeClass('.lineImportant', 'currentRow');
    };
    
    this.backFromSwipe = function() {
        ScreenService.closeSwipe();
    };
    
    this.backFromPopup = function() {
        ScreenService.closePopup();
    };
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }

    function getEventFromWidget(widget, eventName) {
        return widget.events.filter(event => { return event.name === eventName; })[0];
    }
    
    function setCodeOnEventWidgetAfterMoveRow(eventCode) {
        const event = getEventFromWidget(templateManager.container.getWidget('widgetOldCot'), 'WidgetAfterMoveRow');
        
        event.code = eventCode;
    }
    
    this.removeOpenPorEntregaFromWidgetAfterMoveRow = function() {
        const eventCode = "ApuracaoEfetivacaoController.removeClass('.lineImportant', 'currentRow');";
        
        setCodeOnEventWidgetAfterMoveRow(eventCode);
    };
    
    this.addOpenPorEntregaOnWidgetAfterMoveRow = function() {
        const eventCode = "ApuracaoEfetivacaoController.openPorEntrega();ApuracaoEfetivacaoController.removeClass('.lineImportant', 'currentRow');";
        
        setCodeOnEventWidgetAfterMoveRow(eventCode);
    };
    
    function isActionOfInlineEdit(action) {
        return action.showAsAction === 'back_inline_edit' || action.showAsAction === 'never_inline_edit';
    }
    
    function turnActionVisible(action) {
        action.isVisible = true;
    }
    
    function getEditableFields(widget) {
		return widget.fields.filter(function(field) {
			return field.inlineEditable;
		});
	}
    
    function actionsAfterInlineEditOperation(widgetCotacao) {
        widgetCotacao.inlineEditing = false;
		widgetCotacao.list();
		widgetCotacao.actions.filter(isActionOfInlineEdit).map(turnActionVisible);
    }
    
    function removeChangedPropertiesFromRow(widgetCotacao) {
        let editableFields = getEditableFields(widgetCotacao);
        
		widgetCotacao.dataSource.data.forEach(function(row) {
			editableFields.forEach(function(field) {
				if (row.hasOwnProperty('changed_' + field.name)) {
					delete row['changed_' + field.name];
				}
			});
			delete row.changed;
		});
    }
    
    function transferRowData(originRow, destinyRow) {
        for (let property in originRow) {
			destinyRow[property] = originRow[property];
		}
    }
    
    this.permiteExecutarOpenInformacao = function() {
        podeAbrirInformacao = true;
    };
    
    /**
     * Função responsável por simular o funcionamento que evita que um evento
     * específico do WidgetAfterMoveRow fosse acionado ao clicar no field.
     * 
     * Originalmente, este recurso foi implementado utilizando a seguinte composição de eventos:
     * - FieldOnClick do field VRPRECUNIAP, acionando a função removeEventFromWidgetAfterMoveRow;
     * - WidgetBeforeInlineEditMoveRow da widget widgetOldCot, acionando a função addEventInWidgetAfterMoveRow.
     * 
     * Para simular, foi utilizada uma promise.
     */
    this.changeEventCodeWidgetAfterMoveRow = function() {
        let deferred = ZHPromise.defer();
        
        setCodeOnEventWidgetAfterMoveRow("ApuracaoEfetivacaoController.updateApuracao()");
        deferred.resolve();
        
        return deferred.promise.then(() => { this.addOpenPorEntregaOnWidgetAfterMoveRow(); });
    };
    
    /*************************************************************************************/
    /*                                 FUNÇÕES DO FILTRO                                 */
    /*************************************************************************************/

    this.openLoginValidation = function(widget) {
        if (widget.currentRow.CDCOMPRADOR != "") {

            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/compValidation", "Row", {
                "CDCOMPRADOR": widget.currentRow.CDOPERADOR,
                "CDOPERADOR": getLocalVar('CDOPERADOR'),
                "CDCENTCMP": getLocalVar('CDFILCENTCMP')
            }).then(function(response) {
                if (response.dataset.passwordAut.PARAM === 'S') {
                    widget.container.getWidget('LOGIN').currentRow.CDCOMPRADOR = widget.currentRow.CDCOMPRADOR;
                    widget.container.getWidget('LOGIN').currentRow.CDOPERADOR = widget.currentRow.CDOPERADOR;
                    ScreenService.openPopup(widget.container.getWidget('LOGIN'));
                }
            }).catch(function(error) {
                ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
                widget.currentRow.CDCOMPRADOR = "";
            });
        }
    };

    this.loginValidation = function(widget) {
        if(!Util.isEmptyOrBlank(widget.currentRow.PASSWORD)){
            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/passwordValidation", "Row", widget.currentRow).then(function(response) {

                widget.currentRow = {};
                ScreenService.closePopup();
    
            }).catch(function(error) {
    
                ScreenService.showMessage(error.data.error);
                widget.currentRow.PASSWORD = "";
            });    
        } else {
            MessageService.showMessageByCode("INFORME_SENHA");
        }
    };

    this.openFilter = function() {
        var popupWidget = templateManager.container.getWidget('FILTER');
        
        popupWidget.getField('DTENTREGA').defaultValue = {
            start: moment().format('DD/MM/YYYY'),
            end: moment().format('DD/MM/YYYY')
        };
        
        ServiceLancamentoAF.retornaComprador().then(function(callback) {
            const comprador = callback.dataset.comprador_operador;
            if (comprador.length) {
                const codigoComprador = comprador[0].CDOPERADOR;
                const nomeComprador = comprador[0].NMOPERADOR;
                const fieldComprador = popupWidget.getField('CDCOMPRADOR');
                fieldComprador.reload().then(() => {
                    ScreenService.openPopup(popupWidget);
                    popupWidget.newRow();
                    popupWidget.currentRow.CDOPERADOR = codigoComprador;
                    popupWidget.currentRow.CDCOMPRADOR = codigoComprador + ' | ' + nomeComprador;
                    if (popupWidget.inEditMode()) {
                        popupWidget.newRow = function() {}; //Faz o newRow ser executado apenas uma vez
                    }
                });
            } else {
                ScreenService.openPopup(popupWidget);
                popupWidget.newRow();
                if (popupWidget.inEditMode()) {
                    popupWidget.newRow = function() {};
                }
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
            ScreenService.openPopup(popupWidget);
            popupWidget.newRow();
            if (popupWidget.inEditMode()) {
                popupWidget.newRow = function() {};
            }
        });
    };
    
    function isProdutoValido(currentRow) {
        return General.comparaPratoProduto(currentRow.CDPRODINI, currentRow.CDPRODFIN, getLocalVar('CDPICTPROD'));
    }

    /* Apura os produtos de acordo com os parâmetros passados no popup.
     * 
     * Seta os campos do stripe com os parâmetros do primeiro produto a ser exibido.
     * Defini os parâmetros locais a serem passados na requisição.
     */
    this.applyFilter = function(widget) {
        if (widget.isValid()) {
            if (isProdutoValido(widget.currentRow)) {
                widget.container.getWidget('STRIPE').currentRow = {
                    'CDPRODUTO': "",
                    'NMPRODUTO': "",
                    'NMOPERADOR': widget.currentRow.CDCOMPRADOR,
                    'DTINI': widget.currentRow.DTENTREGA.start,
                    'DTFIN': widget.currentRow.DTENTREGA.end
                };
                widget.currentRow.FILIPROC = getLocalVar('CDFILIAL'); //FILIAL LOGADA
                widget.currentRow.CDOPERADORLOG = getLocalVar('CDOPERADOR'); //OPERADOR LOGADO
                widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL'); //FILIAL LOGADA
    
                this.loadProdutos(widget);
            } else {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            }
        }
    };
    
    this.limpaCampoUnidades = function() {
        templateManager.container.getWidget('FILTER').getField('LISTAFILIAL').clearValue();
    };

    function updateConditionOnDataSourceFilter(params) {
        const { field, widget, conditionName, operator, newValue, cleaningOperation } = params;

        if (!Util.isEmptyOrBlank(widget.currentRow[conditionName])) {
            const regionCondition = field.dataSourceFilter.filter(filtro => filtro.name == conditionName);

            if (regionCondition.length) {
                regionCondition[0].value = newValue;
            } else {
                field.dataSourceFilter.push({
                    name: conditionName,
                    operator,
                    value: newValue,
                });
            }
        } else {
            cleaningOperation(field, conditionName);
        }
    }

    /* Define as regras para o filtro do campo "Unidades" de acordo
     * com os campos "Regiao" e "Agrupamento de Unidades".
     */
    this.filterUnidades = function(widget) {
        const field = widget.getField('LISTAFILIAL');
        const params = {
            field,
            widget,
        };
        
        params.conditionName = 'CDREGIAO';
        params.operator = 'IN';
        params.newValue = widget.currentRow.CDREGIAO;
        params.cleaningOperation = (field, conditionName) => field.dataSourceFilter = field.dataSourceFilter.filter(filtro => filtro.name != conditionName);
        
        updateConditionOnDataSourceFilter(params);
        
        params.conditionName = 'CDGRUPFILI';
        params.operator = '=';
        params.newValue = concatArrayForParams(widget.currentRow.CDGRUPFILI);
        params.cleaningOperation = (field, conditionName) => {
            const condition = field.dataSourceFilter.filter(filtro => filtro.name == conditionName)[0];

            condition.value = 'T';
        };
        
        field.reload();
    };
    
    function resetFieldProduto(field) {
        field.readOnly = true;
		field.validations = {};
		deepClearField(field);
		if (field.widget.currentRow.$error) {
        	delete field.widget.currentRow.$error[field.name];
		}
    }
    
    function activateFieldProduto(field) {
        field.readOnly = false;
		field.validations = {
			required: true
		};
    }
    
    this.onChangeTodosProdutosAComprar = function() {
        const widgetFilter = templateManager.container.getWidget('FILTER');
        const fieldTodosProdutos = widgetFilter.getField('TODOS_PRODUTOS');
        const fieldProdutoInicial = widgetFilter.getField('PRODUTOINI');
        const fieldProdutoFinal = widgetFilter.getField('PRODUTOFIN');
        
        if (fieldTodosProdutos.checked) {
			resetFieldProduto(fieldProdutoInicial);
			resetFieldProduto(fieldProdutoFinal);
		} else {
			activateFieldProduto(fieldProdutoInicial);
			activateFieldProduto(fieldProdutoFinal);
		}
    };

    this.nextProduto = function() {
        if (index != produtos.length - 1) {
            index++;
            this.setCotacaoWithParams();
        }
    };

    this.previousProduto = function() {
        if (index != 0) {
            index--;
            this.setCotacaoWithParams();
        }
    };

    /*************************************************************************************/
    /*                                 FUNÇÕES 'PRODUTOS'                                */
    /*************************************************************************************/

    /* Roda procedure que retorna dois valores para parametrização dos produtos
     * que serão apurados e em seguida faz a requisição dos produtos de acordo
     * com os parametros recebidos.
     */
    this.loadProdutos = function(widget) {
        ScreenService.confirmMessage("Confirma apuração de dados para efetivação de AF's?",  'question', function(success) {
            let row = angular.copy(widget.container.getWidget('FILTER').currentRow);
        
            row.CDPRODINI = row.CDPRODINI || '';
            row.CDPRODFIN = row.CDPRODFIN || '';
            
            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/apuracao", "Row", row).then( function(response) {
                let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
                let widgetStripe  = templateManager.container.getWidget('STRIPE');
                
                param = response.dataset.param[0].P_NRSEQAPUR;
                
                General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/qryAutGrupOp", "Row", { 'CDOPERADOR': getLocalVar("CDOPERADOR") }).then(function(response) {
                    if (response.dataset.qryAutGrupOp.PARAM != 'S') {
                        MessageService.showMessageByCode("OPR_SEM_PERMISSAO_ESC_PRECO");
                        widgetCotacao.getField('IDITMSELAPUR').events = [];
                    }
                }.bind(this));
    
                General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/crud/adqProduto", "FilterData", [
                    {
                        'name': 'P_CDCENTCMP',
                        'operator': 'IN',
                        'value': getLocalVar('CDFILCENTCMP')
    				},
                    {
                        'name': 'P_NRSEQAPUR',
                        'operator': 'IN',
                        'value': param
    				}
    			]).then(function(response) {
                    produtos = response.dataset.adqProduto;
                    index = 0;
                    this.setCotacaoWithParams();
                }.bind(this));
    
                widgetCotacao.actions[1].isVisible = true;
                widgetCotacao.actions[2].isVisible = true;
                
                widgetStripe.actions.forEach(function(value, index) {
                    widgetStripe.actions[index].isVisible = true;
                }.bind(this));
                
                ScreenService.closePopup();
    
            }.bind(this)).catch(function(error) {
                let errosEncontrados = error.data;
                let mensagem = 'Não há dados a serem listados para essa apuração.';
                
                if (Array.isArray(errosEncontrados.error)) {
                    if (Util.isEmptyOrBlank(errosEncontrados.error)) {
                        mensagem = mensagem.concat(ScreenService.i18n("Favor verificar o relatório de Produtos não Comprados"));
                    }
                } else {
                    mensagem = errosEncontrados.error;
                }
                
                this.confirmMessageModified(mensagem, error).then(
                    function() {},
                    function(callback) {
                        this.handleInsertErrors(callback);
                    }.bind(this));
            }.bind(this));
        }.bind(this), function(error) {});
    };

    /* Seta no stripe, o produto selecionado.
     */
    this.setCotacaoWithProdutoOnGrid = function(widget) {
        var cdprod = widget.container.getWidget('PRODUTOS').currentRow.CDPRODUTO;

        produtos.forEach(function(value, i) {
            if (cdprod == produtos[i].CDPRODUTO) {
                index = i;
            }
        }.bind(this));
        this.setCotacaoWithParams();
        ScreenService.closePopup();
    };

    this.openPopupProdutos = function() {
        var widProd = templateManager.container.getWidget('PRODUTOS');

        widProd.dataSource.setData(produtos);
        ScreenService.openPopup(widProd);
    }; 

    /*************************************************************************************/
    /*                                 FUNÇÕES COTAÇÃO                                   */
    /*************************************************************************************/
    
    /* Faz uma requisição em 'Cotação' filtrando com o produto selecionado
     * no 'STRIPE'.
     */
    function getCotacoes(fillFilterFunction) {
        templateManager.container.getWidget('STRIPE').currentRow.CDPRODUTO = produtos[index].CDARVPROD;
        templateManager.container.getWidget('STRIPE').currentRow.NMPRODUTO = produtos[index].NMPRODUTO;
        
        return General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/adqCotacao", "Row", {
            'P_CDCENTCMP': getLocalVar('CDFILCENTCMP'),
            'P_CDPRODESTO': produtos[index].CDPRODUTO,
            'P_NRSEQAPUR': param,
            'P_CDFILIOPELOG': getLocalVar('CDFILIAL')
        }).then(fillFilterFunction).catch(function(error) {
            ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
        }); 
    }
    
    function setCotacao(response) {
        const widgetCotacao = templateManager.container.getWidget('widgetOldCot');
            
        widgetCotacao.dataSource.setData(response.dataset.cotacao[0]);
        widgetCotacao.reload();
    }
    
    this.setCotacaoWithParams = function() {
        return getCotacoes(function(response) {
            const widgetCotacao = templateManager.container.getWidget('widgetOldCot');
            
            setCotacao(response);
            widgetCotacao.activate();
            if (widgetCotacao.dataSource.data.VRPRECUNIAP == 0) {
                MessageService.showMessageByCode("PRECO_UNIT_INFORMADO");
            }
        });
    };
    
    this.setCotacaoWithParamsWithoutActivateWidgetCotacao = function() {
        getCotacoes(setCotacao);
    };

    this.backFilter = function(widget) {
        ScreenService.confirmMessage("Deseja realizar uma nova apuração?", 'question', function(success) {
            widget.container.getWidget('PRODUTOS').dataSource.setData([]);
            widget.container.getWidget('widgetOldCot').dataSource.setData([]);
            widget.container.getWidget('STRIPE').currentRow = [];
            this.openFilter();
        }.bind(this), function(error) {});
    }; 

    this.updateApuracao = function() {
        let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
        let row = this.getRow(widgetCotacao);

        if (row.IDITMSELAPUR == 'S') {
            row.CDCENTITMAP = getLocalVar('CDFILCENTCMP');

            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/updateMelhorCotacao", "Row", row).then(function(response) {
                this.setCotacaoWithParams();
            }.bind(this));
        } else {
            let data = widgetCotacao.dataSource.data;
            for (let i = 0; i < data.length; i++) {
                if (row.CDNMREGIAO == data[i].CDNMREGIAO) {
                    if (data[i].IDITMSELAPUR == 'S') {
                        return false;
                    }
                }
            }
            
            if (this.idjustificativa == 'S') {
                let widgetJustificativa = templateManager.container.getWidget('JUSTIFICATIVA');
                
                ScreenService.openPopup(widgetJustificativa);
            } else {
                row.CDCENTITMAP = getLocalVar('CDFILCENTCMP');

                General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/updateMelhorCotacao", "Row", row).then(function(response) {
                    this.setCotacaoWithParams();
                }.bind(this));
            }
        }

        this.removeClass('.lineImportant', 'currentRow');
    };

    this.confirmarJustificativa = function(widget) {
        if (widget.isValid()) {
            let row = angular.copy(templateManager.container.getWidget('widgetOldCot').currentRow);
            row.OLD_CDCENTITMAP = getLocalVar('CDFILCENTCMP');

            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/updateMelhorCotacao", "Row", row).then(function(response) {
                ScreenService.closePopup();
                this.setCotacaoWithParams();
            }.bind(this));
        }
    };
    
    this.updateVrUnitario = function() {
        let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
        ScreenService.confirmMessage("Deseja atualizar a cotação conforme novo preço informado?", 'question', function(success) {
            let row = {
                'ITEM': widgetCotacao.dataSource.data.filter(item => item.changed),
                'PARAMS': {
                    'CDOPERADOR': getLocalVar('CDOPERADOR'),
                    'NMCONTAINER': templateManager.container.name,
                    'NMOPERADOR': getLocalVar('NMOPERADOR'),
                    'NRORG': getLocalVar('NRORG')
                }
            };

            widgetCotacao.actions[widgetCotacao.actions.length - 2].isVisible = false;
            widgetCotacao.actions[widgetCotacao.actions.length - 1].isVisible = false;

            General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/updateVrUnitario', "Row", row).then(function(success) {
    			widgetCotacao.lastInlineEditingElement.find('input').blur();
                widgetCotacao.activate();
                
    			removeChangedPropertiesFromRow(widgetCotacao);
                actionsAfterInlineEditOperation(widgetCotacao);
                
                MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
            }).catch(function(error) {
                widgetCotacao.rollbackInlineEdit();
                
                actionsAfterInlineEditOperation(widgetCotacao);
                
                ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
            });
        }.bind(this));
    };
    
    this.realizaEscolhaManualDoPreco = function() {
        this.changeEventCodeWidgetAfterMoveRow();
    };

    this.apurar = function(widget) {
        ScreenService.confirmMessage("Todas as cotações selecionadas serão desmarcadas. Confirma operação?", 'question', function(success) {

            General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/melhorCotacao', 'Row', {
                'P_CDCENTCMP': getLocalVar('CDFILCENTCMP'),
                'P_NRSEQAPUR': param
            }).then(function(response) {
                this.setCotacaoWithParams().then(function() {
                    General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/verificaPrecoEconomicoZerado', 'Row', {
                        'ITENS': widget.dataSource.data
                    }).then(function(response) {
                        if (!Util.isEmptyOrBlank(response.messages)) {
                            ScreenService.showMessage(response.messages[0].message);
                        }
                    });
                });
            }.bind(this));
        }.bind(this));
    };

    this.efetivar = function(widget) {
        const filterWidget = templateManager.container.getWidget('FILTER');
        
        General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/efetivar', 'Row', {
            'P_CDCENTCMP': getLocalVar('CDFILCENTCMP'),
            'P_NRSEQAPUR': param,
            'P_CDFILIOPELOG': getLocalVar('CDFILIAL'),
            'P_CDCOMPRADOR': templateManager.container.getWidget('FILTER').currentRow.CDOPERADOR,
            'P_CDOPERALANC': getLocalVar('CDOPERADOR'),
            'P_DTAUTOFORN': getLocalVar('DTPROCESSA')
        }).then(function(response) {
            var data = response.dataset.data[0];
            const mensagens = data.MENSAGENS;
            // const inconsistencias = data.INCONSISTENCIAS;
            
            if (!Util.isEmptyOrBlank(mensagens)) {
                ScreenService.showMessage(mensagens[0]);
            }

            MessageService.successNotificationByCode("EFETIVACAO_SUCCESS");
            
            ScreenService.openWindow('cmp_fornecimento_autorizacaoFornecimento#sup05100_analise_AF').then(function() {
                
                templateManager.container.getWidget('widgetPrincipal').NRSEQAPUR = data.NRSEQAPUR[0];
                templateManager.container.getWidget('widgetPrincipal').CDFILLANC = getLocalVar('CDFILIAL');
                templateManager.container.getWidget('widgetPrincipal').CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
                templateManager.container.getWidget('widgetPrincipal').CODCOMPRADOR = filterWidget.currentRow.CDCOMPRADOR;
                templateManager.container.getWidget('widgetPrincipal').CDOPERADOR = getLocalVar('CDOPERADOR');
                templateManager.container.getWidget('widgetPrincipal').DTAPURPREC = getLocalVar('DTPROCESSA');
                templateManager.container.getWidget('widgetPrincipal').DTINIAPUPREC = filterWidget.currentRow.DTENTREGA.formattedStart;
                templateManager.container.getWidget('widgetPrincipal').DTFINAPUPREC = filterWidget.currentRow.DTENTREGA.formattedEnd;
                
		    }.bind(this), function(error) {
			    throw error;
		    });
            
        }).catch(function(error) {
            if(error.data.error) {
                ScreenService.showMessage(error.data.error, 'error', 'error');
            } else {
                ScreenService.showMessage(error.data, 'error', 'error');
            }
        });
    };

    /*************************************************************************************/
    /*                                 FUNÇÕES POR ENTREGA                               */
    /*************************************************************************************/
    
    function executeDataSourcePorEntrega(row) {
        const filter = [
            {
                "name": "P_CDCENTITMAP",
                "operator": "=",
                "value": row.CDCENTITMAP
			},
            {
                "name": "P_NRSEQITMAP",
                "operator": "=",
                "value": row.NRSEQITMAP
			},
            {
                "name": "P_CDPRODITMAP",
                "operator": "=",
                "value": row.CDPRODITMAP
			},
            {
                "name": "P_CDREGITMAP",
                "operator": "=",
                "value": row.CDREGITMAP
			}
		];
		
        return General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/crud/porEntrega', 'FilterData', filter);
    }
    
    function executeDataSourceAllEntregas(row) {
        const filter = [
            {
                "name": "P_CDCENTITMAP",
                "operator": "=",
                "value": row.CDCENTITMAP
			},
            {
                "name": "P_NRSEQITMAP",
                "operator": "=",
                "value": row.NRSEQITMAP
			},
            {
                "name": "P_CDPRODITMAP",
                "operator": "=",
                "value": row.CDARVPROD
			},
            {
                "name": "P_CDREGITMAP",
                "operator": "=",
                "value": row.CDREGITMAP
			}
		];
		
        return General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/crud/allEntregas', 'FilterData', filter);
    }
    
    this.openPorEntrega = function() {
        let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
        let row = this.getRow(widgetCotacao);

        if (row.IDITMSELAPUR == 'S' && widgetCotacao.getMode() !== 'inline_edit') {
            executeDataSourcePorEntrega(row).then(function(response) {
			    let widgetPorEntrega = templateManager.container.getWidget('POR_ENTREGA');
			    
                widgetPorEntrega.dataSource.setData(response.dataset.porEntrega);
                ScreenService.openSwipe(widgetPorEntrega).then(function(){
    				$('.swipe-tip').before('<div style="position: absolute;left: 0;top: 0;bottom: 0;right: 0;opacity: 0.6;transform: translate(-100%, 0);-webkit-transform: translate(-100%, 0);"></div>');
                    this.removeClass('.lineImportant', 'currentRow');
    			}.bind(this));
            }.bind(this));
        }
        else {
            ScreenService.closeSwipe();
        }
    };
    
    this.openPopupIncluir = function() {
        executeDataSourceAllEntregas(templateManager.container.getWidget('widgetOldCot').currentRow).then(function(response) {
            const widgetIncluir = templateManager.container.getWidget('INCLUIR');
            
            allEntregas = response.dataset.allEntregas;
            
            resetAllFieldsWidgetIncluir(widgetIncluir);
            setDataSourceFieldDataEntrega(widgetIncluir);
            ScreenService.openPopup(widgetIncluir);
            widgetIncluir.newRow();
        });
    };
    
    /**
     * Decodifica informação recebida como código na aba 'POR ENTREGA' e 
     * exibe em popup.
     */
    this.openInformacao = function() {
        let widgetPorEntrega = templateManager.container.getWidget('POR_ENTREGA');
        
        if (podeAbrirInformacao) {
            let widgetInformacao = templateManager.container.getWidget('INFORMACAO');
            let currentRowProduto = this.getRow(widgetPorEntrega);
            let idmotprescaf = currentRowProduto.IDMOTIVPRESC;
            let indexMensagem = '';
            let mensagem = '';
        
            for (var i = 0; i < idmotprescaf.length; i++) {
                indexMensagem = i + idmotprescaf[i];
                mensagem = mensagem + mensagensInformacao(indexMensagem);
            }
        
            if (!mensagem) {
                mensagem = mensagem + mensagensInformacao('M0');
            }
        
            widgetInformacao.currentRow.mensagem = mensagem;
        
            ScreenService.openPopup(widgetInformacao);
            podeAbrirInformacao = false;
        } else {
            let widgetItemPorEntrega = templateManager.container.getWidget('ITEM_POR_ENTREGA');
            
            transferRowData(widgetPorEntrega.currentRow, widgetItemPorEntrega.currentRow);
            
            ScreenService.openSwipe(widgetItemPorEntrega).then(function() {
                widgetItemPorEntrega.view();
            });
        }
    };
    
    function mensagensInformacao(indexMensagem, param) {
        var mensagens = {
            '01': 'Escolhido por Produto Preferencial.\n',
            '17': 'Escolhido por Fornecedor/Marca Obrigatórios.\n',
            '18': 'Escolhido por Fornecedor/Marca Preferenciais.\n',
            '19': 'Escolhido por Fornecedor/Marca Restritivos.\n',
            '24': 'Escolhido por Fornecedor Obrigatório.\n',
            '25': 'Escolhido por Fornecedor Preferencial.\n',
            '26': 'Escolhido por Fornecedor Restritivo.\n',
            '2A': 'Escolhido por Acordo.\n',
            '31': 'Escolhido por Marca Obrigatória.\n',
            '32': 'Escolhido por Marca Preferencial.\n',
            '33': 'Escolhido por Marca Restritiva.\n',
            '41': 'Escolhido da Lista de Preços.\n',
            '42': 'Escolhido da Cotação Fora da Lista.\n',
            '51': 'Apuração para solicitações extras - Fornecedor escolhido não é extra.\n',
            '52': 'Apuração para solicitações extras - Fornecedor escolhido é extra.\n',
            '53': 'Apuração para solicitações não extras.\n',
            'M0': 'Escolhida manualmente.\n',
            'M1': 'Cotação: ' + param + '\n',
            'M2': 'Lista de preços: ' + param + '\n',
            'M3': 'Obs.: Item alterado manualmente.\n'
        };
        return mensagens[indexMensagem] ? mensagens[indexMensagem] : '';
    }
    
    function resetAllFieldsWidgetIncluir(widgetIncluir) {
        widgetIncluir.fields.map(field => field.clearValue());
        
        lockField(widgetIncluir.getField('NMFILIAL'));
        lockField(widgetIncluir.getField('NMFANTFORN'));
    }
    
    function getCotacoesLoaded() {
        let widgetCotacao = templateManager.container.getWidget('widgetOldCot');
        let data = widgetCotacao.dataSource.data;
        let values = [];
        let i = 0;
        
        data.forEach(function(value, index) {
            if (data[index].CDNMREGIAO == widgetCotacao.currentRow.CDNMREGIAO && data[index].CDNMPRODUTO == widgetCotacao.currentRow.CDNMPRODUTO) {
                values[i] = angular.copy(data[index]);
                i++;
            }
        }.bind(this));
        
        return values;
    }
    
    function getDate(date) {
        return date.split(' ')[0];
    }
    
    function dateEquals(dateFromItem, dateToBeEqual) {
        return getDate(dateFromItem) === dateToBeEqual;
    }
    
    function unidadeEquals(codigoUnidadeItem, codigoUnidadeToBeEqual) {
        return codigoUnidadeItem === codigoUnidadeToBeEqual;
    }
    
    function mountObjectWithDate(item) {
        return { DTENTRAPUT: getDate(item.DTENTRAPUT) };
    }
    
    function mountObjectWithFilial(item) {
        return { CDFILIAL: item.CDFILIAP, NMFILIAL: item.NMFILIAL };
    }
    
    function getArrayWithUniqueElements(dataToFilter, filterFunction, mountFunction, primitivePropertyToSearch) {
        let dataPrepared;
        
        if (typeof(filterFunction) === 'function') {
            dataPrepared = dataToFilter.filter(filterFunction);
        } else {
            dataPrepared = dataToFilter;
        }
        
        const result = [];
        const map = new Map();
        for (const item of dataPrepared) {
            if(!map.has(item[primitivePropertyToSearch])){
                map.set(item[primitivePropertyToSearch], true); // set any value to Map
                result.push(mountFunction(item));
            }
        }
        
        return result;
    }
    
    function setDataSourceFieldDataEntrega(widgetIncluir) {
        widgetIncluir.getField('DTENTRAPUT').dataSource.setData(getArrayWithUniqueElements(allEntregas, null, mountObjectWithDate, 'DTENTRAPUT'));
    }
    
    function setDataSourceFieldUnidade(fieldUnidade) {
        const filterFunction = function(item) {
            return dateEquals(item.DTENTRAPUT, fieldUnidade.getParent().currentRow.DTENTRAPUT);
        };
        
        fieldUnidade.dataSource.setData(getArrayWithUniqueElements(allEntregas, filterFunction, mountObjectWithFilial, 'CDFILIAP'));
    }
    
    function getQtdeComprarPorEntrega(date, codigoUnidade) {
        const mountFunction = function(item) { return item.QTSOLACOMP; };
        const dateAndUnidadeEqualsTo = function(item) {
            return dateEquals(item.DTENTRAPUT, date) && unidadeEquals(item.CDFILIAP, codigoUnidade);
        };
        
        return getArrayWithUniqueElements(allEntregas, dateAndUnidadeEqualsTo, mountFunction)[0];
    }
    
    function deepClearField(field) {
        field.clearValue();
        field.clearByOutData();
		field.clearByName();
		field.clearByOutDescription();
    }
    
    function clearFieldWithDataSource(field) {
        deepClearField(field);
        field.dataSource.clearCheckedRows();
		field.dataSource.setData([]);
    }
    
    function lockField(field) {
        field.readOnly = true;
        field.validations = {};
    }
    
    function unlockField(field) {
        field.readOnly = false;
        field.validations = { required: true };
    }
    
    this.fieldOnChangeDataEntrega = function() {
        const widgetIncluir = templateManager.container.getWidget('INCLUIR');
        const fieldQtdeComprar = widgetIncluir.getField('QTSOLACOMP');
        const fieldUnidade = widgetIncluir.getField('NMFILIAL');
        const fieldFornecedor = widgetIncluir.getField('NMFANTFORN');
        
        fieldQtdeComprar.clearValue();
        
        clearFieldWithDataSource(fieldUnidade);
        unlockField(fieldUnidade);
        
        clearFieldWithDataSource(fieldFornecedor);
        lockField(fieldFornecedor);
        
        setDataSourceFieldUnidade(fieldUnidade);
    };
    
    function fornecedorEquals(fornecedor, fornecedorToBeFound) {
        return fornecedor.NRINSJURFORN === fornecedorToBeFound.NRINSJURFORN &&
               fornecedor.NRCOLEITMAP === fornecedorToBeFound.NRCOLEITMAP &&
               fornecedor.CDMARCITMAP === fornecedorToBeFound.CDMARCITMAP;
    }
    
    function filtraDataSourceFornecedor() {
        const widgetIncluir = templateManager.container.getWidget('INCLUIR');
        const widgetPorEntrega = templateManager.container.getWidget('POR_ENTREGA');
        const fieldFornecedor = widgetIncluir.getField('NMFANTFORN');
        const dataFilterByDateAndUnidade = widgetPorEntrega.dataSource.data.filter(item => {
            return dateEquals(item.DTENTRAPUT, widgetIncluir.currentRow.DTENTRAPUT) && unidadeEquals(item.CDFILIAP, widgetIncluir.currentRow.CDFILIAP);
        });
        const dataFilterByFornecedorNaoIncluido = fieldFornecedor.dataSource.data.filter(item => {
            return !dataFilterByDateAndUnidade.find(element => fornecedorEquals(element, item));
        });
        
        fieldFornecedor.dataSource.setData(dataFilterByFornecedorNaoIncluido);
    }
    
    this.fieldOnChangeUnidade = function() {
        const widgetIncluir = templateManager.container.getWidget('INCLUIR');
        const fieldQtdeComprar = widgetIncluir.getField('QTSOLACOMP');
        const fieldUnidade = widgetIncluir.getField('NMFILIAL');
        const fieldFornecedor = widgetIncluir.getField('NMFANTFORN');
        
        clearFieldWithDataSource(fieldFornecedor);
        
        if (Util.isEmptyOrBlank(fieldUnidade.value())) {
            fieldQtdeComprar.clearValue();
            lockField(fieldFornecedor);
        } else {
            unlockField(fieldFornecedor);
            
            fieldFornecedor.dataSource.setData(getCotacoesLoaded());
            filtraDataSourceFornecedor();
            
            if (Util.isEmptyOrBlank(fieldFornecedor.dataSource.data)) {
                fieldQtdeComprar.clearValue();
                MessageService.showMessageByCode("SEM_COTACAO_PROD");
            } else {
                fieldQtdeComprar.setValue(getQtdeComprarPorEntrega(widgetIncluir.currentRow.DTENTRAPUT, widgetIncluir.currentRow.CDFILIAP));
            }
        }
    };

    this.incluiFornecedor = function() {
        const widgetIncluir = templateManager.container.getWidget('INCLUIR');
        
        if (widgetIncluir.isValid()) {
            const widgetCotacao = templateManager.container.getWidget('widgetOldCot');
            const widgetPorEntrega = templateManager.container.getWidget('POR_ENTREGA');
            const currentRowIncluir = angular.copy(widgetIncluir.currentRow);
    
            currentRowIncluir.CDCENTITMAP = getLocalVar('CDFILCENTCMP');
            
            const row = {
                NEW_ITEM: currentRowIncluir,
                OLD_ITEM: widgetIncluir.backupRow || currentRowIncluir
            };
    
            General.callRestEngine("cmp_fornecimento_apuracaoEfetivacao#/incluirPorEntrega", "Row", row).then(function(response) {
                ScreenService.closePopup();
                MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                
                this.setCotacaoWithParamsWithoutActivateWidgetCotacao();
                
                executeDataSourcePorEntrega(widgetCotacao.currentRow).then(function(response) {
                    widgetPorEntrega.dataSource.setData(response.dataset.porEntrega);
                });
            }.bind(this))
            .catch(function(error) {
                ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
            });
        }
    };
    
    this.saveEdicaoPorEntrega = function() {
        const widgetItemPorEntrega = templateManager.container.getWidget('ITEM_POR_ENTREGA');
        
        if (widgetItemPorEntrega.isValid()) {
            const widgetPorEntrega = templateManager.container.getWidget('POR_ENTREGA');
            const widgetCotacao = templateManager.container.getWidget('widgetOldCot');
            const row = {
                NEW_ITEM: widgetItemPorEntrega.currentRow,
                OLD_ITEM: widgetItemPorEntrega.backupRow
            };
            
            General.callRestEngine('cmp_fornecimento_apuracaoEfetivacao#/saveEdicaoPorEntrega', 'Row', row).then(function(response) {
    		    MessageService.successNotificationByCode("REG_SUCCESS_UPDATE");
    		    
    		    executeDataSourcePorEntrega(widgetCotacao.currentRow).then(function(response) {
                    widgetPorEntrega.dataSource.setData(response.dataset.porEntrega);
                });
    		    
    		    widgetItemPorEntrega.view();
            }).catch(function(error) {
                ScreenService.showMessage(error.data ? error.data.error : messages.timeout, 'error', 'error');
            });
        }
    };
    
    this.cancelEdicaoPorEntrega = function() {
        let widgetItemPorEntrega = templateManager.container.getWidget('ITEM_POR_ENTREGA');
        
		widgetItemPorEntrega.view();
		
		transferRowData(widgetItemPorEntrega.backupRow, widgetItemPorEntrega.currentRow);
    };
    
    this.editarEntrega = function() {
        let widgetItemPorEntrega = templateManager.container.getWidget('ITEM_POR_ENTREGA');
        
        General.edit(widgetItemPorEntrega);
    };

    /*************************************************************************************/
    /*                            FUNÇÕES PARA TRATATIVAS DE ERROS                       */
    /*************************************************************************************/
    
    this.confirmMessageModified = function(message, callbackForError) {
        let actions = [
            {
                label: ScreenService.i18n("Ok"),
                "default": true,
                code: function(e, deferred) {
                    deferred.resolve(e);
                }
            }
        ];
        
        if (Array.isArray(callbackForError.data.error) && !Util.isEmptyOrBlank(callbackForError.data.error)) {
            actions.push({
                label: ScreenService.i18n("Detalhes"),
                code: function(e, deferred) {
                    deferred.reject(callbackForError);
                }
            });
        }
        
        return ScreenService.showCustomDialog(message, 'error', 'error', actions);
    };
    
    /**
     * Altera a action 'Exportar' da widget de log de erros, passando uma
     * mensagem modificada, contendo:
     * - cabeçalho contendo o filtro realiazdo;
     * - os erros encontrados;
     */
    function atualizaExportar() {
        let filterWidget = templateManager.container.getWidget('FILTER');
        let messagesWidget = templateManager.container.getActiveWidget();
        let exportarAction = messagesWidget.getAction('exportar');
    
        messagesWidget.headerDataset = [];
    
        messagesWidget.headerDataset.push('-----------------------------------------');
        filterWidget.fields.forEach((field) => {
            if (field.isVisible === true) {
                let fieldValue;
                
                switch(field.name) {
                    case 'DTENTREGA':
                        let tempFieldValue = field.value();
                    
                        fieldValue =  tempFieldValue.start + ' a ' + tempFieldValue.end;
                        break;
                        
                    case 'EXTRA':
                        let tempField = field.dataSource.data.filter(dataItem => { return dataItem.value == field.value(); })[0];
                        
                        fieldValue = tempField.name;
                        break;
                        
                    default:
                        fieldValue = field.value();
                        break;
                }
                
                messagesWidget.headerDataset.push(field.label + ': ' + fieldValue);
            }
        });
        messagesWidget.headerDataset.push('-----------------------------------------');
    
        messagesWidget.bodyMessageDataset = messagesWidget.headerDataset.concat(messagesWidget.messagesDataset);
    
        exportarAction.events = [
            {
                "name": "ActionEvent",
                "code": "General.generateFileByDataSet(args.owner.widget.bodyMessageDataset);"
            }
        ];
    }
    
    this.handleInsertErrors = function (callback) {
        var filterWidget = templateManager.container.getWidget("FILTER");
        var message = messages.timeout;
        var errorMessages = Util.getNestedProperty(callback, ["data", "error"]);
    
        if (Array.isArray(errorMessages)) {
            filterWidget.reload().then(function() {
                let title = messages.errosApuracao;
                if (callback.data && callback.data.error) {
                    title = messages[callback.data.error] || title;
                }
                General.showErrorMessages(filterWidget, errorMessages, ScreenService.i18n(title));
                atualizaExportar();
            });
        } else {
            if (callback.data && callback.data.error) {
                message = messages[callback.data.error] || callback.data.error;
            }
            ScreenService.showMessage(message, "error");
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ApuracaoEfetivacaoController', ApuracaoEfetivacaoController);
});


// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.js
function Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller(Cmp03900_LancamentoAutorizacaoDeFornecimento_Service, ScreenService, MessageService, General, maskEngine, ZhUtil, ZHPromise, templateManager, Parametros, $http, Utilities, restEngine, metaDataFactory, renderEngine, ZhFilterPreferences){
    
    var ServiceLancamentoAF = Cmp03900_LancamentoAutorizacaoDeFornecimento_Service;
    var self = this;
    var paramAuditoria = false; // Variável auxiliar para abertura de PopUp 'Justificativa de Alteração'
    var paramDtEntrega = "N";   // Controla permissão ao adicionar várias datas de entrega
    var auxContador, auxRow;    // Variáveis auxiliares para salvar Justificativas
    var containerAF;
    var permissoes;
    let intervalId;
    let utilizaAnexo = false;
    let paramGeral;
    let paraSupri;
    let stateOnEnterAdicao;
    let triggerWidget;
    let imprimeObs = {
        unidade: 'N',
        produto: 'N'
    };
    const reportFormats = [
	    {
	        name: "pdf",
	        value: "PDF"
	    },
	    {
	        name: "xls",
	        value: "XLS"
	    },
	    {
	        name: "txt",
	        value: "TXT"
	    }
	];
	var MESSAGEBAIXA = ['EM_ABERTO', 'BAIXA_PARCIAL', 'BAIXA_TOTAL', 'BAIXA_MANUAL', 'ENCERRADA', 'CANCELADA', 'EDI'];
	var CHANGE_SITUATION_AF = 'CHANGE_SITUATION_AF';
    
    /*************************************************************************************/
    /*                             CONTROLE DA VISUALIZAÇÃO AF                           */
    /*************************************************************************************/
    
    const stateAFVisualizacao = {
        dados: {
            validationExecuted: false,
        },
        produtos: {
            validationExecuted: false,
        },
        mensagem: {
            validationExecuted: false,
        },
        formaPagamento: {
            validationExecuted: false,
        },
        encargo: {
            validationExecuted: false,
        },
        anexo: {
            validationExecuted: false,
        },
    };
    
    const tabsAF = ['dados', 'produtos', 'mensagem', 'formaPagamento', 'encargo', 'anexo'];
    
    function initStateAFVisualizacao() {
        tabsAF.forEach(tabName => {
            stateAFVisualizacao[tabName] = {
                validationExecuted: false,
            };
        });
    }
    
    /*************************************************************************************/
    /*                            FUNÇÕES GERAIS E DE VALIDAÇÃO                          */
    /*************************************************************************************/

    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function addCustomFieldOnStripe(field) {
        const unidadeLanc = document.querySelector(`#${field.name}`);
        
        if (unidadeLanc) {
            unidadeLanc.textContent = field.content;
        } else {
            const labelElement = document.createElement('span');
        
            labelElement.textContent = `${ScreenService.i18n(field.label)}: `;
            labelElement.style.paddingLeft = '46px';
            
            const contentElement = document.createElement('span');
            
            contentElement.id = field.name;
            contentElement.textContent = field.content;
            
            const parentElement = document.querySelector(`.stripe-value-${field.parentName}`).parentElement;
            
            parentElement.append(labelElement);
            parentElement.append(contentElement);
        }
    }
    
    function clearCustomFieldOnStripe(field) {
        const unidadeLanc = document.querySelector(`#${field.name}`);
        
        if (unidadeLanc) {
            unidadeLanc.textContent = '';
        }
    }
    
    /*************
     * PERMISSÃO *
     *************/
    
    function validaPermissoesActionsAF() {
        const dadosAF = templateManager.container.getWidget("dadosAF");
        const listaAF = templateManager.container.getWidget("listaAF");
        
        if (permissoes.indexOf('ABAF') == -1) {
            dadosAF.getAction("retornarParaEmAbertoAF").permission = false;
            listaAF.getAction("retornarParaEmAbertoAF").permission = false;
        }
        
        if (permissoes.indexOf('CAAF') == -1) {
            dadosAF.getAction("cancelarAF").permission = false;
            listaAF.getAction("cancelarAF").permission = false;
        }
        
        if (permissoes.indexOf('ENAF') == -1) {
            dadosAF.getAction("encerrarAF").permission = false;
            listaAF.getAction("encerrarAF").permission = false;
        }
        
        if (permissoes.indexOf('EXAF') == -1) {
            dadosAF.getAction("excluirAF").permission = false;
            listaAF.getAction("excluirAF").permission = false;
        }
    }
    
    function validaPermissoesWidgetProdutos() {
        const tabProdutos = templateManager.container.getWidget("produtos");
        
        if (permissoes.indexOf('EXAF') == -1) {
            tabProdutos.showCheckbox = false;
        } else {
            tabProdutos.showCheckbox = true;
        }
        
        const fieldQtdeEntrega = tabProdutos.getField("QTPROGENTAF");
        
        if (permissoes.indexOf('ALAF') == -1) {
            fieldQtdeEntrega.readOnly = true;
        } else {
            fieldQtdeEntrega.readOnly = false;
        }
        
        const fieldQtdeVolume = tabProdutos.getField("QTVOLUITEMAF");
        
        if (paraSupri.IDUTQTDEVOLU == 'S') {
            fieldQtdeVolume.isVisible = true;
        } else {
            fieldQtdeVolume.isVisible = false;
        }
    }
    
    function permiteFecharAFsInconsistentesOuForaDoLimite() {
        const ignorarInconsistencia = templateManager.container.getWidget("inconsistencias").getAction("ignorarInconsistencia");
        
        if (paraSupri.IDBLOQUEAAF == 'S') {
            ignorarInconsistencia.isVisible = false;
        } else {
            ignorarInconsistencia.isVisible = true;
        }
    }
    
    function utilizaAuditoriaAlteracoesAFs() {
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        
        if (paraSupri.IDAUDALTAF == 'S') {
            justificativaAlteracao.isVisible = true;
            paramAuditoria = true;
        } else {
            justificativaAlteracao.isVisible = false;
            paramAuditoria = false;
        }
    }
    
    function utilizaTabAnexo() {
        const tabAnexo = templateManager.container.getWidget("AnexoTituloGrid");
        
        if (paraSupri.IDANEXOLANCAF == 'S') {
            tabAnexo.isVisible = true;
            utilizaAnexo = true;
        } else {
            tabAnexo.isVisible = false;
            utilizaAnexo = false;
        }
    }
    
    function setCentralDeCompras(codigo, nome) {
        setLocalVar('CDFILCENTCMP', codigo);
		setLocalVar('NMFILCENTCMP', nome);
    }
    
    function setBaixaMessage() {
        let promises = [];
        
        /* Nao utilizar este bloco de comando
        //nao sei oque estava rolando mas ao deixar assim MessageService.getMessageByCode(MESSAGEBAIXA[0 a 6]) ele dava erro
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[0]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[1]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[2]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[3]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[4]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[5]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[6])); */
        
        promises.push(MessageService.getMessageByCode("EM_ABERTO"));
        promises.push(MessageService.getMessageByCode("BAIXA_PARCIAL"));
        promises.push(MessageService.getMessageByCode("BAIXA_TOTAL"));
        promises.push(MessageService.getMessageByCode("BAIXA_MANUAL"));
        promises.push(MessageService.getMessageByCode("ENCERRADA"));
        promises.push(MessageService.getMessageByCode("CANCELADA"));
        promises.push(MessageService.getMessageByCode("EDI"));
        promises.push(MessageService.getMessageByCode('CHANGE_SITUATION_AF'));
        
        
        Promise.all(promises).then((response) => {
            if(response[0]) MESSAGEBAIXA[0] = response[0];
            if(response[1]) MESSAGEBAIXA[1] = response[1];
            if(response[2]) MESSAGEBAIXA[2] = response[2];
            if(response[3]) MESSAGEBAIXA[3] = response[3];
            if(response[4]) MESSAGEBAIXA[4] = response[4];
            if(response[5]) MESSAGEBAIXA[5] = response[5];
            if(response[6]) MESSAGEBAIXA[6] = response[6];
            if(response[7]) CHANGE_SITUATION_AF = response[7];
        });
    }
    
    this.validacoesIniciais = function(owner) {
        ServiceLancamentoAF.validacoesIniciais().then(function(callback) {
            // Permissoes do Operador
            permissoes = callback.dataset.cmp03900_autgrupop_opergrupop.map(function(elem){
                return elem.IDAUTGRUPOP;
            }).join("_");

            // Define variável local Central de Compras
            const { CDFILCENTCMP, NMFILCENTCMP } = callback.dataset.centralCompras[0];
            
            setCentralDeCompras(CDFILCENTCMP, NMFILCENTCMP);
			
			templateManager.container.getWidget("filtro").currentRow.NMFILCENTCMP = NMFILCENTCMP;
			
			const dadosAF = templateManager.container.getWidget("dadosAF");
			const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
			
			if (Util.isEmptyObject(dadosAF.currentRow)) {
			    General.changeWidgetAcessibility(tabbedWidget.widgets, false);
			} else {
			    General.changeWidgetAcessibility(tabbedWidget.widgets, true);
			}
			
			const promiseParamGeral = Parametros.paramgeral();
			const promiseParaSupri = Parametros.parasupri(getLocalVar('CDFILCENTCMP'));
			
			Promise.all([promiseParamGeral, promiseParaSupri]).then(function(callback) {
                paramGeral = callback.shift().dataset.paramgeral[0];
                paraSupri = callback.shift().dataset.parasupri[0];
                
                validaParametros(paramGeral, paraSupri);
                
                validaPermissoesActionsAF();
            
                validaPermissoesWidgetProdutos();
                
                utilizaAuditoriaAlteracoesAFs();
                permiteFecharAFsInconsistentesOuForaDoLimite();
                utilizaTabAnexo();
                setBaixaMessage();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function validaParametros(paramGeral, paraSupri) {
        if(!paramGeral) {
            MessageService.showMessageByCode("PARAMGERAL_NOT_REGISTERED", null, Constants.errorMessage);
        }
        
        if(!paraSupri) {
            MessageService.showMessageByCode("PARASUPRI_NOT_REGISTERED", {CDFILCENTCMP: getLocalVar('CDFILCENTCMP')}, Constants.errorMessage);
        }
    }
    
    function visibilidadeActions(widget) {
        widget.actions.forEach(function(action) {
            if(action.permission)
                action.isVisible = true;
            else if(action.permission == false)
                action.isVisible = false;
        });
        
        if(usaIndiceFinanceiro()) {
            resetActions(widget, ['adicionarAF']);
        } else {
            resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']);
        }
    }
    
    function modoFieldGroups(widget, value) {
        widget.fieldGroups.forEach(function(fieldGroup) {
            fieldGroup.opened = value;
        });
        templateManager.updateTemplate();
    }
    
    function getTriggerWidget() {
        const triggerWidgetName = ScreenService.isSwipeOpen() ? 'dadosAF' : 'listaAF';
        
        return templateManager.container.getWidget(triggerWidgetName);
    }
    
    /**
     * Responsável por controlar a visualização das ações relacionadas a AF.
     */
    function validaActionsAF(widget) {
        const row = widget.currentRow;
        const actionEditar = widget.getAction("editarAF");
        const actionExcluir = widget.getAction("excluirAF");
        
        widget.getAction('relatorio').isVisible = true;
        
        if (("1_2_3_4_5_S").indexOf(row.IDBAIXAAF) != -1) {
            if (actionEditar) actionEditar.isVisible = false;
            
            actionExcluir.isVisible = false;
        } else {
            if (actionExcluir.permission) actionExcluir.isVisible  = true;
            if (actionEditar) actionEditar.isVisible = true;
        }
        
        const idsisdos = paramGeral.IDSISDOS;
        
        // Consistir
        if(("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || (row.IDBAIXAFSAI != 1 && row.IDBAIXAFSAI) || row.CDFILDESTCON || row.CDGERENTE || row.IDAFEXPIRADA == "S" || (idsisdos == '3' && row.IDTIPOLANCAF != 'M'))
            widget.getAction("consistirAF").isVisible = false;
        else if(widget.getAction("consistirAF").permission)
            widget.getAction("consistirAF").isVisible = true;
            
        // Fechar 
        if(("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || (row.IDBAIXAFSAI != 1 && row.IDBAIXAFSAI) || row.CDFILDESTCON  || row.IDAFEXPIRADA == "S" || (idsisdos == '3' && row.IDTIPOLANCAF != 'M'))
            widget.getAction("fecharAF").isVisible = false;
        else if(widget.getAction("fecharAF").permission)
            widget.getAction("fecharAF").isVisible = true;
            
        // Retorna AF para Em Aberto
        if (!row.IDBAIXAAF || row.IDBAIXAAF == '7' || row.IDBAIXAAF == '2' || row.CDFILDESTCON || (row.IDBAIXAFSAI && row.IDBAIXAFSAI != '1'))
            widget.getAction("retornarParaEmAbertoAF").isVisible = false;
        else if(widget.getAction("retornarParaEmAbertoAF").permission)
            widget.getAction("retornarParaEmAbertoAF").isVisible = true;
            
        // Baixar Totalmente
        if (row.IDSITUATUAAF == '1' || row.IDAFFORALIM == 'S' || row.IDAFEXPIRADA == 'S' || ("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || row.CDFILDESTCON || (row.IDBAIXAFSAI && row.IDBAIXAFSAI != '1'))
            widget.getAction("baixarTotalmenteAF").isVisible = false;
        else if(widget.getAction("baixarTotalmenteAF").permission)
            widget.getAction("baixarTotalmenteAF").isVisible = true;
        
        // Cancelar
        if (row.IDAFEXPIRADA == 'S' || (row.IDBAIXAAF && row.IDBAIXAAF != '7'))
            widget.getAction("cancelarAF").isVisible = false;
        else if(widget.getAction("cancelarAF").permission)
            widget.getAction("cancelarAF").isVisible = true;
        
        // Encerrar
        if (row.IDAFEXPIRADA == 'S' || (row.IDBAIXAAF && row.IDBAIXAAF != '1' && row.IDBAIXAAF != '7'))
            widget.getAction("encerrarAF").isVisible = false;
        else if(widget.getAction("encerrarAF").permission)
            widget.getAction("encerrarAF").isVisible = true;
            
        if (row.IDBAIXAAF == 3) {
            widget.getAction('enviarAF').isVisible = false;
            widget.getAction('enviarAFSelecao').isVisible = false;
        } else {
            widget.getAction('enviarAF').isVisible = true;
            widget.getAction('enviarAFSelecao').isVisible = true;
        }
    }
    
    function validacoesActions(widget) {
        const widProdutos        = widget.container.getWidget("produtos");
        const widImpostos        = widget.container.getWidget("impostos");
        const widObservacao      = widget.container.getWidget("observacao");
        const widFormaPagamento  = widget.container.getWidget("formaPagamento");
        const widDetalhesEncargo = widget.container.getWidget("detalhesEncargo");
        const widMensagem        = widget.container.getWidget("mensagem");
        const row = widget.currentRow;
        
        row.IDBAIXAAF   = row.IDBAIXAAF   != 0 ? row.IDBAIXAAF   : null;
        row.IDBAIXAFSAI = row.IDBAIXAFSAI != 0 ? row.IDBAIXAFSAI : null;
        
        validaActionsAF(widget);
        
        // AF Cancelada
        if(("2_3_4_5_S").indexOf(row.IDBAIXAAF) != -1) {
            const toggleActionsWidgetProdutos = function(visibility) {
                visibility = visibility;
                widProdutos.getAction("adicionarProdutoGeral").isVisible = visibility;
                widProdutos.getAction("editarProdutoGeral").isVisible    = visibility;
                widProdutos.getAction("excluirProduto").isVisible        = visibility;
                widProdutos.showCheckbox                                 = visibility;
            };
            
            /**
             * Recurso que permite a alteração dos itens de uma AF reprovada no workflow
             */
            if (row.IDBAIXAAF == '5') {
                ServiceLancamentoAF.verificaStatusAprovacaoWorkflow(row).then(function(response) {
                    const { STATUS: statusAprovacao } = response.dataset.data;
                    
                    if (statusAprovacao == 'RECUSADO') {
                        toggleActionsWidgetProdutos(true);
                    } else {
                        toggleActionsWidgetProdutos(false);
                    }
                }).catch(function(response) {
                    toggleActionsWidgetProdutos(false);
                    ScreenService.showMessage(response.data.error);
                });
            } else {
                toggleActionsWidgetProdutos(false);
            }
            
            widImpostos.getField('VRALIQITMAF').inlineEditable            = "";
            widImpostos.getField('VRIMPITMAF').inlineEditable             = "";
            widObservacao.getAction("editarObservacao").isVisible         = false;
            widFormaPagamento.getAction("editarFormaPagamento").isVisible = false;
            widDetalhesEncargo.getField('VRENCARGOAF').inlineEditable     = "";
            widMensagem.getAction("adicionarMensagem").isVisible          = false;
            widMensagem.getAction("editarMensagem").isVisible             = false;
            widMensagem.getAction("excluirMensagem").isVisible            = false;
        } else {
            widProdutos.getAction("adicionarProdutoGeral").isVisible   = true;
            widProdutos.getAction("editarProdutoGeral").isVisible      = true;
            widProdutos.getAction("excluirProduto").isVisible          = true;
            widProdutos.showCheckbox                                   = true;
            widImpostos.getField('VRALIQITMAF').inlineEditable         = "number";
            widImpostos.getField('VRIMPITMAF').inlineEditable          = "number";
            widDetalhesEncargo.getField('VRENCARGOAF').inlineEditable  = "number";
            widObservacao.getAction("editarObservacao").isVisible      = true;
            widFormaPagamento.isVisible                                = true;
            widMensagem.getAction("adicionarMensagem").isVisible       = true;
            widMensagem.getAction("editarMensagem").isVisible          = true;
            widMensagem.getAction("excluirMensagem").isVisible         = true;
        }
        
        verificaPrecoCotacaoAF(row, widProdutos);
    }
    
    this.carregaStatusCotacaoAF = function (widget) {
        let promises = [];
        let mensagem = [];
        
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_1"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_2"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_3"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_4"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_5"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_6"));
        
        Promise.all(promises).then((response) => {
            if(response[0]) mensagem.push(response[0]);
            if(response[1]) mensagem.push(response[1]);
            if(response[2]) mensagem.push(response[2]);
            if(response[3]) mensagem.push(response[3]);
            if(response[4]) mensagem.push(response[4]);
            if(response[5]) mensagem.push(response[5]);
            
            widget.currentRow.MESSAGES = mensagem;
        
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/getStatusCotacaoAF','Row', widget.currentRow).then(function(res){
                let mensagens;
                    
                if (res.dataset && res.dataset.res)
                    mensagens = res.dataset.res;
                        
                widget.currentRow.STATUSAUTOCOTAF = "";
                
                mensagens.forEach(function(mensagem){
                    if(mensagem)
                        widget.currentRow.STATUSAUTOCOTAF += mensagem + "\n";
                });
                
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    /*
     * Permite acionar o Workflow apenas quando a aprovação não foi recusada.
     * Do contrário, poderá entrar no fluxo novamente somente através da ação
     * "Enviar para Aprovação", na tela "Dados da AF".
     */
    function permiteAcionarWorkflow(row) {
        return new Promise(function(resolve, reject) {
            ServiceLancamentoAF.verificaStatusAprovacaoWorkflow(row).then(function(response) {
                const { STATUS: statusAprovacao } = response.dataset.data;
                
                if (statusAprovacao == 'RECUSADO') {
                    reject(statusAprovacao);
                } else {
                    resolve(statusAprovacao);
                }
            }).catch(function(response) {
                reject();
                ScreenService.showMessage(response.data.error);
            });
        });
    }
    
    function isMarcaDiferente(row) {
        return new Promise((resolve, reject) => {
            if (row.CDMARCA == row.CDSEGMARCA) {
                MessageService.showMessageByCode("MARCA_SEGUNDA_MARCA_DIFERENTES");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isQuantidadeMaiorQueZero(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.QTPROGENTAF) <= 0) {
                MessageService.showMessageByCode("QTD_MAIOR_ZERO");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isPrecoUnitarioMaiorQueZero(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.VRPREUNIAF) <= 0) {
                MessageService.showMessageByCode("PRECO_UNIT_MAIOR_ZERO");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isDescontoOnRange(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.VRPERDESAF) < 0 || General.valueToFloat(row.VRPERDESAF) > 100) {
                MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function validationsBeforeSaveProduct(row) {
        return isMarcaDiferente(row)
            .then(isQuantidadeMaiorQueZero)
            .then(isPrecoUnitarioMaiorQueZero)
            .then(isDescontoOnRange);
    }
    
    function translateBaixaSaidaAF(baixaSaida) {
        return {
            "0": "Em aberto",
            "1": "Baixa Parcial",
            "2": "Baixa Total",
            "3": "Baixa Manual",
            "4": "Encerrada",
            "5": "Cancelada",
            "null": "Em aberto"
        }[baixaSaida];
    }
    
    function translateBaixaFutura(baixaFutura) {
        return {
            "S": "Sim",
            "N": "Não"
        }[baixaFutura];
    }
    
    this.backToGridAF = function(widget) {
        const widgetListaAF = widget.container.getWidget("listaAF");
        
        ScreenService.closeSwipe();
        
        widgetListaAF.list();
        widgetListaAF.activate();
    };
    
    function permiteSalvarMultiplasDatasDeEntrega(row) {
        return new Promise((resolve, reject) => {
            ServiceLancamentoAF.dadosFornecedor(row).then(function(callback) {
                if (callback.dataset.fornecedor.length == 0) {
                    MessageService.showMessageByCode("FORNECEDOR_NAO_ENCONTRADO");
                    
                    return reject("Fornecedor não encontrado.");
                }
                
                if (callback.dataset.fornecedor[0].IDGERAFDTENT == "S") {
                    paramDtEntrega = "S";
                } else {
                    paramDtEntrega = "N";
                }
                
                return resolve(paramDtEntrega);
            }, function(err) {
                ScreenService.showMessage(err.data.error);
                
                return reject(err);
            });
        });
    }
    
    function resetActions(widget, exceptions = []) {
        widget.actions
                .filter(action => !exceptions.includes(action.name))
                .forEach(action => action.isVisible = false);
    }
    
    function permiteAdicionarProduto(widget) {
        const currentRow = widget.currentRow;
        
        if (paramDtEntrega === 'N') {
            return function produtoIgualGeraAFPorDataEntregaIgualN(row) {
                return row.CDPRODUTO == currentRow.CDPRODUTO &&
                        row.CDMARCA == currentRow.CDMARCA &&
                        row.DTPROGENTAF == currentRow.DTPROGENTAF;
            };
        } else {
            return function produtoIgualGeraAFPorDataEntregaIgualS(row) {
                return row.CDPRODUTO == currentRow.CDPRODUTO &&
                        row.CDMARCA == currentRow.CDMARCA;
            };
        }
    }
    
    function validaUsoIndiceFinanceiro() {
        let dadosAF, widgetsName;
        
        if (templateManager.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
            widgetsName = ['widProduto'];
            dadosAF = templateManager.container.getWidget('adicao_AF');
        } else {
            widgetsName = ['adicaoProduto', 'editProducts'];
            dadosAF = templateManager.container.getWidget('dadosAF');
        }
        
        changeVisibilityIndiceFinanceiro({
            widgetsName,
            usaIndiceFinanceiro: usaIndiceFinanceiro(),
            dadosAF,
        });
    }
    
    function usaIndiceFinanceiro() {
        return paraSupri.IDUTINDICECOL == 'S';
    }
    
    function changeVisibilityIndiceFinanceiro(parameters) {
        const unitario = {};
        const financeiro = {};
        const {
            widgetsName,
            usaIndiceFinanceiro,
            dadosAF,
        } = parameters;
        const nomeIndice = dadosAF.currentRow.NMINDICE;
        
        dadosAF.getField('NMINDICE').isVisible = usaIndiceFinanceiro;
        
        if (usaIndiceFinanceiro) {
            if (dadosAF.currentRow.CDINDICE || dadosAF.currentRow.CDINDICEAF) {
                unitario.readOnly = true;
                
                financeiro.readOnly = false;
                financeiro.validations = { required: true };
            } else {
                unitario.readOnly = false;
                
                financeiro.readOnly = true;
                financeiro.validations = {};
            }
        }
        
        financeiro.label = nomeIndice ? `Pr ${nomeIndice}` : 'Pr Financeiro';
        
        widgetsName.forEach(name => {
            const widget = templateManager.container.getWidget(name);
            const fieldPrecoUnitario = widget.getField('VRPREUNIAF');
            const fieldPrecoFinanceiro = widget.getField('VRINDICEITMAF');
            
            fieldPrecoUnitario.readOnly = unitario.readOnly;
            
            fieldPrecoFinanceiro.label = financeiro.label;
            fieldPrecoFinanceiro.isVisible = usaIndiceFinanceiro;
            fieldPrecoFinanceiro.readOnly = financeiro.readOnly;
            fieldPrecoFinanceiro.validations = financeiro.validations;
        });
    }
    
    /*************************************************************************************/
    /*                                FUNÇÕES DO FILTRO                                  */
    /*************************************************************************************/
    
    this.verificaProjCorp = function(field){
        field.readOnly = false;
    };
    
    function setUnidadeDestinoDefault(fieldUnidadeDestino) {
        const codigoUnidade = getLocalVar('CDFILIAL');
        const inFilterExists = function (fieldUnidadeDestino) {
            return fieldUnidadeDestino.dataSourceFilter.find(filter => filter.operator === 'IN');
        };
        
        if (!inFilterExists(fieldUnidadeDestino)) {
			fieldUnidadeDestino.dataSourceFilter.push({
			    name: 'CDFILIAL',
			    operator: 'IN',
			    value: [ codigoUnidade ]
			});
        }
		
		fieldUnidadeDestino.dataSource
		    .load(fieldUnidadeDestino.dataSourceFilter)
		    .then(function() {
			    fieldUnidadeDestino.setValue([codigoUnidade]);
				const row = fieldUnidadeDestino.dataSource.getFirstRow();
				
				row.__isSelected = true;
				
				fieldUnidadeDestino.dataSource.updateCheckedRows();
				
				if (inFilterExists(fieldUnidadeDestino)) {
				    fieldUnidadeDestino.dataSourceFilter = fieldUnidadeDestino.dataSourceFilter.filter(filter => filter.operator !== 'IN');
				}
				
				fieldUnidadeDestino.dataSource.load(fieldUnidadeDestino.dataSourceFilter);
			});
		
		self.verificaProjCorp(fieldUnidadeDestino);
    }
    
    this.abreFiltroOnEnter = function(widget) {
        ScreenService.openPopup(widget).then(function() {
            const fieldUnidadeDestino = widget.getField('NMFILIAL');
        
            widget.applyDefaultValue();
            
            ServiceLancamentoAF.retornaComprador()
                .then(function(callback) {
                    const comprador = callback.dataset.comprador_operador;
        
                    if (comprador.length) {
                        const codigoComprador = comprador[0].CDOPERADOR;
                        const fieldComprador = widget.getField('NMCOMPRADOR');
                        const checkboxTodosComprador = widget.getField('checkboxComprador');
        
        				fieldComprador.dataSource.checkedRows = [codigoComprador];
        				fieldComprador.readOnly = false;
                        fieldComprador.validations = { required: true };
                        fieldComprador.reload();
        				fieldComprador.setValue([codigoComprador]);
                        
        				checkboxTodosComprador.setValue(false);
        				checkboxTodosComprador.checked = false;
        			}
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                })
                .then(function(response) {
                    setUnidadeDestinoDefault(fieldUnidadeDestino);
                }).then(function(response) {
                    templateManager.updateTemplate();
                });
        });
    };
    
    this.abreFiltro = function() {
        const widget = templateManager.container.getWidget('filtro');
        
        self.verificaProjCorp(widget.getField('NMFILIAL'));
        ScreenService.openPopup(widget);
    };
    
    this.closeFilter = function() {
        ScreenService.closePopup(true);
        
        const listaAF = templateManager.container.getWidget("listaAF");
        
        listaAF.activate();
        
        //if (Util.isEmptyObject(listaAF.currentRow)) {
            if(usaIndiceFinanceiro()) {
                resetActions(listaAF, ['adicionarAF']);
            } else {
                resetActions(listaAF, ['adicionarAF', 'importarSolicitacaoCompra']);
            }
        //}
    };
    
    this.filtraUnidade = function(widget) {
        if(widget.currentRow.NMGRUPFILI) {
            widget.getField("NMFILIAL").dataSourceFilter[2].value = widget.currentRow.CDGRUPFILI;
            widget.getField("NMFILIAL").value("");
        } else {
            widget.getField("NMFILIAL").dataSourceFilter[2].value = "T";
        }
        widget.getField("NMFILIAL").reload();
    };
    
    this.readOnlyDatas = function(dtInicial, dtFinal) {
        if(!dtInicial.value() && !dtFinal.value()) {
            dtInicial.validations = {};
            dtFinal.validations   = {};
        } else {
            dtInicial.validations = {"required": true};
            dtFinal.validations   = {"required": true};
        }
    };
    
    this.filtrarAFEnvio = function(args){
        const row = args.e.preference.FILTER_ROW;
        const widgetGrid = templateManager.container.getWidget('listaAFSelecionadas');
        const stripe = templateManager.container.getWidget('stripe');
        
        const dtafini     = row.DT_AF ? row.DT_AF.formattedStart : '';
        const dtaffim     = row.DT_AF ? row.DT_AF.formattedEnd : '';
        const dtentini    = row.DT_ENTREGA ? row.DT_ENTREGA.formattedStart : '';
        const dtentfim    = row.DT_ENTREGA ? row.DT_ENTREGA.formattedEnd : '';
        
        widgetGrid.FILTER_ROW = row;
        
        if(dtafini){
            stripe.currentRow.DTAF = "De " + dtafini + " até " + dtaffim;
            stripe.getField('DTAF').isVisible = true;
        } else {
            stripe.getField('DTAF').isVisible = false;
        }
            
        if(dtentini){
            stripe.currentRow.DTENTREGA = "De " + dtentini + " até " + dtentfim;
            stripe.getField('DTENTREGA').isVisible = true;
        } else {
            stripe.getField('DTENTREGA').isVisible = false;
        }
        
        widgetGrid.dataSourceFilter = [
            {
                "name": "P_CDFILDEST",
                "operator": "=",
                "value": concatArrayForParams(row.CDFILIAL)
            },
            {
                "name": "P_CDFORNECED",
                "operator": "=",
                "value": concatArrayForParams(row.NMFANTFORN)
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": concatArrayForParams(row.NMOPERADOR)
            },
            {
                "name": "P_DTAFINI",
                "operator": "=",
                "value": dtafini
            },
            {
                "name": "P_DTAFFIN",
                "operator": "=",
                "value": dtaffim
            },
            {
                "name": "P_DTENTINI",
                "operator": "=",
                "value": dtentini
            },
            {
                "name": "P_DTENTFIN",
                "operator": "=",
                "value": dtentfim
            },
            {
                "name": "P_CDFILPROC",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "P_AGRUPAF",
                "operator": "=",
                "value": row.IDAGRUPAF ? 'S' : 'N'
            }
        ];
        
        ScreenService.closePopup();
        
        widgetGrid.showCheckbox = !row.IDAGRUPAF;
        
        widgetGrid.activate();
        widgetGrid.reload();
    };
    
    this.validaReportAction = function (widget) {
        widget.getAction('enviarEmail').isVisible = widget.dataSource.data.length > 0;
    };
    
    this.backLancamento = function () {
        ScreenService.openWindow('cmp_fornecimento_autorizacaoFornecimento#cmp03900_lancamento_autorizacao_de_fornecimento').then(function() {
		    const listaAF = templateManager.container.getWidget("listaAF");
            listaAF.activate();
	    }.bind(this), function(error) {
		    throw error;
	    });
    };
    
    
    this.filtrar = function(widget) {
        if(widget.isValid()) {
            var dados = widget.currentRow;
            var cdforneced      = widget.getField('checkboxFornecedor').checked ? "" : dados.NMFANTFORN.join("_");
            var cdcomprador     = widget.getField('checkboxComprador').checked  ? "" : dados.NMCOMPRADOR.join("_");
            var idsituatuaaf    = dados.IDSITUATUAAF.length == 2    ? "T" : dados.IDSITUATUAAF;
            var idafforalim     = dados.IDAFFORALIM.length  == 2    ? ""  : dados.IDAFFORALIM;
            var idbaixaaf_nulos = dados.IDBAIXAAF[0]        ==  "0" ? "X" : "Z";
            var tdtprogentaf    = dados.DT_ENTREGA.start && dados.DT_ENTREGA.end ? "" : "T";
            var dtentrini    = dados.DT_ENTREGA.start ? dados.DT_ENTREGA.start : "";
            var dtentrfin    = dados.DT_ENTREGA.end ? dados.DT_ENTREGA.end : "";
            var dtafini    = dados.DT_AF.start ? dados.DT_AF.start : "";
            var dtaffin    = dados.DT_AF.end ? dados.DT_AF.end : "";
            var listaAF = widget.container.getWidget("listaAF");
            listaAF.dataSourceFilter = [
                {"name": "CDFORNECED",       "value": cdforneced,                       "operator": "="},
                {"name": "CDFILIAL",         "value": `_${dados.NMFILIAL.join('_')}_`,  "operator": "="},
                {"name": "CDCOMPRADOR",      "value": cdcomprador,                      "operator": "="},
                {"name": "DTAUTOFORN_INI",   "value": dtafini,                          "operator": "="},
                {"name": "DTAUTOFORN_FIN",   "value": dtaffin,                          "operator": "="},
                {"name": "IDSITUATUAAF",     "value": idsituatuaaf,                     "operator": "="},
                {"name": "IDAFFORALIM",      "value": idafforalim,                      "operator": "="},
                {"name": "IDBAIXAAF",        "value": dados.IDBAIXAAF.join("_"),        "operator": "="},
                {"name": "IDBAIXAAF_NULOS",  "value": idbaixaaf_nulos,                  "operator": "="},
                {"name": "IDAUTOFORNEX",     "value": dados.STATUSAF.join("_"),         "operator": "="},
                {"name": "IDTIPOLANCAF",     "value": dados.TIPOAF.join("_"),           "operator": "="},
                {"name": "EDI",              "value": "S",                              "operator": "="},
                {"name": "DTPROGENTAF_INI",  "value": dtentrini,                        "operator": "="},
                {"name": "DTPROGENTAF_FIN",  "value": dtentrfin,                        "operator": "="},
                {"name": "TDTPROGENTAF",     "value": tdtprogentaf,                     "operator": "="}
            ];
            
            listaAF.reload();
            
            ScreenService.closePopup();
            
            listaAF.activate();
        }
    };
    
    function setStripeData(row) {
        const stripe = templateManager.container.getWidget("stripe").currentRow;
        
        stripe.NMFILDEST = row.NMFILDEST;
        stripe.DTAUTOFORN   = row.DTAUTOFORN.split(' ').shift();
        stripe.IDBAIXAFSAI = translateBaixaSaidaAF(row.IDBAIXAFSAI);
        stripe.IDBAIXITMFUTURA = translateBaixaFutura(row.IDBAIXITMFUTURA);
        stripe.NRAUTOFORN_CDFILLANC  = row.NRAUTOFORN;
        stripe.NRINSJURFORN = Util.applyMask(row.NRINSJURFORN, { type: "CPFCNPJ", params: {} }, maskEngine, ZhUtil);
        stripe.NMRAZSOCFORN = row.NMRAZSOCFORN;
        stripe.NRSEQAPURAF = row.NRSEQAPURAF;
        
        const field = {
            name: 'CDFILLANC_OF_NRAUTOFORN',
            label: 'Lanç.',
            content: row.CDFILLANC,
            parentName: 'NRAUTOFORN_CDFILLANC',
        };
        
        addCustomFieldOnStripe(field);
    }
    
    function clearStripeData() {
        const stripe = templateManager.container.getWidget("stripe");
        
        stripe.currentRow = {};
        
        clearCustomFieldOnStripe({
            name: 'CDFILLANC_OF_NRAUTOFORN'
        });
    }
    
    function getDataFromInfoAF(row, info) {
        const nrInscrucaoFornecedor = Util.applyMask(info.NRINSJURFORN, { type: "CPFCNPJ", params: {} }, maskEngine, ZhUtil);
        
        row.FORNECEDOR   = nrInscrucaoFornecedor + " - " + info.NMRAZSOCFORN;
        row.COMPRADOR    = info.COMPRADOR;
        row.NMOPERADOR   = info.NMOPERADOR;
        row.UNIDADELANC  = info.UNIDADELANC;
        row.UNIDADEDEST  = info.UNIDADEDEST;
        row.NMEMPRESA    = info.NMEMPRESA;
        row.NMTIPOCOBR   = info.NMTIPOCOBR;
        row.DSTPCTPAGAR  = info.DSTPCTPAGAR;
        row.NMRAZSOCTRAN = info.NMRAZSOCTRAN;
        row.COMPRADOR    = info.COMPRADOR;
        // row.NRINSJURFORN = info.NRINSJURFORN;
        // row.NRINSJURFORN_FORMATTED = nrInscrucaoFornecedor;
        // row.NMRAZSOCFORN = info.NMRAZSOCFORN;
        // row.NMFANTFORN   = info.NMFANTFORN;
        
        return row;
    }
    
    this.abreAF = function(widget, openOnProductTab = false) {
        return new Promise((resolve, reject) => {
            const dadosAF = widget.container.getWidget("dadosAF");
            const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
            
            dadosAF.currentRow = widget.dataSource.data[widget.currentRow.__index];
            
            tabbedWidget.defaultTab = openOnProductTab ? 'produtos' : 'dadosAF';
            
            let openFunction, params = [dadosAF];
            
            if (openOnProductTab) {
                openFunction = abreAFOnProductTab;
                params.push(tabbedWidget);
            } else {
                openFunction = abreAFOnDadosTab;
            }
            
            initStateAFVisualizacao();
            
            if (usaIndiceFinanceiro()) {
                ServiceLancamentoAF
                    .indiceJoinMovindice(dadosAF.currentRow)
                    .then(function(response) {
                        const indiceFinanceiro = response.dataset.indiceJoinMovindice.shift();
                        
                        for (let prop in indiceFinanceiro) {
                            if (!['NRORG', '__is_new'].includes(prop)) {
                                dadosAF.currentRow[prop] = indiceFinanceiro[prop];
                            }
                        }
                        
                        validaUsoIndiceFinanceiro();
                    });
            }
            
            return openFunction(...params)
                    .then(() => {
                        const closeAll = true;
                        const enabled = true;
                        
                        visibilidadeActions(dadosAF);          // Validações por permissão do operador
                        filtraDatasources(dadosAF.currentRow); // Filtra os dataSources dependentes
                        validacoesActions(dadosAF);            // Validações por parâmetros da AF
                        
                        General.changeWidgetAcessibility(tabbedWidget.widgets, enabled);
                        
                        ScreenService.openSwipe(tabbedWidget, closeAll);
                    })
                    .finally(() => resolve(tabbedWidget));
        });
    };
    
    function abreAFOnProductTab(dadosAF, tabbedWidget) {
        return new Promise((resolve, reject) => {
            // Permissão para salvar mais de uma data de entrega por AF
            permiteSalvarMultiplasDatasDeEntrega(dadosAF.currentRow)
                .then(() => {
                    self.atualizaFiltroProduto(dadosAF, 'adicaoProduto');
                    
                    resolve(tabbedWidget);
                });
        });
    }
    
    function abreAFOnDadosTab(dadosAF) {
        return new Promise((resolve, reject) => {
            ServiceLancamentoAF.infoAF(dadosAF.currentRow).then(function(callback) {
                const info = callback.dataset.infoAF[0];
                
                getDataFromInfoAF(dadosAF.currentRow, info);
                
                modoFieldGroups(dadosAF, true);        // Abre todos os fieldGroups
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
                reject();
            });
        });
    }
    
    function controlaSituacaoAf(widget){
        widget.dataSource.data.forEach(function(af){
            if(af.IDAFEXPIRADA == 'S'){
                af.IDBAIXAAF = 'S';
            }
        });
    }
    
    this.afterLoadDataSourceGridAF = function(widget) {
        controlaSituacaoAf(widget);
        
        if (widget.currentRow && !Util.isEmptyObject(widget.currentRow)) {
            const afExists = widget.dataSource.data.find(function(row) {
                return widget.currentRow.NRAUTOFORN == row.NRAUTOFORN;
            });
            
            if (!afExists) ScreenService.closeSwipe(0);
        }
        
        widget.currentRow = {};
        clearStripeData();
        if(usaIndiceFinanceiro()) {
            resetActions(widget, ['adicionarAF']);
        } else {
            resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']); 
        }
    };
    
    function filtraDatasources(dados) {
        // DADOS DA AF
        var dadosAF = templateManager.container.getWidget("dadosAF");
        dadosAF.getField("NMEMPRESA").dataSourceFilter[0].value = dados.CDFILDEST;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = dados.CDFILDEST;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[1].value = dados.IDTPIJURTRAN;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[2].value = dados.NRINSJURTRAN;
        
        // PRODUTOS
        templateManager.container.getWidget("produtos").dataSourceFilter = [
            {   "name": "CDFILLANC",    "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "NRAUTOFORN",   "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "CDFILDEST",    "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRORG",        "operator": "=",    "value": dados.NRORG       }
        ];
        
        // MENSAGEM
        templateManager.container.getWidget("mensagem").dataSourceFilter = [
            {   "name": "P_CDFILLANC",   "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "P_CDFILDEST",   "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "P_NRAUTOFORN",  "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
        
        // ENCARGO
        templateManager.container.getWidget("encargo").dataSourceFilter = [
            {   "name": "CDFILLANC",     "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "CDFILDEST",     "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRAUTOFORN",    "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
        
        // JUSTIFICATIVA DE ALTERAÇÃO
        templateManager.container.getWidget("justificativaAlteracao").dataSourceFilter = [
            {   "name": "CDFILLANMOV",   "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "CDFILDESMOV",   "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRAUTOMOV",     "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
    }
    
    this.afterMoveRowGridAF = function(widget) {
        const openOnProductTab = true;
        const widgetProdutos = templateManager.container.getWidget('produtos');
        
        widgetProdutos.unSelectAll();
        
        if (!widget.currentRow || Util.isEmptyObject(widget.currentRow)) {
            return;
        }
        
        setStripeData(widget.currentRow);
        
        visibilidadeActions(widget);
        validaActionsAF(widget);
        
        if (ScreenService.isSwipeOpen()) {
            this.abreAF(widget, openOnProductTab)
                .then((tabbedWidget) => {
                    const activeWidget = templateManager.container.getActiveWidget();
                    
                    if (activeWidget.name === 'produtos') {
                        activeWidget.reload();
                    } else {
                        /**
                         * Força a abertura da tab de 'Produtos' para caso outra aba
                         * esteja aberta.
                         */
                        tabbedWidget.openTab('produtos');
                    }
                });
        } else {
            Utilities.onDoubleClick(this.abreAF, [ widget, openOnProductTab ]);
        }
    };
    
    /*************************************************************************************/
    /*                              FUNÇÕES 'DADOS DA AF'                                */
    /*************************************************************************************/
    
    this.onEnterTabDadosAF = function(widget) {
        if (!stateAFVisualizacao.dados.validationExecuted) {
            stateAFVisualizacao.dados.validationExecuted = true;
            
            abreAFOnDadosTab(widget);
        }
    };
    
    this.editarAF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == "2") {
			widget.getField('NMEMPRESA').dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField('NMEMPRESA').readOnly = false;
			widget.getField('NMEMPRESA').reload();
        } else {
            widget.getField('NMEMPRESA').readOnly = true;
        }
        validaUsoIndiceFinanceiro();
        General.widgetEdit(widget);
        widget.fieldGroups[2].isVisible = false;
    };
    
    this.cancelarEdicaoAF = function(widget) {
        General.widgetCancelForm(widget);
        widget.fieldGroups[2].isVisible = true;
    };
    
    this.salvarEdicaoAF = function(widget) {
        let row = widget.currentRow;
    	let backup = widget.backupRow;
        let mensagem = [];
        let promises = [];
        let arrayFind = [];
        let arrayReplace = [];
            
        if(widget.isValid()) {
            
            if(row.CDTIPCOB != backup.CDTIPCOB) {
                let CDTIPCOB     = row.CDTIPCOB    ? row.CDTIPCOB    : "\" \"";
                let CDTIPCOB_BKP = backup.CDTIPCOB ? backup.CDTIPCOB : "\" \"";
                arrayFind.push("__CDTIPCOB_BKP__", "__CDTIPCOB__");
                arrayReplace.push(CDTIPCOB_BKP, CDTIPCOB);
                
                promises.push(MessageService.getMessageByCode("CHANGE_COBRANCA"));
            }
            if(row.CDTPCTPAGAR != backup.CDTPCTPAGAR) {
                let CDTPCTPAGAR     = row.CDTPCTPAGAR    ? row.CDTPCTPAGAR    : "\" \"";
                let CDTPCTPAGAR_BKP = backup.CDTPCTPAGAR ? backup.CDTPCTPAGAR : "\"\"";
                arrayFind.push("__CDTPCTPAGAR_BKP__", "__CDTPCTPAGAR__");
                arrayReplace.push(CDTPCTPAGAR_BKP, CDTPCTPAGAR);
    
                promises.push(MessageService.getMessageByCode("CHANGE_TP_CONTA"));
            }
            if(row.IDTIPOFRETAF != backup.IDTIPOFRETAF) {
                let IDTIPOFRETAF     = row.IDTIPOFRETAF    ? row.IDTIPOFRETAF    : "\" \"";
                let IDTIPOFRETAF_BKP = backup.IDTIPOFRETAF ? backup.IDTIPOFRETAF : "\" \"";
                
                arrayFind.push("__IDTIPOFRETAF_BKP__", "__IDTIPOFRETAF__");
                arrayReplace.push(IDTIPOFRETAF_BKP, IDTIPOFRETAF);
    
                promises.push(MessageService.getMessageByCode("CHANGE_FRETE"));
            }
            if(row.IDAUTOFORNEX != backup.IDAUTOFORNEX) {
                var IDAUTOFORNEX     = row.IDAUTOFORNEX    ? row.IDAUTOFORNEX    : "\" \"";
                var IDAUTOFORNEX_BKP = backup.IDAUTOFORNEX ? backup.IDAUTOFORNEX : "\" \"";
                
                arrayFind.push("__IDAUTOFORNEX_BKP__", "__IDAUTOFORNEX__");
                arrayReplace.push(IDAUTOFORNEX_BKP, IDAUTOFORNEX);
    
                promises.push(MessageService.getMessageByCode("CHANGE_EXTRA_AF"));
            }
            
            Promise.all(promises).then((response) => {
                if(response[0]) mensagem.push(replaceArray(response[0], arrayFind, arrayReplace));
                if(response[1]) mensagem.push(replaceArray(response[1], arrayFind, arrayReplace));
                if(response[2]) mensagem.push(replaceArray(response[2], arrayFind, arrayReplace));
                if(response[3]) mensagem.push(replaceArray(response[3], arrayFind, arrayReplace));
            
                auxContador = 0;
                auxRow = [];
                auxRow[0] = mensagem;
                auxRow[1] = [];
                
                if(widget.currentRow.IDBAIXAAF == 'S'){
                   widget.currentRow.IDBAIXAAF = null; 
                }
                
                if(paramAuditoria && mensagem.length) {
                    self.definirParametrosEdicaoAF(widget.currentRow, "edicaoAF", mensagem[auxContador]);
                    ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
                } else {
                    ServiceLancamentoAF.salvarDadosAF(widget.currentRow).then(function () {
                        General.formWidgetSwitchTemplate(widget);
                        General.changeWidgetAcessibility(widget.getParent().widgets, true);
                        General.changeWidgetAcessibility([widget.getParent()], true);
                        widget.fieldGroups[2].isVisible = true;
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                        
                        if(widget.currentRow.IDAFEXPIRADA == 'S'){
                            widget.currentRow.IDBAIXAAF = 'S';
                        }
                        widget.view();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                }
            });
        }
    };
    
    this.destinatarioNF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == "1") {
            
            widget.getField('NMEMPRESA').validations = {required: true};
            ServiceLancamentoAF.empresasPorUnidade(widget.currentRow).then(function(callback) {
				widget.currentRow.CDEMPRESA = callback.dataset.empresasPorUnidade[0].CDEMPRESA;
				widget.currentRow.NMEMPRESA = callback.dataset.empresasPorUnidade[0].NMEMPRESA;
				widget.getField('NMEMPRESA').readOnly = true;
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        } else if(widget.currentRow.IDTIPOEMITAF == "2") {
            
            widget.getField('NMEMPRESA').validations = {required: true};
			widget.getField('NMEMPRESA').dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField('NMEMPRESA').readOnly = false;
			widget.getField('NMEMPRESA').reload();
			widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        } else if(widget.currentRow.IDTIPOEMITAF == "3") {
            
            ServiceLancamentoAF.empresaClientePrincipal(widget.currentRow).then(function(callback) {
                if (callback.dataset.empresaClientePrincipal.length) {
                    widget.currentRow.NMEMPRESA = callback.dataset.empresaClientePrincipal[0].NMEMPRESA;
    			    widget.currentRow.CDEMPRESA = callback.dataset.empresaClientePrincipal[0].CDEMPRESA;
                } else {
                    widget.currentRow.NMEMPRESA = '';
    			    widget.currentRow.CDEMPRESA = '';    
                }
                if (callback.dataset.empresaClientePrincipal.length === 0) {
                    MessageService.showMessageByCode("SEM_CLIENTE_PRINCIPAL_FILIAL");
                    widget.currentRow.IDTIPOEMITAF = '2';
                    widget.currentRow.NMTIPOEMITAF = 'Empresa Informada';
                    widget.getField('NMEMPRESA').readOnly = false;
                    widget.getField('NMEMPRESA').validations = {required: true};
                    return false;
                } else {
                    widget.getField('NMEMPRESA').readOnly = true;
                    widget.getField('NMEMPRESA').validations = {};
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.excluirAF = function() {
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const popupCheckboxEmail = templateManager.container.getWidget('popupCheckboxEmail');
        const rowPopupEnviaEmail = popupEnviaEmail.currentRow;
        const widget = templateManager.container.getWidget('listaAF');
        
        let row = widget.currentRow;
        
        row.COOKIE_NAME = rowPopupEnviaEmail.COOKIE_NAME;
        row.EMAIL_ASSUNTO = rowPopupEnviaEmail.ASSUNTO;
        row.EMAIL_MENSAGEM = rowPopupEnviaEmail.MENSAGEM;
        row.NMOPERADOR = getLocalVar('NMOPERADOR');
        row.EMAIL_LOGADO = getLocalVar('EMAIL');
        row.FILIAL_LOGADA = getLocalVar('CDFILIAL');
        row.CENTRAL_COMPRAS = getLocalVar('CDFILCENTCMP');
        
        const finalizaExclusaoAF = function(message, success) {
            ServiceLancamentoAF.proceConsisteOrcamentoGopWorkflow(widget.currentRow.CDFILDEST);
            
            if(popupEnviaEmail.isActive())
                ScreenService.closePopup(popupEnviaEmail);
            else
                ScreenService.closePopup(popupCheckboxEmail);
            
            clearStripeData();
            
            widget.currentRow = {};
            widget.reload();
            
            if(usaIndiceFinanceiro()) {
                resetActions(widget, ['adicionarAF']);
            } else {
                resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']);
            }
            
            if(success) {
                MessageService.successNotificationByCode('SUCCESS_DELETE');
            } else {
                MessageService.showMessageByCode('SUCCESS_DEL_ERROR_MAIL', null, Constants.errorMessage);
            }
        };
        
        ServiceLancamentoAF.excluirAF(row).then(function () {
            finalizaExclusaoAF('AF excluída com sucesso.', true);
        }, function(response) {
            const errorMessage = response.data.error;
            
            if (errorMessage.indexOf('SMTP') !== -1) {
                finalizaExclusaoAF('AF excluída com sucesso, porém, ocorreu um erro ao enviar o e-mail.', false);
            } else {
                ScreenService.showMessage(errorMessage);
            }
        });
    };
    
    this.filtraInconsistenciaAF = function(widget, dados) {
        widget.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": dados.CDFILLANC,             "operator": "="},
            {"name": "CDFILDEST",    "value": dados.CDFILDEST,             "operator": "="},
            {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,            "operator": "="},
            {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'), "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),        "operator": "="}
        ];
        
        return widget.reload();
    };
    
    this.abandonarOperacao = function(widget) {
		ScreenService.closePopup(true);
		widget.getParent().activate();
		widget.getParent().view();
	};
	
    this.continuarOperacao = function(widget) {
        const triggerWidget = getTriggerWidget();
        
        if (widget.OPERACAO == "fecharAF")
            self.salvaFecharAF(triggerWidget);
        else if(widget.OPERACAO == "consistirAF")
            self.salvaConsistirAF(triggerWidget);
    };
    
    this.fecharAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            const inconsistWidget = widget.container.getWidget("inconsistenciasAF");
            
            self.filtraInconsistenciaAF(inconsistWidget, widget.currentRow)
                .then(function(callback) {
                    if (inconsistWidget.dataSource.data.length > 0) {
                        ScreenService.confirmMessage("AF está inconsistente ou fora do limite. Deseja visualizar pendências?", "INFORMATION", function() {
                            inconsistWidget.OPERACAO = "fecharAF";
                            ScreenService.openPopup(inconsistWidget);
                        }, function() {
                            self.salvaFecharAF(widget);
                        });
                    } else {
                        self.salvaFecharAF(widget);
                    }
                });
        });
    };
    
    this.salvaFecharAF = function(widget) {
        const listaAF = templateManager.container.getWidget("listaAF");
        const actualAF = listaAF.currentRow;
        
        if (
            !Util.isEmptyObject(paraSupri) &&
            paraSupri.IDBLOQUEAAF == 'S' &&
            (actualAF.IDSITUATUAAF == 1 || actualAF.IDAFFORALIM == 'S')
        ) {
            MessageService.showMessageByCode("ERRO_AF_PARAM");
            ScreenService.closePopup(true);
            widget.activate();
        } else {
            ServiceLancamentoAF.consisteOrcamento(widget.currentRow).then(function() {
                self.atualizarInconsistencias(templateManager.container.getWidget("inconsistenciasAF"), true, false).then(function() {
                    ScreenService.closePopup(true);
                    widget.activate();
                    MessageService.successNotificationByCode('SUCCESS_OPERATION');
                    
                    listaAF
                        .reload()
                        .then(() => {
                            if (ScreenService.isSwipeOpen()) {
                                self.abreAF(listaAF);
                            }
                        });
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.consistirAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var inconsistWidget = widget.container.getWidget("inconsistenciasAF");
            self.filtraInconsistenciaAF(inconsistWidget, widget.currentRow);
            inconsistWidget.reload().then(function(callback) {
                if(inconsistWidget.dataSource.data.length > 0) {
                    ScreenService.confirmMessage("AF está inconsistente ou fora do limite. Deseja visualizar pendências?", "INFORMATION", function() {
                        inconsistWidget.OPERACAO = "consistirAF";
                        ScreenService.openPopup(inconsistWidget);
                    }, function() {
                        self.salvaConsistirAF(widget);
                    });
                } else {
                    self.salvaConsistirAF(widget);
                }
            });
        });
    };
    
    this.salvaConsistirAF = function(widget) {
        var inconsistWidget = widget.container.getWidget("inconsistenciasAF");
        var dsinconsitaf = this.msgInconsistAF(inconsistWidget.dataSource.data);
        var produtos     = this.msgInconsistProduto(inconsistWidget.dataSource.data);
        const listaAF = templateManager.container.getWidget("listaAF");
        
        ServiceLancamentoAF.consisteDsincons(widget.currentRow, produtos, dsinconsitaf).then(function(callback) {
            self.atualizarInconsistencias(inconsistWidget, true, false).then(function() {
                ScreenService.closePopup(true);
                widget.activate();
                MessageService.successNotificationByCode('SUCCESS_OPERATION');
                
                listaAF
                    .reload()
                    .then(() => {
                        if (ScreenService.isSwipeOpen()) {
                            self.abreAF(listaAF);
                        }
                    }); 
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.msgInconsistAF = function(inconsistencias) {
        var autoforne = ["L08", "L09", "I10", "I11", "I33"];
        var mensagem = templateManager.container.getWidget("inconsistenciasAF").getField("CDERRO").options;
        var dsinconsaf = '';
        for(var i = 0; i < inconsistencias.length; i++) {
            if(autoforne.includes(inconsistencias[i].CDERRO)) {
                var msg = mensagem[inconsistencias[i].CDERRO];
                dsinconsaf = msg + dsinconsaf;
            }
        }
        dsinconsaf = dsinconsaf ? [dsinconsaf] : [];
        return dsinconsaf;
    };
    
    this.msgInconsistProduto = function(inconsistencias) {
        var produtos = [], arrayProdutos = [];
        var mensagem = templateManager.container.getWidget("inconsistenciasAF").getField("CDERRO").options;
        var itemautf = ["L12", "L13", "L20", "L23", "L24", "L22", "I14", "I15", "I16-1", "I16-2", "I16-3", "I16-4", "I16-5", "I16-6", "I16-7", "I16-8", "I16-9", "I17", "I21", "I25", "I28", "I29", "I31", "I30"];
        for(var i = 0; i < inconsistencias.length; i++) {
            if(itemautf.includes(inconsistencias[i].CDERRO)) {
                var key = inconsistencias[i].CDPRODUTO + inconsistencias[i].CDMARCA;
                if(!produtos[key]) {
                    produtos[key] = {
                        "KEY":          key,
                        "CDFILDEST":    inconsistencias[i].CDFILDEST,
                        "CDFILLANC":    inconsistencias[i].CDFILLANC,
                        "NRAUTOFORN":   inconsistencias[i].NRAUTOFORN,
                        "DTPROGENTAF":  inconsistencias[i].DTPROGENTAF,
                        "CDMARCA":      inconsistencias[i].CDMARCA,
                        "CDPRODUTO":    inconsistencias[i].CDPRODUTO,
                        "NRORG":        inconsistencias[i].NRORG,
                        "DSINCONSITAF": mensagem[itemautf[i].CDERRO],
                        "__is_new":     false
                    };
                } else {
                    var msg = mensagem[inconsistencias[i].CDERRO] + ". " + produtos[key].DSINCONSITAF;
                    produtos[key].DSINCONSITAF = msg;
                }
            }
        }
        
        for (var property in produtos) arrayProdutos.push(produtos[property]);
        return arrayProdutos;
    };
    
    this.abrePopupCheckboxEmail = function(label, code, cookieName) {
        const popupCheckboxEmail = templateManager.container.getWidget("popupCheckboxEmail");
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const widget = getTriggerWidget();
        const row = widget.currentRow;
        
        popupCheckboxEmail.paramValues = {
            "label": label,
            "code": code,
            "cookieName": cookieName
        };
        
        if(label == "Cancelamento AF") {
            if(!row.IDBAIXAAF || (row.IDBAIXAAF == "7" && row.IDBAIXAFSAI == "1")) {
                ScreenService.openPopup(popupCheckboxEmail);
            } else {
                popupEnviaEmail.currentRow.COOKIE_NAME = null;
                popupEnviaEmail.currentRow.ASSUNTO     = null;
                popupEnviaEmail.currentRow.MENSAGEM    = null;
                this.cancelar();
            }
        } else if(label == "Encerramento AF") {
            if(!row.IDBAIXAAF || ((row.IDBAIXAAF == "7" || row.IDBAIXAAF == "1") && row.IDBAIXAFSAI == "1")) {
                ScreenService.openPopup(popupCheckboxEmail);
            } else {
                popupEnviaEmail.currentRow.COOKIE_NAME = null;
                popupEnviaEmail.currentRow.ASSUNTO     = null;
                popupEnviaEmail.currentRow.MENSAGEM    = null;
                this.encerrar();
            }
        } else {
            ScreenService.openPopup(popupCheckboxEmail);
        }
    };
    
    this.continueOrOpenPopupEmail = function() {
        const popupCheckboxEmail = templateManager.container.getWidget("popupCheckboxEmail");
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        
        if(popupCheckboxEmail.currentRow.CHECKBOXEMAIL === "S") {
            popupCheckboxEmail.currentRow.CHECKBOXEMAIL = "N";
            ScreenService.closePopup(popupCheckboxEmail);
            this.abrePopupEmail(popupCheckboxEmail.paramValues.label, popupCheckboxEmail.paramValues.code, popupCheckboxEmail.paramValues.cookieName);
        } else {
            popupEnviaEmail.currentRow.COOKIE_NAME = null;
            popupEnviaEmail.currentRow.ASSUNTO     = null;
            popupEnviaEmail.currentRow.MENSAGEM    = null;
            
            if(popupCheckboxEmail.paramValues.label == "Exclusão AF")
                this.excluirAF();
            else if(popupCheckboxEmail.paramValues.label == "Cancelamento AF")
                this.cancelar();
            else if(popupCheckboxEmail.paramValues.label == "Encerramento AF")
                this.encerrar();
        }
    };
    
    this.abrePopupEmail = function(label, code, cookieName) {
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const actionEnviar = popupEnviaEmail.actions.filter((action) => { return action.name === 'ENVIAR'; });
        const actionEvent = actionEnviar[0].events.filter((event) => { return event.name === 'ActionEvent'; });
        
        MessageService.getMessageByCode(cookieName).then( messageCookie => {
    		MessageService.getMessageByCode("EMAIL_MSG").then( message => {
    		    const arrayfind = ['__NRAUTOFORN__', '__OPCOOKIE__', '__NMOPERADOR__'];
                const arrayReplace = ['[N° AF]', messageCookie, '[Nome Operador]'];
                const mensagemPadrao = replaceArray(message, arrayfind, arrayReplace);
    			let rowPopupEnviaEmail = popupEnviaEmail.currentRow;
                
                popupEnviaEmail.label = label;
                actionEvent[0].code = code;
                
                ServiceLancamentoAF.retornaCookieEmail(cookieName).then((mensagem) => {
                    mensagem = mensagem.messages[0].message;
                    
                    rowPopupEnviaEmail.COOKIE_NAME = cookieName;
                    rowPopupEnviaEmail.ASSUNTO = label;
                    rowPopupEnviaEmail.MENSAGEM = mensagem ? mensagem : mensagemPadrao;
                    
                    ScreenService.openPopup(popupEnviaEmail);
               });
    		});
        });
    };
    
    this.cancelar = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || (row.IDBAIXAAF == "7" && row.IDBAIXAFSAI == "1")) {
            row.IDBAIXAAF = "5";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "cancelar_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget: widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: false,
            });
        }
    };
    
    this.cancelarAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            var workflowRow = {};

            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', row).then(function(success) {
                if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                    workflowRow.CDFILLANC = row.CDFILLANC;
                    workflowRow.CDFILDEST = row.CDFILDEST;
                    workflowRow.NRDEMANDA = row.NRAUTOFORN;
                    workflowRow.OPERACAO = 'LANCAMENTO';
                    workflowRow.IDTPDEMANDA = 'AF';
                    // chamar a função do Victor 
    	            // Parametros: 'CDFILLANC', 'CDFILDEST', 'NRDEMANDA', 'OPERACAO', 'IDTPDEMANDA'
                    // Response: 'SEM_ALCADA', 'APROVADA', 'PENDENTE', 'VALIDO' (?)
                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(success) {
        	            if(success == 'PENDENTE'){
        	                ScreenService.showMessage("AF pendente de aprovação!");
        	            }
        	            else{
        	                self.cancelar(widget, row);
        	            }
                    });
                }
                else{
    	            self.cancelar(widget, row);
    	        }
            });
        });
    };
    
    this.encerrar = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || ((row.IDBAIXAAF == "7" || row.IDBAIXAAF == "1") && row.IDBAIXAFSAI == "1")) {
            row.IDBAIXAAF = "4";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "encerrar_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget: widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: false,
            });
        }
    };
    
    this.encerrarAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            var workflowRow = {};
           
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', row).then(function(success) {
                if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                    workflowRow.CDFILLANC = row.CDFILLANC;
                    workflowRow.CDFILDEST = row.CDFILDEST;
                    workflowRow.NRDEMANDA = row.NRAUTOFORN;
                    workflowRow.OPERACAO = 'LANCAMENTO';
                    workflowRow.IDTPDEMANDA = 'AF';
                    // chamar a função do Victor 
    	            // Parametros: 'CDFILLANC', 'CDFILDEST', 'NRDEMANDA', 'OPERACAO', 'IDTPDEMANDA'
                    // Response: 'SEM_ALCADA', 'APROVADA', 'PENDENTE', 'VALIDO' (?)
                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(success) {
        	            if(success == 'PENDENTE'){
        	                ScreenService.showMessage("AF pendente de aprovação!");
        	            }
        	            else{
        	                self.encerrar(widget, row);
        	            }
                    });
                }
                else{
    	            self.encerrar(widget, row);
    	        }
            });
        });
    };
    
    this.validateIsVisibleExtraReport = function (widget) {
        var reportFieldData = widget.getField('REPORT').dataSource.data;
    };
    
    function validateParamsExtraReport(row) {
        return (row.IDAFFORALIM == 'N' && row.IDSITUATUAAF == null && row.IDBAIXAAF == null &&
            (row.IDAFOPERLOG == null || row.IDAFOPERLOG == '1') && 
            ((row.IDAFPRODWEB == null || row.IDAFPRODWEB == 'N') || (row.IDBAIXAAF == '2' || row.IDBAIXAAF == '3')));
    }
    
    function replaceArray(strReplace, arrayfind, arrayReplace){
        for (var i = 0; i < arrayfind.length; i++) {
            strReplace = strReplace.replace(arrayfind[i], arrayReplace[i]);
        }  
        
        return strReplace;
    }
    
    this.backFiltroEnvioAf = function () {
        const listaAf = templateManager.container.getWidget('listaAFSelecionadas');
        
        ScreenService.closePopup();
        
        listaAf.activate();
        listaAf.getAction('enviarEmail').isVisible = listaAf.dataSource.data.length > 0;
        
    };
    
    this.baixaTot = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || row.IDBAIXAAF == "1") {
            row.IDBAIXAAF = "3";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "baixarTotalmente_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: true,
            });
        }
    };
    
    this.baixarTotalmenteAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            self.baixaTot(widget, widget.currentRow);
        });
    };
    
    function baixarItemAF({ widget, widgetAF }) {
        const widgetProdutos = templateManager.container.getWidget("produtos");
        const produtos = getItensParaBaixar(widgetProdutos);
        const listaAF = templateManager.container.getWidget("listaAF");
        
        produtos.forEach(produto => {
            produto.VALOR_IDBAIXITMAF = 3;
            
            produto.IDBAIXAAF = listaAF.currentRow.IDBAIXAAF;
            produto.IDBAIXAFSAI = listaAF.currentRow.IDBAIXAFSAI;
            produto.IDAFOPERLOG = listaAF.currentRow.IDAFOPERLOG;
            produto.CDFILIOPELOG = listaAF.currentRow.CDFILIOPELOG;
            produto.IDAFEXPIRADA = listaAF.currentRow.IDAFEXPIRADA;
        });
        
        ServiceLancamentoAF.atualizaItemBaixa(produtos).then(function(callback) {
            const result = Object.values(callback.dataset.produtos);
            const row = result[0];
            
            if(result.length) {
                widgetProdutos.reload().then(function() {
                    if(produtos.length === result.length)
                        MessageService.successNotificationByCode("BAIXA_SUCCESS");
                    else
                        MessageService.showMessageByCode("BAIXA_NOTALL_ITEMS", null, Constants.alertMessage);
                    
                    produtos.forEach(produto => {
                        produto.IDBAIXITMAF = produto.IDBAIXITMAF_BKP == "3" ? "3" : produto.IDBAIXITMAF;
                    });
                    
                    const finalizaBaixarItemAF = function() {
                        widgetProdutos.dataSource.clearCheckedRows();
                        
                        widgetAF.currentRow.IDBAIXAAF = row.IDBAIXAAF;
                        
                        if (row.IDBAIXAAF == '1') {
                            const rowAF = widgetAF.currentRow;
                            
                            return verificaUtilizaWorkflow(rowAF.CDFILLANC, rowAF.CDFILDEST, rowAF.NRAUTOFORN)
                                        .then(() => {
                                            if (widgetAF.name === 'dadosAF') self.abreAF(listaAF).then(tabbedWidget => tabbedWidget.openTab('dadosAF'));
                                            else widgetAF.reload();
                                        }, () => limpaAF());
                        } else {
                            if (widgetAF.name === 'dadosAF') self.abreAF(listaAF);
                            else widgetAF.reload();
                        }
                        
                        validacoesActions(listaAF);
                    };
                    
                    finalizaBaixarItemAF();
                });
            } else {
                MessageService.showMessageByCode("BAIXA_NOTALL_ITEMS", null, Constants.alertMessage);
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.acionaRetornarParaEmAbertoAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
            if(row.IDBAIXAFSAI != "2" && row.IDBAIXAAF != "2" && row.IDBAIXAAF != "7") {
                row.IDBAIXAAF = "0";
            }
            if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
                self.definirParametros(row, "retornar_AF");
                ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
            } else {
                retornarParaEmAbertoAF({ widget });
            }
        });
    };
    
    /**
     * TODO: Retirar a Justificativa para melhorar o fluxo. Fazer igual
     * ao fluxo baixarItemAF
     */
    function retornarParaEmAbertoAF({ widget, justificativa = false }) {
        const paramsAtualizaProdutosTipoBaixa = {
            widget,
            valorBaixaItemAF: null,
            retornaAberto: true,
            baixarTotalmente: false
        };
        
        if (!justificativa) {
            return atualizaProdutosTipoBaixa(paramsAtualizaProdutosTipoBaixa);
        }
        
        ServiceLancamentoAF.salvarJustificativas([ justificativa.row ]).then(function() {
            atualizaProdutosTipoBaixa(paramsAtualizaProdutosTipoBaixa);
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function atualizaProdutosTipoBaixa({ widget, valorBaixaItemAF, retornaAberto, baixarTotalmente }) {
        widget.currentRow.VALOR_IDBAIXITMAF = valorBaixaItemAF;
        widget.currentRow.SALVAR_AF         = true;
        widget.currentRow.RETORNAR_ABERTO   = retornaAberto;
        widget.currentRow.BAIXAR_TOTALMENTE = baixarTotalmente;
        widget.currentRow.FILIAL_LOGADA     = getLocalVar('CDFILIAL');
        widget.currentRow.CENTRAL_COMPRAS   = getLocalVar('CDFILCENTCMP');
        widget.currentRow.EMAIL_LOGADO      = getLocalVar('EMAIL');
        
        const abrirAF = function() {
            const widgetAF = templateManager.container.getActiveWidget().lastActiveWidget;
            const listaAF = templateManager.container.getWidget("listaAF");

            validacoesActions(widget);
            
            ScreenService.closePopup(true);
            
            /**
             * TODO: Repassar a recuperação da Row através do número da AF
             * para todas as funcionalidades que precisam quando estiverem com
             * o swipe de DadosAF aberto.
             */
            const numeroAF = widgetAF.currentRow.NRAUTOFORN;
            
            listaAF.activate();
            
            listaAF
                .reload()
                .then(function(success) {
                    if (widgetAF.name === 'dadosAF') {
                        const row = listaAF.dataSource.data.find(row => row.NRAUTOFORN == numeroAF);
                        
                        listaAF.setCurrentRow(row);
                    }
                });
        };
        
        ServiceLancamentoAF.atualizaProdutosTipoBaixa(widget.currentRow).then(function() {
            if (retornaAberto) {
                const row = widget.currentRow;
                const verificarApuracaoReprovada = false;
                
                return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN, verificarApuracaoReprovada).then(abrirAF).catch(self.limpaAFAdicao);
            }
            
            return abrirAF();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.adicionarAF = function(widget) {
        containerAF = widget.container;
        
        const filtro     = widget.container.getWidget("filtro");
        const qtdVolume  = widget.container.getWidget("produtos").getField("QTVOLUITEMAF").isVisible;
        const inconsAF   = widget.container.getWidget("inconsistencias").getAction("ignorarInconsistencia").isVisible;

		$http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_adicao_autorizacao_de_fornecimento.json').then(function(result) {
            const containerAdicaoAF = this.containerFactory(result.data);
            
            templateManager.container = containerAdicaoAF;
            
            
			self.onEnterAdicao({
			    widget: templateManager.container.getWidget("tab_adicao"),
                filtro,
                qtdVolume,
                inconsAF,
                isOnEnterEvent: true
		    });
		}.bind(metaDataFactory), function(error) {
			throw error;
		});
    };
    
    this.onChangeSelectIndiceFinanceiro = function(widget) {
        validaUsoIndiceFinanceiro();
    };
    
    /*************************************************************************************/
    /*                                 FUNÇÕES 'PRODUTOS'                                */
    /*************************************************************************************/
    let productHasCheckbox;
    
    this.onEnterTabProdutos = function(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        
        if (!stateAFVisualizacao.produtos.validationExecuted) {
            stateAFVisualizacao.produtos.validationExecuted = true;
            
            permiteSalvarMultiplasDatasDeEntrega(dadosAF.currentRow).then(() => {
                this.atualizaFiltroProduto(dadosAF, 'adicaoProduto');
            });
            
            widget.reload();
        }
    };
    
    this.editarProdutoGeral = function(widget) {
        const dadosAF = templateManager.container.getWidget('dadosAF');
        const editProducts = templateManager.container.getWidget('editProducts');
        
        General.changeWidgetAcessibility(widget.container.getWidget('tabbedWidget').widgets, false);
        General.widgetEdit(widget);
        
        editProducts.currentRow.CDTPINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
		editProducts.currentRow.IDPERVALORCOL = dadosAF.currentRow.IDPERVALORAF;
		editProducts.currentRow.CDINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
		editProducts.currentRow.DTREFINDCOL = dadosAF.currentRow.DTREFINDAF;
        
        productHasCheckbox = widget.showCheckbox;
        
        if (productHasCheckbox) widget.showCheckbox = false;
        
        validaUsoIndiceFinanceiro();
 	};
 	
 	this.cancelEditProdutoGeral = function(widget) {
 	    if (productHasCheckbox) widget.showCheckbox = true;
 	    
 	    widget.activate();
        widget.list();
        widget.dataSourceSave = [];
        widget.reload();
        
        General.changeWidgetAcessibility(widget.container.getWidget('tabbedWidget').widgets, true);
 	};
 	
 	this.editarProduto = function(widget) {
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = widget.currentRow.CDARVPROD;
        General.widgetEdit(widget);
        widget.currentRow.NOVO = false;
        widget.oldRow = {};
        validaEditaQtdProduto(widget);
        self.validaEdicaoPreco(widget);
    };
    
    function validaEditaQtdProduto(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        const  row = widget.currentRow;
        
        if(idBaixaItemAF(row) || idBaixaAFSaida(dadosAF.currentRow) || mixProdValitadions(row)){
            widget.getField('QTPROGENTAF').readOnly = true;
        }else{
            widget.getField('QTPROGENTAF').readOnly = false;
        }
    }
    
    function idBaixaItemAF(row) {
        return row.IDBAIXITMAF == '1' || row.IDBAIXITMAF == '2' || row.IDBAIXITMAF == '3' || row.IDBAIXITMAF == '4' || row.IDBAIXITMAF == '5';
    }
    
    function idBaixaAFSaida(row) {
        return row.IDBAIXAFSAI != '1' && !Util.isEmptyOrBlank(row.IDBAIXAFSAI);
    }
    
    function mixProdValitadions(row) {
        const dadosAF = templateManager.container.getWidget('dadosAF');
        return !Util.isEmptyOrBlank(dadosAF.currentRow.CDFILDESTCON) || row.IDITMSEPARADO == 'S' || dadosAF.currentRow.IDTIPOLANCAF == 'A' && permissoes.indexOf('ALAF') == -1;
    }
    
    this.excluirProduto = function(widget) {
        const checkedRows = widget.getCheckedRows();
        const widgetListaAF = widget.container.getWidget("listaAF");
        const msg = (checkedRows.length > 1) ? 'DELETE_ITEMS' : 'DELETE_ITEMAF';
        
        MessageService.confirmMessageByCode(msg, null, Constants.confirmationMessage).then(function(success) {
            checkedRows.forEach(row => {
                row.IDBAIXAAF = widgetListaAF.currentRow.IDBAIXAAF;
                row.IDAFEXPIRADA = widgetListaAF.currentRow.IDAFEXPIRADA;
                row.IDBAIXAFSAI = widgetListaAF.currentRow.IDBAIXAFSAI;
                row.CDFILDESTCON = widgetListaAF.currentRow.CDFILDESTCON;
            });
            
            ServiceLancamentoAF.excluirProduto(checkedRows).then(function (callback) {
                ServiceLancamentoAF.proceConsisteOrcamentoGopWorkflow(checkedRows[0].CDFILDEST);

				if(callback.messages[0].message.TYPE == 'ERROR') {
					MessageService.showMessageByCode(callback.messages[0].message.MESSAGE, null, Constants.alertMessage);
					if(callback.messages[0].message.MESSAGE === 'DELETED_AF_WITHOUT_ITEMS') {
					    ScreenService.closeSwipe();
					    widgetListaAF.reload();
					    widgetListaAF.activate();	
					} else {
					    widget.reload();
					    widget.activate();
					    widget.unSelectAll();
					}
				} else {
					MessageService.successNotificationByCode(callback.messages[0].message.MESSAGE);
					widget.reload();
					widget.activate();
					widget.unSelectAll();
				}
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.voltarProduto = function(widget) {
        var widProdutos = widget.container.getWidget('produtos');
        if(!widProdutos.editing){
            widget.dataSource.clearCheckedRows();
            widget.reload();
        }
        ScreenService.closeSwipe();
        widProdutos.activate();
    };
    
    this.adicionarProdutoGeral = function(widgetPrincipal) {
        var widget = widgetPrincipal.container.getWidget("adicaoProduto");
        var dados = widgetPrincipal.container.getWidget("dadosAF").currentRow;
        
        widget.oldRow = {};
        widget.currentRow = {};
        widget.currentRow.__createdLocal = true;
		widget.currentRow.__is_new = true;
		widget.currentRow.NOVO = true;
		widget.applyDefaultValue();
		widget.getField("NMMARCA").dataSourceFilter[0].value    = "";
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = "";
        widget.getField("NMMARCA").reload();
        widget.getField("NMSEGMARCA").reload();
        
        if (!dados.IDBAIXAAF)
			widget.getField("IDBAIXITMAF").setValue("0");
		else if (dados.IDBAIXAAF === "1")
			widget.getField("IDBAIXITMAF").setValue("1");
		else if (dados.IDBAIXAAF === "2")
			widget.getField("IDBAIXITMAF").setValue("2");
		
        widget.getField("NRPARCITMAF").setValue("01");
        widget.getField("IDBAIXITAFS").setValue("0");
        if(!widget.currentRow.PRECOTOTAL) {
            widget.getField("VRPERDESAF").setValue("0");
			widget.getField("PRECOTOTAL").setValue("0");
			widget.getField("VRDESCITMAF").setValue("0");
        }
        
        widget.currentRow.CDFILDEST  = dados.CDFILDEST;
        widget.currentRow.CDFILLANC  = dados.CDFILLANC;
        widget.currentRow.NRAUTOFORN = dados.NRAUTOFORN;
        widget.currentRow.CDFORNECED = dados.CDFORNECED;
        widget.currentRow.NRORG      = dados.NRORG;
        
        widget.getField('NMPRODUTO').readOnly = false;
        
        if(paraSupri.IDAUDALTAF === 'S') {
            widget.getField("TIPOJUST").isVisible = true;
            widget.getField("DSJUSTOPERMOV").isVisible = true;
            widget.currentRow.TIPOJUST = "P";
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("TIPOJUST").isVisible = false;
            widget.getField("DSJUSTOPERMOV").isVisible = false;
        }
        
        ScreenService.openSwipe(widget);
        widget.edit();
    };
    
    this.cancelarProdutoGeral = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.validaProdutoGeral = function(widget) {
        const dataSource = widget.getParent().dataSource.data;
        const sameProduct = permiteAdicionarProduto(widget);
        const productExists = dataSource.find(sameProduct);
        
        
        if (productExists) {
            /*if (paramDtEntrega == 'S') {
                MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
            } else {
                const params = {
                    PARAM: productExists.NMPRODUTO
                };
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
            }*/
            
            const params = {
                PARAM: productExists.NMPRODUTO
            };
            MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
            
            widget.currentRow.NMPRODUTO = "";
            widget.currentRow.CDPRODUTO = "";
            
            return false;
        }
        
        self.filtraMarca(widget);
    };
    
    this.salvarProdutoGeral = function(widget) {
        const dados = widget.container.getWidget("dadosAF");
        
        if(widget.currentRow.changed && paraSupri.IDAUDALTAF === 'S') {
			widget.getField("DSJUSTOPERMOV").validations.required = true;
		} else {
			widget.getField("DSJUSTOPERMOV").validations = {};    
		}
		
        if(widget.isValid()) {
            const sameProduct = permiteAdicionarProduto(widget);
            const productExists = widget.getParent().dataSource.data.find(sameProduct);
            
            if (productExists) {
                /*if (paramDtEntrega == 'S') {
                    MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
                } else {
                    const params = {
                        PARAM: productExists.NMPRODUTO
                    };
                    MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
                }*/
                
                const params = {
                    PARAM: productExists.NMPRODUTO
                };
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
                
                return;
            }
            
            validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
                widget.currentRow.OPERADOR = dados.currentRow.CDOPERADOR;
                
                ServiceLancamentoAF.retornaParametroCotacao(getLocalVar('CDFILCENTCMP')).then(function(res) {
                    var params = res.dataset.param[0];
                    widget.currentRow.IDCARPRECLAF = params.IDCARPRECLAF;
                    widget.currentRow.IDBLOQFORNCOTAF = params.IDBLOQFORNCOTAF;
                    widget.currentRow.CDOPERADORSEMREST = params.CDOPERADOR;
                    widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
                    widget.currentRow.CDFORNECED = dados.currentRow.CDFORNECED;
                    
                    ServiceLancamentoAF.validaProduto(widget.currentRow).then(function() {
                        ServiceLancamentoAF.validaFornecedor(dados.currentRow).then(function() {
                            widget.currentRow.VALIDADATA = false;
                            
                            MessageService.getMessageByCode("INSERT_ITEMAUTF").then( message => {
                                widget.currentRow.JUSTIFICATIVAS = [];
                                setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'I', message);
                                
                                ServiceLancamentoAF.salvarProduto(widget.currentRow, widget.oldRow, dados.currentRow).then(function() {
                                    verificaInconsistencias(widget);
                                }, function(err) {
                                    ScreenService.showMessage(err.data.error);
                                });
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    }); 
                });
            });
        }
    };
    
    function verificaInconsistencias(widget) {
        const inconsistWidget = widget.container.getWidget("inconsistencias");
        
        inconsistWidget.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,   "operator": "="},
            {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,   "operator": "="},
            {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,  "operator": "="},
            {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'),   "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),          "operator": "="}
        ];
        
        inconsistWidget.reload().then(function(callback) {
            if(inconsistWidget.dataSource.data.length > 0) {
                ScreenService.openPopup(inconsistWidget);
                MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
                widget.currentRow.__is_new = false;
                inconsistWidget.widgetAlterada = widget;
            } else {
                const widgetDadosAF = widget.container.getWidget("dadosAF");
                
                backListProducts();
                widget.currentRow.CDEMPRESA = widgetDadosAF.currentRow.CDEMPRESA;
                
                finalizaSalvaProduto(widget);
            }
        });
    }
    
    this.corrigirInconsistencias = function(widget) {
        const produtoWidget = templateManager.container.getWidget('produtos');
        
        produtoWidget.dataSourceSave = [];
        widget.lastActiveWidget.oldRow = angular.copy(widget.lastActiveWidget.currentRow);
        ScreenService.closePopup();
    };
    
    function finalizaSalvaProduto(widgetAlterada) {
        const produtoWidget = templateManager.container.getWidget('produtos');
        const rowDadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        verificaUtilizaWorkflow(rowDadosAF.CDFILLANC, rowDadosAF.CDFILDEST, rowDadosAF.NRAUTOFORN).then(function() {
            ScreenService.closePopup();
            self.atualizaValorTotal();
            
            if(widgetAlterada.name == "adicaoProduto") {
                widgetAlterada.getParent().reload();
                widgetAlterada.getParent().activate();
                MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
            } else {
                if(widgetAlterada.currentRow.NOVO) {
                    MessageService.successNotificationByCode('PRODUTO_SUCCESS_INSERT');
                } else {
                    produtoWidget.reload();
                    produtoWidget.list();
                    produtoWidget.dataSourceSave = [];
                    produtoWidget.activate();
                    
                    widgetAlterada.computeDescriptionOrder();
                    MessageService.successNotificationByCode('PRODUTO_SUCCESS_UPDATE');
                }
                
                widgetAlterada.reload();
                
                General.changeWidgetAcessibility(widgetAlterada.widgets, true);
            }
        }).catch(function(err) {
            if(err && err.data) { 
                ScreenService.showMessage(err.data.error);
            } else if (err !== 'PENDENTE') {
                ScreenService.showMessage(err);
            }
        });
    }
    
    this.ignorarInconsistencia = function(widget) {
        const widgetAlterada = widget.widgetAlterada;
        const rowDadosAF = widget.container.getWidget("dadosAF").currentRow;
        
        widgetAlterada.currentRow.VALIDADATA = false;
        widgetAlterada.currentRow.CDEMPRESA = rowDadosAF.CDEMPRESA;
        
        finalizaSalvaProduto(widgetAlterada);
    };
    
    this.atualizarInconsistencias = function(inconsistWidget, procedure, adicao) {
        var deferred = ZHPromise.defer();
        var dadosAF;
        var inconsistencias = inconsistWidget.dataSource.data;
        var limiteParam = [], inconsisParam = [];
        if(adicao)
            dadosAF = templateManager.container.getWidget("adicao_AF");
        else
            dadosAF = templateManager.container.getActiveWidget().lastActiveWidget;
            
        for(var i = 0; i < inconsistencias.length; i++) {
            if(inconsistencias[i].CDERRO[0] == "L")
                limiteParam.push(inconsistencias[i].CDERRO);
            else if(inconsistencias[i].CDERRO[0] == "I")
                inconsisParam.push(inconsistencias[i].CDERRO);
        }
		
		return ServiceLancamentoAF.atualizarInconsistencias([limiteParam, inconsisParam, [procedure], dadosAF.currentRow]).then(function(callback) {
		    if(callback.dataset.updateCdtpctpagar.length) {
                dadosAF.currentRow.CDTPCTPAGAR = callback.dataset.updateCdtpctpagar[0];
                dadosAF.currentRow.DSTPCTPAGAR = callback.dataset.updateCdtpctpagar[1];
		    }
            deferred.resolve();
			return deferred.promise;
		}, function(err) {
            deferred.reject(err.data.error);
        });
    };
    
    this.filtraMarca = function(widget) {
        widget.getField("NMMARCA").dataSourceFilter[0].value    = widget.currentRow.CDARVPROD;
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = widget.currentRow.CDARVPROD;
        widget.getField("NMMARCA").reload();
        widget.getField("NMSEGMARCA").reload();
        if(!widget.currentRow.NMPRODUTO) {
            widget.currentRow.NMMARCA = "";
            widget.currentRow.CDMARCA = "";
            widget.currentRow.NMSEGMARCA = "";
            widget.currentRow.CDSEGMARCA = "";
        } else {
            self.validaEdicaoPreco(widget);
        }
    };
    
    this.atualizaValores = function(field, row) {
        if (!row) {
            row = field.widget.currentRow;
        }
        
        row.PRECOTOTAL = General.valueToFloat(row.QTPROGENTAF) * General.valueToFloat(row.VRPREUNIAF);
		row.PRECOTOTAL = Util.applyMask(row.PRECOTOTAL, field.widget.getField("PRECOTOTAL").mask, maskEngine, ZhUtil);

		if(field.name == "VRPERDESAF") {
			if(General.valueToFloat(row.VRPERDESAF) < 0 || General.valueToFloat(row.VRPERDESAF) > 100) {
				MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
				row.VRPERDESAF = "0,00";
			}
		} else if(field.name == "VRDESCITMAF") {
			if(General.valueToFloat(row.VRDESCITMAF) < 0 || General.valueToFloat(row.VRDESCITMAF) > General.valueToFloat(row.PRECOTOTAL)) {
				MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
				row.VRDESCITMAF = "0,00000";
			}
		}

		if(field.name == 'VRDESCITMAF') {
			row.VRPERDESAF = General.valueToFloat(row.VRDESCITMAF)*100 / General.valueToFloat(row.PRECOTOTAL);
			row.VRPERDESAF = Util.applyMask(row.VRPERDESAF, field.widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
		} else {
			row.VRDESCITMAF = General.valueToFloat(row.VRPERDESAF)/100 * General.valueToFloat(row.PRECOTOTAL);
			row.VRDESCITMAF = Util.applyMask(row.VRDESCITMAF, field.widget.getField("VRDESCITMAF").mask, maskEngine, ZhUtil);
		}
        
        if(field.name == 'VRPREUNIAF') {
            verifyAdjustment(row, field);
        }
        
        if(field.name == 'VRINDICEITMAF') {
            verifyAdjustment(row, field);
        }
    };
    
    function verifyAdjustment(row, field){
        if (paraSupri.IDCARPRECLAF == "S" && paraSupri.IDBLOQFORNCOTAF == "S" && row.VRPREUNIAFORIG) {
            if(row.VRPREUNIAFORIG != row.VRPREUNIAF) {
        		ServiceLancamentoAF.getAdjustments(row).then(function(response) {
					if(response.dataset.adjustments) {
						const adjustmentValues = {
							VRACRESCIMO: General.valueToFloat(row.VRPREUNIAFORIG) * (General.valueToFloat(response.dataset.adjustments.VRPERCENTACRESCIMO)/100),
							VRDESCONTO: General.valueToFloat(row.VRPREUNIAFORIG) * (General.valueToFloat(response.dataset.adjustments.VRPERCENTDESCONTO)/100)
						};

						if(General.valueToFloat(row.VRPREUNIAF) > (General.valueToFloat(row.VRPREUNIAFORIG) +  adjustmentValues.VRACRESCIMO)) {
                            MessageService.showMessageByCode("ADJUSTMENT_ABOVE_ALLOWED", null, Constants.errorMessage);
                            field.clearValue();
                            return;
						}
						if(General.valueToFloat(row.VRPREUNIAF) < (General.valueToFloat(row.VRPREUNIAFORIG) -  adjustmentValues.VRDESCONTO)) {
						    MessageService.showMessageByCode("ADJUSTMENT_BELOW_ALLOWED", null, Constants.errorMessage);
						    field.clearValue();
						    return;
						}
					}
				});
        	}
        }
    }
    
    this.atualizaValoresComIndiceFinanceiro = function(widget) {
        let dadosAF;
        
        if (templateManager.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
            dadosAF = templateManager.container.getWidget('adicao_AF');
        } else {
            dadosAF = templateManager.container.getWidget('dadosAF');
        }
        
        const fieldPrecoUnitario = widget.getField('VRPREUNIAF');
        const valorIndice = dadosAF.currentRow.VRINDICE;
        
        const precoConvertido = General.valueToFloat(widget.currentRow.VRINDICEITMAF) * General.valueToFloat(valorIndice);
        
        fieldPrecoUnitario.setValue(precoConvertido);
        
        this.atualizaValores(fieldPrecoUnitario);
    };
    
    this.consultarPreco = function(widget) {
        if(!widget.currentRow.CDPRODUTO || !widget.currentRow.CDMARCA) {
            MessageService.showMessageByCode("PROD_MARCA_OBRIGATORIO");
            return false;
        } else {
            let consultaPreco = widget.container.getWidget("consultaPreco");
            let rowAF;
            
            if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('adicao_AF').currentRow;
			} else if(widget.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('dadosAF').currentRow;
			}
            
            consultaPreco.dataSourceFilter = [
                {"name": "CDPRODUTO",    "value": widget.currentRow.CDPRODUTO,       "operator": "="},
                {"name": "CDMARCA",      "value": widget.currentRow.CDMARCA,         "operator": "="},
                {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,      "operator": "="},
                
                {"name": "P_CDTPINDICECOL", "value": rowAF.CDTPINDICE ? rowAF.CDTPINDICE : null, "operator": "="},
                {"name": "P_IDPERVALORCOL", "value": rowAF.IDPERVALOR ? rowAF.IDPERVALOR : null, "operator": "="},
                {"name": "P_CDINDICECOL",   "value": rowAF.CDINDICE   ? rowAF.CDINDICE   : null, "operator": "="},
                {"name": "P_DTREFINDCOL",   "value": rowAF.DTREFIND   ? rowAF.DTREFIND   : null, "operator": "="}
            ];
            consultaPreco.reload().then(function(callback) {
                if(callback.dataset.consultaPrecoUltAF.length == 0) {
                    MessageService.showMessageByCode("N_VLR_AF_CADASTRADO");
                } else {
                    ScreenService.openPopup(consultaPreco);
                }
            });
        }
    };
    
    this.filtrosDependentes = function(widget) {
        const widgetEditProducts = widget.container.getWidget("editProducts");
        const widgetImpostos = widget.container.getWidget("impostos");
        const widgetEntregaBaixaManual = widget.container.getWidget("entregaBaixaManual");
        const parentWidget = widgetEditProducts.getParent();
        const widgetObservacao = templateManager.container.getWidget('observacao');
        
        if(widget.editing){
            if(!allowsEditItem(widget.currentRow)) {
            	MessageService.showMessageByCode("CHANGE_NOT_ALLOWED", null, Constants.errorMessage);
                return; 
            }
        }
        
        //Produtos
        widgetEditProducts.dataSourceFilter = [
            {   "name": "CDFILLANC",    "operator": "=",    "value": widget.currentRow.CDFILLANC   },
            {   "name": "NRAUTOFORN",   "operator": "=",    "value": widget.currentRow.NRAUTOFORN  },
            {   "name": "CDFILDEST",    "operator": "=",    "value": widget.currentRow.CDFILDEST   },
            {   "name": "CDPRODUTO",    "operator": "=",    "value": widget.currentRow.CDPRODUTO   }
        ];
        
        // IMPOSTOS
        widgetImpostos.dataSourceFilter = [
            {"name": "CDFILDEST",     "value": widget.currentRow.CDFILDEST,      "operator": "="},
            {"name": "CDFILLANC",     "value": widget.currentRow.CDFILLANC,      "operator": "="},
            {"name": "NRAUTOFORN",    "value": widget.currentRow.NRAUTOFORN,     "operator": "="},
            {"name": "CDPRODUTO",     "value": widget.currentRow.CDPRODUTO,      "operator": "="},
            {"name": "CDMARCA",       "value": widget.currentRow.CDMARCA,        "operator": "="},
            {"name": "DTPROGENTAF",   "value": widget.currentRow.DTPROGENTAF,    "operator": "="}
        ];
        widgetImpostos.reload();
        
        // ENTREGA/BAIXA MANUAL
        widgetEntregaBaixaManual.dataSourceFilter = [
            {"name": "CDFILDEST",     "value": widget.currentRow.CDFILDEST,      "operator": "="},
            {"name": "CDFILLANC",     "value": widget.currentRow.CDFILLANC,      "operator": "="},
            {"name": "NRAUTOFORN",    "value": widget.currentRow.NRAUTOFORN,     "operator": "="},
            {"name": "CDPRODUTO",     "value": widget.currentRow.CDPRODUTO,      "operator": "="},
            {"name": "CDMARCA",       "value": widget.currentRow.CDMARCA,        "operator": "="},
            {"name": "DTPROGENTAF",   "value": widget.currentRow.DTPROGENTAF,    "operator": "="}
        ];
        widgetEntregaBaixaManual.reload();
        
        //Observação
        widgetObservacao.currentRow = widget.currentRow;
        
        self.validaBaixaItem(widget.container.getWidget("entregaBaixaManual"));
        //self.validaEdicaoPreco(widget);
        
        if(widget.editing){
            widgetEditProducts.showCheckbox = false;
            widgetEditProducts.editing = true;
            widgetEditProducts.edit();
        
            widgetEditProducts.getField('PRECOBUTTON').readOnly = false;
        
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabEditProducts").widgets, false);
        } else {
            widgetEditProducts.showCheckbox = true;
            widgetEditProducts.list();
            
            widgetEditProducts.getField('PRECOBUTTON').readOnly = true;
            
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabEditProducts").widgets, true);
        }
        
        widgetEditProducts.currentRow = widget.currentRow;
        widgetEditProducts.backupRow = angular.copy(widget.currentRow);
        
        if(paraSupri.IDAUDALTAF === 'S') {
            widgetEditProducts.getField("TIPOJUST").isVisible = true;
            widgetEditProducts.getField("DSJUSTOPERMOV").isVisible = true;
            widgetEditProducts.currentRow.TIPOJUST = "P";
            widgetEditProducts.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widgetEditProducts.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widgetEditProducts.getField("TIPOJUST").isVisible = false;
            widgetEditProducts.getField("DSJUSTOPERMOV").isVisible = false;
        }
        
        parentWidget.activate();
        ScreenService.openSwipe(parentWidget);
    };
    
    function allowsEditItem(row) {
        const dadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        return dadosAF.IDBAIXAAF != '2' &&
               dadosAF.IDBAIXAAF != '3' &&
               dadosAF.IDBAIXAAF != '4' &&
               dadosAF.IDBAIXAAF != '5' &&
               row.IDBAIXITMAF != '1' &&
               row.IDBAIXITMAF != '2' &&
               row.IDBAIXITMAF != '3' &&
               (dadosAF.IDBAIXAFSAI == '1' || !dadosAF.IDBAIXAFSAI) &&
               !dadosAF.CDFILDESTCON &&
               dadosAF.IDITMSEPARADO != 'S' &&
               dadosAF.IDAFEXPIRADA != 'S';
    } 
    
    this.selecionaPreco = function(widget) {
        const wid = widget.lastActiveWidget;
        
        if(usaIndiceFinanceiro()) {
        	wid.getField("VRPREUNIAF").setValue(widget.currentRow.VRPREUNIAF);
        	wid.getField("VRINDICEITMAF").setValue(widget.currentRow.VRINDICEITMAF);
        } else {
            wid.getField("VRPREUNIAF").setValue(widget.currentRow.VRPREUNIAF);
        }
        
		this.atualizaValores(wid.getField("VRPREUNIAF"));
		ScreenService.closePopup();
    };
    
    function MarcaField(isMarcaPrincipal) {
        this.baseField = isMarcaPrincipal ? '' : 'SEG';
        this.code = `CD${this.baseField}MARCA`;
        this.name = `NM${this.baseField}MARCA`;
    }
    
    function validaCampoMarca({ dataset, currentRow, backupRow, isMarcaPrincipal = true }) {
        const marcaField = new MarcaField(isMarcaPrincipal);
        
        const isDeliveryDateEquals = function(currentItem, currentRow, isMarcaPrincipal) {
            if (!isMarcaPrincipal) return true;
            
            return currentItem.DTPROGENTAF == currentRow.DTPROGENTAF;
        };
        
        /**
         * No modo de Edição, compara primeiro com a backupRow e, depois, com
         * os demais itens.
         */
        /*if (backupRow) {
            if (
                currentRow.CDPRODUTO == backupRow.CDPRODUTO &&
                currentRow[marcaField.code] == backupRow[marcaField.code] &&
                isDeliveryDateEquals(currentRow, backupRow, isMarcaPrincipal)
            ) {
                return true;
            }
        }*/
        
        for (let i = 0; i < dataset.length; i++) {
            let currentItem = dataset[i];
            
            if (currentItem.CDPRODUTO && currentItem.CDPRODUTO !== currentRow.CDPRODUTO) {
                if (currentItem[marcaField.code] == currentRow[marcaField.code] && isDeliveryDateEquals(currentItem, currentRow, isMarcaPrincipal)) {
                    ScreenService.showMessage(`Parcela já cadastrada para a${isMarcaPrincipal ? '' : ' segunda'} marca ${currentRow[marcaField.name]}.`);
                    
                    if (!backupRow) {
                        currentRow[marcaField.code] = "";
                        currentRow[marcaField.name] = "";
                    }
                    
                    return false;
                }
            }
        }
        
        return true;
    }
    
    this.voltarProdutoDetalhes = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };
    
    this.filtraSegundaMarca = function(widget) {
        if(widget.currentRow.NMMARCA) {
            widget.getField("NMSEGMARCA").dataSourceFilter[2] = {
                "name": "CDMARCA",
                "operator": "<>",
                "value": widget.currentRow.CDMARCA
            };
        } else {
            widget.getField("NMSEGMARCA").dataSourceFilter = [
                widget.getField("NMSEGMARCA").dataSourceFilter[0],
                widget.getField("NMSEGMARCA").dataSourceFilter[1]
            ];
        }
        widget.getField("NMSEGMARCA").reload();
    };
    
    /**
     * Return an JavaScript Date object.
     */
    function getDateFromString(date, formatter) {
        if (!date) return null;
        
        return moment(date, 'DD/MM/YYYY').toDate();
    }
    
    function validaMultiplasDatasEntrega(data, currentRow) {
    	if(data.length === 0)
    	    return false;

    	if(!currentRow.__is_new)
            return [...new Set(data.map(row => row.DTPROGENTAF))].length > 1;
    	
    	return [...new Set(data.map(row => row.DTPROGENTAF))].filter(filter => filter === currentRow.DTPROGENTAF).length === 0;
    }
    
    function setCurrentRowProduto(widget) {
        const currentRow = widget.currentRow;
        
        currentRow.CDTPINDICECOL = null;
		currentRow.IDPERVALORCOL = null;
		currentRow.CDINDICECOL = null;
		currentRow.DTREFINDCOL = null;
		
		if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
			const row = widget.container.getWidget('adicao_AF').currentRow;
			
		    currentRow.CDFORNECED = row.CDFORNECED;
		}
        
        if(usaIndiceFinanceiro()) {
            let rowAF;
			
			if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('adicao_AF').currentRow;
			} else if(widget.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('dadosAF').currentRow;
			}		

			currentRow.CDTPINDICECOL = rowAF.CDTPINDICE ? rowAF.CDTPINDICE : null;
            currentRow.IDPERVALORCOL = rowAF.IDPERVALOR ? rowAF.IDPERVALOR : null;
            currentRow.CDINDICECOL = rowAF.CDINDICE ? rowAF.CDINDICE : null;
            currentRow.DTREFINDCOL = rowAF.DTREFIND ? rowAF.DTREFIND : null;	
        }
        
        return currentRow;
        
    }
    
    function getCotacao(widget) {
        const currentRow = setCurrentRowProduto(widget);
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        let fieldPreco = widget.getField("VRPREUNIAF");
        let fieldMarca = widget.getField("NMMARCA");
        let fieldIndice = widget.getField("VRINDICEITMAF");
        
        ServiceLancamentoAF.validaDataEntrega(currentRow).then(function(response) {
              
            if (!Util.isEmptyOrBlank(response.dataset)) {
                if (!Util.isEmptyOrBlank(response.dataset.cotacao)) {
                    if(!Util.isEmptyOrBlank(response.dataset.cotacao[0])) {
                		const cotacao = response.dataset.cotacao[0];
                	    
                	    widget.currentRow.VRPREUNIAFORIG = cotacao[0].VRPRECUNIITM;
                	    fieldPreco.value(cotacao[0].VRPRECUNIITM);
						if(usaIndiceFinanceiro()) {
							fieldIndice.value(cotacao[0].VRINDICEITMCOL);
						}
						fieldMarca.setValue(cotacao[0].NMMARCA);
						widget.currentRow.CDMARCA = cotacao[0].CDMARCA;
                	}
                	if(response.dataset.cotacao[1]) {
                		if(usaIndiceFinanceiro()) {
							fieldIndice.readOnly = false;
						} else {
						    fieldPreco.readOnly = false;
						}
                	}
                    
                    self.validaMarca(widget);
                } else {
            		widget.currentRow.VRPREUNIAFORIG = null;
            	    fieldPreco.value(null);
					if(usaIndiceFinanceiro()) {
						fieldIndice.value(null);
					}
            	}       				
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error).then(function(){
                clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
            });
        });
    }
    
    this.validaDataEntrega = function(widget, dadosAF, validaMarca) {
        const currentRow = widget.currentRow;
        const dataEntrega = getDateFromString(currentRow.DTPROGENTAF, 'DD/MM/YYYY');
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        let fieldPreco = widget.getField("VRPREUNIAF");
        let fieldMarca = widget.getField("NMMARCA");
        let fieldIndice = widget.getField("VRINDICEITMAF");
        
        if (dataEntrega) {
            const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');  
            const dataAF      = getDateFromString(dadosAF.currentRow.DTAUTOFORN, 'DD/MM/YYYY');
            
            currentRow.DTPROGBKP   = widget.backupRow ? widget.backupRow.DTPROGENTAF : currentRow.DTPROGENTAF;
            currentRow.DTAUTOFORN  = dadosAF.currentRow.DTAUTOFORN;
            currentRow.BLOQ_MULT_DATAS = paramDtEntrega;
            currentRow.OPERADOR   = dadosAF.currentRow.CDOPERADOR;
            
            if(!basicDeliveryDateValidation({
                dataEntrega,
                dataAtual,
                dataAF
            })) return;
            
            if(currentRow.DTPROGENTAF) {
                if(currentRow.BLOQ_MULT_DATAS && currentRow.BLOQ_MULT_DATAS === 'S') {
                    let widgetData = '';
                    
                    if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
                        widgetData = widget.container.getWidget("adicao_produtos").dataSourceAuxiliar;
                    } else {
                        widgetData = widget.container.getWidget('produtos').dataSource.data;    
                    }
                    
                    if(validaMultiplasDatasEntrega(widgetData, currentRow)) {
                        widget.currentRow.UPDATE_ALL_ITENS = 'N';
                        
                        if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
                            MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF", null, Constants.confirmationMessage);
							clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
                        } else {
                            MessageService.confirmMessageByCode("QUESTION_SOMENTE_UMA_DTPROGENTAF", null, Constants.confirmationMessage).then(function() {
                                widget.currentRow.UPDATE_ALL_ITENS = 'S';
                                getCotacao(widget);
                            }).catch(function() {
                                clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
                            });    
                        }
                    } else {
                        getCotacao(widget);
                    }
                }
            } else {
                MessageService.showMessageByCode('INVALID_DATE', null, Constants.alertMessage);
            }
        }
    };
    
    function clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca){
        fieldDataEntrega.clearValue(fieldDataEntrega);
        fieldPreco.clearValue(fieldPreco);
        fieldMarca.clearValue(fieldMarca);
    }
    
    this.validaProduto = function(widget, dadosAF) {
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        const fieldProduto = widget.getField('NMPRODUTO');
        
        fieldDataEntrega.clearValue(fieldDataEntrega);
        
        if(widget.currentRow.NMPRODUTO) {
            
            widget.currentRow.OPERADOR = dadosAF.currentRow.CDOPERADOR;
            widget.currentRow.CDFORNECED = dadosAF.currentRow.CDFORNECED;
            
            ServiceLancamentoAF.validaProduto(widget.currentRow).then(function(response) {
                if (!Util.isEmptyOrBlank(response.dataset)) {
                    if (!Util.isEmptyOrBlank(response.dataset.message)) {
                        const error = {
        					"NMPRODUTO": widget.currentRow.NMPRODUTO, 
        					"NMUNIDADE": dadosAF.currentRow.NMFILDEST
        				};
        				fieldProduto.clearValue(fieldProduto);
        				MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                    } else {
                        self.filtraMarca(widget);    
                    }
                }
            }, function(err) {
                ScreenService.showMessage(err);
            });
        }
    };
    
    this.validaMarca = function(widget) {
        const currentRow = widget.currentRow;

        isMarcaDiferente(currentRow).catch(function(currentRow) {
            const fieldsName = [ 'CDMARCA', 'NMMARCA', 'CDSEGMARCA', 'NMSEGMARCA' ];
            
            fieldsName.forEach(name => currentRow[name] = '');
        });
    };

    self.validaEdicaoPreco = function (widProduto) {
        var fieldPreco = widProduto.getField("VRPREUNIAF");
        var fieldMarca = widProduto.getField("NMMARCA");
        var botaoPreco = widProduto.getField("PRECOBUTTON");
        var precoTotal = widProduto.getField("PRECOTOTAL");
        var centralCompras = getLocalVar('CDFILCENTCMP');
        const fieldIndice = widProduto.getField("VRINDICEITMAF");
        
        ServiceLancamentoAF.retornaParametroCotacao(centralCompras).then(function(res) {
            var params = res.dataset.param[0];
            
            widProduto.currentRow.IDCARPRECLAF = params.IDCARPRECLAF;
            widProduto.currentRow.IDBLOQFORNCOTAF = params.IDBLOQFORNCOTAF;
            widProduto.currentRow.CDOPERADORSEMREST = params.CDOPERADOR;
            
            if (params.IDCARPRECLAF == 'S' && !usaIndiceFinanceiro()) {
                if (params.IDBLOQFORNCOTAF == "S") {
                    botaoPreco.isVisible = false;
                    precoTotal.class = 6;
                    if (getLocalVar("CDOPERADOR") == params.CDOPERADOR) {
                        fieldPreco.readOnly = false;
                        fieldPreco.readOnlyOnEdit = false;
                        fieldMarca.readOnly = false;
                    } else {
                        if(widProduto.currentRow.CDARVPROD) {
                    	    ServiceLancamentoAF.getAdjustments(widProduto.currentRow).then(function(response) {
								if(response.dataset.adjustments.length > 0) {
									fieldPreco.readOnly = false;
									fieldPreco.readOnlyOnEdit = false;
									fieldMarca.readOnly = true;
								} else {
									fieldPreco.readOnly = true;
									fieldPreco.readOnlyOnEdit = true;
									fieldMarca.readOnly = true;	
								}
							});	
                    	} else {
                    	    fieldPreco.readOnly = true;
							fieldPreco.readOnlyOnEdit = true;
							fieldMarca.readOnly = true;		
                    	}
                    }
                } else {
                    botaoPreco.isVisible = true;
                    precoTotal.class = 12;
                    fieldPreco.readOnly = false;
                    fieldPreco.readOnlyOnEdit = false;
                    fieldMarca.readOnly = false;
                }
            } else if (params.IDCARPRECLAF == 'S' && usaIndiceFinanceiro()) {
                if (params.IDBLOQFORNCOTAF == "S") {
                    botaoPreco.isVisible = false;
                    precoTotal.class = 6;
                    fieldPreco.readOnly = true;
                    fieldPreco.readOnlyOnEdit = true;
                    fieldMarca.readOnly = true;
                    if (getLocalVar("CDOPERADOR") == params.CDOPERADOR) {
                        fieldIndice.readOnly = false;
                        fieldIndice.readOnlyOnEdit = false;
                        fieldIndice.readOnly = false;
                    } else {
                        fieldIndice.readOnly = true;
                        fieldIndice.readOnlyOnEdit = true;
                        fieldIndice.readOnly = true;
                    }
                } else {
                    botaoPreco.isVisible = true;
                    precoTotal.class = 12;
                    fieldPreco.readOnly = true;
                    fieldPreco.readOnlyOnEdit = true;
                    fieldPreco.readOnly = true;
                    fieldIndice.readOnly = false;
                    fieldIndice.readOnlyOnEdit = false;
                    fieldIndice.readOnly = false;
                }
            }
            
            if (widProduto.mode == 'view' || widProduto.mode == 'list'){
                botaoPreco.isVisible = false;
                precoTotal.class = 6;
            } else {
                botaoPreco.isVisible = true;
                precoTotal.class = 12;
            }
        });
    };
    
    self.setPrecoCotacao = function(widProduto) {
        if(widProduto.currentRow.IDCARPRECLAF == "S") {
            var fieldPreco = widProduto.getField("VRPREUNIAF");
            var fieldMarca = widProduto.getField("NMMARCA");
            var fieldProduto = widProduto.getField("NMPRODUTO");
            var rowAdicao = widProduto.container.getWidget("adicao_AF").currentRow;
            var addRow = {CDFILCENTCMP: getLocalVar('CDFILCENTCMP'), CDFORNECED: rowAdicao.CDFORNECED};
            var currentRow = Object.assign(widProduto.currentRow, addRow);
            fieldPreco.value("");
            fieldMarca.setValue("");
            if(fieldProduto.value() !== "") {
                ServiceLancamentoAF.retornaCotacaoProduto(currentRow)
                .then(
                    function(res) {
                        var valor = res.dataset.cotacao[0].VRPRECUNIITM;
                        var cdMarca = res.dataset.cotacao[0].CDMARCA;
                        var nmMarca = res.dataset.cotacao[0].NMMARCA;
                        fieldPreco.value(valor);
                        fieldMarca.setValue(nmMarca);
                        widProduto.currentRow.CDMARCA = cdMarca;
                    },
                    function(err) {
                        if(widProduto.currentRow.IDBLOQFORNCOTAF == "S" && rowAdicao.CDOPERADOR != widProduto.currentRow.CDOPERADORSEMREST) {
                            ScreenService.showMessage(err.data.error);
                            fieldPreco.value("");
                            fieldProduto.setValue("");
                            fieldMarca.setValue("");
                            widProduto.currentRow.CDMARCA = "";
                        }
                    }
                );
            }
        }
    };
    
    this.controlaFieldQtd = function (widget) {
        if(widget.currentRow.IDBAIXITMAF == '3' || widget.currentRow.IDBAIXITMAF == '2'){
            widget.getField("baixarEntregaBaixa").readOnly = true;
        }else{
            widget.getAction("baixarEntregaBaixa").readOnly = false;
        }
    };
    
    function basicDeliveryDateValidation({ dataEntrega, dataAtual, dataAF, showMessage = true }) {
        if(dataEntrega < dataAtual && dataEntrega < dataAF) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTATUAL&&DTAUTOFORN', null, Constants.alertMessage);
            return false;   
        }
        
        if (dataEntrega < dataAtual) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTATUAL', null, Constants.alertMessage);
            return false;
        }
        
        if (dataEntrega < dataAF) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTAUTOFORN', null, Constants.alertMessage);
            return false;
        }
        
        return true;
    }
    
    /*************************************************************************************/
    /*                                 FUNÇÕES 'IMPOSTOS'                                */
    /*************************************************************************************/
    
    this.calculaValorImposto = function(row, name) {
        var produto = templateManager.container.getWidget("produtos").currentRow;
        var imposto = templateManager.container.getWidget("impostos");
        
        row.VRIMPITMAF  = Util.applyMask(row.VRIMPITMAF,  imposto.getField("VRIMPITMAF").mask,  maskEngine, ZhUtil);
        row.VRALIQITMAF = Util.applyMask(row.VRALIQITMAF, imposto.getField("VRALIQITMAF").mask, maskEngine, ZhUtil);
        
        if(row.changed) {
            if(!row.changed_VRIMPITMAF && row.changed_VRIMPITMAF != 0)
                row.changed_VRIMPITMAF = row.VRIMPITMAF;
            if(!row.changed_VRALIQITMAF && row.changed_VRALIQITMAF != 0)
                    row.changed_VRALIQITMAF = row.VRALIQITMAF;
                    
            if(name == "aliquota")
                imposto.getField("VRIMPITMAF").setValue(General.valueToFloat(row.VRALIQITMAF) * General.valueToFloat(produto.PRECOTOTAL) / 100);
            else if(name == "imposto")
                imposto.getField("VRALIQITMAF").setValue(General.valueToFloat(row.VRIMPITMAF) / General.valueToFloat(produto.PRECOTOTAL) * 100);
            
            if(General.valueToFloat(row.changed_VRALIQITMAF) == General.valueToFloat(row.VRALIQITMAF))
                row.changed = false;
        }
    };
    
    this.saveEditImposto = function(widget) {
        var impostos = widget.dataSource.data.filter(function(row) {
            return row.changed;
        });
        auxRow = [];
        auxRow[0] = impostos;
        auxRow[1] = [];
        if(paramAuditoria && impostos.length) {
            auxContador = 0;
            self.definirParametrosImpostos(impostos[auxContador], "impostos");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            ServiceLancamentoAF.salvarImposto(impostos).then(function() {
                widget.commitInlineEdit();
                widget.list();
                MessageService.successNotificationByCode('IMPOSTOS_SUCCESS_UPDATE');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelEditImposto = function(args) {
		args.owner.rollbackInlineEdit();
		args.owner.list();
		args.owner.reload();
    };
    
    /*************************************************************************************/
    /*                            FUNÇÕES 'BAIXA/ENTREGA MANUAL'                         */
    /*************************************************************************************/
    
    function getItensParaBaixar(widget) {
        const widProdutos = widget.container.getWidget("produtos");
        
        return widProdutos.hasCheckedRows() ? widProdutos.getCheckedRows() : [ widget.currentRow ];
    }
    
    this.baixarEntregaBaixa = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        let produto = widgetProdutos.currentRow;
        let dadosAF = widget.container.getWidget("dadosAF");
        const produtos = getItensParaBaixar(widgetProdutos);
        const baixaMultipla = widgetProdutos.hasCheckedRows();
        
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(function() {
            const produtoReferencia = produtos[0];
            const dataProcessa = getLocalVar('DTPROCESSA');
            const dataEntrega  = produtoReferencia.DTPROGENTAF ? moment(produtoReferencia.DTPROGENTAF, 'DD/MM/YYYY')._d : null;
            
            if (dataEntrega > dataProcessa) {
                MessageService.showMessageByCode("DOWNLOAD_AF_ERRO_DTA_PROC");
                return false;
            }
            
            produtos.forEach(produto => {
                produto.VALOR_IDBAIXITMAF = 3;
                
                if (produto.IDBAIXITMAF != "2" && produto.IDBAIXITAFS != "2")
                    produto.IDBAIXITMAF_BKP = 3;
            });
            
            if (paramAuditoria && (produtoReferencia.IDBAIXITMAF_BKP == 3)) {
                self.definirParametrosBaixaItem(produto, "baixarItem_AF", baixaMultipla);
            } else {
                baixarItemAF({
                    widget,
                    widgetAF: dadosAF,
                });
            }
        }.bind(this));
    };
    
    function allowsBaixaItem(row) {
        const dadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        return row.IDBAIXITMAF != '2' &&
               row.IDBAIXITMAF != '3' &&
               dadosAF.IDBAIXAAF != '4' &&
               dadosAF.IDBAIXAAF != '5' &&
               dadosAF.IDAFEXPIRADA != 'S'&&
               dadosAF.IDITMSEPARADO != 'S' &&
               (dadosAF.IDBAIXAFSAI == '1' || !dadosAF.IDBAIXAFSAI) &&
               (dadosAF.IDAFOPERLOG != '1' || dadosAF.CDFILIOPELOG.length > 0);
        
    }
    
    this.validaBaixaItem = function(widget) {
        if (allowsBaixaItem(widget.currentRow))
            widget.getAction("baixarEntregaBaixa").isVisible = true;
        else
            widget.getAction("baixarEntregaBaixa").isVisible = false;
    };
    
    function aplicarMascara(widget, fieldName) {
        return Util.applyMask(widget.currentRow[fieldName], widget.getField(fieldName).mask, maskEngine, ZhUtil);
    }
    
    function produtoTemBaixa(produto) {
        return !!produto.DTBAIXITMAF && !!produto.NMOPERBAIXA;
    }
    
    this.valoresFooter = function(entregaBaixaManual) {
        const footer = templateManager.container.getWidget('footerEntregaBaixa');
        const dadosEntregaBaixaManual = entregaBaixaManual.dataSource.data[0];
        const produtoAtual = templateManager.container.getWidget("produtos").currentRow;
        const quantidadeProduto = produtoAtual.QTPROGENTAF;
        
        if (dadosEntregaBaixaManual && quantidadeProduto) {
            footer.currentRow.TOTALENTRADAS  = dadosEntregaBaixaManual.QTEFETENTRAF;
            footer.currentRow.QTDNAOENTREGUE = quantidadeProduto - dadosEntregaBaixaManual.QTEFETENTRAF;
            
        } else {
            footer.currentRow.TOTALENTRADAS = 0.0;
            footer.currentRow.QTDNAOENTREGUE = quantidadeProduto;
        }
        
        footer.currentRow.BAIXAMANUAL = produtoTemBaixa(produtoAtual) ? `${produtoAtual.DTBAIXITMAF} - ${produtoAtual.NMOPERBAIXA}` : '';
        
        footer.currentRow.QTDNAOENTREGUE = aplicarMascara(footer, 'QTDNAOENTREGUE');
        footer.currentRow.TOTALENTRADAS = aplicarMascara(footer, 'TOTALENTRADAS');
    };
    
    this.controlaActionBaixar = function (widget) {
        var widProdutos = templateManager.container.getWidget('produtos');
        if(widProdutos.currentRow.IDBAIXITMAF == '3' || widProdutos.currentRow.IDBAIXITMAF == '2'){
            widget.getAction("baixarEntregaBaixa").isVisible = false;
        }else{
            widget.getAction("baixarEntregaBaixa").isVisible = true;
        }
    };
    
    /*************************************************************************************/
    /*                               FUNÇÕES 'OBSERVAÇÕES'                               */
    /*************************************************************************************/
    
    this.carregaObservacao = function() {
        var widget = templateManager.container.getWidget("observacao");
        ServiceLancamentoAF.itemautf(widget.container.getWidget("produtos").currentRow).then(function(callback) {
            widget.currentRow = callback.dataset.itemautf[0];
            widget.view();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.editarObservacao = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.cancelarObservacao = function(widget) {
        General.widgetCancelForm(widget);
    };
    
    this.salvarObservacao = function(widget) {
        ServiceLancamentoAF.itemautfSave(widget.currentRow).then(function(callback) {
            General.formWidgetSwitchTemplate(widget);
            General.changeWidgetAcessibility(widget.getParent().widgets, true);
            General.changeWidgetAcessibility([widget.getParent()], true);
            widget.view();
            MessageService.successNotificationByCode('OBS_SUCCESS_UPDATE');
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    /*************************************************************************************/
    /*                               FUNÇÕES 'MENSAGEM'                                  */
    /*************************************************************************************/ 
    
    this.adicionarMensagem = function(widget, dadosAF) {
        ServiceLancamentoAF.novoCodigoMensagem(dadosAF.currentRow).then(function(callback) {
            General.widgetNewRow(widget);
            widget.currentRow.NRMENSAUTFOR = callback.dataset.novoCodigo[0].toString().padStart(2, "0");
            widget.currentRow.CDFILDEST    = dadosAF.currentRow.CDFILDEST;
            widget.currentRow.CDFILLANC    = dadosAF.currentRow.CDFILLANC;
            widget.currentRow.NRAUTOFORN   = dadosAF.currentRow.NRAUTOFORN;
            widget.currentRow.NRORG        = dadosAF.currentRow.NRORG;
            widget.currentRow.TIPOMENS     = "P";
            self.carregaTipoMensagem(widget);
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.editarMensagem = function(widget) {
        General.edit(widget);
    };
    
    this.voltarMensagem = function(args) {
        General.backOrCancel(args);
    };
    
    this.cancelarMensagem = function(args) {
        General.backOrCancel(args);
    };
    
    this.salvarMensagem = function(widget) {
        if (widget.isValid()) {
            ServiceLancamentoAF.salvarMensagem(widget.currentRow).then(function() {
                const widgetDadosAF = templateManager.container.getWidget("dadosAF");
                
                return ServiceLancamentoAF.salvarDadosAF(widgetDadosAF.currentRow);
            }).then(function() {
                if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.computeDescriptionOrder();
					widget.view();
				}
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.excluirMensagem = function(widget) {
        ScreenService.confirmMessage("Confirma exclusão da mensagem?", "INFORMATION", function() {
            ServiceLancamentoAF.excluirMensagem(widget.currentRow).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.mudaMensagem = function(widget) {
        widget.currentRow.DSMENSAF = "";
        if(widget.currentRow.TIPOMENS == "P")
            widget.getField("DSMENSAF").template = "zh-select-autocomplete#field/select-autocomplete.html";
        else
            widget.getField("DSMENSAF").template = "field/text-edit.html";
    };
    
    this.carregaTipoMensagem = function(widget) {
        if(widget.currentRow.TIPOMENS == "P")
            widget.getField("DSMENSAF").template = "zh-select-autocomplete#field/select-autocomplete.html";
        else
            widget.getField("DSMENSAF").template = "field/text-edit.html";
    };
    
    
    /*************************************************************************************/
    /*                          FUNÇÕES 'FORMA DE PAGAMENTO'                             */
    /*************************************************************************************/
    
    
    this.carregaFormaPagamento = function(widget) {
        var dados = widget.container.getWidget("dadosAF").currentRow;
        ServiceLancamentoAF.formaPagamento(dados).then(function(callback) {
            widget.currentRow = callback.dataset.af_formaPagamento[0];
            self.exibicaoFormaPagamento(widget);
            widget.view();
            
            widget.container.getWidget("prazoPercentual").dataSourceFilter = [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,       "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,      "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ];
            widget.container.getWidget("prazoPercentual").reload();
            General.justInteger('#NRDIAPGFIXAF');
            General.justInteger('#NRPARCPGTOAF');
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function sanitizaNomeFormaPagamento(widget) {
        return widget.name === 'formaPagamento' ? 'IDTPFORPGTAF' : 'IDTPFORPGTFO';
    }
    
    this.exibicaoFormaPagamento = function(widget) {
        const nomeFormaPagamento = sanitizaNomeFormaPagamento(widget);
        const formaPagamento = widget.currentRow[nomeFormaPagamento];
        
        switch (formaPagamento) {
			default:
				widget.getField('NRDIAPGFIXAF').isVisible   = false;
				widget.getField('NRPARCPGTOAF').isVisible   = false;
				widget.getField('IDUTDIAPGTAF').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXAF').validations = {};
				widget.getField('NRPARCPGTOAF').validations = {};
				break;
			case 'F':
				widget.getField('NRDIAPGFIXAF').isVisible   = true;
				widget.getField('NRPARCPGTOAF').isVisible   = true;
				widget.getField('IDUTDIAPGTAF').isVisible   = true;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXAF').validations = {required: true};
				widget.getField('NRPARCPGTOAF').validations = {required: true};
				break;
			case 'V':
				widget.getField('NRDIAPGFIXAF').isVisible   = false;
				widget.getField('NRPARCPGTOAF').isVisible   = false;
				widget.getField('IDUTDIAPGTAF').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = true;
				widget.getField('PRAZOSBUTTON').isVisible   = true;
				widget.getField('NMFORMPGTO').validations   = {required: true};
				widget.getField('NRDIAPGFIXAF').validations = {};
				widget.getField('NRPARCPGTOAF').validations = {};
				break;
		}
    };
    
    this.abrePrazoPercentual = function(widget) {
        if(widget.isValid() || widget.mode == "view")
            ScreenService.openPopup(widget.container.getWidget("prazoPercentual"));
    };
    
    this.editarFormaPagamento = function(widget) {
        var prazo = widget.container.getWidget("prazoPercentual");
        prazo.backupData = angular.copy(prazo.dataSource.data);
        prazo.showCheckbox = true;
        prazo.getAction("adicionarPrazo").isVisible = true;
        prazo.getField("NRDIASPGTOAF").inlineEditable = "number";
        prazo.getField("VRPERCPGTOAF").inlineEditable = "number";
        General.widgetEdit(widget);
    };
    
    this.cancelarFormaPagamento = function(widget) {
        var prazo = widget.container.getWidget("prazoPercentual");
        prazo.reload();
        prazo.showCheckbox = false;
        prazo.getAction("adicionarPrazo").isVisible = false;
        prazo.getField("NRDIASPGTOAF").inlineEditable = "number";
        prazo.getField("VRPERCPGTOAF").inlineEditable = "number";
        General.widgetCancelForm(widget);
        this.exibicaoFormaPagamento(widget);
    };
    
    this.salvarFormaPagamento = function(widget) {
        widget.currentRow.NRDIAPGFIXAF = widget.currentRow.NRDIAPGFIXAF ? widget.currentRow.NRDIAPGFIXAF : "";
        widget.currentRow.NRPARCPGTOAF = widget.currentRow.NRPARCPGTOAF ? widget.currentRow.NRPARCPGTOAF : "";
        if(widget.isValid()) {
            var prazos = widget.container.getWidget("prazoPercentual");
            
            if(widget.currentRow.IDTPFORPGTFO == "F") {
                if(widget.currentRow.NRDIAPGFIXAF < 1 || widget.currentRow.NRDIAPGFIXAF > 31) {
                    MessageService.showMessageByCode('FORMPGTO_DIA_ENTRE_1E31', null, Constants.alertMessage);
                    return false;
                }
                if(widget.currentRow.NRPARCPGTOAF < 1 || widget.currentRow.NRPARCPGTOAF > 99) {
                    MessageService.showMessageByCode("FORMPGTO_DIA_ENTRE_1E99");
                    return false;
                }
            }
            
            if(widget.currentRow.IDTPFORPGTFO == "V" && prazos.dataSource.data.length == 0) {
                ScreenService.openPopup(prazos);
                MessageService.showMessageByCode("PRAZO_OBRIGATORIO");
                return false;
            }
            
            var dataSourcePrazos = prazos.dataSource ? prazos.dataSource.data : [];
            var dadosAF = widget.container.getWidget("dadosAF").currentRow;
            var editado = self.definirParametrosFormaPgto(widget.currentRow, widget.backupRow, "formaPagamento");
            
            if(paramAuditoria && editado) {
                ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
            } else {
                ServiceLancamentoAF.salvarFormaPagamento([dadosAF, widget.currentRow, dataSourcePrazos]).then(function() {
                    //return ServiceLancamentoAF.salvarDadosAF(dadosAF);
                    //Comentado pois estava retornando a forma de pagamento para a antiga
                }).then(function() {
                    General.formWidgetSwitchTemplate(widget);
                    General.changeWidgetAcessibility(widget.getParent().widgets, true);
                    widget.view();
                    prazos.showCheckbox = false;
                    prazos.getAction("adicionarPrazo").isVisible = false;
                    prazos.getField("NRDIASPGTOAF").inlineEditable = "";
                    prazos.getField("VRPERCPGTOAF").inlineEditable = "";
                    prazos.reload();
                    MessageService.showMessageByCode("FORMA_PGTO_SUCCESS_UPDATE");
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        }
    };
    
    this.voltarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        
        widget.dataSource.data = widget.dataSource.data.filter(function(row) {
            return row[percentualName] != 0 && row[diasName] != 0;
        });
        ScreenService.closePopup();
    };
    
    this.cancelarPrazo = function(widget) {
        widget.reload();
        widget.list();
    };
    
    this.adicionarPrazo = function(widget, dadosAF) {
        widget.newRow();
        widget.currentRow.CDFILDEST  = dadosAF.currentRow.CDFILDEST;
        widget.currentRow.CDFILLANC  = dadosAF.currentRow.CDFILLANC;
        widget.currentRow.NRAUTOFORN = dadosAF.currentRow.NRAUTOFORN;
    };
    
    this.excluirPrazo = function(widget) {
        var checkedRows = widget.getCheckedRows();
        checkedRows.forEach(function(row) {
            var index = widget.dataSource.data.indexOf(row);
			widget.dataSource.data.splice(index, 1);
        });
        widget.unSelectAll();
    };
    
    this.justInteger = function(widget) {
        const { diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        const diasNameInline = diasName + '_inline';
        
        widget.currentRow[diasName] = parseInt(widget.currentRow[diasName], 10);
        widget.currentRow[diasNameInline] = parseInt(widget.currentRow[diasName], 10);
    };
    
    function sanitizaNomeFieldsPercentualAndDiaPrazo(widgetPrazoPercentual) {
        const fields = {
            percentualName: '',
            diasName: ''
        };
        
        if (widgetPrazoPercentual.getParent().name === 'formaPagamento') {
            fields.percentualName = 'VRPERCPGTOAF';
            fields.diasName = 'NRDIASPGTOAF';
        } else {
            fields.percentualName = 'VRPERCPGTOFO';
            fields.diasName = 'NRDIASPGTOFO';
        }
        
        return fields;
    }
    
    this.confirmarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        var total = 0;
        var prazos = widget.dataSource.data;
        prazos.forEach(function(row) {
            var index = prazos.indexOf(row);
            if (row[percentualName] == 0) {
                prazos.splice(index, 1);
            }
		});
		
        for(var i = 0; i < prazos.length; i++) {
            var valor  = General.valueToFloat(prazos[i][percentualName]);
            var nrdia = General.valueToFloat(prazos[i][diasName]); 
            total += valor;
            
            if(nrdia > 999 || nrdia < 0) {
                MessageService.showMessageByCode("PRAZO_DIA_ENTRE_1E999");
                return false;
            }
            var existe = 0;
            for(var j = 0; j < prazos.length; j++) {
                if(prazos[j][diasName] == nrdia)
                    existe++;
            }
			if(existe > 1) {
                MessageService.showMessageByCode("PRAZO_DIA_CADASTRADO");
                return false;
			}
        }
        
        if(total != 100) {
            MessageService.showMessageByCode("SOMA_PERC_PRAZO_CEM");
            return false;
        }
        
        widget.list();
        ScreenService.closePopup();
    };
    
    /*************************************************************************************/
    /*                                FUNÇÕES 'ENCARGO'                                  */
    /*************************************************************************************/
    
    this.filtraEncargo = function(widget) {
        var detalhesEncargo = widget.container.getWidget("detalhesEncargo");
        detalhesEncargo.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,    "operator": "="},
            {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,    "operator": "="},
            {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,   "operator": "="},
            {"name": "DTPROGENTAF",  "value": widget.currentRow.DTPROGENTAF,  "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),           "operator": "="}
        ];
        detalhesEncargo.reload();
        ScreenService.openSwipe(detalhesEncargo);
    };
    
    this.voltarEncargo = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.salvarEncargo = function(widget) {
        var dataset = widget.dataSource.data.filter(function(row) {
            return row.changed;
        });
        auxRow = [];
        auxRow[0] = dataset;
        auxRow[1] = [];
        if(paramAuditoria && dataset.length) {
            auxContador = 0;
            self.definirParametrosEncargo(dataset[auxContador], "encargo");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            ServiceLancamentoAF.salvarEncargo(dataset).then(function() {
                widget.commitInlineEdit();
                widget.reload();
                widget.list();
                MessageService.successNotificationByCode('ENCARGO_SUCCESS_UPDATE');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelarEncargo = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.validaAltercaoEncargo = function(row) {
        if(General.valueToFloat(row.VRENCARGOAF) == General.valueToFloat(row.changed_VRENCARGOAF))
            row.changed = false;
    };

    /*************************************************************************************/
    /*                      FUNÇÕES 'JUSTIFICATIVA DE ALTERAÇÃO'                         */
    /*************************************************************************************/
    
    this.editarJustificativa = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.cancelarEditJustificativa = function(widget) {
        General.widgetCancelForm(widget);
    };
    
    this.salvarEditJustificativa = function(widget) {
        if(widget.isValid()){
            ServiceLancamentoAF.editarJustificativa(widget.currentRow).then(function() {
                General.formWidgetSwitchTemplate(widget);
                widget.view();
                MessageService.successNotificationByCode("JUSTIFICATIVA_SUCCESS_UPDATE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });    
        }
    };
    
    this.voltarJustificativa = function(widget) {
        ScreenService.closeSwipe();
    };
    
    this.carregaTipoJustificativa = function(widget) {
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("DSJUSTOPERMOV").template = "field/text-edit.html";
            widget.getField("DSJUSTOPERMOV").label    = "Outra";
        }
    };
    
    /*************************************************************************************/
    /*                    FUNÇÕES 'JUSTIFICATIVA DE ALTERAÇÃO' - POPUP                   */
    /*************************************************************************************/
    
    this.cancelarJustPopup = function(widget) {
        var dadosAF = widget.container.getWidget("dadosAF");
        dadosAF.currentRow.IDBAIXAAF = dadosAF.currentRow.IDBAIXAAF_BKP ? dadosAF.currentRow.IDBAIXAAF_BKP : null;
        if(dadosAF.isLastActiveWidget() && dadosAF.mode != "edit") {
            ScreenService.closePopup(true);
            dadosAF.view();
            dadosAF.activate();
        } else {
            ScreenService.closePopup();
        }
    };
    
    this.salvarJustPopup = function(widget) {
        if (widget.isValid()) {
            const widgetAF = getTriggerWidget();
            const row = widgetAF.currentRow;
            var justificativa = widget.currentRow.JUSTIFICATIVA;
            var produtoWid;
            
            switch(justificativa) {
                case("cancelar_AF"):
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        atualizaProdutosTipoBaixa({
                            widget: widgetAF,
                            valorBaixaItemAF: 3,
                            retornaAberto: false,
                            baixarTotalmente: false,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case ("encerrar_AF"):
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        atualizaProdutosTipoBaixa({
                            widget: widgetAF,
                            valorBaixaItemAF: 3,
                            retornaAberto: false,
                            baixarTotalmente: false,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("retornar_AF"):
                    retornarParaEmAbertoAF({
                        widget: widgetAF,
                        justificativa: {
                            row: widget.currentRow
                        },
                    });
                    break;
                case("baixarItem_AF"):
                    const produtos = getItensParaBaixar(widget);
                    
                    ServiceLancamentoAF.salvarJustificativas(produtos).then(function() {
                        ScreenService.closePopup();
                        
                        baixarItemAF({
                            widget,
                            widgetAF,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("baixarTotalmente_AF"):
                    const productWidget = widget.container.getWidget("produtos");
                    
                    productWidget.dataSourceFilter = [
						{   "name": "CDFILLANC",    "operator": "=",    "value": row.CDFILLANC   },
						{   "name": "NRAUTOFORN",   "operator": "=",    "value": row.NRAUTOFORN  },
						{   "name": "CDFILDEST",    "operator": "=",    "value": row.CDFILDEST   },
						{   "name": "NRORG",        "operator": "=",    "value": row.NRORG       }
					];
                    
                    productWidget.reload().then(function(){
                        auxRow = [];
                        auxRow.push(widget.currentRow);
                        
                        if(widget.container.getWidget("produtos").dataSource.data.length > 0) {
                            const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
                            const produtos = productWidget.dataSource.data.filter(filter => {
                                return filter.IDBAIXITMAF != '2' && filter.IDBAIXITAFS != '2';
                            });
                            
                            produtos.map(produto => {
                                produto.VALOR_IDBAIXITMAF = 3;
                                if(produto.IDBAIXITMAF != '2' && produto.IDBAIXITAFS != '2')
                                    produto.IDBAIXITMAF_BKP = 3;
                                    
                                let arrayReplace = [];
                                arrayReplace.push(MESSAGEBAIXA[produto.IDBAIXITMAF]);
                                arrayReplace.push(MESSAGEBAIXA[produto.IDBAIXITMAF_BKP]);
                                
                                produto.CDFILDESMOV   = produto.CDFILDEST;
                                produto.CDFILLANMOV   = produto.CDFILLANC;
                                produto.NRAUTOMOV     = produto.NRAUTOFORN;
                                produto.DTPROGENTMOV  = null;
                                produto.IDOPERAMOVAF  = "A";
                                produto.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
                                produto.ITEM          = produto.NMPRODUTO;
                                produto.MARCA         = produto.NMMARCA;
                                produto.DATA          = produto.DTPROGENTAF;
                                produto.CDPRODMOV     = produto.CDPRODUTO;
                                produto.CDMARCMOV     = produto.CDMARCA;
                                produto.DTPROGENTMOV  = produto.DTPROGENTAF;
                                
                                produto.DSJUSTOPERMOV = widget.currentRow.DSJUSTOPERMOV;
                            });
                            
                            ServiceLancamentoAF.salvarJustificativas(produtos).then(function() {
                                atualizaProdutosTipoBaixa({
                                    widget: widgetAF,
                                    valorBaixaItemAF: 3,
                                    retornaAberto: false,
                                    baixarTotalmente: true,
                                });
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        } else {
                            ServiceLancamentoAF.salvarJustificativas(auxRow).then(function() {
                                atualizaProdutosTipoBaixa({
                                    widget: widgetAF,
                                    valorBaixaItemAF: 3,
                                    retornaAberto: false,
                                    baixarTotalmente: true,
                                });
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }
                    });
                    break;
                    
                case("baixarTotalmente_itens"):
                    auxRow.push(widget.currentRow);
                    if(auxContador < widget.container.getWidget("produtos").dataSource.data.length) {
                        var produtos2 = widget.container.getWidget("produtos").dataSource.data;
                        produtos2[auxContador].VALOR_IDBAIXITMAF = 3;
                        if(produtos2[auxContador].IDBAIXITMAF != "2" && produtos2[auxContador].IDBAIXITAFS != "2")
                            produtos2[auxContador].IDBAIXITMAF_BKP = 3;
                        self.definirParametrosBaixaItem(produtos2[auxContador], "baixarTotalmente_itens");
                        auxContador++;
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow).then(function() {
                            atualizaProdutosTipoBaixa({
                                widget: widgetAF,
                                valorBaixaItemAF: 3,
                                retornaAberto: false,
                                baixarTotalmente: true,
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("formaPagamento"):
                    var prazos = widget.container.getWidget("prazoPercentual");
                    var fmpgto = widget.container.getWidget("formaPagamento");
                    var dataSourcePrazos = prazos.dataSource ? prazos.dataSource.data : [];
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        ServiceLancamentoAF.salvarFormaPagamento([row, fmpgto.currentRow, dataSourcePrazos]).then(function() {
                            return ServiceLancamentoAF.salvarDadosAF(row);
                        }).then(function() {
                            ScreenService.closePopup();
                            General.formWidgetSwitchTemplate(fmpgto);
                            General.changeWidgetAcessibility(fmpgto.getParent().widgets, true);
                            fmpgto.view();
                            prazos.showCheckbox = false;
                            prazos.getAction("adicionarPrazo").isVisible = false;
                            prazos.getField("NRDIASPGTOFO").inlineEditable = "";
                            prazos.getField("VRPERCPGTOFO").inlineEditable = "";
                            prazos.reload();
                            MessageService.successNotificationByCode("FORMA_PGTO_SUCCESS_UPDATE");
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("encargo"):
                    var encargoWid = widget.container.getWidget("detalhesEncargo");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosEncargo(auxRow[0][auxContador], "encargo");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarEncargo(auxRow[0]).then(function() {
                                ScreenService.closePopup(true);
                                encargoWid.activate();
                                encargoWid.commitInlineEdit();
                                encargoWid.reload();
                                encargoWid.list();
                                MessageService.successNotificationByCode("ENCARGO_SUCCESS_UPDATE");
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("impostos"):
                    var impostos = widget.container.getWidget("impostos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosImpostos(auxRow[0][auxContador], "impostos");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarImposto(auxRow[0]).then(function() {
                                ScreenService.closePopup(true);
                                impostos.activate();
                                impostos.commitInlineEdit();
                                impostos.list();
                                MessageService.successNotificationByCode("IMPOSTOS_SUCCESS_UPDATE");
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("edicaoAF"):
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosEdicaoAF(row, "edicaoAF", auxRow[0][auxContador]);
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarDadosAF(row).then(function () {
                                if (widgetAF.name === 'dadosAF') {
                                    ScreenService.closePopup(true);
                                    General.formWidgetSwitchTemplate(widgetAF);
                                    General.changeWidgetAcessibility(widgetAF.getParent().widgets, true);
                                    General.changeWidgetAcessibility([widgetAF.getParent()], true);
                                    widgetAF.fieldGroups[2].isVisible = true;
                                    widgetAF.activate();
                                    widgetAF.view();
                                } else {
                                    /**
                                     * TODO: Colocar chamada para atualizar a listaAF, recuperar a row e chamar o currentRow para definí-la novamente.
                                     */
                                }
                                MessageService.successNotificationByCode('SUCCESS_OPERATION');
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("inclusaoProdutoGeral_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("adicaoProduto");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return ServiceLancamentoAF.salvarDadosAF(row);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.getParent().reload();
                        produtoWid.getParent().activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("inclusaoProduto_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return ServiceLancamentoAF.salvarDadosAF(row);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        // produtoWid.list();
                        produtoWid.reload();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                        General.changeWidgetAcessibility(produtoWid.widgets, true);
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("alteracaoProduto_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosProduto(produtoWid, auxRow[0], auxContador, "CONSISTENTE");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                        }).then(function() {
                            return ServiceLancamentoAF.salvarDadosAF(row);
                        }).then(function() {
                            return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                        }).then(function() {
                            self.atualizaValorTotal();
                            ScreenService.closePopup(true);
                            produtoWid.computeDescriptionOrder();
                            // produtoWid.view();
                            MessageService.successNotificationByCode("PRODUTO_SUCCESS_UPDATE");
                            General.changeWidgetAcessibility(produtoWid.widgets, true);
                        }).catch(function(err) {
                            if(err && err.data) { 
                                ScreenService.showMessage(err.data.error);
                            } else if (err !== 'PENDENTE') {
                                ScreenService.showMessage(err);
                            }
                        });
                    }
                    break;
                case("inclusaoProdutoGeral_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("adicaoProduto");

                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                    }).then(function() {
                        return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                    }).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.getParent().reload();
                        produtoWid.getParent().activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("inclusaoProduto_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                    }).then(function() {
                        return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                    }).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.reload();
                        produtoWid.activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                        General.changeWidgetAcessibility(produtoWid.widgets, true);
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("alteracaoProduto_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosProduto(produtoWid, auxRow[0], auxContador, "INCONSISTENTE");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                        }).then(function() {
                            return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                        }).then(function() {
                            return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                        }).then(function() {
                            return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                        }).then(function() {
                            self.atualizaValorTotal();
                            ScreenService.closePopup(true);
                            produtoWid.computeDescriptionOrder();

                            // produtoWid.list();
                            produtoWid.activate();
                            MessageService.successNotificationByCode("PRODUTO_SUCCESS_UPDATE");
                            General.changeWidgetAcessibility(produtoWid.widgets, true);
                        }).catch(function(err) {
                            if(err && err.data) { 
                                ScreenService.showMessage(err.data.error);
                            } else if (err !== 'PENDENTE') {
                                ScreenService.showMessage(err);
                            }
                        });
                    }
                    break;
            }
        }
    };
    
    /*************************************************************************************/
    /*                                FUNÇÕES 'ADIÇÃO DE AF'                             */
    /*************************************************************************************/
    
    this.onEnterAdicao = function({ widget, filtro, qtdVolume, unidadeDestino, inconsAF, isOnEnterEvent = false }) {
        if (isOnEnterEvent) {
            stateOnEnterAdicao = {
                widget,
                filtro,
                qtdVolume,
                unidadeDestino,
                inconsAF,
            };
        }
        
        validaUsoIndiceFinanceiro();
        
        const dadosAF  = widget.container.getWidget('adicao_AF');
        
        dadosAF.newRow();
        
        const fieldsToLock = dadosAF.fields.filter(field => !['NMFILDEST', 'NMFILLANC'].includes(field.name));
        
        if (!unidadeDestino || (!unidadeDestino.codigo && !unidadeDestino.nome)) {
            fieldsToLock.forEach(field => {
                field.clearValue(field);
                field.readOnly = true;
            });
            return;
        }
        
        fieldsToLock.forEach(field => field.readOnly = false);
        
        ServiceLancamentoAF.retornaDataLancamento(unidadeDestino.codigo).then(response => {
            const dataLancamento = response.dataset.data.DTLANC;
            const produtos = widget.container.getWidget('adicao_produtos');
            const produto = widget.container.getWidget('widProduto');
            const inconsis = widget.container.getWidget('inconsistencias');
            const stripe = widget.container.getWidget('stripe_adicao');
            
            if(filtro.container.getWidget("listaAF").active)
                ScreenService.closePopup(true);

            stripe.currentRow.CDFILCENTCMP = getLocalVar("CDFILCENTCMP") + " - " + getLocalVar("NMFILCENTCMP");
            
            produto.getField("QTVOLUITEMAF").isVisible = qtdVolume;
            inconsis.getAction("ignorarInconsistencia").isVisible = inconsAF;
            widget.container.getWidget('AnexoDocGrid').isVisible = utilizaAnexo;
            
            widget.widgets.filter(widget => widget.name != 'justificativaPopup').forEach(widget => widget.edit());
            
            dadosAF.applyDefaultValue();
            
            if (widget.container.isImportacao)
                setDataFromImportacaoSoliticacaoCompras(dadosAF, produto, produtos, unidadeDestino);
            
            dadosAF.currentRow.CDFILDEST = unidadeDestino.codigo;
            dadosAF.currentRow.NMFILDEST = unidadeDestino.nome;
            dadosAF.currentRow.NRORG     = getLocalVar("NRORG");
            dadosAF.currentRow.IDAFFORALIM = 'N';
            dadosAF.currentRow.IDBAIXAFSAI = '0';
            dadosAF.currentRow.DTAUTOFORN = dataLancamento;
            
            this.validaFilial(unidadeDestino.codigo, dadosAF).finally(() => {
                if (widget.container.isImportacao) {
                    intervalId = setInterval(() => {
                        if (dadosAF.isValid()) {
                            clearInterval(intervalId);
                            /**
                             * TODO: Revisar este conteúdo após a impementação da tradução através do MessageService
                             */
                            const tabNameToFind = ScreenService.i18n('Produtos');
                    
                            Array.prototype.filter.call(document.querySelectorAll('.zh-tab-cell a'), (el) => el.innerText == tabNameToFind)[0].click();
                            
                            widget.container.isImportacao = false;
                        }
                    }, 500);
                }
            });
        });
    };
    
    this.validaFilial = function(cdfilial, widget) {
        return new Promise((resolve, reject) => {
            if(cdfilial) {
                ServiceLancamentoAF.validaFilial(cdfilial).then(function(callback) {
                    var dados = callback.dataset.dados;
    
                    if(dados.IDTIPEMITGER) {
                        var tipo = ["Empresa da Unidade", "Empresa Informada", "Cliente Principal"];
                        widget.currentRow.IDTIPOEMITAF = dados.IDTIPEMITGER;
                        widget.currentRow.NMTIPOEMITAF = tipo[dados.IDTIPEMITGER - 1];
                    }
    
                    self.mudaUnidadeDestino(widget);
                    self.destinatarioNF(widget);
                    widget.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
                    widget.getField("NMRAZSOCTRAN").reload();
                    
                    resolve();
                }, function(err) {
                    widget.currentRow.CDFILDEST = "";
                    widget.currentRow.NMFILDEST = "";
                    self.mudaUnidadeDestino(widget);
                    ScreenService.showMessage(err.data.error);
                    
                    reject();
                });
            } else {
                self.mudaUnidadeDestino(widget);
                
                resolve();
            }
        });
    };
    
    this.mudaUnidadeDestino  = function(widget) {
		if (widget.currentRow.CDFILDEST) {
			widget.getField('DTAUTOFORN').readOnly   = false;
			widget.getField('NMOPERADOR').readOnly   = false;
			widget.getField('NMRAZSOCFORN').readOnly = false;
			widget.getField('NMTIPOEMITAF').readOnly = false;
		} else {
			widget.currentRow.DTAUTOFORN   = '';
			widget.currentRow.NMEMPRESA    = '';
			widget.currentRow.NMRAZSOCFORN = '';
			widget.currentRow.IDTIPOEMITAF = '2';
			widget.currentRow.NMTIPOEMITAF = 'Empresa Informada';
			widget.getField('NMFILDEST').readOnly    = false;
			widget.getField('NMEMPRESA').readOnly    = true;
			widget.getField('DTAUTOFORN').readOnly   = true;
			widget.getField('NMRAZSOCFORN').readOnly = true;
			widget.getField('NMTIPOEMITAF').readOnly = true;
		}
	};
    
    this.validaComprador = function(widget) {
        var comprador = widget.currentRow.CDOPERADOR;
        var operador  = getLocalVar("CDOPERADOR");
        if(widget.currentRow.NMOPERADOR && comprador != operador) {
            ServiceLancamentoAF.validaComprador(comprador, operador).then(function(callback) {
                if(callback.dataset.dados.EXIGE_SENHA) {
                    var senhaOper = widget.container.getWidget("senhaOperador");
                    senhaOper.currentRow.CDCOMPRADOR = widget.currentRow.CDOPERADOR;
                    senhaOper.currentRow.NMOPERADOR  = widget.currentRow.NMOPERADOR;
                    senhaOper.currentRow.SENHA       = "";
                    ScreenService.openPopup(senhaOper);
                }
            }, function(err) {
                widget.currentRow.NMOPERADOR = "";
                widget.currentRow.CDOPERADOR = "";
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelarSenhaOperador = function(widget) {
        ScreenService.closePopup();
        widget.getParent().currentRow.CDOPERADOR = "";
        widget.getParent().currentRow.NMOPERADOR = "";
    };
    
    this.confirmarSenhaOperador = function(widget) {
        if(widget.isValid()) {
            ServiceLancamentoAF.confirmaSenhaComprador(widget.currentRow).then(function() {
                ScreenService.closePopup();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }    
    };
    
    this.validaFornecedor = function(widget) {
        if (widget.currentRow.NMRAZSOCFORN) {
            ServiceLancamentoAF.validaFornecedor(widget.currentRow).then(function() {
                ServiceLancamentoAF.retornaDadosFornecedor(widget.currentRow).then(function(callback) {
                    var fornecedor = callback.dataset.fornecedor;
                    if(!widget.currentRow.IDTIPOFRETAF)
                        widget.currentRow.IDTIPOFRETAF = fornecedor.IDTPFRETFORN;
                    if(!widget.currentRow.CDTIPCOB) {
                        widget.currentRow.CDTIPCOB   = fornecedor.CDTIPCOB;
    				    widget.currentRow.NMTIPOCOBR = fornecedor.NMTIPOCOBR;
                    }
                    widget.currentRow.CDFORMPGTO   = fornecedor.CDFORMPGTO;
    				widget.currentRow.NMFORMPGTO   = fornecedor.NMFORMPGTO;
    				widget.currentRow.IDTPFORPGTFO = fornecedor.IDTPFORPGTFO;
    				widget.currentRow.IDUTDIAPGTAF = fornecedor.IDUTDIAPGTFO;
    				widget.currentRow.NRDIAPGFIXAF = fornecedor.NRDIAPGFIXFO;
    				widget.currentRow.NRPARCPGTOAF = fornecedor.NRPARCPGTOFO;
    				paramDtEntrega = fornecedor.IDGERAFDTENT;
                }, function(err) {
                    widget.currentRow.CDFORNECED = "";
                    widget.currentRow.NMRAZSOCFORN = "";
                    ScreenService.showMessage(err.data.error);
                });
            }, function(err) {
                MessageService.showMessageByCode(err.data.error, {"NMRAZSOCFORN": widget.currentRow.NMRAZSOCFORN}).then(function(){
                    widget.currentRow.CDFORNECED = "";
    		        widget.currentRow.NMRAZSOCFORN = "";
                },function(err) {
                    widget.currentRow.CDFORNECED = "";
    		        widget.currentRow.NMRAZSOCFORN = "";    
    		        ScreenService.showMessage(err.data.error);
                });
            });
        }
    };
    
    this.setFilterPrazoPercentual = function (field) {
        const prazoPercentual = field.widget.container.getWidget('prazoPercentual');
        if(!Util.isEmptyOrBlank(field.value())){
            prazoPercentual.dataSourceBackup = angular.copy(prazoPercentual.dataSource.data);
            prazoPercentual.dataSourceFilter = [
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": field.widget.currentRow.CDFORNECED
                }    
            ];
            prazoPercentual.reload();
        }
    };
    
    this.verificaTransportadora = function(field, args) {
        if(!field.dataSource.data.length) {
            args.e.preventDefault();
            MessageService.showMessageByCode("FILIAL_SEM_TRANSPORTADORA");
        }
    };
    
    this.validaDataLancamento = function(widget, validaMudanca) {
        const deferred = ZHPromise.defer();
        
        if((validaMudanca && widget.currentRow.DTAUTOFORN) || (!validaMudanca && widget.getField("DTAUTOFORN").readOnly == false)) {
            return ServiceLancamentoAF.validaDataLancamento(widget.currentRow).then(function() {
                deferred.resolve();
                return deferred.promise;
            }, function(err) {
                if(validaMudanca)
                    ScreenService.showMessage(err.data.error);
                deferred.reject(err);
                return deferred.promise;
            });
        }
        
        deferred.resolve();
        return deferred.promise;
    };
    
    this.controlarWidgetValida = function(args, validaProduto) {
        var deferred = ZHPromise.defer();
        var tabbed  = templateManager.container.getWidget("tab_adicao");
        var dadosAF = tabbed.widgets[0];
        var produto = tabbed.widgets[1];
        const validaMudanca = false;
        
        if(dadosAF.isValid()) {
            return this.validaDataLancamento(dadosAF, validaMudanca).then(function() {
                if(validaProduto) {
                    if(produto.dataSource.data.length == 0) {
                        self.ativaTab(args, tabbed, produto);
                        MessageService.showMessageByCode("PRODUCT_IS_REQUIRED");
                        deferred.reject();
                    } else {
                        deferred.resolve();
                    }
                } else {
                    deferred.resolve();
                }
                
                return deferred.promise;
            }, function(err) {
                self.ativaTab(args, tabbed, dadosAF);
                ScreenService.showMessage(err.data.error);
                deferred.reject();
                
                return deferred.promise;
            });
        } else {
            self.ativaTab(args, tabbed, dadosAF);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            deferred.reject();
            
            return deferred.promise;
        }
    };
    
    this.ativaTab = function(args, tabbed, widget) {
        args.e.preventDefault();
        tabbed.currentWidget = widget;
        widget.activate();
    };
    
    this.onEnterProduto = function(args) {
        var widget = args.owner;
        this.controlarWidgetValida(args, false).then(function() {
            if(!widget.wasOpened) {
                const dadosAF = widget.container.getWidget("adicao_AF");
                
                // Produto
                startProduto(widget, dadosAF);
                
                // Forma Pagamento
                startFormaPagamento(dadosAF);
            }
        });
    };
    
    function startProduto(widProduto, dadosAF) {
        widProduto.applyDefaultValue();
        
        dadosAF.getField("NMFILDEST").readOnly = true;
        dadosAF.getField("DTAUTOFORN").readOnly = true;
        dadosAF.getField("NMOPERADOR").readOnly = true;
        dadosAF.getField("NMRAZSOCFORN").readOnly = true;
        
        widProduto.currentRow.CDFILDEST = dadosAF.currentRow.CDFILDEST;
        widProduto.currentRow.CDFILLANC = dadosAF.currentRow.CDFILLANC;
        widProduto.wasOpened = true;
    }
    
    function startFormaPagamento(dadosAF) {
        const dados = dadosAF.currentRow;
        const formaPgto = templateManager.container.getWidget("adicao_formaPgto");
        const fields = [
            'IDTPFORPGTFO',
            'IDUTDIAPGTAF',
            'NRDIAPGFIXAF',
            'NRPARCPGTOAF',
        ];
        
        const dataExists = fields.filter(fieldName => dados[fieldName]);
        
        if (dataExists.length) {
            dataExists.forEach(fieldName => {
                formaPgto.getField(fieldName).defaultValue = dados[fieldName];
            });
        }
        
        formaPgto.applyDefaultValue();
        self.exibicaoFormaPagamento(formaPgto);
        formaPgto.wasOpened = true;
        
        if (dados.CDFORMPGTO) {
            ServiceLancamentoAF.retornaFormpgto(dados.CDFORMPGTO).then(function(callback) {
                if(callback.dataset.formpgto.length) {
                    formaPgto.currentRow.CDFORMPGTO = callback.dataset.formpgto[0].CDFORMPGTO;
                    formaPgto.currentRow.NMFORMPGTO = callback.dataset.formpgto[0].NMFORMPGTO;
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    }
    
    this.onEnterMensagem = function(args) {
        this.controlarWidgetValida(args, true);
    };
    
    this.onEnterFormaPagamento = function(args) {
        this.controlarWidgetValida(args, true).then(() => {
            const widDadosAF = templateManager.container.getWidget('adicao_AF');
            const widPagamento = templateManager.container.getWidget('adicao_formaPgto');
            
            widPagamento.dataSourceFilter = [
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": widDadosAF.currentRow.CDFORNECED
                }    
            ];
            widPagamento.reload().then(function(success) {
                setFormPgtoRow(widPagamento);
            });
        });
    };
    
    function setFormPgtoRow(widget) {
        widget.currentRow.IDTPFORPGTFO = widget.dataSource.data[0].IDTPFORPGTFO;
        widget.getField('IDTPFORPGTFO').change();
    }
    
    this.setDataSorcePrazoPercentual = function(widget){
        var widAdicaoAf = templateManager.container.getWidget('adicao_AF');
        ServiceLancamentoAF.getFormPgtoFornecedor(widAdicaoAf.currentRow).then(function(res) {
            widget.dataSource.data = [];
            if(res.length && res.dataset.res.length) {
                res.dataset.res.forEach(function(row) {
                    widget.dataSource.data.push(
                        {
                            "NRDIASPGTOFO": row.NRDIASPGTOFO,
                            "VRPERCPGTOFO": row.VRPERCPGTOFO
                        }
                    );
                });
            }else{
                widget.dataSource.data = [
                    {
                        "NRDIASPGTOFO": 30,
                        "VRPERCPGTOFO": 100
                    }
                ];
            }
        });
    };
    
    this.onEnterEncargo = function(args) {
        var widget = args.owner;
        this.controlarWidgetValida(args, true).then(function() {
            var produto = widget.container.getWidget("adicao_produtos").currentRow;
            widget.dataSource.data = [{
                DTPROGENTAF: produto.DTPROGENTAF,
                DIA: moment(produto.DTPROGENTAF, 'DD/MM/YYYY').format('dddd').toUpperCase()
            }];
        });
    };
    
    this.abreEncargo = function(widget) {
        ScreenService.openSwipe(widget.widgets[0]);
    };
    
    this.abrePrazoPercentualAdicao = function(widget) {
        const prazos = widget.container.getWidget("prazoPercentual");
        
        if (widget.isValid()) {
            ScreenService.openPopup(prazos);
        }
    };
    
    this.cancelarPrazoAdicao = function(widget) {
        widget.dataSource.data = widget.dataSourceBackup;
        widget.list();
    };
    
    this.cancelarEncargoAdicao = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
    };

    function validarWidgetProduto(args, tabbed) {
        const produto = tabbed.container.getWidget('adicao_produtos');

        if (!produto.dataSource.data.length) {
            self.ativaTab(args, tabbed, produto);
            MessageService.showMessageByCode("PRODUCT_IS_REQUIRED");
            return false;
        }

        return true;
    }

    function validarWidgetFormaPagamento(args, tabbed) {
        const formaPg = tabbed.container.getWidget('adicao_formaPgto');

        if (!formaPg.isValid()) {
            self.ativaTab(args, tabbed, formaPg);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
        }

        if (!formaPg.currentRow.NRDIAPGFIXAF)
            formaPg.currentRow.NRDIAPGFIXAF = null;
        
        if (!formaPg.currentRow.NRPARCPGTOAF)
            formaPg.currentRow.NRPARCPGTOAF = null;
        
        if (!formaPg.currentRow.NRPARCITMAF)
            formaPg.currentRow.NRPARCITMAF = "01";

        let erro = false;
        const prazos = tabbed.container.getWidget('prazoPercentual');

        if (formaPg.currentRow.IDTPFORPGTFO == "F") {
            if (formaPg.currentRow.NRDIAPGFIXAF < 1 || formaPg.currentRow.NRDIAPGFIXAF > 31) {
                MessageService.showMessageByCode('FORMPGTO_DIA_ENTRE_1E31', null, Constants.alertMessage);
                erro = true;
            } else if (formaPg.currentRow.NRPARCPGTOAF < 1 || formaPg.currentRow.NRPARCPGTOAF > 99) {
                MessageService.showMessageByCode("FORMPGTO_DIA_ENTRE_1E99");
                erro = true;
            }
        }

        if (erro) {
            self.ativaTab(args, tabbed, formaPg);
            return false;
        }
        
        if(formaPg.currentRow.IDTPFORPGTFO == "V" && prazos.dataSource.data.length == 0) {
            self.ativaTab(args, tabbed, formaPg);
            ScreenService.openPopup(prazos);
            MessageService.showMessageByCode("PRAZO_OBRIGATORIO");
            return false;
        }

        return true;
    }

    function exigeAuditoria(widget) {
        return paramAuditoria && !widget.currentRow.JUSTIFICADA;
    }
    
    this.validaAdicaoAF = function(args) {
        const tabbed  = templateManager.container.getWidget("tab_adicao");
        const dadosAF = templateManager.container.getWidget('adicao_AF');
        
        const validaMudanca = false;
        
        if(!dadosAF.isValid()) {
            this.ativaTab(args, tabbed, dadosAF);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            return;
        }

        this.validaDataLancamento(dadosAF, validaMudanca).then(function() {
            if (!validarWidgetProduto(args, tabbed)) {
                return;
            }

            if (!validarWidgetFormaPagamento(args, tabbed)) {
                return;
            }
            
            if(exigeAuditoria(dadosAF)) {
                const just = templateManager.container.getWidget("justificativaPopup");

                just.currentRow.IDOPERAMOVAF = "I";
                just.currentRow.DSALTERAF = "Inclusão de AF Manual";
                just.currentRow.TIPOJUST = "P";
                
                self.mudaJustificativa(just);
                ScreenService.openPopup(just);

                return;
            }
            
            editVrPrecoIndice(dadosAF);
        
            self.salvarAdicaoAF(false);
        }, function(err) {
            self.ativaTab(args, tabbed, dadosAF);
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.cancelarJustAdicaoAF = function() {
        ScreenService.closePopup();
    };
    
    function editVrPrecoIndice(dadosAF){
        const indiceFinanceiro = usaIndiceFinanceiro();
        const valorIndice = dadosAF.currentRow.VRINDICE;
        
        if(indiceFinanceiro){
        	if(templateManager.container.dadosImportacao){
				templateManager.container.dadosImportacao.itens.forEach(item => {
					item.VRPREUNIAF = item.VRCUSTO;
					item.PRECOTOTAL = item.VRCUSTO * item.QTSOLIPROD;
					item.VRINDICEITMAF = item.VRCUSTO / General.valueToFloat(valorIndice);
				});	
        	}
        }
    }
    
    
    this.mostrarDialogoAfPendenteAprov = function(cdfillanc, cdfildest, nrautoforn) {
        let popupJustificaLancamentoAf = templateManager.container.getWidget('popupJustificaLancamentoAf');
        let rowJustificaLancamentoAf = popupJustificaLancamentoAf.currentRow;
        
        rowJustificaLancamentoAf.CDFILLANC = cdfillanc;
        rowJustificaLancamentoAf.CDFILDEST = cdfildest;
        rowJustificaLancamentoAf.NRAUTOFORN = nrautoforn;
        rowJustificaLancamentoAf.DSMOTVAFALCADA = '';
        
		let message = 'A AF está pendente de aprovação e estará indisponível até a liberação de todos os gerentes!';
		let type = 'INFORMATION';
		let icon = '';
		let label = 'Justificar lançamento';
		let success = function() { ScreenService.openPopup(popupJustificaLancamentoAf); };
		
		return ScreenService.showCustomDialog(message, type, icon, [{
			label: ScreenService.i18n(label),
			"default": true,
			code: function(e, deferred) {
				success(e);
				deferred.resolve(e);
			}
		}]);
	};
	
	
	this.salvaJustLancAf = function() {
	    
	    let widgetJustLancAf = templateManager.container.getWidget('popupJustificaLancamentoAf');
	    
	    if(widgetJustLancAf.isValid()) {
	        let rowJustificativa = widgetJustLancAf.currentRow;
	        
    	    let dsmotvafalcada = rowJustificativa.DSMOTVAFALCADA;
    	    let cdfildest = rowJustificativa.CDFILDEST;
    	    let cdfillanc = rowJustificativa.CDFILLANC;
    	    let nrautoforn = rowJustificativa.NRAUTOFORN;
	    
	        ServiceLancamentoAF.salvaJustLancAf(cdfildest, cdfillanc, nrautoforn, dsmotvafalcada).then(function() {
                ScreenService.closePopup(true);
                ScreenService.closeSwipe(0);
                self.limpaAFAdicao();
	        });
	    }
	    
	};
	
	
	function verificaUtilizaWorkflow(cdfillanc, cdfildest, nrautoforn, verificarApuracaoReprovada = true) {
	    return new Promise(function(resolve, reject) {
	        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', { "CDFILDEST": cdfildest }).then(function(success) {
	            const { IDUTLWORKFLOW } = success.dataset.data[0];
	            
	            if (IDUTLWORKFLOW =='S') {
	                const workflowRow = {
	                    CDFILLANC:  cdfillanc,
	                    CDFILDEST:  cdfildest,
	                    NRDEMANDA:  nrautoforn,
	                    OPERACAO: 'LANCAMENTO',
	                    IDTPDEMANDA: 'AF',
	                };
	                
	                const checkApprovalWorkflow = function(workflowRow) {
	                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
    	                    const { message: workflowResult } = response.messages[0];
    	                    
    	                    if (workflowResult == 'PENDENTE') {
    	                        self.mostrarDialogoAfPendenteAprov(cdfillanc, cdfildest, nrautoforn);
    	                        reject('PENDENTE');
    	                    } else {
    	                        resolve(workflowResult);
    	                    }
	                    }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
	                };
	                /**
	                 * 18/06/2020 - Comentada para que, ao editar a AF Reprovada
	                 * no Workflow, ela passe pelo fluxo normalmente.
	                 * 
	                 * TODO: Possivelmente será necessário elaborar uma solução
	                 * que permita chamar o Workflow somente para alguns
	                 * casos de manipulação de AF, dentre: adicionar produto,
	                 * editar e excluir.
	                 */
	               // if (verificarApuracaoReprovada) {
	               //     permiteAcionarWorkflow({
    	           //         CDFILLANC:  cdfillanc,
    	           //         CDFILDEST:  cdfildest,
    	           //         NRAUTOFORN:  nrautoforn,
    	           //     }).then(function(response) {
    	           //         checkApprovalWorkflow(workflowRow);
    	           //     }, function() {
    	           //         resolve('NAO_ACIONA_WORKFLOW');
    	           //     });
	               // } else {
	                    checkApprovalWorkflow(workflowRow);
	               // }
	            } else {
	                resolve('NAO_PARTICIPA_WORKFLOW');
    	        }
	        });
	    });
	}
    
    function getWidget(actualWidget, nameToFind) {
        const index = actualWidget.widgets.findIndex(item => item.name == nameToFind);
        
        if (index == -1) return null;
        
        return actualWidget.widgets[index];
    }
    
    this.salvarAdicaoAF = function(justificativa) {
        if(justificativa) {
            ScreenService.closePopup();
        }
        var tabbed   = templateManager.container.getWidget("tab_adicao");
        var dadosAF  = tabbed.widgets[0];
        var produto  = tabbed.widgets[1].dataSourceAuxiliar;
        var mensagem = tabbed.widgets[2].dataSource.data;
        var formaPg  = tabbed.widgets[3].currentRow;
        var justif   = tabbed.widgets[5].currentRow;
        var encargo  = tabbed.widgets[4].widgets[0].dataSource.data;
        var prazos   = tabbed.widgets[3].widgets[0].dataSource.data;
        const anexos = getWidget(tabbed, 'AnexoDocGrid').dataSource.data;

        dadosAF.currentRow.CDOPERLANCAF = getLocalVar("CDOPERADOR");
        
        justif.paramAuditoria = paramAuditoria;
        
    	for (var i in formaPg) {
    		dadosAF.currentRow[i] = formaPg[i];
    	}
    	tabbed.currentWidget = dadosAF;
        dadosAF.activate();
        if(!dadosAF.currentRow.QTVOLUITEMAF)
            dadosAF.currentRow.QTVOLUITEMAF = null;
        
        const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        const dataAF = dadosAF.currentRow.DTAUTOFORN;
        
        const validProducts = produto.filter(product => basicDeliveryDateValidation({
            dataEntrega: product.DTPROGENTAF ? moment(product.DTPROGENTAF, 'DD/MM/YYYY')._d : null,
            dataAtual,
            dataAF,
            showMessage: false
        }));
        
        if (validProducts.length !== produto.length) {
            MessageService.showMessageByCode("PRODUTO_DTA_ENTREGA_INVALIDA");
            return;
        }
        
        editVrPrecoIndice(dadosAF);
        
        ServiceLancamentoAF.salvarAdicaoAF([dadosAF.currentRow, produto, mensagem, formaPg, encargo, justif, prazos, anexos]).then(function(callback) {
            if(callback.dataset.dadosAF.length) {
                dadosAF.currentRow = callback.dataset.dadosAF[0];
            }
            if(callback.dataset.inconsistencias.length > 0) {
                dadosAF.currentRow.__is_new = false;
                var inconsistWidget = templateManager.container.getWidget("inconsistencias");
                
                inconsistWidget.dataSource.data = callback.dataset.inconsistencias;
                ScreenService.openPopup(inconsistWidget);
                MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
            } else {
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', dadosAF.currentRow).then(function(success) {
                    if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                        var workflowRow = {};
                        workflowRow.CDFILLANC   = dadosAF.currentRow.CDFILLANC;
                        workflowRow.CDFILDEST   = dadosAF.currentRow.CDFILDEST;
                        workflowRow.NRDEMANDA   = dadosAF.currentRow.NRAUTOFORN;
                        workflowRow.OPERACAO    = 'LANCAMENTO';
                        workflowRow.IDTPDEMANDA = 'AF';
                        return General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
            	            if(response.messages[0].message == 'PENDENTE') {
            	               self.mostrarDialogoAfPendenteAprov(dadosAF.currentRow.CDFILLANC, dadosAF.currentRow.CDFILDEST, dadosAF.currentRow.NRAUTOFORN);
            	            }
            	            
            	            self.limpaAFAdicao();
                        });
                    } else {
                        self.limpaAFAdicao();
        	        }
        	       
        	        dadosAF.currentRow.__is_new = false;
                }.bind(self)).catch(function(err) {
                    self.limpaAFAdicao();
                    ScreenService.showMessage(err.data.error);
                });
                
                renderEngine.changeContainer(`cmp_fornecimento_autorizacaoFornecimento#${containerAF.name}`);
            }
        }.bind(self),
        function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.limpaAFAdicao = function() {
        var dadosAF = templateManager.container.getWidget("dadosAF");
        var listaAF = templateManager.container.getWidget("listaAF");
        var stripe  = templateManager.container.getWidget("stripe").currentRow;
        var dados   = templateManager.container.getWidget("filtro").currentRow;
        
        if (templateManager.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento') {
            clearStripeData();
            listaAF.reload().then(function(callback) {
                listaAF.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        } else {
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabbedWidget").widgets, false);
            dadosAF.currentRow = {};
            dadosAF.getParent().currentWidget = dadosAF;
            modoFieldGroups(dadosAF, false);
            
            stripe.CDFILCENTCMP = getLocalVar("CDFILCENTCMP") + " - " + getLocalVar("NMFILCENTCMP");
            stripe.CDFILDEST    = dados.CDFILIAL + " - " + dados.NMFILIAL;
            stripe.NRAUTOFORN   = "";
            stripe.NMRAZSOCFORN = "";
            listaAF.reload().then(function(callback) {
                listaAF.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    function limpaAF(widget) {
        clearStripeData();
        resetActions(widget);
        
        ScreenService.closeSwipe(0);
    }
    
    this.salvarJustAdicaoAF = function(widget) {
        if(widget.isValid()) {
            templateManager.container.getWidget("adicao_AF").currentRow.JUSTIFICADA = true;
            self.salvarAdicaoAF(true);
        }
    };
    
    this.ignorarInconsistenciasAdicao = function(widget) {
        var info     = {};
        var dadosAF  = templateManager.container.getWidget("adicao_AF").currentRow;
        var justif   = templateManager.container.getWidget("justificativaPopup").currentRow;
        var encargo  = templateManager.container.getWidget("detalhesEncargo").dataSource.data;
        var prazos   = templateManager.container.getWidget("prazoPercentual").dataSource.data;
        var mensagem = templateManager.container.getWidget("adicao_mensagem").dataSource.data;
        const widProduto = templateManager.container.getWidget("widProduto");
        
        info.CDFILDEST   = dadosAF.CDFILDEST;
        info.CDFILLANC   = dadosAF.CDFILLANC;
        info.NRAUTOFORN  = dadosAF.NRAUTOFORN;
        info.CDFORNECED  = dadosAF.CDFORNECED;
        info.CDEMPRESA   = dadosAF.CDEMPRESA;
        info.NRORG       = dadosAF.NRORG;
        
        const row = Util.isEmptyObject(widProduto.currentRow) ? widProduto.dataSource.getFirstRow() : widProduto.currentRow;
        
        info.DTPROGENTAF = row.DTPROGENTAF;
        
        self.atualizarInconsistencias(widget, true, true).then(function() {
            ServiceLancamentoAF.finalizaAdicaoAF([info, justif, encargo, prazos, mensagem]).then(function() {
                ScreenService.closePopup();
                templateManager.container = containerAF;
 
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', dadosAF).then(function(success) {
                    if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                        var workflowRow = {};
                        workflowRow.CDFILLANC   = dadosAF.CDFILLANC;
                        workflowRow.CDFILDEST   = dadosAF.CDFILDEST;
                        workflowRow.NRDEMANDA   = dadosAF.NRAUTOFORN;
                        workflowRow.OPERACAO    = 'LANCAMENTO';
                        workflowRow.IDTPDEMANDA = 'AF';
                        return General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
            	            if(response.messages[0].message == 'PENDENTE') {
            	               self.mostrarDialogoAfPendenteAprov(dadosAF.CDFILLANC, dadosAF.CDFILDEST, dadosAF.NRAUTOFORN);
            	            }
            	            self.limpaAFAdicao();
                        });
                    } else {
                        self.limpaAFAdicao();
                    }
                }.bind(self)).catch(function(err) {
                    self.limpaAFAdicao();
                    ScreenService.showMessage(err.data.error);
                });
            
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.cancelarAdicaoAF = function(widget) {
        ScreenService.confirmMessage("Deseja abandonar inclusão de AF?", "INFORMATION", function() {
            const finalizaCancelarAdicaoAF = function() {
                const widgetAnexo = widget.container.getWidget('AnexoDocGrid');
                
                ServiceLancamentoAF.deleteAnexoLocal(widgetAnexo.dataSource.data).then(function (sucess) {
                    widgetAnexo.dataSource.data = [];
                    widgetAnexo.dataSource.clearCheckedRows();
                }, function(response) {
                    ScreenService.showMessage(response.error);
                });
                    
                renderEngine.changeContainer(`cmp_fornecimento_autorizacaoFornecimento#${containerAF.name}`);
                
                /*if (!containerAF.getWidget("stripe").currentRow.NRAUTOFORN)
                    ScreenService.goBack();*/
            };
            
            if (widget.currentRow.NRAUTOFORN) {
                widget.currentRow.FILIAL_LOGADA = getLocalVar('CDFILIAL');
                widget.currentRow.CENTRAL_COMPRAS = getLocalVar('CDFILCENTCMP');
                widget.currentRow.EMAIL_LOGADO = getLocalVar('EMAIL');
                ServiceLancamentoAF.excluirAF(widget.currentRow).then(function() {
                    finalizaCancelarAdicaoAF();
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            } else {
                finalizaCancelarAdicaoAF();
            }
        });
    };
    
    this.adicionarMensagem_AF = function(widget, dadosAF) {
        var formMsg = widget.widgets[0];
        widget.backupData  = angular.copy(widget.dataSource.data);
        ScreenService.openSwipe(formMsg);
        formMsg.newRow();
        formMsg.currentRow.NRMENSAUTFOR = (widget.dataSource.data.length + 1).toString().padStart(2, "0");
        formMsg.currentRow.CDFILDEST    = dadosAF.currentRow.CDFILDEST;
        formMsg.currentRow.CDFILLANC    = dadosAF.currentRow.CDFILLANC;
        formMsg.currentRow.NRAUTOFORN   = dadosAF.currentRow.NRAUTOFORN;
        formMsg.currentRow.NRORG        = dadosAF.currentRow.NRORG;
        formMsg.currentRow.DSMENSAF     = dadosAF.currentRow.DSMENSAF;
        formMsg.currentRow.TIPOMENS     = "P";
        formMsg.currentRow.NOVO         = true;
        self.carregaTipoMensagem(formMsg);
    };
    
    this.editarMensagem_AF = function(widget) {
        var formMsg = widget.widgets[0];
        widget.backupData  = angular.copy(widget.dataSource.data);
        ScreenService.openSwipe(formMsg);
        formMsg.newRow();
        formMsg.currentRow = widget.currentRow;
        this.carregaTipoMensagem(formMsg);
    };
    
    this.cancelarMensagem_AF = function(widget) {
        widget.getParent().dataSource.data = widget.getParent().backupData;
        ScreenService.closeSwipe();
    };
    
    this.salvarMensagem_AF = function(widget) {
        if(widget.isValid()) {
            if(widget.currentRow.NOVO) {
                widget.currentRow.NOVO = false;
                widget.getParent().dataSource.data.push(widget.currentRow);
            }
            ScreenService.closeSwipe();
        }
    };
    
    this.excluirMensagem_AF = function(widget) {
        ScreenService.confirmMessage("Confirma exclusão da mensagem?", "INFORMATION", function() {
            var novoDataSource = [];
            widget.getParent().dataSource.data.forEach(function(row) {
                if(row.NRMENSAUTFOR !=  widget.currentRow.NRMENSAUTFOR) {
                    if(row.NRMENSAUTFOR > widget.currentRow.NRMENSAUTFOR)
                        row.NRMENSAUTFOR--;
                    novoDataSource.push(row);
                }
            });
            widget.getParent().dataSource.data = novoDataSource;
            ScreenService.closeSwipe();
        });
    };
    
    this.adicionarProduto_AF = function(widget, tipo) {
        var dadosAF      = templateManager.container.getWidget("adicao_AF");
        var tabProduto   = templateManager.container.getWidget("tabProdutos");
        var widPrincipal = templateManager.container.getWidget("adicao_produtos");
        var widProduto   = tabProduto.widgets[0];
        
        widProduto.edit();
        widProduto.currentRow = {
            "CDFILDEST": dadosAF.currentRow.CDFILDEST,
            "CDFILLANC": dadosAF.currentRow.CDFILLANC,
			"__createdLocal": true,
			"__is_new": true
        };
        widProduto.applyDefaultValue();
        widProduto.widgetAntiga = widget;
        
        if(tipo == "adicaoGeral") {
            widProduto.getField("NMPRODUTO").readOnly = false;
        } else if(tipo == "adicao") {
            widProduto.getField("NMPRODUTO").readOnly = true;
            widProduto.currentRow.NMPRODUTO = widPrincipal.currentRow.NMPRODUTO;
            widProduto.currentRow.CDPRODUTO = widPrincipal.currentRow.CDPRODUTO;
            widProduto.currentRow.SGUNIDADE = widPrincipal.currentRow.SGUNIDADE;
            widProduto.currentRow.TIPO_PRODUTO = "adicao";
        }
        widProduto.currentRow.TIPO_PRODUTO = tipo;
        ScreenService.openSwipe(tabProduto);
    };
    
    this.editarProduto_AF = function(widget) {
        var tabProduto = templateManager.container.getWidget("tabProdutos");
        var widProduto = tabProduto.widgets[0];
        widProduto.edit();
        widProduto.currentRow = widget.currentRow;
        widProduto.backupRow  = angular.copy(widget.currentRow);
        widProduto.currentRow.TIPO_PRODUTO = "edicao";
        widProduto.widgetAntiga = widget;
        ScreenService.openSwipe(tabProduto);
        widProduto.getField("NMPRODUTO").readOnly = true;
    };
    
    this.detalhesProduto_AF = function(widget) {
        var tabDetalhes = widget.widgets[0];
        ScreenService.openSwipe(tabDetalhes);
        tabDetalhes.widgets[0].dataSource.data = widget.dataSourceAuxiliar.filter(function(row) {
            return row.CDPRODUTO == widget.currentRow.CDPRODUTO;
        });
        tabDetalhes.widgets[0].edit();
    };
    
    this.salvarProduto_AF = function(widget) {
        const adicaoAF = templateManager.container.getWidget("adicao_AF");
        
        if(widget.isValid()) {
            validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
                var widPrincipal = templateManager.container.getWidget("adicao_produtos");
                if(paramDtEntrega == "S") {
                    var datasIguais = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                        return row.DTPROGENTAF != widget.currentRow.DTPROGENTAF;
                    });
                    if(datasIguais.length > 0) {
                        MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
                        return false;
                    }
                }
                
                var lengthProdIguais = 0;
                var prodIguais = "";
                if(widget.currentRow.TIPO_PRODUTO == "edicao") {
                    /**
                     * Trocar validação aqui
                     */
                    prodIguais = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                        return row.CDPRODUTO == widget.currentRow.CDPRODUTO && row.CDMARCA == widget.currentRow.CDMARCA && row.DTPROGENTAF == widget.currentRow.DTPROGENTAF &&
                              (row.CDPRODUTO == widget.backupRow.CDPRODUTO && (row.CDMARCA != widget.backupRow.CDMARCA  || row.DTPROGENTAF != widget.backupRow.DTPROGENTAF));
                    });
                    lengthProdIguais = prodIguais.length - 1;
                } else {
                    const sameProduct = permiteAdicionarProduto(widget);
                    
                    prodIguais = widPrincipal.dataSourceAuxiliar.filter(sameProduct);
                    
                    lengthProdIguais = prodIguais.length;
                }
                if(lengthProdIguais > 0) {
                    const param = {
                        NMMARCA: widget.currentRow.NMMARCA
                    };
                    
                    MessageService.showMessageByCode('PART_ALREADY_REGISTERED', param, Constants.alertMessage);
                    
                    widget.currentRow.CDMARCA = "";
                    widget.currentRow.NMMARCA = "";
                    return false;
                }
                
                // Valida data entrega
                var data        = widget.currentRow.DTPROGENTAF;
                var dataEntrega = data ? moment(data, 'DD/MM/YYYY')._d : null;        
                const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
                var dataAF      = adicaoAF.currentRow.DTAUTOFORN;
                dataAF          = dataAF ? moment(dataAF, 'DD/MM/YYYY')._d : null;
                widget.currentRow.DTAUTOFORN = dataAF;
                widget.currentRow.CDFORNECED = adicaoAF.currentRow.CDFORNECED;
                widget.currentRow.OPERADOR   = adicaoAF.currentRow.CDOPERADOR;
                
                const isDeliveryDateValid = basicDeliveryDateValidation({
                    dataEntrega,
                    dataAtual,
                    dataAF,
                });
                
                if (!isDeliveryDateValid) return;
                
                
                ServiceLancamentoAF.validaProduto(widget.currentRow).then(function(response) {
                    const error = {
    					"NMPRODUTO": widget.currentRow.NMPRODUTO, 
    					"NMUNIDADE": adicaoAF.currentRow.NMFILDEST
    				};
                    
                    if (!Util.isEmptyOrBlank(response.dataset)) {
                        if (!Util.isEmptyOrBlank(response.dataset.message)) {
                            MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                        } else {
                            const currentRow = setCurrentRowProduto(widget);
							
                            ServiceLancamentoAF.validaDataEntrega(currentRow).then(function(response) {
                                if (!Util.isEmptyOrBlank(response.dataset)) {
                                    if (!Util.isEmptyOrBlank(response.dataset.message)) {
                                        MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                                    }        				
                                }
                                
                                if(widget.currentRow.TIPO_PRODUTO == "adicaoGeral") {
                                    widPrincipal.dataSourceAuxiliar.push(widget.currentRow);
                                    widPrincipal.dataSource.data.push(widget.currentRow);
                                } else if(widget.currentRow.TIPO_PRODUTO == "adicao") {
                                    widPrincipal.dataSourceAuxiliar.push(widget.currentRow);
                                    widget.widgetAntiga.dataSource.data = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                                        return row.CDPRODUTO == widget.currentRow.CDPRODUTO;
                                    });
                                }
                                ScreenService.closeSwipe();
                                widget.widgetAntiga.activate();
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                                widget.currentRow.DTPROGENTAF = "";
                            });
                        }       				
                    }
                }, function(err) {
                    ScreenService.showMessage(err);
                });
            });
        }
    };
    
    this.voltarProdutoDetalhes_AF = function(widget) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("adicao_produtos").activate();
    };
    
    this.cancelarProduto_AF = function(widget) {
        ScreenService.closeSwipe();
        widget.widgetAntiga.activate();
    };
    
    this.validaProdutoGeral_AF = function(widget) {
        var dataSource = templateManager.container.getWidget("adicao_produtos").dataSource.data;
        
        for(var i = 0; i < dataSource.length; i++) {
            if(widget.currentRow.CDPRODUTO == dataSource[i].CDPRODUTO) {
                const param = {
                    PARAM: widget.currentRow.NMPRODUTO  
                };
                
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', param, Constants.alertMessage);
                
                widget.currentRow.NMPRODUTO = "";
                widget.currentRow.CDPRODUTO = "";
                return false;
            }
        }
        self.filtraMarca(widget);
    };
    
    this.onChangeUnidadeDestinoAdicaoAF = function(widget) {
        stateOnEnterAdicao.unidadeDestino = {
            codigo: widget.currentRow.CDFILDEST,
            nome: widget.currentRow.NMFILDEST,
        };
        
        this.onEnterAdicao(stateOnEnterAdicao);
    };
    
    /*************************************************************************************/
    /*                FUNÇÕES RELACIONADAS À JUSTIFICATIVA DE ALTERAÇÃO                  */
    /*************************************************************************************/
    
    this.definirParametros = function(row, acao) {
        const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
        let just = templateManager.container.getWidget("justificativaPopup");
        let arrayReplace = [];
        
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXAAF_BKP]);
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXAAF]);
	
    	just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.IDOPERAMOVAF  = "A";
        just.currentRow.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        just.currentRow.JUSTIFICATIVA = acao;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
    };
    
    function setParametrosBaixaItem({ row, produto, justificativaPopup, baixaMultipla = false }) {
        const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
        let arrayReplace = [];
        
        if (baixaMultipla) row.DSJUSTOPERMOV = "";
        
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXITMAF]);
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXITMAF_BKP]);
        
        justificativaPopup.currentRow.CDFILDESMOV   = produto.CDFILDEST;
        justificativaPopup.currentRow.CDFILLANMOV   = produto.CDFILLANC;
        justificativaPopup.currentRow.NRAUTOMOV     = produto.NRAUTOFORN;
        justificativaPopup.currentRow.DTPROGENTMOV  = null;
        justificativaPopup.currentRow.IDOPERAMOVAF  = "A";
        justificativaPopup.currentRow.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        justificativaPopup.currentRow.ITEM          = produto.NMPRODUTO;
        justificativaPopup.currentRow.MARCA         = produto.NMMARCA;
        justificativaPopup.currentRow.DATA          = produto.DTPROGENTAF;
        justificativaPopup.currentRow.CDPRODMOV     = produto.CDPRODUTO;
        justificativaPopup.currentRow.CDMARCMOV     = produto.CDMARCA;
        justificativaPopup.currentRow.DTPROGENTMOV  = produto.DTPROGENTAF;
        
        row.CDFILDESMOV   = produto.CDFILDEST;
        row.CDFILLANMOV   = produto.CDFILLANC;
        row.NRAUTOMOV     = produto.NRAUTOFORN;
        row.DTPROGENTMOV  = null;
        row.IDOPERAMOVAF  = "A";
        row.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        row.ITEM          = produto.NMPRODUTO;
        row.MARCA         = produto.NMMARCA;
        row.DATA          = produto.DTPROGENTAF;
        row.CDPRODMOV     = produto.CDPRODUTO;
        row.CDMARCMOV     = produto.CDMARCA;
        row.DTPROGENTMOV  = produto.DTPROGENTAF;
    }
    
    this.definirParametrosBaixaItem = function(produto, acao, baixaMultipla = false) {
        const justificativaPopup = templateManager.container.getWidget("justificativaPopup");
        
        justificativaPopup.currentRow = {};
        justificativaPopup.applyDefaultValue();
        
        this.mudaJustificativa(justificativaPopup);
        
        if (baixaMultipla) {
            templateManager.container.getWidget("produtos").getCheckedRows().forEach(row => {
                setParametrosBaixaItem({
                    row,
                    produto: row,
                    justificativaPopup,
                    baixaMultipla
                });
            });
        } else {
            setParametrosBaixaItem({
                row: produto,
                produto,
                justificativaPopup,
            });
        }
        
        justificativaPopup.currentRow.JUSTIFICATIVA = acao;
        
        justificativaPopup.getField("ITEM").isVisible  = true;
        justificativaPopup.getField("MARCA").isVisible = true;
        justificativaPopup.getField("DATA").isVisible  = true;
        
        ScreenService.openPopup(justificativaPopup);
    };
    
    this.definirParametrosFormaPgto = function(row, backup, acao) {
        var just  = templateManager.container.getWidget("justificativaPopup");
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.JUSTIFICATIVA = acao;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
        
        if(row.IDTPFORPGTFO == null && row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            just.currentRow.DSALTERAF = "Exclusão Forma de Pagamento";
            just.currentRow.IDOPERAMOVAF  = "E";
            return true;
        } else if(backup.IDTPFORPGTFO == null && row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            just.currentRow.DSALTERAF = "Inclusão Forma de Pagamento";
            just.currentRow.IDOPERAMOVAF  = "I";
            return true;
        } else if(row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            MessageService.getMessageByCode("CHANGE_PAYMENT").then( message => {
                const arrayFind = ["__IDTPFORPGTFO__", "__IDTPFORPGTFO__"];
                const arrayReplace = [backup.IDTPFORPGTFO, row.IDTPFORPGTFO];
                
                just.currentRow.DSALTERAF = replaceArray(message, arrayFind, arrayReplace);
                just.currentRow.IDOPERAMOVAF  = "A";
                return true;
            });
        } else
            return false;
    };
    
    this.definirParametrosEncargo = function(row, acao) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        MessageService.getMessageByCode("CHANGE_CHARGES").then( message => {
            const arrayFind = ["__NMENCARGO__", "__VRENCARGOAF__", "__VRENCARGOAF__"];
            const arrayReplace = [row.NMENCARGO, toString(row.changed_VRENCARGOAF), toString(General.valueToFloat(row.VRENCARGOAF))];
            
            just.currentRow = {};
            just.applyDefaultValue();
            this.mudaJustificativa(just);
            just.currentRow.__is_new      = true;
            just.currentRow.CDFILDESMOV   = row.CDFILDEST;
            just.currentRow.CDFILLANMOV   = row.CDFILLANC;
            just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
            just.currentRow.DTPROGENTMOV  = null;
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.DSALTERAF = replaceArray(message, arrayFind, arrayReplace);
            just.currentRow.JUSTIFICATIVA = acao;
            just.getField("ITEM").isVisible  = false;
            just.getField("MARCA").isVisible = false;
            just.getField("DATA").isVisible  = false;
        });
    };
    
    this.definirParametrosImpostos = function(row, acao) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        MessageService.getMessageByCode("CHANGE_ALIQUOT").then( message => {
            const arrayFind = ["__VRALIQITMAF__", "__VRALIQITMAF__"];
            const arrayReplace = [toString(row.changed_VRALIQITMAF), toString(General.valueToFloat(row.VRALIQITMAF))];
            
            just.currentRow = {};
            just.applyDefaultValue();
            this.mudaJustificativa(just);
            just.currentRow.__is_new      = true;
            just.currentRow.CDFILDESMOV   = row.CDFILDEST;
            just.currentRow.CDFILLANMOV   = row.CDFILLANC;
            just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
            just.currentRow.DTPROGENTMOV  = null;
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.DSALTERAF     = replaceArray(message, arrayFind, arrayReplace);
            just.currentRow.JUSTIFICATIVA = acao;
            just.getField("ITEM").isVisible  = false;
            just.getField("MARCA").isVisible = false;
            just.getField("DATA").isVisible  = false;
        });
    };
    
    this.definirParametrosEdicaoAF = function(row, acao, mensagem) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.IDOPERAMOVAF  = "A";
        just.currentRow.JUSTIFICATIVA = acao;
        just.currentRow.DSALTERAF = mensagem;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
    };
    
    this.definirParametrosProduto = function(widget, mensagem, posicao, tipo) {
        var row = widget.currentRow;
        var just = templateManager.container.getWidget("justificativaPopup");
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.ITEM          = row.NMPRODUTO;
        just.currentRow.MARCA         = row.NMMARCA;
        just.currentRow.DATA          = row.DTPROGENTAF;
        just.currentRow.CDPRODMOV     = row.CDPRODUTO;
        just.currentRow.CDMARCMOV     = row.CDMARCA;
        just.currentRow.DTPROGENTMOV  = row.DTPROGENTAF;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
        if(widget.name == "adicaoProduto") {
            just.currentRow.IDOPERAMOVAF  = "I";
            just.currentRow.JUSTIFICATIVA = "inclusaoProdutoGeral" + "_" + tipo;
            just.currentRow.DSALTERAF = "Inclusão de Item de AF";
        } else if(row.NOVO) {
            just.currentRow.IDOPERAMOVAF  = "I";
            just.currentRow.JUSTIFICATIVA = "inclusaoProduto" + "_" + tipo;
            just.currentRow.DSALTERAF = "Inclusão de Item de AF";
        } else {
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.JUSTIFICATIVA = "alteracaoProduto" + "_" + tipo;
            just.currentRow.DSALTERAF = mensagem[posicao];
        }
    };
    
    this.mudaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPERMOV = "";
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("DSJUSTOPERMOV").template = "field/text-edit.html";
            widget.getField("DSJUSTOPERMOV").label    = "Outra";
        }
    };
    
    this.atualizaValorTotal = function() {
        const listaAF = templateManager.container.getWidget("listaAF");
        const dadosAF = templateManager.container.getWidget("dadosAF");
        
        listaAF.reload().then(function() {
            const atual = listaAF.dataSource.data.filter(function(row) {
                return row.NRAUTOFORN == dadosAF.currentRow.NRAUTOFORN;
            }).shift();
            
            listaAF.setCurrentRow(atual);
        });
    };
    
    var toString = function(val) {
        val = val ? val : 0;
		var string = (typeof val === "string") ? val : val.toString().replace('.', ',');
		return string;
	};
	
	this.abreFiltroRelatorioAF = function() {
	    
	    let widgetRelatorio = templateManager.container.getWidget('widgetRelatorio');
	    
	    ScreenService.openPopup(widgetRelatorio).then(function() {
	        widgetRelatorio.applyDefaultValue();
	        widgetRelatorio.redraw();
	    });
	    
	};
	
	this.defineFiltroMensagem = function() {
	    let rowDadosAF = templateManager.container.getWidget('dadosAF').currentRow;
	    let fieldMensagem = templateManager.container.getWidget('widgetRelatorio').getField('NRMENSAUTFOR');
	    
	    General.onClickDependentField(fieldMensagem, { 'CDFILLANC': rowDadosAF.CDFILLANC, 'CDFILDEST': rowDadosAF.CDFILDEST, 'NRAUTOFORN': rowDadosAF.NRAUTOFORN });
	    
	};
	
	this.gerarRelatorio = function() {
	    const widgetRelatorio = templateManager.container.getWidget('widgetRelatorio');
	    const rowRelatorio = widgetRelatorio.currentRow;
	    const row = templateManager.container.getWidget('listaAF').currentRow;
	    const params = {
	        "__report_name": rowRelatorio.REPORT,
            "CDFILIAL": row.CDFILDEST,
            "NRAUTOFORN": row.NRAUTOFORN,
            "CDFILLANC": row.CDFILLANC,
            "PROXMES": row.IDUTDIAPGTAF ? row.IDUTDIAPGTAF : 'N',
            "IMPRIMEOBS": rowRelatorio.IMPRIMEOBS,
            "IMPRIMEOBSPROD": rowRelatorio.IMPRIMEOBSPROD,
            "NRMENSAUTFOR": rowRelatorio.NRMENSAUTFOR.length ? rowRelatorio.NRMENSAUTFOR.join('_') : 'T',
            "NRORG": getLocalVar("NRORG")
	    };
	    
	    General.openReportPopup(widgetRelatorio, abreRelatorio, [params, rowRelatorio], reportFormats);
	};
	
    function abreRelatorio(row, rowRelatorio) {
        
        row.QR2TYPE = rowRelatorio.QR2TYPE;
        General.openReport('cmp_fornecimento_autorizacaoFornecimento#/CMP03900', row.__report_name, row);
         
    }
    
    this.abreImportacaoSolicitacaoCompras = function() {
        if(paraSupri.CDMARCA == null){
            MessageService.showMessageByCode("MARCA_NOT_REGISTERED", null, Constants.errorMessage);
        } else {
            
            $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03905_importacao_solicitacao_compras.json').then(function (response) {
                const containerImportacaoSolicitacao = this.containerFactory(response.data);
        			
    			templateManager.container = containerImportacaoSolicitacao;
            }.bind(metaDataFactory));
        }
    };
    
    function setDataFromImportacaoSoliticacaoCompras(dadosAF, produto, produtos, filialDestino) {
        const container = dadosAF.container;
        const dadosImportacao = container.dadosImportacao;
        
        dadosAF.currentRow.NMRAZSOCFORN = dadosImportacao.NMRAZSOCFORN;
        dadosAF.currentRow.CDFORNECED = dadosImportacao.CDFORNECED;
        dadosAF.currentRow.IDGERAFDTENT = dadosImportacao.IDGERAFDTENT;
        
        self.onChangeFornecedorAdicaoAF(dadosAF.getField('NMRAZSOCFORN'));
        
        dadosAF.currentRow.CDOPERADOR = dadosImportacao.CDOPERADOR;
        dadosAF.currentRow.NMOPERADOR = dadosImportacao.NMOPERADOR;
        
        dadosImportacao.itens.forEach(item => {
            item.CDFILDEST = filialDestino.codigo;
            item.NMFILDEST = filialDestino.nome;
            item.QTVOLUITEMAF = null;
            item.QTPROGENTAF = item.QTSOLIPROD;
            item.VRPREUNIAF = item.VRCUSTO;
            item.PRECOTOTAL = item.VRCUSTO * item.QTSOLIPROD;
            item.VRPERDESAF = null;
            item.VRDESCITMAF = null;
            item.DTPROGENTAF = item.DTPROGENTR;
        });
        
        self.validaComprador(dadosAF);
        
        produtos.dataSourceAuxiliar = dadosImportacao.itens;
        produtos.dataSource.data = dadosImportacao.itens;
        
        produto.dataSource.data = dadosImportacao.itens;
    }
    
    this.setContainer = function(newContainer) {
        containerAF = newContainer;
    };
    
    this.onChangeFornecedorAdicaoAF = function(field) {
        self.validaFornecedor(field.widget);
        self.setFilterPrazoPercentual(field);
        self.atualizaFiltroProduto(field.widget, 'widProduto');
    };
    
    this.atualizaFiltroProduto = function(widget, widgetName) {
		let currentRow = widget.currentRow;
		
		let params = {
				"NRORG": getLocalVar('NRORG'),
				"P_CDFORNECED": currentRow.CDFORNECED
            };
            
        widget.container.getWidget(widgetName).getField('NMPRODUTO').dataSourceFilter.forEach(function(filter){
			filter.value = params[filter.name];
		});
 	};
 	
 	this.backToProducts = function(widget) {
        ScreenService.closeSwipe();
        let widgetProdutos = widget.container.getWidget("produtos");
        widgetProdutos.list();
        widgetProdutos.activate();
    };
    
    this.cancelEditProducts = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        
        ScreenService.closeSwipe();
        
        widgetProdutos.activate();
    };
    
    function setJustificativa(row, dtProgEntAF, idOperacao, dsAlterAF) {
        row.JUSTIFICATIVAS.push({
    	    'CDFILDESMOV':   row.CDFILDEST,
    	    'CDFILLANMOV':   row.CDFILLANC,
    	    'NRAUTOMOV':     row.NRAUTOFORN,
    	    'DTPROGENTMOV':  dtProgEntAF,
    	    'IDOPERAMOVAF':  idOperacao,
    	    'DSALTERAF':     dsAlterAF,
    	    'DSJUSTOPERMOV': row.DSJUSTOPERMOV,
    	    'CDPRODMOV':     row.CDPRODUTO,
    	    'CDMARCMOV':     row.CDMARCA,
    	});
    }
    
    this.saveEditProductAF = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        const dadosAF = templateManager.container.getWidget('dadosAF');
        let promises = [];
		let mensagem = [];
		
		if(widget.currentRow.changed && paraSupri.IDAUDALTAF === 'S') {
			widget.getField("DSJUSTOPERMOV").validations.required = true;
		} else {
			widget.getField("DSJUSTOPERMOV").validations = {};    
		}

		if(widget.isValid()) {
		    widget.currentRow.QTPROGENTAFORIG = widget.backupRow.QTPROGENTAF;
		    
		    if(General.valueToFloat(widget.backupRow.QTPROGENTAF) !== General.valueToFloat(widget.currentRow.QTPROGENTAF)) {
                widget.currentRow.ATUSOLI = 'N';
				if(paraSupri.IDATUSOLILAF === 'S' && widget.currentRow.IDTPLANITEAF === 'A') {
                    MessageService.confirmMessageByCode("CONFIRM_ATUSOLI", null, Constants.confirmationMessage).then(function(){
                        widget.currentRow.ATUSOLI = 'S';
                    });
				}
			}
		    
            promises.push(MessageService.getMessageByCode("CHANGE_QTPROGENTAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_DTPROGENTAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_VRPREUNIAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_VRPERDESAF"));
    
    		Promise.all(promises).then((response) => {
    			if(paraSupri.IDAUDALTAF === 'S') {
        			if(response[0]) mensagem.push(response[0]);
        			if(response[1]) mensagem.push(response[1]);
        			if(response[2]) mensagem.push(response[2]);
        			if(response[3]) mensagem.push(response[3]);
        			
        			widget.currentRow.JUSTIFICATIVAS = [];
    			
                    if(General.valueToFloat(widget.backupRow.QTPROGENTAF) !== General.valueToFloat(widget.currentRow.QTPROGENTAF)) {
                        let currentValue = Util.applyMask(widget.currentRow.QTPROGENTAF, widget.getField("QTPROGENTAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.QTPROGENTAF, widget.getField("QTPROGENTAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    					
    					arrayFind.push("__OLDQTPROGENTAF__", "__NEWQTPROGENTAF__");
    					arrayReplace.push(backupValue, currentValue);
    					
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[0], arrayFind, arrayReplace));
    				}
    				if(widget.currentRow.DTPROGENTAF !== widget.backupRow.DTPROGENTAF) {
    				    let currentValue = moment(widget.currentRow.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
                        let backupValue = moment(widget.backupRow.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDDTPROGENTAF__", "__NEWDTPROGENTAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'I', replaceArray(mensagem[1], arrayFind, arrayReplace));
    					setJustificativa(widget.currentRow, widget.backupRow.DTPROGENTAF, 'E', replaceArray(mensagem[1], arrayFind, arrayReplace));
    				}
    				if(General.valueToFloat(widget.backupRow.VRPREUNIAF) !== General.valueToFloat(widget.currentRow.VRPREUNIAF)) {
    				    let currentValue = Util.applyMask(widget.currentRow.VRPREUNIAF, widget.getField("VRPREUNIAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.VRPREUNIAF, widget.getField("VRPREUNIAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDVRPREUNIAF__", "__NEWVRPREUNIAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[2], arrayFind, arrayReplace));
    				}
    				if(General.valueToFloat(widget.backupRow.VRPERDESAF) !== General.valueToFloat(widget.currentRow.VRPERDESAF)) {
    				    let currentValue = Util.applyMask(widget.currentRow.VRPERDESAF, widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.VRPERDESAF, widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDVRPERDESAF__", "__NEWVRPERDESAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[3], arrayFind, arrayReplace));
    				}
    			}
    			
    			widget.currentRow.CDTPINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
				widget.currentRow.IDPERVALORCOL = dadosAF.currentRow.IDPERVALORAF;
				widget.currentRow.CDINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
				widget.currentRow.DTREFINDCOL = dadosAF.currentRow.DTREFINDAF;
				
				validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
					widgetProdutos.dataSourceSave.push(widget.currentRow);
					ScreenService.closeSwipe();
					widget.container.getWidget("produtos").activate();
				});
		    });
		}
    };
    
    this.saveAllProducts = function(widgetProdutos) {
        if(widgetProdutos.isValid()) {
            const widget = widgetProdutos.container.getWidget("produtos");
            if(widget.dataSourceSave.length > 0){
                ServiceLancamentoAF.validateAllProducts(widget.dataSourceSave).then(function() {
                    widget.currentRow.VALIDADATA = true;
                    
                    ServiceLancamentoAF.saveAllProduct({
                        'dadosAF': templateManager.container.getWidget('listaAF').currentRow,
                        'produtos': widget.dataSourceSave,
                    }).then(function() {
                        verificaInconsistencias(widget);
                        /**
                         * TODO: Revisar essa chamada do backListProducts, pois, caso haja inconsistências e o usuário queira corrigir,
                         * o dataSourceSave já foi limpo por essa função.
                         */
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                        backListProducts();
                    });
                    
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                    backListProducts();
                });   
            } else {
                MessageService.showMessageByCode("NO_UPDATES");
                backListProducts();
            }
        }
    };
    
    function backListProducts() {
        const widgetProdutos = templateManager.container.getWidget("produtos");
        
        widgetProdutos.list();
        widgetProdutos.dataSourceSave = [];
        
        General.changeWidgetAcessibility(templateManager.container.getWidget('tabbedWidget').widgets, true);
    }
    
    function verificaPrecoCotacaoAF(row, widProdutos) {
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/verificaPrecoCotacaoAF','Row', row).then(function(res){
            let result;
            
            if (res.dataset && res.dataset.res[0])
                result = res.dataset.res[0];
                
            if(result && result.IDMOTPRESCAF == "0000100000" && paraSupri.IDBLOQFORNCOTAF == 'S')
                widProdutos.getAction("editarProdutoGeral").isVisible = false;
            
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.onEnterWidgetProduto = function(widProduto) {
        
        validaUsoIndiceFinanceiro();
        
        if (widProduto.inEditMode()) {
            this.validaEdicaoPreco(widProduto);
        }
    };
    
    /*************************************************************************************/
    /*                                   FUNÇÕES 'ANEXO'                                 */
    /*************************************************************************************/
     
    /**
     * Adição de AF
     */
    
    this.importAnexoFile = function(args) {
      const importWidget = templateManager.container.getWidget('AnexoDocGridImportFile');
    
      importWidget.newRow();
      ScreenService.openPopup(importWidget);
    };
    
    this.saveAnexoLocal = function(widget) {
        if (!widget.isValid()) return;
        
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.DTANEXOLANCAF = moment().format('DD/MM/YYYY');
        
        ServiceLancamentoAF.saveAnexoLocal(widget.currentRow).then(function(response) {
            const item = angular.copy(widget.currentRow);
            
            item.NRANEXOLANCAF = response.dataset.data.NRANEXOLANCAF;
            item.NMANEXOLANCAF = item.ANEXO[0].name;
            
            widget.getParent().dataSource.data.push(item);
            
            ScreenService.closePopup();
            MessageService.successNotificationByCode("IMPORT_SUCCESS");
        }, function(response) {
            ScreenService.showMessage(response.error);
        });
    };
    
    this.deleteAnexoLocal = function(widget) {
        const itens = widget.getCheckedRows().map(item => ({ NRANEXOLANCAF: item.NRANEXOLANCAF }));
        
        ServiceLancamentoAF.deleteAnexoLocal(itens).then(function (sucess) {
            widget.dataSource.data = widget.dataSource.data.filter(item => !widget.getCheckedRows().includes(item));
            widget.dataSource.clearCheckedRows();
        }, function(response) {
            ScreenService.showMessage(response.error);
        });
    };
    
    /**
     * Visualização da AF
     */
    
    const ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    this.saveAnexoGrid = function(widget) {
        if (!widget.isValid()) return;
        
        const dadosAF = widget.container.getWidget('dadosAF');
        
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.CDFILDEST = dadosAF.currentRow.CDFILDEST;
        widget.currentRow.NRAUTOFORN = dadosAF.currentRow.NRAUTOFORN;
        widget.currentRow.DTANEXOLANCAF = moment().format('DD/MM/YYYY');
        
        const row = Util.clone(widget.currentRow, ignoredKeys);
        
        ServiceLancamentoAF.salvaAnexoGrid(row).then(function (sucess) {
            widget.getParent().reload();
            
            ScreenService.closePopup();
            MessageService.successNotificationByCode("IMPORT_SUCCESS");
        }, function(error) {
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    this.deleteAnexoGrid = function(widget){
      ScreenService.confirmMessage('Deseja realmente excluir o(s) anexo(s)?', 'question', function() {
          const isMultilineDelete = widget.hasCheckedRows();
          const hasAttach = !!widget.currentRow.NRANEXOLANCAF;
          const dataSet = isMultilineDelete ? cleanDataSet(widget.getCheckedRows()) : [ Util.clone(widget.currentRow, ignoredKeys) ];
          
          if (!isMultilineDelete && !hasAttach) {
            return;
          }
    
          ServiceLancamentoAF.deleteAnexoGrid(dataSet).then(
              function (sucess){
                  if (!isMultilineDelete) {
                    ScreenService.goBack();
                    MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
                  }
    
                  widget.reload();
                  
                  widget.dataSource.clearCheckedRows();
              }, function(error){
                  ScreenService.showMessage(error.dataset.error);
              }
          );
      });
    };
    
    this.downloadAnexoGrid = function(widget){
      ServiceLancamentoAF.getFileServerUrl().then(
        function(sucess) {
            const isMultilineDownload = widget.hasCheckedRows();
            const serviceUrl = sucess.dataset.sucess.fileName;
            const downloadFile = function(row) {
              const fileName = row.NMPATHANEXO;
              const serviceUrlIndex = window.serviceUrls.findIndex(service => service.package == 'cmp');
              const baseUrl = window.serviceUrls[serviceUrlIndex].baseUrl;
              const downloadRoute = baseUrl + "/downloadArquivoAnexoFileServer?requestType=Row&row[NMARQUIVO]=";
              
              const rowDownload = {
                  'NMANEXOLANCAF':row.NMANEXOLANCAF, 
                  'PATH': serviceUrl+fileName
              };
    
              window.open(`${downloadRoute}${rowDownload.NMANEXOLANCAF}&row[PATH]=${rowDownload.PATH}`);
          };
    
          const rows = isMultilineDownload ? widget.getCheckedRows() : [ widget.currentRow ];
          
          rows.forEach(downloadFile);
        });
    };
    
    function cleanDataSet(dataSet) {
      // Remove rightActions
      dataSet.forEach(function(data){
        delete data.__rightActions;
      });
      
      return dataSet;
    }
    
    this.onEnterTabAnexo = function(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        
        widget.dataSourceFilter = [
            {
                name: 'NRORG',
                operator: '=',
                value: getLocalVar('NRORG'),
            },
            {
                name: 'NRAUTOFORN',
                operator: '=',
                value: dadosAF.currentRow.NRAUTOFORN,
            }
        ];
        
        widget.reload();
    };

    function genericOpenMailPopUp(idAgrupAF, idTpEnvAF) {
        const widget = templateManager.container.getWidget('EMAIL_EDIT_POPUP');
        
        widget.applyDefaultValue();
        
		const promises = [
		    MessageService.getMessageByCode("DEFAULT_MAIL_PORTAL_BODY"),
		    MessageService.getMessageByCode("DEFAULT_MAIL_ANEXO_BODY"),
		    MessageService.getMessageByCode("DEFAULT_MAIL_SUBJECT"),
		    MessageService.getMessageByCode("MSG_EMAIL_VISUALIZA"),
		    MessageService.getMessageByCode("MSG_EMAIL_AUTO"),
		    MessageService.getMessageByCode("MSG_DATE_SENT"),
		    
		    //msgArray
		    MessageService.getMessageByCode("SUCCESS_MESSAGE"),
		    MessageService.getMessageByCode("ERROR_MESSAGE"),
		    MessageService.getMessageByCode("EMAIL_N_REGISTERED"),
		    MessageService.getMessageByCode("MAIL_NOT_SENDED_IDTPENVAFFOR"),
		    MessageService.getMessageByCode("EMAIL_SEND_SUCCESS_GROUP"),
		    MessageService.getMessageByCode("EMAIL_SEND_FAILED_GROUP"),
		    MessageService.getMessageByCode("EMAIL_SEND_SUCCESS"),
		    MessageService.getMessageByCode("EMAIL_SEND_FAILED"),
		    MessageService.getMessageByCode("MSG_SEND_OPERATOR")
        ];
		
		Promise.all(promises).then((response) => {
			const row = {
                "DEFAULT_MAIL_PORTAL_BODY": response.shift(),
                "DEFAULT_MAIL_ANEXO_BODY": response.shift(),
                "DEFAULT_MAIL_SUBJECT": response.shift(),
                "MSG_EMAIL_VISUALIZA": response.shift(),
                "MSG_EMAIL_AUTO": response.shift(),
                "MSG_DATE_SENT": response.shift(),
                "IDTPENVAFNORMAL": idTpEnvAF
            };
            
            const msgArray = {
                'SUCCESS_MESSAGE': response.shift(),
                'ERROR_MESSAGE': response.shift(),
                'EMAIL_N_REGISTERED': response.shift(),
                'MAIL_NOT_SENDED_IDTPENVAFFOR': response.shift(),
                'EMAIL_SEND_SUCCESS_GROUP': response.shift(),
                'EMAIL_SEND_FAILED_GROUP': response.shift(),
                'EMAIL_SEND_SUCCESS': response.shift(),
    		    'EMAIL_SEND_FAILED': response.shift()
            };
            
            const descLabel = response.shift() + getLocalVar('NMOPERADOR');
            widget.getField('SENDOPERATOR').label = descLabel;

            ServiceLancamentoAF.retornaCookieEmail(row).then(function(success) {
			    widget.currentRow.ASSUNTO = success.messages.shift().message;
                widget.currentRow.MENSAGEM = success.messages.shift().message;
                widget.currentRow.DSLINK = success.messages.shift().message;
                widget.currentRow.MSGCOMPRAS = success.messages.shift().message;
                widget.currentRow.MSGDATESENT = success.messages.shift().message;
                widget.currentRow.SENDOPERATOR = success.messages.shift().message;
                widget.currentRow.MSGARRAY = msgArray;
                widget.currentRow.IDAGRUPAF = idAgrupAF;
			    ScreenService.openPopup(widget);
			    widget.reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
		});
    }

    this.openMailPopUp = function(afPosicionada){
        if (afPosicionada) {
            const rowListaAF = templateManager.container.getWidget("listaAF").currentRow;
            triggerWidget = getTriggerWidget();
            
            if (Util.isEmptyOrBlank(rowListaAF.IDSITUATUAAF) && rowListaAF.IDAFFORALIM == 'N') {
                if(rowListaAF.IDTPENVAFFOR === '1') {
                    genericOpenMailPopUp('N', triggerWidget.currentRow.IDTPENVAFNORMAL);
                } else {
                    MessageService.showMessageByCode("MAIL_NOT_SENDED_IDTPENVAFFOR", {NMFANTFORN: rowListaAF.NMFANTFORN}, Constants.errorMessage);
                }
            } else {
        	    MessageService.showMessageByCode("AF_INCONSISTENTE");
        	}
        } else {
            const listaAF = templateManager.container.getWidget("listaAFSelecionadas");
            const row = Util.isEmptyObject(listaAF.currentRow) ? listaAF.currentRow : listaAF.dataSource.getFirstRow();
            let isOk = true;
            
            if(row.IDAGRUPAF === 'S'){
                isOk = !Util.isEmptyOrBlank(row);
            } else {
                isOk = !Util.isEmptyOrBlank(listaAF.getCheckedRows());
            } 
            
            if(isOk){
                //Por ser possível selecionar mais de um fornecedor o cookie retornado será sempre o de anexo
                genericOpenMailPopUp(row.IDAGRUPAF, 'E');
            } else {
                MessageService.showMessageByCode("AF_NAO_SELECIONADA", null, Constants.errorMessage);
            }
        }
    };
    
    this.openSelectAF = function(){
        triggerWidget = getTriggerWidget();
        ScreenService.openWindow('cmp_fornecimento_autorizacaoFornecimento#cmp03900_envio_AF');
    };
    
    this.setupFilter = function(widget){
        widget.getField('DT_AF').defaultValue.start      = moment().format('DD/MM/YYYY');
        widget.getField('DT_AF').defaultValue.end        = moment().format('DD/MM/YYYY');
        widget.getField('DT_ENTREGA').defaultValue.start = moment().format('DD/MM/YYYY');
        widget.getField('DT_ENTREGA').defaultValue.end   = moment().format('DD/MM/YYYY');
        
        ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('listaAFSelecionadas'));
    };
    
    this.emailAFPosicionada = function(widget) {
        const currentRow = triggerWidget.currentRow;
        const row = {
            "DADOS_EMAIL": widget.currentRow,
            "CURRENT_ROW": currentRow
        };
        
        if (Util.isEmptyOrBlank(currentRow.IDSITUATUAAF) && currentRow.IDAFFORALIM == 'N') {
            
            ServiceLancamentoAF.sendEmailAFPosicionada(row).then(function(success) {
                exibeLogEnviosAF(widget, success.messages, false);
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
            });
        } else {
    	    MessageService.showMessageByCode("AF_INCONSISTENTE");
    	}
    };
    
    function exibeLogEnviosAF(widget, success, isGroup) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        const arrayMesssages = widget.currentRow.MSGARRAY;
        let arrayError = [];
        let arraySuccess = [];
        let arrayLogs = [];
        let addHeadSuccess = true;
        let addHeadError = true;
        
        success.forEach(function(row) {
            const logSuccess = row.message.SUCCESS;
            const logError = row.message.ERROR;
        
			if (!Util.isEmptyOrBlank(logSuccess)) {
			    if (addHeadSuccess) {
				    addHeadSuccess = false;
				    arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
				    adicionaCabecalhoAoLog(arraySuccess, arrayMesssages.SUCCESS_MESSAGE);
			    } else {
			        arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
			    }
			}
			
			if (!Util.isEmptyOrBlank(logError)) {
			    if (addHeadError) {
				    addHeadError = false;
				    arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
				    adicionaCabecalhoAoLog(arrayError, arrayMesssages.ERROR_MESSAGE);
			    } else {
			        arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
			    }
			}
        });

        arrayLogs = arrayError.concat(arraySuccess);
        ScreenService.closePopup();
        General.showErrorMessages(widgetOrigem, arrayLogs, ScreenService.i18n('Log'));
    }
    
    function adicionaCabecalhoAoLog(logArray, titulo) {
        logArray.unshift('----------------------------');
        logArray.unshift(titulo);
        logArray.unshift('----------------------------');
    }
    
    function setArrayLog(messages, arrayMesssages) {
        let result = [];
        
        messages.forEach(row => {
    		result.push(arrayMesssages[row.MESSAGE].replace('__NMFANTFORN__', row.NMFANTFORN).replace('__NRAUTOFORN__', row.NRAUTOFORN));
		});
		
		return result;
    }
    
    this.emailAFSelecionadas = function(widget) {
        const listaAF = templateManager.container.getWidget("listaAFSelecionadas");
        const row = {
            "DADOS_EMAIL": widget.currentRow,
            "DATASET": listaAF.dataSource.data,
            "CHECKED_ROWS": listaAF.getCheckedRows(),
            "FILTER_ROW": listaAF.FILTER_ROW
        };
        
        ServiceLancamentoAF.sendEmailAFSelecionada(row).then(function(success) {
            exibeLogEnviosAF(widget, success.messages, false);
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller', Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/CMP03905ImportacaoSolicitacaoComprasController.js
function CMP03905ImportacaoSolicitacaoComprasController(CMP03905ImportacaoSolicitacaoComprasService, Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller, metaDataFactory, $http, General, Utilities, ScreenService, templateManager, MessageService, ZHPromise) {
    /**********
     * Filtro *
     **********/
    
    this.onEnterOnceImportacaoSolicitacaoCompras = function(widget) {
        const filterRow = {
            FORNECEDOR: '',
            COMPRADOR: '',
            CDFILDEST: '',
            NRSOLICMP_FILTRO: '',
            CARREGAJAIMP: 'N',
            CARREGARPRECOLISTA: 'N',
            NMTIPOCUSTO: '',
            CUSTOZERO: 'N'
        };
        
        Utilities.startFilter(widget, filterRow);
    };
    
    function skipZeedhiFilterApply(args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    }
    
    this.beforeFilterApply = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widgetGrid = templateManager.container.getWidget('cmp03905_grid');
        
        skipZeedhiFilterApply(args);
        
        // if(!widget.SENHA_GERENTE) {
        //     return ScreenService.showMessage("Senha inválida!");
        // }
        
        widgetGrid.dataSourceFilter = [
            {
                name: 'P_CDFILIAL',
                operator: '=',
                value: filterRow.CDFILIAL,
            },
            {
                name: 'P_LISTAPRECO',
                operator: '=',
                value: '',
            },
            {
                name: 'P_CUSTOZERO',
                operator: '=',
                value: filterRow.CUSTOZERO,
            },
            {
                name: 'P_NRTIPCUST',
                operator: '=',
                value: filterRow.CDTIPOCUSTO,
            },
            {
                name: 'P_CDFORNECED',
                operator: '=',
                value: filterRow.CDFORNECED,
            },
            {
                name: 'P_NRSOLICMP',
                operator: '=',
                value: filterRow.NRSOLICMP,
            },
            {
                name: 'P_CARREGAJAIMP',
                operator: '=',
                value: filterRow.CARREGAJAIMP,
            },
            {
                name: 'P_CDOPERADOR',
                operator: '=',
                value: filterRow.CDOPERADOR,
            },
            {
                name: 'NRORG',
                operator: '=',
                value: getLocalVar('NRORG'),
            }
        ];
    };
    
    this.afterFilterApply = function(widget) {
        widget.floatingControl.refreshAction = true;
        if (widget.dataSource.data.length) {
            if(widget.dataSource.data[0].CDMARCA == null){
                MessageService.showMessageByCode("MARCA_NOT_REGISTERED", null, Constants.errorMessage).then(function(){
                    widget.dataSource.data = [];	
                });
            }
        }
    };
    
    this.habilitaFieldNumeroSolicitacao = function(fieldUnidadeDestino) {
        const widget = fieldUnidadeDestino.widget;
        const fieldNumeroSolicitacao = widget.getField('NRSOLICMP_FILTRO');
        
        if (fieldUnidadeDestino.value()) {
            const checkboxCarregaSolicitacoesJaImportadas = widget.getField('CARREGAJAIMP');
            
            fieldNumeroSolicitacao.readOnly = false;
            fieldNumeroSolicitacao.dataSourceFilter = [
                {
                    name: 'P_CDFILIAL',
                    operator: '=',
                    value: widget.currentRow.CDFILIAL
                },
                {
                    name: 'P_NRSOLICMP',
                    operator: '=',
                    value: ''
                },
                {
                    name: 'P_CARREGAJAIMP',
                    operator: '=',
                    value: checkboxCarregaSolicitacoesJaImportadas.value()
                },
                {
                    name: 'P_CDFORNECED',
                    operator: '=',
                    value: widget.currentRow.CDFORNECED
                }
            ];
        } else {
            fieldNumeroSolicitacao.readOnly = true;
            fieldNumeroSolicitacao.clearValue();
        }
    };
    
    
    /********
     * Grid *
     ********/  
    this.voltarParaLancamentoAF = function() {
        $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
            const containerLancamentoAF = this.containerFactory(response.data);
            
            Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.containerAF = containerLancamentoAF;
            templateManager.container = containerLancamentoAF;
        }.bind(metaDataFactory));
    };
    
    function verificaDtEntregaPorFornecedor(filterRow) { 
        const deferred = ZHPromise.defer();
        const checkedRows = templateManager.container.getWidget('cmp03905_grid').getCheckedRows();
        
        if(filterRow.CDFORNECED && filterRow.IDGERAFDTENT) {
            if(filterRow.IDGERAFDTENT === 'S') {
                const dtEntregas = [...new Set(checkedRows.map(row => row.DTPROGENTR))];
                if(dtEntregas.length > 1) {
                    MessageService.showMessageByCode("BLOCK_DIFFERENTS_DATES", {NMFANTFORN: filterRow.NMFANTFORN}, Constants.errorMessage);
                    return deferred.reject();
                }
            } else {
                deferred.resolve();
            }
        } else {
            return deferred.reject();
        }
        
        return deferred.promise;
    }
    
     
    this.importarParaAutorizacaoFornecimento = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const unidadeDestino = {
            codigo: filterRow.CDFILIAL,
            nome: filterRow.NMFILIAL,
        };
        
        if(verificaDtEntregaPorFornecedor(filterRow)) {
            $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
                const containerLancamentoAF = this.containerFactory(response.data);
                
                Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.setContainer(containerLancamentoAF);
                
                const filtro     = containerLancamentoAF.getWidget('filtro');
                const qtdVolume  = containerLancamentoAF.getWidget('produtos').getField('QTVOLUITEMAF').isVisible;
                const inconsAF   = containerLancamentoAF.getWidget('inconsistencias').getAction('ignorarInconsistencia').isVisible;
                
        		$http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_adicao_autorizacao_de_fornecimento.json').then(function(result) {
        			const containerAdicaoAF = this.containerFactory(result.data);
        			
        			templateManager.container = containerAdicaoAF;
        			
        			const tabAdicao = templateManager.container.getWidget('tab_adicao');
        			
        			const itens = widget.getCheckedRows().map(row => {
        			    row.QTESTOQUE = General.valueToFloat(row.QTESTOQUE);
        			    row.QTSOLIPROD = General.valueToFloat(row.QTSOLIPROD);
        			    row.VRCUSTO = General.valueToFloat(row.VRCUSTO);
        			    row.IDITMIPORT = true;
        			    
        			    return row;
        			});
        			
        			containerAdicaoAF.isImportacao = true;
        			containerAdicaoAF.dadosImportacao = {
        			    NMRAZSOCFORN: filterRow.NMRAZSOCFORN,
                        CDFORNECED: filterRow.CDFORNECED,
                        IDGERAFDTENT: filterRow.IDGERAFDTENT,
                        CDOPERADOR: filterRow.CDOPERADOR,
                        NMOPERADOR: filterRow.NMOPERADOR,
                        itens
        			};
        			
        			Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.onEnterAdicao({
        			    widget: tabAdicao,
        			    filtro,
        			    qtdVolume,
        			    unidadeDestino,
        			    inconsAF,
        			    isOnEnterEvent: true,
        			});
        		}.bind(this), function(error) {
        			throw error;
        		});
            }.bind(metaDataFactory));
        }
    };
    
    this.verificaCusto = function(args) {
        const widgetGrid = templateManager.container.getWidget('cmp03905_grid');
        
        if(widgetGrid.editing) {
        	args.e.preventDefault();
        }
        
        if(parseFloat(args.selectedRow.QTSOLIPROD) == 0){
            MessageService.showMessageByCode("INFORMAR_QTDE", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
        
        if(parseFloat(args.selectedRow.VRCUSTO) == 0){
            MessageService.showMessageByCode("INFORMAR_CUSTO", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CMP03905ImportacaoSolicitacaoComprasController', CMP03905ImportacaoSolicitacaoComprasController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp04200_liberacao_af_inconsistente_fora_do_limiteController.js
function Cmp04200_liberacao_af_inconsistente_fora_do_limiteController(Cmp04200_LiberacaoAfInconsistenteForaLimite_Service, General, Utilities, ScreenService, localStorageEngine, templateManager, ZhFilterPreferences, MessageService) {
    const ServiceLiberacaoAF = Cmp04200_LiberacaoAfInconsistenteForaLimite_Service;
    
    /******************
     * Funções Gerais *
     ******************/
    
    function showErrorMessage(response) {
        let errorMessage = 'Timeout';
                
        if (response.data) {
            errorMessage = response.data.error;
        }
        
        ScreenService.showMessage(errorMessage, 'error');
        
        if (!Util.isEmptyOrBlank(messageManager.processes)) {
            messageManager.unsubscribeAll();
        }
    }
    
    /******************
     * Grid Principal *
     ******************/
    
    function checksSupplyAuthorizationSituation(row, situation) {
        return row.SITUACAOAF.includes(situation);
    }
    
    function getSituationLabel(filterRow) {
        if (checksSupplyAuthorizationSituation(filterRow, 'IDAFFORALIM') &&
            checksSupplyAuthorizationSituation(filterRow, 'IDAFINCONS')) {
            return ScreenService.i18n('AFs Fora do Limite e AFs Inconsistentes');
        }
        
        if (checksSupplyAuthorizationSituation(filterRow, 'IDAFINCONS')) {
            return ScreenService.i18n('AFs Inconsistentes');
        }
        
        return ScreenService.i18n('AFs Fora do Limite');
    }
    
    this.setStripe = function(widget){
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const stripeRow = widget.container.getWidget('stripe').currentRow;
        const widgetGridPrincipal = templateManager.container.getWidget('cmp04200_grid');
        
        stripeRow.SITUACAO = getSituationLabel(filterRow);
        stripeRow.UNIDEST = `Unidade Destino: ${filterRow.NMFILIAL}`;
        stripeRow.COMPRADOR = `Comprador: ${filterRow.NMCOMPRADOR}`;
        stripeRow.GERENTE = `Gerente: ${filterRow.NMGERENTE}`;
        stripeRow.DATA = `Período de entrega: ${filterRow.PERIODO.start} a ${filterRow.PERIODO.end}`;
        
        widgetGridPrincipal.reload();
        widgetGridPrincipal.activate();
    };
    
    this.gridOnEnterOnce = function(widget) {
        const filterRow = {
            CDFILDEST: getLocalVar('CDFILIAL'),
            SITUACAOAF: [ "IDAFINCONS", "IDAFFORALIM" ],
            PERIODO: {
                start: moment().format('L'),
                end: moment().format('L'),
                formattedStart: moment().format('L'),
                formattedEnd: moment().format('L'),
            },
        };
        
        Utilities.startFilter(widget, filterRow);
    };
    
    /**************
     * Liberar AF *
     **************/

    this.liberarAutorizacaoFornecimento = function(widget) {
        const codigoGerente = widget.appliedFilter.FILTER_ROW.CDGERENTE;
        const adicionarGerenteNaRow = row => row.CDGERENTE = codigoGerente;
        const rows = widget.getCheckedRows();
        
        rows.forEach(adicionarGerenteNaRow);
        
        ScreenService.confirmMessage('Confirma a liberação da(s) AF(s) selecionada(s)?', 'question', function(success) {
            ServiceLiberacaoAF.verificaUtilizaWorkflow(rows[0]).then(function(response) {
                const utilizaWorkflow = response.dataset.data.IDUTLWORKFLOW == 'S';
                const processes = [
                    'emailLiberacao'
                ];
                
                if (utilizaWorkflow) {
                    processes.push('workflow');
                }
                
                registerProcesses(processes);
                
                ServiceLiberacaoAF.liberarAutorizacaoFornecimento(rows).then(function(response) {
                    if (utilizaWorkflow) {
                        const message = response.messages ? response.messages.shift().message : '';
                        
                        messageManager.notify('workflow', message);
                    }
                    
                    envioDeEmailParaResponsaveisPelaAf(widget);
                }).catch(showErrorMessage);
            }).catch(showErrorMessage);
        });
    };
    
    /**
     * Realiza uma chamada no backend para a função que dispara
     * emails para os responsáveis da AF  que está sendo liberada.
     *
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
     */
    //notifiesAfResponsibleAboutProductEditing (NOME ANTIGO)

    function envioDeEmailParaResponsaveisPelaAf(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const rows = widget.getCheckedRows();
        
        rows[0].COD_COMPRADOR = filterRow.CDCOMPRADOR;
        
        ServiceLiberacaoAF.enviarEmailAosResponsaveisPelaAF(rows).then(function(success) {
            messageManager.notify('emailLiberacao', 'Notificação de e-mail de liberação de AF enviada ao responśavel.');
        }, function(error) {
            messageManager.notify('emailLiberacao', 'Não foi possível enviar a notificação de e-mail de liberação de AF ao responsável.');
        });
        
        widget.reload();
    }
    
    /**********
     * Filter *
     **********/
    
    this.filtrar = function(args) {
        const widget = args.owner;
        
        if (!widget.SENHA_GERENTE) {
            args.e.preventDefault();
            MessageService.showMessageByCode("INVALID_PASSWORD");
        }
        
        const filterRow = args.e.preference.FILTER_ROW;
            
        if (typeof(filterRow) === 'object'){
            args.e.preference.CUSTOM_FILTER_ROW = {
                "CDFILDEST": filterRow.CDFILDEST,
                "CDCOMPRADOR": filterRow.CDCOMPRADOR,
                "CDGERENTE": filterRow.CDGERENTE,
                "DTINICIAL": filterRow.PERIODO.start,
                "DTFINAL": filterRow.PERIODO.end,
                "IDAFFORALIM": filterRow.SITUACAOAF.includes("IDAFFORALIM") === true ? "S" : "",
                "IDAFINCONS": filterRow.SITUACAOAF.includes("IDAFINCONS") === true ? "S" : "",
                "NRORG": getLocalVar("NRORG")
            };
        }
        
        return ServiceLiberacaoAF.considerarAFsTodosCompradoresNaValidacaoDoLimiteGerente(filterRow).then(function(callback) {
            if (callback.dataset.IDAFCOMPLIMGER[0] === "S") {
                widget.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/af_fora_limite_inconsistente_2";
            } else {
                widget.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/af_fora_limite_inconsistente";
            }
            
            widget.currentRow.CDGERENTE = filterRow.CDGERENTE;
            widget.reload();
        }, function(error) {
            showErrorMessage(error);
        });
    };
    
    /**************************
     * Filter - Manager Field *
     **************************/
    
    function filtraGerente(field) {
        field.dataSourceFilter = [
            {
                name: "CDOPERGERE",
                operator: "=",
                value: "T"
            },
            {
                name: "CDOPERCOMP",
                operator: "=",
                value: field.widget.currentRow.CDCOMPRADOR
            },
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar("NRORG")
            }
        ];
    }
    
    function cleanManagerData(widget) {
        const passwordFields = ['NMGERENTE', 'CDGERENTE'];
        const isPasswordField = field => passwordFields.includes(field.name);
        
        widget.fields.filter(isPasswordField).forEach(field => field.clearValue());
    }
    
    this.habilitaGerente = function(field) {
        const managerField = field.widget.getField("NMGERENTE");
        
        cleanManagerData(field.widget);
        
        managerField.readOnly = !field.value();
        
        filtraGerente(managerField);
    };
    
    /**************************
     * Manager Authentication *
     **************************/
    
    this.openManagerAuthenticationWidget = function(widget) {
        if (!Util.isEmptyOrBlank(widget.currentRow.NMGERENTE)) {
            const widgetAutenticar = widget.container.getWidget('widget_autenticar');
            const widgetGridPrincipal = widget.container.getWidget('cmp04200_grid');
            
            widgetAutenticar.currentRow.CDGERENTE = widget.currentRow.CDGERENTE;
            widgetAutenticar.currentRow.USER = widget.currentRow.NMGERENTE; 
            widgetAutenticar.currentRow.SENHA = "";
            
            ScreenService.openPopup(widgetAutenticar);
            
            widgetGridPrincipal.activate();    
        }
    };
    
    this.cancelarSenhaGerente = function(args, widget) {
        const widgetGridPrincipal = widget.container.getWidget('cmp04200_grid');
        
        widgetGridPrincipal.SENHA_GERENTE = false;
        ScreenService.closePopup();
        
        cleanManagerData(widgetGridPrincipal);
        
        widgetGridPrincipal.activate(); 
    };
    
    this.confirmarSenhaGerente = function(args) {
        const widget = args.owner.widget;
        
        if (widget.isValid()) {
            const widgetGridPrincipal = widget.container.getWidget('cmp04200_grid');
            
            ServiceLiberacaoAF.confirmaSenhaGerente(widget.currentRow).then(function() {
                widgetGridPrincipal.SENHA_GERENTE = true;
                ScreenService.closePopup();
            }, function(err) {
                widgetGridPrincipal.SENHA_GERENTE = false;
                ScreenService.showMessage(err.data.error);
            });
        }    
    };
    
    /*******************
     * Message Manager *
     *******************/
    
    const messageManager = {
        processes: [],
        subscribe: function(processName) {
            this.processes.push({
                name: processName,
                hasNotified: false,
                messages: [],
            });
        },
        unsubscribe: function(processName) {
            this.processes = this.processes.filter(process => process.name != processName);
        },
        unsubscribeAll: function() {
            this.processes = [];
        },
        notify: function(processName, message) {
            const process = this.processes.filter(process => process.name == processName).shift();
            
            process.hasNotified = true;
            
            if (message) {
                process.messages.push(message);
            }
            
            if (this.processes.every(process => process.hasNotified)) {
                this.showMessages();
                this.unsubscribeAll();
            }
        },
        showMessages: function() {
            const messages = this.processes.filter(process => !Util.isEmptyOrBlank(process.messages)).map(process => process.messages.join(' '));
            const separator = messages.length > 1 ? '<br><br>' : '';
            const message = messages.join(separator);
            
            ScreenService.showMessage(message);
        }
    };
    
    function registerProcesses(processes) {
        processes.forEach(processName => {
            messageManager.subscribe(processName);
        });
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04200_liberacao_af_inconsistente_fora_do_limiteController', Cmp04200_liberacao_af_inconsistente_fora_do_limiteController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/cmp06500_log_de_autorizacao_de_fornecimento_Controller.js
/*  Para essa tela, utilizei:
    cmp06500_log_de_autorizacao_de_fornecimento_Controller.js
    cmp06500_log_de_autorizacao_de_fornecimento.json
    Cmp06500LogDeAutorizacaoDeFornecimento.php
    routes.json de solicitacao/modules/relatorios/config
    controllers.xml (mesma pasta do routes.json)
*/

function cmp06500_log_de_autorizacao_de_fornecimento_Controller(ScreenService, General, Sup03000Service, localStorageEngine, Parametros, Sup03600PedidoColetaService, MessageService) {

    //cria variável para usar quando fizer referência a uma função do próprio js.
    var self = this;
    
    this.valoresDefault = function(widget) {
        widget.currentRow.FILIALDEST = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("FILIALDEST");
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.FILIALDEST = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.FILIALDEST[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.FILIALDEST;
    	               delete widget.currentRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.filial_filioper_regiao.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.FILIALDEST[0]) {
                                verificador++;
                            }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete widget.currentRow.FILIALDEST;
    	                   delete widget.currentRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.FILIALDEST = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
    };

    //função para permitir apenas inserção de números no campo
    this.onlyNumbers = function(field) {
    //se o caracter que acabou de ser digitado for "not a number", ele é instantaneamente apagado
		if(isNaN(parseInt(field.value().charAt(field.value().length - 1)))) {
			field.value(field.value().toString().slice(0, -1));
		}
	};
    
    //função chamada ao clicar em OK na tela
    this.criaRelatorio = function(widget) {
        //a variável reportName recebe o relatório que deverá ser gerado.
        var row = angular.copy(widget.currentRow);
        //widget.isValid diz respeito a todos os campos obrigatórios estarem preenchidos
        //se isso e as datas estiverem válidas, chama o controller do php
        if (widget.isValid()) {
            if(this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) {
            
            var reportName  = widget.currentRow.REPORT_NAME;
            
            if (!Util.isEmptyObject(row.FILIALDEST)) {
                row.FILIALDEST = row.FILIALDEST.join("_");
            } else {
                row.FILIALDEST = "T";
            }
            
            if (!Util.isEmptyObject(row.OPERADOR)) {
                row.OPERADOR = row.OPERADOR.join("_");
            } else {
                row.OPERADOR = "T";
            }
            
            if (widget.currentRow.NRAUTFOR === "") {
                row.NRAUTFOR = "T";
            }
            
            General.openReportPopup(widget, self.abreRelatorio, [widget, row, reportName]);  
            }
        }
    };
    this.preencheCaracterDireta = function(string){
        var pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    };
    
   
    this.changeRequired = function(field){
        if (field.widget.getField('NMPRODINI').value() || field.widget.getField('NMPRODFIN').value()){
            field.widget.getField('NMPRODINI').validations = { "required" : true };
            field.widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            field.widget.getField('NMPRODINI').validations = {};
            field.widget.getField('NMPRODFIN').validations = {};
        }
    };

    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    }; 
    
    this.abreRelatorio = function(widget, currentRow, reportName) {          
        if(!currentRow.CDPRODFIN) {
            currentRow.CDPRODINI = null;
            currentRow.CDPRODFIN = null;
            currentRow.TCDPRODUTO = 'T';
        }
        else {
            currentRow.CDPRODFIN = self.preencheCaracterDireta(currentRow.CDPRODFIN);
            currentRow.TCDPRODUTO = null;
        }
        currentRow.DTINI   = currentRow.INTERVAL_DT.start;
        currentRow.DTFIM   = currentRow.INTERVAL_DT.end;
        currentRow.DATAINIC   = currentRow.INTERVAL_DT.start;
        currentRow.DATAFINA   = currentRow.INTERVAL_DT.end;
   	    General.openReport('cmp_fornecimento_autorizacaoFornecimento#/cmp_fornecimento_autorizacaoFornecimento/cmp06500_relatorio', reportName, currentRow); 
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp06500_log_de_autorizacao_de_fornecimento_Controller', cmp06500_log_de_autorizacao_de_fornecimento_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller.js
var Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller = function(General, ScreenService, templateManager, Utilities, ZhFilterPreferences, MessageService) {

    var dayOfWeek = null;
    var self = this;

    this.openFilterAction = function() {
        var popupWidget = templateManager.container.getWidget('widget_filter_poupup');
        ScreenService.openPopup(popupWidget);
        popupWidget.newRow();
        if (popupWidget.inEditMode()) {
            popupWidget.newRow = function() {};
        }
    };
    
    this.onEnter = function(widget) {
        this.verificaProjectCorp(widget);
        ZhFilterPreferences.openFilterWidget(widget);
     
    };
    
    this.setCustomFilterRow = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.filterSolicitaGrid = function(args) {
        var widget = args.owner;
        if (widget.isValid()) {
            this.createGridFilter(args);
            this.setStripeValues(widget);
            ScreenService.closePopup();
            widget.activate();
        }
    };
    
    this.fieldDependente = function(field) {
        if (field.widget.getField('NMFILIAL').value() === "") {
            field.widget.getField('NRAUTOFORN').readOnly = true;
            field.widget.getField('T_NRAUTOFORN').readOnly = true;
            field.widget.getField('NRAUTOFORN').clearValue();
        } else {
            field.widget.getField('NRAUTOFORN').clearValue();
            field.widget.getField('NRAUTOFORN').readOnly = true;
            field.widget.getField('T_NRAUTOFORN').checked = true;
            field.widget.getField('T_NRAUTOFORN').value('T');
            field.widget.getField('T_NRAUTOFORN').readOnly = false;
        }

    };

    this.verificaPermissao = function(widget) {

        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/crud/permissao_operador', 'FilterData', [{
            'name': 'P_CDOPERADOR',
            'operator': '=',
            'value': getLocalVar('CDOPERADOR')
        }]).then(function(callback) {
            if (callback && callback.dataset && callback.dataset.permissao_operador) {
                var permissao = callback.dataset.permissao_operador;
                var permissaoEncerrar = false;
                var permissaoCancelar = false;
                
                if (permissao.length) {
                   if (permissao[0].IDAUTGRUPOP == 'CAAF') {
                       permissaoCancelar = true;
                       if (permissao[1].IDAUTGRUPOP) {
                            permissaoEncerrar = true;
                        }
                   }else if(permissao[0].IDAUTGRUPOP == 'ENAF'){
                       permissaoEncerrar = true;
                   }
                }
                
                widget.getAction('cancelar').isVisible = permissaoCancelar;
                widget.getAction('encerrar').isVisible = permissaoEncerrar;

            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
        
    };
    
    this.setStripeValues = function(widget){
        var dataAf;
        var dataEntrega;

        var widgetFiltro = widget.appliedFilter.FILTER_ROW;
        var widgetStripe = widget.container.getWidget('FILTER');
            
            if (!widgetFiltro.DATA_AF.start) {
                dataAf = ScreenService.i18n('Todas');
                widgetStripe.getField('AFFIM').isVisible = false;
                widgetStripe.getField('AFINI').label =  ScreenService.i18n('Data da AF: ') + dataAf;
            } else {
                widgetStripe.getField('AFFIM').isVisible = true;
                widgetStripe.getField('AFINI').label = ScreenService.i18n('Data Inicial AF: ') + widgetFiltro.DATA_AF.start;
                widgetStripe.getField('AFFIM').label = ScreenService.i18n('Data Final AF: ') + widgetFiltro.DATA_AF.end;
            }

            if (!widgetFiltro.DATA_ENT.start) {
                dataEntrega = ScreenService.i18n('Todas');
                widgetStripe.getField('ENTREGAFIM').isVisible = false;
                widgetStripe.getField('ENTREGAINI').label = ScreenService.i18n('Data de Entrega: ') + dataEntrega;
            } else {
                widgetStripe.getField('ENTREGAFIM').isVisible = true;
                widgetStripe.getField('ENTREGAINI').label = ScreenService.i18n('Data Inicial de Entrega: ') + widgetFiltro.DATA_ENT.start;
                widgetStripe.getField('ENTREGAFIM').label = ScreenService.i18n('Data Final de Entrega: ') + widgetFiltro.DATA_ENT.end;
            }
    };

    this.validaData = function(dataInicial, dataFinal) {

        if (moment(dataFinal, 'DD/MM/YYYY') < moment(dataInicial, 'DD/MM/YYYY')) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.concatenaUnidade = function(widget) {
        if (widget.appliedFilter.FILTER_ROW.CDFILDEST === '') {
            widget.appliedFilter.FILTER_ROW.UNIDADE = 'T';
            return widget.appliedFilter.FILTER_ROW.UNIDADE;
        } else {

            widget.appliedFilter.FILTER_ROW.UNIDADE = [widget.appliedFilter.FILTER_ROW.CDFILDEST].join('_');
            return widget.appliedFilter.FILTER_ROW.UNIDADE;
        }
    };

    this.concatenaNumeroAF = function(row) {
        if (!Array.isArray(row.NRAUTOFORN) || row.NRAUTOFORN === "" || row.NRAUTOFORN.length === 0) {
            row.AF = 'T';
            return row.AF;
        } else {
            row.AF = row.NRAUTOFORN.join('_');
            return row.AF;
        }
    };

    this.setValorAgrupamento = function(row) {
        if (row.NMAGRUPFILI === '') {
            row.AGRUPAMENTO = 'T';
            return row.AGRUPAMENTO;
        } else {
            row.AGRUPAMENTO = row.CDAGRUPFILI;
            return row.AGRUPAMENTO;
        }
    };

    this.setValorDataEntrega = function(row) {
        if ((!row.DATA_ENT) || (row.DATA_ENT.start === '')){
            row.DATAENT = 'T';
            return row.DATAENT;
        } else {
            row.DATAENT = '';
            return row.DATAENT;
        }
    };

    this.setValorDataAF = function(row) {
        if ((!row.DATA_AF) || (row.DATA_AF.start === '')) {
            row.DATAAF = 'T';
            return row.DATAAF;
        } else {
            row.DATAAF = '';
            return row.DATAAF;
        }
    };

    this.limpaField = function(field) {
        if(field.name === 'NMAGRUPFILI'){

            field.widget.getField('CDFILDEST').clearValue();
           // field.widget.getField('NMFILLANC').clearValue();
            field.widget.currentRow.CDFILDEST = '';
            //field.widget.currentRow.NMFILLANC = '';
        }
        if(field.name === 'CDFILDEST' || field.name === 'NMAGRUPFILI' || field.name === 'DATA_AF' || field.name === 'DATA_ENT'){

            field.widget.getField('NRAUTOFORN').clearValue();
            field.widget.currentRow.NRAUTOFORN = '';
            
        }
    };
    
    this.verificaProjectCorp = function(owner){
        // if(window.projectCorp){
        //     owner.getField("CDFILDEST").filterProperties.readOnly = false;
        // }
        // else{
        //     owner.getField("CDFILDEST").filterProperties.readOnly = true;
        // }
        owner.getField("CDFILDEST").filterProperties.readOnly = false;
    };
    this.validaProdutoFinal = function(row) { 
        var prod;
        if(row.CDPRODFIN === undefined || row.CDPRODFIN === "") {
            prod = "";
        } else {
            var aux = 'ZZZZZZZZZZ';
            var str = row.CDPRODFIN;
            prod = str + aux.substr(0, aux.length - str.length); 
        } 
        return prod;
    };
   
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }; 
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        
        var filterPopupCurrentRow = args.row;
        if(!(self.validaProduto(filterPopupCurrentRow.CDPRODINI, filterPopupCurrentRow.CDPRODFIN))){
            if(field.name == 'PRODINI'){
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.PRODINI = '';
            }else {
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.PRODFIN = '';
            }
        }
    };
    this.readOnlyProduto = function(widget) {
         if(!widget.currentRow.CDPRODINI && !widget.currentRow.CDPRODFIN) {
             widget.getField('PRODINI').validations = {};
             widget.getField('PRODFIN').validations = {};
        } else {
            widget.getField('PRODINI').validations = {"required": true};
            widget.getField('PRODFIN').validations = {"required": true};
        }
    };
  
    this.createFilialFilter = function(field) {
        var row = field.widget.currentRow;
        var widget = field.widget;
        var filial = field.widget.getField('CDFILDEST');
        var filtro = [
            {
                'name': 'P_CDOPERADOR',
                'operator': '=',
                'value': getLocalVar('CDOPERADOR')
            },
            {
                'name': 'P_CDGRUPFILI',
                'operator': '=',
                'value': row.CDAGRUPFILI
            },
            {
                "operator": "ORDER_BY",
                "name": [{
                    "name": "CDFILIAL",
                    "direction": "ASC"
                }]
            }
        ];
        filial.dataSourceFilter = filtro;
        if (!row.NMAGRUPFILI) {
            filial.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_unidade_sem_agrupamento";
        } else {
            
            filial.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_unidade_com_agrupamento";
        
        }
        filial.reload();
    };

    this.createNumeroFilter = function(field) {
        var row = field.widget.currentRow,
            dt_ent_start = (row.DATA_ENT) ? row.DATA_ENT.start : '',
            dt_ent_end = (row.DATA_ENT) ? row.DATA_ENT.end : '',
            dt_af_start = (row.DATA_AF) ? row.DATA_AF.start : '',
            dt_af_end = (row.DATA_AF) ? row.DATA_AF.end : '';
       
        var cdfildest = row.CDFILDEST ? Array.isArray(row.CDFILDEST) ? row.CDFILDEST.join('_') : 'T' : 'T';
        
        var filtro = [
        	{
                "operator": "ORDER_BY",
                "name": [{
                    "name": "NRAUTOFORN",
                    "direction": "ASC"
                }    
                ]
            },
        	{
                'name': 'P_CDFILDEST',
                'operator': '=',
                'value': cdfildest
            },
            {
                'name': 'P_CDSUBGRUFILI',
                'operator': '=',
                'value': self.setValorAgrupamento(row)
            },
            {
                'name': 'P_DTINIENTR',
                'operator': '=',
                'value': dt_ent_start
            },
            {
                'name': 'P_DTFINENTR',
                'operator': '=',
                'value': dt_ent_end
            },
            {
                'name': 'P_TDAENTREGA',
                'operator': '=',
                'value': self.setValorDataEntrega(row)
            },
            {
                'name': 'P_DTINIAUTOFORN',
                'operator': '=',
                'value': dt_af_start
            },
            {
                'name': 'P_DTFINAUTOFORN',
                'operator': '=',
                'value': dt_af_end
            },
            {
                'name': 'P_TDTAUTOFORN',
                'operator': '=',
                'value': self.setValorDataAF(row)
            },
            {
                'name': 'P_CDOPERADOR',
                'operator': '=',
                'value': 'OPERADOR_LOGADO'
            }
           
        ];
        
        field.dataSourceFilter = filtro;
        General.callRestEngine('cmp_fornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_numero', 'FilterData', filtro).then(function(callback) {
                var retorno = callback.dataset.cmp07200_alteracao_automatica_de_situacao_da_af_numero;
                if (!retorno.length) {
                    MessageService.showMessageByCode("SEM_AF_PARA_FILIAL_DEST");
                }

            }, function(err) {
                ScreenService.showMessage(err.data.error);
        });
        field.reload();
    };

    this.createGridFilter = function(args) {
        var widget = args.owner,
    	    filterCurrentRow = angular.copy(widget.appliedFilter.FILTER_ROW),
            cdfildest = filterCurrentRow.CDFILDEST ? Array.isArray(filterCurrentRow.CDFILDEST) ? filterCurrentRow.CDFILDEST.join('_') : 'T' : 'T',
            dt_ent_start = filterCurrentRow.DATA_ENT.start ? filterCurrentRow.DATA_ENT.start : null,
            dt_ent_end = filterCurrentRow.DATA_ENT.end ? filterCurrentRow.DATA_ENT.end : null,
            dt_af_start = filterCurrentRow.DATA_AF.start ? filterCurrentRow.DATA_AF.start : null,
            dt_af_end = filterCurrentRow.DATA_AF.end ? filterCurrentRow.DATA_AF.end : null;

            filterCurrentRow.UNIDADE = this.concatenaUnidade(widget);
            filterCurrentRow.AGRUPAMENTO = self.setValorAgrupamento(filterCurrentRow);
            
            args.e.preventDefault();
    
            
                var filter = [
                    {
                        'name': 'P_CDFILDEST',
                        'operator': '=',
                        'value': cdfildest
                    },
                    {
                        'name': 'P_DTINIENTR',
                        'operator': '=',
                        'value': dt_ent_start
                    },
                    {
                        'name': 'P_DTFINENTR',
                        'operator': '=',
                        'value': dt_ent_end
                    },
                    {
                        'name': 'P_TDTENTREGA',
                        'operator': '=',
                        'value': self.setValorDataEntrega(filterCurrentRow)
                    },
                    {
                        'name': 'P_NRAUTOFORN',
                        'operator': '=',
                        'value': self.concatenaNumeroAF(filterCurrentRow)
                    },
                    {
                        'name': 'P_DTFINAUTOFORN',
                        'operator': '=',
                        'value': dt_af_end
                    },
                    {
                        'name': 'P_DTINIAUTOFORN',
                        'operator': '=',
                        'value': dt_af_start
                    },
                    {
                        'name': 'P_TDTAUTOFORN',
                        'operator': '=',
                        'value': self.setValorDataAF(filterCurrentRow)
                    },
                    {
                        'name': 'P_CONSAFEXP',
                        'operator': '=',
                        'value': filterCurrentRow.AFEXPIRADA
                    },
    				{
    					"operator": "ORDER_BY",
    					"name": [
    						{
    							"name": "DTPROGENTAF",
    							"direction": "ASC"
    						}    
    					]
    				}
                ];
                
                
                if( !Util.isEmptyOrBlank(filterCurrentRow.PRODINI) && !Util.isEmptyOrBlank(filterCurrentRow.PRODFIN) ){
                    filter.push(
                        {
                            'name': 'P_CDPRODINI',
                            'operator': '=',
                            'value': filterCurrentRow.CDPRODINI
                        },
                        {
                            'name': 'P_CDPRODFIN',
                            'operator': '=',
                            'value': this.validaProdutoFinal(filterCurrentRow)
                        }
                    );
                }
                else
                {
                    filter.push(
                        {
                            'name': 'P_TPRODUTOS',
                            'operator': '=',
                            'value': 'T'
                        }
                    );
                }
                widget.dataSourceFilter = filter;
                widget.reload();
         

        
        
             
    };

    this.actionButtons = function(widget, idbaixaaf) {
    
        for (var i = 0; i < widget.getCheckedRows().length; i++) {
            widget.getCheckedRows()[i].IDBAIXAAF = idbaixaaf;
            widget.getCheckedRows()[i].DT = widget.getCheckedRows()[i].DTPROGENTAF.split(" ")[0];
        }
        var row = widget.getCheckedRows();

        if (idbaixaaf === 3) {
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/cmp07200_alteracao_automatica_de_situacao_da_af/baixar', 'DataSet', row).then(function() {
                widget.reload();
                widget.unSelectAll();
                MessageService.showMessageByCode("BAIXA_MANUAL_SUCCESS");

            }, function(err) {

                ScreenService.showMessage(err.data.error);
            });

        } else {
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/cmp07200_alteracao_automatica_de_situacao_da_af/cancelarEncerrar', 'DataSet', row).then(function() {
                widget.reload();

                if (idbaixaaf === 5) {
                    widget.unSelectAll();
                    MessageService.showMessageByCode("AF_CANCELADA_SUCCESS");
                } else {
                    widget.unSelectAll();
                    MessageService.showMessageByCode("AF_ENCERRADA_SUCCESS");
                }

            }, function(err) {

                ScreenService.showMessage(err.data.error);
            });

        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller', Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp07600_Alteracao_Aprovacao_Af_Controller.js
var Cmp07600_Alteracao_Aprovacao_Af_Controller = function(General, ScreenService, Utilities, templateManager, ZHPromise, Cmp03900_LancamentoAutorizacaoDeFornecimento_Service, ZhFilterPreferences, MessageService) {
    
    var self = this;
    
    let CDFILCENTCMP;
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    /**
     * Define o filtro padrão de filial no popup de filtro,
     * setando o código e o nome da filial logada no sistema
     * na currentRow do popup do filtro.
    */
    this.setFilterInitValues = function(){   
	    /*filterRow.DATA_AF = {};
        filterRow.DATA_AF.start = moment().format('DD/MM/YYYY');
        filterRow.DATA_AF.end = moment().format('DD/MM/YYYY');
        filterRow.DATA_ENTREGA = {};
        filterRow.DATA_ENTREGA.start = moment().format('DD/MM/YYYY');
        filterRow.DATA_ENTREGA.end = moment().format('DD/MM/YYYY');*/
        
        return {
            "CDFILDEST": getLocalVar("CDFILIAL"),
            "CDFILIAL": [getLocalVar('CDFILIAL')],
            "NMFILIAL": [getLocalVar("NMFILIAL")],
            "ITENS_AF": "S",
            "NMTPAF": "A"
        };
    };
    
    /**
     * Método executado no evento "WidgetOnEnterOnce"
     * da widget principal.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.widgetOnEnter = function(widget){
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/getCentralCompras', "Row", {}).then(function(res){
            let fieldUnidade = widget.getField("CDFILIAL");
            
            CDFILCENTCMP = res.dataset.res.CDFILCENTCMP;
            
        	Utilities.startFilter(widget, this.setFilterInitValues());
            
            //fieldUnidade.filterProperties.readOnly = CDFILCENTCMP != getLocalVar('CDFILIAL');
            
            if (fieldUnidade.filterProperties.readOnly) {
                delete fieldUnidade.filterProperties.validations;
                delete fieldUnidade.validations;
            } else {
                fieldUnidade.validations = {
                    "required": true
                };
            }
            
            this.getParamGeralIdsisdos(widget);
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.validaFiltro = function(widget){
        if(widget.PARAMGERAL.IDSISDOS == 3) {
            widget.getField('NMTPAF').dataSource.data = 
            [
                {
                    "NMTPAF": ScreenService.i18n("Automática"),
                    "CDTPAF": "A"
                }
            ];
        }
        else {
            widget.getField('NMTPAF').dataSource.data = 
            [
                {
                    "NMTPAF": ScreenService.i18n("Automática"),
                    "CDTPAF": "A"
                },
                {
                    "NMTPAF": ScreenService.i18n("Manual"),
                    "CDTPAF": "M"
                }

            ];
        }
    };
    
    /**
     * Seta alguns valores selecionados no filtro
     * na widget stripe.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF"), referente ao filtro
     * principal da tela.
    */
    this.setStripe= function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget('WDGT_STRIPE');
        var gridWidget = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var dtAfIni = filterPopupCurrentRow.DATA_AF ? filterPopupCurrentRow.DATA_AF.start : "";
        var dtAfFin = filterPopupCurrentRow.DATA_AF ? filterPopupCurrentRow.DATA_AF.end : "";
        var dtEntIni = filterPopupCurrentRow.DATA_ENTREGA ? filterPopupCurrentRow.DATA_ENTREGA.start : "";
        var dtEntFin = filterPopupCurrentRow.DATA_ENTREGA ? filterPopupCurrentRow.DATA_ENTREGA.end : "";
        
        var valuesToPutOnStripe = {
            NMFILIAL: filterPopupCurrentRow.NMFILIAL,
            DTAUTOFORN: this.returnRangeOnFilter(dtAfIni, dtAfFin, ScreenService.i18n(' até ')),
            DTPROGENTAF: this.returnRangeOnFilter(dtEntIni, dtEntFin, ScreenService.i18n(' até ')),
            RANGE_PRODUTOS: this.returnRangeOnFilter(filterPopupCurrentRow.NMPRODUTO_INICIAL, filterPopupCurrentRow.NMPRODUTO_FINAL, ScreenService.i18n(' até ')),
            NMTPAF: this.getAfTypeOnFilterPopupCurrentRow(owner),
            TPITEN: this.getSelectedItemTypeOnFilter(owner)
        };
        
        for (var field in valuesToPutOnStripe) {
            var currentField = stripeWidget.getField(field);
            this.concatValueToStripeFieldLabelAfterColon(currentField, valuesToPutOnStripe[field]);
        }
        
        owner._filterInfo = [
            { "label": ScreenService.i18n("Tipo da AF"),       "value" : filterPopupCurrentRow.CDTPAF },
            { "label": ScreenService.i18n("Agrupamento de Un"),"value": filterPopupCurrentRow.NMGRUPFILI },
            { "label": ScreenService.i18n("Data da AF"),       "value" : filterPopupCurrentRow.DATA_AF && filterPopupCurrentRow.DATA_AF.start && filterPopupCurrentRow.DATA_AF.end ? filterPopupCurrentRow.DATA_AF.start + ' / ' + filterPopupCurrentRow.DATA_AF.end : ''},
            { "label": ScreenService.i18n("Data de Entrega"),  "value" : filterPopupCurrentRow.DATA_ENTREGA && filterPopupCurrentRow.DATA_ENTREGA.start && filterPopupCurrentRow.DATA_ENTREGA.end ? filterPopupCurrentRow.DATA_ENTREGA.start + ' / ' + filterPopupCurrentRow.DATA_ENTREGA.end : ''},
            { "label": ScreenService.i18n("Produto Inicial"),  "value" : filterPopupCurrentRow.CDPRODUTO_INICIAL ? filterPopupCurrentRow.CDPRODUTO_INICIAL : "" },
            { "label": ScreenService.i18n("Produto Final"),    "value" : filterPopupCurrentRow.CDPRODUTO_FINAL   ? filterPopupCurrentRow.CDPRODUTO_FINAL   : "" },
            { "label": ScreenService.i18n("Itens AF"),         "value" : filterPopupCurrentRow.ITENS_AF == 'N'   ? 'Itens de AF Alterados' : "Todos os Itens de AF" },
            { "label": ScreenService.i18n("Comprador"),        "value" : concatArrayForParams(filterPopupCurrentRow.CDOPERADOR, 'Todos')},
            { "label": ScreenService.i18n("Fornecedor"),       "value" : concatArrayForParams(filterPopupCurrentRow.CDFORNECED, 'Todos')},
            { "label": ScreenService.i18n("Unidade Destino"),  "value" : owner.getField('CDFILIAL').readOnly ? getLocalVar('CDFILIAL') : concatArrayForParams(filterPopupCurrentRow.CDFILIAL, 'Todas')}
        ];
	    
    };
    
    this.filtrar = function (args){
	        
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;
        this.cleanEmptyAfFilterOnFilterPopup(args);
        if(widget.dataSourceFilter){
            widget.dataSourceFilter = [];    
        }
        this.setWidgetAfFilterBySelectedAfOnFilterPopup(args);
        //this.setComponentAfFilter(args, widget);
        
        self.transformaData(filterRow);
        
        if(typeof(filterRow) === 'object'){
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_IDSITUACAO" : filterRow.NMTPAF            ? filterRow.NMTPAF                     : 'A_M',
                "P_DTAFINI"    : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.start : null,
                "P_DTAFFIN"    : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.end : null,
                "P_DTENTINI"   : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.start : null,
                "P_DTENTFIN"   : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.end : null,
                "P_CDAGRUPFILI": filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI                        : "",
                "P_PRODINI"    : filterRow.CDPRODUTO_INICIAL ? filterRow.CDPRODUTO_INICIAL          : "",
                "P_PRODFIN"    : filterRow.CDPRODUTO_FINAL   ? filterRow.CDPRODUTO_FINAL            : "",
                "P_AUTOFORNE"  : concatArrayForParams(filterRow.NRAUTOFORN),
                "P_TITENS"     : filterRow.ITENS_AF          ? filterRow.ITENS_AF                   : "S",
                
                "P_TPROD"      : (!(filterRow.CDPRODUTO_INICIAL && filterRow.CDPRODUTO_FINAL)) ? "T": "",
                "P_TDTAF"      : filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? null : 'T',
                "P_TDTENT"     : filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? null : 'T',
                "P_COMPRADOR"  : concatArrayForParams(filterRow.CDOPERADOR),
                "P_FORNECEDOR" : concatArrayForParams(filterRow.CDFORNECED),
                "P_CDFILDEST"  : widget.getField('CDFILIAL').readOnly ? getLocalVar('CDFILIAL') : concatArrayForParams(filterRow.CDFILIAL) 
            };
        }
	    
    };
    
    self.transformaData = function(filterRow){
        if(!filterRow.DATA_AF){
            filterRow.DATA_AF = {'start': "", 'end': ""};
        }
        
        if(!filterRow.DATA_ENTREGA){
            filterRow.DATA_ENTREGA = {'start': "", 'end': ""};
        }
    };
    
    /**
     * Define o filtro do componente relacionado
     * a AF's de acordo com os outros valores 
     * inseridos no popup(filtro).
     * 
     * os filtros são montados com 4 
     * propriedades, ás comuns: name, operator, value,
     * e uma quarta propriedadade(defaultValue)
     * para quando o valor principal for nulo,
     * este valor assumirá o valor do filtro.
     * 
     * @param {object} component component que irá
     * receber os filtros.
     * 
     * @param {boolean} reloadComponent valor lógico indicando se 
     * o função deve ou não atualizar o componente em caso.
    */
    this.setComponentAfFilter = function(args, component, reloadComponent){
        
        var filterPopupCurrentRow = args.row;
        var cdforneced = filterPopupCurrentRow.CDFORNECED ? filterPopupCurrentRow.CDFORNECED : 'T';
        var cdoperador = filterPopupCurrentRow.CDOPERADOR ? filterPopupCurrentRow.CDOPERADOR : 'T';
        // var cdproduto_final = filterPopupCurrentRow.CDPRODUTO_FINAL ? filterPopupCurrentRow.CDPRODUTO_FINAL : "";
        
        var fieldsToFilterTheAfField = [
            {
                name: "P_FORNECEDOR",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(cdforneced)
            },
            {
                name: "P_COMPRADOR",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(cdoperador)
            },
            {
                name: "P_CDFILDEST",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDFILIAL)
            },
            {
                name: "P_IDSITUACAO",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.NMTPAF, 'A_M')
            },
            {
                name: "P_DTAFINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_AF.start, "")
            },
            {
                name: "P_DTAFFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_AF.end, "")
            },
            {
                name: "P_TDTAF",
                operator: "=",
                value: (filterPopupCurrentRow.DATA_AF) ? 'T': ""
            },
            {
                name: "P_DTENTINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_ENTREGA.start, "")
            },
            {
                name: "P_DTENTFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.DATA_ENTREGA.end, "")
            },
            {
                name: "P_TDTENT",
                operator: "=",
                value: (filterPopupCurrentRow.DATA_ENTREGA) ? 'T': ""
            },
            {
                name: "P_CDAGRUPFILI",
                operator: "=",
                value: ""
            },
            {
                name: "P_PRODINI",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDPRODUTO_INICIAL, "")
            },
            {
                name: "P_PRODFIN",
                operator: "=",
                value: this.conctArrayValuesWithUnderLine(filterPopupCurrentRow.CDPRODUTO_FINAL, "")
            },
            {
                name: "P_TPROD",
                operator: "=",
                value: (!(filterPopupCurrentRow.CDPRODUTO_INICIAL && filterPopupCurrentRow.CDPRODUTO_FINAL)) ? 'T': ""
            },
            {
                name: "P_AUTOFORNE",
                operator: "=",
                value: 'T'
            },
            {
                name: "P_TITENS",
                operator: "=",
                value: filterPopupCurrentRow.ITENS_AF ? filterPopupCurrentRow.ITENS_AF : "S"
            }
        ];
        
        fieldsToFilterTheAfField.forEach(function(filter){
            component.dataSourceFilter = this.setFilterOnComponent(component, filter);
        }.bind(this));
        
        if(Boolean(reloadComponent)){
            component.reload();
        }
        
        return component.dataSourceFilter;
        
    };
    
    /**
     * Define o filtro recebido como parâmetro
     * no componente também recebido como parâmetro,
     * caso um filtro com o mesmo nome seja 
     * encontrado no componente, a função apenas atualizará
     * o seu valor pelo valor do filtro recebido.
     * 
     * @param {object} component componente que receberá 
     * o filtro recebido.
     * 
     * @param {object} filter filtro que será inserido
     * no array(dataSourceFilter) da field recebida.
     * 
     * @return {object} array com os filtro configurados.
    */
    this.setFilterOnComponent = function(component, filter){
        
        var fieldFilter = component.dataSourceFilter;
        var receivedFilterIndex = this.getObjectPositionInArrayByName(fieldFilter, filter.name);
        
        if(!Util.isUndefined(receivedFilterIndex) && Boolean(receivedFilterIndex.toString())){
            fieldFilter[receivedFilterIndex].value = filter.value;
        } else {
            fieldFilter.push(filter);
        }
        
        return fieldFilter;
        
    };
    
    /**
     * Concatena os valores do array recebido como parâmetro
     * e em uma string, separando-os com underline('_').
     * 
     * @param {object} array array com os valores a serem
     * concatenados.
     * 
     * @return {string} string com os valores do array concatenado,
     * caso o parâmetro recebido não seja um array(typeod object)
     * a função retorna o mesmo valor recebido.
    */
    
    this.conctArrayValuesWithUnderLine = function(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    };
    
    /**
     * Procedimento para recuperar a posição
     * de um objeto dentro de um array.
     * 
     * @param {object} array array onde será feito
     * a varredura.
     * 
     * @param {object} objectName nome do objeto a ser
     * buscado.
    */
    this.getObjectPositionInArrayByName = function(array, objectName){
        
        var indexFieldObject;
      
        array.forEach(function(value, i){
            if(value.name === objectName){
                indexFieldObject = i;
            } 
        });
        
        return indexFieldObject;
        
    };
    
    /**
     * Limpa a propriedade 'dataSourceFilter' do componente
     * recebido como parâmetro.
     * 
     * @param {object} component componente que terá seu
     * dataSourceFilter limpo.
    */
    this.cleanComponentDataSourceFilter = function(component){
        
        if(component.dataSourceFilter){
            component.dataSourceFilter = [];    
        }
        
    };
    
    
    /**
     * Retorna o código do produto recebido concatenado com os caracteres 'Z'.
     * O método é necessário para filtrar um periodo de produto, permitindo que
     * a query retorne os filhos daquele produto.
     * 
     * @param {string} string refernete ao código do produto
    */ 
    this.concatProductCodeWithComplementString = function(productCode){
        
        var complementString = "ZZZZZZZZZZ";    
        
        if(productCode){
            return productCode + complementString;
        }
        
    };
    
    /**
     * Define um filtro na widget de AF's ("WDGT_ALTERACAO_APROVACAO_AF")
     * para exibir apenas as AF's selecionadas no popup de filtro.
     * Caso nenhuma AF tenha sido selecionada no popup de filtro
     * nenhum filtro é adicionado a widget.
     * 
     * @param {object} widget widget de AF's
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.setWidgetAfFilterBySelectedAfOnFilterPopup = function(args){
        
        var filterPopupCurrentRow = args.e.preference.FILTER_ROW;
        var valuesToFilterWidget = ["CDFILDEST", "CDFILLANC", "NRAUTOFORN"];
        
        if(Boolean(filterPopupCurrentRow.CDFILLANC) && typeof filterPopupCurrentRow.CDFILLANC === "object" && filterPopupCurrentRow.CDFILLANC.length > 0){
            
            valuesToFilterWidget.forEach(function(valueToFilter){
                
                var filter = {name: valueToFilter, operator: "IN", value: filterPopupCurrentRow[valueToFilter]};
                args.owner.dataSourceFilter = this.setFilterOnComponent(args.owner, filter); 
                
            }.bind(this));
            
        } else {
            this.cleanEmptyAfFilterOnFilterPopup(args);
        }
        
    };
    
    /**
     * Limpa o filtro da widget recebida como parâmetro
     * relacionado a AF.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.cleanEmptyAfFilterOnFilterPopup = function(args){
        
        var widgetFilter = args.owner.dataSourceFilter;
        var filterPopupCurrentRow = args.e.preference.FILTER_ROW;
        var cdfillanc = filterPopupCurrentRow.CDFILLANC ? filterPopupCurrentRow.CDFILLANC : "";
        
        if(Boolean(cdfillanc)){
            
            var afValueOnFilter = filterPopupCurrentRow.CDFILLANC;
            
            if((typeof afValueOnFilter === 'object' && afValueOnFilter.length === 0) || !afValueOnFilter){
                
                delete filterPopupCurrentRow.CDFILLANC;
                
                widgetFilter.forEach(function(filter, index){
                    
                    if(filter.name === "CDFILLANC"){
                        owner.dataSourceFilter.splice(index, 0);
                    }    
                    
                });
                
            }    
            
        }
        
    };
    
    /**
     * Retorna a data recebida como parâmetro em um objecto
     * moment.
     * 
     * @param {string} date data que será retornada.
     * 
     * @param {format} format formato da data recebida e
     * que será retornada.
     * 
     * @return {object} objeto moment com a data recebida.
    */
    this.changeDateToMomentObject = function(date, format){
        return moment(date, format);
    };
    
    /**
     * Busca os parâmetros gerais do sistema.
     * 
     * @param {object} widget widget principal
     * da tela, ("WDGT_ALTERACAO_APROVACAO_AF")
     * que irá receber os parâmetros buscados.
    */
    this.getParamGeralIdsisdos = function(widget){
        
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/getSystemParamGeral', "Row", widget.currentRow).then(function(response){
            widget.PARAMGERAL = response.dataset.PARAMGERAL[0];
            this.validaFiltro(widget);
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    
    /**
     * Retorna os tipos de af selecionados no popup do filtro.
     * 
     * @return {string} tipo de AF selecionado no filtro.
    */
    this.getAfTypeOnFilterPopupCurrentRow = function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var selectedAfTypes = filterPopupCurrentRow.NMTPAF;
            
        if(selectedAfTypes === 'A'){
            return ScreenService.i18n("Automática");
        }else  if(selectedAfTypes === 'M'){
            return ScreenService.i18n("Manual");
        }
        
    };
    
    /**
     * concatena um valor na propriedade 'label' do campo recebido como parâmetro
     * (presente em uma widget stripe) após encontrado dois pontos(':') na mesma label.
     * 
     * @param {object} stripeField field que terá sua label modificada.
     * 
     * @param {string} valueToConcat valor que será concatenado na label do campo recebido
     * como parâmetro.
     * 
    */
    this.concatValueToStripeFieldLabelAfterColon = function(stripeField, valueToConcat){
        
        var fieldLabel = stripeField.label;
        var colonIndex = fieldLabel.indexOf(':');
        var defaultFieldValue = fieldLabel.substr(0, colonIndex + 2);
        
        if(valueToConcat){
            stripeField.label = defaultFieldValue + (Array.isArray(valueToConcat) ? valueToConcat.join(', ') : valueToConcat);
        } else {
            stripeField.label = defaultFieldValue;
        }
        
    };
    
    /**
     * Define dois campos relacionados como obrigatório caso um esteja preenchido
     * na currentRow da widget recebida como parâmetro.
     * 
     * @param {object} widget widget onde estão localizados os campos recebidos
     * como parâmetro.
     * 
     * @param {object} field primeiro campo da relação.
     * 
     * @param {obbject} referenceField segundo campo da relação.
    */
    this.setRelatedFieldsAsRequired = function(widget, field, referenceField){
        
        var currentRow = widget.currentRow;
        
        if(Boolean(currentRow[field.name]) || Boolean(currentRow[referenceField.name])){
            
            this.setFieldRequireValidation(field, true);
            this.setFieldRequireValidation(referenceField, true);
            
        } else {
            
            this.setFieldRequireValidation(field, false);
            this.setFieldRequireValidation(referenceField, false);
            
        }
        
    };
    
    /**
     * Retorna o tipo de itens selecionado no
     * filtro, referente ao código dos mesmos
     * definidos no pŕoprio JSON do campo.
     * 
     * @return {string} nome referente ao tipo 
     * selecionado.
    */
    this.getSelectedItemTypeOnFilter = function(owner){
        
        var filterPopupCurrentRow = owner.appliedFilter.FILTER_ROW;
        var selectedItemType = filterPopupCurrentRow.ITENS_AF;
        
        if(selectedItemType === 'S'){
            return ScreenService.i18n("Todos os Itens da AF");
        } else if(selectedItemType === 'N'){
            return ScreenService.i18n("Itens da AF Alterados");
        }
        
    };
    
    /**
     * Retorna dois valores referentes a um intervalor
     * presente no filtro.
     * 
     * @param {string} valueIni valor do campo referente ao inicio
     * do intervalo.
     * 
     * @param {string} valueEnd valor do campo referente ao final do
     * intervalo.
     * 
     * @param {string} separator string que irá ser concatenada entre os dois valores.
     * 
     * @return {string} valores concatenados com o separador.
    */
    this.returnRangeOnFilter = function(valueIni, valueEnd, separator){
        
        if(valueIni && valueEnd) {
            return valueIni + separator + valueEnd;
        } else {
            return "";
        }
        
    };
    
    /**
     * Define se um campo será obrigatório pelo valor
     * lógico(isRequired) recebido como parâmetro.
     * 
     * @param {object} field campo que terá sua validação definida.
     * 
     * @param {boolean} isRequired valor lógico indicando se o campo
     * será obrigatório ou não.
    */
    this.setFieldRequireValidation = function(field, isRequired){
        
        if(isRequired){
            field.validations.required = true;
        } else {
            delete field.validations.required;
        }
        
    };
    
    this.backGridPrincipal = function(widget) {
        if (this.isGrSystem()) {
            const widgetProdutos = widget.container.getWidget("WDGT_PRODUTOS_AF");
            this.notifiesAfResponsibleAboutProductEditing(widgetProdutos);
        }
        
        General.widgetGoBackToList(widget);
        widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').activate();
    };
    
    this.backGridProdutos = function(widget){
        General.widgetGoBackToList(widget);
        widget.activate();
    };
    
    /**
     * Função para definir o filtro dos campos referente ao
     * renge de produto presentes no popup do filtro.
     * Se um campo estiver preenchido, o outro campo, referente,
     * e filtrado.
     * 
     * O código do produto final deve ser obrigatoriamente menor
     * do que o código do produto inicial.
    */
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        
        var filterPopupCurrentRow = args.row;
        if(!(self.validaProduto(filterPopupCurrentRow.CDARVPROD_INICIAL, filterPopupCurrentRow.CDARVPROD_FINAL))){
            if(field.name == 'NMPRODUTO_INICIAL'){
                filterPopupCurrentRow.CDPRODUTO_INICIAL = '';
                filterPopupCurrentRow.NMPRODUTO_INICIAL = '';
            }else{
                filterPopupCurrentRow.CDPRODUTO_FINAL = '';
                filterPopupCurrentRow.NMPRODUTO_FINAL = '';
            }
        }
        // var iniProductField = widget.getField("NMPRODUTO_INICIAL");
        // var endProductField = widget.getField("NMPRODUTO_FINAL");
        
        // var filter, valueFilter;
        // if(Boolean(filterPopupCurrentRow.CDPRODUTO_INICIAL)){
            
        //     valueFilter = filterPopupCurrentRow.CDPRODUTO_INICIAL;
        //     filter = {name: "CDPRODUTO", operator: ">=", value: valueFilter};
        //     endProductField.dataSourceFilter = this.setFilterOnComponent(endProductField, filter);
            
        //     endProductField.reload();
            
        // } else {
        //     this.deleteComponentFilterByName(endProductField, "CDPRODUTO");
        //     endProductField.reload();
        // }
        // if(Boolean(filterPopupCurrentRow.CDPRODUTO_FINAL)){
            
        //     valueFilter = filterPopupCurrentRow.CDPRODUTO_FINAL;
        //     filter = {name: "CDPRODUTO", operator: "<=", value: valueFilter};
        //     iniProductField.dataSourceFilter = this.setFilterOnComponent(iniProductField, filter);
            
        //     iniProductField.reload();
            
        // }else {
        //     this.deleteComponentFilterByName(iniProductField, "CDPRODUTO");
        //     iniProductField.reload();
        // }
        
    };
    
    /**
     * Remove um objeto presente no array de filtros ('dataSourceFilter'),
     * do componente recebido como parâmetro, pelo nome recebido como parâmetro.
     * 
     * @param {object} component componente que terá seu filtro modificado.
     * 
     * @param {string} filterName nome do objeto a ser removido do componente.
    */
    this.deleteComponentFilterByName = function(component, filterName){
        
        var componentFilter = component.dataSourceFilter;
        
        componentFilter.forEach(function(filter, index){
           
           if(filter.name === filterName){
               component.dataSourceFilter.splice(index, 1);
           }
            
        });
        
    };
    
    /**
     * Limpa um valor na currentRow do popup do filtro pelo nome
     * recebido como parâmetro.
     * 
     * @param {string} valueName nome da propriedade que irá ser limpa
     * na currentRow do filtro.
    */
    /*
    this.cleanValueOnFilterPopupCurrentRowByName = function(valueName){
        
        var filterPopupCurrentRow = this.getFilterPopupCurrentRow();
        
        filterPopupCurrentRow[valueName] = "";
        
    };
    */
    
    /**
     * Executa os eventos definidos na função no evento
     * 'WidgetAfterMoveRow' da widget recebida como
     * parâmetro.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.productWidgetAfterMoveRow = function(widget){
        if (this.isGrSystem()) {
            const widgetProdutos = widget.container.getWidget("WDGT_PRODUTOS_AF");
            this.notifiesAfResponsibleAboutProductEditing(widgetProdutos);
        }
        
        this.getCurrentAfInfosAndSetOnWidget(widget);
        this.controlActionsProduct(widget);
    };
    
//=====================================================================================================================
// WIDGET AF PRODUCT'S
    
    /**
     * Define o filtro da widget de produtos da af
     * pela AF selecionada.
     * 
     * @param {object} widget widget de produtos de af
     * ("WDGT_PRODUTOS_AF");
     * 
     * @param {string} cdgrup parametro que verifica se produto pode aumentar preço.
     * 
     * @param {string} cdsubgrup parametro que verifica se produto pode aumentar preço.
    */
    this.setWidgetAfProductsFilter = function(widget, cdgrup, cdsubgrup){
        
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        
        var fieldsToFilterAfProductsWidget = [
            {
                name: "P_CDFILDEST",
                operator: "=",
                value: parentWidgetCurrentRow.CDFILDEST,
                defaultValue: ""
            },
            {
                name: "P_CDFILLANC",
                operator: "=",
                value: parentWidgetCurrentRow.CDFILLANC,
                defaultValue: ""
            },
            {
                name: "P_NRAUTOFORN",
                operator: "=",
                value: parentWidgetCurrentRow.NRAUTOFORN,
                defaultValue: ""
            },
            {
                name: "P_CDGRUPPROD",
                operator: "=",
                value: cdgrup,
                defaultValue: ""
            },
            {
                name: "P_CDSUBGRPROD",
                operator: "=",
                value: cdsubgrup,
                defaultValue: ""
            }
        ];
        
        fieldsToFilterAfProductsWidget.forEach(function(filter){
            widget.dataSourceFilter = fieldsToFilterAfProductsWidget;
        }.bind(this));
        
        widget.reload();
        
    };
    
    /**
     * Busca as informações necessárias sobre a AF selecionda,
     * Operador da unidade, Periodicidade, Integração e Central
     * de vendas. Com essas informações, chama o método que
     * monta o filtro para a tela de produtos.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.getCurrentAfInfosAndSetOnWidget = function(widget){
        
        var currentRow = widget.currentRow;
        currentRow.CDFILCENTCMP = widget.appliedFilter.FILTER_ROW.CDFILIAL.join('_');
        var widgetProdutosAf = widget.container.getWidget('WDGT_PRODUTOS_AF');
        
        this.setIdSisDosOnCurrentRow(widget);
        
        General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getCurrentAfInfos", "Row", currentRow).then(function(response){
            var afInfos = response.dataset.AF_INFOS[0];
            
            if (!afInfos.PERMISSIONS.length) {
                widgetProdutosAf.getAction("INCLUIR_PRODUTO").isVisible = false;
            }
            else {
                  widgetProdutosAf.getAction("INCLUIR_PRODUTO").isVisible = true;
            }
            
                var cdGrupProd = afInfos.PERMISSIONS.length ? afInfos.PERMISSIONS[0].CDGRUPPROD : false;
                var cdSubGrupProd = afInfos.PERMISSIONS.length ? afInfos.PERMISSIONS[0].CDSUBGRUPPROD : false;
                widget.PERMISSIONS = afInfos.PERMISSIONS;
                widget.OPERADORES_UNIDADE = afInfos.BRANCH_OPERATOR;
                widget.PERIODICIDADE = afInfos.FREQUENCY;
                widget.INTEGRACAO = Boolean(afInfos.INTEGRATION[0]) ? afInfos.INTEGRATION[0].CDFILDEST : "";
                widget.CENTRAL_VENDA = afInfos.TRADING_CENTER;
                
                this.setWidgetAfProductsFilter(widgetProdutosAf, cdGrupProd, cdSubGrupProd);
                this.setProductWidgetFooterInfos(widget);
            
        }.bind(this))
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    /**
     * Seta o parâmetro "IDSISDOS" na currentRow
     * da widget recebida como parâmetro.
     * 
     * @param {object} widget widget que receberá,
     * em sua currentRow, o parâmetro "IDSISDOS".
    */
    this.setIdSisDosOnCurrentRow = function(widget){
        
        var paramGeral = this.getGeralParam();
        
        widget.currentRow.IDSISDOS = paramGeral.IDSISDOS;
        
    };
    
    /**
     * Exibe no footer da widget de produtos, a situação/limite
     * e a periodicidade da AF selecionada.
     * 
     * @param {object} widget widget principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.setProductWidgetFooterInfos = function(widget){
        
        var productFooter = templateManager.container.getWidget("WDGT_STRIPE_FOOTER_PRODUTO");
        var productFooterFields = productFooter.fields;
        
        var situacaoLimiteFieldIndex = this.getObjectPositionInArrayByName(productFooterFields, "SITUACAO_LIMITE");
        var fieldSituacaoLimite = productFooterFields[situacaoLimiteFieldIndex];
        this.concatValueToStripeFieldLabelAfterColon(fieldSituacaoLimite, widget.currentRow.DSINCONSAF);
        //this.concatValueToStripeFieldLabelAfterColon(fieldSituacaoLimite,widget.container.getWidget('WDGT_PRODUTOS_AF').currentRow.DSINCONSITAF);
        var periodicidadeFieldIndex = this.getObjectPositionInArrayByName(productFooterFields, "PERIODICIDADE");
        var fieldPeriodicidade = productFooterFields[periodicidadeFieldIndex];
        this.concatValueToStripeFieldLabelAfterColon(fieldPeriodicidade, this.getAfFrequency(widget));
        
    };
    
    this.informaInconsistenciaItemAF = function() {
        
        let rowProduto = templateManager.container.getActiveWidget().currentRow;
        
        ScreenService.showMessage(rowProduto.DSINCONSITAF);
    };
    
    this.abreSituacao = function () {
        const widgetSituacao        = templateManager.container.getWidget('situacao');
        const alteracaoAprovacaoRow = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        
        widgetSituacao.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": alteracaoAprovacaoRow.CDFILLANC,   "operator": "="},
            {"name": "CDFILDEST",    "value": alteracaoAprovacaoRow.CDFILDEST,   "operator": "="},
            {"name": "NRAUTOFORN",   "value": alteracaoAprovacaoRow.NRAUTOFORN,  "operator": "="},
            {"name": "CDPRODUTO",    "value": null,                              "operator": "="},
            {"name": "CDMARCA",      "value": null,                              "operator": "="},
            {"name": "DTPROGENTAF",  "value": alteracaoAprovacaoRow.DTPROGENTAF, "operator": "="},
            {"name": "CDFILCENT",    "value": CDFILCENTCMP,       "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),              "operator": "="}
        ];
        ScreenService.openPopup(widgetSituacao);
    };
    
    this.backPopupSituacao = function () {
        const alteracaoAprovacaoWid = templateManager.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        const produtoWid            = templateManager.container.getWidget('WDGT_PRODUTOS_AF');
        
        ScreenService.closePopup();
    };
    
    /**
     * Retorna a periodicidade da AF selecionada.
     * 
     * @param {object} widget widget principal
     * da tela ("WDGT_ALTERACAO_APROVACAO_AF").
     * 
     * @return {string} periodicidade da AF
     * em caso.
    */
    this.getAfFrequency = function(widget){
        
        if(Boolean(widget.PERIODICIDADE) && this.isObject(widget.PERIODICIDADE) && widget.PERIODICIDADE.length > 0){
            return widget.PERIODICIDADE[0].CDPERIENTR + " " + widget.PERIODICIDADE[0].NMPERIENTR;
        } else {
            return "Livre";
        }
        
    };
    
   /*  this.controlaSituacaoAf = function(widget) {
        var produto = widget.container.getWidget('WDGT_PRODUTOS_AF');
        produto.dataSource.data.forEach(function(item) {
            if(!item.DSINCONSITAF) {
              produto.getAction('situacao').isVisible = false;
              produto.getAction('situacao').showAsAction = "";
              
            }
            else {
            produto.getAction('situacao').isVisible = true;
            produto.getAction('situacao').showAsAction = "grid_left";
            }
        });
        //produto.redraw();
        produto.activate();
    };*/
    
    /**
     * Retorna os parâmetros gerais
     * do sistema presente na widget
     * principal da tela
     * ("WDGT_ALTERACAO_APROVACAO_AF").
    */
    this.getGeralParam = function(){
        
        var mainWidge = templateManager.container.getWidget("WDGT_ALTERACAO_APROVACAO_AF");
        return mainWidge.PARAMGERAL;
        
    };
    
    /**
     * Retorna um valor lógico indicando
     * se o tipo do elemento recebido
     * como parâmetro é um objeto.
     * 
     * @param {*} element elemento a ser
     * inspecionado.
     * 
     * @return {boolean} valor lógico
     * indicando se o elemento recebido
     * é um objecto.
    */
    this.isObject = function(element){
        return typeof element === "object";  
    };
    
    /**
     * Abre um swipe para adicionar novos produtos,
     * 
     * @param {object} tabbedWidget widget de produtos.
    */
    this.addProduct = function(tabbedWidget){
        ScreenService.openSwipe(tabbedWidget).then(function(){
            tabbedWidget.currentWidget.newRow();
            tabbedWidget.currentWidget.activate();
        });
    };
    
    /**
     * Habilita o ambiente de edição
     * de um produto.
     * 
     * @param {object} widget widget de 
     * produtos.
    */
    this.editProduct = function(widget){
        
        General.widgetEdit(widget);    
        
        this.setProductDefaultValues(widget);
        this.setPermissionsJustificationFields(widget, true);
    };
    
    /**
     * Define os valores padrão para a edição de
     * um produto.
     * 
     * @param {object} widget widget de produtos.
    */
    this.setProductDefaultValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.__is_new = false;
        currentRow.TIPOJUSTI = "S";
        currentRow.DSJUSTITMAFRPV = "";
        currentRow.IDTIPOLANITM = "M";
        currentRow.CDOPERADORITMAF = getLocalVar("CDOPERADOR");
        
    };
    
    /**
     * Aplica as regras no campo data de entrega, são elas:
     * A data nova não pode ser maior que o campo “Entrega Original",
     * A data nova não pode ser menor que a data atual,
     * A data nova não pode ser diferente da data que retornar na procedure  CARREGA_PERIFORN.
     * Casa seja, a função limpa o campo "Data de Entrega".
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.validateDeliveryDate = function(widget){
        
        var currentRow = widget.currentRow;
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        var alterApprovWidgetCurrentRow = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        var message;
       
        if(Boolean(currentRow.DTNOVAENTRAF)){
            
            var deliveryDateWithMomentInstance       = this.changeDateToMomentObject(currentRow.DTNOVAENTRAF, "DD/MM/YYYY");
            var originDeliveryDateWithMomentInstance = this.changeDateToMomentObject(currentRow.DTPROGITMAF, "DD/MM/YYYY");
            var currentDateWithMomentInstance        = this.changeDateToMomentObject(this.getCurretDate(), "DD/MM/YYYY");
            
            currentRow.CDFORNECED = alterApprovWidgetCurrentRow.CDFORNECED;
            
            if(widget.name === 'WDGT_INSERT_PRODUTOS_AF'){
                
                var afDateWithMomentInstance = this.changeDateToMomentObject(alterApprovWidgetCurrentRow.DTAUTOFORN, "DD/MM/YYYY");
                currentRow.CDFILDEST = alterApprovWidgetCurrentRow.CDFILDEST;
                
                if(!this.checkParamAfForDeliveryDate(alterApprovWidgetCurrentRow.IDGERAFDTENT, widget, currentRow)){
                    
                    return false;
                    
                } else if (deliveryDateWithMomentInstance < afDateWithMomentInstance){
                    
                    message = "Operação bloqueada!<br/><br/>Data de entrega do produto deve ser maior que a Data da AF.";
                    this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                    
                    return false;
                    
                }
                
            } else if(deliveryDateWithMomentInstance > originDeliveryDateWithMomentInstance){
                
                message = "Operação bloqueada!<br/><br/>Data de entrega do produto deve ser menor que a Data de Entrega Original.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
                return false;
            }
        
            if (deliveryDateWithMomentInstance < currentDateWithMomentInstance){
                
                message = "Operação bloqueada!<br/><br/>Data de Entrega do Produto deve ser maior que a data atual.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
            } else {
                
                this.executeProcedureCarregaPeriforn(currentRow).then(function(response){
                    
                    response = this.changeDateToMomentObject(response, "DD/MM/YYYY");
                    
                    var responseWithBrazilianDateFormat = this.convertMomentInstanceToBrazilianDateFormat(response);
                    var deliveryDateWithBrazilianDateFormat = this.convertMomentInstanceToBrazilianDateFormat(deliveryDateWithMomentInstance);
                    
                    if(responseWithBrazilianDateFormat !== deliveryDateWithBrazilianDateFormat){
                        
                        message = "Operação bloqueada!<br/><br/>Fornecedor não atende a data de entrega informada devido à sua periodicidade.";
                        this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                        
                    } else {
                    
                        if(widget.name === 'WDGT_INSERT_PRODUTOS_AF'){
                            
                            this.checkBestPrice(widget);
                            
                        }
                    
                    }
                    
                }.bind(this));
                
            }
            
        }
        
    };
    
    /**
     * Retorna a data relacionada a instância "moment", recebida como parâmetro, no formato
     * brasileiro.
     * 
     * @param {object} dateAsMomentInstance instância moment que será convertida.
     * 
     * @return {string} instância moment convertida no formato de data brasileiro.
    */
    this.convertMomentInstanceToBrazilianDateFormat = function(dateAsMomentInstance){
        return dateAsMomentInstance.format("DD/MM/YYYY");  
    };
    
    /**
     * Limpa a propriedade "DTNOVAENTRAF" da currentRow recebida como parâmetro,
     * e logo em seguida exibe uma mensagem ao usuário.
     * 
     * @param {object} currentRow currentRow que terá a propriedade limpa.
     * 
     * @param {string} message menssagem que será exibida ao usuário logo após a
     * propriedade ser limpa.
    */
    this.cleanNewDateDeliveryFieldAndShowMessage = function(widget, message){
        const field = widget.getField('DTNOVAENTRAF');
        field.clearValue(field);
        ScreenService.showMessage(message);
    };

    /**
     * Retorna a data atual.
    */
    this.getCurretDate = function(){
        return moment().format("DD/MM/YYYY");
    };
    /**
     * Executa a procedure CARREGA_PERIFORN e retorna uma data
     * relacionada a periodicidade referente ao fornecedor da
     * AF em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.executeProcedureCarregaPeriforn = function(currentRow){
        
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/executeProcedureCarregaPeriforn", "Row", currentRow).then(function(response){
            
            return response.dataset.DATA.RETURNED_DATE;
            
        })
        .catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
        
    };
    
    /**
     * Retorna um valor lógico indicando se o campo "Data de Entrega"
     * está vazio e anteriormente estava preenchido.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS").
    */
    this.checkDeliveryDateOldValueAndApplyRule = function(widget){
        
        var backUpCurrentRow = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(Boolean(backUpCurrentRow.DTNOVAENTRAF) && !Boolean(currentRow.DTNOVAENTRAF)) {
            MessageService.showMessageByCode("OPR_BLOCK_DTA_ENTREGA");
            return false;
            
        } else {
            return true;
        }
        
    };
    
    /**
     * Retorna um valor lógico indicando se o campo "Qtde."
     * está vazio e anteriormente estava preenchido.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS").
    */
    this.checkAmountOldValueAndApplyRule = function(widget){
        
        var backUpCurrentRow = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(Boolean(backUpCurrentRow.QTNOVAPROGAF) && !Boolean(currentRow.QTNOVAPROGAF)) {
            MessageService.showMessageByCode("OPR_BLOCK_QTD_NEW");
            return false;
        } else {
            return true;
        }
        
    };
    
    /**
     * Verifica se a nova quantidade informada ("QTNOVAPROGAF") é maior que a 
     * quantidade de origem ("QTORIG"), case seja, a função limpa o campo e exibe
     * uma mensagem para o usuário.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.checkIfCurrentAmountIsBiggerOriginAmountAndApplyRule = function(widget){
        
        var currentRow = widget.currentRow;
        
        if(this.parseStringToFloat(currentRow.QTNOVAPROGAF) > this.parseStringToFloat(currentRow.QTORIG) && !currentRow.ALTERAQTDE){
            
            currentRow.QTNOVAPROGAF = "";
            MessageService.showMessageByCode("OPR_BLOCK_QTD_MENOR_QTDORI");
        } else {
            if(!this.verifyMaxValue(currentRow.QTNOVAPROGAF)){
                currentRow.QTNOVAPROGAF = "";
                MessageService.showMessageByCode("OPR_BLOCK_QTD_EXCEDENTE");
            } else {
                this.checkInputtedNewDeliveryDateAndNewAmountOnCurrentRow(widget);
            }
        }
    };
    
    /**
     * Recebe um valor numérico e veriica se o mesmo é maior que o permitido, caso seja,
     * bloqueia o procedimento
     * @param {string} string com um valor numérico
    */
    
    this.verifyMaxValue = function(value){
        var maxValue = '9999999.99';
        
        if(typeof(value) == 'string'){
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if(value && parseFloat(value) > parseFloat(maxValue)){
            return false;
        }
        return true;
    };
    
    /**
     * Trata o valor numerico dos campos verificando se os valores são maiores que o permitido, caso seja,
     * bloqueia o procedimento
     * @param {string} string com um valor numérico
    */
    
    this.verifyFieldMaxValuePreco = function (widget) {
        if(this.verifyMaxValue(widget.currentRow.VRPREUNIAF) == false){
            widget.currentRow.VRPREUNIAF = '';
            MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDENTE");
        }
    };
    
    this.verifyFieldMaxValueQtde = function (widget) {
        if(this.verifyMaxValue(widget.currentRow.QTNOVAPROGAF) == false){
            widget.currentRow.QTNOVAPROGAF = '';
            MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDENTE");
        }
    };
    
    /**
     * Recebe um valor numérico e veriica se o mesmo é string, caso seja,
     * retira os pontos e substitui as virgulas por pontos, convertendo para
     * float.
     * 
     * @param {string} string com um valor numérico
    */
    this.parseStringToFloat = function(value){
        
        var type = typeof value;
        
        if(type === "string"){
            value = parseFloat(value.replace('.', '').replace(',', '.'));
        }
        
        return value;
        
    };
    
    /**
     * Define se os campos relacionados a justificativa serão bloqueados
     * ou não.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF")
    */
    this.checkInputtedNewDeliveryDateAndNewAmountOnCurrentRow = function(widget){
        if(widget){
            if(this.checkNewValuesOnAfProduct(widget)){
                this.setPermissionsJustificationFields(widget, false);
            } else {
                this.setPermissionsJustificationFields(widget, true);
            }
        }
        
    };
    
    /**
     * Verifica se ouve alguma alteção no campo "Entrega"
     * e no campo "Qtd" na widget de produtos.
     * 
     * @param {object} object widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkNewValuesOnAfProduct = function(widget){
        
        var currentRow = this.setNullValuesToEmptyValuesOnObject(widget.currentRow, ["DTNOVAENTRAF", "QTNOVAPROGAF"]);
        var backUpCurrentRow = this.setNullValuesToEmptyValuesOnObject(widget.backupRow, ["DTNOVAENTRAF", "QTNOVAPROGAF"]);
        
        if(currentRow.DTNOVAENTRAF !== backUpCurrentRow.DTNOVAENTRAF || currentRow.QTNOVAPROGAF !== backUpCurrentRow.QTNOVAPROGAF){
            
            currentRow.EDITEDPRODUCT = true;
            return true;
            
            
        } else {
            
            currentRow.EDITEDPRODUCT = false;
            return false;
            
        }
        
    };
    
    /**
     * Verifica se no objeto recebida como parâmetro, existem os valores
     * do array, também recebido como parâmtro, como nulos.
     * 
     * @param {object} object objeto a ser verificado.
     * 
     * @param {object} arrayOfValues array com os valores a serem verificados.
    */
    this.setNullValuesToEmptyValuesOnObject = function(object, arrayOfValues){
        
        arrayOfValues.forEach(function(value){
            
            object[value] = typeof object[value] === 'number' ? object[value].toString() : object[value];
            
            if(!Boolean(object[value])){
                object[value] = "";
            }
            
        });
        
        return object;
        
    };
    
    /**
     * Define a propriedade "readOnly" da field recebida com
     * parâmetro.
     * 
     * @param {object} field field que teŕa sua propriedade
     * definida.
     * 
     * @param {boolean} isReadOnly valor lógico indicando se
     * o field será apenas leitura ou não.
    */
    this.setFieldReadOnlyProperty = function(field, isReadOnly){
        field.readOnly = isReadOnly;
    };
    
    /**
     * Define a propriedade "isVisible" da action recebida como
     * parâmetro.
     * 
     * @param {object} action action que teŕa sua propriedade
     * definida.
     * 
     * @param {boolean} isVisible valor lógico indicando se
     * a action será visivel ou não.
    */
    this.setActionVisibleProperty = function(action, isVisible){
        action.isVisible = isVisible;
    };
    
    /**
     * Define se os campos relacionados a justivicativa serão desbloqueados
     * ou não.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF"),
     * onde estão localizados os campos em questão.
    */
    this.setPermissionsJustificationFields = function(widget, isLocked){
        
        var currentRow = widget.currentRow;
        
        var justificationType = widget.getField("TIPOJUSTI");
        var justificationSelectField = widget.getField("DSJUSTITMAF");
        
        if(isLocked){
            
            this.setFieldRequireValidation(justificationSelectField, false);   
            this.setFieldReadOnlyProperty(justificationSelectField, true);
            this.setFieldReadOnlyProperty(justificationType, true);
            currentRow[justificationSelectField.name] = "";
            
        } else {
            
            this.setFieldRequireValidation(justificationSelectField, true);   
            this.setFieldReadOnlyProperty(justificationSelectField, false);
            this.setFieldReadOnlyProperty(justificationType, false);
            
        }
      
    };
    
    /**
     * Define o template do campo de justificativa através
     * do valor informado no campo tipo justificativa
     * ("TIPOJUSTI").
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.setJustificationFieldTemplate = function(widget){
        
        var currentRow = widget.currentRow;
        
        var justificationField = widget.getField("DSJUSTITMAF");
        
        if(currentRow.TIPOJUSTI === "S"){
            this.setFieldTemplate(justificationField, "field/select.html");
        } else {
            this.setFieldTemplate(justificationField, "field/text-edit.html");
            justificationField.maxlength = 100;
        }
        justificationField.reload();
        
        
    };
    
    /**
     * Define o templete da field recebido como parâmetro
     * para o template também recebido como parâmetro.
     * 
     * @param {object} field field que terá seu template
     * modificado.
     * 
     * @param {string} templateName nome do template que será
     * definido no field.
    */
    this.setFieldTemplate = function(field, templateName){
        
        field.template = templateName;
        templateManager.updateTemplate();
        
    };
    
    /**
     * Caso o sistema reconheça que o usuário logado
     * pertença ao cliente GR, o sistema verifica se
     * o parâmetro INTEGRACAO, presente na wiget principal
     * da tela, está vazio, caso esteja, o sistema não permite
     * o usuário realizar a rotina e exibe uma mensagem informando
     * o mesmo.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AG").
     * 
    */
    this.applyGRRulesToSaveByParentAfIntegration = function(widget){
        
        var parentWidget = widget.getParent();
        var zhPromise = ZHPromise.defer();
        if(this.isGrSystem()){
            
            if(!Boolean(parentWidget.INTEGRACAO)){
                return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getParamSupplier", "Row", parentWidget.currentRow).then(function(response){
                    let param = response.dataset.PARAM;
                    if (param.USR_INTEGRAMESAP === 'S') {
                        MessageService.showMessageByCode("OPR_BLOCK_AF_N_HABILITADA");
                        return false;
                    } else if ((param.IDPERALTAFCONF === 'N') && (param.IDSITUATENDIMENTOAF != 'X')) {
                        MessageService.showMessageByCode("OPR_BLOCK_AF_N_PODE_ALTERAR");
                        return false;
                    } else {
                        return true;
                    }
                });
                
            } else {
                zhPromise.resolve(true);
                return zhPromise.promise;
            }
            
        } else {
            zhPromise.resolve(true);
            return zhPromise.promise;
        }
        
    };
    
    /**
     * Verifica se o sistema está sendo usado pelo cliente GR e se
     * o usuário está alterando, simultaneamente, a nova data de entrega
     * e a quantidade.
     * Esta validação é feita da seguinte forma, quando os campos "entrega" ou "Qtde"
     * já está preenchido, indica que ainda não ocorreu aprovação do mesmo,
     * sendo assim, o sistema deve permitir que apenas um campo seja alterado por vez.
     * Ex.:
     * O usuário solicitou a alteração da quantidade do produto(campo Qtde) e salvou no campo,
     * logo ele não pode solicitar a alteração do campo entrega enquanto a quantidade não
     * tiver recebido um feedback.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF");
    */
    this.applyGRRulesToSaveByNewAmountAndNewDeliveryDate = function(widget){
        
        var currentRowBackup = widget.backupRow;
        var currentRow = widget.currentRow;
        
        if(this.isGrSystem()){
            
            if(
                (Boolean(currentRowBackup.DTNOVAENTRAF) && Boolean(currentRow.QTNOVAPROGAF)) || 
                (Boolean(currentRowBackup.QTNOVAPROGAF) && Boolean(currentRow.DTNOVAENTRAF)) ||
                (currentRowBackup.QTNOVAPROGAF !== this.removeValueCurrencyMask(currentRow.QTNOVAPROGAF)) && (currentRowBackup.DTNOVAENTRAF !== currentRow.DTNOVAENTRAF)
            )
            {
                
                ScreenService.showMessage("Operação bloqueada.<br/><br/>Não é permitido alterar data de entrega e quantidade simultaneamente.");
                return false;
                
            } else {
                return true;
            }
            
        } else {
            return true;
        }
       
    };
    
    /**
     * APlica as regras de negócio para salvar
     * uma edição referente ao produto em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.applyRulesToSaveEditing = function(widget){
        
        this.createBackupRowCopyOnWidget(widget);
        
        if(widget.isValid()){
            const situacaoWid = templateManager.container.getWidget('situacao');
            situacaoWid.dataSourceFilter = [
                {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,   "operator": "="},
                {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,   "operator": "="},
                {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,  "operator": "="},
                {"name": "CDPRODUTO",    "value": widget.currentRow.CDPRODUTO,   "operator": "="},
                {"name": "CDMARCA",      "value": widget.currentRow.CDMARCA,     "operator": "="},
                {"name": "DTPROGENTAF",  "value": widget.currentRow.DTPROGITMAF, "operator": "="},
                {"name": "CDFILCENT",    "value": CDFILCENTCMP,   "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),          "operator": "="}
            ];
            situacaoWid.reload().then(function(callback) {
                if(situacaoWid.dataSource.data.length > 0) {
                    ScreenService.openPopup(situacaoWid);
                    MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
                    widget.currentRow.__is_new = false;
                    situacaoWid.widgetAlterada = widget;
                } else {
                    self.applyGRRulesToSaveByParentAfIntegration(widget).then(function(response){
                        if(response){
                            
                            if(self.applyGRRulesToSaveByNewAmountAndNewDeliveryDate(widget)){
                                
                                if(self.checkDeliveryDateOldValueAndApplyRule(widget)){
                                    
                                    if(self.checkAmountOldValueAndApplyRule(widget)){
                                        
                                        self.applyGRRulesToChangeProductsDeliveryDates(widget).then(function(response){
                                            if(response){
                                                
                                                self.checkDeliveryDateChange(widget).then(function(){
                                                
                                                    self.saveProductEditing(widget);
                                                    
                                                });
                                                
                                            }    
                                            
                                        });
                                    }
                                }
                            }
                        }
                    });
                }
            });
           
        }
        
    };
    
    /**
     * Verifica se o sistema em uso pertence ao cliente "GR", e se o usuário
     * está inserindo uma nova data de entrega no produto de uma uma af, em que
     * já existem solicitações de novas quantidades, garantindo a regra de
     * alteração única por produto.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.applyGRRulesToChangeProductsDeliveryDates = function(widget){
        
        var currentRow = widget.currentRow;
        var backupRow = widget.backupRow;
        
        var zhPromise = ZHPromise.defer();
        
        if(this.isGrSystem() && backupRow.DTNOVAENTRAF !== currentRow.DTNOVAENTRAF){
            deleteleftAndRightActions(widget.currentRow);
            
            return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/getProductsWithNewDeliveryDate", "Row", widget.currentRow)
            .then(function(response){
                
                var products = response.dataset.PRODUCTS;
                if(products.length > 0){
                    MessageService.showMessageByCode("OPR_BLOCK_PROD_EXISTENTES");
                    return false;
                    
                } else {
                    return true;
                }
                
            }); 
            
        } else {
            
            zhPromise.resolve(true);
            return zhPromise.promise;
            
        }   
        
    };
    
    function deleteleftAndRightActions(row) {
        delete row.__leftActions;
        delete row.__rightActions;
    }
    
    /**
     * Cria uma cópia do backup da row selecionada
     * na widget recebida como parâmetro.
     * 
     * @param {object} widget widget que recebera a cópia.
    */
    this.createBackupRowCopyOnWidget = function(widget){
        widget.BACKUPROWCOPY = angular.copy(widget.backupRow);
    };
    
    /**
     * Verifica se o usuário deseja replica a data
     * de entrega, inserida no registro em caso, para
     * todos os outros produtos relacionados a AF em caso.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkDeliveryDateChange = function(widget){
        
        var zhPromise = ZHPromise.defer();
        var parentWidgetCurrentRow = widget.getParent().currentRow;
        delete widget.currentRow.__rightActions;
        delete widget.currentRow.__leftActions;
        
        if(widget.BACKUPROWCOPY.DTNOVAENTRAF !== widget.currentRow.DTNOVAENTRAF && parentWidgetCurrentRow.IDGERAFDTENT === 'S'){
            
            ScreenService.confirmMessage("Devido ao parâmetro do fornecedor 'Gerar AF por Data de Entrega' as datas de entregas dos demais itens serão alteradas. Deseja continuar?", 'question',
                
                function (success){
                    
                    General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/updateAllAfProductDeliveryDate", "Row", widget.currentRow).then(function(){
                        
                        zhPromise.resolve();
                        
                    });
                    
                }.bind(this),
                function(){
                    zhPromise.reject();
                    const field = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF').getField('DTNOVAENTRAF');
                    field.clearValue(field);
                }
                
            );
            
        } else {
            zhPromise.resolve();
        }
        
        return zhPromise.promise;
        
    };
    
    
    this.checkParamAfForDeliveryDate = function(idgerafdtent, widget, currentRow){
        
        if(idgerafdtent === 'S') {
                    
            var productsData = widget.container.getWidget('WDGT_PRODUTOS_AF').dataSource.data;
            var dtprogitmaf = productsData.length ? productsData[0].DTPROGITMAF : '';
            
            if(dtprogitmaf && dtprogitmaf !== currentRow.DTNOVAENTRAF) {
        
                var message = "Operação bloqueada!<br/><br/>Devido ao parâmetro do fornecedor 'Gerar AF por Data de Entrega' a data de entrega deve ser igual a dos demais produtos.";
                this.cleanNewDateDeliveryFieldAndShowMessage(widget, message);
                
                return false;
                
            } else {
                
                return true;
                
            }
                    
        } else {
            
            return true;
            
        }
        
    };

    
    /**
     * Salva a edição de um produto.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.saveProductEditing = function(widget) {
        if (widget.isValid()) {
            const rowToSave = this.setProductValuesToSaveOnRowToSave(widget);
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/itemautf_produto_marca/save", "Row", rowToSave).then(function() {
                General.widgetGoBackToList(widget);
                templateManager.container.getWidget('WDGT_PRODUTOS_AF').reload();
                this.checkIfProductEditingWiilBeNotificated(widget);
            }.bind(this));
            
            widget.reload();
        }
    };
    
    /**
     * Função resposável por salvar os novos produtos que estão sendo inseridos
     * na AF. Realiza uma serie de procedimentos que estão relacionados a 
     * inserção do item.
     * 
     * @param {widget} widget widget WDGT_INSERT_PRODUTOS_AF onde são informados
     * os dados do produto que será inserido.
    */
    this.saveNewProductAF = function(widget){
        
        if(widget.isValid()){
            if(this.verifyMaxValue(widget.currentRow.VRPREUNIAF) == false || this.verifyMaxValue(widget.currentRow.QTNOVAPROGAF) == false){
                MessageService.showMessageByCode("OPR_BLOCK_VLR_EXCEDE_MAX");
            }else{
                var mainWidget        = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
                var productWidget     = widget.container.getWidget('WDGT_PRODUTOS_AF');
                var currentRowProduct = widget.currentRow;
                var limitParam        = [];
                var inconsisParam     = [];
                var products          = '';
                
                currentRowProduct.CDFILCENT    = mainWidget.CENTRAL_VENDA;
                currentRowProduct.CDFILDEST    = mainWidget.currentRow.CDFILDEST;
                currentRowProduct.CDFILLANC    = mainWidget.currentRow.CDFILLANC;
                currentRowProduct.NRAUTOFORN   = mainWidget.currentRow.NRAUTOFORN;
                currentRowProduct.CDFORNECED   = mainWidget.currentRow.CDFORNECED;
                currentRowProduct.QTNOVAPROGAF = this.parseStringToFloat(currentRowProduct.QTNOVAPROGAF);
                currentRowProduct.QTPROGENTAF  = 0;
                currentRowProduct.VRPREUNIAF   = this.parseStringToFloat(currentRowProduct.VRPREUNIAF);
                currentRowProduct.DTPROGENTAF  = currentRowProduct.DTNOVAENTRAF;
                currentRowProduct.IDTIPOLANITM = 'M';
                currentRowProduct.NRORG        = getLocalVar('NRORG');
                
                widget.dataSource.data = [];
                
                widget.saveRow().then(function(){
                    const widProdInsert = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF');
                    const fieldDtEntrega = widProdInsert.getField('DTNOVAENTRAF');
                    
                    fieldDtEntrega.clearValue(fieldDtEntrega);
                    productWidget.reload();
                    this.closeSwipe(productWidget);
                    MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    
                    this.getInconsistencyAF(currentRowProduct).then(function(inconsistency){
                        
                        inconsistency.dataset.inconsistencia.forEach(function(inconsist){
                            if(inconsist.CDERRO[0] == "L")
                                limitParam.push(inconsist.CDERRO);
                            else if(inconsist.CDERRO[0] == "I")
                                inconsisParam.push(inconsist.CDERRO);
                        });
                        
                        this.updateInconsistencyAF([limitParam, inconsisParam, currentRowProduct]).then(function(){
                            
                        this.insertTaxes(currentRowProduct);
                            
                        }.bind(this));
                        
                    }.bind(this));
                    
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
            }
            
        }
        
    };
    
    /**
     * Função para removar mascarás de moedas do valor
     * recebido como parâmetro.
     * 
     * @param {String} valueWithCurrencyMask valor que 
     * será retornado sem máscara de moeda.
     * 
     * @return {String} valueWithoutSymbols valor
     * recebido como parâmetro sem máscara de moeda.
     * 
    */
    this.removeValueCurrencyMask = function(valueWithCurrencyMask){
        
        if(valueWithCurrencyMask){
            
            var valuesWithoutCurrencyMask = $.currency.unmaskString(valueWithCurrencyMask, {"thousands": "."});
            return valuesWithoutCurrencyMask;
            
        }else{
            return "";
        }
        
    };
    
    /**
     * Verifica se uma af será notificada sobre alterações realizadas
     * em seus produtos.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.checkIfProductEditingWiilBeNotificated = function(widget) {
        const currentRow = widget.currentRow;
        
        if (currentRow.EDITEDPRODUCT) {
            if (this.isGrSystem()) {
                this.defineAfToSendEmail(widget);
            } else {
                ScreenService.confirmMessage(ScreenService.i18n('Deseja enviar e-mail para o(s) operador(es) responsável pela AF?'), 'question',
                    function (success) {
                        this.defineAfToSendEmail(widget);
                        this.notifiesAfResponsibleAboutProductEditing(widget);
                    }.bind(this)
                );
            }
        }
    };
    
    /**
     * Verifica se o cliente
     * que está logado no sistema
     * é a GR.
    */
    this.isGrSystem = function(){
        
        var paramGeral = this.getGeralParam();
        
        if(parseInt(paramGeral.IDSISDOS, 10) === 3){
            return true;
        } else {
            return false;
        }
    };
    
    /**
     * Define uma af para ser notificada da 
     * modificação do produto.
     * 
     * @param {object} widget widget de produtos
     * ("WDGT_PRODUTOS_AF").
    */
    this.defineAfToSendEmail = function(widget) {
        const currentRow = widget.currentRow;
        
        if (!Boolean(widget.CHANGED_AFS) || widget.CHANGED_AFS.NRAUTOFORN !== currentRow.NRAUTOFORN) {
            let afInfos = {
                NRAUTOFORN: currentRow.NRAUTOFORN
            };
            
            afInfos = this.getAfBranchsAndSetOnObject(afInfos);
            
            widget.CHANGED_AFS = afInfos;    
        }
    };
    
    /**
     * Define os valores a serem salvo ,em uma edição de produto, e retorna-os como objeto.
     * 
     * @param {object} widget widget de produtos, onde está ocorrendo
     * a rotina de edição.
     * 
     * @param {object} objeto com as informações a serem salvas.
    */
    this.setProductValuesToSaveOnRowToSave = function(widget){
        
        var currentRow = widget.currentRow;
        var valuesToSave = [
            "__is_new",
            "QTNOVAPROGAF", 
            "DSJUSTITMAF", 
            "DTNOVAENTRAF", 
            "IDTIPOLANITM", 
            "CDOPERADORITMAF",
            "DSJUSTITMAFRPV",
            "CDFILDEST",
            "CDFILLANC",
            "NRAUTOFORN",
            "CDMARCA",
            "CDPRODUTO",
            "DTPROGENTAF"
        ];
        
        var rowToSave = {};
        valuesToSave.forEach(function(value){
            rowToSave[value.valueOf()] = currentRow[value];
        });
        
        rowToSave.QTNOVAPROGAF = this.removeValueCurrencyMask(rowToSave.QTNOVAPROGAF);
        
        return rowToSave;
        
    };
    
    /**
     * Realiza uma chamada no backend para a função que dispera
     * emails para os responsáveis da AF relacionada com o produto
     * em edição.
     * 
     * @param {object} widget widget de produtos ("WDGT_PRODUTOS_AF").
    */
    this.notifiesAfResponsibleAboutProductEditing = function(widget) {
        const currentRow = widget.currentRow;
        
        if (Boolean(widget.CHANGED_AFS) && Boolean(currentRow.EDITEDPRODUCT)) {
            let row = widget.CHANGED_AFS;
            row.FILIAL_LOGADA = getLocalVar("CDFILIAL");
            row.EMAIL_LOGADO = getLocalVar("EMAIL");
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/sendEmailToProductResponsibleOperators", "Row", row).then(function(){
                delete widget.CHANGED_AFS;
                delete currentRow.EDITEDPRODUCT;
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    /**
     * Seta no objeto, recebido como parâmetro, o código e
     * o nome das filiais, de lançamento e de destino, da af em caso.
     * 
     * @param {object} object objeto que será modificada.
     * 
     * @return {object} objeto a ser modificado;
    */
    this.getAfBranchsAndSetOnObject = function(object){
        const mainWidget = templateManager.container.getWidget("WDGT_ALTERACAO_APROVACAO_AF");
        
        object.CDFILLANC = mainWidget.currentRow.CDFILLANC;
        object.NMFILLANC = mainWidget.currentRow.NMFILLANC;
        
        object.CDFILDEST = mainWidget.currentRow.CDFILDEST;
        object.NMFILDEST = mainWidget.currentRow.NMFILDEST;
        
        return object;
    };
    
    /**
     * Controla o estado dos campos para inserção de um novo produto. Verifica
     * se o cliente é a GR ou o parametro IDCARPRECLAF, caso retorne 'S', o 
     * sistema verificará se existe o melhor preço, caso exista, os campos são
     * preenchidos e bloqueados. Caso não exista o melhor preço, o cliente não
     * seja a GR ou o parametro seja 'N', os campos são liberados para 
     * preenchimento do usuário.
     * 
     * @param {object} widget widget WDGT_INSERT_PRODUTOS_AF onde são preenchidos
     * os dados do produto inserido.
    */
    this.checkReadOnlyFieldsAddProduct = function(widget){
        var alteraprovWid = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var loadBestPrice = alteraprovWid.PERMISSIONS && alteraprovWid.PERMISSIONS.length ? alteraprovWid.PERMISSIONS[0].IDCARPRECLAF : null;
        
        if(loadBestPrice === 'S' || this.isGrSystem()){
            this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), true);
            this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), true);
            this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), true);
            this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), true);
            this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), true);
            this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), false);
            this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), false);
        } else {
            this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), false);
            this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
            this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
            this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
            this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), true);
            this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
            this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
        }
        
    };
    
    /**
     * Aplica filtro na pesquisa de produto, pegando valores da widget principal
     * e dos parâmetros da AF
     * 
     * @param {object} field field NMPRODUTO que receberá o filtro
    */
    this.applyDataSourceFilterProduct = function(field){
        
        var mainWidget = field.widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        
        var params = {
            'CDFILDEST': mainWidget.currentRow.CDFILDEST,
            'CDFORNECED': mainWidget.currentRow.CDFORNECED,
            'CDGRUPPROD': mainWidget.PERMISSIONS[0].CDGRUPPROD,
            'CDSUBGRUPPROD': mainWidget.PERMISSIONS[0].CDSUBGRUPPROD,
            'CDPRODUTO': ''
        };
        
        General.onClickDependentField(field, params);
        
    };
    
    /**
     * Função ativada ao alterar o campo produto da tela de inserção de produtos
     * 
     * @param {widget} widget widget WDGT_INSERT_PRODUTOS_AF
    */
    this.productFieldOnChangeAddProduct = function(widget){
        
        this.applyReadOnlyBrand(widget);
        this.checkBestPrice(widget);
        
    };
    
    /**
     * Verifica se o produto foi preenchido para liberar o preenchimento da marca,
     * pois são campos vinculados.
     * 
     * @param {object} widget widget WDGT_INSERT_PRODUTOS_AF
    */
    this.applyReadOnlyBrand = function(widget){
        
        var fieldBrand = widget.getField('NMMARCA');
        var fieldProduct = widget.getField('NMPRODUTO');
        var loadBestPrice = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').PERMISSIONS[0].IDCARPRECLAF;
        
        fieldBrand.setValue('');
        
        if(fieldProduct.value() && (loadBestPrice === 'N' || !this.isGrSystem())){
            this.setFieldReadOnlyProperty(fieldBrand, false);
            this.setFieldRequireValidation(fieldBrand, true);
        } else {
            this.setFieldReadOnlyProperty(fieldBrand, true);
            this.setFieldRequireValidation(fieldBrand, false);
        }
        
    };
    
    /**
     * 
     * Caso o sistema reconheça que o usuário logado
     * pertença ao cliente GR ou que o parametro IDCARPRECLAF seja igual 'S',
     * o mesmo irá verificar se a nova data e produto foram preenchidos e buscar
     * o melhor preço.
     * 
     * 
    */ 
    this.checkBestPrice = function(widget){
        
        var currentRow = widget.currentRow;
        var mainWidget = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF');
        var loadBestPrice = mainWidget.PERMISSIONS[0].IDCARPRECLAF;
        
        if(loadBestPrice === 'S' || this.isGrSystem()){
            
            if(currentRow.CDPRODUTO && currentRow.DTNOVAENTRAF){
                
                var params = [
                    { 'name': 'CDPRODUTO',      'operator': '=',    'value': currentRow.CDPRODUTO },
                    { 'name': 'CDCENTCMP',      'operator': '=',    'value': mainWidget.CENTRAL_VENDA },
                    { 'name': 'CDFORNECED',     'operator': '=',    'value': mainWidget.currentRow.CDFORNECED },
                    { 'name': 'CDFILDEST',      'operator': '=',    'value': mainWidget.currentRow.CDFILDEST },
                    { 'name': 'DTPROGENTAF',    'operator': '=',    'value': currentRow.DTNOVAENTRAF }
                ];
                
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/crud/retornaMelhorPreco', "FilterData", params).then(function(response){
                    var retornaMelhorPreco = response.dataset.retornaMelhorPreco;
                    
                    if(retornaMelhorPreco.length){
                        currentRow.VRPREUNIAF = retornaMelhorPreco[0].VRPRECUNIITM;
                        currentRow.CDMARCA = retornaMelhorPreco[0].CDMARCA;
                        currentRow.NMMARCA = retornaMelhorPreco[0].NMMARCA;
                        
                        this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
                        this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), true);
                        this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), true);
                        this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
                        this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
                        this.setFieldRequireValidation(widget.getField('NMMARCA'), false);
                        this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), false);
                    } else {
                        this.setFieldReadOnlyProperty(widget.getField('QTNOVAPROGAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('TIPOJUSTI'), false);
                        this.setFieldReadOnlyProperty(widget.getField('DSJUSTITMAF'), false);
                        this.setFieldReadOnlyProperty(widget.getField('NMMARCA'), false);
                        this.setFieldReadOnlyProperty(widget.getField('VRPREUNIAF'), false);
                        this.setFieldRequireValidation(widget.getField('NMMARCA'), true);
                        this.setFieldRequireValidation(widget.getField('VRPREUNIAF'), true);
                        this.setFieldRequireValidation(widget.getField('QTNOVAPROGAF'), true);
                        this.setFieldRequireValidation(widget.getField('DSJUSTITMAF'), true);
                    }
                    
                    currentRow.TIPOJUSTI = 'S';
                    widget.redraw();
                }.bind(this))
                .catch(function(error){
                    ScreenService.showMessage(error.data.error);
                });
                
            }
            
        }
    };
    
    /**
     * Retorna as insconsistencias da AF.
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.getInconsistencyAF = function(params) {
     
        params = [
            { 'name': 'NRAUTOFORN',     'operator': '=',    'value': params.NRAUTOFORN },
            { 'name': 'CDFILCENT',      'operator': '=',    'value': params.CDFILCENT },
            { 'name': 'CDFILDEST',      'operator': '=',    'value': params.CDFILDEST },
            { 'name': 'CDFILLANC',      'operator': '=',    'value': params.CDFILLANC },
            { 'name': 'CDPRODUTO',      'operator': '=',    'value': '' },
            { 'name': 'CDMARCA',        'operator': '=',    'value': '' },
            { 'name': 'DTPROGENTAF',    'operator': '=',    'value': '' }
        ];
        
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/inconsistencia", "FilterData", params);
        
    };
    
    /**
     * Atualiza a AF como inconsistente caso alguma inconsistencia seja 
     * encontrada
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.updateInconsistencyAF = function(params){
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/updateInconsistencyAF", "Row", params);
    };
    
    /**
     * Insere os impostos para a empresa relacionada a AF
     * 
     * @param {params} Array Array com os parametros necessários
    */
    this.insertTaxes = function(params){
        return General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/insertTaxes", "Row", params);
    };
    
    /**
     * Fecha o swipe e ativa a widget passada como parametro.
     * 
     * @param {widget} widget widget que será ativada após o swipe ser fechado
    */
    this.closeSwipe = function(widget){
        const widProdInsert = templateManager.container.getWidget('WDGT_INSERT_PRODUTOS_AF');
        const fieldDtEntrega = widProdInsert.getField('DTNOVAENTRAF');
        
        fieldDtEntrega.clearValue(fieldDtEntrega);
        ScreenService.closeSwipe();
        widget.activate();
    };
    
    /**
     * Função criada para contornar um erro no master detail do Zeedhi, que 
     * mesmo ativando a widget, as actions da widget anterior permanecem.
     * 
     * @param {widget} widget widget ativa no momento da chamada da função.
    */
    this.controlActionsProduct = function(widget){
        
        var isVisible = false;
        //const widAlteracaoRow = widget.container.getWidget('WDGT_ALTERACAO_APROVACAO_AF').currentRow;
        
        if(widget.name === 'WDGT_ALTERACAO_APROVACAO_AF'){
            
            widget = widget.container.getWidget('WDGT_PRODUTOS_AF');
            isVisible = true;
            
        }
        
        var actionIncluir = widget.getAction('INCLUIR_PRODUTO');
        var actionVoltar = widget.getAction('VOLTAR_LISTA');
        //var actionSituacao = widget.getAction('situacao');
        
        /*if(widAlteracaoRow.IDAFFORALIM == 'S' || widAlteracaoRow.IDSITUATUAAF){
            actionSituacao.isVisible = true;
            delete actionSituacao.condition;
        }else{
            actionSituacao.isVisible = false;
            actionSituacao.condition = 'row.DSINCONSITAF';
        }*/
        
        actionIncluir.isVisible = isVisible;
        actionVoltar.isVisible = isVisible;
    };
    
    self.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }; 
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07600_Alteracao_Aprovacao_Af_Controller', Cmp07600_Alteracao_Aprovacao_Af_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller.js
function Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller(General, ScreenService, templateManager, localStorageEngine, Utilities, MessageService) {
    
    var dayOfWeek = null;
    
    this.setWeekDay = function(field, widget){
    
         dayOfWeek = moment(field.value(), "DD/MM/YYYY").weekday();
    
        switch(dayOfWeek) {
            case 0:
                dayOfWeek = ScreenService.i18n('Domingo');
                break;
            case 1:
                dayOfWeek = ScreenService.i18n('Segunda-Feira');
                break;
            case 2:
                dayOfWeek = ScreenService.i18n('Terça-Feira');
                break;
            case 3:
                dayOfWeek = ScreenService.i18n('Quarta-Feira');
                break;
            case 4:
                dayOfWeek = ScreenService.i18n('Quinta-Feira');
                break;
            case 5:
                dayOfWeek = ScreenService.i18n('Sexta-Feira');
                break;
            case 6:
                dayOfWeek = ScreenService.i18n('Sábado');
                break;
            default:
                dayOfWeek = '';
        }
        
        if(field.name === 'DTINI'){
            widget.currentRow.SEMANAINI = dayOfWeek;
        }
        else if(field.name ==='DTFIN'){
            widget.currentRow.SEMANAFIM = dayOfWeek;
        }
       
    };
    
    this.setDefaultWeekDay = function(){
    
        dayOfWeek = moment().weekday();
    
        switch(dayOfWeek) {
            case 0:
                dayOfWeek = ScreenService.i18n('Domingo');
                break;
            case 1:
                dayOfWeek = ScreenService.i18n('Segunda-Feira');
                break;
            case 2:
                dayOfWeek = ScreenService.i18n('Terça-Feira');
                break;
            case 3:
                dayOfWeek = ScreenService.i18n('Quarta-Feira');
                break;
            case 4:
                dayOfWeek = ScreenService.i18n('Quinta-Feira');
                break;
            case 5:
                dayOfWeek = ScreenService.i18n('Sexta-Feira');
                break;
            case 6:
                dayOfWeek = ScreenService.i18n('Sábado');
                break;
            default:
                dayOfWeek = '';
        }
        
        return dayOfWeek;
    };
    
    this.createDsFilterOperador = function (field) {
        
			field.dataSourceFilter = [
				{
					'name' : 'CDFILIAL',
					'operator': '=',
					'value': 'FILIAL_LOGADA'
				},
				{
                    "operator": "ORDER_BY",
                    "name": [
                        {
                            "name": "CDOPERADOR",
                            "direction": "ASC"
                        }
                    ]
                }
			];
    };
    
    this.createDsFilter = function (field) {
        field.dataSourceFilter = [
			{
				'name' : 'P_CDFILDEST',
				'operator': '=',
				'value': getLocalVar('CDFILIAL')
			}
		];
		
		field.reload();
	};
	
    this.validaData = function(widget) {
        var dataInicial = widget.currentRow.DTINI ? moment(widget.currentRow.DTINI, 'DD/MM/YYYY')._d : null;
        var dataFinal = widget.currentRow.DTFIN ? moment(widget.currentRow.DTFIN, 'DD/MM/YYYY')._d : null;

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            widget.currentRow.DTFIN = widget.currentRow.DTINI;
         
            return false;
        }
            
        return true;
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    };
    
    this.readOnlyProduto = function(widget) {
        if(!widget.currentRow.CDPRODINI && !widget.currentRow.CDPRODFIN) {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        } else {
            widget.getField('NMPRODINI').validations = {"required": true};
            widget.getField('NMPRODFIN').validations = {"required": true};
        }
    };
    
    this.productControl = function(field, widget){
        if(!(this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN))){
            if(field.name == 'NMPRODINI'){
                widget.currentRow.CDPRODINI = '';
                widget.currentRow.NMPRODINI = '';
            }else{
                widget.currentRow.CDPRODFIN = '';
                widget.currentRow.NMPRODFIN = '';
            }
        }
    };
    
    this.onEnterFiltro = function(widget) {
        var filterRow = {};
        filterRow.DTINI = moment().format('L');
        filterRow.DTFIN = moment().format('L');
        widget.getField('DTINI').defaultValue = moment().format('L');
        widget.getField('DTFIN').defaultValue = moment().format('L');
        widget.applyDefaultValue();
        this.setWeekDay(widget.getField('DTINI'), widget);
        this.setWeekDay(widget.getField('DTFIN'), widget);
        filterRow.SEMANAINI = widget.currentRow.SEMANAINI;
        filterRow.SEMANAFIM = widget.currentRow.SEMANAFIM;
        Utilities.startFilter(widget, filterRow);
    };
    
    this.setCustomFilterRow = function(args){
        delete args.e.preference.FILTER_ROW.NMPRODFIN;
        delete args.e.preference.FILTER_ROW.SEMANAFIM;
        delete args.e.preference.FILTER_ROW.SEMANAINI;
    };
    
    this.limpaFieldUnidades = function(widget) {
        widget.currentRow.CDFILDEST = '';
    };
    
    this.filtrar = function(args){
        var row = args.e.preference.FILTER_ROW;
        if(args.owner.isValid() && this.validaData(args.owner)) {
            var CDGRUPFILI  = row.CDAGRUPFILI ? row.CDAGRUPFILI : null;
            var CDFILIAL    = row.CDFILDEST ? Array.isArray(row.CDFILDEST) && row.CDFILDEST.length > 0 ? row.CDFILDEST.join('_') : 'T' : 'T';
            var CDOPERADOR  = row.CDOPERADOR == undefined || row.CDOPERADOR.length === 0  ? 'T' : row.CDOPERADOR.join('_');
            var CDOPERAPROV = row.CDOPERAPROV == undefined || row.CDOPERAPROV.length === 0  ? 'T' : row.CDOPERAPROV.join('_');
            var NRAUTOFORN  = row.NRAUTOFORN == undefined || row.NRAUTOFORN.length === 0  ? 'T' : row.NRAUTOFORN.join('_');
            var CDPRODINI   = row.CDPRODINI ? row.CDPRODINI : '0';
            var CDPRODFIN   = row.CDPRODFIN ? preencheCaracterDireta(row.CDPRODFIN) : 'ZZZZZZZZZZ';
            
            args.owner.dataSourceFilter = [
                { "name": "P_CDAGRUPFILI", "operator": "=", "value": CDGRUPFILI },
                { "name": "L_CDFILDEST", "operator": "=", "value": CDFILIAL },
                { "name": "P_PRODINI",  "operator": "=", "value": CDPRODINI },
                { "name": "P_PRODFIN",  "operator": "=", "value": CDPRODFIN },
                { "name": "P_DTINI", "operator": "=", "value": row.DTINI },
                { "name": "P_DTFIN", "operator": "=", "value": row.DTFIN },
                { "name": "L_CDOPERADOR", "operator": "=", "value": CDOPERAPROV },
                { "name": "L_CDCOMPRADOR", "operator": "=", "value": CDOPERADOR },
                { "name": "L_AUTOFORNE", "operator": "=", "value": NRAUTOFORN }
            ];

            this.setStripeValues(args.owner);
            ScreenService.closePopup();
            args.owner.reload();

        }

    };
    
    this.concatenaAutoFornec = function(widget) {
        
        var data = widget.dataSource.data;
        var IDTIPOLANC;
        
        data.forEach(function(row){
            if(row.IDTIPOLANCAF == 'M') {
                IDTIPOLANC = "Manual";
            }
            else {
                IDTIPOLANC = "Automática";
            }
            var autofornec = row.NRAUTOFORN + ' / ' + row.CDFILLANC + ' -- ' + IDTIPOLANC + ' -- ' + 'Data: ' + moment(row.DTAUTOFORN,'DD/MM/YYYY').format("DD/MM/YYYY"); 
            row.NRAUTOFORN = autofornec;
        });  
    
        
    };
    
    this.setStripeValues = function (widget) {
		var stripe = templateManager.container.getWidget('stripe');
		stripe.currentRow.PERIODO	= widget.appliedFilter.FILTER_ROW.DTINI + " a " + widget.appliedFilter.FILTER_ROW.DTFIN;

	};
	
    function preencheCaracterDireta (string){
        var pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    }
    
    this.fechaSwipe = function(widget){
        ScreenService.closeSwipe();
        widget.activate();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller', Cmp07603_RelatorioAlteracaoAprovacaoAF_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Cmp09600_ConsultaEnvioAfFornecedor.js
function Cmp09600_ConsultaEnvioAfFornecedor(General, ScreenService, MessageService, localStorageEngine, ZhFilterPreferences, templateManager, Utilities) {
    
    this.getCentralCompras = function(owner) {
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP); 
            
            Utilities.startFilter(owner);
        }, function(error) {
			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
		});
    };
   
   this.limpaField = function(field, name) {
        if(field.name === 'NMGRUPFILI'){

            field.widget.getField(name).clearValue();
            field.widget.currentRow.NMFILDEST = '';
        }
   };
    
    this.setDsFilterApuracao = function(field) {
     
        let filterRow = field.widget.currentRow;
        
        let param = {
            "P_CDFILCENTCMP": getLocalVar("CDFILCENTCMP"),
            "P_IDCOINCDTAPU": filterRow.IDCOINCDTAPU,
            "P_DTAPURAAF_INI": filterRow.DTAPURAAF.start ? filterRow.DTAPURAAF.start : null,
            "P_DTAPURAAF_FIN": filterRow.DTAPURAAF.end ? filterRow.DTAPURAAF.end : null,
            "P_TDTAPURAAF": filterRow.DTAPURAAF.start && filterRow.DTAPURAAF.end ? null : 'T'
        };
        
        General.onClickDependentField(field, param);
        
    };
    
    this.openWidgetDetalhes = function(args) {
        var widget = args.owner.container.getWidget('WDGT_CONSULTA');
        ScreenService.openSwipe(widget);
        widget.activate();
        var row = widget.getParent().currentRow ;
        var cdfildest = args.owner.appliedFilter.FILTER_ROW.CDFILDEST.join('_');
         widget.dataSourceFilter = [
                {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
                {"name": "P_ENVIO",                 "value": row.NRSEQENVIOAFORN ,   "operator": "="},
                {"name": "P_NRAPURPREC",            "value": row.NRAPURPREC,         "operator": "="},
                {"name": "P_CDFORNECED",            "value": row.CDFORNECED,         "operator": "="},
                {"name": "P_CDFILDEST",             "value": cdfildest,              "operator": "="}
            
        ]; 
        widget.reload();
    };    
    this.openTabbed = function(args) {
        var widget = args.owner.container.getWidget('tabbedWidget');
        var widgetProduto = args.owner.container.getWidget('WDGT_PRODUTO');
        var widgetUsuario = args.owner.container.getWidget('WDGT_USUARIO');
        var currentRowConsulta = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var currentRowAf = widget.container.getWidget('WDGT_CONSULTA_AF').currentRow;
        ScreenService.openSwipe(widget);
        var row = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var filterProduct = [
            {"name": "P_CDFILDEST",             "value": row.CDFILDEST ,        "operator": "="},
            {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
            {"name": "P_NRAUTOFORN",            "value": row.NRAUTOFORN,         "operator": "="}
        ]; 
        var filterUser = [
            {"name": "P_CDFILDEST",             "value": currentRowConsulta.CDFILDEST ,         "operator": "="},
            {"name": "P_CDFILLANC",             "value": currentRowConsulta.CDFILLANC,          "operator": "="},
            {"name": "P_NRAUTOFORN",            "value": currentRowConsulta.NRAUTOFORN,         "operator": "="},
            {"name": "P_NRSEQENVIOAFORN",       "value": currentRowAf.NRSEQENVIOAFORN,    "operator": "="}
        ];
        widgetProduto.dataSourceFilter = angular.copy(filterProduct);
        widgetUsuario.dataSourceFilter = angular.copy(filterUser);
        widgetProduto.reload();
        widgetUsuario.reload();
        widget.activate();
    }; 
    this.createFilialFilter = function(fieldFilial){
        var fieldAgrupFili = fieldFilial.widget.getField('NMGRUPFILI');
        var widget = fieldFilial.widget;
        var row = {};
        row.CDOPERADOR = getLocalVar('CDOPERADOR');
        if(fieldAgrupFili.value()){
            row.CDGRUPFILI = widget.currentRow.CDGRUPFILI;
            row.FILTER_ALL_FILIAIS = null;
        } else {
            row.CDGRUPFILI = null;
            row.FILTER_ALL_FILIAIS = 'T';
        }
        
        fieldFilial.dataSourceFilter.forEach(function(filter){
            filter.value = row[filter.name];
        });
        fieldFilial.reload();
    };
    this.openFilter = function(widget){
        ZhFilterPreferences.openFilterWidget(widget).then(function(){
            var widgetFilter = templateManager.container.getActiveWidget();
            widgetFilter.newRow();
        });    
    };
    
    this.filtrar = function(args) {
  
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;

        widget.dataSourceFilter = [
            {"name": "P_CDFILCENTCMP",       "value": getLocalVar('CDFILCENTCMP'),                                                                     "operator": "="},
            {"name": "P_CDFILDEST",          "value": filterRow.CDFILDEST.join('_'),                                                                   "operator": "="},
            {"name": "P_CDFORNECED",         "value": filterRow.CDFORNECED && filterRow.CDFORNECED.length ? filterRow.CDFORNECED.join('_') : 'T',      "operator": "="},
            {"name": "P_CDOPERADOR",         "value": filterRow.CDOPERADOR && filterRow.CDOPERADOR.length ? filterRow.CDOPERADOR.join('_') : 'T',      "operator": "="},
            {"name": "P_CDCOMPRADOR",        "value": filterRow.CDCOMPRADOR && filterRow.CDCOMPRADOR.length ? filterRow.CDCOMPRADOR.join('_') : 'T',   "operator": "="},
            {"name": "P_NRAPURPRECO",        "value": filterRow.APURACAO && filterRow.APURACAO.length ? filterRow.APURACAO.join('_') : 'T',            "operator": "="},
            {"name": "P_SITUAF",             "value": filterRow.IDBAIXAAF.join('_'),                                                                   "operator": "="},
            {"name": "P_IDTCLASSENVAFOR",    "value": filterRow.CLASSENVAFOR.join('_'),                                                                "operator": "="},
            {"name": "P_DTAUTFINI",          "value": filterRow.DATA_AF.start ? filterRow.DATA_AF.start : null,                                        "operator": "="},
            {"name": "P_DTAUTFFIM",          "value": filterRow.DATA_AF.end ? filterRow.DATA_AF.end : null,                                            "operator": "="},
            {"name": "P_TDTAUTOFORN",        "value": filterRow.DATA_AF.start ? null : 'T',                                                            "operator": "="},
            {"name": "P_DTPROGINI",          "value": filterRow.DATA_ENTREGA.start ? filterRow.DATA_ENTREGA.start : null,                              "operator": "="},
            {"name": "P_DTPROGFIM",          "value": filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.end : null,                                  "operator": "="},
            {"name": "P_TDTPROGENTAF",       "value": filterRow.DATA_ENTREGA.start ? null : 'T',                                                       "operator": "="},
            {"name": "P_DTENVIOAF_INI",      "value": filterRow.DTENVIOAF.start ? filterRow.DTENVIOAF.start : null,                                    "operator": "="},
            {"name": "P_DTENVIOAF_FIN",      "value": filterRow.DTENVIOAF.end ? filterRow.DTENVIOAF.end : null,                                        "operator": "="},
            {"name": "P_TDTENVIOAF",         "value": filterRow.DTENVIOAF.start ? null : 'T',                                                          "operator": "="},
            {"name": "P_IDCOINCDTAPU",       "value": filterRow.IDCOINCDTAPU,                                                                          "operator": "="},
            {"name": "P_DTAPURAAF_INI",      "value": filterRow.DTAPURAAF.start ? filterRow.DTAPURAAF.start : null,                                    "operator": "="},
            {"name": "P_DTAPURAAF_FIN",      "value": filterRow.DTAPURAAF.end ? filterRow.DTAPURAAF.end : null,                                        "operator": "="},
            {"name": "P_TDTAPURAAF",         "value": filterRow.DTAPURAAF.start ? null : 'T',                                                          "operator": "="},
            {"name": "P_ENVIADO",            "value": filterRow.TIPO_ENVIO.indexOf('E') !== -1 ? 'S' : 'N',                                            "operator": "="},
            {"name": "P_RETORNADO",          "value": filterRow.TIPO_ENVIO.indexOf('R') !== -1 ? 'S' : 'N',                                            "operator": "="}
        ];
          
        widget.reload();
        
    };

    this.setDsFilterGridProduto = function (widget) {
        var row = widget.container.getWidget('WDGT_CONSULTA').currentRow ;
         widget.dataSourceFilter = [
                {"name": "P_CDFILDEST",             "value": row.CDFILDEST ,        "operator": "="},
                {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
                {"name": "P_NRAUTOFORN",            "value": row.NRAUTOFORN,         "operator": "="}
            
        ]; 
        widget.reload();
    };
    this.setDsFilterGridUsuario = function (widget) {
        var currentRowConsulta = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var currentRowAf = widget.container.getWidget('WDGT_CONSULTA_AF').currentRow;
         widget.dataSourceFilter = [
                {"name": "P_CDFILDEST",         "value": currentRowConsulta.CDFILDEST , "operator": "="},
                {"name": "P_CDFILLANC",         "value": currentRowConsulta.CDFILLANC,  "operator": "="},
                {"name": "P_NRAUTOFORN",        "value": currentRowConsulta.NRAUTOFORN, "operator": "="},
                {"name": "P_NRSEQENVIOAFORN",   "value": currentRowAf.NRSEQENVIOAFORN,  "operator": "="}
        ]; 
        widget.reload();
    };
    this.setVazio = function(args) {
         args.e.preference.CUSTOM_FILTER_ROW = {};
    };    
    this.setStripe = function(widget){
      
        var filterRow = widget.appliedFilter.FILTER_ROW;
        var stripeRow = widget.container.getWidget('WDGT_STRIPE').currentRow;
        
        stripeRow.AGRUPFILI    = filterRow.NMGRUPFILI ? filterRow.NMGRUPFILI : "Todos";
        stripeRow.DTAUTOFORN   = filterRow && filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.start + " a " + filterRow.DATA_AF.end : "Todas";
        stripeRow.OPERADOR     = filterRow.NMOPERADOR ? filterRow.NMOPERADOR : "Todos";
        stripeRow.NMFILDESTINO = filterRow.NMFILDEST ? filterRow.NMFILDEST : "Todas";
        stripeRow.DTPROGENTAF  = filterRow && filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.start + " a " + filterRow.DATA_ENTREGA.end : "Todas";
        stripeRow.COMPRADOR    = filterRow.NMCOMPRADOR ? filterRow.NMCOMPRADOR : "Todos";
        
        widget._filterInfo = [
            {"label": ScreenService.i18n("Agrupamento de Unidades"), "value": stripeRow.AGRUPFILI},
            {"label": ScreenService.i18n("Unidade de Destino"), "value": stripeRow.DTAUTOFORN},    
            {"label": ScreenService.i18n("Data AF"), "value": stripeRow.OPERADOR},                 
            {"label": ScreenService.i18n("Dt. Entrega"), "value": stripeRow.NMFILDESTINO},         
            {"label": ScreenService.i18n("Operador"), "value": stripeRow.DTPROGENTAF},             
            {"label": ScreenService.i18n("Comprador"), "value": stripeRow.COMPRADOR}               
        ];
    };
    this.cancelReport = function(widget){
        ScreenService.closePopup();
        widget.container.getWidget('WDGT_CONSULTA_AF').activate();
    };
    this.corStatus = function(element, row){
        element.css('color', '#37943a');
    };
    
    this.openReport = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()){
            var reportName = "CMP09600";
            
            General.openReportPopup(widget, this.abreRelatorio, [args, reportName]);
        }
    };
    
    this.abreRelatorio = function(args, reportName) {
        var row = angular.copy(args.row);
        var dataAf = !args.row.DATA_AF.start ? false : true;
        var dataEntrega = !args.row.DATA_ENTREGA.start ? false : true;
        
        row.__report_name = reportName;
        row.P_CDFILICENTCOMP = getLocalVar('CDFILCENTCMP');
        row.P_CDGRUPFILI = 'T';
        row.L_FILIAL = args.row.NMFILDEST.join('_');
        row.L_FORNECEDOR = args.row.CDFORNECED && args.row.CDFORNECED.length ? args.row.CDFORNECED.join('_') : 'T';
        row.L_COMPRADOR = args.row.NMCOMPRADOR && args.row.NMCOMPRADOR.length ? args.row.NMCOMPRADOR.join('_') : 'T';
        row.P_DTINICIALAF = dataAf ? args.row.DATA_AF.start : null;
        row.P_DTFINALAF = dataAf ? args.row.DATA_AF.end : null;
        row.P_TDTAF = dataAf ? null : 'T';
        row.P_DTENTREGAINI = dataEntrega ? args.row.DATA_ENTREGA.start : null;
        row.P_DTENTREGAFIN = dataEntrega ? args.row.DATA_ENTREGA.end : null;
        row.P_TDTENTREGA = dataEntrega ? null : 'T';
        row.P_ENVIADA = args.row.STATUS.indexOf("E") !== -1 ? 'S' : 'N' ;
        row.P_RETORNADA = args.row.STATUS.indexOf("R") !== -1 ? 'S' : 'N' ;
        row.QR2TYPE = args.row.QR2TYPE;
          
        General.openReport('cmp_fornecimento_autorizacaoFornecimento#/consultaEnvioReport', reportName, row);
    };
    
    this.openReportWidget = function(widget){
        var reportWidget = widget.container.getWidget('WDGT_REPORT');
        reportWidget.newRow();
        ScreenService.openPopup(reportWidget);
    };
            
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp09600_ConsultaEnvioAfFornecedor', Cmp09600_ConsultaEnvioAfFornecedor);
});


// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/sup05100_analise_AF_Controller.js
function sup05100_analise_AF_Controller(ScreenService, MessageService, templateManager, maskEngine, ZhUtil, General, sup05100_analise_AF_Service, Utilities, ZHPromise) {
    
    const serviceAnalise = sup05100_analise_AF_Service;
    let params;
    
    this.onEnterOnceWidgetPrincipal = function(args) {
        const wdgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        serviceAnalise.retornaParaSupriCentralCompras(getLocalVar('CDFILIAL')).then(function(parametros){
            params = parametros.dataset.parasupri_central_compras[0];
            
            if(params) {
                if(!!wdgetPrincipal.NRSEQAPUR) {
            
                    const dataSourceFilter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": params.CDFILIAL
                        },
                        {
                            "name": "CDCOMPRADOR",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "SITUACAO",
                            "operator": "=",
                            "value": "1"
                        },
                        {
                            "name": "CDOPERADOR",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTINIPERIODO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTFINPERIODO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "DTGERACAO",
                            "operator": "=",
                            "value": ""
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": getLocalVar('NRORG')
                        },
                        {
                            "name": "NRAPURPREC",
                            "operator": "=",
                            "value": wdgetPrincipal.NRSEQAPUR
                        }
                    ];
        
                    wdgetPrincipal.getField('NRAPURPREC').dataSource.filter(dataSourceFilter, function(data) {
                        const { IDSITAPUPREC: situacaoApuracao } = data[0];
                        
                        wdgetPrincipal.currentRow.IDSITAPUPREC = situacaoApuracao;
                        wdgetPrincipal.currentRow.NRAPURPREC = wdgetPrincipal.NRSEQAPUR;
                        wdgetPrincipal.currentRow.CDFILLANC = wdgetPrincipal.CDFILLANC;
                        wdgetPrincipal.currentRow.CDFILCENTCMP = wdgetPrincipal.CDFILCENTCMP;
                        
                        wdgetPrincipal.currentRow.CDOPERADOR = data[0].CDOPERADOR;
                        wdgetPrincipal.currentRow.CDCOMPRADOR = data[0].CDCOMPRADOR;
                        wdgetPrincipal.currentRow.NMCOMPRADOR = data[0].NMCOMPRADOR;
                        wdgetPrincipal.currentRow.NMOPERADOR = data[0].NMOPERADOR;
                        
                        wdgetPrincipal.currentRow.DTAPURPREC = wdgetPrincipal.DTAPURPREC;
                        wdgetPrincipal.currentRow.DTINIAPUPREC = wdgetPrincipal.DTINIAPUPREC;
                        wdgetPrincipal.currentRow.DTFINAPUPREC = wdgetPrincipal.DTFINAPUPREC;
                    
                        Utilities.startFilter(wdgetPrincipal, wdgetPrincipal.currentRow);
                    });
                } else {
                	Utilities.startFilter(wdgetPrincipal);
                }
                
            } else {
                MessageService.showMessageByCode("PARASUPRI_NOT_FOUND_FILIOPER", {CDFILIAL: getLocalVar('CDFILIAL')}, Constants.errorMessage);
            }
            
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    };
    
    function exibeMensagemErro(erro) {
        MessageService.getMessageByCode("TRY_AGAIN").then( message => {
            let mensagem = message;
            
            if(erro.data) {
                mensagem = erro.data.error;
            } else if(typeof erro === 'string') {
                mensagem = erro;
            }
            
            if(erro.type !== 'click') {
                ScreenService.showMessage(mensagem);
            }
        });
    }
    
    this.limpaApuracao = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.currentRow.NRAPURPREC = "";
    };
    
    this.verificaSituacaoRequerida = function(field) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const fieldConcluida = widgetPrincipal.getField('CONCLUIDA');
        const fieldAnalise = widgetPrincipal.getField('ANALISE');
        
        if(!fieldConcluida.checked && !fieldAnalise.checked) {
            if(field.name === 'ANALISE') {
                fieldConcluida.checked = true;
                fieldConcluida.setValue('2_3_4');
            } else {
                fieldAnalise.checked = true;
                fieldAnalise.setValue('1');
            }
        }
        
        this.limpaApuracao();
    };
    
    this.getNrApuracao = function(widget) {
    	const currentRow = widget.currentRow;
        const situacao   = [currentRow.ANALISE, currentRow.CONCLUIDA].join("_");
        const apuracaoField = widget.getField("NRAPURPREC");
        
        apuracaoField.dataSourceFilter = [
			{
				'name': 'CDFILIAL',
				'operator': '=',
				'value': getLocalVar('CDFILIAL')
			},
			{
				'name': 'CDCOMPRADOR',
				'operator': '=',
				'value': currentRow.CDCOMPRADOR
			},
			{
				'name': 'SITUACAO',
				'operator': '=',
				'value': situacao
			},
			{
				'name': 'CDOPERADOR',
				'operator': '=',
				'value': getLocalVar('CDOPERADOR')
			},
			{
				'name': 'DTINIPERIODO',
				'operator': '=',
				'value': currentRow.DTPERIODO.start || ''
			},
			{
				'name': 'DTFINPERIODO',
				'operator': '=',
				'value': currentRow.DTPERIODO.end || ''
			},
			{
				'name': 'DTGERACAO',
				'operator': '=',
				'value': currentRow.DATA
			}
		];
        
        //apuracaoField.reload().then(function(callback) {
            currentRow.NRAPURPREC = "";	
        //});
    };
    
    this.filtraApuracao = function(widget) {
        var currentRow = widget.currentRow;
        var situacao   = [currentRow.ANALISE, currentRow.CONCLUIDA].join("_");
        var dataSourceFilter = [];
        currentRow.NRAPURPREC = "";
        
        dataSourceFilter = {
            'CDFILIAL': getLocalVar('CDFILIAL'),
            'CDCOMPRADOR': currentRow.CDCOMPRADOR,
            'SITUACAO': situacao,
            'CDOPERADOR': currentRow.CDOPERADOR,
            'DTINIPERIODO': currentRow.DTPERIODO.start || '',
            'DTFINPERIODO': currentRow.DTPERIODO.end || '',
            'DTGERACAO': currentRow.DATA
        };
        
        General.onClickDependentField(widget.getField("NRAPURPREC"), dataSourceFilter);
    };
    
    /**
     * A apuração atual é a que foi FILTRADA e, portanto, a que se encontra
     * na backupRow, já que essa é atualizada na função confirmarFiltro.
     * 
     * Pode ser diferente da apuração SELECIONADA, já que o usuário pode
     * selecionar uma nova apuração e não realizar o filtro, optando por clicar
     * em cancelar.
     */ 
    function getApuracaoAtual() {
        return templateManager.container.getWidget("stripeWidget").currentRow;
    }
    
    this.setDataSourceFilter = function(args) {
        const stripe = templateManager.container.getWidget('stripeWidget');
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        stripe.filteredRow = filterRow;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFILLANC",
		        "operator": "=",
		        "value": getLocalVar('CDFILIAL')
		    },
		    {
		        "name": "P_NRSEQAPURAF",
		        "operator": "=",
		        "value": filterRow.NRAPURPREC
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILDEST",
                        "direction": "ASC"
                    },
                    {
                        "name": "NMFANTFORN",
                        "direction": "ASC"
                    },
                    {
                        "name": "NRAUTOFORN",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		widget.reload().then(function(callback) {
		    const actions = widget.actions;
		    const firstRow = callback.dataset.sup05100_unidades.find(x => x!==undefined);
            
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
		    widget.activate();
		    widget.showCheckbox = firstRow ? firstRow.IDSITAPUPREC === '1' : true;
		});
		
    };
    
    function setVisibilityOfActions(actions, visibility) {
        actions.map(action => {
            action.isVisible = (action.name === 'reenviarEmail' || action.name === 'salvarRelatorioAF') ? !visibility : visibility;
        });
    }
    
    function aplicarMascara(widget, fieldName) {
        return Util.applyMask(widget.currentRow[fieldName], widget.getField(fieldName).mask, maskEngine, ZhUtil);
    }
    
    function setStripeValues() {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const stripeCurrentRow = stripeWidget.currentRow;
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(widgetPrincipal.dataSource.data.length){
            const firstRow = widgetPrincipal.dataSource.data[0];
            
            stripeCurrentRow.NRAPURPREC = firstRow.NRAPURPREC;
            stripeCurrentRow.VRTOTALAPURAC = firstRow.VRTOTALAPURAC;
            stripeCurrentRow.DESCCOMPRADOR = firstRow.CDCOMPRADOR.concat(' | ', firstRow.NMOPERADOR);
            stripeCurrentRow.PERIODO = moment(firstRow.DTINIAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY').concat(' | ', moment(firstRow.DTFINAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY'));
            stripeCurrentRow.IDSITAPUPREC = firstRow.IDSITAPUPREC;
            stripeCurrentRow.DSSITAPUPREC = stripeWidget.getField('DSSITAPUPREC').options[firstRow.IDSITAPUPREC];
            stripeCurrentRow.CDCOMPRADOR = firstRow.CDCOMPRADOR;
            stripeCurrentRow.NMCOMPRADOR = firstRow.NMCOMPRADOR;
            stripeCurrentRow.CDOPERADOR = firstRow.CDOPERADOR;
            stripeCurrentRow.NMOPERADOR = firstRow.NMOPERADOR;
            stripeCurrentRow.DTAPURPREC = firstRow.DTAPURPREC;
            stripeCurrentRow.DTINIAPUPREC = moment(firstRow.DTINIAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY');
            stripeCurrentRow.DTFINAPUPREC = moment(firstRow.DTFINAPUPREC, 'DD/MM/YYYY').format('DD/MM/YYYY');
            stripeCurrentRow.CDFILLANC = firstRow.CDFILLANC;
            stripeCurrentRow.CDFILCENTCMP = firstRow.CDFILCENTCMP;
            
            stripeCurrentRow.VRTOTALAPURAC = aplicarMascara(stripeWidget, 'VRTOTALAPURAC');
        } else {
            stripeCurrentRow.NRAPURPREC = "";
            stripeCurrentRow.VRTOTALAPURAC = "";
            stripeCurrentRow.NMCOMPRADOR = "";
            stripeCurrentRow.PERIODO = "";
            stripeCurrentRow.IDSITAPUPREC = "";
            stripeCurrentRow.CDCOMPRADOR = "";
            stripeCurrentRow.DTAPURPREC = "";
            stripeCurrentRow.DTINIAPUPREC = "";
            stripeCurrentRow.DTFINAPUPREC = "";
            stripeCurrentRow.CDFILLANC = "";
            stripeCurrentRow.CDFILCENTCMP = "";
        }
    }
    
    this.abreProdutos = function(widget) {
        const tabbed      = widget.container.getWidget("tabbed");
        const produtos    = widget.container.getWidget("produtos");
        
        produtos.dataSource.clearCheckedRows();
        
        produtos.dataSourceFilter = [
            { 'name': 'P_CDFILDEST',   'operator': '=', 'value': widget.currentRow.CDFILDEST   },
			{ 'name': 'P_CDFILLANC',   'operator': '=', 'value': widget.currentRow.CDFILLANC   },
			{ 'name': 'P_NRSEQAPURAF', 'operator': '=', 'value': widget.currentRow.NRAPURPREC  },
			{ 'name': 'P_NRAUTOFORN',  'operator': '=', 'value': widget.currentRow.NRAUTOFORN  },
			{ 'name': 'P_DTPROGENTAF', 'operator': '=', 'value': widget.currentRow.DTPROGENTAF }
		];
		produtos.reload();
		ScreenService.openSwipe(tabbed);
    };
    
    this.voltarAtivar = function(widget) {
        ScreenService.closeSwipe();
        widget.activate();
    };
    
    this.editarProduto = function() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        
        if (isApuracaoConcluida()) {
            MessageService.showMessageByCode("ANALISE_ALREADY_FINISHED", null, Constants.errorMessage);
        } else {
            General.widgetEdit(widgetProduto);
        }
    };
    
    function isApuracaoConcluida() {
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        
        return (stripeWidget.currentRow && stripeWidget.currentRow.IDSITAPUPREC != '1');
    }
    
    this.salvaEdicaoProduto = function(isDataEntregaValida) {
        const widgetProduto = templateManager.container.getWidget('produtos');
        
        if(widgetProduto.isValid()) {
            if(!isDataEntregaValida) {
                validaDataEntrega();
            } else {
                confirmSaveProduct();
            }
        }
    };
    
    function confirmAtuDeEntrSoli(row) {
        const deferred = ZHPromise.defer();
        
        if(moment(row.DTPROGENTAF_OLD, 'DD/MM/YYYY').format('DD/MM/YYYY') !== moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')) {
            return MessageService.confirmMessageByCode("UPDATE_DTPROGENTAF_AF_ITEMSOLI", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function confirmSaveProduct() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const currentRowProduto = widgetProduto.currentRow;
        
        confirmaQuantidade(converteParaFloat(currentRowProduto.QTPROGENTAF)).then(function() {
            currentRowProduto.IDGERAFDTENT = widgetPrincipal.currentRow.IDGERAFDTENT;
            currentRowProduto.CDFORNECED = widgetPrincipal.currentRow.CDFORNECED;
            currentRowProduto.IDFUNCAOFILI = widgetPrincipal.currentRow.IDFUNCAOFILI;
            currentRowProduto.DTPROGENTAF_OLD = widgetProduto.backupRow.DTPROGENTAF;
            currentRowProduto.QTPROGENTAF_OLD = widgetProduto.backupRow.QTPROGENTAF;
            currentRowProduto.ALTERADTENTREGA = currentRowProduto.ALTERADTENTREGA ? currentRowProduto.ALTERADTENTREGA : false;
            
            MessageService.confirmMessageByCode("UPDATE_SOLICITA", null, Constants.confirmationMessage).then(() => {
                confirmAtuDeEntrSoli(currentRowProduto).then(function() {
                    currentRowProduto.ATUSOLICITACMP = true;
                    serviceAnalise.salvaEdicaoProduto(currentRowProduto).then(function(mensagem) {
                        finalizaEdicao(widgetPrincipal, widgetProduto, mensagem);
                    }).catch(function(erro) {
                        exibeMensagemErro(erro);
                    });
                }.bind(this));
            }, function(error) {
                currentRowProduto.ATUSOLICITACMP = false;
                serviceAnalise.salvaEdicaoProduto(currentRowProduto).then(function(mensagem) {
                    finalizaEdicao(widgetPrincipal, widgetProduto, mensagem);
                }).catch(function(erro) {
                    exibeMensagemErro(erro);
                });
            });
        });
    }
    
    function validaDataEntrega() {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const dtprogentafAntiga = widgetProduto.backupRow.DTPROGENTAF.substring(0, 10);
        const dtprogentafAntigaMoment = moment(dtprogentafAntiga, 'DD/MM/YYYY');
        const dtprogentafNova = widgetProduto.currentRow.DTPROGENTAF.substring(0, 10);
        const dtprogentafNovaMoment = moment(dtprogentafNova, 'DD/MM/YYYY');
        const dataAtual = moment(moment().format('DD/MM/YYYY'), 'DD/MM/YYYY');
        
        if(dtprogentafAntiga != dtprogentafNova) {
            if(dtprogentafNovaMoment < dataAtual) {
                MessageService.showMessageByCode("DTPROGENTAF>DTATUAL", null, Constants.alertMessage);
            } else {
                confirmaValidade(dtprogentafNovaMoment, dtprogentafAntigaMoment).then(function() {
                    confirmaAfPorDataEntrega();
                }.bind(this));
            }
        } else {
            confirmSaveProduct();
        }
    }
    
    function confirmaValidade(dtprogentafNova, dtprogentafAntiga) {
        const widgetProduto = templateManager.container.getWidget('produtos');
        const nrDiasValidade = converteParaFloat(widgetProduto.currentRow.NRDIASVALPRFORN);
        const deferred = ZHPromise.defer();
        
        if(nrDiasValidade) {
            const diferencaDias = Math.abs(dtprogentafNova.diff(dtprogentafAntiga, 'days'));
            
            if(diferencaDias > nrDiasValidade) {
                return MessageService.confirmMessageByCode("CONFIRM_VALIDADE_DIAS", null, Constants.confirmationMessage);
            } else {
                deferred.resolve();
            }
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function confirmaAfPorDataEntrega() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetProduto = templateManager.container.getWidget('produtos');
        const idgerafdtent = widgetPrincipal.currentRow.IDGERAFDTENT;
        
        widgetProduto.currentRow.ALTERADTENTREGA = false;
        
        if(idgerafdtent === 'S') {
            MessageService.confirmMessageByCode("QUESTION_AF_DTPROGENTR", null, Constants.confirmationMessage).then(() => {
                widgetProduto.currentRow.ALTERADTENTREGA = true;
                confirmSaveProduct();
            }, function(error) {
                widgetProduto.currentRow.ALTERADTENTREGA = false;
                MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF", null, Constants.alertMessage);
            });
        } else {
            confirmSaveProduct();
        }
    }
    
    function confirmaQuantidade(quantidade) {
        var deferred = ZHPromise.defer();
        
        if(quantidade == 0) {
            return MessageService.confirmMessageByCode("QTPROGENTAF_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function converteParaFloat(valor) {
        if(valor) {
            if(typeof valor === 'string') {
                valor = valor.replace(/\./g, '').replace(',', '.');
            }
            
            valor = parseFloat(valor);
        }
        
        return valor;
    }
    
    function finalizaEdicao(widgetAf, widgetProduto, mensagem) {
        var excluido = mensagem.messages[0].message;

        if(excluido.EDITED_ITEM) {
        	ScreenService.closeSwipe().then(function() {
				ScreenService.closeSwipe().then(function() {
					MessageService.successNotificationByCode('SUCCESS_OPERATION');
					widgetAf.activate();
					widgetAf.reload();
				});
        	});
        } else if(!excluido.AF_DELETADA && !excluido.ITEM_DELETADO) {
            ScreenService.closeSwipe().then(function() {
                widgetProduto.activate();
                widgetProduto.reload();
            });
        } else if(excluido.AF_DELETADA) {
            ScreenService.closeSwipe(0).then(function() {
                MessageService.successNotificationByCode('ITEMAUTF_AND_AF_DELETED');
                widgetAf.activate();
                widgetAf.reload();
            });
        } else if(excluido.ITEM_DELETADO) {
            ScreenService.closeSwipe().then(function() {
                MessageService.successNotificationByCode('ITEMAUTF_DELETED');
                widgetProduto.activate();
                widgetProduto.reload();
            });
        }
    }
    
    this.clearApuracao = function(field) {
        field.widget.getField('NRAPURPREC').clearValue();
        field.widget.getField('NMFILIAL').clearValue();
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearUnidadeDestino = function(field) {
        field.widget.getField('NMFILIAL').clearValue();
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearFornecedor = function(field) {
        field.widget.getField('NMFANTFORN').clearValue();
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    this.clearAF = function(field) {
        field.widget.getField('NRAUTOFORN').clearValue();
    };
    
    function setPopUpValues(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const stripeWidget = templateManager.container.getWidget("stripeWidget");
        
        const fieldComprador = widget.getField('NMCOMPRADOR');
        const fieldApuracao = widget.getField('NRAPURPREC');
        const firstRow = widgetPrincipal.dataSource.data.find(x=>x!==undefined);
        
        setReadOnlyFields(widget, false, allFieldsExceptComprador);
		
        fieldApuracao.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeWidget.currentRow.CDFILLANC    },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeWidget.currentRow.CDFILCENTCMP }
        ];
        
        fieldApuracao.reload().then(function(){
            fieldComprador.setValue(stripeWidget.currentRow.NMOPERADOR);
        	fieldApuracao.setValue([stripeWidget.currentRow.NRAPURPREC]);
    		widget.currentRow.CDCOMPRADOR = firstRow.CDCOMPRADOR;
    		widget.currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;
    
            widget.getField('NMFANTFORN').clearValue();
            widget.getField('NMFILIAL').clearValue();
            widget.getField('NRAUTOFORN').clearValue();
    
    		ScreenService.openPopup(widget);
        });
    }
    
    this.excluirAF = function(widget) {
        if (widget.hasCheckedRows()) {
            MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
                const row = getRowForExclusaoAF();
                
                serviceAnalise.excluirAF(row).then(function(success) {
                    finalizaExclusaoAF(success);
                }).catch(function(error) {
                    exibeMensagemErro(error);
                });
            });
        } else {
            setPopUpValues(templateManager.container.getWidget('exclusaoAfsEmAnalise'));
        }
    };
    
    function filtraApuracaoAF(widget) {
    	const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;

        widget.getField("NRAPURPREC").dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeRow.CDFILLANC         },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeRow.CDFILCENTCMP         }
        ];
        widget.getField("NRAPURPREC").reload();
    }
    
    function filtraAF(widget) {
        const row         = angular.copy(widget.currentRow);
        const CDCOMPRADOR = row.CDCOMPRADOR || null;
        const APURACAO    = concatArrayForParams(row.NRAPURPREC);
        const CDFORNECED  = concatArrayForParams(row.NMFANTFORN);
        const CDFILIAL    = concatArrayForParams(row.NMFILIAL);
        
        widget.getField('NRAUTOFORN').dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': CDCOMPRADOR  },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': APURACAO     },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': CDFORNECED   },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': CDFILIAL	  }
        ];
        
        widget.getField('NRAUTOFORN').reload();
    }
    
    this.setDataSourceComprador = function(field) {
    	const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const comprador = Array.isArray(row.CDCOMPRADOR) ? concatArrayForParams(row.CDCOMPRADOR) : row.CDCOMPRADOR;
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': comprador },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': apuracao  },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(row.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(row.NMFILIAL)	  }
        ];
        
        field.reload();
    };
    
    this.setDataSourceFilterFornecedor = function(field) {
        const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDFILLANC',	'operator': '=', 'value': row.CDFILLANC },
            {  'name': 'P_NRSEQAPURAF',	'operator': '=', 'value': apuracao },
            {  'name': 'P_CDFILDEST',	'operator': '=', 'value': concatArrayForParams(row.NMFILIAL) },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "IDTPIJURFORN",
                        "direction": "ASC"
                    },
                    {
                        "name": "NRINSJURFORN",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        
        field.reload();
    };
    
    this.setDataSourceFilterAF = function(field) {
    	const widget = templateManager.container.getActiveWidget();
        const row = angular.copy(widget.currentRow);
        const apuracao = Array.isArray(row.NRAPURPREC) ? concatArrayForParams(row.NRAPURPREC) : row.NRAPURPREC;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': row.CDCOMPRADOR },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': apuracao  },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(row.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(row.NMFILIAL)	  }
        ];
        
        field.reload();
    };
    
    function allFieldsExceptComprador(field) {
        return field.name !== 'NMCOMPRADOR';
    }
    
    this.validaApuracao = function(args, field) {
        const widget = templateManager.container.getActiveWidget();
        const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR  },
            {  'name': 'P_1',	            'operator': '=',	'value': 'Em análise'                   },
            {  'name': 'P_CDFILLANC',	    'operator': '=',	'value': stripeRow.CDFILLANC         },
            {  'name': 'P_CDFILCENTCMP',	'operator': '=',	'value': stripeRow.CDFILCENTCMP         }
        ];
        
        field.reload().then(function() {
            if(field.dataSource.data.length == 0) {
                args.e.preventDefault();
                MessageService.showMessageByCode("APURPRECO_NOT_REGISTERED", null, Constants.errorMessage);
            } 
        });
    };
    
    function setReadOnlyFields(widget, readOnlyValue, filterFunction) {
        const fields = filterFunction ? widget.fields.filter(filterFunction) : widget.fields;
        
        fields.map(field => { field.readOnly = readOnlyValue; });
    }
    
    function finalizaExclusaoAF(response) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.reload().then(function(callback) {
            ScreenService.closePopup(true);
            MessageService.successNotificationByCode('SUCCESS_DELETE');
            if (callback.dataset.sup05100_unidades.length){
                widgetPrincipal.dataSource.clearCheckedRows();
            	widgetPrincipal.activate();
            } else {
                widgetPrincipal.currentRow.NRAPURPREC = '';
                
                setStripeValues();
                
                Utilities.startFilter(widgetPrincipal, widgetPrincipal.currentRow);
            }
        });
    }
    
    function getRowForExclusaoAF() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = widgetPrincipal.getCheckedRows();
        
        if (Util.isEmptyOrBlank(afsSelecionadas)) {
            const currentRowExclusaoAfs = templateManager.container.getWidget('exclusaoAfsEmAnalise').currentRow;
            
            return {
                AFS_SELECIONADAS: null,
                P_AUTOFORNE: !Util.isEmptyOrBlank(currentRowExclusaoAfs.CONC_AUTOFORNE) ? currentRowExclusaoAfs.CONC_AUTOFORNE : 'T',
                P_NRAPURPREC: concatArrayForParams(currentRowExclusaoAfs.NRAPURPREC),
                P_CDFORNECED: concatArrayForParams(currentRowExclusaoAfs.NMFANTFORN),
                P_CDFILIAL: concatArrayForParams(currentRowExclusaoAfs.NMFILIAL),
                P_CDCOMPRADOR: currentRowExclusaoAfs.CDCOMPRADOR || null
            };
        } else {
            const apuracaoAtual = getApuracaoAtual();
            
            return {
                AFS_SELECIONADAS: afsSelecionadas,
                P_IDQTFRACIONADO: apuracaoAtual.IDQTFRACIONADO,
                P_NRAPURPREC: apuracaoAtual.NRAPURPREC, // widgetPrincipal.currentRow.NRAPURPREC
            };
        }
    }
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    this.voltarParaWidgetPrincipal = function() {
        const widget = templateManager.container.getWidget('widgetPrincipal');
        
        ScreenService.closePopup();
        widget.unSelectAll();
        
        widget.getAction('remanejarAF').isVisible = false;
        widget.getAction('remanejarAFItens').isVisible = false;
        widget.getAction('remanejarAFItensRelacionados').isVisible = false;
    };
    
    this.onChangeCompradorExclusao = function() {
        const widget = templateManager.container.getWidget('exclusaoAfsEmAnalise');
        const fieldComprador = widget.getField('NMCOMPRADOR');
        
        clearFieldsWidget('exclusaoAfsEmAnalise', allFieldsExceptComprador);
        
        if (!Util.isEmptyOrBlank(fieldComprador.value())) {
            filtraApuracaoAF(widget);
            filtraAF(widget);
        }
    };
    
    function clearFieldsWidget(widgetName, filterFunction) {
        const widget = templateManager.container.getWidget(widgetName);
        const fields = filterFunction ? widget.fields.filter(filterFunction) : widget.fields;
        
        fields.map(field => { field.clearValue(); });
    }
    
    this.confirmarExclusaoAF = function() {
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
            const row = getRowForExclusaoAF();
            
            serviceAnalise.excluirAF(row).then(function(success) {
                finalizaExclusaoAF(success);
            }).catch(function(error) {
                exibeMensagemErro(error);
            });
        });
    };
    
    this.liberarAF = function(widget) {
        if (widget.hasCheckedRows()) {
            const apuracao = getApuracaoAtual();
            
            abreEscolhaGerenteDoComprador(apuracao.CDCOMPRADOR);
        } else {
            setPopUpValues(templateManager.container.getWidget('liberarAfsInconsistentes'));
        }
    };
    
    function abreEscolhaGerenteDoComprador(codigoComprador) {
        const widgetGerenteDoComprador = templateManager.container.getWidget('gerenteComprador');
        const fieldGerenteDoComprador = widgetGerenteDoComprador.getField('NMGERENTE');
        
        fieldGerenteDoComprador.dataSourceFilter = [
            {  'name': 'CDOPERGERE',        'operator': '=',    'value': 'T'                                },
            {  'name': 'CDOPERCOMP',        'operator': '=',    'value': codigoComprador                    },
            {  'name': 'NRORG',             'operator': '=',    "value": getLocalVar('NRORG')               }
        ];
        fieldGerenteDoComprador.reload();
        
        ScreenService.openPopup(widgetGerenteDoComprador);
    }
    
    this.confirmarLiberacaoAF = function() {
        const widgetLiberarInconsistencias = templateManager.container.getWidget('liberarAfsInconsistentes');
        
        if (widgetLiberarInconsistencias.isValid()) {
            serviceAnalise.validarBeforeLiberarAF(widgetLiberarInconsistencias.currentRow).then(function() {
                MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
                    abreEscolhaGerenteDoComprador(widgetLiberarInconsistencias.currentRow.CDCOMPRADOR);
                });
            }).catch(function(erro) {
                exibeMensagemErro(erro);
            });
        }
    };
    
    this.onChangeComprador = function() {
        const widgetLiberarInconsistencias = templateManager.container.getWidget('liberarAfsInconsistentes');
        const fieldComprador = widgetLiberarInconsistencias.getField('NMCOMPRADOR');
        
        clearFieldsWidget('liberarAfsInconsistentes', allFieldsExceptComprador);
        
        if (!Util.isEmptyOrBlank(fieldComprador.value())) {
            compradorPossuiGerentes(widgetLiberarInconsistencias).then(function() {
                setReadOnlyFields(widgetLiberarInconsistencias, false, allFieldsExceptComprador);
                filtraApuracaoAF(widgetLiberarInconsistencias);
                filtraAF(widgetLiberarInconsistencias);
            }.bind(this), function(erro) {
                setReadOnlyFields(widgetLiberarInconsistencias, true, allFieldsExceptComprador);
                
                fieldComprador.clearValue();
                widgetLiberarInconsistencias.currentRow.CDCOMPRADOR = '';
                
                exibeMensagemErro(erro);
            });
        } else {
            setReadOnlyFields(widgetLiberarInconsistencias, true, allFieldsExceptComprador);
        }
    };
    
    function compradorPossuiGerentes(widget) {
        return serviceAnalise.verificarGerenteComprador(widget.currentRow);
    }
    
    this.validaAF = function(args, field) {
        const widget = templateManager.container.getActiveWidget();
        
        field.dataSourceFilter = [
            {  'name': 'P_CDCOMPRADOR',		'operator': '=',	'value': widget.currentRow.CDCOMPRADOR },
            {  'name': 'P_NRAPURPREC',	    'operator': '=',	'value': concatArrayForParams(widget.currentRow.NRAPURPREC) },
            {  'name': 'P_CDFORNECED',		'operator': '=',	'value': concatArrayForParams(widget.currentRow.NMFANTFORN) },
            {  'name': 'P_CDFILIAL',		'operator': '=',	'value': concatArrayForParams(widget.currentRow.NMFILIAL)	  }
        ];
        
        field.reload().then(function() {
            if(field.dataSource.data.length === 0) {
                args.e.preventDefault();
                MessageService.showMessageByCode("NAO_HA_AF_INCONSISTENTE", null, Constants.errorMessage);
            } 
        });
    };
    
    this.voltarEscolhaGerenteDoComprador = function() {
        const widget = templateManager.container.getActiveWidget();
        
        clearFieldsWidget('gerenteComprador');
        ScreenService.closePopup();
        
        widget.activate();
    };
    
    this.confirmarEscolhaGerenteDoComprador = function() {
        const widgetGerenteComprador = templateManager.container.getWidget('gerenteComprador');
        
        if (widgetGerenteComprador.isValid()) {
            const currentRowGerenteComprador = widgetGerenteComprador.currentRow;
            
            serviceAnalise.validarSenhaGerente(currentRowGerenteComprador).then(function(response) {
                const row = getRowForLiberacaoAF();
                
                widgetGerenteComprador.currentRow = {};
                
                serviceAnalise.liberarAFInconsistente(row).then(function(success) {
                    const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
                    
                    widgetPrincipal.reload().then(function() {
                        ScreenService.closePopup(true);
                        
                        widgetPrincipal.dataSource.clearCheckedRows();
                        widgetPrincipal.activate();
                        
                        if (success.messages) {
                            ScreenService.showMessage(success.messages[0].message);
                        }
                        
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                    });
                });
            }).catch(function(erro) {
                exibeMensagemErro(erro);
                currentRowGerenteComprador.PASSWORD = "";
            });
        }
    };
    
    function getRowForLiberacaoAF() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = widgetPrincipal.getCheckedRows();
        const currentRowGerenteComprador = templateManager.container.getWidget('gerenteComprador').currentRow;
        
        if (Util.isEmptyOrBlank(afsSelecionadas)) {
            const currentRowLiberacaoAfs = templateManager.container.getWidget('liberarAfsInconsistentes').currentRow;
            
            return {
                AFS_SELECIONADAS: null,
                P_AUTOFORNE: !Util.isEmptyOrBlank(currentRowLiberacaoAfs.CONC_AUTOFORNE) ? currentRowLiberacaoAfs.CONC_AUTOFORNE : 'T', // Utilizado apenas para o Liberar AF's pela widget 'liberarAfsInconsistentes'
                P_NRAPURPREC: concatArrayForParams(currentRowLiberacaoAfs.NRAPURPREC),
                P_CDFORNECED: concatArrayForParams(currentRowLiberacaoAfs.NMFANTFORN),
                P_CDFILIAL: concatArrayForParams(currentRowLiberacaoAfs.NMFILIAL),
                P_CDCOMPRADOR: currentRowLiberacaoAfs.CDCOMPRADOR,
                P_CDGERENTE: currentRowGerenteComprador.CDGERENTE
            };
        } else {
            const apuracaoAtual = getApuracaoAtual();
            
            return {
                IDSITAPUPREC: apuracaoAtual.IDSITAPUPREC,
                AFS_SELECIONADAS: afsSelecionadas,
                P_NRAPURPREC: widgetPrincipal.currentRow.NRAPURPREC, 
                P_CDGERENTE: currentRowGerenteComprador.CDGERENTE
            };
        }
    }
    
    this.concluirAnalise = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(widgetPrincipal.hasCheckedRows()) {
            openPopUpConcluirAnalise(true);
        } else {
            openPopUpConcluirAnalise(false);
        }
    };
    
    function openPopUpConcluirAnalise(hasCheckedRows) {
        const popupWidget = templateManager.container.getWidget('popupConcluirAnalise');
        
        serviceAnalise.retornaCookieEmail({}).then(function(success) {
            popupWidget.getField('ASSUNTO').setValue(success.messages[0].message);
            popupWidget.getField('MENSAGEM').setValue(success.messages[1].message);
            popupWidget.getField('enviarCopiaOperador').setValue(success.messages[2].message);
            
            popupWidget.getField('REPORT_NAME').setValue('padraoEnvioAF.BIRT');
            popupWidget.getField('QR2TYPE').setValue('PDF');
            popupWidget.getField('enviarEmailAF').setValue('S');
            popupWidget.getField('CLASSE').setValue('N');
            
            popupWidget.currentRow.EMITIR_AF = 'N';

            popupWidget.getField('NMFANTFORN').isVisible = !hasCheckedRows;
            popupWidget.getField('NMFILIAL').isVisible = !hasCheckedRows;
            popupWidget.getField('NRAUTOFORN').isVisible = !hasCheckedRows;
            
            setFilterFields(popupWidget);
            
            MessageService.getMessageByCode("MSG_SEND_OPERATOR").then( message => {
                popupWidget.getField('enviarCopiaOperador').label = message + getLocalVar('NMOPERADOR');
            });
            
            ScreenService.openPopup(popupWidget);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function finalizaConclusoaAnalise(success) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        const afInconsist = success.messages.length ? success.messages[0].message.AF_INCONSIST : false;
        
        if(afInconsist) {
            MessageService.showMessageByCode("INCONSISTENT_NRAPURPREC", {NRAPURPREC: success.messages[0].message.NEW_NRAPURPREC}, Constants.errorMessage);
        } else {
            MessageService.successNotificationByCode('SUCCESS_OPERATION');
        }
        
        ScreenService.closePopup(true);
        widgetPrincipal.reload().then(function(callback){
            const firstRow = callback.dataset.sup05100_unidades.find(x => x!==undefined);
            
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.showCheckbox = firstRow ? firstRow.IDSITAPUPREC === '1' : true;
            widgetPrincipal.getField('NRAPURPREC').reload();
            widgetPrincipal.unSelectAll();
            widgetPrincipal.reload();
            widgetPrincipal.activate();
            exibeLogEnviosAF(success);
        });
    }
    
    function concluirAF() {
        serviceAnalise.concluirAF(getRowForConclusaoAnalise()).then(function(success) {
            finalizaConclusoaAnalise(success);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function salvarRelatorioDeAf() {
        const popupAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        MessageService.confirmMessageByCode("VIEW_REPORT", null, Constants.confirmationMessage).then(function(success) {
            popupAnalise.currentRow.EMITIR_AF = 'S';
            concluirAF();
        }, function (error) {
            popupAnalise.currentRow.EMITIR_AF = 'N';
            concluirAF();   
        });
    }
    
    this.confirmarConclusaoAnalise = function() {
        const popUpAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        if(popUpAnalise.getField('enviarEmailAF').checked){
            popUpAnalise.currentRow.EMITIR_AF = 'N';
            
            serviceAnalise.defineCookieEmail(popUpAnalise.currentRow).then(function(success) {
                return serviceAnalise.concluirAF(getRowForConclusaoAnalise()).then(function(success) {
                    finalizaConclusoaAnalise(success);
                });
            }).catch(function(error) {
                exibeMensagemErro(error);
            });
        } else {
            salvarRelatorioDeAf();
        }
    };
    
    this.setVisibilityOfClasse = function(widget) {
        const field = widget.getField('CLASSE');
        
        field.isVisible = widget.getField('enviarEmailAF').checked ? true : false;
    };
    
    function getRowForConclusaoAnalise() {
        const currentRowConclusaoAnalise = templateManager.container.getWidget('popupConcluirAnalise').currentRow;
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetPopUpSelect = templateManager.container.getWidget('popupConcluirAnalise');
        
        return {
            "ALL_DATA_APURACAO": widgetPrincipal.dataSource.data,
            "CURRENT_ROW": widgetPopUpSelect.currentRow,
            "DADOS_APURACAO": getApuracaoAtual(),
            "AFS_SELECIONADAS": widgetPrincipal.getCheckedRows(),
            "CLASSE": currentRowConclusaoAnalise.CLASSE ? currentRowConclusaoAnalise.CLASSE : 'N',
            "DADOS_RELATORIO": {
                "NOME_RELATORIO": currentRowConclusaoAnalise.REPORT_NAME,
                "EXTENSAO": currentRowConclusaoAnalise.QR2TYPE,
                "CLASSE": currentRowConclusaoAnalise.CLASSE,
                "EMITIR_AF": currentRowConclusaoAnalise.EMITIR_AF,
                "EMAIL_AF": currentRowConclusaoAnalise.enviarEmailAF.checked
            },
            "DADOS_EMAIL": {
                "ASSUNTO": currentRowConclusaoAnalise.ASSUNTO,
                "MENSAGEM": Utilities.changeTagRichText(currentRowConclusaoAnalise.MENSAGEM),
                "enviarCopiaOperador": currentRowConclusaoAnalise.enviarCopiaOperador
            }
        };
    }
    
    function exibeLogEnviosAF(success) {
        const logSucesso = success.messages[0].message.SUCESSO;
        const logErro = success.messages[0].message.ERRO;
        const widgetOrigem = templateManager.container.getActiveWidget();
        let popupConcluirAnalise = templateManager.container.getWidget('popupConcluirAnalise');
        
        if (!Util.isEmptyOrBlank(logSucesso)) {
            if(popupConcluirAnalise.currentRow.EMITIR_AF === 'S'){
                openRelatorio(logSucesso[0]);       
            } else {
                adicionaCabecalhoAoLog(logSucesso, 'Sucesso');
            }
        }
    
        if (!Util.isEmptyOrBlank(logErro)) {
            adicionaCabecalhoAoLog(logErro, 'Erro');
        }
        
        if(popupConcluirAnalise.currentRow.enviarEmailAF === 'S'){
            showLogMessages(widgetOrigem, logErro, logSucesso);
        } else {
            if (!Util.isEmptyOrBlank(logErro)) {
                showLogMessages(widgetOrigem, logErro, logSucesso);
            }
        }
    }
    
    function openRelatorio(url) {
        let popup_window = window.open(url, '_blank');
        
        if (!popup_window) {
            ScreenService.showMessage('Pop-up Blocker is enabled! Please add this site to your exception list.');
        }
    }
    
    function adicionaCabecalhoAoLog(logArray, titulo) {
        logArray.unshift('----------------------------');
        logArray.unshift(titulo);
        logArray.unshift('----------------------------');
    }
    
    function showLogMessages(widgetOrigem, logErro, logSucesso) {
        let mensagem = logErro.concat(logSucesso);
        
        General.showErrorMessages(widgetOrigem, mensagem, ScreenService.i18n('Log'));
    }
    
    this.abreInformacao = function(widgetInformacao) {
        var currentRowProduto = widgetInformacao.container.getWidget('produtos').currentRow;
        var idmotprescaf = currentRowProduto.IDMOTPRESCAF;
        var idtipolanitm = currentRowProduto.IDTIPOLANITM;
        var nrcotpreitaf = currentRowProduto.NRCOTPREITAF ? currentRowProduto.NRCOTPREITAF : '';
        var nrlistaitaf = currentRowProduto.NRLISTAITAF ? currentRowProduto.NRLISTAITAF : '';
        var indexMensagem = '';
        var mensagem = '';
        
        for(var i = 0; i < idmotprescaf.length; i++) {
            indexMensagem = i + idmotprescaf[i];
            mensagem = mensagem + mensagensInformacao(indexMensagem);
        }
        
        if(!mensagem) {
            mensagem = mensagem + mensagensInformacao('M0');
        }
        
        mensagem = mensagem + mensagensInformacao('M1', nrcotpreitaf) + mensagensInformacao('M2', nrlistaitaf);
        
        if(idtipolanitm === 'M') {
            mensagem = mensagem + mensagensInformacao('M3');
        }

        widgetInformacao.currentRow.mensagem = mensagem;
        
        ScreenService.openPopup(widgetInformacao);
    };
    
    function mensagensInformacao(indexMensagem, param) {
        var mensagens = {
            '01': 'Escolhido por Produto Preferencial.\n',
            '17': 'Escolhido por Fornecedor/Marca Obrigatórios.\n',
            '18': 'Escolhido por Fornecedor/Marca Preferenciais.\n',
            '19': 'Escolhido por Fornecedor/Marca Restritivos.\n',
            '24': 'Escolhido por Fornecedor Obrigatório.\n',
            '25': 'Escolhido por Fornecedor Preferencial.\n',
            '26': 'Escolhido por Fornecedor Restritivo.\n',
            '2A': 'Escolhido por Acordo.\n',
            '31': 'Escolhido por Marca Obrigatória.\n',
            '32': 'Escolhido por Marca Preferencial.\n',
            '33': 'Escolhido por Marca Restritiva.\n',
            '41': 'Escolhido da Lista de Preços.\n',
            '42': 'Escolhido da Cotação Fora da Lista.\n',
            '51': 'Apuração para solicitações extras - Fornecedor escolhido não é extra.\n',
            '52': 'Apuração para solicitações extras - Fornecedor escolhido é extra.\n',
            '53': 'Apuração para solicitações não extras.\n',
            'M0': 'Escolhida manualmente.\n',
            'M1': 'Cotação: ' + param + '\n',
            'M2': 'Lista de preços: ' + param + '\n',
            'M3': 'Obs.: Item alterado manualmente.\n'
        };
        
        return mensagens[indexMensagem] ? mensagens[indexMensagem] : '';
    }
    
    this.abreSituacao = function(widgetSituacao) {
        var currentRowProdutos = widgetSituacao.container.getWidget('produtos').currentRow;
        var currentRowAF = widgetSituacao.container.getWidget('widgetPrincipal').currentRow;
        var currentRowStripe = widgetSituacao.container.getWidget('stripeWidget').currentRow;
        
        var dtprogentaf = moment(currentRowProdutos.DTPROGENTAF, 'DD/MM/YYYY');
        var dtPeriodoIni = moment(currentRowStripe.PERIODO.substring(0, 10), 'DD/MM/YYYY');
        var dtPeriodoFin = moment(currentRowStripe.PERIODO.substring(13), 'DD/MM/YYYY');
        var dtProcessamento = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        var dtAtual = moment();
        var mensagemSituacao = '';
        var mensagemValidacao = '';
        
        if(dtprogentaf < dtAtual.format('DD/MM/YYYY')) {
            mensagemSituacao = 'Data de entrega menor que a data atual.\n';
        } else if(currentRowProdutos.DTPROGENTAF === dtAtual.format('DD/MM/YYYY')) {
            mensagemSituacao = 'Data de entrega igual a data atual.\n';
        }
        
        if(currentRowAF.DSINCONSAF) {
            mensagemSituacao = mensagemSituacao + currentRowAF.DSINCONSAF + '\n';
        }
        
        if(currentRowProdutos.DSINCONSITAF) {
            mensagemSituacao = mensagemSituacao + currentRowProdutos.DSINCONSITAF + '\n';
        }
        
        if(dtprogentaf >= dtProcessamento) {
            if(dtprogentaf < dtPeriodoIni || dtprogentaf > dtPeriodoFin) {
                mensagemSituacao = mensagemSituacao + 'Data de entrega fora do período de apuração.\n';
            }
        }
        
        widgetSituacao.currentRow.mensagemSituacao = mensagemSituacao;
        
        mensagemValidacao = constroiErrosValidacao(currentRowProdutos.CDPRODUTO + currentRowProdutos.CDMARCA);
        
        if(mensagemValidacao) {
            widgetSituacao.getField('mensagemValidacao').isVisible = true;
            widgetSituacao.currentRow.mensagemValidacao = mensagemValidacao;
        } else {
            widgetSituacao.getField('mensagemValidacao').isVisible = false;
        }
        
        ScreenService.openPopup(widgetSituacao);
    };
    
    function constroiErrosValidacao(widgetProduto, prodMarca) {
        var erros = {};
        var mensagemValidacao = '';
        
        if(erros.length) {
            if(erros[prodMarca][0] === 'S') {
                mensagemValidacao = 'Produto não qualificado para o fornecedor da AF informada. \n';
            }
            
            if(erros[prodMarca][1] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Fornecedor da AF informada não possui preço para o produto ou não atende as particularidades do produto na filial. \n';
            }
            
            if(erros[prodMarca][2] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Produto não cadastrado para o fornecedor da AF informada. \n';
            }
            
            if(erros[prodMarca][3] === 'S') {
                mensagemValidacao = mensagemValidacao + 'Não é permitido remanejar item de AF não atendido pelo fornecedor logístico obrigatório, para uma AF com status OL. \n';
            }   
        }
        
        return mensagemValidacao;
    }
    
    /*Remanejamento*/
    
    this.remanejarAF = function(widget = templateManager.container.getActiveWidget(), trocaProd = false) {
        const stripeRow = templateManager.container.getWidget("stripeWidget").currentRow;
        const afsSelecionadas = retornaAFsParaRemanejar();
        
        verificaConfirmarRemanejoAF().then(function() {
            return verificaTodasAFsSelecionadas(afsSelecionadas, stripeRow);
        }).then(function() {
        	const cdfildest = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        	abreEscolhaAF(afsSelecionadas, widget, trocaProd, cdfildest, stripeRow.CDFILLANC, stripeRow.NRAPURPREC);
        }).catch(function(erro) {
            exibeMensagemErro(erro);
        });
    };
    
    function verificaConfirmarRemanejoAF() {
        const deferred = ZHPromise.defer();
        
        if(params.IDCONFREMANEJAF === 'N') {
            return MessageService.confirmMessageByCode("CONFIRM_REMANEJAMENTO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();  
        }
        
        return deferred.promise;
    }
    
    function verificaTodasAFsSelecionadas(afsSelecionadas, stripeRow) {
        const deferred = ZHPromise.defer();
        const cdfildest = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        
        serviceAnalise.retornaCountAF(cdfildest, stripeRow.CDFILLANC, stripeRow.NRAPURPREC).then(function(callback) {
            const quantidadeAF = callback.dataset.sup05100_afs_count.length ? callback.dataset.sup05100_afs_count[0].QUANTIDADE_AFS : null;
            
            if(afsSelecionadas.length === parseFloat(quantidadeAF)) {
                return MessageService.showMessageByCode("ALL_SELECTED_AF", {CDFILDEST: cdfildest}, Constants.alertMessage);
            } else {
                deferred.resolve();
            }
        });
        
        return deferred.promise;
    }
    
    function abreEscolhaAF(afsSelecionadas, widgetAtiva, trocaProd, cdfildest, cdfillanc, nrseqapuraf) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widgetRemanejo = widgetAtiva.container.getWidget("remanejo");
        const fieldNrautoforn = widgetRemanejo.getField("NRAUTOFORN");
        const principalData = angular.copy(widgetPrincipal.dataSource.data);
        const allRows = principalData.filter(function(afs) {
            return afs.CDFILDEST === cdfildest[0] && afs.CDFILLANC === cdfillanc && afs.NRAPURPREC === nrseqapuraf && !afs.__isSelected;
        });
        
        fieldNrautoforn.dataSource.data = allRows;
        widgetRemanejo.WIDGET_PAI = widgetAtiva.name;
        widgetRemanejo.TROCA_PROD = trocaProd;
        ScreenService.openPopup(widgetRemanejo).then(function() {
            widgetRemanejo.applyDefaultValue();
        });
    }
    
    this.beforeSelectPrincipalRow = function(args) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const activeWidget = templateManager.container.getActiveWidget();
        
        if(widgetPrincipal !== activeWidget) {
            ScreenService.closePopup(true);
            ScreenService.closeSwipe();
            widgetPrincipal.activate();
        }
    };
    
    this.verifyDifferentUnidades = function(args) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const afsSelecionadas = retornaAFsParaRemanejar();
        const uniqueRows = [...new Set(afsSelecionadas.map(row => row.CDFILDEST))];
        
        setVisibilityOfRemanejarAFActions(widgetPrincipal, uniqueRows.length == 1);
    };
    
    function getActionsByName(widget, namesToFind) {
        return widget.actions.filter(action => { return namesToFind.includes(action.name); });
    }
    
    this.enableRemanejo = function(widget) {
        setVisibilityOfRemanejarAFActions(widget, true);
    };
    
    function setVisibilityOfRemanejarAFActions(widget, isVisible) {
        const actionsToFind = [
            'remanejarAF',
            'remanejarAFItens',
            'remanejarAFItensRelacionados',
            'remanejarProdAF',
            'remanejarTrocarProduto'
        ];
        const actions = getActionsByName(widget, actionsToFind);
        
        isVisible = isVisible && !isApuracaoConcluida();
        setVisibilityOfActions(actions, isVisible);
    }
    
    function retornaAFsParaRemanejar() {
        const activeWidget = templateManager.container.getActiveWidget();
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        let afsSelecionadas;
        
        if (activeWidget.name === 'actions_widget') {
            afsSelecionadas = widgetPrincipal.getCheckedRows();
            
            if (Util.isEmptyOrBlank(afsSelecionadas)) {
                afsSelecionadas = [widgetPrincipal.currentRow];
            }
        } else {
            afsSelecionadas = widgetPrincipal.getCheckedRows();
        }
        
        return afsSelecionadas;
    }
    
    this.confirmarRemanejoAF = function(widgetRemanejo) {
        if(widgetRemanejo.isValid()) {
            const afsSelecionadas = retornaAFsParaRemanejar();
            const afDestino = widgetRemanejo.currentRow;
            const validacaoBlocoAFs = validaBlocoAFs(afsSelecionadas, afDestino);
            const currentRowRemanejo = widgetRemanejo.currentRow;
            const apuracaoAtual = getApuracaoAtual();
            
            exibeMensagemConfirmacao(validacaoBlocoAFs.AF_INCONS).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.GERA_DTENTREGA);
            }).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.PRORROGAR_DT);
            }).then(function() {
                return exibeMensagemConfirmacao(validacaoBlocoAFs.VALIDADE);
            }).then(function() {
                if(widgetRemanejo.TROCA_PROD) {
                    const prodSelecionados = widgetRemanejo.container.getWidget('produtos').getCheckedRows()[0];
                    abreEscolhaProduto(widgetRemanejo, afDestino, prodSelecionados);
                } else {
                	if(widgetRemanejo.WIDGET_PAI === 'produtos') {
                	    const prodSelecionados = widgetRemanejo.container.getWidget('produtos').getCheckedRows();
                	    
                	    serviceAnalise.remanejarItensAF(prodSelecionados, afDestino, currentRowRemanejo, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
							const messageRemanejo = callback.messages ? callback.messages[0].message : null;
							
							finalizaRemanejamento(messageRemanejo);
						}, function(error) {
							exibeMensagemErroRemanejamento(error);
						});
                	} else {
						serviceAnalise.remanejarAF(afsSelecionadas, afDestino, currentRowRemanejo, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
							const messageRemanejo = callback.messages ? callback.messages[0].message : null;
							
                            finalizaRemanejamento(messageRemanejo);
						}, function(error) {
							exibeMensagemErroRemanejamento(error);
						});
                    }
                }
            }).catch(function(erro) {
                exibeMensagemErro(erro);
            });
        }
    };
    
    function showErrorsRemanejamento(selected_rows) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        let promises = [];
        
    	promises.push(MessageService.getMessageByCode("PRODUCTS_WITHOUT_PRICE"));
    	promises.push(MessageService.getMessageByCode("DISQUALIFIED_PRODUCT"));
    	promises.push(MessageService.getMessageByCode("PRODUCTS_N_REGISTERED_SUPPLIER"));
    	
    	Promise.all(promises).then((messages) => {
            let arrayMesssages = [];
            let arrayError = [];
            	
            if(messages[0]) arrayMesssages.PRODUCTS_WITHOUT_PRICE = messages[0];
            if(messages[1]) arrayMesssages.DISQUALIFIED_PRODUCT = messages[1]; 
            if(messages[2]) arrayMesssages.PRODUCTS_N_REGISTERED_SUPPLIER = messages[2];

            selected_rows.forEach(function(row) {
        		let messageFunction;
            	
            	if(row.P_RESULT_ERROS === 'NNN') {
            	    return MessageService.successNotificationByCode('SUCCESS_OPERATION');
            	}
        		
        		arrayError = setHeader(arrayError, row);
                        
                row.PRODUCTS.forEach(function(product) {
                    if(product.ERROR.substr(0, 1) === 'S') {
						messageFunction = replaceMessage(arrayMesssages.DISQUALIFIED_PRODUCT, product);
						arrayError = arrayError.concat(messageFunction);
					} 
					if(product.ERROR.substr(1, 1) === 'S') {
						messageFunction = replaceMessage(arrayMesssages.PRODUCTS_WITHOUT_PRICE, product);
						arrayError = arrayError.concat(messageFunction);
					} 
					if(product.ERROR.substr(2, 1) === 'S') {
					    messageFunction = replaceMessage(arrayMesssages.PRODUCTS_N_REGISTERED_SUPPLIER, product);
					    arrayError = arrayError.concat(messageFunction);
					}
                });
            });
            
            if(arrayError.length){
                General.showErrorMessages(widgetOrigem, arrayError, ScreenService.i18n('Log'));
            }
    	});
    }
    
    function setHeader(arrayError, row) {
    	let title_array = [];
    	
    	if(!arrayError.includes(row.NRAUTOFORN.concat(' | ', moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')))) {
    		title_array.unshift('----------------------------');
            title_array.unshift(row.NRAUTOFORN.concat(' | ', moment(row.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY')));
            title_array.unshift('----------------------------');
    	}
    	
    	return arrayError.concat(title_array);
    }
    
    function replaceMessage(message, row) {
        return message.replace('__NMFANTFORN__', row.NMFANTFORN).replace('__CDARVPROD__', row.CDARVPROD);
    }
    
    function exibeMensagemErroRemanejamento(error) {
        var widgetProdutos = templateManager.container.getWidget('produtos');
        
        if(error.data) {
            if(error.data.errorCode == 100) {
                widgetProdutos.ERROS_REMANEJAMENTO = error.data.error;
                MessageService.showMessageByCode("INVALID_REMANEIO");
                finalizaRemanejamento();
            } else if(error.data.errorCode == 200) {
                widgetProdutos.ERROS_REMANEJAMENTO = error.data.error;
                ScreenService.showMessage(error.data.error);
                finalizaRemanejamento();
            } else {
                exibeMensagemErro(error);
            }
        }
    }
    
    function finalizaRemanejamento(messages) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        
        ScreenService.closePopup(true);
        ScreenService.closeSwipe();
        widgetPrincipal.reload().then(function() {
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.unSelectAll();
            widgetPrincipal.activate();
            if(messages){
                showErrorsRemanejamento(messages);	
            }
        });
    }
    
    function abreEscolhaProduto(widget, afDestino, prodSelecionados) {
        var widgetEscolhaProd = widget.container.getWidget('remanejoTrocaProd');
        var fieldProduto = widgetEscolhaProd.getField('NMPRODUTO');
        var dtprogentaf = moment(prodSelecionados.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
        
        fieldProduto.dataSourceFilter = [
            { 'name': 'CDPRODESTO',     'operator': '=',    'value': prodSelecionados.CDPRODESTO        },
            { 'name': 'CDPRODUTO',      'operator': '=',    'value': prodSelecionados.CDPRODUTO         },
            { 'name': 'CDFORNECED',     'operator': '=',    'value': afDestino.CDFORNECED               },
            { 'name': 'CDFILDEST',      'operator': '=',    'value': prodSelecionados.CDFILDEST         },
            { 'name': 'DTPROGENTAF',    'operator': '=',    'value': dtprogentaf                        },
            { 'name': 'IDMOTIVPRESC',   'operator': '=',    'value': prodSelecionados.IDMOTPRESCAF      },
            { 'name': 'CONSPARTFILDEST','operator': '=',    'value': widget.currentRow.CONSPARTFILDEST  },
            {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    },
                    {
                        "name": "VRPRECUNIITM",
                        "direction": "ASC"
                    }
                ]
            }
        ];
        
        fieldProduto.reload().then(function(produtos) {
            produtos = produtos.dataset.sup05100_produtos_itemcole_particularidades ? produtos.dataset.sup05100_produtos_itemcole_particularidades[0] : produtos.dataset.sup05100_produtos_itemcole[0];

            if(produtos) {
                ScreenService.openPopup(widgetEscolhaProd).then(function() {
                    widgetEscolhaProd.applyDefaultValue();
                });
            } else {
                exibeMensagemErro('Não há produtos de mesmo grupo de estoque cotados para o fornecedor da AF de destino ou o mesmo não atende as particularidades do produto na filial.');
            }
        });
    }
    
    function exibeMensagemConfirmacao(mensagem) {
        var deferred = ZHPromise.defer();
        
        if(mensagem) {
            return ScreenService.confirmMessage(mensagem, "question");
        } else {
            deferred.resolve();  
        }

        return deferred.promise;
    }
    
    function validaBlocoAFs(afsSelecionadas, afDestino) {
        const dtprogentafDestinoMoment = moment(afDestino.DTPROGENTAF, 'DD/MM/YYYY');
        const validacaoBlocoAFs = {
            'AF_INCONS': false,
            'GERA_DTENTREGA': false,
            'PRORROGAR_DT': false,
            'VALIDADE': false
        };
        
        afsSelecionadas.forEach(function(af) {
            const dtprogentafOrigemMoment = moment(af.DTPROGENTAF, 'DD/MM/YYYY');
            const nrDiasValidade = converteParaFloat(af.MIN_PRODVALIDADE);
            
            validacaoBlocoAFs.AF_INCONS = !validacaoBlocoAFs.AF_INCONS ? validaAFInconsistente(af.IDSITUATUAAF, af.IDAFFORALIM) : validacaoBlocoAFs.AF_INCONS;
            validacaoBlocoAFs.GERA_DTENTREGA = !validacaoBlocoAFs.GERA_DTENTREGA ? validaDtentregaRemanejamento(afDestino.IDGERAFDTENT, dtprogentafOrigemMoment, dtprogentafDestinoMoment) : validacaoBlocoAFs.GERA_DTENTREGA;
            validacaoBlocoAFs.PRORROGAR_DT = !validacaoBlocoAFs.PRORROGAR_DT ? validaProrrogaDtentrega(dtprogentafOrigemMoment, dtprogentafDestinoMoment) : validacaoBlocoAFs.PRORROGAR_DT;
            validacaoBlocoAFs.VALIDADE = !validacaoBlocoAFs.VALIDADE ? validaValidadeProduto(nrDiasValidade, dtprogentafDestinoMoment, dtprogentafOrigemMoment) : validacaoBlocoAFs.VALIDADE;
        });

        return validacaoBlocoAFs;
    }
    
    
    function validaAFInconsistente(idsituatuaaf, idafforalim) {
        if(!idsituatuaaf && idafforalim === 'N') {
            return "AF não está inconsistente. <br> Deseja continuar?";
        } else {
            return false;
        }
    }
    
    function validaDtentregaRemanejamento(idgerafdtent, dtprogentafOrigem, dtprogentafDestino) {
        if(idgerafdtent === 'S' && dtprogentafDestino.format('DD/MM/YYYY') != dtprogentafOrigem.format('DD/MM/YYYY')) {
            return "Fornecedor da AF destino possui entrega diferente da do Fornecedor da AF origem. <br> Entrega será alterada. <br> Deseja continuar?";
        } else {
            return false;
        }
        
    }
    
    function validaProrrogaDtentrega(dtprogentafOrigem, dtprogentafDestino) {
        if(dtprogentafOrigem < dtprogentafDestino) {
            return "Tem certeza que deseja prorrogar a entrega do produto?";
        } else {
            return false;
        }
    }
    
    
    function validaValidadeProduto(nrDiasValidade, dtprogentafNova, dtprogentafAntiga) {
        if(nrDiasValidade) {
            var diferencaDias = Math.abs(dtprogentafNova.diff(dtprogentafAntiga, 'days'));

            if(diferencaDias > nrDiasValidade) {
                return 'A "Validade (dias)" de um ou mais itens é inferior à diferença de dias entre a entrega atual e a nova data de entrega. <br> Deseja prosseguir?';
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    this.voltarAcoes = function(widget, nomeWidgetActivate) {
        ScreenService.closePopup();
        widget.container.getWidget(nomeWidgetActivate).activate();
    };
    
    this.confirmarRemanejoTrocaProd = function() {
        const widgetRemanejo = templateManager.container.getWidget('remanejo');
        const selectProduct = templateManager.container.getWidget('produtos').getCheckedRows();
    	const apuracaoAtual = getApuracaoAtual();
    	const currentRowRemanejo = widgetRemanejo.currentRow;
    	const currentRowRemanejoTrocaProd = templateManager.container.getWidget('remanejoTrocaProd').currentRow;
    	
        serviceAnalise.remanejarAFTrocaProd(currentRowRemanejo, currentRowRemanejoTrocaProd, selectProduct, apuracaoAtual.IDSITAPUPREC).then(function(callback) {
            const messageRemanejo = callback.messages ? callback.messages[0].message : null;
            
            finalizaRemanejamento(messageRemanejo);
		}, function(error) {
			exibeMensagemErroRemanejamento(error);
		});
    };
    
    this.remanejarAFTrocaProd = function(widgetProduto) {
        const prodSelecionados = widgetProduto.getCheckedRows();
        
        if(validaQuantProdSelecionados(prodSelecionados)) {
            this.remanejarAF(widgetProduto, true);
        }
        
    };
    
    function validaQuantProdSelecionados(prodSelecionados) {
        if(prodSelecionados.length > 1) {
            exibeMensagemErro('É permitido alterar apenas um produto por vez.');
            return false;
        } else {
            return true;
        }
    }
    
    this.checkGridAF = function(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        widgetPrincipal.currentRow.__isSelected = true;
        widgetPrincipal.updateCheckedRows();
    };
    
    this.uncheckGridAF = function(widget) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        
        if(!widget.getCheckedRows().length) {
            widgetPrincipal.unSelectAll();
        }
    };
    
    this.salvarRelatorioAF = function() {
        MessageService.getMessageByCode("SALVAR_RELATORIO").then( message => {
            openPopUpReenviarEmailSalvarRelatorio(message, false);
        });
    };
    
    this.reenviarEmail = function() {
        MessageService.getMessageByCode("REENVIAR_EMAIL").then( message => {
            openPopUpReenviarEmailSalvarRelatorio(message);
        });
    };
    
    function openPopUpReenviarEmailSalvarRelatorio(label, email = true) {
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        popupWidget.currentRow.ISRESENDEMAIL = email;
        serviceAnalise.retornaCookieEmail(popupWidget.currentRow).then(function(success) {
            popupWidget.label = label;
            popupWidget.getField('NOME_RELATORIO').setValue('padraoEnvioAF.BIRT');
            popupWidget.getField('EXTENSAO').setValue('PDF');
            
            popupWidget.getField('ASSUNTO').isVisible = email;
            popupWidget.getField('ASSUNTO').setValue(success.messages[0].message);
            popupWidget.getField('MENSAGEM').isVisible = email;
            popupWidget.getField('MENSAGEM').setValue(success.messages[1].message);
            
            
            popupWidget.getField('emailNaoEnviado').isVisible = email;
            popupWidget.getField('emailNaoEnviado').setValue('S');
            popupWidget.getField('emailEnviado').isVisible = email;
            popupWidget.getField('emailEnviado').setValue('S');
            
            popupWidget.getField('enviarCopiaOperador').isVisible = email;
            popupWidget.getField('enviarCopiaOperador').setValue(success.messages[2].message);
            
            MessageService.getMessageByCode("MSG_SEND_OPERATOR").then( message => {
                popupWidget.getField('enviarCopiaOperador').label = message + getLocalVar('NMOPERADOR');
            });

            setFilterFields(popupWidget);
            
            ScreenService.openPopup(popupWidget);
        }).catch(function(error) {
            exibeMensagemErro(error);
        });
    }
    
    function setFilterFields(widget) {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        
        widget.currentRow.NRAPURPREC = stripeWidget.currentRow.NRAPURPREC;
        widget.currentRow.CDCOMPRADOR = stripeWidget.currentRow.CDCOMPRADOR;
        widget.currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;

        widget.getField('NMFANTFORN').clearValue();
        widget.getField('NMFILIAL').clearValue();
        widget.getField('NRAUTOFORN').clearValue();
    }
    
    function getRowForReenvio(salvarRelatAF) {
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const gridWidget = templateManager.container.getWidget('widgetPrincipal');
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        const currentRow = popupWidget.currentRow;
        
        currentRow.CDFILLANC = stripeWidget.currentRow.CDFILLANC;
        currentRow.NRAPURPREC = stripeWidget.currentRow.NRAPURPREC;
        currentRow.CDFILCENTCMP = stripeWidget.currentRow.CDFILCENTCMP;
        currentRow.DTINIAPUPREC = stripeWidget.currentRow.DTINIAPUPREC;
        currentRow.DTFINAPUPREC = stripeWidget.currentRow.DTFINAPUPREC;
        currentRow.IDSITAPUPREC = stripeWidget.currentRow.IDSITAPUPREC;
        currentRow.EMITIR_AF = salvarRelatAF ? 'S' : 'N';
        
        return {
            "ALL_DATA_APURACAO": gridWidget.dataSource.data,
            "CURRENT_ROW": currentRow
        };
    }
    
    function exibeLogReenvioAF(success) {
        const logSucesso = success.messages[0].message.SUCESSO;
        const logErro = success.messages[0].message.ERRO;
        const widgetOrigem = templateManager.container.getActiveWidget();
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        if (!Util.isEmptyOrBlank(logSucesso)) {
            if(popupWidget.currentRow.EMITIR_AF === 'S'){
                openRelatorio(logSucesso[0]);       
            } else {
                adicionaCabecalhoAoLog(logSucesso, 'Sucesso');
            }
        }
        
        if (!Util.isEmptyOrBlank(logErro)) {
            adicionaCabecalhoAoLog(logErro, 'Erro');
        }
        
        if(popupWidget.currentRow.ISRESENDEMAIL){
            showLogMessages(widgetOrigem, logErro, logSucesso);
        } else {
            if (!Util.isEmptyOrBlank(logErro)) {
                showLogMessages(widgetOrigem, logErro, logSucesso);
            }
        }
    }
    
    function finalizaReenvio(success) {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const actions = widgetPrincipal.actions;
        
        widgetPrincipal.reload().then(function(){
            ScreenService.closePopup(true);
            setStripeValues();
            setVisibilityOfActions(actions, !isApuracaoConcluida());
            widgetPrincipal.getField('NRAPURPREC').reload();
            widgetPrincipal.activate();
            exibeLogReenvioAF(success);
        });
    }
    
    this.confirmaReenvioEmailRelatorio = function() {
        const popupWidget = templateManager.container.getWidget('popupReenviarEmailSalvarRelatorio');
        
        if(popupWidget.currentRow.ISRESENDEMAIL) {
            if(popupWidget.currentRow.emailEnviado === 'N' && popupWidget.currentRow.emailNaoEnviado === 'N') {
                MessageService.showMessageByCode("ERROR_RESEND_NOT_CHECKED", null, Constants.errorMessage);  
            } else {
                serviceAnalise.defineCookieEmail(popupWidget.currentRow).then(function(success) {
                    return serviceAnalise.resendEmail(getRowForReenvio(false)).then(function(success) {
                        finalizaReenvio(success);
                    });
                }).catch(function(error) {
                    exibeMensagemErro(error);
                });   
            }
        } else {
            return serviceAnalise.resendEmail(getRowForReenvio(true)).then(function(success) {
                finalizaReenvio(success);
            });
        }
    };
    
    this.remanejarAFItensApuracao = function(widget, itemRelac) {
        const produtosRemaneja = templateManager.container.getWidget('popupRemanejamentoApuracao');
        let nrAutoForn = [];
    	let cdFilDest = [];
    	let cdFilLanc = [];
    	let cdProduto = [];
    	let nrApurPrec = [];
        
        ScreenService.closePopup(true);
        
        if(widget.name === 'produtos') {
            ScreenService.closeSwipe();
            
            widget.getCheckedRows().forEach(function(af) {
                nrAutoForn.push(af.NRAUTOFORN);
                cdFilDest.push(af.CDFILDEST);
                cdFilLanc.push(af.CDFILLANC);
                nrApurPrec.push(af.NRAPURPREC);
                cdProduto.push(af.CDPRODUTO);
            });
        } else {
            widget.getCheckedRows().forEach(function(af) {
                nrAutoForn.push(af.NRAUTOFORN);
                cdFilDest.push(af.CDFILDEST);
                cdFilLanc.push(af.CDFILLANC);
                nrApurPrec.push(af.NRAPURPREC);
            });
        }
        
        produtosRemaneja.dataSourceFilter = [
            {  'name': 'P_CDFILDEST',      'operator': '=',    'value': concatArrayForParams([...new Set(cdFilDest)]) },
			{  'name': 'P_CDFILLANC',      'operator': '=',    'value': concatArrayForParams([...new Set(cdFilLanc)]) },
			{  'name': 'P_NRSEQAPURAF',    'operator': '=',    'value': concatArrayForParams([...new Set(nrApurPrec)]) },
			{  'name': 'P_CDPRODUTO',      'operator': '=',    'value': concatArrayForParams([...new Set(cdProduto)]) },
			{  'name': 'P_NRAUTOFORN',     'operator': '=',    'value': concatArrayForParams([...new Set(nrAutoForn)]) },
			{  'name': 'P_ITENSRELAC',     'operator': '=',    'value': itemRelac }
		];
        
        produtosRemaneja.reload();
        
        ScreenService.openPopup(produtosRemaneja);
    };
    
    this.concluiRemanejamentoApuracao = function(){
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        const widget = templateManager.container.getWidget('popupRemanejamentoApuracao');
        
        serviceAnalise.concluiRemanejamentoApuracao(widget.getCheckedRows()).then(function(mensagem) {
            ScreenService.closePopup(true);
            widgetPrincipal.unSelectAll();
            widgetPrincipal.reload();
            widgetPrincipal.activate();
            MessageService.successNotificationByCode('SUCCESS_OPERATION');
        }).catch(function(erro) {
            exibeMensagemErro(erro);
        });
        
    };
    
    this.onSelectAllRemanejamento = function(widget) {
        widget.dataSource.data.forEach(register => {
            register.__notSelectable = true;
        });
    };
    
    this.onSelectRowRemanejamento = function(args) {
        if (args.selectedRow.ID) {
            args.owner.dataSource.removeCheckedRows([args.selectedRow]);
		} else {
		    var rows = args.owner.dataSource.data.filter(function(item) {
    			return item.PARENT && item.__isSelected && item.PARENT === args.selectedRow.PARENT;
    		});
    		
    		if(rows.length > 1){
    		    args.owner.dataSource.removeCheckedRows([args.selectedRow]);    
    		}
		}
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('sup05100_analise_AF_Controller', sup05100_analise_AF_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/js/controllers/Sup11300DadosFilialEnvioAfEmailController.js
function Sup11300DadosFilialEnvioAfEmailController(ScreenService, MessageService, templateManager, General) {
    
    this.UpdateDadosFilial = function (widget) {
        if (widget.isValid()) {
            const row = widget.currentRow;

            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/UpdateDadosFilial','Row', 
                row).then(function(success) {
                
                MessageService.notificationMessageByCode("cmp#SUCCESS_OPERATION",'success');
                widget.reload();
    
            }, function (error) {
                var errorMessage = "Timeout";
                let textContentError = '';
                if (error.data){
                    errorMessage = "ERR_GENERICO"; 
                    textContentError = error.data.error;
                }
                MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
            });
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup11300DadosFilialEnvioAfEmailController', Sup11300DadosFilialEnvioAfEmailController);
});


// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp04100BaixaAFsController.js
function Cmp04100BaixaAFsController(ScreenService, General, Utilities, templateManager, MessageService) {
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
	
	function concatenaEscolhas(currentRow) {

		let escolhas = '';
		let array = currentRow.ESCOLHAS;
		
		currentRow.P_IDBAIXAAF_NULL = "Z";
    
        for(let i = 0; i<array.length; i++){
            
            switch (array[i]) {
        	    case '0':
        	        escolhas += '1';
        	        break;
        	    case '1':
        	        escolhas += '_2';
        	        break;
        	    case '2':
        	        escolhas += '_3';
        	        break;
        	    case '3': 
        	        escolhas += '_4';
        	        break;
        	    case '4':
        	        escolhas += '_5';
        	        break;
        	    case '5':
        	        currentRow.P_IDBAIXAAF_NULL = "X";
        	        break;
        	}
        }	
		
		if (escolhas === '') escolhas = '0';
    	if (escolhas !== '') currentRow.P_IDBAIXAAF = escolhas;

		currentRow.CDPRODFIM = currentRow.CDPRODFINAL;
		currentRow.CDPRODINI = currentRow.CDPRODUTO;
		currentRow.DATAINI 	 = currentRow.INTERVALO_DATA.start;
		currentRow.DATAFIN 	 = currentRow.INTERVALO_DATA.end;
		currentRow.NRORG 	 = getLocalVar('NRORG');
	}

    this.productValidations = function(field) {
        const row         = field.widget.currentRow;
        const prodInicial = row.CDARVPRODINI;
        const prodFinal   = row.CDARVPRODFIM;
        
        if(!validaProduto(prodInicial, prodFinal)){
            field.clearValue();
        }
    };

	this.validaReport = function(widget, currentRow) {

		if(widget.isValid()) {
			if(!Util.isEmptyObject(currentRow.ESCOLHAS)){
				General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow.REPORT_NAME, currentRow]);
			} else {
				MessageService.showMessageByCode("SITUACAO_AF_SELECT");
			}
		} else {
			MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
		}

	};

	this.abreRelatorio = function(widget, reportName, currentRow) {
		
		if(!window.projectCorp)
			currentRow.NMFILIAL = getLocalVar('CDFILIAL');
			
		currentRow.LISTAFILIAIS = !Util.isEmptyOrBlank(currentRow.NMFILIAL) ? currentRow.NMFILIAL.join('_') : 'T';
		currentRow.DTINICIAL    = currentRow.INTERVALO_DATA.start;
		currentRow.DTFINAL      = currentRow.INTERVALO_DATA.end;
		
		concatenaEscolhas(currentRow);
	
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp04100_baixa_afs', reportName, currentRow);

	}.bind(this);

	this.setInitValues = function(widget) {
	    
	    const filialField = widget.getField("CDFILDEST");
            
        filialField.value(getLocalVar("NMFILIAL"));
	    
	    General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
	        const filterRow = {
        	    INTERVALO_DATA : {
                    'formattedStart' : moment().format('DD/MM/YYYY'),
                    'start'          : moment().format('DD/MM/YYYY'),
                    'formattedEnd'   : moment().format('DD/MM/YYYY'),
                    'end'            : moment().format('DD/MM/YYYY')
                },
                IDBAIXAAF : [ "0", "1", "2", "3" ],
                NMIDBAIXAAF : [ "Em Aberto", "Baixa Parcial", "Baixa Total", "Baixa Manual" ],
                IDAFEXPIRADA : "T",
                CDFILDEST: [ getLocalVar("CDFILIAL") ],
                NMFILDEST: [ getLocalVar("NMFILIAL") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILDEST = [ CDFILCENTCMP ];
                filterRow.NMFILDEST = [ NMFILCENTCMP ];
                filialField.value(NMFILCENTCMP);
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILDEST;
    	               delete filterRow.NMFILDEST;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILDEST;
    	                   delete filterRow.NMFILDEST;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
       
		    Utilities.startFilter(widget, filterRow);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
        
        
    };
    
    this.skipFilterZeedhi = function(args) {
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.setDataSourceFilterBaixaAf = function (args) {
    	const row                   = args.e.preference.FILTER_ROW;
        const widget                = templateManager.container.getWidget('cmp04100');
        const filterPopupCurrentRow = widget.appliedFilter.FILTER_ROW;
        
        widget.dataSourceFilter = [
            {
    			"name": "P_DTINI",
    			"operator": "=",
    			"value": row.INTERVALO_DATA.start
    		},
    		{
    		    "name": "P_DTFIN",
    			"operator": "=",
    			"value": row.INTERVALO_DATA.end
    		},
    		{
    			"name": "L_CDFILIAL",
    			"operator": "=",
    			"value": !row.CDFILDEST || Util.isEmptyObject(row.CDFILDEST) ? 'T' : row.L_CDFILIAL = '_' + row.CDFILDEST.join('_') + '_'
    		},
    		{
    	    	"name": "P_CDPRODINI",
    			"operator": "=",
    			"value": row.CDARVPRODINI
    		},
    		{
    			"name": "P_CDPRODFIN",
    			"operator": "=",
    			"value": row.CDARVPRODFIM + 'ZZZZZZZZZZZZZZZZZZZ'
    		},
    		{
    			"name": "P_IDBAIXAAF",
    			"operator": "=",
				"value": row.IDBAIXAAF.join('_')
			},
			{
    	    	"name": "P_IDAFEXPIRADA",
    			"operator": "=",
    			"value": row.IDAFEXPIRADA
    		},
    		{
				"name": "P_MODO",
				"operator": "=",
				"value": 'N'
			},
			{
			    "name": "P_CDOPERADOR",
			    "operator": "=",
			    "value": getLocalVar("CDOPERADOR")
			}
		];
    	
       	widget._filterInfo = [
       	    { "label": ScreenService.i18n("Unidade Destino"), "value" : concatArrayForParams(filterPopupCurrentRow.NMFILDEST, ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("Situação da AF"),  "value" : concatArrayForParams(setBaixaAF(filterPopupCurrentRow.IDBAIXAAF), ScreenService.i18n("Todas"))},
            { "label": ScreenService.i18n("AF Expirada"),     "value" : filterPopupCurrentRow.IDAFEXPIRADA == 'T' ? ScreenService.i18n("Todas") : filterPopupCurrentRow.IDAFEXPIRADA == 'N' ? ScreenService.i18n("Não") : ScreenService.i18n("Sim")},
            { "label": ScreenService.i18n("Data de Entrega"), "value" : filterPopupCurrentRow.INTERVALO_DATA.formattedStart + ' a ' + filterPopupCurrentRow.INTERVALO_DATA.formattedEnd},
            { "label": ScreenService.i18n("Produto Inicial"), "value" : filterPopupCurrentRow.NMPRODUTOINI},
            { "label": ScreenService.i18n("Produto Final"),   "value" : filterPopupCurrentRow.NMPRODUTOFIM},
        ];
        		
        widget.reload();
        widget.activate();
        setStripeValues(filterPopupCurrentRow);
    };
    
    function setStripeValues(filterPopupCurrentRow) {
        const stripe = templateManager.container.getWidget('FILTERSTRIPE');
        
        stripe.currentRow.NMFILDEST      = concatArrayForParams(filterPopupCurrentRow.NMFILDEST, ScreenService.i18n("Todas")).replaceAll("_", ", ");
        stripe.currentRow.IDBAIXAAF      = concatArrayForParams(setBaixaAF(filterPopupCurrentRow.IDBAIXAAF), ScreenService.i18n("Todas")).replaceAll("_", ", ");
        stripe.currentRow.IDAFEXPIRADA   = filterPopupCurrentRow.IDAFEXPIRADA == 'T' ? ScreenService.i18n("Todas") : filterPopupCurrentRow.IDAFEXPIRADA == 'N' ? ScreenService.i18n("Não") : ScreenService.i18n("Sim");
        stripe.currentRow.INTERVALO_DATA = filterPopupCurrentRow.INTERVALO_DATA.start + " à " + filterPopupCurrentRow.INTERVALO_DATA.end;
        stripe.currentRow.NMPRODUTOINI   = filterPopupCurrentRow.NMPRODUTOINI;
        stripe.currentRow.NMPRODUTOFIM   = filterPopupCurrentRow.NMPRODUTOFIM;
    }
    
    function setBaixaAF(IDBAIXAAF) {
        let baixa = [];
    	
    	IDBAIXAAF.forEach(function(idBaixa){
            switch (idBaixa) {
        	    case '0':
        	        baixa.push(ScreenService.i18n('Em Aberto'));
        	        break;
        	    case '1':
        	        baixa.push(ScreenService.i18n('Baixa Parcial'));
        	        break;
        	    case '2':
        	        baixa.push(ScreenService.i18n('Baixa Total'));
        	        break;
        	    case '3':
        	        baixa.push(ScreenService.i18n('Baixa Manual'));
        	        break;
        	    case '4':
        	        baixa.push(ScreenService.i18n('Encerrada'));
        	        break;
        	    case '5':
        	        baixa.push(ScreenService.i18n('Cancelada'));
        	        break;
        	    case 'S':
        	        baixa.push(ScreenService.i18n('Expirada'));
        	        break;
        	}
        });
        
        return baixa;
    }
    
    function validaProduto(prodInicial, prodFinal) {
        
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04100BaixaAFsController', Cmp04100BaixaAFsController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp05200_AfsPorFornecedor_Controller.js
var Cmp05200_AfsPorFornecedor_Controller = function (ScreenService, General, restEngine, MessageService) {
    var listaUnidades = '';

    this.valoresDefault = function(widget) {
        if (!widget.currentRow.L_CDFILIAL) {
            widget.newRow();
        }

        widget.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY');
        widget.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        widget.getField("CDFILIAL").reload();
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                widget.getField("CDFILIAL").readOnly = false;
                widget.getField("CDFILIAL").reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.CDFILIAL;
    	               delete widget.currentRow.NMFILIAL;
    	               widget.getField("CDFILIAL").reload();
    	           }
                });
            } else {
                widget.getField("CDFILIAL").readOnly = true;
                widget.getField("CDFILIAL").reload().then(function(success) {
    	           if(widget.getField("CDFILIAL").readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   widget.getField("CDFILIAL").validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete widget.currentRow.CDFILIAL;
    	                   delete widget.currentRow.NMFILIAL;
    	                   widget.getField("CDFILIAL").reload();
    	               } else {
    	                   delete widget.getField("CDFILIAL").validations.required;
    	                   widget.getField("CDFILIAL").reload();
    	               }
    	           }
    	       });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            widget.getField("CDFILIAL").reload();
        });
    };

    function verificaCampoJoin(campo) {
        if (!Util.isEmptyObject(campo)) {
            return '_' + campo.join('_') + '_';
        } else {
            return "T";
        }
    }
    
    function montaParametrosRelatorio(currentRow) {
        var params = {};
        let L_FORNECEDOR, CDOPERADOR, CDIMPOSTO, L_REGIAO, L_FILIAL;
        L_FORNECEDOR = verificaCampoJoin(currentRow.FORNECEDOR);
        CDOPERADOR = verificaCampoJoin(currentRow.NMCOMPRADOR);
        CDIMPOSTO = verificaCampoJoin(currentRow.SGIMPOSTO);
        L_REGIAO = verificaCampoJoin(currentRow.NMREGIAO);
        L_FILIAL = verificaCampoJoin(currentRow.CDFILIAL);
        
        params = {
            'QR2TYPE': currentRow.QR2TYPE,
            'L_FILIAL': L_FILIAL,
            'L_FORNECEDOR': L_FORNECEDOR,
            'CDOPERADOR': CDOPERADOR,
            'CDIMPOSTO': CDIMPOSTO,
            'L_REGIAO': L_REGIAO,
            'DTAFINI': currentRow.DT_INTERVAL.start,
            'DTAFFIN': currentRow.DT_INTERVAL.end,
            'RADIODATA': currentRow.RADIODATA,
            'FILIALLOGADA1': getLocalVar('CDFILIAL'),
            'FILIALLOGADA2': getLocalVar('CDFILIAL'),
            'RADIOIMPRIME': currentRow.RADIOIMPRIME,
            'IMPRIMEOBS': currentRow.IMPRIMEOBS,
            'IMPRIMEOBSPROD': currentRow.IMPRIMEOBSPROD,
            /* ProjectCorp true é Matriz, do contrário, Filial.
            Para o banco, o MODO 'N' equivale a Matriz, e Filial 'S'.*/
            'MODO': window.projectCorp === true ? 'N' : 'S',
            //Parametros especificos para um determinado cliente
            'NMMENSCMP': currentRow.NMMENSCMP ? currentRow.NMMENSCMP.join('_') : '',
            'CDMENSCMP': currentRow.CDMENSCMP ? currentRow.CDMENSCMP.join('_') : ''
        };
        return params;
    }

    this.geraRelatorio = function(widget, args) {
        var reportName;

        if (widget.isValid()) {
            reportName = widget.currentRow.REPORT_NAME;
            
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportName]);
        }
    };

    this.abreRelatorio = function(widget, reportName) {
        var reportParams = montaParametrosRelatorio(widget.currentRow);
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05200_afs_por_fornecedor', reportName, reportParams);
    }.bind(this);


    this.dataSourceRegiao = function() {
         return restEngine.post('cmp#/search_regiao_filial', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": listaUnidades
                }
            ]
        });
    };
    
    this.toggleReadOnlyMensagem = function (checkboxField) {
        var selectField = checkboxField.widget.getField('NMMENSAGEM'),
            currentRow = checkboxField.widget.currentRow;
        
		if (checkboxField.checked) {
			selectField.readOnly = true;
			selectField.validations = {};
			selectField.clearValue();
			currentRow.CDMENSCMP = '';
			currentRow.NMMENSCMP = '';
			selectField.reload();
		} else {
			selectField.readOnly = false;
			selectField.validations = {
				required: true
			};
			selectField.reload();
		}
	};

    /*
     * Metodo para controlar a quantidade de ítens por pagina do dataSource. Caso haja mais de 500 ítens, o item por página
     deve ser ajustado com um tamanho maior que o total de dados para evitar dupĺicação de dados caso a ação de selecionar tudo
     seja feita novamente
     */

    this.onSelectAllCliente = function(args) {
        args.owner.dataSource.itemsPerPage = args.owner.dataSource.data.length + 1;
        args.owner.reload();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp05200_AfsPorFornecedor_Controller', Cmp05200_AfsPorFornecedor_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp05300AFPorFilialController.js
var Cmp05300AFPorFilialController = function(ScreenService, General, Parametros, restEngine, templateManager, MessageService) {
	
	this.widgetOnEnter = function(widget){
		/* ProjectCorp true é Matriz, do contrário, Filial.
		Na query, o MODO 'N' equivale a Matriz, e Filial 'S'. */
		//widget.currentRow.MODO = window.projectCorp ? 'N' : 'S';
		widget.currentRow.MODO = 'N';
		widget.currentRow.CDFILDEST = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILDEST = [ getLocalVar("NMFILIAL") ];
        
        widget.getField("CDFILDEST").reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILDEST = [ CDFILCENTCMP ];
                widget.currentRow.NMFILDEST = [ NMFILCENTCMP ];
                widget.getField("CDFILDEST").readOnly = false;
                widget.getField("CDFILDEST").reload().then(function(success) {
                	let verificador = 0;
                	success.dataset.filioperregiao.forEach(function(filial) {
                		if(filial.CDFILIAL == widget.currentRow.CDFILDEST[0]) {
                			verificador++;
                		}
                	});
                	if(verificador == 0) {
                		delete widget.currentRow.CDFILDEST;
                		delete widget.currentRow.NMFILDEST;
                		widget.getField("CDFILDEST").reload();
                	}
                });
            } else {
                widget.getField("CDFILDEST").readOnly = true;
                widget.getField("CDFILDEST").reload().then(function(success) {
    	           if(widget.getField("CDFILDEST").readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filioperregiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == widget.currentRow.CDFILDEST[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   widget.getField("CDFILDEST").validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete widget.currentRow.CDFILDEST;
    	                   delete widget.currentRow.NMFILDEST;
    	                   widget.getField("CDFILDEST").reload();
    	               } else {
    	                   delete widget.getField("CDFILDEST").validations.required;
    	                   widget.getField("CDFILDEST").reload();
    	               }
    	           }
    	       });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILDEST = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILDEST = [ getLocalVar("NMFILIAL") ];
            widget.getField("CDFILDEST").reload();
        });
		
		this.atualizaFiltroAutorizacaoFornecimento();
	}; 

	this.limpaFieldsAutorizacaoFornecimento = function(widget) {
		widget.getField("NRAUTOFORNINI").clearValue();
		widget.getField("NRAUTOFORNFIN").clearValue();
	};
	

	this.toggleDataEntrega = function(field) {
		var widget = field.getParent(),
			secondFieldAutoForn = field.name === 'NRAUTOFORNINI' ? widget.getField('NRAUTOFORNFIN') : widget.getField('NRAUTOFORNINI'),
			fieldDataEntrega = widget.getField('DT_INTERVAL'),
			isReadOnly = fieldDataEntrega.readOnly;
			
		if (widget.currentRow[field.name] || widget.currentRow[secondFieldAutoForn.name]) {
			if (!isReadOnly) {
				fieldDataEntrega.readOnly = true;
				fieldDataEntrega.clearValue();
				fieldDataEntrega.validations = {};
			}
		} else if (isReadOnly) {
			fieldDataEntrega.readOnly = false;
			fieldDataEntrega.validations = {requiredInterval: true};
		}
		
		//this.limparMensagemCampoObrigatorio(widget);
	};
	
	this.toggleAutorizacaoFornecimento = function(fieldDataEntrega) {
	
		var widget = fieldDataEntrega.getParent(),
			fieldsAutoForn = [
				widget.getField('NRAUTOFORNINI'),
				widget.getField('NRAUTOFORNFIN')
			],
			isReadOnly = widget.getField('NRAUTOFORNINI').readOnly;
			
		var valida = widget.currentRow[fieldDataEntrega.name].start && widget.currentRow[fieldDataEntrega.name].end;	
		if (valida) {
			if (!isReadOnly) {
				fieldsAutoForn.forEach(function(field) {
					field.readOnly = true;
					field.clearValue();
					field.validations = {};
				});
			}
		} else if (isReadOnly) {
			fieldsAutoForn.forEach(function(field) {
				field.readOnly = false;
				field.validations = {required: true};
			});
		}
		
		this.limparMensagemCampoObrigatorio(widget);
	};

	function concatArray(value, defaultValue = 'T') {
	    if (!Util.isEmptyOrBlank(value)) {
	        return Array.isArray(value) ? value.join('_') : value;
	    }
	
	    return defaultValue;
	}
	
	this.atualizaFiltroAutorizacaoFornecimento = function() {
		const widget = templateManager.container.getWidget('cmp05300');
		let currentRow = widget.currentRow;
		
		let params = {
				"NRORG": getLocalVar('NRORG'),
				"MODO": currentRow.MODO,
				"CDFILDEST": concatArray(currentRow.CDFILDEST),
				"CDFILLANC": concatArray(currentRow.CDFILLANC),
				"CDOPERADOR": concatArray(currentRow.NMOPERADOR)
            };
		let fields = ["NRAUTOFORNINI", "NRAUTOFORNFIN"];
		fields.forEach(function(fieldName){
			widget.getField(fieldName).dataSourceFilter.forEach(function(filter){
				if (params[filter.name])
					filter.value = params[filter.name];
			});
		});
	};
	
	this.atualizaFiltroUnidade = function() {
		const widget = templateManager.container.getWidget('cmp05300');
		let currentRow = widget.currentRow;
		
		let params = {
				"P_NRORG": getLocalVar('NRORG'),
				"P_CDOPERADOR": getLocalVar('CDOPERADOR'),
				"P_CDREGIAO": concatArray(currentRow.CDREGIAO)
            };
		let fields = ["CDFILDEST", "CDFILLANC"];
		fields.forEach(function(fieldName){
			widget.getField(fieldName).dataSourceFilter.forEach(function(filter){
				filter.value = params[filter.name];
			});
		});
		
		widget.getField("CDFILDEST").reload();
		widget.getField("CDFILLANC").reload();
	};

	this.validaNumeroAF = function(currentRow) {
		var autoIni = currentRow.NRAUTOFORNINI;
		var autoFin = currentRow.NRAUTOFORNFIN;

		if (autoIni && autoFin && autoIni > autoFin ) {
			MessageService.showMessageByCode("AUTORIZACAO_AF_MENOR_IGUAL");
			return false;
		} else if(!autoIni && !autoFin) {
			return false;
		}
		
		return true;
	};
	
	function montaParametrosRelatorio(currentRow) {
        var currentRowCopy = angular.copy(currentRow),
        params = {
        	'QR2TYPE': currentRowCopy.QR2TYPE,
	        'REPORT_NAME': currentRowCopy.REPORT_NAME,
	        'CDREGIAO': concatArray(currentRowCopy.CDREGIAO),
	        'FILLANC': concatArray(currentRowCopy.CDFILLANC),
	        'CDFILDEST': concatArray(currentRowCopy.CDFILDEST),
	        'OPERADOR': concatArray(currentRowCopy.NMOPERADOR),
			'IMPOSTO': concatArray(currentRowCopy.SGIMPOSTO),
			'CDFORNECED': concatArray(currentRowCopy.CDFORNECED),
			'ORDENA': currentRowCopy.ORDENA,
			'MODO': currentRowCopy.MODO,
			'NRAUTOFORNINI': currentRowCopy.NRAUTOFORNINI,
			'NRAUTOFORNFIN': currentRowCopy.NRAUTOFORNFIN,
			'IMPRIME': currentRowCopy.IMPRIME,
			'AFORDT': currentRowCopy.AFORDT,
			'IMPRIMEOBS': currentRowCopy.IMPRIMEOBS,
			'CDFILIPROC': getLocalVar("CDFILIAL")
        };
        
        params.CDREGIAO1 = params.CDREGIAO;
		params.CDREGIAO2 = params.CDREGIAO;
		
        if (currentRowCopy.DT_INTERVAL) {
			params.DTENTREINI = currentRowCopy.DT_INTERVAL.start;
			params.DTENTREFIN = currentRowCopy.DT_INTERVAL.end;
		} else {
			params.DTENTREINI = '';
			params.DTENTREFIN = '';
		}
		
        return params;
    }
	
	this.validacaoCampos = function(widget) {
		const reportFormat = [
            {
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xls",
				value: "XLSX"
			},
			{
				name: "txt",
				value: "TXT"
			}   
        ];
		
		
		if(widget.isValid()) {
			var consideraAF = !widget.getField('NRAUTOFORNINI').isReadOnly(),
				currentRow = widget.currentRow,
				reportName = currentRow.REPORT_NAME;
				
			if (consideraAF) {
				if (!this.validaNumeroAF(currentRow)) {
					return;
				}
				
				currentRow.AFORDT = 1;
			} else {
				currentRow.AFORDT = 2;
			}

			General.openReportPopup(
				widget,
				this.abreRelatorio,
				[widget, reportName],
				reportFormat);
		}
	};
	
	this.abreRelatorio = function(widget, reportName) {
		var paramsReport = montaParametrosRelatorio(widget.currentRow);
		General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05300_af_por_filial', reportName, paramsReport);
	}.bind(this);
	
	/**
	 * Utilizado para limpar as mensagems de 'Campo Obrigatório' dos fields:
	 * - 'Inicial' e 'Final' do grupo 'Autorização de Fornecimento';
	 * - 'Data de Entrega'.
	 * 
	 * @params widget
	 */
	this.limparMensagemCampoObrigatorio = function(widget) {
		var fields = [
			'NRAUTOFORNINI',
			'NRAUTOFORNFIN',
			'DT_INTERVAL'
			];
		
			
		fields.forEach(function(field) {
			if (widget.currentRow.$error[field]) {
			   delete widget.currentRow.$error[field];
			}
			//delete widget.getField(field).validations;
		});
		
	};
	
	this.onChangeDataEntrega = function(field) {
		this.toggleAutorizacaoFornecimento(field);
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp05300AFPorFilialController', Cmp05300AFPorFilialController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp05400AFPedidoPorData.js
function Cmp05400AFPedidoPorData (General, ScreenService, ZHPromise, restEngine, MessageService) {
	var filterParams;
    
    var concatArray = function(arr, defaultValue) {
	    return !Util.isEmptyOrBlank(arr) ? '_' + arr.join('_') + '_' : defaultValue || 'T';
	};

    this.onEnter = function (widget) {
    	widget.newRow();
    	
    	widget.currentRow.REPORT_NAME = "CMP05400";
    	widget.currentRow.RUPTURA_OL = [ 'T', 'U' ];
    	widget.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY');
        widget.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        widget.getField("CDFILIAL").reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                widget.getField("CDFILIAL").readOnly = false;
                widget.getField("CDFILIAL").reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.CDFILIAL;
    	               delete widget.currentRow.NMFILIAL;
    	               widget.getField("CDFILIAL").reload();
    	           }
                });
            } else {
                widget.getField("CDFILIAL").readOnly = true;
                widget.getField("CDFILIAL").reload().then(function(success) {
    	           if(widget.getField("CDFILIAL").readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   widget.getField("CDFILIAL").validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete widget.currentRow.CDFILIAL;
    	                   delete widget.currentRow.NMFILIAL;
    	                   widget.getField("CDFILIAL").reload();
    	               } else {
    	                   delete widget.getField("CDFILIAL").validations.required;
    	                   widget.getField("CDFILIAL").reload();
    	               }
    	           }
    	       });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            widget.getField("CDFILIAL").reload();
        });
        
    };

	this.onClickCdfilial = function (fieldUnidadeDestino) {
		if (filterParams) {
			General.onClickDependentField(fieldUnidadeDestino, filterParams);
			
			fieldUnidadeDestino.dataSourceFilter = [
	            {
	                name: "P_LISTAREGIAO",
	                operator: "=",
	                value: filterParams.P_LISTAREGIAO
	            },
	            {
	                name: "P_CDGRUPFILI",
	                operator: "=",
	                value: filterParams.P_CDGRUPFILI
	            },
	            {
	                name: "P_CDOPERADOR",
	                operator: "=",
	                value: filterParams.P_CDOPERADOR
	            },
	            {
	                name: "NRORG",
	                operator: "=",
	                value: filterParams.NRORG
	            }
	        ];
		}
	};

	this.atualizaFiltroUnidadeDestino = function (widget) {
		var fieldUnidadeDestino = widget.getField('CDFILIAL'),
			currentRow = widget.currentRow;
	    
	    // Variável de escopo do controller
	    filterParams = {
            "P_LISTAREGIAO": concatArray(currentRow.CDREGIAO),
            "P_CDGRUPFILI": currentRow.CDGRUPFILI || 'T',
            "P_CDOPERADOR": getLocalVar('CDOPERADOR'),
            "NRORG": getLocalVar('NRORG')
        };
        
		fieldUnidadeDestino.clearValue();
	};

	this.acionaGerarRelatorio = function(widget) {
		if (widget.isValid()) {
			var currentRow = widget.currentRow;
			
			if (comparaProduto(currentRow.CDPRODINICIAL, currentRow.CDPRODFINAL)) {
				General.openReportPopup(widget, gerarRelatorio, [widget]);
			}
		}
	};
	
	var gerarRelatorio = function(widget) {
		var reportParams = montaParametrosRelatorio(widget.currentRow);
		General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05400_af_pedido_por_data', widget.currentRow.REPORT_NAME, reportParams);
	};
	
	var montaParametrosRelatorio = function(currentRow) {
		var currentRowCopy = angular.copy(currentRow),
		params = {
			'QR2TYPE': currentRowCopy.QR2TYPE,
	        'REPORT_NAME': currentRowCopy.REPORT_NAME,
			'DTINI': currentRowCopy.DT_INTERVAL.start,
			'DTFIN': currentRowCopy.DT_INTERVAL.end,
			'DTINICIAL': currentRowCopy.DT_INTERVAL.start,
			'DTFINAL': currentRowCopy.DT_INTERVAL.end,
			'FILIAL': concatArray(currentRowCopy.CDFILIAL),
			'COMPRADOR': concatArray(currentRowCopy.CDOPERADOR),
			'IMPOSTO': concatArray(currentRowCopy.CDIMPOSTO),
			'REGIAO': concatArray(currentRowCopy.CDREGIAO),
			'FORNECEDOR': concatArray(currentRowCopy.NRINSJURFORN),
			'GRUPFILI': currentRowCopy.CDGRUPFILI || 'T',
			'FILIALPROC': getLocalVar('CDFILIAL'),
			'MODO': window.projectCorp ? 'N' : 'S',
			'IDTPGERARUP': concatArray(currentRowCopy.RUPTURA_OL)
		};
	    
		if (!currentRowCopy.CDPRODINICIAL && !currentRowCopy.CDPRODFINAL) {
    		params.PRODINICIAL = '0';
    		params.PRODFINAL = 'ZZZZZZZZZZZZZZZZZZZZ';
	        params.TODOSPROD = "T";
	        params.TODOSPROD1 = "T";
	        params.NMPRODINICIAL = "";
	        params.NMPRODFINAL = "";
    	} else {
    		params.PRODINICIAL = currentRowCopy.CDPRODINICIAL;
    		params.PRODFINAL = (currentRowCopy.CDPRODFINAL + 'ZZZZZZZZZZZZZZZZZZZZ').slice(0, 20);
    		params.TODOSPROD = "";
	        params.TODOSPROD1 = "";
	        params.NMPRODINICIAL = currentRowCopy.NMPRODINICIAL;
	        params.NMPRODFINAL = currentRowCopy.NMPRODFINAL;
    	}
    	
    	params.AUTOFORNE = (params.FORNECEDOR == 'T' || params.COMPRADOR == 'T') ? 'X' : 'T';
	    
	    return params;
	};

	var comparaProduto = function(produtoInicial, produtoFinal) {

		var intervaloValido = true;

		if (produtoInicial && !produtoFinal) {
			intervaloValido = false;
			MessageService.showMessageByCode("PRODFINAL_NULO", "ERROR");
		} else if (!produtoInicial && produtoFinal) {
			intervaloValido = false;
			MessageService.showMessageByCode("PRODINICIAL_NULO", "ERROR");
		} else if (produtoInicial && produtoFinal) {
			intervaloValido = General.comparaPratoProduto(produtoInicial, produtoFinal, getLocalVar('CDPICTPROD'));
			if (!intervaloValido) {
				MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", "ERROR");
			}
		}

		return intervaloValido;
	};
	
	this.toggleReadOnlyFields = function(widget) {
		/*
		Um dos campos escolhido aleatoriamente é utilizado como referência
		para evitar que diversos forEach sejam executados desnecessariamente.
		*/
		var fieldsAfetadosCMP05405_CMP05406 = [
				widget.getField('CDOPERADOR'),
				widget.getField('CDIMPOSTO'),
				widget.getField('NRINSJURFORN')
			],
			fieldsAfetadosCMP0540D = [
				widget.getField('RUPTURA_OL')
			],
			isReadOnly = widget.getField('CDOPERADOR').readOnly,
			isReadOnlyCMP0540D = widget.getField('RUPTURA_OL').readOnly,
			trataFields = function(fields, clausula, newValueReadOnly, clearValue, isObrigatorio) {
				if (clausula) {
					fields.forEach(function(field) {
						field.readOnly = newValueReadOnly;
						
						if (clearValue) {
							field.clearValue();
						}
						
						if (isObrigatorio) {
							field.validations = { required: true };
						}
					});
				}
			},
			trataFieldsDefault = function(fields) {
				fields.forEach(function(field) {
					if (field.name === 'RUPTURA_OL') {
						field.readOnly = true;
						field.validations = {};
						
						if (widget.currentRow.$error) {
							delete widget.currentRow.$error.RUPTURA_OL;
						}
					} else {
						field.readOnly = false;
						field.clearValue();
					}
				});
			};
			
		switch(widget.currentRow.REPORT_NAME) {
			case 'CMP05405':
				trataFields(fieldsAfetadosCMP05405_CMP05406, !isReadOnly, true, true, false);
				break;
			case 'CMP05406':
				trataFields(fieldsAfetadosCMP05405_CMP05406, !isReadOnly, true, true, false);
				break;
			case 'CMP0540D':
				trataFields(fieldsAfetadosCMP0540D, isReadOnlyCMP0540D, false, false, true);
				break;
			default:
				trataFieldsDefault(fieldsAfetadosCMP05405_CMP05406.concat(fieldsAfetadosCMP0540D));
		}
	};
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp05400AFPedidoPorData', Cmp05400AFPedidoPorData);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp05500_AfsGeralPorAfsFornecedor_Controller.js
var Cmp05500_AfsGeralPorAfsFornecedor_Controller = function (ScreenService, General, restEngine, templateManager, Utilities, MessageService) {

    var self = this;
    
    this.valoresDefault = function(widget) {
        const filialField = widget.getField("CDFILIAL");
            
        filialField.value(getLocalVar("NMFILIAL"));
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
	        const filterRow = {
	            DT_INTERVAL: {
                    'formattedStart' : moment().format('DD/MM/YYYY'),
                    'start'          : moment().format('DD/MM/YYYY'),
                    'formattedEnd'   : moment().format('DD/MM/YYYY'),
                    'end'            : moment().format('DD/MM/YYYY')
                },
	            IDTIPOLANCAF: 'T',
                CDFILIAL: [ getLocalVar("CDFILIAL") ],
                NMFILIAL: [ getLocalVar("NMFILIAL") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILIAL = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.value(NMFILCENTCMP);
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILIAL;
    	               delete filterRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILIAL;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
       
		    Utilities.startFilter(widget, filterRow);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.clearDefaultFilterGeralAf = function (args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.applyFilterGeralAf = function(args) {
        //const reportName = "CMP05500";
        let widget = args.owner;
        let row = args.e.preference.FILTER_ROW;

        if(widget.isValid()) {
            
    		row.NAOCONSIDERA = 'T';
            row.L_CDGRUPFILI = row.NAOCONSIDERA == 'N'? row.CDGRUPFILI ? row.CDGRUPFILI : "T" : "T";
            //row.L_FILIAL = row.CDFILIAL.join('_');
            row.L_FILIAL = !row.CDFILIAL || Util.isEmptyObject(row.CDFILIAL) ? 'T' : row.L_FILIAL = '_' + row.CDFILIAL.join('_') + '_';
            row.L_FORNECEDOR = !row.FORNECEDOR || Util.isEmptyObject(row.FORNECEDOR) ? 'T' : row.L_FORNECEDOR = '_' + row.FORNECEDOR.join('_') + '_';
            
            row.DATAINI = row.DT_INTERVAL.start;
    		row.DATAFIN = row.DT_INTERVAL.end;
    		row.SEPFORNECEDOR = "F";
    		
    		row.MODO = 'N';
    		
    		widget.dataSourceFilter = [
                { "name": "P_CDPRODINI",    "operator": "=", "value": row.CDPRODINI             },   
    		    { "name": "P_CDPRODFIM",    "operator": "=", "value": row.CDPRODFIN             },
    		    { "name": "P_PAGINA",       "operator": "=", "value": row.SEPFORNECEDOR         }, 
    		    { "name": "P_DATAINI",      "operator": "=", "value": row.DATAINI  	            }, 
    		    { "name": "P_DATAFIM",      "operator": "=", "value": row.DATAFIN	            },
    		    { "name": "L_FILIAL",       "operator": "=", "value": row.L_FILIAL              },
    		    { "name": "L_CDFORNECEDOR", "operator": "=", "value": row.L_FORNECEDOR          },
    		    { "name": "P_CDPRODINICOC", "operator": "=", "value": row.CDPRODINI             },
    		    { "name": "P_CDPRODFIMCOC", "operator": "=", "value": row.CDPRODFIN             },
    		    { "name": "P_MODO",         "operator": "=", "value": row.MODO                  },   
    		    { "name": "P_NRORG",        "operator": "=", "value": getLocalVar('NRORG')      },
    		    { "name": "P_CDOPERADOR",   "operator": "=", "value": getLocalVar("CDOPERADOR") },
    		    { "name": "P_IDTIPOLANCAF", "operator": "=", "value": row.IDTIPOLANCAF          }
            ];
            
            setStripeGeraAf(row);
            
            widget.reload();
        }
    };
    
    function setStripeGeraAf(row) {
        const widStripe = templateManager.container.getWidget('stripe');
        const stripeRow = widStripe.currentRow;
        
        stripeRow.CDPRODINI = row.NMPRODUTOINI;
        stripeRow.CDPRODFIN = row.NMPRODUTOFIM;
        stripeRow.DTENTREGA = ScreenService.i18n("De ") + row.DT_INTERVAL.start + ScreenService.i18n(" até ") + row.DT_INTERVAL.end;
    }

    this.filtraUnidades = function(widget) {
        widget.currentRow.NMFILIAL = "";
        if(widget.currentRow.NMGRUPFILI)
            widget.getField("NMFILIAL").dataSourceFilter[0].value = widget.currentRow.CDGRUPFILI;
        else
            widget.getField("NMFILIAL").dataSourceFilter[0].value = "T";
        widget.getField("NMFILIAL").reload();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp05500_AfsGeralPorAfsFornecedor_Controller', Cmp05500_AfsGeralPorAfsFornecedor_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp05600_NumeroDeAfsPorFornecedorRegiao_Controller.js
var Cmp05600_NumeroDeAfsPorFornecedorRegiao_Controller = function(General, ScreenService, ZhFilterPreferences, Utilities){
    
    this.setFilterInitValues = function(widget){   
	    var filterRow = { };                                                                                                                                                                                                                                  
	    
	    filterRow.DT_INTERVAL = {};                                                                                                                                                                                                                                                                              
        filterRow.DT_INTERVAL.start = moment().format('L');                                                                                                                                                                                                                                        
        filterRow.DT_INTERVAL.end = moment().format('L');                                                                                                                                                                                                                                   

        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);                                                                                                                                                                                                                         
    };
    
	this.widgetOnEnter = function(widget) {
	    var filterRow = { };        
	    filterRow.DT_INTERVAL = {};    
	    filterRow.DT_INTERVAL.start = moment().format('L');                                                                                                                                                                                                                                        
        filterRow.DT_INTERVAL.end = moment().format('L'); 
        filterRow.DT_INTERVAL.formattedStart = moment().format('L');                                                                                                                                                                                                                                        
        filterRow.DT_INTERVAL.formattedEnd = moment().format('L');    
        
    	Utilities.startFilter(widget, filterRow);
    	//this.setFilterInitValues(widget);
    };
    
    this.setStripe = function(widget){
        var filterRow = widget.appliedFilter.FILTER_ROW;
		var stripe = widget.container.getWidget('stripe');
		
		stripe.currentRow.PERIODO	= filterRow.DT_INTERVAL.start + " à " + filterRow.DT_INTERVAL.end;
		if(filterRow.NMREGIAO){
	        stripe.currentRow.REGIAO = Util.isEmptyObject(filterRow.NMREGIAO) ? ScreenService.i18n("Todas") : filterRow.NMREGIAOALT.join(" - ");
	        stripe.getField('REGIAO').isVisible = true;
		}
	};
    this.setCustomFilterRow = function(args) {
         args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    	   
	this.filtrar = function(args) {
	    args.e.preventDefault();

	    var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;
        
        var regiao = (filterRow.NMREGIAO) ? filterRow.NMREGIAO.join("_") : 'T';
        
        widget.container.getWidget('regiao').dataSourceFilter = 
        [
	        {
                "name": "P_DATAINI",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.start
            },
            {
                "name": "P_DATAFIM",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.end
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": regiao
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
			{
				"operator": "ORDER_BY",
				"name": [{
					"name": "CDREGIAO",
					"direction": "ASC"
				}]
			}
        ];
        
        widget.container.getWidget('regiao').currentRow.P_DATAINI = filterRow.DT_INTERVAL.start;
        widget.container.getWidget('regiao').currentRow.P_DATAFIM = filterRow.DT_INTERVAL.end;
        
        
        widget.container.getWidget('fornecedor').dataSourceFilter = [
	        {
                "name": "P_DATAINI",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.start
            },
            {
                "name": "P_DATAFIM",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.end
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": regiao
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
				"operator": "ORDER_BY",
				"name": [{
					"name": "NRINSJURFORN",
					"direction": "ASC"
				}]
			}
        ];
        
        widget.container.getWidget('fornecedor').reload();
        widget.container.getWidget('regiao').reload();
        
        this.setStripe(widget);
	};
    
    this.filtrarFornecedor = function(args) {
        args.e.preventDefault();
	    
	    var widget = args.owner;
        var filterRow = widget.appliedFilter.FILTER_ROW;
        
        var filter = [
	        {
                "name": "P_DATAINI",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.start
            },
            {
                "name": "P_DATAFIM",
                "operator": "=",
                "value": filterRow.DT_INTERVAL.end
            },
            {
                "name": "P_CDREGIAO",
                "operator": "=",
                "value": widget.currentRow.CDREGIAO
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
			{
				"operator": "ORDER_BY",
				"name": [{
					"name": "NRINSJURFORN",
					"direction": "ASC"
				}]
			}
        ];
        
        widget.container.getWidget('afsFornecedor').dataSourceFilter = filter;
        
        widget.container.getWidget('afsFornecedor').reload();
		
	};

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp05600_NumeroDeAfsPorFornecedorRegiao_Controller', Cmp05600_NumeroDeAfsPorFornecedorRegiao_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp07000_RelacaoFornecedoresAFAnalise.js
var Cmp07000_RelacaoFornecedoresAFAnalise = function (ScreenService, General, restEngine, MessageService) {
    /* 
    Devido a passagem de função por parâmetro, ao voltar e ser executada, o 
    contexto do this já não é mais o mesmo. Para contornar e executá-lo, o 
    this é encapsulado num objeto, permanecendo assim a sua referência.
    Equivale à função bind do JavaScript.
    
    "[...]Um objeto ao qual a palavra-chave this pode fazer referência dentro da nova função.[...]"
    - Retirado da documentação da Microsoft sobre a função bind JavaScript;
    */
    var self = this;
    
    /**
     * Define os valores default dos campos.
     * @param {Object} widget - widget principal.
     */
    this.valoresDefault = function(widget) {
        const currentRowWidget = widget.currentRow;
		
		widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("CDFILIAL");
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.cmp07000_filial_por_regiao.forEach(function(filial) {
                        if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete widget.currentRow.CDFILIAL;
                        delete widget.currentRow.NMFILIAL;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.cmp07000_filial_por_regiao.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.CDFILIAL;
    	                    delete widget.currentRow.NMFILIAL;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
            
            setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
            
            //widget.newRow();
            
            currentRowWidget.REPORT_NAME = 'CMP07003';
            
            currentRowWidget.PERIODO_GERACAO = { 
                'formattedStart': moment().format('L'), 
                'formattedEnd': moment().format('L'), 
                'start': moment().format('L'), 
                'end': moment().format('L') 
            };
            
            currentRowWidget.PERIODO_CONCLUSAO = { 
                'formattedStart': moment().format('L'), 
                'formattedEnd': moment().format('L'), 
                'start': moment().format('L'), 
                'end': moment().format('L') 
            };
            
            currentRowWidget.SITU_AF = ['Baixa Parcial', 'Baixa Manual', 'Encerrada', 'Em Análise', 'Baixa Total', 'Em Aberto', 'Cancelada', 'Aguardando EDI'];
            currentRowWidget.ENVIO_AF = ['Normal', 'EDI', 'Não envia AF'];
            
            // Default dataSourceFilter do campo 'Apuração'
            widget.getField('NRAPURPREC').dataSourceFilter = [
                {
                    'name': 'P_CDCOMPRADOR',
                    'operator': '=',
                    'value': 'T'
                },
                {
                    'name': 'P_CDFILCENTCMP',
                    'operator': '=',
                    'value': getLocalVar('CDFILCENTCMP')
                },
                {
                    'name': 'P_1',
                    'operator': '=',
                    'value': 'Em análise'
                },
                {
                    'name': 'P_2',
                    'operator': '=',
                    'value': 'Concluída'
                },
                {
                    'name': 'P_3',
                    'operator': '=',
                    'value': 'Concluída com envio de e-mail'
                },
                {
                    'name': 'P_4',
                    'operator': '=',
                    'value': 'Concluída com aviso para o fornecedor'
                },
                {
                    'name': 'P_5',
                    'operator': '=',
                    'value': 'Em Análise - OL'
                },
                {
                    'name': 'P_6',
                    'operator': '=',
                    'value': 'Consolidada'
                },
                {
                    'name': 'P_7',
                    'operator': '=',
                    'value': 'Concluída com envio de e-mail - OL'
                },
                {
                    'name': 'P_8',
                    'operator': '=',
                    'value': 'Concluída com aviso para o fornecedor - OL'
                }
            ];
        
            // Pega o parâmetro P_CDGRUPPROD, necessário para o field de Sub-Grupo
            General.callRestEngine('cmp_fornecimento_emissaoAutorizacaoFornecimento#/getCodigoGrupProd', 'Row', {'CDFILCENTCMP': getLocalVar('CDFILCENTCMP')}).then(function(response) {
                widget.getField('NMSUBGRPROD').dataSourceFilter = [
                    {
                        "operator": "ORDER_BY",
                        "name": [
                            {
                                "name": "CDSUBGRPROD",
                                "direction": "ASC"
                            }
                        ]
                    },
                    {
                        "name": "P_CDGRUPPROD",
                        "operator": "=",
                        "value": response.dataset.data[0].CDGRUPPROD
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": getLocalVar('NRORG')
                    }
                ];
            }, function(error) {
                ScreenService.showMessage(error.data ? error.data.error : 'Timeout', 'error');
            });
        }, function(error) {
			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
		});
    };
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    this.concatArrayForParams = function (arr, defaultValue) {
        if(!Util.isEmptyOrBlank(arr)) {
            return arr.join('_');
        } else {
            return defaultValue || 'T';
        }
    };
    
    /**
     * Concatena os itens selecionados do campo escolhido. Os campos a que essa
     * função se destina são:
     * - 'Situação da AF';
     * - 'Envio da AF'.
     * Obs.: O item de número 8 é representado como 0.
     * @param {Array} data - campo 'data' do dataSource do campo.
     * @returns {String} Número dos itens concatenados por underline.
     * Ex.: '_1_2_3_4_5_6_7_0'.
     */
    this.formataParamSituAndEnvioAf = function (data) {
        let newIndex,
            retorno = '',
            i = 0;
        
        for (; i < data.length; i++) {
            if (data[i].__isSelected) {
                newIndex = i + 1;
                retorno += '_' + (newIndex === 8 ? 0 : newIndex);
            }
        }
        
        return retorno;
    };
    
    /**
     * Pega o campo 'data' do dataSource do campo escolhido.
     * @params {Object} widget - widget contendo o campo escolhido.
     * @params {Object} field - campo escolhido.
     * @returns {Array} 'data' do campo escolhido.
     */
    this.getDataFromField = function(widget, field) {
        return widget.getField(field).dataSource.data;
    };
    
    this.setDateFieldProperties = function(widget, fieldName) {
        const fieldValidade = widget.getField(fieldName);
        const currentRowWidget = widget.currentRow;
        let startCampoData = '';
        let endCampoData = '';
        
        //Selecionando o campo data de acordo com o fieldName enviado
        if (fieldName === "PERIODO_GERACAO") {
            startCampoData = currentRowWidget.PERIODO_GERACAO.start;
            endCampoData = currentRowWidget.PERIODO_GERACAO.end;
        } else {
            startCampoData = currentRowWidget.PERIODO_CONCLUSAO.start;
            endCampoData = currentRowWidget.PERIODO_CONCLUSAO.end;
        }
        
        //OU Exclusivo - XOR.
        if ((startCampoData && !endCampoData) || (!startCampoData && endCampoData)) {
            fieldValidade.validations = {
                "requiredInterval": true
            };
        } else {
            delete fieldValidade.validations;
            
            if (startCampoData == '' && endCampoData == '' && fieldName === "PERIODO_GERACAO") {
                widget.getField("COINC_PERIODO").checked = false;
            }
        }
        
    };
    
    /**
     * Monta os parâmetros para gerar o relatório.
     * @returns {Object} Parâmetros preparados para o relatório.
     */
    this.montaParametros = function(widget) {
        const getFormattedEndProductCode = code => code ? General.fill(code, 10, true, 'Z') : '';
        const currentRow = widget.currentRow;
        const isBirt = ['CMP07000.BIRT', 'CMP07002.BIRT'].includes(currentRow.REPORT_NAME);
        const regionCode = this.concatArrayForParams(currentRow.NMREGIAO);
        const branchOfficeCode = this.concatArrayForParams(currentRow.CDFILIAL);
        const operatorCode = this.concatArrayForParams(currentRow.NMOPERADOR);
        const providerCode = this.concatArrayForParams(currentRow.NMRAZSOCFORN);
        const subgroupList = this.concatArrayForParams(currentRow.NMSUBGRPROD);
        const nrSeqApurAF = this.concatArrayForParams(currentRow.NRAPURPREC);
        const idBaixaAF = this.formataParamSituAndEnvioAf(this.getDataFromField(widget, 'SITU_AF'));
        const sendTypeAF = this.formataParamSituAndEnvioAf(this.getDataFromField(widget, 'ENVIO_AF'));
        const allBranchOfficeGrouping = Util.isEmptyOrBlank(currentRow.NMGRUPFILI) ? 'T' : 'X';
        const endProductCode = getFormattedEndProductCode(currentRow.CDPRODUTOFIN);
        const parameters = {
            'REPORT_NAME': currentRow.REPORT_NAME,
            'QR2TYPE': currentRow.QR2TYPE || 'PDF',
            'CDREGIAO': regionCode,
            'CDREGIAO1': regionCode,
            'CDFILIAL': branchOfficeCode,
            'CDFILIAL1': branchOfficeCode,
            'CDOPERADOR': operatorCode,
            'CDOPERADOR1': operatorCode,
            'CDFORNECED': providerCode,
            'CDFORNECED1': providerCode,
            'LISTASUBGRUP': subgroupList,
            'LISTASUBGRUP1': subgroupList,
            'NRSEQAPURAF': nrSeqApurAF,
            'NRSEQAPURAF1': nrSeqApurAF,
            'COINCIDE': currentRow.COINC_PERIODO,
            'COINCIDE1': currentRow.COINC_PERIODO,
            'IDBAIXAAF': idBaixaAF,
            'IDBAIXAAF1': idBaixaAF,
            'TPENVIOAF': sendTypeAF,
            'TPENVIOAF1': sendTypeAF,
            'PRODUTINI': currentRow.CDPRODUTOINI || '',
            'PRODUTFIN': currentRow.CDPRODUTOFIN || '',
            'PRODINI': currentRow.CDPRODUTOINI || '',
            'PRODINI1': currentRow.CDPRODUTOINI || '',
            'PRODFIN': endProductCode,
            'PRODFIN1': endProductCode,
            'TPRODUTO': currentRow.CDPRODUTOINI ? '' : 'T', 
            'TPRODUTO1': currentRow.CDPRODUTOINI ? '': 'T', 
            'NMPRODIN': currentRow.NMPRODUTOINI,
            'NMPRODFIN': currentRow.NMPRODUTOFIN,
            'NACCONSIDERA': currentRow.NCONSIDERASUBGRUPO,
            'NACCONSIDERA1': currentRow.NCONSIDERASUBGRUPO,
            'CDGRUPFILI': currentRow.NMGRUPFILI || 'T',
            'TODOSGRUPFILI': allBranchOfficeGrouping,
            'TODOSGRUPFILI1': allBranchOfficeGrouping,
            'NRORG': getLocalVar('NRORG'),
            'NRORG1': getLocalVar('NRORG'),
        };
        const beginGenerationDateParams = [
            'DTINIAPUPREC',
            'DTINIAPUPREC1',
            'DTINIPER',
            'DTINIPER1',
        ];
        const endGenerationDateParams = [
            'DTFINAPUPREC',
            'DTFINAPUPREC1',
            'DTFINPER',
            'DTFINPER1',
        ];
        // const dateParamValue = isBirt ? null : '00:00:00';
        const dateParamValue = null;
        let todosGer;
        
        if (Util.isEmptyOrBlank(currentRow.PERIODO_GERACAO.start) || Util.isEmptyOrBlank(currentRow.PERIODO_GERACAO.end)) {
            beginGenerationDateParams.forEach(param => {
               parameters[param] = moment().subtract(20, 'year').format('L');
            });
            
            endGenerationDateParams.forEach(param => {
               parameters[param] = moment().add(2, 'year').format('L'); 
            });
            
            todosGer = 'T';
        } else {
            beginGenerationDateParams.forEach(param => {
               parameters[param] = currentRow.PERIODO_GERACAO.start; 
            });
            
            endGenerationDateParams.forEach(param => {
               parameters[param] = currentRow.PERIODO_GERACAO.end; 
            });
            
            todosGer = isBirt ? null : '';
        }
        
        const beginCompletionDateParams = [
            'DTCONAPUPRECINI',
            'DTCONAPUPRECINI1',
        ];
        
        const endCompletionDateParams = [
            'DTCONAPUPRECFIN',
            'DTCONAPUPRECFIN1',
        ];
        
        let beginCompletionDateValue;
        let endCompletionDateValue;
        let todosCon;
        
        if (Util.isEmptyOrBlank(currentRow.PERIODO_CONCLUSAO.start) || Util.isEmptyOrBlank(currentRow.PERIODO_CONCLUSAO.end)) {
            beginCompletionDateValue = moment().subtract(20, 'year').format('L');
            endCompletionDateValue = moment().add(2, 'year').format('L');
            
            todosCon = 'T';
        } else {
            beginCompletionDateValue = currentRow.PERIODO_CONCLUSAO.start;
            endCompletionDateValue = currentRow.PERIODO_CONCLUSAO.end;
            
            todosCon = isBirt ? null : '';
        }
        
        beginCompletionDateParams.forEach(param => {
           parameters[param] = beginCompletionDateValue; 
        });
        
        endCompletionDateParams.forEach(param => {
           parameters[param] = endCompletionDateValue; 
        });
        
        let todosProd;
        
        if (Util.isEmptyOrBlank(currentRow.NMPRODUTOINI) && Util.isEmptyOrBlank(currentRow.NMPRODUTOFIN)) {
            todosProd = 'T';
        } else {
            todosProd = isBirt ? null : '';
        }
        
        parameters.TODOSGER = todosGer;
        parameters.TODOSGER1 = todosGer;
        
        parameters.TODOSCON = todosCon;
        parameters.TODOSCON1 = todosCon;
        
        parameters.TODOSPROD = todosProd;
        parameters.TODOSPROD1 = todosProd;
        
        return parameters;
    };

    this.geraRelatorio = function(widget) {
        if(widget.isValid() && this.validaProduto(widget.currentRow.CDPRODUTOINI, widget.currentRow.CDPRODUTOFIN)) {
            const reportName = widget.currentRow.REPORT_NAME;
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportName]);
        }
    };

    this.abreRelatorio = function(widget, reportName) {
        const parametros = self.montaParametros(widget);
        General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp07000_relacao_fornecedores_af_analise', reportName, parametros);
    };

    /**
     * Executa a função clearValue do campo escolhido.
     * @param {Object} widget - widget aonde o campo se encontra.
     * @param {string} nomeCampo - nome do campo a ser limpo.
     */
    this.limparCampo = function(widget, nomeCampo) {
        widget.getField(nomeCampo).clearValue();
    };

    /**
     * Filtra o campo de Unidade de acordo com a Região escolhida.
     * Caso não tenha, filtra por TODAS. 
     * @param {Object} field - campo 'Unidade' a ser filtrado.
     */
    this.filtraUnidades =  function(field) {
        const currentRowParent = field.getParent().currentRow;
        const regiao = currentRowParent.NMREGIAO;
        const grupFili = currentRowParent.CDGRUPFILI != "" && currentRowParent.CDGRUPFILI != undefined ? currentRowParent.CDGRUPFILI : 'T';
        
        const params = {
            "P_CDREGIAO": this.concatArrayForParams(regiao, 'T'),
            "P_CDGRUPFILI": grupFili
        };
        
        General.onClickDependentField(field, params);
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };

    /**
     * Filtra o campo de Apuração de acordo com o Comprador escolhido.
     * Caso não tenha, filtra por TODOS.
     * @param {Object} field - campo 'Apuração' a ser filtrado.
     */
    this.filtraApuracao =  function(field) {
        const cur_row_comprador = field.getParent().currentRow.NMOPERADOR;
              
        const params = {
                "P_CDCOMPRADOR": this.concatArrayForParams(cur_row_comprador)
              };
        
        General.onClickDependentField(field, params);
    };

    /**
     * Habilita/Desabilita o checkbox 'Coincidir o período de geração de apuração' de
     * acordo com o campo 'Período de Geração'. Se o campo estiver preenchido,
     * o checkbox é habilitado. Caso contrário, ele é desmarcado e desabilitado.
     * @param {Object} - .
     */
    this.acionaCoincidePeriodoApuracao = function(args) {
        const widget = args.owner.field.getParent(),
              checkboxCoincPeriodo = widget.getField('COINC_PERIODO');
        
        if (widget.currentRow.PERIODO_GERACAO) {
            checkboxCoincPeriodo.setValue('S');
            checkboxCoincPeriodo.readOnly = false;
        } else {
            checkboxCoincPeriodo.setValue('N');
            checkboxCoincPeriodo.readOnly = true;
        }
    };
    
    /**
     * Habilita/Desabilita o campo 'Sub-Grupo'. Se o checkbox estiver marcado,
     * o campo se torna obrigatório. Caso contrário, o campo é desabilitado.
     * @param {Object} field - campo 'Sub-grupo'.
     */
    this.toggleSubGrupo = function(field) {
        General.toggleReadOnlySelect(field, field.widget.getField('NMSUBGRPROD'));
    };
};


Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07000_RelacaoFornecedoresAFAnalise', Cmp07000_RelacaoFornecedoresAFAnalise);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp07500JustificativaAfsController.js
function Cmp07500JustificativaAfsController(ScreenService, General, Utilities, templateManager, MessageService) {
	function beforeGenerateReport(data) {
	    const filterRow = templateManager.container.getWidget('justificativaAfs').appliedFilter.FILTER_ROW;
	    
	    data.metadata.filter = [
	        {
	            label: 'Unidade de Destino',
	            value: filterRow.CDFILDEST.join(', ')
	        },
	        {
	            label: 'Produto Inicial',
	            value: filterRow.CDARVPRODINI +" - "+ filterRow.NMPRODUTOINI
	        },
	        {
	            label: 'Produto Final',
	            value: filterRow.CDARVPRODFIM +" - "+ filterRow.NMPRODUTOFIM
	        },
	        {
	            label: 'Período de Entrega',
	            value: filterRow.INTERVALO_DATA.start +" a "+ filterRow.INTERVALO_DATA.end 
	        }
	   ];
	}
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
        return defaultValue;
    }
    
    function validaProduto(prodInicial, prodFinal) {
        
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    }
	
	this.atualizaFiltroUnidadeDestino = function (widget) {
		var fieldUnidadeDestino = widget.getField('CDFILDEST'),
		currentRow = widget.currentRow;
		
		fieldUnidadeDestino.dataSourceFilter = [
		    {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": currentRow.CDGRUPFILI ? currentRow.CDGRUPFILI : 'T'
            }
		];
        
		fieldUnidadeDestino.clearValue();
		fieldUnidadeDestino.reload();
	};
	
	this.setInitValues = function(widget) {
		const filialField = widget.getField("CDFILDEST");
		General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
	        const filterRow = {
	    	    INTERVALO_DATA : {
	                'formattedStart' : moment().format('DD/MM/YYYY'),
	                'start'          : moment().format('DD/MM/YYYY'),
	                'formattedEnd'   : moment().format('DD/MM/YYYY'),
	                'end'            : moment().format('DD/MM/YYYY')
	            },
	            CDFILDEST: [ getLocalVar("CDFILIAL") ],
	            NMFILIAL: [ getLocalVar("NMFILIAL") ],
	            IDBAIXAAF   : [ "0", "1", "2", "3", "4", "5" ],
	            NMIDBAIXAAF : [ "Em Aberto", "Baixa Parcial", "Baixa Total", "Baixa Manual", "Encerrada", "Cancelada" ],
	            IDTIPOLAN   : "T"
	        };
	        
	        if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILDEST = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filialgrupfili.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILDEST;
    	               delete filterRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filialgrupfili.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILDEST[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILDEST;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
	       
			Utilities.startFilter(widget, filterRow);
			widget.beforeGenerateReport = beforeGenerateReport;
		}, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };
    
    this.skipFilterZeedhi = function(args) {
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.setDataSourceFilterJustificativaAf = function (args) {
    	const row                   = concatenaEscolhas(args.e.preference.FILTER_ROW);
        const widget                = templateManager.container.getWidget('justificativaAfs');
        const filterPopupCurrentRow = widget.appliedFilter.FILTER_ROW;
        
	widget.dataSourceFilter = [
	        {
				"name": "P_CDFILDESMOV",
				"operator": "=",
				"value": concatArrayForParams(row.CDFILDEST)
			},
			    			{
				"name": "P_IDBAIXAAF",
				"operator": "=",
				"value": row.P_IDBAIXAAF
			},
            {
				"name": "P_IDTIPOLAN",
				"operator": "=",
				"value": row.IDTIPOLAN
			},
			{
				"name": "P_DTINI",
				"operator": "=",
				"value": row.INTERVALO_DATA.start
			},
			{
				"name": "P_DTFIM",
				"operator": "=",
				"value": row.INTERVALO_DATA.end
			},
			{
				"name": "P_PRODINI",
				"operator": "=",
				"value": row.CDARVPRODINI
			},
			{
				"name": "P_PRODFIN",
				"operator": "=",
				"value": General.fill(row.CDARVPRODFIM, 20, true, 'Z')
			},
			{
				"name": "P_CDOPERADOR",
				"operator": "=",
				"value": getLocalVar("CDOPERADOR")
			}
		];
		
    	widget.reload();
    	widget.activate();
    };

    this.productValidations = function(field) {
        const row         = field.widget.currentRow;
        const prodInicial = row.CDARVPRODINI;
        const prodFinal   = row.CDARVPRODFIM;
        
        if(!validaProduto(prodInicial, prodFinal)){
            field.clearValue();
        }
    };
    
    function concatenaEscolhas(currentRow) {
        let row = angular.copy(currentRow);
 		let array = row.IDBAIXAAF;
 		
 		row.IDBAIXAAF = '';

        for(let i = 0; i<array.length; i++){
        
             switch (array[i]) {
         	    case '1':
         	        row.IDBAIXAAF += '1';
         	        break;
         	    case '2':
         	        row.IDBAIXAAF += '_2';
         	        break;
         	    case '3': 
         	        row.IDBAIXAAF += '_3';
         	        break;
         	    case '4':
         	        row.IDBAIXAAF += '_4';
         	        break;
         	    case '5':
         	        row.IDBAIXAAF += '_5';
         	        break;
         	}
        }	
		
 		if (row.IDBAIXAAF === '') row.IDBAIXAAF = '0';
     	if (row.IDBAIXAAF !== '') row.P_IDBAIXAAF = row.IDBAIXAAF;

        return row;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07500JustificativaAfsController', Cmp07500JustificativaAfsController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Cmp08400_Modelo_Emissao_Af_Controller.js
var Cmp08400_Modelo_Emissao_Af_Controller = function(MessageService, General, Parametros, restEngine, templateManager) {
	this.onEnterOnceStripe = function(widget) {
		General.callRestEngine('cmp#/crud/enderautoforne','FilterData',[]).then(function(response){
			if (response.dataset.enderautoforne.length === 0 ){
				widget.applyDefaultValue();
				widget.currentRow.__is_new = true;
				widget.currentRow.NRENDERAUTOFORNE = 1;
				widget.saveRow();
			}else{
				widget.currentRow = response.dataset.enderautoforne.shift();
			}
		});
	};
    	
	this.edit = function (widget) {
		General.edit(widget);
		
	};	
	
	this.cancel = function(widget) {
        General.widgetCancelForm(widget);
    };
    
    this.confirmarEditModEmisAf = function (widget){
		if(!widget.currentRow.changed) {
			widget.list();
			return;
		}
		widget.currentRow.__is_new = false;
    	widget.saveRow().then(function(res){
    	    widget.list();
    	    MessageService.successNotificationByCode('cmp#SALVO_SUCESSO');
        }, function(error) {
        	MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT', null, { type: 'ERROR' });
        });
    };
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp08400_Modelo_Emissao_Af_Controller', Cmp08400_Modelo_Emissao_Af_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/cmp08600_relacionamento_fornecedores_afController.js
function cmp08600_relacionamento_fornecedores_afController(ScreenService, templateManager, General, maskEngine, MessageService) {
    var fornec;
   
    this.openInsert = function(widget){
        widget.container.getWidget('add_relacao').mode = "edit";
        ScreenService.openSwipe(widget.container.getWidget('add_relacao')); 
        
    };
    this.filterRelacoes = function(widget) {
        ScreenService.openSwipe(widget.container.getWidget('relacoes_table'));
       
        widget.container.getWidget('relacoes_table').dataSourceFilter = [{
            "name": "CDFORNERELACAF",
            "operator": "=",
            "value":  widget.currentRow.CDFORNECED
        }];
        
        fornec = widget.currentRow.CDFORNECED;
        widget.container.getWidget('relacoes_table').reload();
    };
    
    this.searchDsFilter = function(widget) {
        widget.getField('NMFORNECED').dataSourceFilter = [{
            "name": "P_CDFORNECED",
            "operator": "=",
            "value":  fornec
        }];
        widget.getField('NMFORNECED').reload();
    };
    
    this.adicionarRelacao = function(widget) {
        var widForn = widget.container.getWidget('fornecedor_table'); 
        if(widget.isValid()){
            var row = widget.currentRow;
            row.OLDFORNECED = fornec;
            General.callRestEngine('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp08600_relacionamento_fornecedores/add', 'Row', row).then(function() {
                ScreenService.closeSwipe();
                widget.getField('NMFORNECED').clearValue();
                widget.getParent().reload();
                widForn.reload();
            });
        }
        else {
            MessageService.showMessageByCode("PREENCHER_CAMPO_CORRETAMENTE");
        }
    };
    
    this.excluirRelacao = function(widget) {
        var widForn = widget.container.getWidget('fornecedor_table'); 
        ScreenService.confirmMessage('Deletar registro?', 'question', function (success) {
            var rows = widget.getCheckedRows();
            rows.forEach(function(row){
                General.callRestEngine('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp08600_relacionamento_fornecedores/delete', 'Row', row).then(function() {
                    widget.reload();
                    widget.getParent().reload();
                    widForn.reload();
                    
                    
                });
            });
            
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

}

Configuration(function(ContextRegister) {
   ContextRegister.register('cmp08600_relacionamento_fornecedores_afController', cmp08600_relacionamento_fornecedores_afController);
});

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/js/controllers/Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller.js
function Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller(General, Utilities, RestEngine, ScreenService, templateManager){

    this.voltarAcomSoliCmp = function(widget) {
    	ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#cmp09500_acompanhamento_de_solicitacao_de_compras');
    };

     this.applyDefaultValue = function(widget) {
        widget.newRow();
        widget.currentRow.DT_ENTREGA = {
            start: moment().format('DD/MM/YYYY'),
            end: moment().format('DD/MM/YYYY'),
            formattedStart: moment().format('DD/MM/YYYY'),
            formattedEnd: moment().format('DD/MM/YYYY')
        };
        widget.currentRow.REPORT = 'SUP00704';
        if(widget.ABERTA_POR) {
	    	widget.getAction('voltar_acompanhamento_solicitacao_compras').isVisible = true;
		}
    };
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function setDatasParams(datas, defaultReturn = null) {
        return {
            "formattedStart": datas && datas.start ? datas.formattedStart : defaultReturn,
            "formattedEnd"  : datas && datas.end   ? datas.formattedEnd : defaultReturn
        };
    }
    
     this.dtSourceSolicitacao = function(widget) {
        
        const datas = setDatasParams(widget.currentRow.DT_ENTREGA);
        const solicitacao =  widget.getField('SOLICITACAO');
        
        solicitacao.dataSourceFilter = [
            {
                "name": "P_DTENTRINI",
                "operator": "=",
                "value": datas.formattedStart
            },
            {
                "name": "P_DTENTRFIN",
                "operator": "=",
                "value": datas.formattedEnd
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL !== "" ? concatArrayForParams(widget.currentRow.CDFILIAL) : 'T'
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        solicitacao.reload();
    };
    
    this.criaRelatorio = function(widget) {
        if (!widget.isValid()) return;
        
        const reportName = widget.currentRow.REPORT;
        
        General.openReportPopup(widget, abreRelatorio, [widget, widget.currentRow, reportName]);
    };
    
    function preencheCaracterDireita(string) {
        var pad = 'ZZZZZZZZZZZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);
    }
    
    function abreRelatorio(widget, row, reportName) {
        if(widget.isValid()) {
            row.DTINICIAL = row.DT_ENTREGA && row.DT_ENTREGA.start ? row.DT_ENTREGA.start : '';
            row.DTFINAL = row.DT_ENTREGA && row.DT_ENTREGA.end ? row.DT_ENTREGA.end : '';
            row.CDPRODFINAL = preencheCaracterDireita(row.CDPRODFIN);
            row.CDFILIAL = widget.currentRow.UNIDADE.length !== "" ? concatArrayForParams(widget.currentRow.UNIDADE) : 'T';
            row.CDFILIAL1 = row.CDFILIAL;
            row.NRSOLICMP = widget.currentRow.SOLICITACAO.length !== "" ? concatArrayForParams(widget.currentRow.SOLICITACAO) : 'T';
            General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/sup00700_relatorio', reportName, row);
        }
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller', Sup00700_EmissaoDeSolicitacaoCotacaoAf_Controller);
});    

// FILE: ./assets/modules/fornecimento/assets/modules/listaPreco/assets/js/controllers/Cmp04502_EmissaoDaListaDePrecos_Controller.js
function Cmp04502_EmissaoDaListaDePrecos_Controller(General, ScreenService, localStorageEngine, MessageService) {

    this.onEnter = function(owner){
        setProdutoDefault(owner);
        
        owner.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
        owner.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY'); 
    };
    
    function setProdutoDefault(widget){
        const filter = [
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('NRORG')
            }    
        ];
        
        General.callRestEngine("cmp_fornecimento_listaPreco#/cmp04502_emissao_da_lista_de_precos_produto", "FilterData", filter).then(function(callback) {
            const { NMMIN, NMMAX, CDMIN, CDMAX } = callback.dataset.cmp04502_emissao_da_lista_de_precos_produto[0];
            
            widget.currentRow.NMPRODINI = NMMIN;
            widget.currentRow.NMPRODFIN = NMMAX;
            widget.currentRow.CDPRODINI = CDMIN;
            widget.currentRow.CDPRODFIN = CDMAX;
        });
    }

    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        
        return true;
    };
    
    function formataParametrosRelatorio(currentRow) {
        currentRow.COMPRADOR   = concatArrayForParams(currentRow.L_COMPRADOR);
        currentRow.FORNECEDOR  = concatArrayForParams(currentRow.L_FORNECEDOR);
        currentRow.P_CDPRODFIN = validaProdutoFinal(currentRow);
        currentRow.COMPRADOR1  = currentRow.COMPRADOR;
        currentRow.FORNECEDOR1 = currentRow.FORNECEDOR;
        currentRow.DTINI       = currentRow.DT_INTERVAL.start;
        currentRow.DTFIM       = currentRow.DT_INTERVAL.end;
    }
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        formataParametrosRelatorio(currentRow);
        
        General.openReport('cmp_fornecimento_listaPreco#/cmp04502_relatorio', reportName, currentRow);  
    };
    
    this.criaRelatorio = function(widget) {
        const reportName  = widget.currentRow.REPORT_NAME;
        
        if (!widget.isValid()) return;
        
        if (!this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) return;
        
        General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);
    };
    
    /*************
     * Utilities *
     *************/
    
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    function validaProdutoFinal(row) { 
        let prod;
        
        if (row.CDPRODFIN === undefined || row.CDPRODFIN === "") {
            prod = "";
        } else {
            const aux = 'ZZZZZZZZZZ';
            let str = row.CDPRODFIN;
            
            prod = str + aux.substr(0, aux.length - str.length); 
        }
        
        return prod;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04502_EmissaoDaListaDePrecos_Controller', Cmp04502_EmissaoDaListaDePrecos_Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/listaPreco/assets/js/controllers/Sup03000Controller.js
function Sup03000Controller(ScreenService, General, Sup03000Service, localStorageEngine, Parametros) {
    var centralCompra = false;
    var idutmenpreclt = false;
    var ajuste = 0;

    this.parametros = function() {
		Sup03000Service.retornaFilial().then(function(callback) {
		    var	unidade = callback.dataset.filial[0];
			centralCompra = unidade.CDFILCENTCMP ? unidade.CDFILCENTCMP : unidade.CDFILIAL;
			Parametros.parasupri(centralCompra).then(function(parasupri) {
				idutmenpreclt = parasupri.dataset.parasupri.length ? parasupri.dataset.parasupri[0].IDUTMENPRECLT : "N";
			});
		});
	};

    this.habilitaCampos = function(widget) {
        if (!widget.currentRow.NMFILIAL) {
            widget.getField('TODOSPROD').readOnly = true;
            widget.getField('TODOSPROD').validations = {};
        } else {
            widget.getField('TODOSPROD').readOnly = false;
            widget.getField('TODOSPROD').validations = {required: true};
        }
    };

    this.completaSemanaValidade = function(currentRow) {
        if (currentRow.DTFINVALCOL) {
            currentRow.SEMANAVALIDADE = moment(currentRow.DTFINVALCOL, "DD/MM/YYYY").week();
        } else {
            currentRow.SEMANAVALIDADE = " ";
        }
    };

    this.completaSemana = function(currentRow) {
        if (currentRow.DTINIVALITM) {
            currentRow.SEMANADTINI  = moment(currentRow.DTINIVALITM, "DD/MM/YYYY").week();
        }
        if (currentRow.DTFINVALITM) {
            currentRow.SEMANADTFIM = moment(currentRow.DTFINVALITM, "DD/MM/YYYY").week();
        }
    };

    this.listaSemanas = function(widget) {
        var currentRow = widget.currentRow;
        General.onClickDependentField(widget.getField('NMOPERADOR'), {CDFILIAL: centralCompra, DTFINVALCOL: currentRow.DTFINVALCOL, CDREGIAO: currentRow.CDREGIAO});
    };

    this.limpaCurrentRow = function(widget, field) {
        if(!widget.currentRow.field) {
            var fieldNames = ['NMOPERADOR', 'DTINIVALITM', 'DTFINVALITM', 'SEMANADTINI', 'SEMANADTFIM'];
            fieldNames.forEach(function(fieldName) {
                if ( (widget.getField(fieldName)) && (widget.getField(fieldName).value().length > 0) )
                    widget.getField(fieldName).setValue('');
            });
        }
    };

    this.filter = function(stripeWidget, filterWidget) {
        if(filterWidget.isValid()) {
            var cdfilial = filterWidget.currentRow.CDFILIAL ? filterWidget.currentRow.CDFILIAL : centralCompra;
            Sup03000Service.retornaAjuste(cdfilial, getLocalVar('NRORG')).then(function(callback){
                ajuste = callback.dataset.sup03000Ajuste.length ? callback.dataset.sup03000Ajuste[0].VRPERAJTFORNFIL : 0;
            });

            if(filterWidget.currentRow.NMFILIAL) {
                dataSourceFilter = [
                    { "name": "P_CDFILIAL", "value": filterWidget.currentRow.CDFILIAL, "operator": "=" },
                    { "name": "P_ORDPRPI",  "value": filterWidget.currentRow.ORDPRPI,  "operator": "="},
                    { "name": "P_SISTEMA",  "value": "CMP", "operator": "=" },
                ];
            } else {
                dataSourceFilter = [
                    { "name": "P_CDFILIAL", "value": centralCompra, "operator": "=" },
                    { "name": "P_ORDPRPI",  "value": filterWidget.currentRow.ORDPRPI, "operator": "=" },
                    { "name": "P_SISTEMA",     "value": "SUP", "operator": "=" },
                ];
            }

            var completaDataSourceFilter = [
                { "name": "P_DTINIVALITM", "value": filterWidget.currentRow.DTINIVALITM, "operator": "=" },
                { "name": "P_DTFINVALITM", "value": filterWidget.currentRow.DTFINVALITM, "operator": "=" },
                { "name": "P_CDREGIAO",    "value": filterWidget.currentRow.CDREGIAO,    "operator": "=" },
                { "name": "P_CDOPERADOR",  "value": filterWidget.currentRow.CDOPERADOR,  "operator": "="},
                { "name": "P_TODOSPROD",   "value": filterWidget.currentRow.TODOSPROD,   "operator": "="},
                { "name": "P_DTPROCESSA",  "value": '', "operator": "=" }
            ];

            dataSourceFilter = dataSourceFilter.concat(completaDataSourceFilter);
            filterWidget.getParent().dataSourceFilter = dataSourceFilter;
            filterWidget.getParent().reload();
            this.setaStripe(stripeWidget, filterWidget);
            ScreenService.closePopup();
        }
    };

    this.calculaAjuste = function(widget){
        var dados = widget.dataSource.data;
        var result;
        for (indice = 0; indice < dados.length; indice++) {
            if (idutmenpreclt == 'S') {
                result = dados[indice].VRPRECUNIITM - (dados[indice].VRPRECUNIITM * dados[indice].VRPERPIFORN / 100) + (dados[indice].VRPRECUNIITM * ajuste / 100);
            } else {
                result = dados[indice].VRPRECUNIITM + (dados[indice].VRPRECUNIITM * ajuste / 100);
            }
            dados[indice].PRECO = result.toString().replace('.', ',');
        }
    };

    this.retiraHoraData = function(widget) {
        var dataSourceWidget = widget.dataSource.data;

        for(var posicao in dataSourceWidget) {
            dataSourceWidget[posicao].DTFINVALITM = dataSourceWidget[posicao].DTFINVALITM.split(" ")[0];
            dataSourceWidget[posicao].DTINIVALITM = dataSourceWidget[posicao].DTINIVALITM.split(" ")[0];
        }
    };

    this.setaStripe = function(stripeWidget, filterWidget) {
        stripeWidget.getField('regiao').setValue(filterWidget.currentRow.CDREGIAO + ' - ' + filterWidget.currentRow.NMREGIAO);
        stripeWidget.getField('listaPreco').setValue(filterWidget.currentRow.NMOPERADOR);
        stripeWidget.getField('validade').setValue(filterWidget.currentRow.DTINIVALITM + ' a ' + filterWidget.currentRow.DTFINVALITM);

        if(filterWidget.currentRow.CDFILIAL) {
            stripeWidget.getField('unidade').isVisible = true;
            stripeWidget.getField('unidade').setValue(filterWidget.currentRow.CDFILIAL + ' - ' + filterWidget.currentRow.NMFILIAL);
        } else {
            stripeWidget.getField('unidade').isVisible = false;
            stripeWidget.getField('unidade').setValue('');
        }
    };

    this.prazoDePagamento = function(currentRow, widgetPagamento) {
        var cdfilial      = currentRow.CDFILIAL;
        var nrcolepreco   = currentRow.NRCOLEPRECO;
        var cdproduto     = currentRow.CDPRODUTO;
        var cdmarca       = currentRow.CDMARCA;
        var cdregiao      = currentRow.CDREGIAO;
        var cdfornecedor  = currentRow.CDFORNECED;

        Sup03000Service.retornaPrazoPagamento(cdfilial, nrcolepreco, cdproduto, cdmarca, cdregiao, cdfornecedor).then(function(callback) {
            widgetPagamento.dataSource.data = callback.dataset.sup03000pagamento;
            ScreenService.openPopup(widgetPagamento);
            widgetPagamento.container.getWidget('tab_sup03000_listaPreco').activate();
        });

    };

    this.voltarView = function(widgetMaster) {
        ScreenService.closePopup();
        widgetMaster.currentWidget = widgetMaster;
        widgetMaster.activate();
        widgetMaster.view();
    };
    
    this.fieldRegiaoOnChange = function(widget) {
        var fieldFilial = widget.getField('NMFILIAL');
        
        if (Util.isEmptyOrBlank(widget.getField('NMREGIAO').value())) {
            fieldFilial.readOnly = true;
            //fieldFilial.validations = {required: false};
        } else {
            fieldFilial.readOnly = false;
            //fieldFilial.validations = {required: true};
        }
        
        fieldFilial.setValue('');
        
        if(!fieldFilial.readOnly) {
            fieldFilial.dataSourceFilter[0].value = widget.currentRow.CDREGIAO;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup03000Controller', Sup03000Controller);
});

// FILE: ./assets/modules/fornecimento/assets/modules/migracaoAF/assets/js/controllers/MigracaoAFController.js
function MigracaoAFController(ScreenService, templateManager, General, maskEngine, ZhUtil, MessageService, ZHPromise) {
    
    const self = this;
    let paramVrUnit;

    this.getFilialdestino = function(field){
        field.dataSourceFilter = [
			{'name': 'P_CDGRUPFILI', 'operator': '=', 'value': field.widget.currentRow.CDGRUPFILI},
			{'name': 'P_CDCENTCMP',  'operator': '=', 'value': getLocalVar('CDFILCENTCMP')},
			{'name': 'P_CDOPERADOR',  'operator': '=', 'value': getLocalVar('CDOPERADOR')},
			{'name': 'NRORG',  'operator': '=', 'value': getLocalVar('NRORG')}
		];
		field.reload();
    };
    
    this.openFiltro = function(widget){
        const widgetFiltro = widget.container.getWidget('sup98000_filtroMigracaoAF');
        
        MessageService.getMessageByCode("cmp#VR_UNIT").then(function(vrUnit) {
            paramVrUnit = {
                PARAMS: '\"'.concat(vrUnit, '\"')
            };
            General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
                setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
                setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
                
                ScreenService.openPopup(widgetFiltro);
                
            }, function(error) {
    			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
    		});
        });
    };
    
    this.setProdFinalMin = function(widget){
        let nmprodfin = widget.getField('NMPRODFIN');
        
        changeProduct(widget);
        if(widget.currentRow.CDPRODINI){
            nmprodfin.dataSourceFilter = [
                {"name": "CDARVPROD",    "value": widget.currentRow.CDPRODINI, "operator": ">="},
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
                {"operator": "ORDER_BY", "name": [{"name": "CDARVPROD", "direction": "ASC"}]}
            ];
        } else {
            nmprodfin.dataSourceFilter = [
                {"name": "NRORG",       "value": getLocalVar('NRORG'),         "operator": "="},
                {"operator": "ORDER_BY", "name": [{"name": "CDARVPROD", "direction": "ASC"}]}
            ];  
        }
        nmprodfin.reload();
    };
    
    this.fecharFiltro = function(widget){
        ScreenService.closePopup();
        ScreenService.closeSwipe(0);
        widget.activate();
    };
    
    function validaProduto(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("cmp#PRODUTO_INICIAL_MENOR_IGUAL_FINAL", {}, {
                type: 'INFORMATION'
            });
            return false;
        }
        return true;
    }
    
    function changeProduct(widget) {
        if (widget.getField('NMPRODINI').value() || widget.getField('NMPRODFIN').value()){
            widget.getField('NMPRODINI').validations = { "required" : true };
            widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        }    
    }
    
    this.changeRequired = function(widget){
        changeProduct(widget);
    };
    
    this.getFornecedoresGrid = function(widget){
    	const widgetForn = widget.container.getWidget('sup98000_gridFornecedorAF');
    	const widStripe  = templateManager.container.getWidget('sup98000_stripeWidget');
        
        if (widget.isValid()) {
    	    if(validaProduto(widget.currentRow.NMPRODINI, widget.currentRow.NMPRODFIN)){
    	        setDtAutoForn(widget);
                setDtProgEntAF(widget);
                setFiltroProduto(widget);
                        
                setLocalVar('IDTPGERARUP', widget.currentRow.exibeRupturaOL);
        	    setLocalVar('CDPRODINI', widget.currentRow.CDPRODINI);
            	setLocalVar('CDPRODFIN', widget.currentRow.CDPRODFIN);
            	setLocalVar('DTPROGENTAFINI', widget.currentRow.DTPROGENTAFINI);
        		setLocalVar('DTPROGENTAFFIN', widget.currentRow.DTPROGENTAFFIN);
                
                widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
                General.callRestEngine('cmp_fornecimento_migracaoAF#/migracaoAF', 'Row', widget.currentRow).then(function(callback) {
    			    widgetForn.dataSource.data = callback.dataset.resposta;
    			    
    			    widStripe.currentRow.NMGRUPFILI_STRIPE  = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : "Não informado.";
    			    widStripe.currentRow.RUPTURA_STRIPE     = widget.currentRow.exibeRupturaOL === "S" ? "Sim" : "Não";
    			    widStripe.currentRow.DTAF_STRIPE        = widget.currentRow.DTAUTFINI && widget.currentRow.DTAUTFFIN ? widget.currentRow.DTAUTFINI + " a " + widget.currentRow.DTAUTFFIN : "Não informado.";
    			    widStripe.currentRow.DTENTREGA_STRIPE   = widget.currentRow.DTPROGENTAFINI && widget.currentRow.DTPROGENTAFFIN ? widget.currentRow.DTPROGENTAFINI + " a " + widget.currentRow.DTPROGENTAFFIN : "Não informado.";
                    if(widget.currentRow.CDPRODINI && widget.currentRow.CDPRODFIN){
                        let mask = {
                			type: "fix",
                			params: {
                				mask: getLocalVar('CDPICTPROD')
                			}
                		};
                		widStripe.currentRow.PRODUTO_STRIPE = Util.applyMask(widget.currentRow.CDPRODINI, mask, maskEngine, ZhUtil) + " - " + widget.currentRow.NMPRODINI + " a " + Util.applyMask(widget.currentRow.CDPRODFIN, mask, maskEngine, ZhUtil) + " - " + widget.currentRow.NMPRODFIN;
                    } else {
                        widStripe.currentRow.PRODUTO_STRIPE = "Não informado.";    
                    }
                    
    			    ScreenService.closePopup();
    		        widgetForn.reload();
    				widgetForn.activate();
                });   
    	    }
		}
    };
    
    var setDtAutoForn = function(widget){
        if(widget.currentRow.INTERVAL_DTAUTOFORN) {
            widget.currentRow.DTAUTFINI = widget.currentRow.INTERVAL_DTAUTOFORN.start;
            widget.currentRow.DTAUTFFIN = widget.currentRow.INTERVAL_DTAUTOFORN.end;
        } else {
            widget.currentRow.DTAUTFINI = null;
            widget.currentRow.DTAUTFFIN = null;
        }    
    };
    
    var setDtProgEntAF = function(widget){
        if(widget.currentRow.INTERVAL_DTPROGENTAF) {
            widget.currentRow.DTPROGENTAFINI = widget.currentRow.INTERVAL_DTPROGENTAF.start;
            widget.currentRow.DTPROGENTAFFIN = widget.currentRow.INTERVAL_DTPROGENTAF.end;
        } else {
            widget.currentRow.DTPROGENTAFINI = null;
            widget.currentRow.DTPROGENTAFFIN = null;
        }    
    };
    
    var setFiltroProduto = function(widget) {
        if(!widget.currentRow.CDPRODINI){
            widget.currentRow.CDPRODINI = null;
        }
        if(!widget.currentRow.CDPRODFIN){
            widget.currentRow.CDPRODFIN = null;
        }
    };
    
    this.openProdutoAF = function(widget){
        var widgetTabbed  = widget.container.getWidget('sup98000_tabbedProdutoAF');
        var widgetProdutoAF = widget.container.getWidget('sup98000_gridProdutoAF');
        widgetProdutoAF.dataSourceFilter = dsFilterProdutoAF(widget);
		widgetProdutoAF.reload().then(function(callback){
			ScreenService.openSwipe(widgetTabbed).then(function() {
				widgetProdutoAF.activate();
			});
		});
    };
    
    this.selectRowProdutoAF = function(widget){
        var widgetFornAF = widget.container.getWidget('sup98000_gridFornecedorAF');
        var widgetProdAF = widget.container.getWidget('sup98000_gridProdutoAF');
        if(widgetProdAF && widgetProdAF.dataSource.data && widgetProdAF.dataSource.data.length){
            widgetProdAF.dataSource.data.forEach(function(row){
                row.__isSelected = true;
            });
        }
        this.fechaSwipe(widgetFornAF);
    };
    
    var dsFilterProdutoAF = function(widget){
        var widgetFiltro = widget.container.getWidget('sup98000_filtroMigracaoAF');
        var filterProd = [
			{name: "P_CDFILDEST",       value: widget.currentRow.CDFILDEST            || '', operator: "="},
			{name: "P_CDFILLANC",       value: widget.currentRow.CDFILLANC            || '', operator: "="},  
			{name: "P_NRAUTOFORN",	    value: widget.currentRow.NRAUTOFORN           || '', operator: "="},  
			{name: "P_CDPRODINI",	    value: widgetFiltro.currentRow.CDPRODINI      || '', operator: "="},
			{name: "P_CDPRODFIN",	    value: widgetFiltro.currentRow.CDPRODFIN	  || '', operator: "="},
			{name: "P_DTPROGENTAFINI",	value: widgetFiltro.currentRow.DTPROGENTAFINI || '', operator: "="},
			{name: "P_DTPROGENTAFFIN",	value: widgetFiltro.currentRow.DTPROGENTAFFIN || '', operator: "="},
			{name: "P_IDTPGERARUP",	    value: getLocalVar('IDTPGERARUP')             || '', operator: "="},
			{name: "NRORG",             value: getLocalVar('NRORG')	                  || '', operator: "="}
		];
		return filterProd;    
    };
    
    this.fechaSwipe = function(widgetActivate){
        ScreenService.closeSwipe();
        widgetActivate.activate();
        widgetActivate.redraw();
    };
    
    this.cancelaMigracao = function(widget){
        ScreenService.closeSwipe();
        widget.container.getWidget(widget.container.getWidget('sup98000_gridConfirmaMigracaoAF').widgetOrigem).activate();
    };
    
    this.backToList = function(widget){
		 widget.list();
		 ScreenService.closeSwipe();
		 widget.activate();
	};
	
	this.setConfirmaMigracao = function(widget){
	    var widgetForn  = widget.container.getWidget('sup98000_pesquisaForn');
        widgetForn.currentRow = {};
        widget.container.getWidget('sup98000_gridConfirmaMigracaoAF').widgetOrigem = widget.name;
        var fieldForn = widgetForn.getField('NMFANTFORN');
        fieldForn.dataSourceFilter = dsFilterPesqForn(widget); 
		fieldForn.reload().then(function(callback){
			ScreenService.openPopup(widgetForn);
		});
    };
    
    var dsFilterPesqForn = function(widget){
        var filterForn = [
			{name: "P_CDFILIAL", value: getLocalVar('CDFILCENTCMP') || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filterForn;
    };
    
    var preencheRowFiltro = function(rows, widget){
        rows.forEach(function(row) {
            row.IDTPGERARUP    = getLocalVar('IDTPGERARUP');
            row.CDPRODINI      = getLocalVar('CDPRODINI');
            row.CDPRODFIN      = getLocalVar('CDPRODFIN');
            row.DTPROGENTAFINI = getLocalVar('DTPROGENTAFINI');
            row.DTPROGENTAFFIN = getLocalVar('DTPROGENTAFFIN');
            row.CDOPERADOR     = getLocalVar('CDOPERADOR');
            row.CDFILCENTCMP   = getLocalVar('CDFILCENTCMP');
            row.CDOPERADOR     = getLocalVar('CDOPERADOR');
            
            row.NEW_CDFORNECED     = widget.currentRow.CDFORNECED;
            row.NEW_NRINSJURFORN   = widget.currentRow.NRINSJURFORN;
            row.NEW_IDTPIJURFORN   = widget.currentRow.IDTPIJURFORN;
            row.NEW_NMFANTFORN     = widget.currentRow.NMFANTFORN;
            row.NEW_NMRAZSOCFORN   = widget.currentRow.NMRAZSOCFORN;
            row.NEW_IDGERAFDTENT   = widget.currentRow.IDGERAFDTENT;
            
            widget.container.getWidget('sup98000_gridFornecedorAF').getField('IDUTLPROCMPAF').dataSource.data.forEach(function(p){
				if(p.CDFILIAL == getLocalVar('CDFILCENTCMP')){
					row.IDUTLPROCMPAF  = p.IDUTLPROCMPAF;	
				}	
			});
        });
        return rows;
    };
    
    this.setCriaConfirmacao = function(widget){
        if(widget.currentRow.NMFANTFORN.length > 0){
            var widgetFornAF = widget.container.getWidget('sup98000_gridFornecedorAF');
            var widgetProdAF = widget.container.getWidget('sup98000_gridProdutoAF');
            var widgetTabbed = widget.container.getWidget('sup98000_tabbedConfirmaMigracaoAF');
            var widgetConfAF = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
            var allProducts = widgetFornAF.isLastActiveWidget();
            var row;
            var itens;
            
            ScreenService.closePopup();
            if(allProducts){
                itens = widgetFornAF.dataSource.getCheckedRows();
                itens = preencheRowFiltro(itens, widget);
    
            } else{
                itens = widgetProdAF.dataSource.getCheckedRows();
                itens = preencheRowFiltro(itens, widget);
                itens.forEach(function(item){
                    item.__isSelected   = false;
                    item.DTAUTOFORN     = widgetFornAF.currentRow.DTAUTOFORN;
                    item.IDTIPOEMITAF   = widgetFornAF.currentRow.IDTIPOEMITAF;
                    item.CDEMPRESA      = widgetFornAF.currentRow.CDEMPRESA;
                    item.IDAFOPERLOG    = widgetFornAF.currentRow.IDAFOPERLOG;
                    item.CDFORNECED_OLD = widgetFornAF.currentRow.CDFORNECED;
                    item.CDFORNOPELOG   = widgetFornAF.currentRow.CDFORNOPELOG;
                    item.CDFILIOPELOG   = widgetFornAF.currentRow.CDFILIOPELOG;
                    item.IDTIPOLANCAF   = widgetFornAF.currentRow.IDTIPOLANCAF;
                });
                
            }
            
            row = [ [ allProducts ], itens ];
            
            General.callRestEngine('cmp_fornecimento_migracaoAF#/confirmaMigracao', 'DataSet', row).then(function(callback) {
        		widgetConfAF.dataSource.data = callback.dataset.resposta;
        		widgetConfAF.reload();
        		ScreenService.openSwipe(widgetTabbed).then(function() {
    				$('.swipe-tip').before('<div style="position: absolute;left: 0;top: 0;bottom: 0;right: 0;opacity: 0.6;transform: translate(-100%, 0);-webkit-transform: translate(-100%, 0);"></div>');
    				widgetConfAF.activate();  
    			});
    		});
        }
    };
    
    this.editarConfMigracao = function(widget){
		General.edit(widget);
    	var fieldFornOL = widget.container.getWidget('sup98000_gridFornecedorAF').getField('CDFILIOPELOG');
    	fieldFornOL.dataSourceFilter = dsFilterPesqFornecedorOL(widget); 
		fieldFornOL.reload().then(function(callback){
		    var fieldProduto = widget.getField('NMPRODUTO');
		    fieldProduto.dataSourceFilter = dsFilterPesqProduto(widget, callback, null); 
		    fieldProduto.reload().then(function(callback){
		        self.getMarcaProduto(widget);
		    });
		});
    };
    
    this.cancelConfMigracao = function(args){
        var widget = args.owner.widget;
        General.backOrCancel(args);
        this.fechaSwipe(widget.container.getWidget('sup98000_gridConfirmaMigracaoAF'));
    };
    
    var dsFilterPesqFornecedorOL = function(widget){
        var filter = [
			{name: "P_CDFORNOPELOG", value: widget.currentRow.CDFORNECED || '', operator: "="},
			{name: "P_CDFILDEST", value: widget.currentRow.CDFILDEST || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    var dsFilterPesqProduto = function(widget, callback, cdarvprod){
        var fornOpeLog = null;
        if(callback.dataset.sup98000_fornecedorOL.length > 0){
            fornOpeLog = callback.dataset.sup98000_fornecedorOL[0].CDFORNOPELOG;   
        }
        var filter = [
			{name: "P_CDFILCENTCMP", value: getLocalVar('CDFILCENTCMP') || '', operator: "="},
			{name: "P_CDPRODOLD", value: widget.currentRow.CDPRODUTO_OLD || '', operator: "="},
			{name: "P_CDFORNECED", value: widget.currentRow.CDFORNECED || '', operator: "="},
			{name: "P_CDFORNOPELOG", value: fornOpeLog || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    this.getMarcaProduto = function(widget){
		var fieldMarca = widget.getField('NMMARCA');
	    fieldMarca.dataSourceFilter = dsFilterPesqMarcaProduto(widget); 
	    fieldMarca.reload().then(function(callback){
	        if(widget.currentRow.CDARVPROD != '' && widget.currentRow.CDPRODUTO != widget.currentRow.CDPRODUTO_OLD){
	        	self.NovoPreco(widget);
	    	}   
	    });
    };
    
    var dsFilterPesqMarcaProduto = function(widget){
        var filter = [
			{name: "P_CDARVPROD", value: widget.currentRow.CDARVPROD || '', operator: "="},
			{name: "NRORG",      value: getLocalVar('NRORG') || '', operator: "="}
		];
		return filter;
    };
    
    this.changeDtEntrega = function(widget){
        if(widget.currentRow.DTPROGENTAF != '' && widget.currentRow.DTPROGENTAF != widget.currentRow.DTPROGENTAF_OLD){
            validaDtEntrega(widget);
        }
    };
    
    this.NovoPreco = function(widget){
	    widget.dataSource.data.forEach(function(value) {
            value.CDFORNECED  = widget.currentRow.CDFORNECED;
            value.CDFILDEST   = widget.currentRow.CDFILDEST;
            value.CDPRODUTO   = widget.currentRow.CDPRODUTO;
            value.CDMARCA     = widget.currentRow.CDMARCA;
            value.DTPROGENTAF = widget.currentRow.DTPROGENTAF;
        });
    	General.callRestEngine('cmp_fornecimento_migracaoAF#/novoPreco', 'DataSet', widget.dataSource.data).then(function(callback) {
    	    if(callback.dataset.resposta.length > 0){
    	        widget.currentRow.VRPREUNIAF = callback.dataset.resposta[0].VRPRECUNIITM;    
    	    } else {
    	        widget.currentRow.VRPREUNIAF = 0;    
    	    }
        });
    };
    
    var validaDtEntrega = function(widget){
        const dataEntrega = widget.currentRow.DTPROGENTAF;
        const prtDataEntrega = dataEntrega.split("/");
        const widgetMigracao = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
      
        if(dataEntrega < new Date(prtDataEntrega[2], prtDataEntrega[1] - 1, prtDataEntrega[0])) {
            MessageService.showMessageByCode("cmp#DELIVERY_DATE_GREATER_EQUAL_CURRENT", {}, {
                type: 'INFORMATION'
            });
        } else {
            const params = {
                PARAMS: widget.currentRow.DTPROGENTAF
            };

            MessageService.confirmMessageByCode("cmp#CHANGE_OTHER_DELIVERES", params, 'question').then(function(success) {
                widgetMigracao.dataSource.data.forEach(function(af){
                    af.DTPROGENTAF = widget.currentRow.DTPROGENTAF;
                    self.NovoPreco(widget);
                });
            });
        }
    };
    
    function validaVrUnit(rows) {
        let result = true;
        rows.forEach(function(row) {
            row.VRPREUNIAF = General.valueToFloat(row.VRPREUNIAF ? row.VRPREUNIAF : 0);
            if (parseFloat(row.VRPREUNIAF) == 0) {
                result = false;
            }
        });
        return result;
    }
    
    function validaDataEntrega(rows){
        const currentDate = moment(moment(), 'L').format('L');
        let result = true;

        rows.forEach(function(row){
            if(currentDate > moment(row.DTPROGENTAF, 'L').format('L')){
                result = false;
            }
        });
        return result;
    }
    
    function validaEntregaPorFornecedor(rows){
        const firstDate = moment(rows[0].DTPROGENTAF, 'L').format('L');
        let result = true;

        if(rows.length > 1){
            rows.forEach(function(row){
                if(row.IDGERAFDTENT == 'S'){
                    if(moment(row.DTPROGENTAF, 'L').format('L') != firstDate){
                        result = false;
                    }
                }
            });
        }
        return result;
    }
    
    function verificaDataIgual(rows) {
        let count = 0;
        
        rows.forEach(function(row){
            if(row.DTPROGENTAF == row.DTPROGENTAF_OLD){
                count = count + 1;    
            }
        });
        return count == 0;
    }
    
    function validaQuantidade(rows) {
        let result = true;
        
        rows.forEach(function(row){
            row.QTPROGENTAF = General.valueToFloat(row.QTPROGENTAF ? row.QTPROGENTAF : 0);
            if(parseFloat(row.QTPROGENTAF) == 0){
                result = false;
            }    
        });
        return result;
    }
    
    this.migracaoAF = function(widget){
        const rows = widget.dataSource.data;
        
        if(!validaVrUnit(rows)) {
            MessageService.showMessageByCode("cmp#VALUE_FIELD_N_INFORMED", paramVrUnit, {type: 'ERROR'});
            return false;
        }
        
        if(!validaDataEntrega(rows)) {
            MessageService.showMessageByCode("cmp#DELIVERY_DATE_GREATER_EQUAL_CURRENT", {}, {type: 'ERROR'});
            return false;
        }
        
        if(!validaEntregaPorFornecedor(rows)) {
            MessageService.showMessageByCode("cmp#SOMENTE_UMA_DTPROGENTAF", {}, {type: 'ERROR'});
            return false;
        }
        
        if(!validaQuantidade(rows)) {
            MessageService.showMessageByCode("cmp#ONE_OR_MORE_QT_ZERO", {}, {type: 'ERROR'});
            return false;    
        }
        
        if(!verificaDataIgual(rows)) {
            MessageService.confirmMessageByCode("cmp#DELIVERY_DATE_EQUAL_ORIGINAL", 'question').then(function(success) {
                self.inLineMigracaoAF(widget);
            });    
        } else {
            self.inLineMigracaoAF(widget);
        }
    };
    
    this.inLineMigracaoAF = function(widget){
        const widgetMigracao = widget.container.getWidget('sup98000_gridConfirmaMigracaoAF');
        const widgetPesqForn = widget.container.getWidget('sup98000_pesquisaForn');
        const widgetResult = widget.container.getWidget('sup98000_resultado');
        const rows = widgetMigracao.dataSource.data;
        const arrayError = preencheArrayError();
        let promises = [];
        
        if(widget.isValid()){
            arrayError.forEach(function(row) {
                var messagePromise = MessageService.getMessageByCode('cmp#'.concat(row.codeError)).then(function(message) {
                    row.msgError = message;
                });
                promises.push(messagePromise);            
            });
            
            ZHPromise.all(promises).then(function() {
                setTimeout(function() {
                    let params = {
                        'MESSAGES': arrayError,
                        'PRODUTOS': rows,
                        'FORNECEDOR': widgetPesqForn.currentRow
                    };

                    General.callRestEngine('cmp_fornecimento_migracaoAF#/finalizaMigracao', 'DataSet', params).then(function(callback) {
                        if(callback.dataset.resposta.length > 0) {
                            if(callback.dataset.resposta[0].DSERROR != null){
                                var widgetResult = widget.container.getWidget('sup98000_resultado');
                                var arrayError = preencheArrayError();
                                callback.dataset.resposta.forEach(function(error){
                                    arrayError.forEach(function(msg){
                                        if(msg.CODE == error.DSERROR){
                                            error.DSERROR = msg.DSERROR;
                                        }
                                    });
                                });
                                widgetResult.dataSource.data = callback.dataset.resposta;
                                widgetResult.widgetOrigem = widgetMigracao;
                                ScreenService.openPopup(widgetResult);
                                widgetResult.activate();
                            } else {
                                if(callback.dataset.resposta[0] != '          '){
                                    const params = {
                                        PARAMS: callback.dataset.resposta[0]
                                    };

                                    MessageService.successNotificationByCode("cmp#SUCCESS_MIGRACAO", params).then(function(){
                                        ScreenService.closeSwipe(0);
                                        self.getFornecedoresGrid(widget.container.getWidget('sup98000_filtroMigracaoAF'));    
                                    });
                                    

                                }
                            }
                        }
                    });
                }, 350);
            });
        }
    };
    
    var preencheArrayError = function(){
        const arrayError = [
            {'codeError': 'ProdNCad'},
            {'codeError': 'Prod_est'},
            {'codeError': 'ProdEstoInval'},
            {'codeError': 'PesqMarcaProd'},
            {'codeError': 'Produto_Inativo'},
            {'codeError': 'Marc_NQualif'},
            {'codeError': 'N_MarcProd'},
            {'codeError': 'N_ProdFornComp'},
            {'codeError': 'N_RefoReg'},
            {'codeError': 'MarcaObrig'},
            {'codeError': 'MarcaPref'},
            {'codeError': 'RestricMarca'},
            {'codeError': 'ProdPref'},
            {'codeError': 'DT_Prod_Inv'},
            {'codeError': 'PeriForn'},
            {'codeError': 'ProdComprador'}
        ];
        return arrayError;
    };
    
    this.fechaPopup = function(widget){
        ScreenService.closePopup();
        widget.widgetOrigem.activate();
    };
    
    this.saveRowOnForm = function(args){
        if(args.owner.widget.isValid()) {
            General.saveRow(args, true);
        }   
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MigracaoAFController', MigracaoAFController);
});    

// FILE: ./assets/modules/fornecimento/assets/modules/emissaoAF/assets/js/controllers/Sup00800AfsInconsistenteForaLimiteController.js
function Sup00800AfsInconsistenteForaLimiteController(ScreenService, MessageService, templateManager, General) {
    this.setDataEntregaDefault = function(widget) {
        if (Util.isEmptyOrBlank(widget.currentRow.DATAENTREGA)) {
            widget.currentRow.DATAENTREGA = { 
                'formattedStart': moment().format('L'),
                'formattedEnd': moment().format('L'), 
                'start': moment().format('L'), 
                'end': moment().format('L') 
            };
        }
    };
    
    this.verificaAgrupamento = function(field) {
        if (field.widget.getField('NMGRUPFILI').value()) {
            field.dataSource.name = "cmp_fornecimento_emissaoAF#/crud/filial_por_agrupamento";
            field.dataSourceFilter = [{
                "name": "P_CDGRUPFILI",
                "operator": "=",
                "value": field.widget.currentRow.CDGRUPFILI
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
            ];
        } else {
            field.dataSource.name = "cmp_fornecimento_emissaoAF#/crud/filial_sem_agrupamento";
            field.dataSourceFilter = [{
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }];
        }
        
        field.reload();
    };
    
    this.criaRelatorio = function(widget) {
        var reportName = widget.currentRow.RELATORIO;
        if (widget.isValid()) {
            var row = Util.clone(widget.currentRow);
           

            row.P_DATAINI1 = row.DATAENTREGA.start;
            row.P_DATAINI2 = row.DATAENTREGA.start;
            row.P_DATAFIN1 = row.DATAENTREGA.end;
            row.P_DATAFIN2 = row.DATAENTREGA.end;
            row.P_NRAUTOFORN1 = 'T';
            row.P_NRAUTOFORN2 = 'T';
            row.P_CDOPERADOR = getLocalVar('CDOPERADOR');
            row.P_CDGRUPFILI1 = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T';
            row.P_CDGRUPFILI2 = widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T';
            row.L_CDFILDEST1 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST2 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST3 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDFILDEST4 = !Util.isEmptyOrBlank(widget.getField('CDFILIAL').value()) ? widget.getField('CDFILIAL').value().join("_") : 'T'; // Filtro de filial. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDREGIAO1 = !Util.isEmptyOrBlank(widget.getField('CDREGIAO').value()) ? widget.getField('CDREGIAO').value().join("_") : 'T'; // Filtro de região. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDREGIAO2 = !Util.isEmptyOrBlank(widget.getField('CDREGIAO').value()) ? widget.getField('CDREGIAO').value().join("_") : 'T'; // Filtro de região. Passar as selecionadas concatenadas em um string e separadas por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDOPERADOR1 = !Util.isEmptyOrBlank(widget.getField('CDOPERADOR').value()) ? widget.getField('CDOPERADOR').value().join("_") : 'T'; // Filtro de operador. Passar os selecionados concatenados em um string e separados por underline. caso o filtro esteja vazio passar 'T'
            row.L_CDOPERADOR2 = !Util.isEmptyOrBlank(widget.getField('CDOPERADOR').value()) ? widget.getField('CDOPERADOR').value().join("_") : 'T'; // Filtro de operador. Passar os selecionados concatenados em um string e separados por underline. caso o filtro esteja vazio passar 'T'
            row.P_NRORG = getLocalVar('NRORG');

            General.openReportPopup(widget, this.abreRelatorio, [widget, row, reportName]);
        } else {
            MessageService.showMessageByCode("cmp#TODOS_CAMPOS_OBRIGATORIOS"); 
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.QR2TYPE = templateManager.container.getActiveWidget().currentRow.QR2TYPE;
        General.openReport('cmp_fornecimento_emissaoAF#/sup00800_relatorio', reportName, row); 
    };
    
    this.onChangeAgrupamento = function(){
        var field = templateManager.container.getWidget('inconsistente_fora_limite').getField('CDFILIAL');
        field.clearValue();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup00800AfsInconsistenteForaLimiteController', Sup00800AfsInconsistenteForaLimiteController);
});


// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller.js
function Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller(General, ScreenService, localStorageEngine, ZhFilterPreferences, Utilities, MessageService) {
    this.widgetOnEnter = function(widget) {
        const filialField = widget.getField("CDFILIAL");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            var filterRow = {
        	    INTERVALO_DATA : {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILIAL: [ getLocalVar("CDFILIAL") ],
        	    NMFILIAL: [ getLocalVar("NMFILIAL") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILIAL = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.cmp03200_filial_movopsol.forEach(function(filial) {
                        if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete filterRow.CDFILIAL;
                        delete filterRow.NMFILIAL;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp03200_filial_movopsol.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_MOVOPSOL", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILIAL;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
            
            if (widget.OPENED) {
                delete widget.OPENED;
                
                widget.getAction('back_alt_automatica').isVisible = true;
                
                widget.dataSourceFilter = [];
                widget.dataSource.reload().then(function() {
                    widget._filterInfo = [];
                    widget.container.getWidget('stripe').getField('UNIDADE').label = ScreenService.i18n('Unidade Solicitante: ');
                    widget.container.getWidget('stripe').getField('PERIODO').label = ScreenService.i18n('Período: ');
                });
            } else {
                widget.getAction('back_alt_automatica').isVisible = false;
            }
            
            Utilities.startFilter(widget, filterRow);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };
    
    this.setFilterInitValues = function(widget){
        var filterRow = {
            'NMFILIAL': getLocalVar('NMFILIAL'),
            'INTERVALO_DATA': {
                'start': moment().format('L'),
                'end': moment().format('L')
            }
        };
        
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
        return defaultValue;
    }
    
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        const filterPopupCurrentRow = args.row;
        
        if (!(this.validaProduto(filterPopupCurrentRow.CDARVPRODINI, filterPopupCurrentRow.CDARVPRODFIN))){
            if (field.name == 'NMPRODINI') {
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.CDARVPRODINI = '';
                filterPopupCurrentRow.NMPRODINI = '';
            } else {
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.CDARVPRODFIN = '';
                filterPopupCurrentRow.NMPRODFIN = '';
            }
        }
    };
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", "ERROR");
                return false;
            }
        }

        return true;
    }; 
    this.readOnlyProduto = function(widget) {
        if (!widget.getField('NMPRODINI').value() && !widget.getField('NMPRODFIN').value()) {
            widget.getField('NMPRODINI').validations = {};
            widget.getField('NMPRODFIN').validations = {};
        }
        else {
            widget.getField('NMPRODINI').validations = {
                "required": true
            };
            widget.getField('NMPRODFIN').validations = {
                "required": true
            };
        }
    };
    
    this.setStripe = function(widget, filterRow){
     
    	var filial = filterRow.NMFILIAL == "@getLocalVar('NMFILIAL')@" ? getLocalVar('NMFILIAL') : filterRow.NMFILIAL;
    	widget.container.getWidget('stripe').getField('UNIDADE').label = ScreenService.i18n('Unidade Solicitante: ') + filial;
        widget.container.getWidget('stripe').getField('PERIODO').label = ScreenService.i18n('Período: ') + filterRow.INTERVALO_DATA.start + ' à '  + filterRow.INTERVALO_DATA.end;
    
        widget._filterInfo = [
            {"label": ScreenService.i18n("Unidade "), "value": filterRow.CDFILIAL.join(',')},    
            {"label": ScreenService.i18n("Dt. Entrega"), "value": filterRow.INTERVALO_DATA.start + ' à '  + filterRow.INTERVALO_DATA.end},         
            {"label": ScreenService.i18n("Produto Inicial"), "value": filterRow.NMPRODINI ? filterRow.NMPRODINI : ScreenService.i18n("Todos")},             
            {"label": ScreenService.i18n("Produto Final"), "value": filterRow.NMPRODFIN  ? filterRow.NMPRODFIN : ScreenService.i18n("Todos")}               
        ];
    };
    
    /**
     * Define o CUSTOM_FILTER_ROW vazio para evitar que o filtro do Zeedhi
     * seja aplicado com os valores do FILTER_ROW
     */
    this.trataFiltroBeforeApply = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = [];
    };
    
    this.filtrar = function(args) {
        var widget = args.owner,
            filterRow = args.e.preference.FILTER_ROW;

        // if (widget.isValid() && this.validaProduto(row.CDPRODINI,row.CDPRODFIN, widget)) {

            //this.setStripe(widget, filterRow);
         

            filterRow.CDPRODINI = filterRow.CDPRODFIN ? filterRow.CDARVPRODINI : null;
            filterRow.CDPRODFIN = filterRow.CDPRODFIN ? preencheCaracterDireta(filterRow.CDARVPRODFIN) : null;

            widget.dataSourceFilter = [
                {
                    "name": "CDFILSOLMOV",
                    "operator": "=",
                    "value": concatArrayForParams(filterRow.CDFILIAL)
                },
                {
                    "name": "PRODINI",
                    "operator": "=",
                    "value": filterRow.CDPRODINI
                },
                {
                    "name": "PRODFIN",
                    "operator": "=",
                    "value": filterRow.CDPRODFIN
                },
                {
                    "name": "DENTRINI",
                    "operator": "=",
                    "value": filterRow.INTERVALO_DATA.start
                },
                {
                    "name": "DENTRFIN",
                    "operator": "=",
                    "value": filterRow.INTERVALO_DATA.end
                },
                {
                    "name": "SOLEXC",
                    "operator": "=",
                    "value": filterRow.SOLEXC
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                },
                {
                    "name": "P_TCDPRODUTO",
                    "operator": "=",
                    "value": (filterRow.CDPRODINI && filterRow.CDPRODFIN) ? null : 'T' 
                },
                {
                    "name": "P_CDOPERADOR",
                    "operator": "=",
                    "value": getLocalVar("CDOPERADOR")
                }
            ];
            ScreenService.closePopup();
            widget.activate();
            widget.reload();
        
    };

    function preencheCaracterDireta(string) {
        var pad = 'ZZZZZZZZZZZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);
    }
    
    this.voltarParaAlteracaoAutomatica = function() {
        ScreenService.goBack();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller', Cmp03200_AlteracaoNosProdutosDaSolicitacao_Controller);
});


// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController.js
function Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController(General, ScreenService, localStorageEngine, MessageService) {

    // var listaUnidades = '';
    // var listaComprador = '';
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function concatProdutoFinal(value) {
        const pad = 'ZZZZZZZZZZ';
        
        return value + pad.substr(0, pad.length - value.length);
    }
    
    this.initialValidations = function (widget) {
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("CDFILIAL");
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.filial_filioper_regiao.forEach(function(filial) {
                        if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete widget.currentRow.CDFILIAL;
                        delete widget.currentRow.NMFILIAL;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.filial_filioper_regiao.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.CDFILIAL;
    	                    delete widget.currentRow.NMFILIAL;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
    };
    this.criaRelatorio = function(widget) {
        const reportName = widget.currentRow.CD_REPORT_NAME;
        
        if (widget.isValid() && this.validaProduto(widget.currentRow.CDARVPRODINI, widget.currentRow.CDARVPRODFIN)) {
            General.openReportPopup(widget, this.abreRelatorio, [widget, reportName] );
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            return true;
        }
        MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
        return false;
    };
    
    this.abreRelatorio = function(widget, reportName) {
        const row = angular.copy(widget.currentRow);
        
        row.CDOPERADOR = concatArrayForParams(row.CDOPERADOR, "T");
        row.CDFILIAL = concatArrayForParams(row.CDFILIAL, "T");
        row.CDPRODFIN1 = row.CDARVPRODFIN;
        row.CDPRODFIN  = concatProdutoFinal(row.CDARVPRODFIN);
        delete row.NMFILIAL;
       
        General.openReport("cmp_relatorio#/cmp04800_relatorio", reportName, row);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController', Cmp04800_FormularioDeLacamentoDeSolicitacoesDeComprasController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller.js
function Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller(General, ScreenService, localStorageEngine, MessageService) {

    var self = this;

    this.limpaFieldUnidades = function(fieldUnidades) {
        fieldUnidades.setValue([]);
    };
    
    this.iniciaTela = function(widget) {
        const fieldDtEntrega = widget.getField('DTENTREGA');
        
        fieldDtEntrega.defaultValue = {
            "start": moment().format('DD/MM/YYYY'),
            "end": moment().format('DD/MM/YYYY')
        };
        
        widget.getField('IDUTPRORIGOBRIG').defaultValue = ['S', 'N'];
        
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("CDFILIAL");
        filialField.dataSourceFilter = [
            {
                "name": "CDGRUPFILI",
                "value": "T",
                "operator": "="
            },
            {
                "name": "CDOPERADOR",
                "value": getLocalVar('CDOPERADOR'),
                "operator": "="
            }
        ];
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filialgrupfili.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.CDFILIAL;
    	               delete widget.currentRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.filialgrupfili.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.CDFILIAL;
    	                    delete widget.currentRow.NMFILIAL;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
    };

    this.nivelSetEdit = function(field) {
        const nivelButton = field.widget.getField('NIVEL');

        if (field.value().toUpperCase() == "ALFABÉTICA") {
            nivelButton.readOnly = false;
            nivelButton.spin = true;
            nivelButton.validations = {
                "required": {}
            };
        } else {
            nivelButton.readOnly = true;
            nivelButton.spin = false;
            nivelButton.value(0);
            nivelButton.validations = undefined;
        }
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    };

    this.filtraUnidades = function(widget) {
        const groupFili = widget.currentRow.UNIDADES;
        const fieldUnidades = widget.getField('CDFILIAL');

        if (groupFili) {
            const unidades = groupFili.split('_');

            fieldUnidades.dataSourceFilter = [{
                "name": "CDFILIAL",
                "value": "",
                "operator": "IN"
            }];
            
            this.defineSelectWidget(fieldUnidades);
            
            General.onClickDependentField(fieldUnidades, {
                'CDFILIAL': unidades
            });
        } else {
            fieldUnidades.dataSourceFilter = [{
                "name": "NRORG",
                "value": "",
                "operator": "="
            }];

            this.defineSelectWidget(fieldUnidades);
            
            General.onClickDependentField(fieldUnidades, {
                'NRORG': getLocalVar('NRORG')
            });
        }
        fieldUnidades.reload();
    };

    this.defineSelectWidget = function(field) {
        if (field.selectWidget) {
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };

    this.setVisibleProdObrigatorio = function(widget) {
        const widgetCurrentRow = widget.currentRow;
        const fieldOrigObrig = widget.getField("IDUTPRORIGOBRIG");

        if (widgetCurrentRow.REPORT_NAME == "CMP04909" || widgetCurrentRow.REPORT_NAME == "CMP0490A" || widgetCurrentRow.REPORT_NAME == "CMP0490B") {
            fieldOrigObrig.readOnly = false;
        } else {
            fieldOrigObrig.readOnly = true;
        }

        fieldOrigObrig.setValue(['S', 'N']);
    };

    this.criaRelatorio = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && this.validaProduto(currentRowWidget.CDPRODINI, currentRowWidget.CDPRODFIN)) {
            const reportName = widget.currentRow.REPORT_NAME;
            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRowWidget, reportName]);
        }
    };

    this.abreRelatorio = function(widget, currentRow, reportName) {
        const row = angular.copy(currentRow);
        const niveis = General.getLevelByMask('CDPICTPROD', 1);
        
        if (row.NRTAMCODIGO == "Código") {
            row.VLR_NIVEL = parseInt(niveis[niveis.length - 1].caracteres);
        } else {
            if (row.NIVEL == "0") {
                row.VLR_NIVEL = parseInt(row.NIVEL);
            } else {
                row.VLR_NIVEL = parseInt(niveis[row.NIVEL - 1].caracteres);
            }
        }

        row.TDTINI = row.DTINI = row.DTENTREGA.start;
        row.TDTFIM = row.DTFIM = row.DTENTREGA.end;
        row.CDPRODINICOC = row.CDPRODINI;

        row.CDPRODFIMCOC = row.CDPRODFIN.padEnd(20,'Z');
        row.CDGRUPFILI = row.CDGRUPFILI ? Array.isArray(row.CDGRUPFILI) && row.CDGRUPFILI.length > 0 ? row.CDGRUPFILI.join('_') : 'T' : 'T';
        row.CDFILIAL   = row.CDFILIAL ? Array.isArray(row.CDFILIAL) && row.CDFILIAL.length > 0 ? row.CDFILIAL.join('_') : 'T' : 'T';
        
        row.CDFILIAL1 = row.CDFILIAL;
        row.CDGRUPFILI1 = row.CDGRUPFILI;

        row.CDFILIAL2 = row.CDFILIAL;
        row.CDGRUPFILI2 = row.CDGRUPFILI;
        row.IDUTPRORIGOBRIG = row.IDUTPRORIGOBRIG.join('_');
        row.NRORG = getLocalVar('NRORG');
        
        General.openReport("cmp_relatorio#/cmp04900_relatorio", reportName, row);
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller', Cmp04900_RelacaoDeSolicitacoesDeCompras_Controller);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp05700JustificativaSolicitacaoController.js
function Cmp05700JustificativaSolicitacaoController(ScreenService, templateManager, General, ZhFilterPreferences, Utilities, MessageService) {
    
    this.setFilterInitValues = function(widget) {
        const filterRow = {
            "INTERVALDT": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
        };
        
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    this.widgetOnEnterOnce = function(widget) {
        //widget.getField("CDFILSOLEXT").filterProperties.readOnly = (window.projectCorp) ?  false : true;
        const filialField = widget.getField("CDFILSOLEXT");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            const filterRow = {
        	    INTERVALDT : {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILSOLEXT: [ getLocalVar("CDFILIAL") ],
        	    NMFILIAL: [ getLocalVar("NMFILIAL") ],
        	    P_CDOPERADOR: [ getLocalVar("CDOPERADOR") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILSOLEXT = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.unidadeSolicitacaoExtra.forEach(function(filial) {
    	               if(filial.CDFILSOLEXT == filterRow.CDFILSOLEXT[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILSOLEXT;
    	               delete filterRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.unidadeSolicitacaoExtra.forEach(function(filial) {
    	                   if(filial.CDFILSOLEXT == filterRow.CDFILSOLEXT[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILSOLEXT;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
	       
            Utilities.startFilter(widget, filterRow);
            //this.setFilterInitValues(widget);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.filtrar = function(args) {
        var filterRow = args.e.preference.FILTER_ROW;
        
        if(typeof(filterRow) === 'object') {
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DTOPERINI": filterRow.INTERVALDT.start,
                "P_DTOPERFIN": filterRow.INTERVALDT.end,
                "P_CDFILSOLEXT": Array.isArray(filterRow.CDFILSOLEXT) && filterRow.CDFILSOLEXT.length ? filterRow.CDFILSOLEXT.join('_') : 'T',
                "NRORG": filterRow.NRORG,
                "P_CDOPERADOR": getLocalVar("CDOPERADOR")
            };
        }
        
        /* Impede que, ao pesquisar por TODAS as Unidades (campo em branco), 
        o campo 'Unidade Solicitante' do corpo do relatório venha somente com a
        Unidade logada preenchida.
        */
        if (args.e.preference.CUSTOM_FILTER_ROW.P_CDFILSOLEXT === 'T') {
            args.owner.getField('CDFILSOLEXT').dataSource.reload();
        }
    };
    
    this.setStripe = function(widget) {
        var filterRow = widget.appliedFilter.FILTER_ROW;
        
        widget.container.getWidget("stripe").currentRow.DTOPERINI = filterRow.INTERVALDT.start + " a " + filterRow.INTERVALDT.end;
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp05700JustificativaSolicitacaoController', Cmp05700JustificativaSolicitacaoController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp06100_ProdutosNaoComprados_Controller.js

function Cmp06100_ProdutosNaoComprados_Controller(General, ScreenService, localStorageEngine, templateManager, ZhFilterPreferences, MessageService) {

    var self = this;            //coloca self para não dar problema no this. quando é usado dentro de uma função para representar outra função do mesmo arquivo.
    var listaUnidades = '';
    
    //TODO voltar com as functions que concatena, mas modificadas para serem utilizadas de forma genérica
    this.setFilterInitValues = function(widget) {
	    widget.currentRow.REPORT_NAME = "CMP06108.QR2";
	    widget.currentRow.RELSOLIEXTRA = "T";
        
	    widget.currentRow.INTERVALO_DATA = {};
	    widget.currentRow.INTERVALO_DATA.formattedStart = moment().format('L');
        widget.currentRow.INTERVALO_DATA.formattedEnd = moment().format('L');
	    widget.currentRow.INTERVALO_DATA.start = moment().format('L');
        widget.currentRow.INTERVALO_DATA.end = moment().format('L');
        widget.currentRow.L_FILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("L_FILIAL");
        filialField.dataSource.name = "cmp_solicitacao_relatorios#/crud/cmp06100_filial_regiao";
        filialField.dataSourceFilter = [
            {
                "name": "P_TCDREGIAO",
                "operator": "=",
                "value": "T"
            }
        ];
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.L_FILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.cmp06100_filial_regiao.forEach(function(filial) {
                        if(filial.CDFILIAL == widget.currentRow.L_FILIAL[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete widget.currentRow.L_FILIAL;
                        delete widget.currentRow.NMFILIAL;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.cmp06100_filial_regiao.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.L_FILIAL[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.L_FILIAL;
    	                    delete widget.currentRow.NMFILIAL;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.L_FILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
    };
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    this.preparaRowParaRelatorio = function(widget) {
        var currentRow = widget.currentRow;
        var prodfin = '';
        
        if(currentRow.CDPRODFIN) {
            let cdprodfin = currentRow.CDPRODFIN + "ZZZZZZZZZZZZZZZZZZZZ";
            cdprodfin = cdprodfin.substring(0, 20);
            prodfin = cdprodfin;
        } else {
            let cdprodfin = "ZZZZZZZZZZZZZZZZZZZZ";
            prodfin = cdprodfin;
        }
        
        var newRow = {
            "REPORT_NAME": currentRow.REPORT_NAME,
            "CDREGIAO": (currentRow.L_REGIAO) ? currentRow.L_REGIAO.join('_') :  'T',
            "DATAINI": currentRow.INTERVALO_DATA.start,
            "DATAFIN": currentRow.INTERVALO_DATA.end,
            "PRODINI": currentRow.CDPRODINI ? currentRow.CDPRODINI : '',
            "PRODFIN": prodfin,
            "OPERADOR": (currentRow.L_COMPRADOR) ? currentRow.L_COMPRADOR.join('_') : 'T',
            "SISTEMA": window.projectCorp ? "SUP" : "CMP",
            "INDEXREL": currentRow.CHKBOXPART === 'S' ? 4 : 0,
            /*Exibe Particularidade '4'=Sim e '0'=Não*/
            "CDFILIAL": concatArrayForParams(currentRow.L_FILIAL, "T"),
            "CDFILIPROC": getLocalVar('CDFILIAL'),
            "CDGRUPFILI": (currentRow.L_GRUPFILI) ? currentRow.L_GRUPFILI : '',
            /*Exibe Observação da Compra 'S'=Sim ou 'N'=Não*/
            "RELCOMPRA": currentRow.CHKBOXOBSCMP,
            "RELESPECIFICO": null,
            /*Solicitação Extra 'S'=Sim ou 'N'=Ambas ou '2'=Não*/
            "RELSOLIEXTRA": currentRow.RELSOLIEXTRA,
            /*Quebrar Página por Comprador 'S'=Sim ou 'N'= Não
            No banco, o default é 'S'; 
            Até o dia 16/08/2018, no relatório QR2 NÃO há opção de exibir ou não
            o comprador, ou seja, sempre está exibindo, independente do valor passado;*/
            "CONSIDERACOMP": 'S'//currentRow.CHKBOXBRKPAG
        };
        
        return newRow;
   };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };
    
    this.setUnidadesNull = function(widget){
        widget.getField('L_FILIAL').clearValue();
    };
    
    this.selectUnidades = function(widget){
        var regiao = (widget.currentRow.L_REGIAO) ? widget.currentRow.L_REGIAO.join('_') :  'T';
        var filterName = regiao === 'T' ? "P_TCDREGIAO" : "P_CDREGIAO";
        
        if (widget.currentRow.L_GRUPFILI === null || widget.currentRow.L_GRUPFILI === "") {
            widget.getField('L_FILIAL').dataSource.name = "cmp_solicitacao_relatorios#/crud/cmp06100_filial_regiao";
            widget.getField('L_FILIAL').dataSourceFilter = [
                {
                    "name": filterName,
                    "operator": "=",
                    "value": regiao
                }
            ];
        }
        else {
            widget.getField('L_FILIAL').dataSource.name = "cmp_solicitacao_relatorios#/crud/cmp06100_filial_grup";
            widget.getField('L_FILIAL').dataSourceFilter = [
                {
                    "name": filterName,
                    "operator": "=",
                    "value": regiao
                },
                {
                    "name": "P_CDGRUPFILI",
                    "operator": "=",
                    "value": widget.currentRow.L_CDGRUPFILI
                }
            ];
        }
        
        widget.getField('L_FILIAL').reload();
    };
    
    this.changeRequired = function(field){
        if (field.widget.getField('NMPRODINI').value() || field.widget.getField('NMPRODFIN').value()){
            field.widget.getField('NMPRODINI').validations = { "required" : true };
            field.widget.getField('NMPRODFIN').validations = { "required" : true };
        } else {
            field.widget.getField('NMPRODINI').validations = {};
            field.widget.getField('NMPRODFIN').validations = {};
        }
    };
    
    
    this.criaRelatorio = function(widget) {
        if (widget.isValid()) {
            if (Util.isEmptyOrBlank(widget.currentRow.NMPRODINI) && Util.isEmptyOrBlank(widget.currentRow.NMPRODFIN)) {
                widget.currentRow.PRODUTO = 'T';
            } else if ((self.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN))) {
                widget.currentRow.PRODUTO = 'X';
            } else {
                return;
            }
            
            var row = self.preparaRowParaRelatorio(widget);
            /* Abre o popup do general que pergunta o tipo de relatório que será gerado (pdf, etc.). 
            Os parâmetros passados podem ser vistos lá no arquivo General.js.*/
            General.openReportPopup(widget, self.abreRelatorio, [widget, row, widget.currentRow.REPORT_NAME]);
        }
    };
    
    
    this.abreRelatorio = function(widget, row, reportName) {
        row.QR2TYPE = widget.currentRow.QR2TYPE;
        
        const [name, strategy] = reportName.split('.');
        
        reportName = name;
        row.STRATEGY = strategy;
        
   	    General.openReport('cmp_solicitacao_relatorios#/cmp06100_relatorio', reportName, row);
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06100_ProdutosNaoComprados_Controller', Cmp06100_ProdutosNaoComprados_Controller);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp06600_LogDeSolicitacaoDeCompras_Controller.js
function Cmp06600_LogDeSolicitacaoDeCompras_Controller(General, ScreenService, localStorageEngine, ZhFilterPreferences, Utilities, MessageService) {
   
    this.setFilterInitValues = function(widget) {
	    const filterRow = {
            "CDFILIAL": getLocalVar('CDFILIAL'),
            "NMFILIALSOL": getLocalVar('NMFILIAL'),
            "PERIODO": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
	    };
	    
	    ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
 
    this.widgetOnEnter = function(widget) {
        //widget.getField("NMFILIALSOL").filterProperties.readOnly = (window.projectCorp) ? false : true;
        
        const filialField = widget.getField("NMFILIALSOL");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            const filterRow = {
        	    PERIODO: {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILIAL: getLocalVar("CDFILIAL"),
        	    NMFILIALSOL: getLocalVar("NMFILIAL")
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILIAL = CDFILCENTCMP;
                filterRow.NMFILIALSOL = NMFILCENTCMP;
                filialField.filterProperties.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == filterRow.CDFILIAL) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILIAL;
    	               delete filterRow.NMFILIALSOL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.filterProperties.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.filterProperties.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.filial_filioper_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == filterRow.CDFILIAL) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.filterProperties.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILIAL;
    	                   delete filterRow.NMFILIALSOL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.filterProperties.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
            
            Utilities.startFilter(widget, filterRow);
            //widget.getField("NMFILIALSOL").reload();
        	//this.setFilterInitValues(widget);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.filtrar = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        
        if (typeof(filterRow) === 'object') {
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DATAINIC": filterRow.PERIODO.start,
                "P_DATAFINA": filterRow.PERIODO.end,
                "P_CDOPERADOR": !Util.isEmptyOrBlank(filterRow.NMOPERADOR) ? filterRow.NMOPERADOR.join('_') : 'T',
                "P_CDFILIAL": filterRow.CDFILIAL,
                "NRORG": filterRow.NRORG,
                "P_CDOPERADORLOG": getLocalVar("CDOPERADOR")
            };
        }
    };
    
    this.setStripe = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const stripe = widget.container.getWidget('stripe');
        
    	stripe.getField('unidade').label = ScreenService.i18n('Unidade Solicitante: ') + filterRow.CDFILIAL + ' | ' + filterRow.NMFILIALSOL;
        stripe.getField('dataInicial').label = ScreenService.i18n('Data Inicial: ') + filterRow.PERIODO.start;
        stripe.getField('dataFinal').label = ScreenService.i18n('Data Final: ') + filterRow.PERIODO.end;
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06600_LogDeSolicitacaoDeCompras_Controller', Cmp06600_LogDeSolicitacaoDeCompras_Controller);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller.js
/*para construir essa tela, usei:
Cmp08000SolicitacaoDeComprasPorAgrupamento.php
Cmp08000_SolicitacaoDeComprasPorAgrpamento_Controller.js
cmp08000_solicitacao_de_compras_por_agrupamento.json
controllers.xml
routes.json do cmp/relatorios*/


function Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller(validateEngine, General, Utilities, ScreenService, templateManager, localStorageEngine, restEngine, ZhFilterPreferences, ZhUtil, MessageService) {

    var self = this;            //coloca self para não dar problema no this. quando é usado dentro de uma função para representar outra função do mesmo arquivo.
    var listaUnidades = '';

    this.onEnterFilterWidget = function(widget) {
        let filterRow = {}; 
        
        filterRow.REPORT_NAME = "CMP08000";
        
        filterRow.INTERVAL_DT = {};
        filterRow.INTERVAL_DT.start = moment().format("L");
        filterRow.INTERVAL_DT.end = moment().format("L");
        filterRow.INTERVAL_DT.formattedStart = moment().format('L');                                                                                                                                                                                                                                        
        filterRow.INTERVAL_DT.formattedEnd = moment().format('L');
        
        self.setHeaderReport(widget);
        
        Utilities.startFilter(widget, filterRow);
    };
    
    this.clearFilterSolicitacaoCompraPorAgrupamento = function (args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.prepareFilterSolicitacaoCompraPorAgrupamento = function (args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
    
        widget.dataSourceFilter = self.createDataSourceFilter(row);
        
        self.setStripeSolicitacaoCompraPorFornecedor(row);
        
        //widget._filterInfo = setFilterInfo(row);
        
        widget.reload();
        widget.activate();
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        
        if (prodInicial && prodFinal) {
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    };
    
    this.setProductIntervalFilterOnFilterPopup = function(args, field) {
        const  filterPopupCurrentRow = args.row;
        
        if (!(self.validaProduto(filterPopupCurrentRow.CDARVPRODINI, filterPopupCurrentRow.CDARVPRODFIN))) {
            if (field.name == 'NMPRODINI') {
                filterPopupCurrentRow.PRODINI = '';
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.CDARVPRODINI = '';
                filterPopupCurrentRow.NMPRODINI = '';
            } else {
                filterPopupCurrentRow.PRODFIN = '';
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.CDARVPRODFIN = '';
                filterPopupCurrentRow.NMPRODFIN = '';
            }
        }
            
    };
	
    this.createDataSourceFilter = function(row) {
        return [
        	{
        		"name": "P_TDTINI",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedStart
        	},
        	{
        		"name": "P_TDTFIN",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedEnd
        	},
        	{
        		"name": "P_DTINI",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedStart
        	},
        	{
        		"name": "P_DTFIN",
		        "operator": "=",
		        "value": row.INTERVAL_DT.formattedEnd
        	},
        	{
        		"name": "P_PRODINI",
		        "operator": "=",
		        "value": row.PRODINI	
        	},
        	{
        		"name": "P_PRODFIN",
		        "operator": "=",
		        "value": self.concatProdutoFinal(row.PRODFIN)
        	}
        ];
    };
    
    this.setStripeSolicitacaoCompraPorFornecedor = function(row) {
        const currentRowStripe = templateManager.container.getWidget('stripe').currentRow;
        
        currentRowStripe.DTENTREGA = ScreenService.i18n("De ") + row.INTERVAL_DT.start  + ScreenService.i18n(" até ") + row.INTERVAL_DT.end;
        currentRowStripe.CDPRODINI = row.NMPRODFIN;
        currentRowStripe.CDPRODFIN = row.NMPRODFIN;
    };
    
    this.setHeaderReport = function(widget) {
        widget.beforeGenerateReport = function(beforeReportData) {
            const row = templateManager.container.getWidget('cmp08000').appliedFilter.FILTER_ROW;
            
            beforeReportData.metadata.filter = [
                { "label": ScreenService.i18n("Agrupamento"), "value" : self.concatArrayForParams(row.NMGRUPFILI, ScreenService.i18n('Todos')) },
                { "label": ScreenService.i18n("Região"), "value" : self.concatArrayForParams(row.NMREGIAO, ScreenService.i18n('Todas')) },
                { "label": ScreenService.i18n("Produto Inicial"), "value" : row.NMPRODINI },
                { "label": ScreenService.i18n("Produto Final"), "value" : row.NMPRODFIN },
                { "label": ScreenService.i18n("Entrega"), "value" : row.INTERVAL_DT.formattedStart  + ScreenService.i18n(" até ") + row.INTERVAL_DT.formattedEnd  }   
            ];
        };
    };
    
    this.concatArrayForParams =  function(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join(', ') : value;
        }
    
        return defaultValue;
    };
    
    this.concatProdutoFinal = function(value) {
        const pad = 'ZZZZZZZZZZZZZZZZZZZZ';
        
        return value + pad.substr(0, pad.length - value.length);
    };
    
    this.validaData = function(dtInicial, dtFinal) {            //função para comparar as datas inicial e final e mostrar erro se a inicial for menor que a final.
        const dataInicial = dtInicial ? moment(dtInicial, 'DD/MM/YYYY')._d : null;        //se existir data inicial, ele manda seu valor para a variável  "dataInicial". Se não, manda null para a mesma.
        const dataFinal = dtFinal ? moment(dtFinal, 'DD/MM/YYYY')._d : null;              //se existir data final, ele manda seu valor para a variável  "dataFinal". Se não, manda null para a mesma.

        if (dataFinal < dataInicial) {              //se data inicial maior que data final,
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;                           //retorna falso, ou seja, não permite que a função que chama essa função dê continuidade.
        }
        
        return true;                                //se estiver tudo certinho, ele retorna verdadeiro e a função segue normalmente.
    };
    
    this.changeRequired = function(field) {
        const fieldProdIni = field.widget.getField('NMPRODINI');
        const fieldProdFin = field.widget.getField('NMPRODFIN');
        
        
        if (fieldProdIni.value() || fieldProdFin.value()){
            fieldProdIni.validations = { "required" : true };
            fieldProdFin.validations = { "required" : true };
        } else {
            fieldProdIni.validations = {};
            fieldProdFin.validations = {};
        }
    };

    this.validaProdutoRelatorio = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    };

    this.criaRelatorio = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (!widget.getField('NMPRODINI').value() && !widget.getField('NMPRODFIN').value()) {
            currentRowWidget.PRODUTO = 'T';
        } else {
            currentRowWidget.PRODUTO = 'X';
        }
        
        var reportName  = currentRowWidget.CD_REPORT_NAME;      //cria uma variável contendo a linha atual de CD_REPORT_NAME, que é o nome do relatório.
        
        if (widget.isValid() && this.validaProdutoRelatorio(currentRowWidget.PRODINI, currentRowWidget.PRODFIN)) {    //se a widget está válida (ou seja, se todos os campos obrigatórios estão preenchidos) e as datas também estão válidas,
            General.openReportPopup(widget, self.abreRelatorio, [widget, currentRowWidget, reportName]);   //abre o popup do general que pergunta o tipo de relatório que será gerado (pdf, etc.). Os parâmetros passados podem ser vistos lá no arquivo General.js.
        }
        
    };
    
    this.concatenaAgrupamento = function(row) {
        if (row.L_GRUPFILI === "" || Util.isEmptyObject(row.L_GRUPFILI)) {           //se o field estiver vazio ou for um array vazio, retorna a opção "T",
            row.GRUPFILI = 'T';                         // que representa todos os campos. Esse valor vai para a lista e é interpretado para o relatório.
            return row.GRUPFILI;
        } else {
            row.GRUPFILI = row.L_GRUPFILI.join('_');      //concatena cada item marcado com um underline separando. Faz isso para mandar para a lista que será mandada para o relatório.
            return row.GRUPFILI;                        //retorna os itens concatenados como se fossem uma coisa só.
        }
    }; 
    
    this.concatenaRegiao = function(row) {
        if (row.L_REGIAO === "" || Util.isEmptyObject(row.L_REGIAO)) {              //se o field estiver vazio ou for um array vazio, retorna a opção "T",
            row.REGIAO = 'T';                         // que representa todos os campos. Esse valor vai para a lista e é interpretado para o relatório.
            return row.REGIAO;
        } else {
            row.REGIAO = row.L_REGIAO.join('_');      //concatena cada item marcado com um underline separando. Faz isso para mandar para a lista que será mandada para o relatório.
            return row.REGIAO;                        //retorna os itens concatenados como se fossem uma coisa só.
        }
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        currentRow.REGION    = self.concatenaRegiao(currentRow);             //chama a função concatenaRegiao (que retorna os campos selecionados concatenados).
        currentRow.OPERADOR  = self.concatenaAgrupamento(currentRow);           //chama a função concatenaOperador (que retorna os campos selecionados concatenados).
        currentRow.DATAINIC  = currentRow.INTERVAL_DT.start;
        currentRow.DATAFINA  = currentRow.INTERVAL_DT.end;
        currentRow.DTINI     = currentRow.INTERVAL_DT.start;
        currentRow.DTFIM     = currentRow.INTERVAL_DT.end;
        currentRow.DTINICIAL = currentRow.INTERVAL_DT.start;
        currentRow.DTFINAL   = currentRow.INTERVAL_DT.end;

        if(currentRow.PRODFIN) {
            var pad = 'ZZZZZZZZZZ';
            var str = currentRow.PRODFIN;
            currentRow.PRODFIN = str + pad.substr(0, pad.length - str.length);
            currentRow.PRODINI = currentRow.PRODINI;
        } else {
            
            currentRow.PRODINI = "";
            currentRow.PRODFIN = "";
        }
   	    General.openReport('cmp_solicitacao_relatorios#/cmp08000_relatorio', reportName, currentRow);   //chama a função openReport (procurá-la no General.js)
    };
    
    this.setIniData = function(widget) {
        widget.currentRow.INTERVAL_DT = { 
            'formattedStart': moment().format('L'), 
            'formattedEnd': moment().format('L'), 
            'start': moment().format('L'),
            'end': moment().format('L') 
        };
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller', Cmp08000_SolicitacaoDeComprasPorAgrupamento_Controller);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/DesempenhoDeCompras_Controller.js
function DesempenhoDeCompras_Controller(General, ScreenService, localStorageEngine, MessageService) {

    var self = this;
    
    this.validaData = function(dtInicial, dtFinal) {        
        var dataInicial = dtInicial ? moment(dtInicial, 'MM/YYYY')._d : null;        
        var dataFinal = dtFinal ? moment(dtFinal, 'MM/YYYY')._d : null;   

        if (dataFinal < dataInicial) {           
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;                           
        }
        return true;                                
    };
    
    this.validaPeriodo = function(dtInicial, dtFinal){
        var maxData = moment(dtInicial, "MM/YYYY");   
        var datFin = moment(dtFinal, "MM/YYYY");
        
        if(self.validaData(dtInicial, dtFinal) === false){
            return false;
            
        }else{
            datFin = datFin.endOf('month').format("DD/MM/YYYY");
            datFin = datFin ? moment(datFin, "DD/MM/YYYY")._d : null;
            maxData = maxData.add(13, 'month').format("DD/MM/YYYY");
            maxData = moment(maxData, "DD/MM/YYYY");
            maxData = maxData.startOf('month').format("DD/MM/YYYY");
            maxData = maxData ? moment(maxData, "DD/MM/YYYY")._d : null;
            
            if(datFin > maxData){
                MessageService.showMessageByCode("PER_ANALISE_MAIOR_13");
                return false;
            }
            return true;
        }
    };
    
    this.setDataDefault = function(widget){
        var datatual = moment().format('MM/YYYY');
        var ano = datatual.split('/')[1];
        ano--;
        var ini = ['01', ano].join("/");
        var fin = ['12', ano].join("/");
        
        widget.getField('MESINIREF').value(ini);
        widget.getField('MESFINREF').value(fin);
    };
    
    this.selecionaFiltro = function(widget){
        var row = widget.currentRow;
        
        if(row.SELECIONAFILTRO == '1'){
            widget.getField('GRUPUNI').isVisible = true;
            widget.getField('REGIONAL').isVisible = false;
            widget.getField('UNIDADE').isVisible = false;
            widget.getField('REGIONAL').value('');
            widget.getField('UNIDADE').value('');
            
        }else if(row.SELECIONAFILTRO == '2'){
            widget.getField('GRUPUNI').isVisible = false;
            widget.getField('REGIONAL').isVisible = true;
            widget.getField('UNIDADE').isVisible = false;
            widget.getField('GRUPUNI').value('');
            widget.getField('UNIDADE').value('');
            
        }else{
            widget.getField('GRUPUNI').isVisible = false;
            widget.getField('REGIONAL').isVisible = false;
            widget.getField('UNIDADE').isVisible = true;
            widget.getField('REGIONAL').value('');
            widget.getField('GRUPUNI').value('');
        }
        
        
    };
    
    this.setValorPHP = function(field){
        if(!field){
            return 'T';
        }else{
            return field;
        }
    };
    
    this.setDatIni = function(field){
        var inicioDoMes = moment(field, "MM/YYYY");
        return inicioDoMes.startOf('month').format("DD/MM/YYYY");
    };
    
    this.setDatFin = function(field){
        var fimDoMes = moment(field, "MM/YYYY");
        return fimDoMes.endOf('month').format("DD/MM/YYYY");
    };
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        widget.currentRow.P_CDAREAGERE = self.setValorPHP(currentRow.CDAREAGERE);
        widget.currentRow.P_CDGRUPFILI = self.setValorPHP(currentRow.CDGRUPFILI);
        widget.currentRow.P_CDFILIAL = self.setValorPHP(currentRow.CDFILIAL);
        widget.currentRow.P_DATA_REF_INICIAL = self.setDatIni(currentRow.MESINIREF);
        widget.currentRow.P_DATA_REF_FINAL = self.setDatFin(currentRow.MESFINREF);
        widget.currentRow.P_DATA_INICIAL = self.setDatIni(currentRow.MESINIANA);
        widget.currentRow.P_DATA_FINAL = self.setDatFin(currentRow.MESFINANA);
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
        

   	    General.openReport('cmp_solicitacao_relatorios#/desempenho_de_compras_relatorio', reportName, currentRow);  
    };
    
    this.criaRelatorio = function(widget) {

        var reportName  = widget.currentRow.REPORT_NAME;      
        if (widget.isValid() && this.validaPeriodo(widget.currentRow.MESINIANA, widget.currentRow.MESFINANA) && this.validaData(widget.currentRow.MESINIREF, widget.currentRow.MESFINREF)) {    
            General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);  
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('DesempenhoDeCompras_Controller', DesempenhoDeCompras_Controller);
});

// FILE: ./assets/modules/solicitacao/assets/modules/relatorios/assets/js/controllers/SolicitacaoComprasUnidade.js
function SolicitacaoComprasUnidadeController(General, ScreenService, localStorageEngine, templateManager, MessageService) {

    var self = this;            

    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
        
    };

    this.criaRelatorio = function(widget) {
        if (!widget.isValid()) return;
        
        if (!this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) return;
        
        const reportName  = widget.currentRow.REPORT_NAME;
        
        General.openReportPopup(widget, self.abreRelatorio, [widget, widget.currentRow, reportName]);
    };
    
    this.setFilLanc = function(widget){
        var row = widget.currentRow;
        var reg = !Util.isEmptyOrBlank(row.REGIAO) ? row.REGIAO.join('_') : 'T';
        var dataSourceFilter = [
            { "name": "P_CDREGIAO", "operator": "=", "value": reg },
            { "name": "NRORG", "operator": "=", "value": getLocalVar('NRORG') },
            { "name": "CDOPERADOR", "operator": "=", "value": getLocalVar('CDOPERADOR') },
            { "operator": "ORDER_BY", "name": [ { "name": "CDFILIAL", "direction": "ASC" } ] }
        ];
        widget.getField('CDFILLANC').dataSourceFilter = dataSourceFilter;
    };
    
    this.setSol = function(widget){
        var row = widget.currentRow;
        var lanc = !Util.isEmptyOrBlank(row.CDFILLANC) ? row.CDFILLANC.join('_') : 'T';
        var filSoli = !Util.isEmptyOrBlank(row.CDFILSOLI) ? row.CDFILSOLI.join('_') : 'T';
        var dataSourceFilter = [
            { "name": "P_CDFILANCA", "operator": "=", "value": lanc },
            { "name": "P_TCDFILANCA", "operator": "=", "value": lanc },
            { "name": "P_CDFILSOLI", "operator": "=", "value": filSoli },
            { "name": "P_TCDFILSOLI", "operator": "=", "value": filSoli },
            { "name": "NRORG", "operator": "=", "value": getLocalVar('NRORG') }
        ];
        widget.getField('SOL').dataSourceFilter = dataSourceFilter;
    };
    
    this.setInitValues = function(widget) {
        var dataSourceFilter = [
            { "name": "P_STIDIOMA", "operator": "=", "value": 'P' },
            { "name": "NRORG", "operator": "=", "value": getLocalVar('NRORG') }
        ];
        
        widget.currentRow.INTERVALO_DATA = { 
            'formattedStart': moment().format('L'), 
            'formattedEnd': moment().format('L'), 
            'start': moment().format('L'), 
            'end': moment().format('L')
        };
        widget.currentRow.CDFILSOLI = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILSOLI = [ getLocalVar("NMFILIAL") ];
        
        const filialField = widget.getField("CDFILSOLI");
        filialField.reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILSOLI = [ CDFILCENTCMP ];
                widget.currentRow.NMFILSOLI = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
                    success.dataset.filial_filioper_regiao.forEach(function(filial) {
                        if(filial.CDFILIAL == widget.currentRow.CDFILSOLI[0]) {
                            verificador++;
                        }
                    });
                    if(verificador == 0) {
                        delete widget.currentRow.CDFILSOLI;
                        delete widget.currentRow.NMFILSOLI;
                        filialField.reload();
                    }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
                    if(filialField.readOnly == true) {
                        let verificador = 0;
                        success.dataset.filial_filioper_regiao.forEach(function(filial) {
                            if(filial.CDFILIAL == widget.currentRow.CDFILSOLI[0]) {
                                verificador++;
                            }
                        });
                        if(verificador == 0) {
                            filialField.validations.required = true;
    	                    MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                    delete widget.currentRow.CDFILSOLI;
    	                    delete widget.currentRow.NMFILSOLI;
    	                    filialField.reload();
                        } else {
                            delete filialField.validations.required;
    	                    filialField.reload();
    	                }
                    }
                });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILSOLI = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILSOLI = [ getLocalVar("NMFILIAL") ];
            filialField.reload();
        });
        
        General.callRestEngine('cmp_solicitacao_relatorios#/filtraCusto', 'FilterData', dataSourceFilter).then(function(callback) {
            widget.getField('NMTIPOCUSTO').dataSource.data = callback.dataset.custo;
            widget.currentRow.NMTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO;
            widget.redraw();
        }, function(err) {
			ScreenService.showMessage(err.data.error);
		});
        widget.redraw();
    };
     
    
    this.abreRelatorio = function(widget, row, reportName) {
        row = angular.copy(widget.currentRow);

        row.CDFILSOLI = row.CDFILSOLI ? Array.isArray(row.CDFILSOLI) && row.CDFILSOLI.length > 0 ? row.CDFILSOLI.join('_') : 'T' : 'T';
        row.CDFILLANC = row.CDFILLANC ? Array.isArray(row.CDFILLANC) && row.CDFILLANC.length > 0 ? row.CDFILLANC.join('_') : 'T' : 'T';
        row.REGIAO    = !Util.isEmptyOrBlank(row.REGIAO) ? row.REGIAO.join('_') : 'T';
        row.GROUPFIL  = row.CDGRUPFILI ? row.CDGRUPFILI : 'T';
        row.SOL       = !Util.isEmptyOrBlank(row.SOL) ? row.SOL.join('_') : 'T';
        row.DTINI     = row.DTINI = row.INTERVALO_DATA.formattedStart;
        row.DTFIM     = row.DTFIM = row.INTERVALO_DATA.formattedEnd;
        
        row.CDFILSOLI1 = row.CDFILSOLI;
        row.REGIAO1    = row.REGIAO;
        row.GROUPFIL1  = row.GROUPFIL;
        row.CDFILLANC1 = row.CDFILLANC;
        row.SOL1       = row.SOL;
        row.DTINI1     = row.DTINI;
        row.DTFIM1     = row.DTFIM;
        
        if(row.CDPRODFIN){
            var pad = 'ZZZZZZZZZZ';
            var str = row.CDPRODFIN;
            row.PRODFIN = str + pad.substr(0, pad.length - str.length);
            row.PRODINI = row.CDPRODINI;
        } else {
            row.PRODFIN = "";
            row.PRODINI = "";
            row.CDPRODFIN = "";
        }
   	    General.openReport('cmp_solicitacao_relatorios#/solicitacaoComprasUnidade', reportName, row);   
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('SolicitacaoComprasUnidadeController', SolicitacaoComprasUnidadeController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/js/controllers/cmp03100_lancamento_de_solicitacao_de_comprasController.js
function cmp03100_lancamento_de_solicitacao_de_comprasController(General, ScreenService, templateManager, ZhFilterPreferences, Utilities, maskEngine, ZhUtil, $http, metaDataFactory, Parametros, MessageService, ZHPromise) {
    
    const permissionsArray = {
        'INCLUIR_DTENTREGA'     : false,
        'EXCLUIR_DTENTREGA'     : false,
        'INCLUIR_PRODUTO'       : false,
        'ALTERAR_PRODUTO'       : false,
        'EXCLUIR_PRODUTO'       : false,
        'EXCLUIR_SOLICITACAO'   : false,
        'AUMENTAR_QUANTIDADE'   : false,
        'DIMINUIR_QUANTIDADE'   : false,
        'percentAumentar'       : undefined,
        'percentDiminuir'       : undefined,
        'APROVAR_SOLICITACAO'   : false
    };
    var self = this;
    var days = [];
    
    this.onEnterOnceWidgetPrincipal = function(args) {
        
        ScreenService.showLoader();
        
        var widget = args.owner;
        var dataSourceFilter = [
            { 
                "name": "P_STIDIOMA", 
                "operator": "=", "value": 'P'
            }
        ];
        var rowsToSet = {};
        
        this.setFieldsGerais(widget);
        
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		
		loadAndOpenFilter(widget, rowsToSet, dataSourceFilter);
        
        /**
         * 
         * Função criada para verificar se o operador logado no sistema possue acesso
         * a tela de Aprovação/Desaprovação de Solicitação, caso possua acesso as
         * actions de aprovação e desaprovação ficarão habilitadas
         *
         */
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getPermissaoAprovReprovacao', 'Row', {}).then(function(callback) {
            permissionsArray.APROVAR_SOLICITACAO = callback.dataset.dataset.length > 0;
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function loadAndOpenFilter(widget, rowsToSet, dataSourceFilter) {
        General.callRestEngine("cmp_solicitacao_solicitacaoCompras#/cmp03100_tipo_custo", "Row", {}).then(function(response) {
            if(response.dataset.dataset.length == 0) {
                General.callRestEngine('cmp_solicitacao_relatorios#/filtraCusto', 'FilterData', dataSourceFilter).then(function(callback) {
                    widget.getField('NMTIPOCUSTO').dataSource.data = callback.dataset.custo;
                    widget.currentRow.NMTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO;
                    widget.currentRow.NMFILIAL = getLocalVar("CDFILIAL");
                    rowsToSet.CDTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO;
                    rowsToSet.NMTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].NMTIPOCUSTO;
                    rowsToSet.NMFILIAL = [ getLocalVar("CDFILIAL") ];
                    rowsToSet.DTSOLCMP = {};
                    rowsToSet.DTSOLCMP.formattedStart = moment().subtract(30, "days").format('L');
                    rowsToSet.DTSOLCMP.formattedEnd = moment().format('L');
        	        rowsToSet.DTSOLCMP.start = moment().subtract(30, "days").format('L');
                    rowsToSet.DTSOLCMP.end = moment().format('L');
                    ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
                        const filterWidget = templateManager.container.getActiveWidget();
                        filterWidget.getField("NMFILIAL").dataSourceFilter = [
                			{
                				"name": "CDOPERADOR",
                				"operator": "=",
                				"value": getLocalVar('CDOPERADOR')
                			},
                			{
                				"name": "CDGRUPFILI",
                				"operator": "=",
                				"value": ""
                			},
                			{
                                "operator": "ORDER_BY",
                                "name": [
                                    {
                                        "name": "CDFILIAL",
                                        "direction": "ASC"
                                    }
                                ]
                            }
                		];
                        filterWidget.getField("NMFILIAL").reload().then(() => {
                            ScreenService.hideLoader();
                        });
                    }).catch(error => {
                        ScreenService.hideLoader();
                    });
                    //Utilities.startFilter(args.owner);
                }, function(err) {
        			ScreenService.showMessage(err.data.error);
        		});
            } else {
                General.callRestEngine('cmp_solicitacao_relatorios#/filtraCusto', 'FilterData', dataSourceFilter).then(function(callback) {
                    widget.getField('NMTIPOCUSTO').dataSource.data = callback.dataset.custo;
                    widget.currentRow.NMTIPOCUSTO = response.dataset.dataset[0].CDTPCUSTCMP;
                    widget.currentRow.NMFILIAL = getLocalVar("CDFILIAL");
                    rowsToSet.CDTIPOCUSTO = response.dataset.dataset[0].CDTPCUSTCMP;
                    rowsToSet.NMTIPOCUSTO = response.dataset.dataset[0].NMTIPOCUSTO;
                    rowsToSet.NMFILIAL = [ getLocalVar("CDFILIAL") ];
                    rowsToSet.DTSOLCMP = {};
                    rowsToSet.DTSOLCMP.formattedStart = moment().subtract(30, "days").format('L');
                    rowsToSet.DTSOLCMP.formattedEnd = moment().format('L');
        	        rowsToSet.DTSOLCMP.start = moment().subtract(30, "days").format('L');
                    rowsToSet.DTSOLCMP.end = moment().format('L');
                    ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
                        const filterWidget = templateManager.container.getActiveWidget();
                        filterWidget.getField("NMFILIAL").dataSourceFilter = [
                			{
                				"name": "CDOPERADOR",
                				"operator": "=",
                				"value": getLocalVar('CDOPERADOR')
                			},
                			{
                				"name": "CDGRUPFILI",
                				"operator": "=",
                				"value": ""
                			},
                			{
                                "operator": "ORDER_BY",
                                "name": [
                                    {
                                        "name": "CDFILIAL",
                                        "direction": "ASC"
                                    }
                                ]
                            }
                		];
                        filterWidget.getField("NMFILIAL").reload().then(() => {
                            ScreenService.hideLoader();
                        });
                    }).catch(error => {
                        ScreenService.hideLoader();
                    });
                    //Utilities.startFilter(args.owner);
                }, function(err) {
        			ScreenService.showMessage(err.data.error);
        		});
            }
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
        
    }
    
    this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
    
    this.limpaFieldUnidade = function(field) {
        const nmfilialField = field.widget.getField('NMFILIAL');
        
        nmfilialField.clearValue();
    };
    
    this.setDataSourceFilter = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDTIPOCUSTO",
		        "operator": "=",
		        "value": filterRow.CDTIPOCUSTO
		    },
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": concatArrayForParams(filterRow.NMFILIAL, '')
		    },
		    {
		        "name": "P_DTSOLINI",
		        "operator": "=",
		        "value": filterRow.DTSOLCMP.start
		    },
		    {
		        "name": "P_DTSOLFIM",
		        "operator": "=",
		        "value": filterRow.DTSOLCMP.end
		    },
		    {
		        "name": "P_TSOLICITA",
		        "operator": "=",
		        "value": verifyDateFieldValues(filterRow, 'DTSOLCMP')
		    },
		    {
		        "name": "P_ENTRINI",
		        "operator": "=",
		        "value": filterRow.DTENTREGA.start
		    },
		    {
		        "name": "P_ENTRFIM",
		        "operator": "=",
		        "value": filterRow.DTENTREGA.end
		    },
		    {
		        "name": "P_TENTREGA",
		        "operator": "=",
		        "value": verifyDateFieldValues(filterRow, 'DTENTREGA')
		    },
		    {
		        "name": "P_COMPRADOR",
		        "operator": "=",
		        "value": filterRow.COMPRADOR
		    },
		    {
		        "name": "P_TCOMPRADOR",
		        "operator": "=",
		        "value": concatArrayForParams(filterRow.COMPRADOR, 'T')
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": getLocalVar('CDOPERADOR')
		    },
		    {
		        "name": "P_CDDESTSOLI",
		        "operator": "=",
		        "value": filterRow.CDDESTSOLI
		    },
		    {
		        "name": "P_TCDDESTSOLI",
		        "operator": "=",
		        "value": !Util.isEmptyOrBlank(filterRow.CDDESTSOLI) ? '' : 'T'
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "DTSOLCMP",
                        "direction": "DESC"
                    },
                    {
                        "name": "NRSOLICMP",
                        "direction": "DESC"
                    }
                ]
            }
		];
		
		widget.reload().then(function(callback) {
		    setArrayPermissoes();
            widget.activate();
		});
		
    };
    
    function setArrayPermissoes() {
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getPermissoesSol', 'Row', {}).then(function(callback) {
            const permissoes = callback.dataset.permissoes;
            
            if(permissoes) {
                permissoes.forEach(function (value) {
                    permissionsArray[value.IDAUTLANCSOLI] = true;
                    
                    if(value.IDAUTLANCSOLI == 'AUMENTAR_QUANTIDADE') {
                        permissionsArray.percentAumentar    = value.PEALTEQTDESOLI;
                    }
                    if(value.IDAUTLANCSOLI == 'DIMINUIR_QUANTIDADE') {
                        permissionsArray.percentDiminuir    = value.PEALTEQTDESOLI;
                    }
                });
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function verifyDateFieldValues(filterRow, fieldName) {
    	//Selecionando o campo data de acordo com o fieldName enviado
    	const startCampoData = filterRow[fieldName].start;
    	const endCampoData = filterRow[fieldName].end;
        
        return (startCampoData && endCampoData) ? '' : 'T';
    }
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    this.setWidgetAfterMoveRow = function(args) {
        const widget = args.owner;
        const row = widget.currentRow;
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        stripeWidget.currentRow.NMFILSOLI   = row.NMFILIAL;
        stripeWidget.currentRow.EXTRA       = stripeWidget.getField('EXTRA').options[row.IDSOLEXTRA];
        stripeWidget.currentRow.IDBAIXASOL  = stripeWidget.getField('IDBAIXASOL').options[row.IDBAIXASOL];
        stripeWidget.currentRow.NMDESTSOLI  = row.NMDESTSOLI;
        stripeWidget.currentRow.COMPRADOR   = row.CDOPERADOR ? row.CDOPERADOR +' | '+ row.NMOPERADOR : '';
        stripeWidget.currentRow.IDUTLOPERSOL = row.IDUTLOPERSOL;
        
        //widget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
        //widget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
        widget.getAction('aprovaSolicitacao').isVisible = widget.currentRow.IDUTAPROVSOL === 'S';
        widget.getAction('reprovaSolicitacao').isVisible = widget.currentRow.IDUTAPROVSOL === 'S';
    
        dadosSolicitacaoWidget.externalRow = row;
        dadosSolicitacaoWidget.currentRow = row;
        
        produtosWidget.dataSourceFilter = [
			{
				'name': 'P_CDFILSOLI',
				'operator': '=',
				'value': row.CDFILSOLI
			},
			{
				'name': 'P_CDFILLAN',
				'operator': '=',
				'value': row.CDFILLANCA
			},
			{
				'name': 'P_NRSOLICMP',
				'operator': '=',
				'value': row.NRSOLICMP
			},
			{
				'name': 'P_NRTIPOCUSTO',
				'operator': '=',
				'value': row.CDTIPOCUSTO
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMPRODUTO",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		const openOnProductTab = true;
		
		if (!widget.currentRow || Util.isEmptyObject(widget.currentRow)) {
            return;
        }
        
        if (ScreenService.isSwipeOpen()) {
            this.abreLancamento(widget, openOnProductTab).then((widgetAtual) => {
               const activeWid = templateManager.container.getActiveWidget();
               if(templateManager.container.getWidget("inclusaoSolicitacaoPrincipal").enabled && activeWid.name === "inclusaoSolicitacaoPrincipal") {
                   templateManager.container.getWidget("dadosSolicitacao").enabled = false;
               }
               setVisibleProductActionsAndFields();
            });
        } else {
            Utilities.onDoubleClick(this.abreLancamento, [ widget, openOnProductTab ]);
        }
    };
    
    function setProdStripeFooter(data) {
        const prodStripeFooter = templateManager.container.getWidget("prodStripeFooter");
        
        prodStripeFooter.currentRow.TOTALPROD = [...new Set(data.dataset.itens_solicitacao.map(value => value.CDPRODUTO))].length;
		prodStripeFooter.currentRow.TOTALENTREGA = data.dataset.itens_solicitacao.length;
    }
    
    function verifyPermission(row, operation) {
        const blockChange = (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C') && row.IDBLOQALTSOLAUT === 'S';
        
        if(blockChange) {
            return permissionsArray[operation];
        } 
        
        return true;
    }
    
    function verifyOperatorPermission(row) {
        if(row.IDUTLOPERSOL === 'S') {
            return (row.CDOPERLANC && (getLocalVar('CDOPERADOR') === row.CDOPERLANC));
        }
        
        return true;
    }
    
    function desabilitaActions(widgets){
        widgets.forEach(function(widget){
            widget.actions.forEach(function(action){
                action.isVisible     = false;
                if(action.name == "voltar" || action.name == 'adicionaSolicitacao'){
                    action.isVisible = true;
                }   
            });
        });
        templateManager.container.getWidget('justificativaAlteracao').getAction('voltar').isVisible = true;
    }
    
    this.setVisibleProductsWidget = function() {
        setVisibleProductActionsAndFields();   
    };
    
    function setVisibleProductActionsAndFields() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        const deleteAction = produtosWidget.getAction('excluiData');
        const addAction = produtosWidget.getAction('adicionaProduto');
        const editSolicita = dadosSolicitacao.getAction('editaSolicitacao');
        const deleteDadosSolicita = dadosSolicitacao.getAction('excluiSolicitacao');
        
        deleteAction.isVisible = true;
        addAction.isVisible = true;
        editSolicita.isVisible = true;
        deleteDadosSolicita.isVisible = true;
        
        produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
        produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
        produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
        
        if(!verifyOperatorPermission(solicitacaoWidget.currentRow)) {
            deleteAction.isVisible = false;
            addAction.isVisible = false;
            editSolicita.isVisible = false;
            deleteDadosSolicita.isVisible = false;
            
            delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
            delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
            delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
        } else {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                if(produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length > 0) {
                    addAction.isVisible = solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'N';
                    deleteAction.isVisible = ((solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S') || (solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'N'));
                    editSolicita.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                    deleteDadosSolicita.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                } else {
                    deleteAction.isVisible = true;
                    addAction.isVisible = true;
                    editSolicita.isVisible = true;
                    deleteDadosSolicita.isVisible = true;
                }
                if(solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S') {
                    deleteAction.isVisible = true;
                    editSolicita.isVisible = true;
                    deleteDadosSolicita.isVisible = true;
                }
            } else {
                if(solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
                    deleteAction.isVisible = (verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_PRODUTO') || verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_DTENTREGA'));
                    addAction.isVisible = (verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') || verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA'));
                    deleteDadosSolicita.isVisible = verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_SOLICITACAO');
                                            
                    if(!verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE') && !verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                        delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                        delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                        delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
                    }
                }
            }
        }
        
        if((solicitacaoWidget.currentRow.IDTIPLAN === 'A' || solicitacaoWidget.currentRow.IDTIPLAN === 'C') && solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
            if(!verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE') && !verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            }
            
            deleteAction.isVisible = permissionsArray.EXCLUIR_PRODUTO || permissionsArray.EXCLUIR_DTENTREGA;
            addAction.isVisible = false;
            deleteDadosSolicita.isVisible = permissionsArray.EXCLUIR_SOLICITACAO;
            
            if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') && verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA')) {
                addAction.isVisible = true;
            }
        }
        
        //DELETE ACTION VERIFY
        // if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
        //     if(solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'N') {
        //         if(produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length > 0) {
        //             deleteDadosSolicita.isVisible = false;
        //         } else {
        //             deleteDadosSolicita.isVisible = true;
        //         }
        //     } else {
        //         deleteDadosSolicita.isVisible = true;
        //     }
        // } else {
        //     deleteDadosSolicita.isVisible = true;
        // }
        
        /** if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S'){
            produtosWidget.getField('IDSOLIAPROV').isVisible = true;
        } else {
            produtosWidget.getField('IDSOLIAPROV').isVisible = false;
        } **/
        
        if(solicitacaoWidget.currentRow.IDUTQTDEVOLU == 'S'){
            produtosWidget.getField('QTVOLUITEMSO').isVisible = true;
        } else {
            produtosWidget.getField('QTVOLUITEMSO').isVisible = false;
        }
        
        if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
            justAltWidget.enabled = true;
		} else {
		    justAltWidget.enabled = false;
		}
        
        //produtosWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        //produtosWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        
        //solicitacaoWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        //solicitacaoWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        
        produtosWidget.getAction('aprovaSolicitacao').isVisible = solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S';
        produtosWidget.getAction('reprovaSolicitacao').isVisible = solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S';
        
        solicitacaoWidget.getAction('aprovaSolicitacao').isVisible = solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S';
        solicitacaoWidget.getAction('reprovaSolicitacao').isVisible = solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S';
        /**
         * To do
         * Criar rotina de calculo de media
         * 
         * */
         
        produtosWidget.getAction('CALCULO_MEDIA').isVisible = false;
        
        produtosWidget.activate();
        produtosWidget.reload();
        
        templateManager.updateTemplate();
    }
    
    function setFieldsVisible(widget) {
        const widDatasAddProduto      = templateManager.container.getWidget('datasAddProduto');
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        if(widget.currentRow.IDUTLOPERSOL == 'S'){
            if(widget.currentRow.CDOPERLANC && widget.currentRow.CDOPERLANC !== getLocalVar('CDOPERADOR')){
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            }
        }
        
        if(widget.currentRow.IDAPROVITMSOLGR == 'S'){
            widDatasAddProduto.getField('DTCMPANTERIOR').validations = {"required": true};
        }else{
            delete widDatasAddProduto.getField('DTCMPANTERIOR').validations;
            widDatasAddProduto.getField('DTCMPANTERIOR').isVisible = false;
        }
        
        /** if(widget.currentRow.IDUTAPROVSOL === 'S'){
            produtosWidget.getField('IDSOLIAPROV').isVisible = true;
        }else{
            produtosWidget.getField('IDSOLIAPROV').isVisible = false;
        } **/
        
        if(widget.currentRow.IDUTQTDEVOLU == 'S'){
            produtosWidget.getField('QTVOLUITEMSO').isVisible = true;
            widDatasAddProduto.getField('QTVOLUITEMSO').isVisible = true;
        }else{
            produtosWidget.getField('QTVOLUITEMSO').isVisible = false;
            widDatasAddProduto.getField('QTVOLUITEMSO').isVisible = false;
        }
        produtosWidget.activate();
        produtosWidget.reload();
    
        templateManager.updateTemplate();
    }
    
    this.filtraUnidades =  function(field) {
        const row = field.widget.currentRow;
        
        field.dataSourceFilter = [
			{
				'name': 'CDOPERADOR',
				'operator': '=',
				'value': getLocalVar('CDOPERADOR')
			},
			{
				'name': 'CDGRUPFILI',
				'operator': '=',
				'value': row.CDGRUPFILI ? row.CDGRUPFILI : ''
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILIAL",
                        "direction": "ASC"
                    }
                ]
            }
		];

        field.reload();
    };
    
    this.setDateFieldProperties = function(widget, fieldName) {
        const fieldValidade = widget.getField(fieldName);
    	const currentRowWidget = widget.currentRow;
    	
    	//Selecionando o campo data de acordo com o fieldName enviado
    	const startCampoData = currentRowWidget[fieldName].start;
    	const endCampoData = currentRowWidget[fieldName].end;
        
        //OU Exclusivo - XOR
        if ((startCampoData && !endCampoData) || (!startCampoData && endCampoData)) {
            fieldValidade.validations = {
                "requiredInterval": true
            };
        } else {
            delete fieldValidade.validations;
        }    
    };
    
    this.loadDataSource = function(field) {
        const widget = field.widget;

        General.onClickDependentField(field, {'P_CDFILIAL': concatArrayForParams(widget.currentRow.NMFILIAL, '')});
    };
    
    this.loadEditDataSource = function(field) {
        const widget = field.widget;
        
        General.onClickDependentField(field, { 'P_CDFILIAL': widget.currentRow.CDFILSOLI });
    };
    
    this.adicionaSolicitacaoFiltro = function(widget) {
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const diasEntrega = templateManager.container.getWidget("DATAS");
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        
        tabbedWidget.defaultTab = "inclusaoSolicitacao";
        ScreenService.openSwipe(tabbedWidget);
        inclusaoSolicitacao.isVisible = true;
        inclusaoSolicitacao.activate();
        principal.activate();
        principal.enabled = true;
        principal.isVisible = true;
        principal.template = "widget/form.html";
        diasEntrega.enabled = false;
        diasEntrega.isVisible = true;
        diasEntrega.template = "widget/grid.html";
        principal.edit();
        delete principal.getField("NMPRODINI").validations.required;
        delete principal.getField("NMPRODFIN").validations.required;
        principal.getField("NMPRODINI").reload();
        principal.getField("NMPRODFIN").reload();
        
        if(widget.currentRow.CDFILCENTCMP && widget.currentRow.NMCENTCMP) {
            principal.currentRow.CDFILIAL = widget.currentRow.CDFILSOLI;
            principal.currentRow.CDFILSOLI = widget.currentRow.CDFILSOLI;
            principal.currentRow.NMFILIAL = widget.currentRow.NMFILIAL;
            principal.currentRow.CDFILCENT = widget.currentRow.CDFILCENTCMP;
            principal.currentRow.NMFILCENT = widget.currentRow.CDFILCENTCMP + " | " + widget.currentRow.NMCENTCMP;
            principal.currentRow.IDUTAPROVSOL = widget.currentRow.IDUTAPROVSOL;
            principal.currentRow.IDPERALTSAPR = widget.currentRow.IDPERALTSAPR;
            principal.currentRow.IDSISDOS = widget.currentRow.IDSISDOS;
        } else if(widget.dataSource.data[0]) {
            widget.currentRow = widget.dataSource.data[0];
            principal.currentRow.CDFILIAL = widget.currentRow.CDFILSOLI;
            principal.currentRow.CDFILSOLI = widget.currentRow.CDFILSOLI;
            principal.currentRow.NMFILIAL = widget.currentRow.NMFILIAL;
            principal.currentRow.CDFILCENT = widget.currentRow.CDFILCENTCMP;
            principal.currentRow.NMFILCENT = widget.currentRow.CDFILCENTCMP + " | " + widget.currentRow.NMCENTCMP;
            principal.currentRow.IDUTAPROVSOL = widget.currentRow.IDUTAPROVSOL;
            principal.currentRow.IDPERALTSAPR = widget.currentRow.IDPERALTSAPR;
            principal.currentRow.IDSISDOS = widget.currentRow.IDSISDOS;
        } else {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getSolicitacaoParameters', 'Row', {}).then(function(callback) {
                const params = callback.dataset.parametros[0];
                
                principal.currentRow.CDFILIAL = getLocalVar("CDFILIAL");
                principal.currentRow.CDFILSOLI = getLocalVar("CDFILIAL");
                principal.currentRow.NMFILIAL = getLocalVar("NMFILIAL");
                principal.currentRow.CDFILCENT = getLocalVar("CDFILIAL");
                principal.currentRow.NMFILCENT = getLocalVar("CDFILIAL") + " | " + getLocalVar("NMFILIAL");
                
                principal.currentRow.IDUTAPROVSOL = params.IDUTAPROVSOL;
                principal.currentRow.IDPERALTSAPR = params.IDPERALTSAPR;
                principal.currentRow.IDSISDOS = params.IDSISDOS;
            });
        }
        
        var row = { 
            "P_CDFILIAL": principal.currentRow.CDFILSOLI ? principal.currentRow.CDFILSOLI : getLocalVar("CDFILIAL")
        };
		
		General.callRestEngine("cmp_solicitacao_solicitacaoCompras#/cmp03100_param_cmp_sup", "Row", row).then(function(response) {
		    const IDUTPRODPREF = response.dataset.dataset[0].IDUTPRODPREF;
		    
		    if(IDUTPRODPREF == 'S') {
		        principal.getField("PRODCMP").checked = true;
		        principal.currentRow.PRODCMP = 'S';
		        principal.getField("PRODCMP").readOnly = false;
		    } else {
		        principal.getField("PRODCMP").checked = false;
		        principal.currentRow.PRODCMP = 'N';
		        principal.getField("PRODCMP").readOnly = true;
		    }
		    
		    dadosSolicitacao.enabled = false;
            produtosWidget.enabled = false;
            justificativaAlteracao.enabled = false;
		}, function(error) {
		    principal.getField("PRODCMP").checked = false;
		    principal.currentRow.PRODCMP = 'N';
		    principal.getField("PRODCMP").readOnly = true;
		    dadosSolicitacao.enabled = false;
            produtosWidget.enabled = false;
            justificativaAlteracao.enabled = false;
            ScreenService.showMessage(error.data.error);
		});
    };
    
    this.cancelarInclusaoSolicitacao = function(args) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        ScreenService.closePopup();
        
        if(solicitacaoWidget.dataSource.data.length === 0) {
            Utilities.startFilter(solicitacaoWidget);   
        } else {
            solicitacaoWidget.list();
            solicitacaoWidget.activate();
        }
    };
    
    this.setCurrentRowInclusao = function(widget, onEnter) {
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        
        widget.currentRow.NMFILLANCA    = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
        widget.currentRow.CDFILLANCA    = getLocalVar('CDFILIAL');
        widget.currentRow.CDFILSOLI     = templateManager.container.getWidget('solicitacaoWidget').currentRow.CDFILSOLI ? templateManager.container.getWidget('solicitacaoWidget').currentRow.CDFILSOLI : getLocalVar("CDFILIAL");
        widget.currentRow.DTSOLCMP      = moment().format('DD/MM/YYYY');
        
        widget.backupRow = angular.copy(widget.currentRow);
        
        setControlDestSoli(principal, onEnter);
    };
    
    function setControlDestSoli(widget, onEnter) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        
        widget.currentRow.CDFILSOLI = widget.currentRow.CDFILIAL;
        //widget.currentRow.NRORG = getLocalVar('NRORG');
        //widget.currentRow.NMFILCENT = widget.currentRow.CDFILCENT + " | " + widget.currentRow.NMFILCENT;
        
        if(!solicitacaoWidget.dataSource.data.length && !onEnter) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra', 'Row', widget.currentRow).then(function(res) {
                const dados = res.dataset.res[0];
                
                if(dados[0] && dados[0].IDUTPRODPREF == "S") {
                    widget.getField('PRODCMP').checked = true;
                    widget.currentRow.PRODCMP = 'S';
                } else {
                    widget.getField('PRODCMP').checked = false;
                    widget.currentRow.PRODCMP = 'N';
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
        
        if(!widget.currentRow.CDFILIAL || widget.currentRow.CDFILIAL == "") {
            widget.getField('NMDESTSOLI').readOnly = true;
            widget.getField('NMDESTSOLI').clearValue();
            widget.currentRow.CDDESTSOLI = "";
            widget.currentRow.NMDESTSOLI = "";
            widget.getField('NMDESTSOLI').reload();
        } else {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra', 'Row', widget.currentRow).then(function(res) {
                const dados = res.dataset.res[0];
                if(dados[0] && dados[0].IDULTDESTSOL == "S") {
                    widget.getField('NMDESTSOLI').dataSourceFilter = [
    			        {
    				        "name": "P_CDFILIAL",
    				        "operator": "=",
    				        "value": widget.currentRow.CDFILIAL
    			        },
    			        {
                            "operator": "ORDER_BY",
                            "name": [
                                {
                                    "name": "CDDESTSOLI",
                                    "direction": "ASC"
                                }
                            ]
                        }
    		        ];
    		        
    		        widget.getField('NMDESTSOLI').reload().then(function(callback) {
                        if(callback.dataset.destsol.length > 0) {
                            widget.getField('NMDESTSOLI').readOnly = false;
                            widget.currentRow.CDDESTSOLI = "";
                            widget.currentRow.NMDESTSOLI = "";
                            widget.getField("NMDESTSOLI").clearValue();
                            widget.getField("NMDESTSOLI").reload();
                        } else {
                            widget.getField('NMDESTSOLI').readOnly = true;
                            widget.getField("NMDESTSOLI").clearValue();
                            widget.currentRow.CDDESTSOLI = "";
                            widget.currentRow.NMDESTSOLI = "";
                            widget.getField("NMDESTSOLI").reload();
                        }
                    });
                } else {
                    widget.getField('NMDESTSOLI').readOnly = true;
                    widget.getField("NMDESTSOLI").clearValue();
                    widget.currentRow.CDDESTSOLI = "";
                    widget.currentRow.NMDESTSOLI = "";
                    widget.getField("NMDESTSOLI").reload();
                }
            });
            
            
            
        }
    }
    
    this.controlaDestinoSolicitacao = function(field, onEnter){
        const widget = field.widget;
        
        setControlDestSoli(widget, onEnter);
    };
    
    this.salvaSolicitacao = function(args) {
        const widget = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        let row = widget.currentRow;
        
        if(validaCamposPreenchidos() && validaProduto() && validaDataInserida()) {
        
            delete row.__rightActions;
            delete row.__leftActions;
        
            row.IDTIPLAN   = 'M';
            row.CDOPERLANC = getLocalVar('CDOPERADOR');
            row.CDOPERADOR = widget.currentRow.CDOPERADOR ? widget.currentRow.CDOPERADOR : null;
            row.CDDESTSOLI = widget.currentRow.CDDESTSOLI ? widget.currentRow.CDDESTSOLI : null;
            row.DSJUSTSOL  = widget.currentRow.DSJUSTSOL  ? widget.currentRow.DSJUSTSOL  : null;
            
            if(row.NRSOLICMP) {
            	row.__isNew = false;
            } else {
            	row.__isNew = true;
            }
            
            return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao', 'Row', row).then(function(sol) {
                const nSolicita = sol.dataset.sol[0];
        
                row.NRSOLICMP = nSolicita;
                
                widget.template = 'widget/form-view.html';
                widget.view();
                widget.reload();
                General.backOrCancel(args);
                templateManager.container.getWidget("inclusaoSolicitacao").isVisible    = false;
                templateManager.container.getWidget("dadosSolicitacao").enabled         = false;
                templateManager.container.getWidget("produtosWidget").enabled           = false;
                templateManager.container.getWidget("justificativaAlteracao").enabled   = false;
                
                if(!row.CDFILIAL_SOL) {
                    row.CDFILIAL_SOL = "";
                }
                
                if(!(row.NMPRODINI && row.NMPRODFIN)) {
                    return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getProdutos', 'Row', row).then(function(callback) {
                        var produto = callback.dataset.res[0];
                        row.CDPRODINI = produto[0].MIN_CDPRODUTO;
                        row.CDPRODFIN = produto[0].MAX_CDPRODUTO;
                        
                        return montaListaProdutos(widget ,row);
                    });
                } else {
                    return montaListaProdutos(widget, row);
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    function validaCamposPreenchidos() {
        const widgetPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        
        if(widgetPrincipal.isValid()) {
            return true;
        } else {
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            widgetPrincipal.activate();
            return false;
        }
    }
    
    function validaProduto() {
        const widgetPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        const row = widgetPrincipal.currentRow;
        
        if(row.CDPRODINI && !row.CDPRODFIN) {
            MessageService.showMessageByCode("PRODUTO_FINAL_N_INFORMADO", {}, {
                type: 'INFORMATION'
            });
            widgetPrincipal.activate();
            return false;
        }

        if(General.comparaPratoProduto(row.CDPRODINI, row.CDPRODFIN, getLocalVar('CDPICTPROD'))) {
            return true;
        } else {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", {}, {
                type: 'INFORMATION'
            });
            widgetPrincipal.activate();
            return false;
        }
    }
    
    function validaDataInserida() {
        const widgetDatas = templateManager.container.getWidget('DATAS');
        const widgetDiasEntrega = templateManager.container.getWidget('diasEntrega');
        
        if(widgetDatas.dataSource.data.length > 0) {
            return true;
        } else {
            widgetDiasEntrega.activate();            
            MessageService.showMessageByCode("DATA_REQUIRED");
            return false;
        }
    }
    
    function montaListaProdutos(widget, row) {
        const widProdNovo = templateManager.container.getWidget("prodnovo");
        const widProd = templateManager.container.getWidget("produtosWidget");
        const widDiasEntrega = templateManager.container.getWidget("DATAS");
        const principalRow = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal').currentRow;
        
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/listaProdutos', 'Row', row).then(function(res) {
            let dados               = res;
            
            widProdNovo.isVisible   = true;
            widProd.isVisible       = false;
            widProdNovo.activate();

            if(dados.dataset.res[0].length <= 0) {
                MessageService.showMessageByCode("NO_DATA_SOL_CMP");
                widget.list();
    			widget.isVisible    = false;
    			ScreenService.openPopup(templateManager.container.getWidget('solicitacaoWidget'));
    			templateManager.container.getWidget('solicitacaoWidget').activate();
    			templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
                templateManager.container.getWidget("produtos").enabled               = true;
                templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
                templateManager.container.getWidget("dadosSolicitacao").activate();
            }
            
            const idSoliApro = getSolicitacaoAprovada(principalRow.IDSISDOS, principalRow.IDUTAPROVSOL, principalRow.IDPERALTSAPR[0]);
            
            days = [];
            var index = 0;
            dados.dataset.res[0].forEach(function(value) {
            	widDiasEntrega.dataSource.data.forEach(function(date) {
            		days.push(angular.copy(value)); 
            		
            		days[index].CDFILIAL = principalRow.CDFILIAL;
            		days[index].CDFILSOLI = principalRow.CDFILSOLI;
            		days[index].CDFILLANCA = principalRow.CDFILLANCA;
            		days[index].NRSOLICMP = principalRow.NRSOLICMP;
            		
            		days[index].DTPROGENTR = angular.copy(date.DTPROGENTR);
            		days[index].SEMANA = angular.copy(date.SEMANA);
            		days[index].IDSOLIAPROV = angular.copy(idSoliApro);
            		days[index].__isNew = angular.copy(true);
            		
            		days[index].QTSOLIPROD = 0;
            		days[index].QTVOLUITEMSO = angular.copy(date.QTVOLUITEMSO ? date.QTVOLUITEMSO : 0);
            		days[index].TXOBSITMSOL = angular.copy(!date.TXOBSITMSOL ? null : date.TXOBSITMSOL);
                    days[index].DTCMPANTERIOR = angular.copy(!date.DTCMPANTERIOR ? null : date.DTCMPANTERIOR);
                    days[index].DSJUSTOPER = angular.copy("");

            		index += 1;
            	});
            });
            
            widProdNovo.dataSource.data = days;
            
            widDiasEntrega.dataSource.data.map(rows => {
                delete rows.__rightActions;
                delete rows.__leftActions;
            });
            
        }).catch(function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT', null, { type: 'ERROR' });
//             widget.list();
// 			   widget.isVisible = false;
// 			   ScreenService.openPopup(templateManager.container.getWidget("solicitacaoWidget"));
// 			   templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
//             templateManager.container.getWidget("produtosWidget").enabled         = true;
//             templateManager.container.getWidget("justificativaAlteracao").enabled = true;
//             templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
//             templateManager.container.getWidget("dadosSolicitacao").activate();
// 			   templateManager.container.getWidget("solicitacaoWidget").activate();
            widProdNovo.isVisible   = true;
            widProd.isVisible       = false;
            widProdNovo.activate();
            widProdNovo.dataSource.data = [];
        });
    }
    
    function insertSolicitaFinally() {
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const widProdNovo = templateManager.container.getWidget("prodnovo");
        const inclusaoSolicitacaoPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        const widgetDatas = templateManager.container.getWidget('DATAS');
        const diasEntrega = templateManager.container.getWidget('diasEntrega');
        
        widProdNovo.isVisible = false;
        widProdNovo.enabled = false;
        produtosWidget.isVisible = true;
        produtosWidget.enabled = true;
        dadosSolicitacao.enabled = true;
        justificativaAlteracao.enabled = true;
        inclusaoSolicitacao.isVisible = false;
        
        tabbedWidget.defaultTab = "produtosWidget";
        ScreenService.closeSwipe();
        inclusaoSolicitacaoPrincipal.currentRow = {};
        diasEntrega.currentRow = {};
        widgetDatas.dataSource.data = [];
        solicitacaoWidget.reload();
        solicitacaoWidget.activate();
    }
    
    this.salvarDataProdNovo = function(widget) {
        if(widget.isValid()) {
            const widProdNovo = templateManager.container.getWidget('prodnovo');
            const inclusaoSolicitacao = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
            const items = widProdNovo.dataSource.data;
            const principalRow = inclusaoSolicitacao.currentRow;
            
            ScreenService.confirmMessage('Itens com quantidades zero não serão inseridos.\nConfirma a operação??', 'question', function() {
                if(typeof widProdNovo.currentRow.__index == "number") {
                    General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProd', 'DataSet', [principalRow, items]).then(function(res) {
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                        widProdNovo.dataSource.data[widProdNovo.currentRow.__index].__isNew = false;
                        MessageService.showMessageByCode("SUCCESS_OPERATION");
                        insertSolicitaFinally();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                } else {
                    MessageService.showMessageByCode("ERRO_INDEX_PROD");
                }
            });
        }
    };
    
    function getSolicitacaoAprovada(idsisdos, idUtAprovSol, idPerAltSapr) {
        if (idsisdos == '3') {
            if (idUtAprovSol == 'S' && idPerAltSapr == 'S') {
                return 'N';
            }
            
            return 'S';
        } else {
            if (idUtAprovSol == 'S') {
                return 'N';
            }
            
            return 'S';
        }
    }
    
    this.cancelarProdNovo = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        
        MessageService.confirmMessageByCode("CANCEL_INSERT_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
            insertSolicitaFinally();
        });
        
        /*var widgetPrincipal = templateManager.container.getWidget('principal');
        let row = widgetPrincipal.currentRow;
        row.EXCLUIR_SOLICITACAO = false;
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteSolicitacao','Row', row).then(function(success){
            var stripe                  = templateManager.container.getWidget("STRIPE");
            var widDatas                = templateManager.container.getWidget("DATAS");
            General.backOrCancel(args);
            templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
            templateManager.container.getWidget("produtos").enabled               = true;
            templateManager.container.getWidget("produtos").isVisible             = true;
            templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
            templateManager.container.getWidget("prodnovo").isVisible  = false;
            templateManager.container.getWidget("dadosSolicitacao").activate();
            if(!stripe.dataSource.data[0]){
                self.abreFiltro(false);
            }
            widDatas.dataSource.data = [];
            widDatas.getParent().currentRow = {};
            widgetPrincipal.currentRow = widgetPrincipal.backupRow;
            stripe.getAction("abreFiltro").isVisible                              = true;
            stripe.getAction("listaSoli").isVisible                               = true;
        });*/
    };
    
    this.cancelaSolicitacao = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        
        if(activeWidget.name === "dadosSolicitacao") {
            activeWidget.template = "widget/form-view.html";
            activeWidget.reload();
            templateManager.container.getWidget("dadosSolicitacao").enabled = true;
            templateManager.container.getWidget("produtosWidget").enabled = true;
            if(activeWidget.currentRow.IDAUDALTSOL == "S")
                templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            else
                templateManager.container.getWidget("justificativaAlteracao").enabled = false;
            
            General.backOrCancel(args);
            //General.widgetCancelForm(activeWidget);
            activeWidget.list();
            activeWidget.reload();
        } else {
            MessageService.confirmMessageByCode("CANCEL_INSERT_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
                if(activeWidget.name === "inclusaoSolicitacaoPrincipal") {
                    General.widgetCancelForm(activeWidget);
                    insertSolicitaFinally();
                }
                
                if(activeWidget.name === "DATAS") {
                    insertSolicitaFinally();
                }
            }).catch(error => {
            });
        }
        
        /*const stripe                  = templateManager.container.getWidget("STRIPE");
        const filtroSolicitacao       = templateManager.container.getWidget("solicitacaoWidget");
        const widPrincipal            = templateManager.container.getWidget("principal");
        const widDatas                = templateManager.container.getWidget("DATAS");
        const widget = args.owner.widget;
        
        General.backOrCancel(args);
        
        widget.list();
        widget.reload();
        
        templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
        templateManager.container.getWidget("produtos").enabled               = true;
        templateManager.container.getWidget("justificativaAlteracao").enabled = true;
        templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
        templateManager.container.getWidget("dadosSolicitacao").activate();
        
        if(!stripe.dataSource.data[0]){
            self.abreFiltro(false);
        }
        
        widDatas.dataSource.data = [];
        widDatas.getParent().currentRow = {};
        
        stripe.getAction("abreFiltro").isVisible                              = true;
        stripe.getAction("listaSoli").isVisible                               = true;
        self.cancelaFiltro();*/
    };
    
    this.confirmsApproval = function() {
    	MessageService.confirmMessageByCode("CONFIRMS_APPROVAL", null, Constants.confirmationMessage).then(function(success) {
            const produtosWidget = templateManager.container.getWidget("produtosWidget");
            const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
    	    const checkedRows = produtosWidget.getCheckedRows();
    	    const disapprovedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'N');
            
            if(disapprovedItems.length > 0) {
                disapprovedItems.map(item => {
                    item.IDSOLIAPROV = 'S';
        			item.DTHRAPROVSOL = moment().format('DD/MM/YYYY HH:mm:ss');
        			item.CDOPERAPROV = getLocalVar('CDOPERADOR');
                });
                
        		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', checkedRows).then(function(success) {
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.unSelectAll();
        			produtosWidget.reload();
        			solicitacaoWidget.reload();
                    setVisibleProductActionsAndFields();
        		}, function(err) {
        			setVisibleProductActionsAndFields();
        			solicitacaoWidget.reload();
        			ScreenService.showMessage(err.data.error);
        		});
            } else {
                produtosWidget.unSelectAll();
                setVisibleProductActionsAndFields();
        		solicitacaoWidget.reload();
        		MessageService.showMessageByCode("SOLICITA_ITENS_ALREADY_APPROVED");
            }
        });
	};
	
	this.confirmsDisapproval = function() {
	    MessageService.confirmMessageByCode("CONFIRMS_DISAPPROVAL", null, Constants.confirmationMessage).then(function(success) {
            const produtosWidget = templateManager.container.getWidget("produtosWidget");
            const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
    	    const checkedRows = produtosWidget.getCheckedRows();
    	    const approvedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'S');
    	    
    	    if(approvedItems.length > 0) {
                approvedItems.map(item => {
                    item.IDSOLIAPROV = 'N';
        			item.DTHRAPROVSOL = null;
        			item.CDOPERAPROV = null;
                });
                
        		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', checkedRows).then(function(success) {
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.unSelectAll();
        			produtosWidget.reload();
        			solicitacaoWidget.reload();
    	            setVisibleProductActionsAndFields();
        		}, function(err) {
        		    setVisibleProductActionsAndFields();
        			solicitacaoWidget.reload();
        			ScreenService.showMessage(err.data.error);
        		});
    	    } else {
    	        setVisibleProductActionsAndFields();
    	        produtosWidget.unSelectAll();
        		solicitacaoWidget.reload();
        		MessageService.showMessageByCode("SOLICITA_ITENS_ALREADY_REPROVED");
    	    }
        });
	};
	
	this.produtosWidgetBeforeSelectRow = function(args) {
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const solicitaRow = templateManager.container.getWidget('solicitacaoWidget').currentRow;
	    const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        
        //if(permissionsArray.APROVAR_SOLICITACAO && solicitaRow.IDUTAPROVSOL === 'S') {
        if(solicitaRow.IDUTAPROVSOL === 'S') {
            produtosWidget.getAction('aprovaSolicitacao').isVisible = true;
            produtosWidget.getAction('reprovaSolicitacao').isVisible = true; 
	    } else {
	        produtosWidget.getAction('aprovaSolicitacao').isVisible = false;
            produtosWidget.getAction('reprovaSolicitacao').isVisible = false;   
	    }
        
        justAltWidget.enabled = false;
        dadosSolicitacao.enabled = false;
        
        delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
        delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
        delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
        
        produtosWidget.activate();
    };
    
    this.produtosWidgetOnEnterOnce = function(args){
        const widget = args.owner;
        
        widget.beforeSelectAll = function(dataSet){
            const produtosFiltrados = dataSet.data.filter(row => row.IDSOLIAPROV == 'S');
            produtosFiltrados.map(row => { row.__notSelectable = true; });
        };
    };
    
    this.editaSolicitacao = function(widget) {
        widget.template = "widget/form.html";
        widget.edit();
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        templateManager.container.getWidget("produtosWidget").enabled = false;
        templateManager.container.getWidget("justificativaAlteracao").enabled = false;
        widget.reload();
        
        if(widget.currentRow.IDULTDESTSOL == "S") {
            widget.getField("NMDESTSOLI").readOnly = false;
            widget.getField("NMDESTSOLI").reload();
        } else {
            widget.getField("NMDESTSOLI").readOnly = true;
            widget.currentRow.NMDESTSOLI = "";
            widget.currentRow.CDDESTSOLI = "";
            widget.getField("NMDESTSOLI").reload();
        }
    };
    
    this.controlaFieldDestSol = function(widget) {
        widget.getField("NMDESTSOLI").clearValue();
        widget.getField("NMDESTSOLI").reload();
    };
    
    this.salvaSolicitacaoEditada = function(args) {
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        dadosSolicitacaoWidget.template = "widget/form-view.html";
        dadosSolicitacaoWidget.reload();
        const row = dadosSolicitacaoWidget.currentRow;
        const widget = args.owner.widget;
        delete row.__rightActions;
        delete row.__leftActions;
        row.__isNew = false;
        
        if(dadosSolicitacaoWidget.isValid()) {
            // return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao', 'Row', row).then(function(success) {
            //     //templateManager.container.getWidget("dadosSolicitacao").enabled = true;
            //     //templateManager.container.getWidget("produtosWidget").enabled = true;
            //     //templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            //     //templateManager.container.getWidget("inclusaoSolicitacao").isVisible = false;
            //     //solicitacaoWidget.reload();
            //     //widget.list();
            //     General.backOrCancel(args);
            //     MessageService.successNotificationByCode('SUCCESS_OPERATION');
            // }, function(err) {
            //     ScreenService.showMessage(err.message);
            // });
            General.callRestEngine("cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao", "Row", row).then(function(success) {
                templateManager.container.getWidget("dadosSolicitacao").enabled = true;
                templateManager.container.getWidget("produtosWidget").enabled = true;
                if(row.IDAUDALTSOL == "S")
                    templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                else
                    templateManager.container.getWidget("justificativaAlteracao").enabled = false;
                General.backOrCancel(args);
                widget.list();
                widget.reload();
                MessageService.successNotificationByCode("SUCCESS_OPERATION");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
                templateManager.container.getWidget("dadosSolicitacao").enabled = true;
                templateManager.container.getWidget("produtosWidget").enabled = true;
                if(row.IDAUDALTSOL == "S")
                    templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                else
                    templateManager.container.getWidget("justificativaAlteracao").enabled = false;
                General.backOrCancel(args);
                widget.list();
                widget.reload();
            });
            
        }
    };
    
    this.controlaFieldJustificativa = function(solExtraField, onEnter) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const justSolField = solExtraField.getParent().getField('DSJUSTSOL');
        
        if(solicitacaoWidget.currentRow.IDSOLEXTRA && onEnter) {
            solExtraField.checked = solicitacaoWidget.currentRow.IDSOLEXTRA === 'S';
        }
        
        if(solExtraField.checked && solicitacaoWidget.currentRow.IDJUSSOLEXT === 'S') {
            justSolField.readOnly = false;
            justSolField.validations = { "required": true };
        } else {
            justSolField.readOnly = true;
            delete justSolField.validations;
        }
        
        if(!onEnter && solicitacaoWidget.currentRow.IDJUSSOLEXT === 'S') {
            justSolField.setValue();
        }
    };
    
    function existsPermissionsDeleteSolicita() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        if(verifyOperatorPermission(solicitacaoWidget.currentRow) && verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_SOLICITACAO')) {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                if(solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'S') {
                    return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length === 0;
                } else {
                    if(solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S')
                        return true;
                    else
                        return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'N').length > 0;
                }
            } else {
                return true;    
            }
        }
        return false;
    }
    
    this.deleteSolicita = function(widget) {
	    const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const currentRow = solicitacaoWidget.currentRow;
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
	    
	    produtosWidget.dataSourceFilter = [
			{
				'name': 'P_CDFILSOLI',
				'operator': '=',
				'value': currentRow.CDFILSOLI
			},
			{
				'name': 'P_CDFILLAN',
				'operator': '=',
				'value': currentRow.CDFILLANCA
			},
			{
				'name': 'P_NRSOLICMP',
				'operator': '=',
				'value': currentRow.NRSOLICMP
			},
			{
				'name': 'P_NRTIPOCUSTO',
				'operator': '=',
				'value': currentRow.CDTIPOCUSTO
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMPRODUTO",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		produtosWidget.reload().then(success => {
    	    if(existsPermissionsDeleteSolicita()) {
        	    MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
        	        delete currentRow.__leftActions;
                    delete currentRow.__rightActions;
        	        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteSolicitacao', 'Row', currentRow).then(function(success) {
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
            			solicitacaoWidget.reload();
            			if(widget !== solicitacaoWidget) {
            			    ScreenService.closeSwipe();
            			    solicitacaoWidget.activate();
            			}
                    }, function(err) {
            			ScreenService.showMessage(err.data.error);
            		});
                });
    	    } else {
    	        if(solicitacaoWidget.currentRow.IDUTLOPERSOL === 'S') {
                    if(solicitacaoWidget.currentRow.CDOPERLANC && ((getLocalVar('CDOPERADOR') != solicitacaoWidget.currentRow.CDOPERLANC))) {
                        MessageService.showMessageByCode("SOLICITA_BELONGS_ANOTHER", null, Constants.errorMessage);
                    } else {
                        MessageService.showMessageByCode("SOLICITA_BLOCK_DELETE_ALL", null, Constants.errorMessage);
                    }
                } else {
                    if(solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
                        MessageService.showMessageByCode("WITHOUT_PERMISSION", null, Constants.errorMessage);
                    } else {
                        MessageService.showMessageByCode("SOLICITA_BLOCK_DELETE_ALL", null, Constants.errorMessage);
                    }
                }
    	    }		    
		});
    };
    
    this.confirmsApprovalSolicita = function() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const currentRow = solicitacaoWidget.currentRow;
	    
	    delete currentRow.__leftActions;
	    delete currentRow.__rightActions;
	    
	    if(currentRow.IDSOLIAPROV === 'S') {
	        MessageService.showMessageByCode("SOLICITA_ALREADY_APPROVED");
	        ScreenService.closePopup();
        	setVisibleProductActionsAndFields();
        	solicitacaoWidget.reload();
        	solicitacaoWidget.activate();
	    } else {
	        MessageService.confirmMessageByCode("CONFIRMS_APPROV_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/aprovarSolicitacoes', 'Row', currentRow).then(function(success) {
        			ScreenService.closePopup();
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.reload().then(function(){
        		        setVisibleProductActionsAndFields();
        		        solicitacaoWidget.reload();
        		        solicitacaoWidget.activate();
        			});
        		}, function(err) {
        		    ScreenService.closePopup();
        			setVisibleProductActionsAndFields();
        			ScreenService.showMessage(err.data.error);
        		    solicitacaoWidget.reload();
        		    solicitacaoWidget.activate();
        		});
            });
	    }
    	    
        
	};
	
	this.confirmsDisapprovalSolicita = function() {
	    const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
	    const currentRow = solicitacaoWidget.currentRow;
    	    
	    delete currentRow.__leftActions;
	    delete currentRow.__rightActions;
	    
	    if(currentRow.IDSOLIAPROV === 'N') {
	        MessageService.showMessageByCode("SOLICITA_ALREADY_REPROVED");
	        ScreenService.closePopup();
        	setVisibleProductActionsAndFields();
        	solicitacaoWidget.reload();
        	solicitacaoWidget.activate();
	    } else {
	        MessageService.confirmMessageByCode("CONFIRMS_DISAPPROV_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/reprovaSolicitacoes', 'Row', currentRow).then(function(success) {
        		    ScreenService.closePopup();
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.reload().then(function(){
        		        setVisibleProductActionsAndFields();
        		        solicitacaoWidget.reload();
        		        solicitacaoWidget.activate();
        			});
        		}, function(err) {
        		    ScreenService.closePopup();
        			setVisibleProductActionsAndFields();
        			ScreenService.showMessage(err.data.error);
        		    solicitacaoWidget.reload();
        		    solicitacaoWidget.activate();
        		});
        		
            });
	    }
	};
	
	this.produtosReload = function() {
        var footerstripe = templateManager.container.getWidget("footerProdStripe");
        var widget = templateManager.container.getWidget("produtosWidget");
        var widSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectProdutosGrid','Row', widSolicitacao.currentRow).then(function(callback){
            var produtos = callback.dataset.produtos;
            widget.dataSource.data = produtos;
            footerstripe.currentRow.TOTALPROD = produtos.length;
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.adicionaProduto = function() {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const checkedRows = produtosWidget.getCheckedRows();
        
        adicionaProduto.backupRow = angular.copy(adicionaProduto.currentRow);
        
        if(solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
            if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO')) {
                adicionaProduto.currentRow.CDPRODUTO = "";
                adicionaProduto.currentRow.NMPRODUTO = "";
            
                setDataFieldReadOnly(adicionaProduto, true);
            } else {
                adicionaProduto.currentRow.CDARVPROD = checkedRows[0].CDARVPROD;
                adicionaProduto.currentRow.CDPRODUTO = checkedRows[0].CDPRODUTO;
                adicionaProduto.currentRow.NMPRODUTO = checkedRows[0].NMPRODUTO;
                    
                adicionaProduto.getField("NMPRODUTO").readOnly = true;
            
                setDataFieldReadOnly(adicionaProduto, false);
            }
        } else {
            adicionaProduto.currentRow.CDPRODUTO = "";
            adicionaProduto.currentRow.NMPRODUTO = "";
            
            setDataFieldReadOnly(adicionaProduto, true);
        }
        
        adicionaProduto.getField('NMPRODUTO').dataSourceFilter = [
			{
				'name': 'P_CDFILIAL',
				'operator': '=',
				'value': solicitacaoWidget.currentRow.CDFILSOLI
			},
			{
				'name': 'P_PRODCOMPRA',
				'operator': '=',
				'value': solicitacaoWidget.currentRow.IDUTPRODPREF
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		ScreenService.openSwipe(adicionaProduto);
    };
    
    this.cancelaAddProduto = function(args) {
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');
        const datasAddProduto = templateManager.container.getWidget('datasAddProduto');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        ScreenService.closeSwipe().then(function() {
            adicionaProduto.currentRow = adicionaProduto.backupRow;
            datasAddProduto.dataSource.data = [];
            produtosWidget.activate();
        });
    };
    
    this.salvaAddProduto = function(validacaoRealizada) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const datasAddProduto = templateManager.container.getWidget('datasAddProduto');
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const justAltAddProd = templateManager.container.getWidget("justAltAddProd");
        
        if(adicionaProduto.isValid()) {
            if(datasAddProduto.dataSource.data.length > 0) {
                if(verifyAlreadyApprovedItems(produtosWidget.dataSource.data)) {
                    verifyItemsWithoutQTSOLIPROD(datasAddProduto.dataSource.data).then(function() {
                        if(validaUtilizaAuditoriaAlteracaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.salvaAddProduto(true)')) {
                            if(solicitacaoWidget.currentRow.IDAUDALTSOL === "S") {
                                justAltAddProd.currentRow.TIPOJUST = 'P';
                                justAltAddProd.currentRow.DSJUSTOPER = '';
                                
                                justAltAddProd.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
                    			justAltAddProd.getField("DSJUSTOPER").reload().then(() => {
                        			ScreenService.openPopup(justAltAddProd);
                    			});
                            } else {
                                this.salvaProduto(produtosWidget);
                            }
                        }
                    }.bind(this));
                }
            } else {
                MessageService.showMessageByCode('DATE_IS_NECESSARY', null, Constants.errorMessage);
            }
        }
    };
    
    function verifyAlreadyApprovedItems(data) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(data.filter(value => value.IDSOLIAPROV === 'S').length > 0 && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'N') {
            return true;
        } else if(data.filter(value => value.IDSOLIAPROV === 'S').length === 0) {
            return true;
        } else if(solicitacaoWidget.currentRow.IDTIPLAN === 'M') {
            return true;
        } else if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') && verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA')) {
            return true;
        } else if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') || verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA') && (solicitacaoWidget.currentRow.IDTIPLAN === 'A' || solicitacaoWidget.currentRow.IDTIPLAN === 'C')) {
            return true;
        } {
            MessageService.showMessageByCode('SOLICITA_BLOCK_NEW_PRODUCT', null, Constants.errorMessage);
            return false;
        }
    }
    
    function verifyItemsWithoutQTSOLIPROD(data) {
        const deferred = ZHPromise.defer();
        
        if(data.filter(value => value.QTSOLIPROD_inline).length === 0) {
            return MessageService.confirmMessageByCode("INSERT_ITEMSOLI_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function validaUtilizaAuditoriaAlteracaoAF(validacaoRealizada, nomeFuncao) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        if(!validacaoRealizada && solicitacaoWidget.currentRow.IDAUDALTSOL == 'S') {
            justificativaAlteracao.getAction('salvar').events[0].code = "args.owner.widget.isValid() ? " + nomeFuncao + " : false";
            justificativaAlteracao.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
            justificativaAlteracao.applyDefaultValue();
            
            const filteredRows = produtosWidget.dataSource.data.filter(row => row.changed === true);
            const verRows = filteredRows.filter(function(row) {
                return !row.QTSOLIPROD_inline;
            });
            
            filteredRows.forEach(row => {
                if(row.QTSOLIPROD_inline) {
                    let QTSOLIPROD_old = row.QTSOLIPROD_inline;
                    
                    row.QTSOLIPROD_new = QTSOLIPROD_old;
                } else {
                    let QTSOLIPROD_old = row.QTSOLIPROD;
                    
                    row.QTSOLIPROD_new = QTSOLIPROD_old;
                }
            });
                
            const dataRow = filteredRows.filter(row => row.QTSOLIPROD_new !== row.changed_QTSOLIPROD).map(value => {
                value.CDFILLANCA = value.CDFILLAN;
                value.DSJUSTOPER = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "";
                
                if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[2] === 'S' && (solicitacaoWidget.currentRow.IDTIPLAN === 'A' || solicitacaoWidget.currentRow.IDTIPLAN === 'C')) {
                    value.IDSOLIAPROV = 'N';
                    value.CDOPERAPROV = null;
                    value.DTHRAPROVSOL = null;
                } else if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N') {
                    value.IDSOLIAPROV = 'S';
                }
                                
                return value;
            });
            
            if(dataRow.length > 0) {
                ScreenService.openPopup(justificativaAlteracao);
                return false;
            } else {
                return true;
            }
        }
        
        return true;
    }
    
    this.salvaProduto = function(produtosWidget) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        let produtoNasceAprovado;
        
        delete solicitacaoWidget.currentRow.__leftActions;
        delete solicitacaoWidget.currentRow.__rightActions;
        
        if (solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[0] === 'S') {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/existeProdutosAprovados', 'Row', solicitacaoWidget.currentRow).then(function(response) {
                if (response.dataset.data.EXISTE_PRODUTOS_APROVADOS) {
                    produtoNasceAprovado = 'S';
                } else {
                    produtoNasceAprovado = 'N';
                }
                
                continuaSalvaProduto(produtoNasceAprovado);
            }).catch(function(response) {
                ScreenService.showMessage(response.error);
            });
        } else if(solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[0] === 'N') {
            produtoNasceAprovado = 'N';
            continuaSalvaProduto(produtoNasceAprovado);
        } else {
            produtoNasceAprovado = 'N';
            continuaSalvaProduto(produtoNasceAprovado);
        }
    };
    
    function continuaSalvaProduto(idSoliAprov) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const dataGrid = templateManager.container.getWidget('datasAddProduto');
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const justAltAddProd = templateManager.container.getWidget("justAltAddProd");
        
        const dataSet = dataGrid.dataSource.data.map(value => {
            value.CDFILIAL      = solicitacaoWidget.currentRow.CDFILSOLI;
            value.CDFILSOLI     = solicitacaoWidget.currentRow.CDFILSOLI;
            value.NRSOLICMP     = solicitacaoWidget.currentRow.NRSOLICMP;
            value.CDPRODUTO     = adicionaProduto.currentRow.CDPRODUTO;
            value.CDFILLANCA    = solicitacaoWidget.currentRow.CDFILLANCA;
            value.__isNew       = true;
            value.CDOPERLANC    = solicitacaoWidget.currentRow.CDOPERLANC;
            value.CDOPERADOR    = solicitacaoWidget.currentRow.CDOPERADOR;
            //value.TXOBSITMSOL   = !dataGrid.dataSource.data[i].TXOBSITMSOL ? null : dataGrid.dataSource.data[i].TXOBSITMSOL;
            //value.DTCMPANTERIOR = !dataGrid.dataSource.data[i].DTCMPANTERIOR ? null : dataGrid.dataSource.data[i].DTCMPANTERIOR;
            value.IDSOLIAPROV   = idSoliAprov;
            value.DSJUSTOPER    = justAltAddProd.currentRow.DSJUSTOPER ? justAltAddProd.currentRow.DSJUSTOPER : "Inclusão de Produto";
            //value.QTVOLUITEMSO  = !dataGrid.dataSource.data[i].QTVOLUITEMSO ? 0 : dataGrid.dataSource.data[i].QTVOLUITEMSO;
            return value;
        });
        
        const datas = dataSet.filter(value => value.QTSOLIPROD);
        
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo', 'Row', datas).then(function() {
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                adicionaProduto.currentRow = adicionaProduto.backupRow;
                dataGrid.dataSource.data = [];
                produtosWidget.activate();
                produtosWidget.reload().then(function(data) {
    			    setProdStripeFooter(data);
    			});
                MessageService.successNotificationByCode('SUCCESS_OPERATION');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    }
    
    function verifyExistsProductAndDate() {
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');

        return produtosWidget.dataSource.data.filter(value => value.CDPRODUTO === adicionaProduto.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    function verifyExistsDate() {
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');
        const datasAddProduto = templateManager.container.getWidget("datasAddProduto");
        
        return datasAddProduto.dataSource.data.filter(value => moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    this.adicionaDataProd = function() {
        const datasAddProduto = templateManager.container.getWidget("datasAddProduto");
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        const selectedDate = adicionaProduto.currentRow.DTPROGENTR;
        const row = {
            "CDFILSOLI": dadosSolicitacaoWidget.currentRow.CDFILSOLI
        };
        
        if(adicionaProduto.currentRow && adicionaProduto.currentRow.DTPROGENTR) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', row).then(function(res) {
                const dado = res.dataset.res[0][0].DTPROCESSA;
                const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                const dataAntes = moment(moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY")).isBefore(moment(dado, "DD/MM/YYYY"));
                if(!dataAntes) {
                    const numDayWeek = moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                    const daysOfWeek = ["WEEK_SUNDAY", "WEEK_MONDAY", "WEEK_TUESDAY", "WEEK_WEDNESDAY", "WEEK_THURSDAY", "WEEK_FRIDAY", "WEEK_SATURDAY"];
            
                    MessageService.getMessageByCode(daysOfWeek[numDayWeek]).then( dayofWeek => {
                        if(verifyExistsProductAndDate()) {
                            if(verifyExistsDate()) {
                                datasAddProduto.dataSource.data.push({
                                    "DTPROGENTR": adicionaProduto.currentRow.DTPROGENTR,
                                    "SEMANA": dayofWeek,
                                    "TXOBSITMSOL": null,
                                    "DTCMPANTERIOR": null,
                                    "QTVOLUITEMSO": 0
                                });
                                datasAddProduto.getAction('CALCULO_MEDIA').isVisible = true;
                            } else {
                                MessageService.showMessageByCode('DATE_ALREADY_INFORMED', null, Constants.errorMessage);
                            }
                        } else {
                            MessageService.showMessageByCode('EXISTS_PRODUCT_DATE', null, Constants.errorMessage);
                        }
                    
                        datasAddProduto.reload();
                    
                        if(selectedDate) {
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        }
                    });
                } else {
                    MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                    adicionaProduto.getField("DTPROGENTR").value(dataProcessamento);
                    adicionaProduto.getField("DTPROGENTR").currentDate = dataProcessamento;
                    adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                }
            }).catch(function(error) {
                console.log(error);
            });
        } else {
            MessageService.showMessageByCode("INVALID_DATA");
            return false;
        }
    };
    
    function verificaDataExistente(data, widgetDestino) {
        const widgetDestinoDataSource = widgetDestino.dataSource.data;

        if (!Util.isEmptyOrBlank(widgetDestinoDataSource)) {
            return widgetDestinoDataSource.filter(dataDestino => dataDestino.DTPROGENTR == data).length <= 0;
        }
        
        return true;
    }
    
    this.adicionaData = function(widget) {
        const widDatas = templateManager.container.getWidget("DATAS");
        const inclSolWidget = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        if(inclSolWidget.currentRow.CDFILSOLI) {
            if(widget.currentRow && widget.currentRow.DTPROGENTR) {
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', inclSolWidget.currentRow).then(function(res) {
                    const dado = res.dataset.res[0][0].DTPROCESSA;
                    const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                    const dataAntes = moment(moment(widget.currentRow.DTPROGENTR, "DD/MM/YYYY")).isBefore(moment(dado, "DD/MM/YYYY"));
                    if(!dataAntes) {
                        var dias      = ["Domingo", "Segunda-feira","Terça-feira","Quarta-feira","Quinta-feira","Sexta-feira","Sábado"];
                        var dayOfWeek = moment(widget.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                        
                        if (verificaDataExistente(widget.currentRow.DTPROGENTR, widDatas)) {
                            widDatas.dataSource.data.push({
                                "DTPROGENTR": widget.currentRow.DTPROGENTR,
                                "SEMANA": dias[dayOfWeek]
                            });
                        } else {
                            MessageService.showMessageByCode("DATA_EXISTS");
                        }
                        widDatas.reload();
                        var diaExistente = widget.widgets[0].dataSource.data.slice(-1)[0].DTPROGENTR;
                        widget.getField("DTPROGENTR").value(moment(diaExistente, "DD/MM/YYYY").add(1, 'days'));
                        
                        widget.getField("DTPROGENTR").currentDate = moment(diaExistente, "DD/MM/YYYY").add(1, 'days');
                            
                        widget.fields[0].element[0].value = widget.currentRow.DTPROGENTR ;
                    } else {
                        MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                        
                        widget.getField("DTPROGENTR").value(dataProcessamento);
                        widget.getField("DTPROGENTR").currentDate = dataProcessamento;
                        widget.fields[0].element[0].value = widget.currentRow.DTPROGENTR ;
                        return false;
                    }
                }).catch(function(error) {
                    console.log(error);
                });
                
            } else {
                MessageService.showMessageByCode("INVALID_DATA");
                return false;
            }
        } else {
            MessageService.showMessageByCode("EMPTY_CDFILSOLI");
            return false;
        }
    };
    
    this.openTelaAlteracaoAutom = function() {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp06900_alteracao_automatica_solicitacao_compras').then(function() {
            const widAlteracao = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
        	const filterRow = {
                    "DTSOLICITACAO" : solicitacaoWidget.currentRow.DTSOLCMP,
                    "NMFILIAL" : [solicitacaoWidget.currentRow.CDFILSOLI],
                    "NRSOLI" : [solicitacaoWidget.currentRow.NRSOLICMP],
                    'ENTREGA': ['ED', 'OL']
        	};
            
            widAlteracao.ABERTA_POR = 'Lançamento da Solicitação de Compras';
            
            Utilities.startFilter(widAlteracao, filterRow).then(function() {
            	widAlteracao.getField('NMFILIAL').reload();
            	widAlteracao.getField('NRSOLI').reload();
            });
        });
    };
    
    this.calcularMediaInclusao = function(widget) {
        var total  = 0;
        var fields = widget.getCheckedRows();
        for(var i  = 0; i<fields.length; i++){
        	total  = parseFloat(total) + parseFloat(fields[i].QTSOLIPROD);	
        }
        var result = parseFloat(total) / parseFloat(i);
        MessageService.showMessageByCode("AVERAGE", { "PARAM": result });
    };
    
    this.calcularMedia = function(widget) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(adicionaProduto.currentRow.CDPRODUTO) {
            if(widget.dataSource.data.length) {
                widget.currentRow.CDFILSOLI = solicitacaoWidget.currentRow.CDFILSOLI;
                widget.currentRow.CDPRODUTO = adicionaProduto.currentRow.CDPRODUTO;
            
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectCalculaMedia','Row', widget.currentRow).then(function(callback){
                    const media = callback.dataset.media;
                    
                    if(media.length === 0) {
                        MessageService.showMessageByCode("NO_AVERAGE");
                    } else {
                        widget.dataSource.data.map(value => {
                            value.QTSOLIPROD_inline = media[0].QTMEDSOLPROD;
                            value.QTSOLIPROD= media[0].QTMEDSOLPROD;
                            value.changed_QTSOLIPROD = media[0].QTMEDSOLPROD;
                            value.changed = true;     
                        });
                        MessageService.showMessageByCode("AVERAGE_SUCCESS");
                        widget.inlineEdit();
                        widget.lastInlineEditingElement = $("#masonry-item-" + widget.id);
                    }
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        } else {
            MessageService.showMessageByCode('PRODUCT_IS_REQUIRED', null, Constants.errorMessage);
        }
    };
    
    this.cancelaEditProdutos = function(widget) {
        cancelEditProducts(widget);
    };
    
    function cancelEditProducts(widget) {
        widget.rollbackInlineEdit();
        widget.list();   
    }
    
    function verifyItemWithoutQTSOLIPROD(row) {
        const deferred = ZHPromise.defer();
        
        if(row.QTSOLIPROD_inline === 0 || row.QTSOLIPROD_inline == "0,000" || row.QTSOLIPROD == "0,000") {
            return MessageService.confirmMessageByCode("INSERT_ITEMSOLI_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    /*function verifyIncreaseProducts(qtSoliProd, qtOriginal, row) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(qtSoliProd > qtOriginal){ 
            if(verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE')) {
                if(permissionsArray.percentAumentar !== null){
                    if(qtSoliProd > parseFloat(qtOriginal + (qtOriginal * (permissionsArray.percentAumentar/100)))){
                        MessageService.showMessageByCode('QTSOLIPROD_CANNOT_BE_CHANGED', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                            return false;  
                        });
                    }
                }
            } else {
                MessageService.showMessageByCode('WITHOUT_PERMISSION', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                    return false;
                });
            }
        }
        
        return true;
    }
    
    function verifyDecreaseProducts(qtSoliProd, qtOriginal, row) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(qtSoliProd < qtOriginal){
            if(verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                if(permissionsArray.percentDiminuir !== null){
                    if(qtSoliProd < parseFloat(qtOriginal - (qtOriginal * (permissionsArray.percentDiminuir/100)))){
                        MessageService.showMessageByCode('QTSOLIPROD_CANNOT_BE_CHANGED', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                            return false;  
                        });
                    }
                }
            } else {
                MessageService.showMessageByCode('WITHOUT_PERMISSION', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                    return false;
                });    
            }
        }
        
        return true;
    }*/
    
    function saveEditProducts(widget) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        const filterdRows = widget.dataSource.data.filter(row => row.changed === true);
        const dataRow = filterdRows.map(value => {
            value.CDFILLANCA = value.CDFILLAN;
            value.DSJUSTOPER = "Alteração de Produto";
            
            if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[2] === 'S' && solicitacaoWidget.currentRow.IDTIPLAN === 'A') {
                value.IDSOLIAPROV = 'N';
                value.CDOPERAPROV = null;
                value.DTHRAPROVSOL = null;
            } else if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N') {
                value.IDSOLIAPROV = 'S';
            }
            
            return value;
        });
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarQuantidadeProd','Row', dataRow).then(function(success) {
            if(success.messages[0].message.length) {
                showlogEditProducts(widget, success.messages[0].message);
            } else {
                ScreenService.closePopup();
                widget.commitInlineEdit();
                widget.list();
                widget.reload().then(function(callback) {
					if(callback.dataset.itens_solicitacao.length === 0) {
						ScreenService.closeSwipe();
						solicitacaoWidget.reload();
						solicitacaoWidget.activate();
					}	
				});
            }
        }, function(err) {
            ScreenService.closePopup();
            cancelEditProducts(widget);
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function showlogEditProducts(widget, success) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        let messages = [];
        
    	messages.push(MessageService.getMessageByCode("WITHOUT_SELECTED_ITEMS"));
    	messages.push(MessageService.getMessageByCode("WITHOUT_PERMISSION"));
    	messages.push(MessageService.getMessageByCode("QTSOLIPROD_CANNOT_BE_CHANGED"));
    	
    	success.push({
    	    MESSAGE: "WITHOUT_PERMISSION"
    	});
    	
    	Promise.all(messages).then((messages) => {
            let arrayMesssages = [];
            let arrayError = [];
            	
            if(messages[0]) arrayMesssages.WITHOUT_SELECTED_ITEMS = messages[0];
            if(messages[1]) arrayMesssages.WITHOUT_PERMISSION = messages[1];
            if(messages[2]) arrayMesssages.QTSOLIPROD_CANNOT_BE_CHANGED = messages[2];

            success.forEach(function(row) {
            	if (!Util.isEmptyOrBlank(row.MESSAGE)) {
				    arrayError = arrayError.concat(setArrayLog(row, arrayMesssages));
				}
            });
            
            ScreenService.closePopup();
            cancelEditProducts(widget);
            widget.reload();

            General.showErrorMessages(widgetOrigem, arrayError, ScreenService.i18n('Log'));
    	});
    }
    
    function setArrayLog(messages, arrayMesssages) {
        let result = [];
        
        result.push(arrayMesssages[messages.MESSAGE].replace('__NMPRODUTO__', messages.NMPRODUTO).replace('__DTPROGENTR__', moment(messages.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).replace('__QTSOLIPROD__', messages.QTSOLIPROD));		
		
		return result;
    }

    function verifyAlreadyApprovedEditadedItem(widget) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[1] == 'N' && widget.currentRow.IDSOLIAPROV == 'S') {
            MessageService.showMessageByCode('QTSOLIPROD_LIBERADA_COMPRA', null, Constants.errorMessage);
            cancelEditProducts(widget);
            return false;
        }

        return true;
    }
    
    this.salvaEditProdutos = function(validacaoRealizada) {
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        if(produtosWidget.isValid()) {
            //if(verifyAlreadyApprovedEditadedItem(produtosWidget)) {
                verifyItemWithoutQTSOLIPROD(produtosWidget.currentRow).then(function() {
                    if(validaUtilizaAuditoriaAlteracaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.salvaEditProdutos(true)')) {
                        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
                        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
                        const filteredRows = produtosWidget.dataSource.data.filter(row => row.changed === true);
                        filteredRows.forEach(row => {
                            if(row.QTSOLIPROD_inline) {
                                let QTSOLIPROD_old = row.QTSOLIPROD_inline;
                                
                                row.QTSOLIPROD_new = QTSOLIPROD_old;
                            } else {
                                let QTSOLIPROD_old = row.QTSOLIPROD;
                                
                                row.QTSOLIPROD_new = QTSOLIPROD_old;
                            }
                        });
                        const dataRow = filteredRows.filter(row => row.QTSOLIPROD_new !== row.changed_QTSOLIPROD).map(value => {
                            value.CDFILLANCA = value.CDFILLAN;
                            value.DSJUSTOPER = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "Alteração de Produto";
                            
                            if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[2] === 'S' && solicitacaoWidget.currentRow.IDTIPLAN === 'A') {
                                value.IDSOLIAPROV = 'N';
                                value.CDOPERAPROV = null;
                                value.DTHRAPROVSOL = null;
                            } else if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N') {
                                value.IDSOLIAPROV = 'S';
                            }
                            
                            return value;
                        });
                        
                        if(dataRow.length > 0) {
                            if(solicitacaoWidget.currentRow.IDAUDALTSOL === "S") {
                                const confirmaJustificativaAlteracao = templateManager.container.getWidget("popupConfirmaJustificativaAlteracao");
                                confirmaJustificativaAlteracao.dataSource.data = dataRow;
                                confirmaJustificativaAlteracao.reload();
                                ScreenService.openPopup(confirmaJustificativaAlteracao);
                            } else {
                                saveEditProducts(produtosWidget);
                            }
                        } else {
                            ScreenService.closePopup();
                            cancelEditProducts(produtosWidget);
                        }
                    }
                }.bind(this));
            //}
        }
    };
    
    function existsPermissionsDeleteItems() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');

        if(verifyOperatorPermission(solicitacaoWidget.currentRow) && (verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_DTENTREGA') || verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_PRODUTO'))) {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                if(solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'S')
                    return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length === 0;
                else
                    return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'N').length > 0;
            } else
                return true;
        }
        return false;
    }
    
    this.excluiDataProduto = function(validacaoRealizada) {
        if(existsPermissionsDeleteItems()) {
    	    MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
    	        const produtosWidget = templateManager.container.getWidget("produtosWidget");
                const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
    	        const checkedRows = produtosWidget.getCheckedRows();
    	        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
    	        const disapprovedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'N');
                
                if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N' || (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && disapprovedItems.length) || solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S') {
                    if(validaUtilizaAuditoriaAlteracaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.excluiDataProduto(true)')) {
                        const dataRow = produtosWidget.dataSource.checkedRows.map(value => {
                            value.CDFILLANCA = value.CDFILLAN;
                            value.CDOPERADOR = getLocalVar('CDOPERADOR');
                            value.DSJUSTOPER = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "";
                            
                            return value;
                        });
                        
                        var newDataRow = dataRow;
                        
                        if(solicitacaoWidget.currentRow.IDPERALTSAPR[1] != 'S')
                            newDataRow = dataRow.filter(row => row.IDSOLIAPROV === 'N');
                        
                        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteQuantidadeProd', 'Row', newDataRow).then(function(success) {
                            MessageService.successNotificationByCode('SUCCESS_OPERATION');
                            ScreenService.closePopup();
                            produtosWidget.unSelectAll();
                            produtosWidget.list();
                            produtosWidget.reload().then(function(callback){
                                if(callback.dataset.itens_solicitacao.length === 0){
                                    ScreenService.closeSwipe();
									solicitacaoWidget.reload();
									solicitacaoWidget.activate();
								}	
                            });
                            if(dataRow.length != newDataRow.length && newDataRow.length > 0 && solicitacaoWidget.currentRow.IDPERALTSAPR[1] != 'S') {
                                MessageService.showMessageByCode("SOLICITA_ITENS_APROVED_EXCLUDE");
                            }
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                } else {
                    MessageService.showMessageByCode("SOLICITA_BLOCK_DELETE_APPROVED_ITEMS");
                }
            });
	    } else {
	        MessageService.showMessageByCode('WITHOUT_PERMISSION', null, Constants.errorMessage);
	    }
    };
    
    function setDataFieldReadOnly(widget, isReadOnly) {
        widget.getField('DTPROGENTR').readOnly = isReadOnly;
        widget.getField('ADD_DATA').isVisible = !isReadOnly;
        
        templateManager.updateTemplate();
    }
    
    /*até aqui*/
    
    self.setFooterTotal = function(){
        var widget = templateManager.container.getWidget('STRIPEFOOTER');
        var detalhesProduto = templateManager.container.getWidget('detalhesProduto');
        var totalqtd = 0;
        var totalvalor = 0;
        for(var i = 0; i < detalhesProduto.dataSource.data.length; i++){
            totalqtd+= parseFloat(detalhesProduto.dataSource.data[i].QTSOLIPROD); 
            totalvalor+= parseFloat(detalhesProduto.dataSource.data[i].VRTOTAL); 
        }
      var mask = {
            type: "float",
            params: {
                symbol: "",
                allowNegative: false,
                precision: 3,
                thousands: ".",
                decimal: ","
            }
      };
        var maskValor = {
            type: "currency",
            params: {
                symbol: "",
                precision: 2,
                thousands: ".",
                decimal: ","
            }
        };
        widget.currentRow.TOTALIZADOR = Util.applyMask(totalqtd, mask, maskEngine, ZhUtil);
        widget.currentRow.QTDTOTAL = Util.applyMask(totalvalor, maskValor, maskEngine, ZhUtil);
        widget.reload();
        
    };
    
    this.verificaProdutoAprovado = function(args) {
        const widStripe = templateManager.container.getWidget("STRIPE");
        const widgetProduto = templateManager.container.getWidget('produtos');
        const isTrue = (widStripe.currentRow.IDTIPLAN == 'A' && widStripe.dataSource.data[0].IDPERALTSAPR[1] == 'N') || (widStripe.dataSource.data[0].IDUTAPROVSOL == 'S' && widgetProduto.dataSource.data[0].IDSOLIAPROV == 'S');
        
        if(isTrue) {
            MessageService.showMessageByCode("QTSOLIPROD_LIBERADA_COMPRA");
            args.e.preventDefault();
        }   
    };
    
    this.widgetProdutoOnEnterOnceEventOnSelectedAll = function(args) {
        let widget = templateManager.container.getWidget("detalhesProduto");
        widget.beforeSelectAll = function(dados) {
            let produtosFiltrados = dados.data.filter(row => row.IDSOLIAPROV == 'S');
            produtosFiltrados.forEach(row => { row.__notSelectable = true; });
        };
    };
    
    /*detalhes*/
    

    function getAprovacaoSolicitacao(item) {
        if (item.IDSOLIAPROV == 'N' && !utilizaAprovacaoSolicitacaoCompras()) {
            return 'S';
        }
        
        return item.IDSOLIAPROV;
    }
    
    function getAprovacaoSolicitacaoGR(item, parameters) {
        if (parameters.IDUTAPROVSOL == 'S' && parameters.IDPERALTSAPR[0] == 'S') {
                return 'N';
            }
        
        return 'S';
    }
    
    function utilizaAprovacaoSolicitacaoCompras() {
        const paramUtilizaAprovacaoSolicitacaoCompras = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal").currentRow.IDUTAPROVSOL;
        
        return paramUtilizaAprovacaoSolicitacaoCompras == 'S';
    }
    
    this.widgetOnEnterOnceDadosSolicitacao = function() {
        const widgetDadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        
        if(Util.isEmptyOrBlank(widgetDadosSolicitacao.externalRow)) {
            let filtroWidget = templateManager.container.getWidget("filtroWidget");
            
            filtroWidget.currentRow.NMFILIAL = getLocalVar('NMFILIAL');
            filtroWidget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
            filtroWidget.getField('NMTIPOCUSTO').readOnly = false;
            
            self.validaGerente(filtroWidget);
            self.validaTipoCusto(filtroWidget);
            //self.validaUnidade(filtroWidget);
            
            General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
                setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
                setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
            }, function(error) {
    			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
    		});
        
            self.abreFiltro(false);
        } else {
            const widgetSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
            self.confirmaFiltroSolicitacao(widgetSolicitacao);
        }
    };
    
    /*self.validaUnidade = function(filtroWidget) {
        if(filtroWidget.currentRow.CDFILIAL) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaFilialSolicitacao','Row', [filtroWidget.currentRow.CDFILIAL]).then(function(res){
                let dataResponse = res.dataset.res;
                
                filtroWidget.dataSource.data = dataResponse;
                
                if(dataResponse[1].IDULTDESTSOL != 'N'){
                    filtroWidget.getField('COMPRADOR').isVisible = true;
                } else {
                    filtroWidget.getField('COMPRADOR').isVisible = false;
                }
                
                if(dataResponse[1].IDULTCOMPSOL != 'N'){
                    filtroWidget.getField('NMDESTSOLI').isVisible = true;
                } else {
                    filtroWidget.getField('NMDESTSOLI').isVisible = false;
                }
            }).catch(function(erro) {
                if(erro.errorCode === 100) {
                    ScreenService.showMessage(erro.error);
                    filtroWidget.getField('NMDESTSOLI').isVisible = false;
                    filtroWidget.getField('COMPRADOR').isVisible = false;
                } else {
                    ScreenService.showMessage(erro);
                }
            });
        }
    };*/
    
    self.validaGerente = function(filtroWidget) {
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaGerente','Row', [getLocalVar('CDOPERADOR'), getLocalVar('NRORG')]).then(function(ger){
            
            var dataGerente = ger.dataset;
            
            if(dataGerente.ger[0] == 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = false;
                filtroWidget.getField('APROVACAO').isVisible    = false;
                
            }else if(dataGerente.ger[0] != 0 && dataGerente.ger[1] == 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = true;
                
            }else if(dataGerente.ger[0] != 0 && dataGerente.ger[1] != 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = true;
                filtroWidget.getField('APROVACAO').isVisible    = true;
            }
        
        });
    };
    
    this.confirmaFiltroFilial = function(widget) {
        var widSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
                
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectSoliciFilial','Row', widget.currentRow).then(function(res){
            var dados = res;
            widSolicitacao.dataSource.data = dados.dataset.res[0];
            
        });
    };
    
    
    this.carregaDataSource = function(widget) {
        
        var filtroWidget        = templateManager.container.getWidget('filtroWidget');
        filtroWidget.currentRow.CDFILIAL = filtroWidget.currentRow.CDFILIAL ? filtroWidget.currentRow.CDFILIAL : templateManager.container.getWidget('dadosSolicitacao').currentRow.CDFILSOLI;
        
        widget.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filtroWidget.currentRow.CDFILIAL
            },
            {
                "name": "P_DTSOLINI",
                "operator": "=",
                "value": filtroWidget.currentRow.DTSOLINI
            },
            {
                "name": "P_DTSOLFIM",
                "operator": "=",
                "value": filtroWidget.currentRow.DTSOLFIM
            },
            {
                "name": "P_TSOLICITA",
                "operator": "=",
                "value": filtroWidget.currentRow.TSOLICITA
            },
            {
                "name": "P_COMPRADOR",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.COMPRADOR) ? filtroWidget.currentRow.COMPRADOR.join('_') : ""
            },
            {
                "name": "P_TCOMPRADOR",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.COMPRADOR) ? "" : 'T'  
            },
            {
                "name": "P_DESTINO",
                "operator": "=",
                "value": filtroWidget.currentRow.CDDESTSOLI
            },
            {
                "name": "P_TDESTINO",
                "operator": "=",
                "value": filtroWidget.currentRow.TCDDESTSOLI
            },
            {
                "name": "P_TCDGERENTE",
                "operator": "=",
                "value": filtroWidget.currentRow.TCDGERENTE
            },
            {
                "name": "P_CDGERENTE",
                "operator": "=",
                "value": filtroWidget.currentRow.CDGERENTE
            },
            {
                "name": "P_STATUS",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.APROVACAO) ? filtroWidget.currentRow.APROVACAO.join('_') : "T"
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": filtroWidget.currentRow.CDOPERADOR
            },
            {
                "name": "P_TENTREGA",
                "operator": "=",
                "value": filtroWidget.currentRow.TENTREGA
            },
            {
                "name": "P_ENTRINI",
                "operator": "=",
                "value": filtroWidget.currentRow.ENTRINI
            },
            {
                "name": "P_ENTRFIM",
                "operator": "=",
                "value": filtroWidget.currentRow.ENTRFIM
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        
        widget.reload();
    };
    
    this.controlaFieldSolicitacao = function(field) {
        const widget = field.widget;
        if(widget.currentRow.CDFILIAL_SOL) {
            widget.getField("NRSOLICMP_SOL").readOnly = false;
            if(widget.currentRow.NRSOLICMP_SOL)
                widget.getField("NRSOLICMP_SOL").clearValue();
            this.validaFieldSolicitacao(widget.getField("NRSOLICMP_SOL"));
        } else {
            widget.getField("NRSOLICMP_SOL").readOnly = true;
            if(widget.currentRow.NRSOLICMP_SOL)
                widget.getField("NRSOLICMP_SOL").clearValue();
        }
        widget.getField("NRSOLICMP_SOL").reload();
    };
    
    this.validaFieldSolicitacao = function(field) {
        field.dataSourceFilter = [
            {
                "name":"CDFILSOLI",
                "operator": "=",
                "value": field.widget.currentRow.CDFILIAL_SOL
            },
            {
                "name":"NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        field.reload();
    };
    
    this.validaDestinoSolicitacao = function(field){
        field.dataSourceFilter = [
            {
                "name":"P_CDFILIAL",
                "operator": "=",
                "value": field.widget.currentRow.CDFILIAL
            }
        ];
        field.reload();
    };
    
    this.adicionaSolicitacao = function() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const diasEntrega = templateManager.container.getWidget("DATAS");
        
        inclusaoSolicitacao.isVisible = true;
        inclusaoSolicitacao.activate();
        principal.enabled = true;
        principal.isVisible = true;
        principal.template = "widget/form.html";
        diasEntrega.enabled = true;
        diasEntrega.isVisible = true;
        diasEntrega.template = "widget/grid.html";
        principal.activate();
        General.edit(principal);
        delete principal.getField("NMPRODINI").validations;
        delete principal.getField("NMPRODFIN").validations;
        principal.getField("NMPRODINI").reload();
        principal.getField("NMPRODFIN").reload();
        
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        templateManager.container.getWidget("produtosWidget").enabled = false;
        templateManager.container.getWidget("justificativaAlteracao").enabled = false;
        principal.currentRow.NRSOLICMP_SOL = "";
        principal.currentRow.NMPRODINI = "";
        principal.currentRow.NMPRODFIN = "";
        principal.currentRow.NMOPERADOR = "";
        principal.currentRow.DSJUSTSOL = "";
        principal.currentRow.CDPRODINI = "";
        principal.currentRow.CDPRODFIN = "";
        principal.currentRow.CDOPERADOR = "";
        principal.currentRow.CDJUSTSOL = "";
        
        principal.currentRow.CDFILIAL = solicitacaoWidget.currentRow.CDFILSOLI;
        principal.currentRow.CDFILSOLI = solicitacaoWidget.currentRow.CDFILSOLI;
        principal.currentRow.NMFILIAL = solicitacaoWidget.currentRow.NMFILIAL;
        principal.currentRow.CDFILCENT = solicitacaoWidget.currentRow.CDFILCENTCMP;
        principal.currentRow.CDFILCENTCMP = solicitacaoWidget.currentRow.CDFILCENTCMP;
        principal.currentRow.NMFILCENT = solicitacaoWidget.currentRow.CDFILCENTCMP+ " | " +solicitacaoWidget.currentRow.NMCENTCMP;
        principal.currentRow.IDUTAPROVSOL = solicitacaoWidget.currentRow.IDUTAPROVSOL;
        principal.currentRow.IDPERALTSAPR = solicitacaoWidget.currentRow.IDPERALTSAPR;
        principal.currentRow.IDSISDOS = solicitacaoWidget.currentRow.IDSISDOS;
    };
    
    this.preparaCurrentRowDadosSolicitacao = function(){
        var widget          = templateManager.container.getWidget('dadosSolicitacao');
        var widSolicita     = templateManager.container.getWidget('solicitacaoWidget');
        var OLD_CDFILSOLI   = widSolicita.currentRow.CDFILSOLI;
        var OLD_CDFILLANCA  = widSolicita.currentRow.CDFILLANCA;
        var OLD_NRSOLICMP   = widSolicita.currentRow.NRSOLICMP;
        
        
        widget.currentRow.OLD_CDFILSOLI  = OLD_CDFILSOLI;
        widget.currentRow.OLD_CDFILLANCA = OLD_CDFILLANCA;
        widget.currentRow.OLD_NRSOLICMP  = OLD_NRSOLICMP;
    };
    
    
    this.readOnlyJustificativa = function(widget) {
        if(widget.currentRow.EXTRA) {
            widget.getField("CDJUSTSOL").readOnly    = false;
            widget.getField("CDJUSTSOL").validations = {required: true};
        } else {
            widget.getField("CDJUSTSOL").readOnly    = true;
            widget.getField("CDJUSTSOL").value("");
            widget.getField("CDJUSTSOL").validations = {};
        }
    };
    
    this.excluiData = function(row, widget) {
        var rows    = widget.dataSource.data;
        var auxRows = [];
        
        for(var i = 0; i < rows.length; i++) {
            if(row.DTPROGENTR !== rows[i].DTPROGENTR) {
                auxRows.push(rows[i]);
            }
        }
        
        widget.dataSource.data = auxRows;
        widget.reload();
    };

    this.nivelCompletoProduto = function() {
        return General.getLevelByMask('GER_CDPICTPROD', '1').length;
    };
    
    this.setReadOnlyAddDateFields = function (widget) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const checkedRows = produtosWidget.getCheckedRows();
        
        if (widget.currentRow.CDPRODUTO) {
            if(solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
                if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA')) {
                    setDataFieldReadOnly(widget, false);
                } else {
                    setDataFieldReadOnly(widget, true);
                    
                    widget.currentRow.DTPROGENTR = moment(checkedRows[0].DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY");
            
                    this.adicionaDataProd(widget);
                }
            } else {
                setDataFieldReadOnly(widget, false);
            }
        } else {
            setDataFieldReadOnly(widget, true);
        }
    };
    
    /*this.abreDetalhesProduto = function(widget) {
        var widDetalhesProduto  = templateManager.container.getWidget("detalhesProduto");
        var widSolicitacao      = templateManager.container.getWidget("solicitacaoWidget");
        
        widget.currentRow.CDFILSOLI  = widSolicitacao.currentRow.CDFILSOLI;
        widget.currentRow.CDFILLANCA = widSolicitacao.currentRow.CDFILLANCA;
        widget.currentRow.NRSOLICMP  = widSolicitacao.currentRow.NRSOLICMP;
        
        ScreenService.openSwipe(widDetalhesProduto);
    };*/
    
    /*this.carregarDetalhesProduto = function(widget){
        widget.dataSourceFilter = [
            {
                "name": "P_NRSOLICMP",
                "operator": "=",
                "value": widget.getParent().currentRow.NRSOLICMP
            },
            {
                "name": "P_CDFILLAN",
                "operator": "=",
                "value": widget.getParent().currentRow.CDFILLANCA
            },
            {
                "name": "P_CDPRODUTO",
                "operator": "=",
                "value": widget.getParent().currentRow.CDPRODUTO
            },
            {
                "name": "P_CDFILSOLI",
                "operator": "=",
                "value": widget.getParent().currentRow.CDFILSOLI
            },
            {
                "name": "P_NRTIPOCUSTO",
                "operator": "=",
                "value":templateManager.container.getWidget('filtroWidget').currentRow.CDTIPOCUSTO
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        widget.unSelectAll();
        widget.reload();
    };*/
    
    self.validaData = function(widget){
        var bool = true;
        widget.getParent().dataSource.data.forEach(function(data){
            if(widget.currentRow.DTPROGENTR == data.DTPROGENTR.substr(0, 10)){
                bool = false;
            }
        });
        return bool;
    };
    
    this.backProdutos = function() {
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        ScreenService.closeSwipe();
        produtosWidget.unSelectAll();
        produtosWidget.reload();
    };
    
    this.limpaDestinoSoli = function() {
        
        let widget = templateManager.container.getActiveWidget();
        
        widget.getField('NMDESTSOLI').clearValue();
     
    };
    
    
    this.openTelaAprovacao = function() {
        var widget = templateManager.container.getWidget("filtroWidget");
        // ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp06400aprovacao_desaprovacao_solicitacao_compras').then(function() {
        //     var widAprovacao = templateManager.container.getActiveWidget();
        // 	var filterRow = {
        //             "DTENTREGA" : widget.currentRow.DTENTREGA ,
        //             "DTSOLICITACAO" : widget.currentRow.DTSOLICITACAO,
        //             "NMGRUPFILI" : widget.currentRow.NMGRUPFILI ,
        //             "CDGRUPFILI" : widget.currentRow.CDGRUPFILI,
        //             "CDFILIAL" : widget.currentRow.CDFILIAL ,
        //             "NMFILIAL" : widget.currentRow.NMFILIAL,
        //             "NRSOLI" : widget.container.getWidget('STRIPE').currentRow.NRSOLICMP,
        //             'ENTREGA': [
        // 	    		'ED',
        // 	    		'OL'
        // 	    	]
        // 	 };
        //      Utilities.startFilter(widAprovacao, filterRow);
        // });
        
        $http.get('assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/json/containers/cmp06400aprovacao_desaprovacao_solicitacao_compras.json').then(function(result) {
			var containerAprovacaoDesaprovacao = this.containerFactory(result.data);
			const filtro = templateManager.container.getWidget('dadosSolicitacao').externalRow;
			templateManager.container = containerAprovacaoDesaprovacao;
			onEnterAprovacaoDesaprovacao(templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid"), filtro);
		}.bind(metaDataFactory), function(error) {
			throw error;
		});
    };
    
    function onEnterAprovacaoDesaprovacao(externWidget, dados) {
        dados.IDOPERACAO = 'R';
        
        externWidget.externParams = dados;
    }
    
    this.carregaGridJustificativa = function(widget){
        var widSolicitacao      = templateManager.container.getWidget('solicitacaoWidget');
        widget.dataSourceFilter = [
            {
                "name": "P_CDFILSOLMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.CDFILSOLI
            },
            {
                "name": "P_CDFILLANMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.CDFILLANCA
            },
            {
                "name": "P_NRSOLIMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.NRSOLICMP
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        
        widget.reload();
    };
    
    this.limpaFields = function(widget){
        //widget.currentRow = {};
        widget.backupRow = widget.currentRow;
        validaCamposAddDataInclusaoCotacao(widget);
    };
    
    function validaCamposAddDataInclusaoCotacao(widget) {
        const widgetProduto = templateManager.container.getWidget('prodnovo');
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra','Row', widgetProduto.currentRow).then(function(res){
            let dados = res.dataset.res[0];
            
            let fieldDataCompraAnterior = widget.getField('DTCMPANTERIOR');
            let fieldObservacao = widget.getField('TXOBSITMSOL');
            
            if(dados[0].IDAPROVITMSOLGR == 'S'){
                fieldDataCompraAnterior.isVisible = true;
                fieldDataCompraAnterior.validations = {"required": true};
                fieldObservacao.isVisible = true;
            }else{
                delete fieldDataCompraAnterior.validations;
                fieldDataCompraAnterior.isVisible = false;
                fieldObservacao.isVisible = false;
            }
            
            templateManager.updateTemplate();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.abreDetalhesJustificativas = function(widget) {
        widget.backupRow = angular.copy(widget.currentRow);
        
        var activeWidget = templateManager.container.getActiveWidget();
        
        if(templateManager.container.getWidget("stripeWidget").currentRow.IDUTLOPERSOL == 'S') {
            widget.view();
            widget.getAction('voltar').isVisible = true;
        } else {
		    widget.getAction('editaJustificativa').isVisible = true;
        }
        
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
        } else {
            widget.getField("DSJUSTOPER").template = "field/text-edit.html";
        }
        
        widget.redraw();
    };
    
    this.editaJustificativa = function(widget) {
	    widget.edit();
    }; 
    
    this.salvaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPER = widget.currentRow.DSJUSTOPER ? widget.currentRow.DSJUSTOPER : null;
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaJustificativa', 'Row', widget.currentRow).then(function(success) {
            ScreenService.closeSwipe();
    		widget.list();
    		widget.activate();
    		ScreenService.notificationMessage("Salvo com sucesso!", "success");
        });
    };
    
    this.cancelaJustificativa = function(widget) {
        ScreenService.closeSwipe().then(function() {
    		widget.reload();
    		widget.list();
    		widget.activate();
        });
    };
    
    this.cancelaEditQuantidade = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
        widget.getAction("CALCULO_MEDIA").isVisible = true;
    };
    
    this.cancelaEditQuantidade = function(widget) {
        widget.commitInlineEdit();
        widget.list();
        widget.getAction("CALCULO_MEDIA").isVisible = true;
    };
    
    //adcionar solicitação
    
    this.abreDetalhesProdNovo        = function(widget) {
        var widDetalhesProduto       = templateManager.container.getWidget("detalhesProdNovo");
        var widSolicitacao           = templateManager.container.getWidget("solicitacaoWidget");
        var widIncluSolicita         = templateManager.container.getWidget("principal");
        var widDatas                 = templateManager.container.getWidget("DATAS");
        
        widget.currentRow.CDFILSOLI  = widIncluSolicita.currentRow.CDFILSOLI;
        widget.currentRow.CDFILLANCA = widIncluSolicita.currentRow.CDFILLANCA;
        widget.currentRow.NRSOLICMP  = widIncluSolicita.currentRow.NRSOLICMP;
        widget.currentRow.NRORG      = getLocalVar('NRORG');
        
        var diasEntrega              = widDatas.dataSource.data;
        
        if(widget.dataSource.data[widget.currentRow.__index].__isNew == false){
            
            return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectDetalhesProduto','Row', widget.currentRow).then(function(res){
                var dados                           = res;
                widDetalhesProduto.dataSource.data  = dados.dataset.res[0];
                var ar                              = [];
        
                for(var k = 0; k < widDetalhesProduto.dataSource.data.length; k++){
                	for(var j = 0; j < ar.length; j++){
                		if(widDetalhesProduto.dataSource.data[k].DTPROGENTR.substr(0, 10) == ar[j].DTPROGENTR){   
                			ar.push(widDatas.dataSource.data.slice(j, 1));
                		}
                	}
                }
                for(var l = 0; l < ar.length; l++){
                    widDetalhesProduto.dataSource.data.push(ar[l]);
                }
                ScreenService.openSwipe(widDetalhesProduto);
            }); 
        }else{
            days.forEach(function(dias) {
                dias.forEach(function(dia){
                    dia.QTSOLIPROD = 0; 
                    dia.__isNew = true;    
                });
                if(dias.CDARVPROD == widget.currentRow.CDARVPROD){
                    widDetalhesProduto.dataSource.data = dias;
                }
            });
            
            ScreenService.openSwipe(widDetalhesProduto); 
        }
    };
    
    this.adicionaProdNovo = function() {
        const widgetProdNovo = templateManager.container.getWidget("adicionaProdNovo");
        const widgetGridDatasProdNovo = templateManager.container.getWidget("datasAddProdNovo");
        
        widgetProdNovo.currentRow.CDPRODUTO     = "";
        widgetProdNovo.currentRow.NMPRODUTO     = "";
        
        widgetGridDatasProdNovo.dataSource.data = [];
        
        setDataFieldReadOnly(templateManager.container.getWidget('adicionaProdNovo'), true);
        
        ScreenService.openSwipe(widgetProdNovo);
    };
    
    this.excluiProdNovo = function(widget) {
        var dataToQuery = [];
        var principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        for(var i = 0; i < widget.getCheckedRows().length; i++){
        	for(var j = 0; j < widget.dataSource.data.length; j++){
        		if(widget.dataSource.data[j]){
        		    if(!widget.getCheckedRows()[i].__isNew){
                        widget.dataSource.data[j].CDFILSOLI  = principal.currentRow.CDFILSOLI;
                        widget.dataSource.data[j].CDFILLANCA = principal.currentRow.CDFILLANCA;
                        widget.dataSource.data[j].NRSOLICMP  = principal.currentRow.NRSOLICMP;
                        widget.dataSource.data[j].NRORG      = getLocalVar('NRORG');
                        
                        if(widget.dataSource.data[j].__isSelected == true){
                            dataToQuery.push(widget.dataSource.data[i]);
                        }
            	    }
                    if(widget.getCheckedRows()[i].CDARVPROD == widget.dataSource.data[j].CDARVPROD)		 {
                        widget.dataSource.data.splice(j, 1);
                    }
                }
            }
        }
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/verificaDetalhesProduto','Row', dataToQuery).then(function(success){
            ScreenService.notificationMessage('Excluido com sucesso');
            widget.updateCheckedRows();
        });
    };
    
    this.cancelaEditProdNovo = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
     
    };
    
    this.salvaEditProdNovo = function(widget) {
        var dataRowNew = [];
        var dataRowOld = [];
        var widStripe = templateManager.container.getWidget('STRIPE');
        for(var i = 0; i < widget.dataSource.data.length; i++){
            widget.dataSource.data[i].CDFILIAL       = templateManager.container.getWidget('principal').currentRow.CDFILIAL;
            widget.dataSource.data[i].CDFILSOLI      = templateManager.container.getWidget('principal').currentRow.CDFILSOLI;
            widget.dataSource.data[i].NRSOLICMP      = widget.getParent().currentRow.NRSOLICMP;
            widget.dataSource.data[i].CDPRODUTO      = widget.getParent().currentRow.CDPRODUTO;
            widget.dataSource.data[i].CDFILLANCA       = templateManager.container.getWidget('principal').currentRow.CDFILLANCA;
            widget.dataSource.data[i].TXOBSITMSOL    = null;
            widget.dataSource.data[i].DTCMPANTERIOR  = null;
            widget.dataSource.data[i].NRORG          = getLocalVar('NRORG');
            widget.dataSource.data[i].CDOPERADOR     = templateManager.container.getWidget('principal').currentRow.CDOPERADOR;
            widget.dataSource.data[i].CDOPERLANC     = templateManager.container.getWidget('principal').currentRow.CDOPERADOR;
            widget.dataSource.data[i].DSJUSTOPER     = null;
            widget.dataSource.data[i].OLD_QTSOLIPROD = widget.dataSource.data[i].changed_QTSOLIPROD;
            widget.dataSource.data[i].QTVOLUITEMSO   = widget.dataSource.data[i].QTVOLUITEMSO ? widget.dataSource.data[i].QTVOLUITEMSO : 0;
            
            const parameters = widStripe.dataSource.data[0] || widStripe.dataSource.data[1];
            
            if (parameters.IDUTAPROVSOL == 'N') {
                widget.dataSource.data[i].IDSOLIAPROV = 'S';
            } else {
                if (parameters.IDPERALTSAPR[0] == 'S'){
                    widget.dataSource.data[i].IDSOLIAPROV = 'S';
                }else{
                    widget.dataSource.data[i].IDSOLIAPROV = 'N';
                }
            }
            
            if (paramGeral.IDSISDOS == '3') {
                widget.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacaoGR(widget.dataSource.data[i], parameters);
            } else {
                widget.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacao(widget.dataSource.data[i]);
            }
            
            if(widget.dataSource.data[i].changed == true){
                if(widget.dataSource.data[i].__isNew == true){
                    dataRowNew.push(widget.dataSource.data[i]);
                    ScreenService.closeSwipe();
                    widget.getParent().activate();
                }else{
                    dataRowOld.push(widget.dataSource.data[i]);
                }
            }
        }
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo','Row', dataRowNew).then(function(success) {
            widget.getParent().dataSource.data[widget.getParent().currentRow.__index].__isNew = false;
            widget.dataSource.data[widget.currentRow.__index].__isNew               = false;
        }, function(error) {
		    MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT', null, { type: 'ERROR' });
		});
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarQuantidadeProd','Row', dataRowOld);
        
        widget.getParent().currentRow.ALTER = true;
        widget.commitInlineEdit();
        widget.list();
        widget.getParent().activate();
    };
    
    this.adicionaDataProdNovo = function() {
        var widget = templateManager.container.getWidget("adicionaDataProdNovo");
        ScreenService.openPopup(widget);
    };
    
    this.excluiDataProdNovo = function(widget) {
        var dataRow = [];
        
        if(widget.getParent().currentRow.__isNew){
            widget.dataSource.data.forEach(function(data, key){
                if(data.__isSelected){
                    widget.dataSource.data.splice(key, 1);
                }
            });
        }else{
            for(var i = 0; i < widget.dataSource.data.length; i++){
                widget.dataSource.data[i].CDFILSOLI = widget.getParent().currentRow.CDFILSOLI;
                widget.dataSource.data[i].CDPRODUTO = widget.getParent().currentRow.CDPRODUTO;
                widget.dataSource.data[i].NRSOLICMP = widget.getParent().currentRow.NRSOLICMP;
                widget.dataSource.data[i].CDFILLANCA  = widget.getParent().currentRow.CDFILLANCA;
                widget.dataSource.data[i].NRORG  = getLocalVar('NRORG');
                if(widget.dataSource.data[i].__isSelected == true){
                    dataRow.push(widget.dataSource.data[i]);
                }
            }
            
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteQuantidadeProd', 'Row', dataRow).then(function(success) {
                widget.reload();
            });
        }
    };
    
    function verifyExistsProdNovoAndDate() {
        const produtosWidget = templateManager.container.getWidget("prodnovo");
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        
        return produtosWidget.dataSource.data.filter(value => value.CDPRODUTO === adicionaProduto.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    function verifyExistsNovoDate() {
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        const datasAddProduto = templateManager.container.getWidget("datasAddProdNovo");
        
        return datasAddProduto.dataSource.data.filter(value => moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    this.addDataProdNovo = function() {
        const datasAddProduto = templateManager.container.getWidget("datasAddProdNovo");
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        const inclSolWidget = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const selectedDate = adicionaProduto.currentRow.DTPROGENTR;
        
        if(adicionaProduto.currentRow && adicionaProduto.currentRow.DTPROGENTR) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', inclSolWidget.currentRow).then(function(res) {
                const dado = res.dataset.res[0][0].DTPROCESSA;
                const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                const dataAntes = moment(moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY")).isBefore(moment(dado, "DD/MM/YYYY"));
                if(!dataAntes) {
                    const numDayWeek = moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                    const daysOfWeek = ["WEEK_SUNDAY", "WEEK_MONDAY", "WEEK_TUESDAY", "WEEK_WEDNESDAY", "WEEK_THURSDAY", "WEEK_FRIDAY", "WEEK_SATURDAY"];
            
                    MessageService.getMessageByCode(daysOfWeek[numDayWeek]).then(dayOfWeek => {
                    if(verifyExistsProdNovoAndDate()) {
                        if(verifyExistsNovoDate()) {
                            datasAddProduto.dataSource.data.push({
                                "DTPROGENTR": adicionaProduto.currentRow.DTPROGENTR,
                                "SEMANA"    : dayOfWeek
                            });
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        } else {
                            MessageService.showMessageByCode('DATE_ALREADY_INFORMED', null, Constants.errorMessage);
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        }
                    } else {
                        MessageService.showMessageByCode('EXISTS_PRODUCT_DATE', null, Constants.errorMessage);
                        adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                        adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                        adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                    }
                });
                datasAddProduto.reload();
                } else {
                    MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                    adicionaProduto.getField("DTPROGENTR").value(dataProcessamento);
                    adicionaProduto.getField("DTPROGENTR").currentDate = dataProcessamento;
                    adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                }
            }).catch(function(error) {
                console.log(error);
            });
        } else {
            MessageService.showMessageByCode("INVALID_DATA");
            return false;
        }
    };
    
    this.cancelaAddProdNovo = function(args) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("prodnovo").activate();
    };
    
    this.cancelaAddDataProdNovo = function(widget) {
        ScreenService.closePopup();
        widget.currentRow = {};
        templateManager.container.getWidget("detalhesProdNovo").activate();
    };
    
    this.salvaAddProdNovo = function(dataGrid) {
        var adicionaProduto     = templateManager.container.getWidget("adicionaProdNovo");
        var widInclusaoSolicita = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        var produtos            = templateManager.container.getWidget("prodnovo");
        
        if(adicionaProduto.isValid()) {
            let produtosCadastrados = produtos.dataSource.data.find((produto) => produto.CDPRODUTO == adicionaProduto.currentRow.CDPRODUTO && produto.DTPROGENTR == adicionaProduto.currentRow.DTPROGENTR);
            if (!produtosCadastrados || Util.isEmptyObject(produtosCadastrados)) {
                // produtos.dataSource.data.push({
                //     "CDARVPROD": adicionaProduto.currentRow.CDARVPROD,
                //     "CDPRODUTO": adicionaProduto.currentRow.CDPRODUTO,
                //     "NMPRODUTO": adicionaProduto.currentRow.NMPRODUTO,
                //     "__isNew"  : false
                // });
                    
                for(var i = 0; i < dataGrid.dataSource.data.length; i++) {
                    dataGrid.dataSource.data[i].CDFILIAL      = widInclusaoSolicita.currentRow.CDFILIAL;
                    dataGrid.dataSource.data[i].CDFILSOLI     = widInclusaoSolicita.currentRow.CDFILSOLI;
                    dataGrid.dataSource.data[i].NRSOLICMP     = widInclusaoSolicita.currentRow.NRSOLICMP;
                    dataGrid.dataSource.data[i].CDPRODUTO     = adicionaProduto.currentRow.CDPRODUTO;
                    dataGrid.dataSource.data[i].CDARVPROD     = adicionaProduto.currentRow.CDARVPROD;
                    dataGrid.dataSource.data[i].CDFILLANCA    = widInclusaoSolicita.currentRow.CDFILLANCA;
                    dataGrid.dataSource.data[i].CDOPERADOR    = widInclusaoSolicita.currentRow.CDOPERLANC;
                    dataGrid.dataSource.data[i].CDOPERLANC    = widInclusaoSolicita.currentRow.CDOPERLANC;
                    dataGrid.dataSource.data[i].DTCMPANTERIOR = null;
                    dataGrid.dataSource.data[i].DSJUSTOPER    = "";
                    dataGrid.dataSource.data[i].TXOBSITMSOL   = null;
                    dataGrid.dataSource.data[i].NMPRODUTO     = adicionaProduto.currentRow.NMPRODUTO;
                    dataGrid.dataSource.data[i].__isNew       = true;
                    dataGrid.dataSource.data[i].QTVOLUITEMSO  = dataGrid.dataSource.data[i].QTVOLUITEMSO ? dataGrid.dataSource.data[i].QTVOLUITEMSO : 0;
                    
                    const dadosStripe = widInclusaoSolicita.currentRow;
                    
                    if (dadosStripe.IDUTAPROVSOL == 'N') {
                        dataGrid.dataSource.data[i].IDSOLIAPROV = 'S';
                    } else {
                        if (dadosStripe.IDPERALTSAPR[0] == 'S') {
                            dataGrid.dataSource.data[i].IDSOLIAPROV = 'S';
                        } else {
                            dataGrid.dataSource.data[i].IDSOLIAPROV = 'N';
                        }
                    }
                    
                    dataGrid.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacao(dataGrid.dataSource.data[i]);
                    
                    dataGrid.dataSource.data[i].NRORG   = getLocalVar('NRORG');
                    dataGrid.dataSource.data[i].__isNew = true;
                }
                
                for(let i = 0; i < dataGrid.dataSource.data.length; i++) {
                    if(dataGrid.dataSource.data[i].QTSOLIPROD) {
                        if(parseFloat(dataGrid.dataSource.data[i].QTSOLIPROD.replace(",", ".")) > 0) {
                            produtos.dataSource.data.push(dataGrid.dataSource.data[i]);
                        }
                    }
                }
                
                ScreenService.closeSwipe();
                produtos.activate();
                
                // General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo', 'Row', datas).then(function(success) {
                //     ScreenService.closeSwipe();
                //     produtos.activate();    
                // }, function(error) {
                //     MessageService.showMessageByCode((error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT'), null, { type: 'ERROR' });
                // });
            } else {
                MessageService.showMessageByCode("PRODUCT_ALREADY_REGISTERED_NO_PARAM");
            }
            //this.validaProduto(adicionaProduto.currentRow.CDPRODUTO);
        }
    };
    
    this.concluirOperacao = function(widget) {
        ScreenService.confirmMessage('Concluir processo\n Obs.: Datas com quantidades zeradas serão deletadas, continuar?', 'question', function() {
			//var stripe = templateManager.container.getWidget("STRIPE");
			var widgetPrincipal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
			var widDatas = templateManager.container.getWidget("DATAS");
			widget.list();
			widget.isVisible = false;
			
			//ScreenService.openPopup(templateManager.container.getWidget('solicitacaoWidget'));
			//templateManager.container.getWidget('solicitacaoWidget').activate();
			templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
            templateManager.container.getWidget("produtosWidget").enabled         = true;
            templateManager.container.getWidget("produtosWidget").isVisible       = true;
            templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
            templateManager.container.getWidget("dadosSolicitacao").activate();
            //if(!stripe.dataSource.data[0]){
            //    self.abreFiltro(false);
            //}
            widDatas.dataSource.data = [];
            widDatas.getParent().currentRow = {};
            widgetPrincipal.currentRow = widgetPrincipal.backupRow;
            //stripe.getAction("abreFiltro").isVisible                              = true;
            //stripe.getAction("listaSoli").isVisible                               = true;
		});        
    };
    
    self.setNrorg = function(){
        templateManager.container.getWidget("dadosSolicitacao").currentRow.NRORG        = getLocalVar('NRORG');
        templateManager.container.getWidget("produtos").currentRow.NRORG                = getLocalVar('NRORG');
        templateManager.container.getWidget("adicionaDataProduto").currentRow.NRORG     = getLocalVar('NRORG');
        templateManager.container.getWidget("detalhesProduto").currentRow.NRORG         = getLocalVar('NRORG');
        templateManager.container.getWidget("justificativaAlteracao").currentRow.NRORG  = getLocalVar('NRORG');
        templateManager.container.getWidget("principal").currentRow.NRORG               = getLocalVar('NRORG');
        templateManager.container.getWidget("adicionaDataProdNovo").currentRow.NRORG    = getLocalVar('NRORG');
        templateManager.container.getWidget('STRIPE').currentRow.NRORG                  = getLocalVar('NRORG');
    };
    
    this.mudaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPER = "";
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.reload().then(() => {
            	widget.activate();
            });
        } else {
            widget.getField("DSJUSTOPER").template = "field/text-edit.html";
            widget.reload().then(() => {
            	widget.activate();
            });
        }
    };
    
    this.validaProdutoCadastrado = function (field) {
        const produtos = templateManager.container.getWidget("prodnovo");
        const widget = field.widget;
        
        // let validacao = produtos.dataSource.data.filter(value => value.CDPRODUTO === widget.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(widget.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
        
        // let produtosCadastrados = produtos.dataSource.data.find((produto) => produto.CDPRODUTO == widget.currentRow.CDPRODUTO);
        // if (produtosCadastrados && !Util.isEmptyObject(produtosCadastrados)) {
        //     MessageService.showMessageByCode("PRODUCT_ALREADY_REGISTERED_NO_PARAM");
        //     field.clearValue();
        //     field.reload();
        // } 
        
        if (widget.currentRow.CDPRODUTO) {
            setDataFieldReadOnly(widget, false);
        } else {
            setDataFieldReadOnly(widget, true);
        }
    };
    
    this.changeProdIni = function(field) {
        const widgetInclusaoSolicitacao = field.getParent();
        const currentRow = widgetInclusaoSolicitacao.currentRow;
        const fieldProdFin = widgetInclusaoSolicitacao.getField("NMPRODFIN");
        if(currentRow.CDPRODINI) {
           field.validations.required = true;
           field.reload();
           fieldProdFin.validations.required = true;
           fieldProdFin.reload();
        } else if(!currentRow.CDPRODINI) {
           delete field.validations.required;
           field.reload();
           delete fieldProdFin.validations.required;
           fieldProdFin.clearValue();
           currentRow.CDPRODINI = "";
           currentRow.CDPRODFIN = "";
           fieldProdFin.reload();
        }
    };
    
    this.goToDatasWidget = function() {
        const widgetDiasEntrega = templateManager.container.getWidget("diasEntrega");
        widgetDiasEntrega.activate();
    };
    
    this.abreLancamento = function(widget, openOnProductTab = false) {
        return new Promise((resolve, reject) => {
            const dadosSolicitacao = widget.container.getWidget("dadosSolicitacao");
            const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
            
            dadosSolicitacao.currentRow = widget.currentRow;
            dadosSolicitacao.enabled = true;
            
            tabbedWidget.defaultTab = openOnProductTab ? "produtosWidget" : "dadosSolicitacao";
            
            let openFunction, params = [dadosSolicitacao];
            
            if(openOnProductTab) {
                openFunction = abreLancamentoOnProductTab;
                params.push(tabbedWidget);
            } else {
                openFunction = abreLancamentoOnDadosTab;
            }
            
            return openFunction(...params).then(() => {
                const closeAll = true;
                const enabled = true;
                
                //General.changeWidgetAcessibility(tabbedWidget, enabled);
                
                ScreenService.openSwipe(tabbedWidget, closeAll).then(function() {
                    setFieldsVisible(widget);
                }).catch(error => {
                    console.log("Error: ", error);
                });
            }).finally(() => resolve(tabbedWidget));
        });
    };
    
    function abreLancamentoOnProductTab(dadosSolicitacao, tabbedWidget) {
        return new Promise((resolve, reject) => {
            const produtosWidget = templateManager.container.getWidget("produtosWidget");
            produtosWidget.reload().then(function(data) {
                setVisibleProductActionsAndFields();
                setProdStripeFooter(data);
                resolve(tabbedWidget);
            });
        });
    }
    
    function abreLancamentoOnDadosTab(dadosSolicitacao) {
        return new Promise((resolve, reject) => {
            
        });
    }
    
    this.salvaConfirmacaoJustificativa = function(widget) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justificativaRow = widget.dataSource.data.filter(row => row.DSJUSTOPER.length == 0);
        
        if(justificativaRow.length == 0) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarQuantidadeProd', 'Row', widget.dataSource.data).then(function(success) {
                if(success.messages[0].message.length) {
                    showlogEditProducts(produtosWidget, success.messages[0].message);
                } else {
                    ScreenService.closePopup();
                    ScreenService.closePopup();
                    produtosWidget.commitInlineEdit();
                    produtosWidget.list();
                    produtosWidget.reload().then(function(callback) {
    					if(callback.dataset.itens_solicitacao.length === 0) {
    						ScreenService.closeSwipe();
    						solicitacaoWidget.reload();
    						solicitacaoWidget.activate();
    					}	
    				});
                    dadosSolicitacao.enabled = true;
                    
                    if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
                        justAltWidget.enabled = true;
            		} else {
            		    justAltWidget.enabled = false;
            		}
            		produtosWidget.showCheckbox = true;
            		produtosWidget.activate();
                }
            }, function(err) {
                ScreenService.closePopup();
                ScreenService.closePopup();
                cancelEditProducts(produtosWidget);
                ScreenService.showMessage(err.data.error);
                dadosSolicitacao.enabled = true;
                    
                if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
                    justAltWidget.enabled = true;
        		} else {
        		    justAltWidget.enabled = false;
        		}
            	produtosWidget.showCheckbox = true;
            	produtosWidget.activate();
            });
        } else {
            MessageService.showMessageByCode("PREENCHER_JUSTIFICATIVA");
        }
    };
    
    this.produtosWidgetBeforeInlineEditRow = function(args) {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        justAltWidget.enabled = false;
        dadosSolicitacao.enabled = false;
        produtosWidget.showCheckbox = false;
        produtosWidget.activate();
    };
    
    this.produtosWidgetCancelInlineEditRow = function(args) {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        dadosSolicitacao.enabled = true;
        
        if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
            justAltWidget.enabled = true;
		} else {
		    justAltWidget.enabled = false;
		}
        produtosWidget.showCheckbox = true;
        produtosWidget.activate();
    };
    
    this.produtosWidgetBeforeUnselectRow = function(args) {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const checkedRows = args.owner.getCheckedRows();
        
        if(checkedRows.length === 1) {
            dadosSolicitacao.enabled = true;
            
            if(solicitacaoWidget.currentRow.IDUTLOPERSOL === 'S') {
                if(solicitacaoWidget.currentRow.CDOPERLANC && ((getLocalVar('CDOPERADOR') != solicitacaoWidget.currentRow.CDOPERLANC))) {
                    delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                    delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                    delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
                } else {
                    produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
                    produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
                    produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
                }
            } else {
                produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
                produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
                produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
            }
            
            if(!verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE') && !verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            }
        
            if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
                justAltWidget.enabled = true;
    		} else {
    		    justAltWidget.enabled = false;
    		}
    		
    		produtosWidget.activate();
        }
    };
    
    this.produtosWidgetBeforeSelectAll = function() {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        justAltWidget.enabled = false;
        dadosSolicitacao.enabled = false;
        delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
        delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
        delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
    };
    
    this.produtosWidgetBeforeUnselectAll = function() {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        dadosSolicitacao.enabled = true;
        
        if(solicitacaoWidget.currentRow.IDUTLOPERSOL === 'S') {
            if(solicitacaoWidget.currentRow.CDOPERLANC && ((getLocalVar('CDOPERADOR') != solicitacaoWidget.currentRow.CDOPERLANC))) {
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            } else {
                produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
                produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
                produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
            }
        } else {
            produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
            produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
            produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
        }
        
        if(!verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE') && !verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            }
        
        if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
            justAltWidget.enabled = true;
		} else {
		    justAltWidget.enabled = false;
		}
    };
    
    this.blockQtdeWhenApproved = function(args) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        
        if(args.row.IDSOLIAPROV === 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[1] != 'S') {
            args.owner.field.widget.rollbackInlineEdit();
            args.owner.field.widget.list();
            MessageService.showMessageByCode("SOLICITA_BLOCK_EDIT_APPROVED_ITEM");
        }
    };
    
    this.verifyPermissionsAfterSelect = function(widget) {
        const checkedRows = widget.getCheckedRows();
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const addAction = produtosWidget.getAction('adicionaProduto');
        
        if(solicitacaoWidget.currentRow.IDTIPLAN === 'M') {
            return;
        } else if(verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') && verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA')) {
            return;
        } else {
            if(checkedRows.length == 1) {
                if((solicitacaoWidget.currentRow.IDTIPLAN === 'A' || solicitacaoWidget.currentRow.IDTIPLAN === 'C') && solicitacaoWidget.currentRow.IDBLOQALTSOLAUT === 'S') {
                    addAction.isVisible = verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') || verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA');
                } else {
                    addAction.isVisible = true;
                }
            } else {
                addAction.isVisible = false;
            }
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp03100_lancamento_de_solicitacao_de_comprasController', cmp03100_lancamento_de_solicitacao_de_comprasController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/js/controllers/cmp06400aprovacao_desaprovacao_solicitacao_comprasController.js
var cmp06400aprovacao_desaprovacao_solicitacao_comprasController = function(General, ScreenService, templateManager, ZhFilterPreferences, Utilities, $http, MessageService) {
	//messages to display
	var mensagens = {
		widgetIsNotValid: 'Preencha todos os campos corretamente.',
		errorInGridAction: 'Ocorreu um erro durante o processo. A operação foi cancelada.',
		cancelGridAction: 'A operação foi cancelada.'
	};

	var self = this;
	
	function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }

	this.setFilterInitValues = function(widget) {
		var filterRow = {
	
			CDOPERADOR: getLocalVar('CDOPERADOR'),
			STATUS: ["S", "N", "R"],
			IDOPERACAO: "R",
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
	};
	
	this.setRelatorio = function(args) {
		var stripe = args.owner.container.getWidget('stripe');
		args.e.metadata.filter = [
			{"label": ScreenService.i18n("Solicitações"), "value": stripe.currentRow.SOLICITACAO},
            {"label": ScreenService.i18n("Status"), "value": stripe.currentRow.STATUS},    
            {"label": ScreenService.i18n("Tipo de Custo"), "value": stripe.currentRow.TIPOCUSTO}, 
            {"label": ScreenService.i18n("Agrupamento"), "value": stripe.currentRow.AGRUPAMENTO}, 
            {"label": ScreenService.i18n("Dt. Entrega"), "value": stripe.currentRow.DTENTREGASTRIPE},         
            {"label": ScreenService.i18n("Dt. Solicitação"), "value": stripe.currentRow.DTSOLICSTRIPE}
		];
	};
	
	this.widgetOnEnter = function() {
		var cdtipocusto;
		var nmtipocusto;
		let filterRowConcat = {};
		let filterRowPadrao = {};
		let filterRowRedirecionamento = {};
		
		const widget = templateManager.container.getWidget('cmp06400aprovacao_desaprovacao_grid');
		
		General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/cmp06400_verificaTipoCusto', 'Row', widget.currentRow).then(function(callback) {
		 	var tipocusto = callback.dataset.res[0];
		 	if(tipocusto.length == 0) {
				cdtipocusto = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO; 
				nmtipocusto = widget.getField('NMTIPOCUSTO').dataSource.data[0].NMTIPOCUSTO; 
		 	}else {
		 		cdtipocusto = tipocusto[0].CDTIPOCUSTO;
		 		nmtipocusto = tipocusto[0].NMTIPOCUSTO;
		 	}
		 	
		 	filterRowPadrao = {
				"CDOPERADOR": getLocalVar('CDOPERADOR'),
				"STATUS": ["S", "N", "R"],
				"CDTIPOCUSTO": cdtipocusto,
				"NMTIPOCUSTO": nmtipocusto
			};
		 	
		 	if(!Util.isEmptyOrBlank(widget.externParams)) {
		 		const idOperacao = widget.externParams.IDOPERACAO == "R" ? "R" : "A";
		 		const cdFilial = widget.externParams.CDFILSOLI ? widget.externParams.CDFILSOLI : "";
		 		const nrSoliCmp = widget.externParams.NRSOLICMP ? widget.externParams.NRSOLICMP : "";
		 		
		 		filterRowRedirecionamento = {
					"IDOPERACAO": idOperacao,
					"CDFILIAL": [cdFilial],
					"NRSOLICMP": [nrSoliCmp]
				};
		 	}
		 	
		 	filterRowConcat = Object.assign({}, filterRowPadrao, filterRowRedirecionamento);
		 	
			Utilities.startFilter(widget, filterRowConcat).then(function () {
				if(!Util.isEmptyOrBlank(widget.externParams)) {
					let fieldCdfilial = widget.getField('CDFILIAL');
					let fieldNrsolicmp = widget.fields.filter(field => field.name == 'NRSOLICMP' && field.template == 'field/select-multiple.html')[0];
					
					setValueSelectMultipleFields(fieldNrsolicmp, fieldCdfilial, widget.externParams);
					
					fieldCdfilial.reload();
					fieldNrsolicmp.reload();
				}
			});
    	});
	};
	
	function setValueSelectMultipleFields(fieldNrsolicmp, fieldCdfilial, externValues) {
		fieldCdfilial.dataSourceFilter = [
			{
				"name": "CDGRUPFILI",
				"operator": "=",
				"value": "T"
			},
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "CDFILIAL",
				"operator": "IN",
				"value": [externValues.CDFILSOLI]
			}
		];
		
		fieldNrsolicmp.dataSourceFilter = [
			{
				"name": "P_CDFILSOLI",
				"operator": "=",
				"value": externValues.CDFILSOLI
			},
			{
				"name": "P_CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "P_CDAGRUPFILI",
				"operator": "=",
				"value": null
			},
			{
				"name": "NRSOLICMP",
				"operator": "IN",
				"value": [externValues.NRSOLICMP]
			}
		];
	}

	this.setStripe = function(widget) {
		var status = '';
	
		var filterRow = widget.appliedFilter.FILTER_ROW;
		var stripe = widget.container.getWidget('stripe');
		for (var i = 0; i < filterRow.STATUS.length; i++) {
		  if(filterRow.STATUS[i] == 'S') status = status + ' Extra ';
    	  if(filterRow.STATUS[i] == 'N') status = status + '- Não Extra';
    	  if(filterRow.STATUS[i] == 'R') status = status + '- Ruptura';
		}
		stripe.currentRow.SOLICITACAO = filterRow.IDOPERACAO === 'A' ? 'Aprovadas' : 'Desaprovadas';
		stripe.currentRow.STATUS = status;
		stripe.currentRow.TIPOCUSTO = filterRow.NMTIPOCUSTO;
		stripe.currentRow.DTENTREGASTRIPE = filterRow.DTENTREGA.start ? "Data de Entrega: " + filterRow.DTENTREGA.start + " à " + filterRow.DTENTREGA.end : "";
		stripe.currentRow.DTSOLICSTRIPE =  filterRow.DTSOLICITACAO.start ? "Data de Solicitação: " + filterRow.DTSOLICITACAO.start + " à " + filterRow.DTSOLICITACAO.end : "";
		stripe.currentRow.AGRUPAMENTO =  filterRow.NMGRUPFILI ? "Agrupamento de Unidades: " + filterRow.NMGRUPFILI : "";
		
		if(!Util.isEmptyOrBlank(widget.externParams)) {
			widget.getAction('VOLTAR_TELA').isVisible = true;
		}
		
		widget._filterInfo = [
            {"label": "Solicitações", "value": stripe.currentRow.SOLICITACAO},
            {"label": "Status", "value": stripe.currentRow.STATUS},    
            {"label": "Tipo de Custo", "value": stripe.currentRow.TIPOCUSTO},                 
            {"label": "Dt. Entrega", "value": stripe.currentRow.DTENTREGASTRIPE},         
            {"label": "Dt. Solicitação", "value": stripe.currentRow.DTSOLICSTRIPE}
        ];
        
		widget.reload().then(function(success) {
			templateManager.container.getWidget('cmp06400aprovacao_desaprovacao_grid').activate();
		});
	};
	
	this.filtrar = function(args) {
		var widget = args.owner;
		var filterRow = args.e.preference.FILTER_ROW;

		if (typeof(filterRow) === 'object') {
			var actionGrid = widget.getAction('GRID_ACTION');
			actionGrid.label = (filterRow.IDOPERACAO) === 'R' ? "Aprovar" : "Desaprovar";
			actionGrid.icon = (filterRow.IDOPERACAO === 'R') ? "checked" : "error";

			widget.getField('QTSOLIPROD').isVisible  = filterRow.IDOPERACAO === 'R';
			widget.getField('DSJUSTOPER').isVisible  = filterRow.IDOPERACAO === 'R';
			widget.getField('TXOBSITMSOL').isVisible = filterRow.IDOPERACAO === 'R';

			var idsolextra = filterRow.STATUS.filter(function(status) {
				return status !== 'R';
			});
			
			var CDFILIAL    = filterRow.CDFILIAL   ? Array.isArray(filterRow.CDFILIAL)   && filterRow.CDFILIAL.length   > 0 ? filterRow.CDFILIAL.join('_')   : null : null;
			var NRSOLICMP   = filterRow.NRSOLICMP  ? Array.isArray(filterRow.NRSOLICMP)  && filterRow.NRSOLICMP.length  > 0 ? filterRow.NRSOLICMP.join('_')  : null : null;
			var CDCOMPRADOR = (!filterRow.CDCOMPRADOR) ? null : filterRow.CDCOMPRADOR;
			var CDGRUPFILI  = filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null;
			var CDOPERADOR  = getLocalVar('CDOPERADOR');
			
			args.e.preference.CUSTOM_FILTER_ROW = {
			    "P_CDFILIAL"    : CDFILIAL,
			    "P_TCDFILIAL"   : CDFILIAL ? null : 'T',
			    "T_CDFILIAL"    : CDFILIAL ? null : 'T',
			    "P_CDGRUPFILI"  : CDGRUPFILI,
			    "P_DTENTRINI"   : filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null,
			    "P_DTENTRFIM"   : filterRow.DTENTREGA ? filterRow.DTENTREGA.end   : null,
			    "P_TENTREGA"    : filterRow.DTENTREGA && filterRow.DTENTREGA.start && filterRow.DTENTREGA.end ? null : 'T',
			    "P_NRSOLICMP"   : NRSOLICMP,
			    "P_TNRSOLICMP"  : NRSOLICMP ? null : 'T',
			    "P_DTSOLINI"    : filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.start : null,
			    "P_DTSOLFIM"    : filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.end   : null,
			    "P_TSOLICITA"   : filterRow.DTSOLICITACAO && filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end ? null : 'T',
			    "P_CDOPERADOR"  : CDOPERADOR,
			    "P_IDSOLEXTRA"  : idsolextra.join(''),
			    "P_IDSOLRUPTURA": filterRow.STATUS.indexOf('R') > -1 ? 'S' : null,
			    "P_CDCOMPRADOR" : CDCOMPRADOR,
			    "P_TCDCOMPRADOR": CDCOMPRADOR ? null : 'T',
			    "P_IDOPERACAO"  : filterRow.IDOPERACAO,
			    "P_NRTIPOCUSTO":  filterRow.CDTIPOCUSTO
			};
			
			widget.dataSourceFilter = [
			   { "name": "P_CDFILIAL"    , 'operator':'=', 'value': CDFILIAL },
			   { "name": "P_TCDFILIAL"   , 'operator':'=', 'value': CDFILIAL ? null : 'T' },
			   { "name": "T_CDFILIAL"    , 'operator':'=', 'value': CDFILIAL ? null : 'T' },
			   { "name": "P_CDGRUPFILI"  , 'operator':'=', 'value': CDGRUPFILI },
			   { "name": "P_DTENTRINI"   , 'operator':'=', 'value': filterRow.DTENTREGA ? filterRow.DTENTREGA.start : null },
			   { "name": "P_DTENTRFIM"   , 'operator':'=', 'value': filterRow.DTENTREGA ? filterRow.DTENTREGA.end   : null },
			   { "name": "P_TENTREGA"    , 'operator':'=', 'value': filterRow.DTENTREGA && filterRow.DTENTREGA.start && filterRow.DTENTREGA.end ? null : 'T' },
			   { "name": "P_NRSOLICMP"   , 'operator':'=', 'value': NRSOLICMP },
			   { "name": "P_TNRSOLICMP"  , 'operator':'=', 'value': NRSOLICMP ? null : 'T' },
			   { "name": "P_DTSOLINI"    , 'operator':'=', 'value': filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.start : null },
			   { "name": "P_DTSOLFIM"    , 'operator':'=', 'value': filterRow.DTSOLICITACAO ? filterRow.DTSOLICITACAO.end   : null },
			   { "name": "P_TSOLICITA"   , 'operator':'=', 'value': filterRow.DTSOLICITACAO && filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end ? null : 'T' },
			   { "name": "P_CDOPERADOR"  , 'operator':'=', 'value': CDOPERADOR },
			   { "name": "P_IDSOLEXTRA"  , 'operator':'=', 'value': idsolextra.join('') },
			   { "name": "P_IDSOLRUPTURA", 'operator':'=', 'value': filterRow.STATUS.indexOf('R') > -1 ? 'S' : null },
			   { "name": "P_CDCOMPRADOR" , 'operator':'=', 'value': CDCOMPRADOR },
			   { "name": "P_TCDCOMPRADOR", 'operator':'=', 'value': CDCOMPRADOR ? null : 'T' },
			   { "name": "P_IDOPERACAO"  , 'operator':'=', 'value': filterRow.IDOPERACAO },
			   { "name": "P_NRTIPOCUSTO" , 'operator':'=', 'value': filterRow.CDTIPOCUSTO }
			];
		}
	};

	//create filter for 'Unidades Solicitantes' fields
	this.createDsFilterUS = function(field) {
		field.dataSourceFilter = [{
			'name': 'CDOPERADOR',
			'operator': '=',
			'value': getLocalVar('CDOPERADOR')
		}, {
			'name': 'CDGRUPFILI',
			'operator': '=',
			'value': field.widget.currentRow.CDGRUPFILI
		}];
		field.reload();
	};

	//create filter for 'Solicitação' field
	this.createDsFilter = function(field) {
		
		if (!field.widget.currentRow.CDFILIAL) {
			field.widget.currentRow.T_NMFILIAL = 'T';
		}
		else {
			field.widget.currentRow.T_NMFILIAL = "L";
		}
		
		if(field.widget.getField('IDOPERACAO').value() == 'A') {
			field.dataSource.name = "cmp_solicitacao_solicitacaoCompras#/crud/solicita_itemsoli_params_aprov";
		}
		else {
			field.dataSource.name = "cmp_solicitacao_solicitacaoCompras#/crud/solicita_itemsoli_params";
		}
	
		var cdfilial = field.widget.currentRow.CDFILIAL ? field.widget.currentRow.CDFILIAL.join('_') : null;
		field.dataSourceFilter = [
			{
				'name': 'P_CDAGRUPFILI',
				'operator': '=',
				'value': field.widget.currentRow.CDGRUPFILI ? field.widget.currentRow.CDGRUPFILI : null
			}, 
			{
				'name': 'P_CDFILSOLI',
				'operator': '=',
				'value': field.widget.currentRow.CDFILIAL ? cdfilial : 'T'
			}, 
			{
				'name': 'P_CDOPERADOR',
				'operator': 'IN',
				'value': getLocalVar('CDOPERADOR')
			}
		];
		field.reload();
	};


	//grid action 'Aprova/Reprova Itens'
	this.aprovaReprovaItens = function(widget) {
		var rows = widget.getCheckedRows();
		var rowsToSave = [];
		rows.forEach(function(row) {
			var rowToSave = {};
			rowToSave.CDFILSOLI = row.CDFILSOLI;
			rowToSave.CDFILLAN = row.CDFILLAN;
			rowToSave.NRSOLICMP = row.NRSOLICMP;
			rowToSave.CDPRODUTO = row.CDPRODUTO;
			rowToSave.DTPROGENTR = moment(row.DTPROGENTR, "DD/MM/YYYY HH:mm:ss").format("DD/MM/YYYY");
			rowToSave.__is_new = false;
			rowToSave.changed = true;
			
			if (widget.getAction('GRID_ACTION').icon === 'error') {
				rowToSave.IDSOLIAPROV = 'N';
				rowToSave.DTHRAPROVSOL = null;
				rowToSave.CDOPERAPROV = null;
			} else {
				rowToSave.IDSOLIAPROV = 'S';
				rowToSave.DTHRAPROVSOL = moment().format('DD/MM/YYYY HH:mm:ss');
				rowToSave.CDOPERAPROV = getLocalVar("CDOPERADOR");
			}
			
			rowsToSave.push(rowToSave);
		});
		
		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', rowsToSave).then(function(success) {
			var msg = {};
			msg.idstatus = widget.getAction('GRID_ACTION').icon === 'error' ? 'desaprovado' : 'aprovado';
			msg.numrows = rowsToSave.length.toString();
			
			if (rowsToSave.length > 1) {
				MessageService.successNotificationByCode("ITENS_SUCCESS_INSERT", { "NUMROWS": msg.numrows, "IDSTATUS": msg.idstatus });
			} else {
				MessageService.successNotificationByCode("ITEM_SUCCESS_INSERT", { "IDSTATUS": msg.idstatus });
			}
			
			widget.unSelectAll();
			widget.reload().then(success => {
				//self.openTelaLancamento();
			});
		}, function(err) {
			ScreenService.notificationMessage(mensagens.errorInGridAction, 'error');
		});
	};
	//clear dependent fields on filter
	this.clearFields = function(field) {
		var widget = field.widget;
		if (field.name === 'NMGRUPFILI') {
			widget.getField('CDFILIAL').clearValue();
		}
		else if (field.name === 'NMFILIAL') {
			widget.getField('CDFILIAL').clearValue();
		}
	};

	//confirm grid action
	this.confirmGridAction = function(widget) {
		var msg = {};
		msg.idstatus = widget.getAction('GRID_ACTION').icon === 'error' ? 'desaprovar' : 'aprovar';
		msg.numrows = widget.getCheckedRows().length.toString();
		
		if (widget.getCheckedRows().length > 1) {
			msg.line = 'Deseja ' + msg.idstatus + ' os ' + msg.numrows + ' itens selecionados?';
		} else {
			msg.line = 'Deseja ' + msg.idstatus + ' o item selecionado?';
		}
		ScreenService.confirmMessage(ScreenService.i18n(msg.line), 'question', function(success) {
			self.aprovaReprovaItens(widget);
		}, function(error) {});
	};

	this.enableGrid = function() {
		var grid = templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid");
		grid.activate();
	};
	
	this.setFilterInfo = function() {
		var grid = templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid");
		var stripe = templateManager.container.getWidget("stripe");
		grid._filterInfo = [
			{
				"label": "Solicitações",
				"value": stripe.currentRow.SOLICITACAO
			}
		];
	};
	
	this.openTelaLancamento = function(widget) {
        ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp03100_lancamento_de_solicitacao_de_compras').then(function() {
            // let widRetorno = templateManager.container.getActiveWidget();
            // widRetorno.externalRow = widget.externParams;
            // Utilities.startFilter(widRetorno, widRetorno.externalRow);
        });
        
		// $http.get('assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/json/containers/cmp03100_lancamento_de_solicitacao_de_compras.json').then(function(result) {
		// 	var containerAprovacaoDesaprovacao = this.containerFactory(result.data);
		// 	const filtro = templateManager.container.getWidget('dadosSolicitacao').currentRow;
		// 	templateManager.container = containerAprovacaoDesaprovacao;
		// 	onEnterAprovacaoDesaprovacao(templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid"), filtro);
		// }.bind(metaDataFactory), function(error) {
		// 	throw error;
		// });
    };

};

Configuration(function(ContextRegister) {
	ContextRegister.register('cmp06400aprovacao_desaprovacao_solicitacao_comprasController', cmp06400aprovacao_desaprovacao_solicitacao_comprasController);
});


// FILE: ./assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/js/controllers/Cmp06900AlteracaoAutomaticaSolicitacaoComprasController.js
var Cmp06900AlteracaoAutomaticaSolicitacaoComprasController = function(General, ScreenService, MessageService, ZhFilterPreferences, templateManager, ZHPromise, Utilities) {
	var paramsParaSupri;
	var self = this;
	
	const permissionsArray = {
        'ALTERAR_DTENTREGA'     : false,
        'ALTERAR_PRODUTO'       : false,
        'EXCLUIR_PRODUTO'       : false,
        'AUMENTAR_QUANTIDADE'   : false,
        'DIMINUIR_QUANTIDADE'   : false,
        'percentAumentar'       : undefined,
        'percentDiminuir'       : undefined
    };
		
	var validaRegras = function(widget) {
		validaRegraJustificativa(widget);
		validaRegraQuantidadeVolume(widget.getParent().getWidget('alteracao_automatica_produto_widget'));
	};
	
	function getParametros() {
		return General.callRestEngine('cmp#/crud/parasupri', 'FilterData',
				[
					{
						"name": "CDFILIAL",
						"operator": "=",
						"value": getLocalVar('CDFILCENTCMP')
					},
					{
						"name": "NRORG",
						"operator": "=",
						"value": getLocalVar('NRORG')
					}
				]);
	}
	
	this.widgetOnEnterOnce = function(widget) {
		General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
            
            getParametros().then(function(success) {
			    paramsParaSupri = success.dataset.parasupri[0];
			    
			    validaRegras(widget);
			    
			    if(widget.ABERTA_POR) {
			    	widget.getAction('voltar_lancamento_solicitacao_compras').isVisible = true;
				} else {
			    	Utilities.startFilter(widget);
					widget.getAction('voltar_lancamento_solicitacao_compras').isVisible = false;
				}
				
				General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getPermissoesAlt', 'Row', {}).then(function(callback) {
		            const permissoes = callback.dataset.permissoes;
		            
		            if(permissoes) {
		                permissoes.forEach(function (value) {
		                    permissionsArray[value.IDAUTALTEPRODSOLI] = true;
		                    
		                    if(value.IDAUTALTEPRODSOLI == 'AUMENTAR_QUANTIDADE') {
		                        permissionsArray.percentAumentar    = value.PEALTEQTDESOLI;
		                    }
		                    if(value.IDAUTALTEPRODSOLI == 'DIMINUIR_QUANTIDADE') {
		                        permissionsArray.percentDiminuir    = value.PEALTEQTDESOLI;
		                    }
		                });
		            }
		        }, function(err) {
		            ScreenService.showMessage(err.data.error);
		        });
				
			    complementaDataSourceFilterSubGrupo(widget);
			});
        }, function(error) {
			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
		});
	};
	
	/**
	 * Fecha todos os popUps, limpa as rows selecionadas e atualiza o Grid.
	 * 
	 * Utilizado por:
	 * * Alteração Automática de Produto;
	 * * Alteração Automática de Data de Entrega.
	 */
	var closePopupAndReloadGrid = function(actualWidget) {
		var widgetGrid = actualWidget.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
		actualWidget.currentRow = {};			
		ScreenService.closePopup(true);
		
		widgetGrid.dataSource.clearCheckedRows();
		
		widgetGrid.reload().then(function() {
			widgetGrid.activate();
		});
	};
	
	/**
     * ########################################################################
     * ########################### >>> FILTRO <<< #############################
     * ########################################################################
     */
     
	this.setFilterInitValues = function(widget) {
	    var filterRow = {
	    	'ENTREGA': [
	    		'ED',
	    		'OL'
	    	]
	    };
	    
	    ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
	};
	
	this.alteraDataSourceFilterUnidade = function(widget) {
		var fieldUnidade = widget.getField('NMFILIAL'),
			dataSourceFilter = [
				{
					'name': 'NRORG',
					'operator': '=',
					'value': getLocalVar('NRORG')
				},
				{
					'name': 'CDOPERADOR',
					'operator': '=',
					'value': getLocalVar('CDOPERADOR')
				},
				{
					'name': 'CDGRUPFILI',
					'operator': '=',
					'value': widget.currentRow.CDGRUPFILI || 'T'
				}
			];
			
		fieldUnidade.clearValue();
		fieldUnidade.dataSource.load(dataSourceFilter);
	};
    
    this.onChangeAgrupamentoUnidade = function(widget) {
    	this.alteraDataSourceFilterUnidade(widget);
    	this.alteraDataSourceFilterNumero(widget);
    };
	
    this.alteraDataSourceFilterNumero = function(widget) {
    	var fieldNumero = widget.getField('NRSOLI'),
    		dataSourceFilter= [
	    		{
	                "name": "P_CDAGRUPFILI",
	                "operator": "=",
	                "value": widget.currentRow.CDGRUPFILI ? widget.currentRow.CDGRUPFILI : 'T'
	            },
	            {
	            	"name": "P_CDOPERADOR",
	            	"operator": "=",
	            	"value": getLocalVar('CDOPERADOR')
                },
	            {
	                "name": "NRORG",
	                "operator": "=",
	                "value": getLocalVar('NRORG')
	            },
        	    {
        	    	"name": "P_CDFILIAL",
        	    	"operator": "=",
        	    	"value": widget.currentRow.NMFILIAL ? widget.currentRow.NMFILIAL.join('_') : getLocalVar('CDFILIAL')
        	    },
        	    {
        	    	"name": "P_TSOLICITA",
        	    	"operator": "=",
        	    	"value": (widget.currentRow.DTSOLICITACAO.start && widget.currentRow.DTSOLICITACAO.end) ? '' : 'T'
        	    },
        	    {
        	    	"name": "P_DTSOLINI",
        	    	"operator": "=",
        	    	"value": widget.currentRow.DTSOLICITACAO ? widget.currentRow.DTSOLICITACAO.start ? widget.currentRow.DTSOLICITACAO.start : '' : ''
        	    },
        	    {
        	    	"name": "P_DTSOLFIN",
        	    	"operator": "=",
        	    	"value": widget.currentRow.DTSOLICITACAO ? widget.currentRow.DTSOLICITACAO.end ? widget.currentRow.DTSOLICITACAO.end : '' : ''
        	    },
        	    {
        	    	"name": "P_TENTREGA",
        	    	"operator": "=",
        	    	"value": (widget.currentRow.DTENTREGA.start && widget.currentRow.DTENTREGA.end) ? '' : 'T'
        	    },
        	    {
        	    	"name": "P_DTENTRINI",
        	    	"operator": "=",
        	    	"value": widget.currentRow.DTENTREGA ? widget.currentRow.DTENTREGA.start ? widget.currentRow.DTENTREGA.start : '' : ''
        	    },
        	    {
        	    	"name": "P_DTENTRFIN",
        	    	"operator": "=",
        	    	"value": widget.currentRow.DTENTREGA ? widget.currentRow.DTENTREGA.end ? widget.currentRow.DTENTREGA.end : '': ''
        	    },
        	    {
        	    	"name": "P_TPRODUTO",
        	    	"operator": "=",
        	    	"value": (widget.currentRow.CDPRODINI && widget.currentRow.CDPRODFIN) ? '' : 'T'
        	    },
        	    {
        	    	"name": "P_CDPRODINI",
        	    	"operator": "=",
        	    	"value": widget.currentRow.CDPRODINI ? widget.currentRow.CDPRODINI : ''
        	    },
        	    {
        	    	"name": "P_CDPRODFIN",
        	    	"operator": "=",
        	    	"value": widget.currentRow.CDPRODFIN ? this.preencheCaractereDireita(widget.currentRow.CDPRODFIN) : ''
        	    }
    		];
    		
    	fieldNumero.clearValue();
    	fieldNumero.dataSourceFilter = dataSourceFilter;
    	fieldNumero.reload();
		
		const fieldDestSoli = widget.getField("NMDESTSOLI");
		const dtSoruceNmDestSoli = [
			 {
			 	"name": "P_CDFILIAL",
	            "operator": "=",
	            "value": widget.currentRow.NMFILIAL ? widget.currentRow.NMFILIAL.join('_') : 'T'
			 }
		];
		
		fieldDestSoli.clearValue();
		fieldDestSoli.dataSource.load(dtSoruceNmDestSoli);
    };
    
    function complementaDataSourceFilterSubGrupo(widget) {
    	var params = {
    		'P_CDFILCENTCMP': getLocalVar('CDFILCENTCMP')
    	};
    	
    	General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/get_codigo_grup_prod', "Row", params).then(function(success) {
	    	widget.getField('CDSUBGRPROD').dataSourceFilter = [
	    		{
	                "name": "CDGRUPPROD",
	                "operator": "=",
	                "value": success.dataset.data[0].CDGRUPPROD
	            }
			];
    	},
    	function(err) {
    		ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
    	});
    }
	
	this.limpaLabelObrigatorioProdutos = function(currentRow) {
		if (currentRow.$error) {
			currentRow.$error.NMPRODINI = [];
			currentRow.$error.NMPRODFIN = [];
		}
	};
	
	this.validaProdutoInicialAndFinal = function(actualField) {
		var widget = actualField.getParent(),
			currentRow = widget.currentRow,
			otherField = actualField.name === 'NMPRODINI' ? widget.getField('NMPRODFIN') : widget.getField('NMPRODINI'),
			limpaLabelObrigatorio = true,
			isProdutoValido;
		
		if (currentRow.CDPRODINI || currentRow.CDPRODFIN) {
			actualField.validations = { 'required': true };
			otherField.validations = { 'required': true };
			
			if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
				isProdutoValido = General.comparaPratoProduto(currentRow.CDPRODINI, currentRow.CDPRODFIN, getLocalVar('CDPICTPROD'));
				if (!isProdutoValido) {
					MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
					actualField.clearValue();
					limpaLabelObrigatorio = false;
				}
			} 
		} else {
			actualField.validations = {};
			otherField.validations = {};
		}
		
		if (limpaLabelObrigatorio) {
			this.limpaLabelObrigatorioProdutos(currentRow);
		}
	};
	
	this.preparaFiltro = function(args) {
		
		var filterRow = args.e.preference.FILTER_ROW,
			customFilterRow;

		if(typeof(filterRow) === 'object'){
            customFilterRow = {
				'P_CDFILIAL': this.concatArrayForParams(filterRow.NMFILIAL),
				'P_CDAGRUPFILI': filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : 'T',
				'P_NRSOLICMP': this.concatArrayForParams(filterRow.NRSOLI),
				'P_CDOPERADOR': getLocalVar('CDOPERADOR'),
				'P_ED': this.getEntrega(filterRow.ENTREGA, 'ED'),
				'P_OL': this.getEntrega(filterRow.ENTREGA, 'OL'),
				'P_CDGRUPROD': this.concatArrayForParams(filterRow.CDSUBGRPROD)
            };
            
            if (filterRow.CDPRODINI && filterRow.CDPRODFIN) {
            	customFilterRow.P_CDPRODINI = filterRow.CDPRODINI;
				customFilterRow.P_CDPRODFIN = this.preencheCaractereDireita(filterRow.CDPRODFIN);
				customFilterRow.P_TPRODUTO = null;
            } else {
            	customFilterRow.P_CDPRODINI = null;
				customFilterRow.P_CDPRODFIN = null;
				customFilterRow.P_TPRODUTO = 'T';
            }
            
            if (filterRow.DTENTREGA.start && filterRow.DTENTREGA.end) {
            	customFilterRow.P_DTENTRINI = filterRow.DTENTREGA.start;
				customFilterRow.P_DTENTRFIN = filterRow.DTENTREGA.end;
				customFilterRow.P_TENTREGA = null;
            } else {
            	customFilterRow.P_DTENTRINI = null;
				customFilterRow.P_DTENTRFIN = null;
				customFilterRow.P_TENTREGA = 'T';
            }
            
            if (filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.start) {
            	customFilterRow.P_DTSOLINI = filterRow.DTSOLICITACAO.start;
				customFilterRow.P_DTSOLFIN = filterRow.DTSOLICITACAO.end;
				customFilterRow.P_TSOLICITA = null;
            } else {
            	customFilterRow.P_DTSOLINI = null;
				customFilterRow.P_DTSOLFIN = null;
				customFilterRow.P_TSOLICITA = 'T';
            }
            
            args.e.preference.CUSTOM_FILTER_ROW = customFilterRow;
        }
    };
     
     
	/**
     * ########################################################################
     * ########################## >>> RELATÓRIO <<< ###########################
     * ########################################################################
     */
	
	this.abrirTelaRelatorio = function(widget) {
		ScreenService.openWindow('cmp_solicitacao_relatorios#cmp03200_alteracao_nos_produtos_da_solitacao').then(function() {
			templateManager.container.getWidget('alteracaoProdutosSolicitacao').OPENED = true;
		});
	};
	
	/**
     * ########################################################################
     * ########################## >>> UTILIDADE <<< ###########################
     * ########################################################################
     */
     
	this.applyFieldValue = function (selectedField, value) {
		if (value) {
			selectedField.setValue(value);
		} else {
			selectedField.applyDefaultValue();
		}
	};
	
	var getNewValidations = function(actualValidations) {
		var validationsIsEmpty;
		
		if (typeof(actualValidations) === 'object') {
			validationsIsEmpty = Util.isEmptyObject(actualValidations);
		} else {
			validationsIsEmpty = Util.isEmptyOrBlank(actualValidations);
		}
		
		return validationsIsEmpty ? {required: true} : {};
	};
	
	this.toggleField = function (widget, selectedFieldName, value) {
		var selectedField = widget.getField(selectedFieldName);
		
		selectedField.readOnly = !selectedField.readOnly;
		selectedField.validations = getNewValidations(selectedField.validations);
		
		if (selectedField.isReadOnly()) {
			selectedField.setValue('');
			
			if (widget.currentRow.$error)
				delete widget.currentRow.$error[selectedFieldName];
				
			templateManager.updateTemplate();
		} else {
			this.applyFieldValue(selectedField, value);
		}
	};
	
	this.getEntrega = function(arrayEntrega, entregaForSearch) {
		var entrega = arrayEntrega.filter(function(item) {
			return item === entregaForSearch;
		})[0];
		
		switch (entrega) {
			case 'ED':
				return 'P';
				
			case 'OL':
				return 'O';
			
			default:
				return null;
		}
	};
	
    this.voltarAlteracaoAutomatica = function(args) {
		ScreenService.closePopup();
    };
	
	this.voltarDetail = function(widget) {
		ScreenService.closeSwipe();
		widget.reload();
	};
	
	var verifyMinValue = function(field) {
        var value = angular.copy(field.value()),
        	minValue = '-99.99';
        
        if(typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if(value && parseFloat(value) < parseFloat(minValue)) {
            field.setValue('0');
            MessageService.showMessageByCode("VLR_MENOR_MENOS_99");
        }
    };
    
    var trataValorNaoPreenchido = function(field) {
    	if (Util.isEmptyOrBlank(field.value())) {
    		field.setValue('0');
    	}
    };
	
	/**
     * Retorna a concatenação do array passado pro parâmetro. 
     * 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    this.concatArrayForParams = function (arr, defaultValue) {
        if(!Util.isEmptyOrBlank(arr)) {
            return arr.join('_');
        } else {
            return defaultValue || 'T';
        }
    };
	
	this.preencheCaractereDireita = function(string){
        var pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    };
    
    this.isQuantidadeZero = function(quantidade) {
    	return quantidade == 0 || quantidade === '0,000' ? true : false;
    };
    
    this.voltarLancSoliCmp = function() {
    	ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#cmp03100_lancamento_de_solicitacao_de_compras').then(function() {
    		delete templateManager.containers['cmp_solicitacao_solicitacaoCompras#/cmp06900_alteracao_automatica_solicitacao_compras'];
    	});
    };
	
	/**
     * ########################################################################
     * ################## >>> ALTERAR ENTREGA ED/OL <<< #######################
     * ########################################################################
     */
     
    this.alteraEntrega = function(widget, newStatus, confirmMessage) {
    	var itensSelecionados = widget.dataSource.getCheckedRows();
		
    	ScreenService.confirmMessage(confirmMessage, 'CONFIRMATION',
    	function(success) {
    		var params = {
				"ITENS_SELECIONADOS": itensSelecionados,
				"NEW_STATUS": newStatus,
				"CDOPERADOR": getLocalVar('CDOPERADOR')
			};
			
    		General.callRestEngine("cmp_solicitacao#/alterar_entrega", "Row", params).then(
    			function(success) {
    				ScreenService.closePopup();
    				widget.reload();
				},
				function(err) {
					ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
				});
    	});
    };
    
    this.alteraParaEntregaOL = function(widget) {
    	if (paramsParaSupri.IDUTILCONSSOLIOL === 'S') {
    		this.alteraEntrega(widget, 'O', ScreenService.i18n('Confirmar alteração dos itens para entrega via OL? A alteração ocorrerá apenas se os mesmos estiverem devidamente parametrizados.'));
    	} else {
    		MessageService.showMessageByCode("OPR_BLOCK_PARAM_OPL_DESMARCADO");
    	}
    };
    
    this.alteraParaEntregaED = function(widget) {
	    this.alteraEntrega(widget, 'P', ScreenService.i18n('Confirmar alteração dos itens para entrega direta (ponto-a-ponto)? A alteração ocorrerá para itens de solicitações que não possuem pedidos do OL já gerados.'));
    };
     
    /**
     * ########################################################################
     * ############### >>> ATUALIZAÇÃO DE ITENS DO GRID <<< ###################
     * ########################################################################
     * 
     * Responsável por atualizar:
     * - Quantidade;
     * - Marca;
     * - Justificativa.
     */
     
	var validaRegraJustificativa = function(widget) {
		if (paramsParaSupri.IDAUDALTSOL === 'N') {
			widget.getField('DSJUSTSOL').isVisible = false;
		}
	};
	
    this.beforeEditSolicitacao = function(widget) {
    	var fieldMarca = widget.getField('NMMARCA'),
    		currentRow = widget.currentRow,
	    	isFilialOL = currentRow.IDFUNCAOFILI === 'O' ? true : false;
    	
    	General.edit(widget);
    	
    	if (isFilialOL) {
	    	fieldMarca.readOnlyOnEdit = false;
    	    fieldMarca.dataSourceFilter = [
	    		{
	                'name': 'CDARVPROD',
	                'operator': '=',
	                'value': currentRow.CDARVPROD
	            },
	            {
	                'operator': 'ORDER_BY',
	                'name': [
	                    {
	                        'name': 'CDMARCA',
	                        'direction': 'ASC'
	                    }
	                ]
	            }
	        ];
    	} else {
    		fieldMarca.readOnlyOnEdit = true;
    	}
    };
    	
    this.salvarAlteracoesSolicitacao = function(widget, deleteItem, inlineEdit) {
    	let rows = widget.dataSource.data.filter(rowsModificadas => rowsModificadas.changed);
    	let params = [];
    	rows.forEach(function(row) {
    		params.push({
    			'IDAUDALTSOL'   : paramsParaSupri.IDAUDALTSOL,
				'IDTIPLAN'      : row.IDTIPLAN,
				'IDUTAPROVSOL'  : row.IDUTAPROVSOL,
				'IDPERALTSAPR'  : row.IDPERALTSAPR,
				'IDSOLIAPROV'   : row.IDSOLIAPROV,
				'NRSEQUCONSOL'  : row.NRSEQUCONSOL,
				'QTSOLIPROD'    : row.QTSOLIPROD,
				'QTSOLIORIG'    : row.changed_QTSOLIPROD,
				'CDMARCA'       : row.CDMARCA ? row.CDMARCA : null,
				'CDFILSOLI'     : row.CDFILSOLI,
				'CDFILLAN'      : row.CDFILLAN,
				'NRSOLICMP'     : row.NRSOLICMP,
				'CDPRODUTO'     : row.CDARVPROD,
				'DTPROGENTR'    : row.DTPROGENTR,
				'STATUS'        : row.STATUS,
				'DSJUSTOPER'    : widget.getField('DSJUSTSOL').isVisible ? row.DSJUSTSOL : 'Alteração - CMP06900 Mobile',
				'CDOPERADOR'    : getLocalVar('CDOPERADOR'),
				'CDMARCA_OLD'   : row.CDMARCA ? row.CDMARCA : null,
				'CDOPERADOR_OLD': getLocalVar('CDOPERADOR'),
				'CDFILSOLI_OLD' : row.CDFILSOLI,
				'CDFILLAN_OLD'  : row.CDFILLAN,
				'NRSOLICMP_OLD' : row.NRSOLICMP,
				'CDPRODUTO_OLD' : row.CDPRODUTO,
				'DTPROGENTR_OLD': row.DTPROGENTR,
				'QTSOLIPROD_OLD': row.changed_QTSOLIPROD ? row.changed_QTSOLIPROD : row.QTSOLIPROD,
				'STATUS_OLD'    : row.STATUS
    		});
    	});
		
		General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvar_alteracoes_solicitacao', 'Row', params).then(function(success) {
		    if (deleteItem) {
		    	this.voltarDetail(widget);
		    	MessageService.showMessageByCode("EXCLUIDO_SUCCESS");
		    } else {
			    MessageService.showMessageByCode("SALVO_SUCESSO");
	    		widget.currentRow.DSJUSTSOL = "";
			    if(inlineEdit){
			    	widget.rollbackInlineEdit();
			    	widget.reload();
        			widget.list();
			    } else {
			    	widget.view();
			    }
		    }
		}.bind(this),
		function(err) {
		    ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
		});
    };
    
	this.acionaSalvarAlteracoesSolicitacao = function(widget) {
		let inlineEdit = widget.currentRow.changed_QTSOLIPROD ? true : false;
		let justificativa = inlineEdit && widget.getField('DSJUSTSOL').isVisible && !widget.currentRow.DSJUSTSOL;
		
		var verificaQuantidade = this.verifyQuantidadeEditPermissions(widget);
		
		verificaQuantidade = verificaQuantidade == undefined ? true : verificaQuantidade;
		
		var changedRows = widget.dataSource.data.filter(function(row) {
			return row.changed === true;
		});
		var changedSemJust = changedRows.filter(function(row) {
			return row.DSJUSTSOL == null || row.DSJUSTSOL == "" || row.DSJUSTSOL == undefined || !row.DSJUSTSOL;	
		});
		
		if (widget.isValid()) {
			if(verificaQuantidade) {
				if (this.isQuantidadeZero(widget.currentRow.QTSOLIPROD)) {
					ScreenService.confirmMessage('Confirma exclusão do registro?', 'CONFIRMATION', function() {
						this.salvarAlteracoesSolicitacao(widget, true, false);
					}.bind(this));
				} else {
					if(changedSemJust.length > 0) {
						if(paramsParaSupri.IDAUDALTSOL == 'S')
							MessageService.showMessageByCode("JUSTIFICATIVA_REQUIRED", "ERROR");
						else
							this.salvarAlteracoesSolicitacao(widget, false, false);
					} else {
						this.salvarAlteracoesSolicitacao(widget, false, false);
					}
				}
			}
		} else {
			if (justificativa) {
				if(paramsParaSupri.IDAUDALTSOL == 'S')
					MessageService.showMessageByCode("JUSTIFICATIVA_REQUIRED", "ERROR");
				else
					this.salvarAlteracoesSolicitacao(widget, false, false);
			}
		}
	};
     
    /**
     * ########################################################################
     * ########## >>> ATUALIZAÇÃO AUTOMÁTICA DE DATA DE ENTREGA <<< ###########
     * ########################################################################
     */
     
	this.openWidgetAlteracaoAutomaticaDataEntrega = function(widget) {
		const popUpWidget = widget.getParent().getWidget('alteracao_automatica_data_entrega_widget');
		const widgetGrid = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
		const checkedRowsGrid = widget.getCheckedRows();
		
		popUpWidget.currentRow.NOVADTENTREGA = moment().format('L');
		popUpWidget.currentRow.TIPOJUST = 'P';
		
		if(paramsParaSupri.IDAUDALTSOL == 'S') {
			popUpWidget.getField("TIPOJUST").isVisible = true;
			popUpWidget.getField("DSJUSTOPER").isVisible = true;
			
			popUpWidget.currentRow.TIPOJUST = 'P';
			popUpWidget.currentRow.DSJUSTOPER = '';
			
			popUpWidget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
			
			popUpWidget.getField("DSJUSTOPER").reload();
		} else {
			popUpWidget.getField("TIPOJUST").isVisible = false;
			popUpWidget.getField("DSJUSTOPER").isVisible = false;
		}
		
		if(paramsParaSupri.IDBLOQALTSOLAUT === 'S') {
			if(permissionsArray.ALTERAR_DTENTREGA) {
				ScreenService.openPopup(popUpWidget);
			} else {
				var positiveRowsM = checkedRowsGrid.filter(function(row) {
					return (row.IDTIPLAN === 'M');
				});
				
				if(positiveRowsM.length == checkedRowsGrid.length) {
					ScreenService.openPopup(popUpWidget);
				} else {
					var negativeRowsM = checkedRowsGrid.filter(function(row) {
						return (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C');
					});
					var rowsToMessageM = [];
					var stringProdM;
					
					negativeRowsM.forEach(row => {
						var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
						
						rowsToMessageM.push(prod);
					});
					
					stringProdM = rowsToMessageM.join("<br>");
					
					MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS", { PRODUTOS: stringProdM }).then(function(confirmed) {
						ScreenService.closePopup(true);
								
						widgetGrid.reload().then(function() {
							widgetGrid.activate();
						});
					});
				}
			}
		} else {
			ScreenService.openPopup(popUpWidget);
		}
	};
     
    var montaParametrosAlteracaoAutomaticaDataEntrega = function(widgetAltAutomaticaDataEntrega) {
    	var row = widgetAltAutomaticaDataEntrega.currentRow,
    		checkedRows = widgetAltAutomaticaDataEntrega.getParent().dataSource.getCheckedRows(),
            parametros = {
				'DTPROGENTR_NEW': row.NOVADTENTREGA,
				'DSJUSTOPER_NEW': row.DSJUSTOPER,
				'CDOPERADOR': getLocalVar('CDOPERADOR'),
				'ITENS_SELECIONADOS': checkedRows
            };
            
        return parametros;
    };
    
    var getMessageForAlteracaoAutomaticaDataEntrega = function(widgetAltAutomaticaDataEntrega) {
    	var checkedRows = widgetAltAutomaticaDataEntrega.getParent().dataSource.getCheckedRows(),
    		stMsgConf = 'Confirmar alteração da data de entrega dos itens selecionados?',
    		dtMultData;
    	
    	for (var i = checkedRows.length; i--;) {
    		if (dtMultData) {
    			if (dtMultData != checkedRows[i].DTPROGENTR) {
    				stMsgConf = 'Houve seleção de entregas distintas para alteração automática. Deseja confirmar a operação?';
    				break;
    			}
    		} else {
               dtMultData = checkedRows[i].DTPROGENTR;
    		}
    	}
    	
    	return stMsgConf;
    };
    
    this.confirmaAlteracaoAutomaticaDataEntrega = function(widgetAltAutomaticaDataEntrega) {
    	if (widgetAltAutomaticaDataEntrega.isValid()) {
    		var message = getMessageForAlteracaoAutomaticaDataEntrega(widgetAltAutomaticaDataEntrega);
    		
    		ScreenService.confirmMessage(message, 'CONFIRMATION', function(success) {
			    var parametros = montaParametrosAlteracaoAutomaticaDataEntrega(widgetAltAutomaticaDataEntrega);
			
				General.callRestEngine("cmp_solicitacao#/alteracao_automatica_data_entrega", "Row", parametros).then(
					function(success) {
						closePopupAndReloadGrid(widgetAltAutomaticaDataEntrega);
					},
					function(err) {
						MessageService.showMessageByCode(err.data ? 'cmp#' + err.data.error : 'Timeout', null, { type: 'ERROR' });
					});
			});
    	}
    };
    
    /**
     * ########################################################################
     * ############## >>> ATUALIZAÇÃO AUTOMÁTICA DE PRODUTO <<< ###############
     * ########################################################################
     */
     
	var validaRegraQuantidadeVolume = function(widget) {
		var fieldQtdVolume = widget.getField('QUANTIDADE_VOLUMES'),
			fieldHabQtdVolume = widget.getField('HABILITAR_QTD_VOL');
			
		if (paramsParaSupri.IDUTQTDEVOLU === 'N') {
			fieldHabQtdVolume.isVisible = false;
			fieldHabQtdVolume.checked = false;
			
			fieldQtdVolume.isVisible = false;
			fieldQtdVolume.readOnly = true;
		} else {
			fieldHabQtdVolume.isVisible = true;
			fieldQtdVolume.isVisible = true;
		}
	};
	
	this.openWidgetAlteracaoAutomaticaProduto = function(widget) {
		var popUpWidget = widget.getParent().getWidget('alteracao_automatica_produto_widget'),
			fieldProduto = popUpWidget.getField('NMPRODUTO'),
			fieldQtd = popUpWidget.getField('QUANTIDADE_CAD'),
			fieldQtdVolume = popUpWidget.getField('QUANTIDADE_VOLUMES');
		
		popUpWidget.newRow();
		
		fieldProduto.readOnly = true;
		fieldQtd.readOnly = true;
		fieldQtdVolume.readOnly = true;
		
		fieldProduto.validations = {};
		fieldQtd.validations = {};
		fieldQtdVolume.validations = {};
		
		popUpWidget.getField('AJUSTE_UNIDADE').isVisible = false;
		popUpWidget.getField('AJUSTE_QUANTIDADE').isVisible = false;
		
		popUpWidget.getField('HABILITAR_PROD').setValue('N');
		popUpWidget.getField('HABILITAR_QTD').setValue('N');
		popUpWidget.getField('HABILITAR_QTD_VOL').setValue('N');
		
		if(paramsParaSupri.IDAUDALTSOL == 'S') {
			popUpWidget.getField("TIPOJUST").isVisible = true;
			popUpWidget.getField("DSJUSTOPER").isVisible = true;
		
			popUpWidget.currentRow.TIPOJUST = 'P';
			popUpWidget.currentRow.DSJUSTOPER = '';
			
			popUpWidget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
			
			popUpWidget.getField("DSJUSTOPER").reload();
		} else {
			popUpWidget.getField("TIPOJUST").isVisible = false;
			popUpWidget.getField("DSJUSTOPER").isVisible = false;
		}
		
		
		
	    ScreenService.openPopup(popUpWidget);
	};
	
	this.habilitarFieldsPercentual = function(widget, fieldToToggle, defaultValue) {
		var habilitarQtdIsChecked = widget.getField('HABILITAR_QTD').checked;
		var habilitarProdIsChecked = widget.getField('HABILITAR_PROD').checked;
		
		const widgetAlt = templateManager.container.getWidget("alteracao_automatica_produto_widget");
		const widgetGrid = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
		
		var checkedRowsGrid = widgetGrid.getCheckedRows();
			
		this.toggleField(widget, fieldToToggle, defaultValue);
		
		var positiveRows = checkedRowsGrid.filter(function(row) {
	    	return (row.IDTIPLAN === 'M');
	    });
	    var negativeRows = checkedRowsGrid.filter(function(row) {
	    	return (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C');
	    });
		var rowsToMessage = [];
	    var stringProd = "";
	    
	    
		if(fieldToToggle === "QUANTIDADE_CAD") {
			if(paramsParaSupri.IDBLOQALTSOLAUT === 'S') {
				if(!permissionsArray.AUMENTAR_QUANTIDADE && !permissionsArray.DIMINUIR_QUANTIDADE) {
	    			if(positiveRows.length != checkedRowsGrid.length) {
	    				negativeRows.forEach(row => {
							var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
										
							rowsToMessage.push(prod);
						});
									
						stringProd = rowsToMessage.join("<br>");
					
						widgetAlt.getField("QUANTIDADE_CAD").setValue("");
						widgetAlt.getField("QUANTIDADE_CAD").readOnly = true;
						widgetAlt.getField("HABILITAR_QTD").setValue('N');
							
						delete widgetAlt.getField("QUANTIDADE_CAD").validations;
							
						habilitarQtdIsChecked = false;
						
						MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS", { PRODUTOS: stringProd }).then(confirmed => {
							ScreenService.closePopup(true);
								
							widgetGrid.reload().then(function() {
								widgetGrid.activate();
							});
						});
	    			}
				}
			} else {
				/**if(positiveRows.length != checkedRowsGrid.length) {
	    			negativeRows.forEach(row => {
						var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
										
						rowsToMessage.push(prod);
					});
									
					stringProd = rowsToMessage.join("<br>");
					
					widgetAlt.getField("QUANTIDADE_CAD").setValue("");
					widgetAlt.getField("QUANTIDADE_CAD").readOnly = true;
					widgetAlt.getField("HABILITAR_QTD").setValue('N');
							
					delete widgetAlt.getField("QUANTIDADE_CAD").validations;
							
					habilitarQtdIsChecked = false;
						
					MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS", { PRODUTOS: stringProd }).then(confirmed => {
						ScreenService.closePopup(true);
								
						widgetGrid.reload().then(function() {
							widgetGrid.activate();
						});
					});
	    		}**/
			}
		}
		
		if (habilitarProdIsChecked && !habilitarQtdIsChecked) {
			widget.currentRow.AJUSTE_UNIDADE = '0';
			widget.currentRow.AJUSTE_QUANTIDADE = '0';
			
			widget.getField('AJUSTE_UNIDADE').isVisible = true;
			widget.getField('AJUSTE_QUANTIDADE').isVisible = true;
		} else {
			delete widget.currentRow.AJUSTE_UNIDADE;
			delete widget.currentRow.AJUSTE_QUANTIDADE;
			
			widget.getField('AJUSTE_UNIDADE').isVisible = false;
			widget.getField('AJUSTE_QUANTIDADE').isVisible = false;
		}
	};
    
    this.realizaCalculoPorcentagens = function(widgetAltAutomaticaProd, cdProdutoOld) {
    	var ajustes,
    		fieldAjusteUnidade = widgetAltAutomaticaProd.getField('AJUSTE_UNIDADE'),
    		fieldAjusteQuantidade = widgetAltAutomaticaProd.getField('AJUSTE_QUANTIDADE'),
    		row = {
	    		'CDPRODUTO_OLD': cdProdutoOld,
	    		'CDARVPROD': widgetAltAutomaticaProd.currentRow.CDARVPROD
    		};
    	
    	return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/calcular_ajustes', 'Row', row).then(function(success) {
    			ajustes = success.dataset.data[0];
    			
    			if (ajustes.AJUSTEUN) {
    				if(ajustes.AJUSTEUN == 0 || ajustes.AJUSTEUN == null)
    					fieldAjusteUnidade.setValue('0');
    				else
    					fieldAjusteUnidade.setValue(ajustes.AJUSTEUN);
    				fieldAjusteUnidade.reload();
    			} else {
    				fieldAjusteUnidade.setValue('0');
    			}
    			
    			if (ajustes.AJUSTEQTDE) {
    				if(ajustes.AJUSTEQTDE == 0 || ajustes.AJUSTEQTDE == null)
    					fieldAjusteQuantidade.setValue('0');
    				else
    					fieldAjusteQuantidade.setValue(ajustes.AJUSTEQTDE);
    				fieldAjusteQuantidade.reload();
    			} else {
    				fieldAjusteQuantidade.setValue('0');
    			}
    			fieldAjusteUnidade.reload();
    			fieldAjusteQuantidade.reload();
	        },
	        function(err) {
	            ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
	        });
    };
    
    this.verificaProduto = function(fieldProduto) {
    	var widgetAltAutomaticaProd = fieldProduto.getParent(),
    		widgetGrid = widgetAltAutomaticaProd.getParent(),
    		checkedRowsGrid = widgetGrid.dataSource.getCheckedRows();
    	
    	if (!Util.isEmptyOrBlank(widgetAltAutomaticaProd.currentRow.CDARVPROD)) {
	    	for (var i = 0; i < checkedRowsGrid.length; i++) {
	    		if (checkedRowsGrid[i].CDARVPROD === widgetAltAutomaticaProd.currentRow.CDARVPROD) {
	    			MessageService.showMessageByCode("NEW_PRODUCT_PRODUCT_ORIGIN");
		    		fieldProduto.clearValue();
		    		return;
	    		}
	    	}
	    	
    		this.realizaCalculoPorcentagens(widgetAltAutomaticaProd, checkedRowsGrid[0].CDARVPROD);
    	} else {
    		widgetAltAutomaticaProd.currentRow.AJUSTE_UNIDADE = '0';
    		widgetAltAutomaticaProd.currentRow.AJUSTE_QUANTIDADE = '0';
    	}
    };
    
    this.onChangeProduto = function(fieldProduto) {
    	this.verificaProduto(fieldProduto);
    };
    
    var montaParametrosAlteracaoAutomaticaProduto = function(widgetAltAutomaticaProd) {
    	var row = widgetAltAutomaticaProd.currentRow,
    		checkedRows = widgetAltAutomaticaProd.getParent().dataSource.getCheckedRows(),
            parametros = {
            	'P_IDBLOQALTSOLAUT': paramsParaSupri.IDBLOQALTSOLAUT,
            	'P_IDPRODUTO': widgetAltAutomaticaProd.getField('HABILITAR_PROD').checked,
				'P_IDQTDE': widgetAltAutomaticaProd.getField('HABILITAR_QTD').checked,
				'P_IDQTDEVOL': widgetAltAutomaticaProd.getField('HABILITAR_QTD_VOL').checked,
				'P_CDPRODUTO': row.CDPRODUTO || '',
				'P_QTDE': row.QUANTIDADE_CAD || '',
				'P_QTDEVOL': row.QUANTIDADE_VOLUMES || '',
				'P_AJUSTEUN': row.AJUSTE_UNIDADE || '',
				'P_AJUSTEQTDE': row.AJUSTE_QUANTIDADE || '',
				'P_FILIPROC': getLocalVar('CDFILIAL'),
				// Código do Produto a ser alterado
				'CDPRODUTO': checkedRows[0].CDPRODUTO,
				'ITENS_SELECIONADOS': checkedRows,
				'CDOPERADOR': getLocalVar('CDOPERADOR'),
                'NRORG': getLocalVar('NRORG')
            };
            
        return parametros;
    };
    
    var acionaAlteracaoAutomaticaProduto = function(widgetAltAutomaticaProd) {
    	const widget = widgetAltAutomaticaProd;
    	const checkedRows = widgetAltAutomaticaProd.getParent().dataSource.getCheckedRows();
    	const approvedRows = checkedRows.filter(function(row) {
    		return 	row.IDTIPLAN === 'M';
    	});
    	
    	var percentToBlock;
		var newQTSOLIPROD = widget.currentRow.QUANTIDADE_CAD.replaceAll('.', '').replaceAll(',', '.');
		var approvedRowsQTD = [], repprovedRowsQTD = [];
		var rowsToMessageQTD = [];
	    var stringProdQTD = "";
		            
		newQTSOLIPROD = parseFloat(newQTSOLIPROD);
    	
    	if(widget.currentRow.HABILITAR_PROD === 'S' && widget.currentRow.HABILITAR_QTD === 'N') {
    		if(paramsParaSupri.IDBLOQALTSOLAUT == 'S') {
    			if(permissionsArray.ALTERAR_PRODUTO) {
    				ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
						General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
							closePopupAndReloadGrid(widgetAltAutomaticaProd);
						}, function(err) {
							ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
						});
					});
    			} else {
    				ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    			parametros.ITENS_SELECIONADOS = approvedRows;
		    			
						General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
							closePopupAndReloadGrid(widgetAltAutomaticaProd);
						}, function(err) {
							ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
						});
					});
    			}
    		} else {
    			ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    		var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    		//parametros.ITENS_SELECIONADOS = approvedRows;
		    			
					General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
						closePopupAndReloadGrid(widgetAltAutomaticaProd);
					}, function(err) {
						ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
					});
				});
    		}
    	} else if(widget.currentRow.HABILITAR_PROD === 'N' && widget.currentRow.HABILITAR_QTD === 'S') {
    		if(paramsParaSupri.IDBLOQALTSOLAUT == 'S') {
    			if(permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE) {
    				if(newQTSOLIPROD == 0) {
	    				MessageService.showMessageByCode("QTD_MAIOR_ZERO");
	    			} else {
	    				checkedRows.forEach(function(row) {
	    					if(row.IDTIPLAN === 'M') {
	    						approvedRowsQTD.push(row);
	    					} else {
	    						var oldQTSOLIPROD = row.QTSOLIPROD.replaceAll('.', '').replaceAll(',', '.');
	    						
		    					oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
		    					
		    					if((newQTSOLIPROD > oldQTSOLIPROD) && permissionsArray.AUMENTAR_QUANTIDADE) {
		    						if(permissionsArray.percentAumentar != null && permissionsArray.percentAumentar != undefined) {
		    							percentToBlock = oldQTSOLIPROD + (oldQTSOLIPROD * (parseFloat(permissionsArray.percentAumentar) / 100));
		    							
		    							if(newQTSOLIPROD > percentToBlock) {
					                        repprovedRowsQTD.push(row);
					                    } else {
					                        approvedRowsQTD.push(row);
					                    }
		    						} else {
		    							approvedRowsQTD.push(row);
		    						}
		    					} else if((newQTSOLIPROD < oldQTSOLIPROD) && permissionsArray.DIMINUIR_QUANTIDADE) {
		    						if(permissionsArray.percentDiminuir != null && permissionsArray.percentDiminuir != undefined) {
		    							percentToBlock = oldQTSOLIPROD - (oldQTSOLIPROD * (parseFloat(permissionsArray.percentDiminuir) / 100));
					                        
					                    if(newQTSOLIPROD < percentToBlock) {
					                    	repprovedRowsQTD.push(row);
					                    } else {
					                        approvedRowsQTD.push(row);
					                    }
		    						} else {
		    							approvedRowsQTD.push(row);
		    						}
		    					} else if(newQTSOLIPROD == oldQTSOLIPROD) {
		    						approvedRowsQTD.push(row);
		    					}
	    					}
	    				});
	    				
	    				if(approvedRowsQTD.length == checkedRows.length) {
	    					ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
				    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
				    			
								General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
									closePopupAndReloadGrid(widgetAltAutomaticaProd);
								}, function(err) {
									ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
								});
							});
	    				} else {
	    					rowsToMessageQTD = [];
	    					
	    					stringProdQTD = "";
	    					
	    					repprovedRowsQTD.forEach(row => {
								var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
										
								rowsToMessageQTD.push(prod);
							});
									
							stringProdQTD = rowsToMessageQTD.join("<br>");
							
							MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS_QTD", { PRODUTOS: stringProdQTD });
	    				}
	    			}
    			} else {
    				ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    			parametros.ITENS_SELECIONADOS = approvedRows;
		    			
						General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
							closePopupAndReloadGrid(widgetAltAutomaticaProd);
						}, function(err) {
							ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
						});
					});
    			}
    		} else {
    			ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    		var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    		//parametros.ITENS_SELECIONADOS = approvedRows;
		    			
					General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
						closePopupAndReloadGrid(widgetAltAutomaticaProd);
					}, function(err) {
						ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
					});
				});
    		}
    	} else {
    		if(paramsParaSupri.IDBLOQALTSOLAUT == 'S') {
    			if(permissionsArray.ALTERAR_PRODUTO && (permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE)) {
    				if(newQTSOLIPROD == 0) {
	    				MessageService.showMessageByCode("QTD_MAIOR_ZERO");
	    			} else {
	    				checkedRows.forEach(function(row) {
	    					if(row.IDTIPLAN === 'M') {
	    						approvedRowsQTD.push(row);
	    					} else {
	    						var oldQTSOLIPROD = row.QTSOLIPROD.replaceAll('.', '').replaceAll(',', '.');
	    						
		    					oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
		    					
		    					if((newQTSOLIPROD > oldQTSOLIPROD) && permissionsArray.AUMENTAR_QUANTIDADE) {
		    						if(permissionsArray.percentAumentar != null && permissionsArray.percentAumentar != undefined) {
		    							percentToBlock = oldQTSOLIPROD + (oldQTSOLIPROD * (parseFloat(permissionsArray.percentAumentar) / 100));
		    							
		    							if(newQTSOLIPROD > percentToBlock) {
					                        repprovedRowsQTD.push(row);
					                    } else {
					                        approvedRowsQTD.push(row);
					                    }
		    						} else {
		    							approvedRowsQTD.push(row);
		    						}
		    					} else if((newQTSOLIPROD < oldQTSOLIPROD) && permissionsArray.DIMINUIR_QUANTIDADE) {
		    						if(permissionsArray.percentDiminuir != null && permissionsArray.percentDiminuir != undefined) {
		    							percentToBlock = oldQTSOLIPROD - (oldQTSOLIPROD * (parseFloat(permissionsArray.percentDiminuir) / 100));
					                        
					                    if(newQTSOLIPROD < percentToBlock) {
					                    	repprovedRowsQTD.push(row);
					                    } else {
					                        approvedRowsQTD.push(row);
					                    }
		    						} else {
		    							approvedRowsQTD.push(row);
		    						}
		    					} else if(newQTSOLIPROD == oldQTSOLIPROD) {
		    						approvedRowsQTD.push(row);
		    					}
	    					}
	    				});
	    				
	    				if(approvedRowsQTD.length == checkedRows.length) {
	    					ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
				    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
				    			
								General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
									closePopupAndReloadGrid(widgetAltAutomaticaProd);
								}, function(err) {
									ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
								});
							});
	    				} else {
	    					rowsToMessageQTD = [];
	    					
	    					stringProdQTD = "";
	    					
	    					repprovedRowsQTD.forEach(row => {
								var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
										
								rowsToMessageQTD.push(prod);
							});
									
							stringProdQTD = rowsToMessageQTD.join("<br>");
							
							MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS_QTD", { PRODUTOS: stringProdQTD });
	    				}
	    			}
    			} else {
    				ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    			var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    			parametros.ITENS_SELECIONADOS = approvedRows;
		    			
						General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
							closePopupAndReloadGrid(widgetAltAutomaticaProd);
						}, function(err) {
							ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
						});
					});
    			}
    		} else {
    			ScreenService.confirmMessage('Os itens selecionados serão atualizados com os valores informados. Deseja confirmar a operação?', 'CONFIRMATION', function(success) {
		    		var parametros = montaParametrosAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
		    			
		    		//parametros.ITENS_SELECIONADOS = approvedRows;
		    			
					General.callRestEngine("cmp_solicitacao#/alteracao_automatica_produto", "Row", parametros).then( function(success) {
						closePopupAndReloadGrid(widgetAltAutomaticaProd);
					}, function(err) {
						ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
					});
				});
    		}
    	}
    };
    
    this.confirmaAlteracaoAutomaticaProduto = function(widgetAltAutomaticaProd) {
    	var quantidade = widgetAltAutomaticaProd.currentRow.QUANTIDADE_CAD,
    		fieldHabProduto = widgetAltAutomaticaProd.getField('HABILITAR_PROD'),
    		cdProdutoOld = widgetAltAutomaticaProd.getParent().dataSource.checkedRows[0].CDARVPROD,
    		fieldsAtivos;
    	
    	if (widgetAltAutomaticaProd.isValid()) {
    		fieldsAtivos = widgetAltAutomaticaProd.fields.filter(function(field) {
    			return (field.name === 'NMPRODUTO' || field.name === 'QUANTIDADE_CAD') && field.isVisible === true && field.readOnly === false;
    		});
    		
			if (fieldsAtivos.length === 0) {
				MessageService.showMessageByCode("MINIMUM_ATTRIBUTE_REQUIRED");
				return;
			}
			
			if (quantidade && quantidade === '0') {
				MessageService.showMessageByCode("QTD_MAIOR_ZERO");
			} else if (fieldHabProduto.checked) {
				this.realizaCalculoPorcentagens(widgetAltAutomaticaProd, cdProdutoOld).then(function(success) {
					acionaAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
				}).catch(function(err) {
					ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
				});
			} else {
				acionaAlteracaoAutomaticaProduto(widgetAltAutomaticaProd);
			}
    	}
    };
	
	this.habilitarProduto = function(widgetAltAutomaticaProd) {
		var widgetGrid = widgetAltAutomaticaProd.getParent(),
			checkedRowsGrid = widgetGrid.dataSource.getCheckedRows(),
			produtoBase = checkedRowsGrid[0],
			permiteOperacao = true;
		
		
    	for (var i = 0; i < checkedRowsGrid.length; i++) {
    		if (checkedRowsGrid[i].CDARVPROD.length < 10) {
				MessageService.showMessageByCode("COMPLETE_LEVEL_REQUIRED");
				widgetAltAutomaticaProd.getField('HABILITAR_PROD').setValue('N');
				permiteOperacao = false;
	    		break;
    		}
    		
    		if (checkedRowsGrid[i].CDARVPROD !== produtoBase.CDARVPROD) {
				MessageService.showMessageByCode("OPR_BLOCK_DIF_PRODUCTS");
				widgetAltAutomaticaProd.getField('HABILITAR_PROD').setValue('N');
				permiteOperacao = false;
	    		break;
    		}
    	}
    	
    	if (permiteOperacao) {
    		if(paramsParaSupri.IDBLOQALTSOLAUT === 'S') {
    			if(permissionsArray.ALTERAR_PRODUTO) {
    				this.habilitarFieldsPercentual(widgetAltAutomaticaProd, 'NMPRODUTO', '');
    			} else {
    				var positiveRowsM = checkedRowsGrid.filter(function(row) {
						return (row.IDTIPLAN === 'M');
					});
					
					if(positiveRowsM.length == checkedRowsGrid.length) {
						this.habilitarFieldsPercentual(widgetAltAutomaticaProd, 'NMPRODUTO', '');
					} else {
						var negativeRowsM = checkedRowsGrid.filter(function(row) {
							return (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C');
						});
						
						var rowsToMessageM = [];
						var stringProdM;
						
						negativeRowsM.forEach(row => {
							var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
							
							rowsToMessageM.push(prod);
						});
						
						stringProdM = rowsToMessageM.join("<br>");
						
						MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS", { PRODUTOS: stringProdM }).then(function(confirmed) {
							ScreenService.closePopup(true);
								
							widgetGrid.reload().then(function() {
								widgetGrid.activate();
							});
						});
					}
    			}
    		} else {
    			this.habilitarFieldsPercentual(widgetAltAutomaticaProd, 'NMPRODUTO', '');
    			/**var positiveRows = checkedRowsGrid.filter(function(row) {
					return (row.IDTIPLAN === 'M');
				});
					
				if(positiveRows.length == checkedRowsGrid.length) {
					this.habilitarFieldsPercentual(widgetAltAutomaticaProd, 'NMPRODUTO', '');
				} else {
					var blockedRows = checkedRowsGrid.filter(function(row) {
						return (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C');
					});
						
					var rowsToMessage = [];
					var stringProd;
						
					blockedRows.forEach(row => {
						var prod = "Produto: " + row.PRODUTO + ", Solicitação: " + row.NRSOLICMP;
							
						rowsToMessage.push(prod);
					});
						
					stringProd = rowsToMessage.join("<br>");
						
					MessageService.showMessageByCode("ALTAUTSOL_BLOCK_PRODS", { PRODUTOS: stringProd }).then(function(confirmed) {
						ScreenService.closePopup(true);
								
						widgetGrid.reload().then(function() {
							widgetGrid.activate();
						});
					});
				}**/
    		}
    	}
	};
	
	this.onChangeAjuste = function(field) {
		verifyMinValue(field);
		trataValorNaoPreenchido(field);
	};
	
	this.setStripe = function(args) {
		var widget = args.owner,
            filterRow = args.e.preference.FILTER_ROW;
    	
    	widget.container.getWidget('stripe').getField('STATUS').label = ScreenService.i18n('Status:') + filterRow.ENTREGA;
    	widget.container.getWidget('stripe').getField('NMPRODINI').label = ScreenService.i18n('Produto Inicial:') + filterRow.NMPRODINI;
    	widget.container.getWidget('stripe').getField('NMPRODFIN').label = ScreenService.i18n('Produto Final:') + filterRow.NMPRODFIN;
    };
    
    this.cancelaEditQuantidade = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.verifyQuantidadeEditPermissions = function(widget) {
    	const row = widget.currentRow;
    	
    	if((row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C') && paramsParaSupri.IDBLOQALTSOLAUT === 'S') {
    		var percentToBlock;
    		var newQTSOLIPROD;
    		
    		if(widget.currentRow.QTSOLIPROD_inline && (typeof widget.currentRow.QTSOLIPROD_inline == "string"))
            	newQTSOLIPROD = widget.currentRow.QTSOLIPROD_inline.replaceAll('.', '').replaceAll(',', '.');
            else
            	newQTSOLIPROD = widget.currentRow.QTSOLIPROD.replaceAll('.', '').replaceAll(',', '.');
            	
            var oldQTSOLIPROD = widget.currentRow.QTSOLIORIG.replaceAll('.', '').replaceAll(',', '.');
            
            newQTSOLIPROD = parseFloat(newQTSOLIPROD);
            oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
            
            if(oldQTSOLIPROD == 0) {
            	oldQTSOLIPROD = widget.currentRow.QTSOLIPRODBKP.replaceAll('.', '').replaceAll(',', '.');
            	oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
            }
            
            if(newQTSOLIPROD == 0 && permissionsArray.EXCLUIR_PRODUTO) {
            	return true;
            } else if(permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE) {
    			if((newQTSOLIPROD > oldQTSOLIPROD) && permissionsArray.AUMENTAR_QUANTIDADE) {
                    if(permissionsArray.percentAumentar != null && permissionsArray.percentAumentar != undefined) {
                        percentToBlock = oldQTSOLIPROD + (oldQTSOLIPROD * (parseFloat(permissionsArray.percentAumentar) / 100));
                        
                        if(newQTSOLIPROD > percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MAIOR_PERCENT");
                            
                            widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                            
                            return false;
                        }
                    }
                } else if((newQTSOLIPROD < oldQTSOLIPROD) && permissionsArray.DIMINUIR_QUANTIDADE) {
                    if(permissionsArray.percentDiminuir != null && permissionsArray.percentDiminuir != undefined) {
                        percentToBlock = oldQTSOLIPROD - (oldQTSOLIPROD * (parseFloat(permissionsArray.percentDiminuir) / 100));
                        
                        if(newQTSOLIPROD < percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MENOR_PERCENT");
                            
                            widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                            
                            return false;
                        }
                    }
                } else if(newQTSOLIPROD == oldQTSOLIPROD) {
                    return true;
                } else {
                    MessageService.showMessageByCode("WITHOUT_PERMISSION");
                    
                    widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                    
                    return false;
                }
    		} else {
    			MessageService.showMessageByCode("WITHOUT_PERMISSION");
    			
                widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                
                return false;
    		}
    	}
    };
    
    this.showJustificativaDialog = function(args) {
    	if(paramsParaSupri.IDAUDALTSOL == 'S')
    		MessageService.showMessageByCode("INFORM_JUST_CHANGE");
    };
    
    this.mudaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPER = "";
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.reload().then(() => {
            	widget.activate();
            });
        } else {
            widget.getField("DSJUSTOPER").template = "field/text-edit.html";
            widget.reload().then(() => {
            	widget.activate();
            });
        }
    };
    
    this.verifyInlineEditQuantidade = function(widget) {
    	const row = widget.currentRow;
    	
    	if((row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C') && paramsParaSupri.IDBLOQALTSOLAUT === 'S') {
    		var percentToBlock;
    		var newQTSOLIPROD;
    		
    		if(widget.currentRow.QTSOLIPROD_inline && (typeof widget.currentRow.QTSOLIPROD_inline == "string"))
            	newQTSOLIPROD = widget.currentRow.QTSOLIPROD_inline.replaceAll('.', '').replaceAll(',', '.');
            else
            	newQTSOLIPROD = widget.currentRow.QTSOLIPROD.replaceAll('.', '').replaceAll(',', '.');
            	
            var oldQTSOLIPROD = widget.currentRow.QTSOLIORIG.replaceAll('.', '').replaceAll(',', '.');
            
            newQTSOLIPROD = parseFloat(newQTSOLIPROD);
            oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
            
            if(oldQTSOLIPROD == 0) {
            	oldQTSOLIPROD = widget.currentRow.QTSOLIPRODBKP.replaceAll('.', '').replaceAll(',', '.');
            	oldQTSOLIPROD = parseFloat(oldQTSOLIPROD);
            }
            
            if(newQTSOLIPROD == 0 && permissionsArray.EXCLUIR_PRODUTO) {
            	return;
            } else if(permissionsArray.AUMENTAR_QUANTIDADE || permissionsArray.DIMINUIR_QUANTIDADE) {
    			if((newQTSOLIPROD > oldQTSOLIPROD) && permissionsArray.AUMENTAR_QUANTIDADE) {
                    if(permissionsArray.percentAumentar != null && permissionsArray.percentAumentar != undefined) {
                        percentToBlock = oldQTSOLIPROD + (oldQTSOLIPROD * (parseFloat(permissionsArray.percentAumentar) / 100));
                        
                        if(newQTSOLIPROD > percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MAIOR_PERCENT");
                            
                            widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                        }
                    }
                } else if((newQTSOLIPROD < oldQTSOLIPROD) && permissionsArray.DIMINUIR_QUANTIDADE) {
                    if(permissionsArray.percentDiminuir != null && permissionsArray.percentDiminuir != undefined) {
                        percentToBlock = oldQTSOLIPROD - (oldQTSOLIPROD * (parseFloat(permissionsArray.percentDiminuir) / 100));
                        
                        if(newQTSOLIPROD < percentToBlock) {
                            MessageService.showMessageByCode("NECECOMP_QTD_MENOR_PERCENT");
                            
                            widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                        }
                    }
                } else if(newQTSOLIPROD == oldQTSOLIPROD) {
                    return;
                } else {
                    MessageService.showMessageByCode("WITHOUT_PERMISSION");
                    
                    widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
                }
    		} else {
    			MessageService.showMessageByCode("WITHOUT_PERMISSION");
    			
                widget.currentRow.QTSOLIPROD_inline = oldQTSOLIPROD;
    		}
    	}
    };
    
    this.saveInlineEdit = function(widget) {
    	const popupJustificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
    	
    	if(paramsParaSupri.IDAUDALTSOL == 'S') {
			popupJustificativaAlteracao.getField("TIPOJUST").isVisible = true;
			popupJustificativaAlteracao.getField("DSJUSTOPER").isVisible = true;
			
			popupJustificativaAlteracao.currentRow.TIPOJUST = 'P';
			popupJustificativaAlteracao.currentRow.DSJUSTOPER = '';
			
			popupJustificativaAlteracao.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
			
			popupJustificativaAlteracao.getField("DSJUSTOPER").reload().then(() => {
    			ScreenService.openPopup(popupJustificativaAlteracao);
			});
		} else {
			let rows = widget.dataSource.data.filter(row => {
				return row.changed;
			});
	    	let params = [];
	    	
	    	rows.forEach(function(row) {
	    		params.push({
	    			'IDAUDALTSOL'   : paramsParaSupri.IDAUDALTSOL,
					'IDTIPLAN'      : row.IDTIPLAN,
					'IDUTAPROVSOL'  : row.IDUTAPROVSOL,
					'IDPERALTSAPR'  : row.IDPERALTSAPR,
					'IDSOLIAPROV'   : row.IDSOLIAPROV,
					'NRSEQUCONSOL'  : row.NRSEQUCONSOL,
					'QTSOLIPROD'    : row.QTSOLIPROD,
					'QTSOLIORIG'    : row.changed_QTSOLIPROD,
					'CDMARCA'       : row.CDMARCA ? row.CDMARCA : null,
					'CDFILSOLI'     : row.CDFILSOLI,
					'CDFILLAN'      : row.CDFILLAN,
					'NRSOLICMP'     : row.NRSOLICMP,
					'CDPRODUTO'     : row.CDARVPROD,
					'DTPROGENTR'    : row.DTPROGENTR,
					'STATUS'        : row.STATUS,
					'DSJUSTOPER'    : "Alteração Automática",
					'CDOPERADOR'    : getLocalVar('CDOPERADOR'),
					'CDMARCA_OLD'   : row.CDMARCA ? row.CDMARCA : null,
					'CDOPERADOR_OLD': getLocalVar('CDOPERADOR'),
					'CDFILSOLI_OLD' : row.CDFILSOLI,
					'CDFILLAN_OLD'  : row.CDFILLAN,
					'NRSOLICMP_OLD' : row.NRSOLICMP,
					'CDPRODUTO_OLD' : row.CDPRODUTO,
					'DTPROGENTR_OLD': row.DTPROGENTR,
					'QTSOLIPROD_OLD': row.changed_QTSOLIPROD ? row.changed_QTSOLIPROD : row.QTSOLIPROD,
					'STATUS_OLD'    : row.STATUS
	    		});
	    	});
	    	
	    	General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvar_alteracoes_solicitacao', 'Row', params).then(function(success) {
	    		MessageService.showMessageByCode("SALVO_SUCESSO");
	    		
	    		widget.commitInlineEdit();
                widget.list();
        		widget.showCheckbox = true;
            	widget.activate();
	    	}.bind(this), function(err) {
			    ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
	    	});
		}
    };
    
    this.cancelaPopupJust = function(widget) {
    	const popupJustificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
    	const widgetGrid = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
    	
    	ScreenService.closePopup(popupJustificativaAlteracao);
    	
    	widgetGrid.rollbackInlineEdit();
        widgetGrid.list();
    };
    
    this.saveJust = function(widget) {
    	const widgetGrid = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
    	const changedRows = widgetGrid.dataSource.data.filter(row => {
    		return row.changed;	
    	});
    	
    	if(changedRows.length > 0) {
    		const confirmaJustificativaAlteracao = templateManager.container.getWidget("popupConfirmaJustificativaAlteracao");
    		const popupJustificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
    		
    		changedRows.map(val => {
    			val.DSJUSTOPER = popupJustificativaAlteracao.currentRow.DSJUSTOPER;
    		});
    		
            confirmaJustificativaAlteracao.dataSource.data = changedRows;
            confirmaJustificativaAlteracao.reload().then(() => {
            	ScreenService.openPopup(confirmaJustificativaAlteracao);
            });
    	} else {
    		self.cancelaPopupJust(widget);
        }
    };
    
    this.cancelaPopupConfirmJust = function(widget) {
    	ScreenService.closePopup(widget);
    	
    	widget.dataSource.data = [];
    	
    	self.cancelaPopupJust(widget);
    };
    
    this.salvaConfirmacaoJustificativa = function(widget) {
    	const justificativaRow = widget.dataSource.data.filter(row => row.DSJUSTOPER.length == 0 || !row.DSJUSTOPER);
    	const widgetGrid = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
    	const confirmaJustificativaAlteracao = templateManager.container.getWidget("popupConfirmaJustificativaAlteracao");
    	const popupJustificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        
        if(justificativaRow.length == 0) {
        	let rows = widget.dataSource.data;
	    	let params = [];
	    	
	    	rows.forEach(function(row) {
	    		params.push({
	    			'IDAUDALTSOL'   : paramsParaSupri.IDAUDALTSOL,
					'IDTIPLAN'      : row.IDTIPLAN,
					'IDUTAPROVSOL'  : row.IDUTAPROVSOL,
					'IDPERALTSAPR'  : row.IDPERALTSAPR,
					'IDSOLIAPROV'   : row.IDSOLIAPROV,
					'NRSEQUCONSOL'  : row.NRSEQUCONSOL,
					'QTSOLIPROD'    : row.QTSOLIPROD,
					'QTSOLIORIG'    : row.changed_QTSOLIPROD,
					'CDMARCA'       : row.CDMARCA ? row.CDMARCA : null,
					'CDFILSOLI'     : row.CDFILSOLI,
					'CDFILLAN'      : row.CDFILLAN,
					'NRSOLICMP'     : row.NRSOLICMP,
					'CDPRODUTO'     : row.CDARVPROD,
					'DTPROGENTR'    : row.DTPROGENTR,
					'STATUS'        : row.STATUS,
					'DSJUSTOPER'    : row.DSJUSTOPER,
					'CDOPERADOR'    : getLocalVar('CDOPERADOR'),
					'CDMARCA_OLD'   : row.CDMARCA ? row.CDMARCA : null,
					'CDOPERADOR_OLD': getLocalVar('CDOPERADOR'),
					'CDFILSOLI_OLD' : row.CDFILSOLI,
					'CDFILLAN_OLD'  : row.CDFILLAN,
					'NRSOLICMP_OLD' : row.NRSOLICMP,
					'CDPRODUTO_OLD' : row.CDPRODUTO,
					'DTPROGENTR_OLD': row.DTPROGENTR,
					'QTSOLIPROD_OLD': row.changed_QTSOLIPROD ? row.changed_QTSOLIPROD : row.QTSOLIPROD,
					'STATUS_OLD'    : row.STATUS
	    		});
	    	});
	    	
	    	General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvar_alteracoes_solicitacao', 'Row', params).then(function(success) {
	    		MessageService.showMessageByCode("SALVO_SUCESSO");
	    		
	    		ScreenService.closePopup(confirmaJustificativaAlteracao);
                ScreenService.closePopup(popupJustificativaAlteracao);
                    
                confirmaJustificativaAlteracao.dataSource.data = [];
                    
                widgetGrid.commitInlineEdit();
                widgetGrid.list();
        		widgetGrid.showCheckbox = true;
            	widgetGrid.activate();
			}.bind(this), function(err) {
			    ScreenService.showMessage(err.data ? err.data.error : 'Timeout', 'error');
			    
			    ScreenService.closePopup(confirmaJustificativaAlteracao);
                ScreenService.closePopup(popupJustificativaAlteracao);
                    
                confirmaJustificativaAlteracao.dataSource.data = [];
                    
                widgetGrid.rollbackInlineEdit();
                widgetGrid.list();
                widgetGrid.showCheckbox = true;
                widgetGrid.activate();
			});
        } else {
        	MessageService.showMessageByCode("PREENCHER_JUSTIFICATIVA");
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp06900AlteracaoAutomaticaSolicitacaoComprasController', Cmp06900AlteracaoAutomaticaSolicitacaoComprasController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/js/controllers/cmp07400controle_de_alteracao_solicitacao_comprasController.js
var cmp07400controle_de_alteracao_solicitacao_comprasController = function(General,ScreenService,templateManager, ZhFilterPreferences, Utilities) {
	
	this.setFilterInitValues = function(widget) {
		var filterRow = {
			"NMFILIAL": getLocalVar('NMFILIAL'),
			"CDFILIAL": getLocalVar('CDFILIAL'),
		    "DTENTREGA": {
		    	"start": moment().format('L'),
		        "end": moment().format('L'),
		    },
		    "DTSOLICITACAO": {
		    	"start": moment().format('L'),
		    	"end": moment().format('L')
		    }
		};
		
		ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    this.widgetOnEnter = function(widget) {
        //widget.getField("NMFILIAL").filterProperties.readOnly = (window.projectCorp) ? false : true;
        widget.getField("NMFILIAL").filterProperties.readOnly = false;
        this.createDsFilterUS(widget.getField('NMFILIAL'));
    	var filterRow = {
    	    DTSOLICITACAO : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    },
    	    DTENTREGA : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    }
    	    
        };

    	Utilities.startFilter(widget, filterRow);
    };

//set values in stripe
	this.setStripe = function (widget) {
		var filterRow = angular.copy(widget.appliedFilter.FILTER_ROW);
		var stripe = widget.container.getWidget('stripe');
		
		stripe.currentRow.UNIDADESOL	 = Array.isArray(filterRow.NMFILIAL) ? filterRow.NMFILIAL.join(', ') : ScreenService.i18n("Todas");
		stripe.currentRow.SOLICITACAO 	 = Array.isArray(filterRow.NRSOLICITA) ? filterRow.NRSOLICITA.join(', ') : ScreenService.i18n("Todas");
		stripe.currentRow.DTENTREGASTRIPE= (filterRow.DTENTREGA.start && filterRow.DTENTREGA.end)? filterRow.DTENTREGA.formattedStart + ' - ' + filterRow.DTENTREGA.formattedEnd : ScreenService.i18n("Todas"); 
		stripe.currentRow.DTSOLISTRIPE	 = (filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end) ? filterRow.DTSOLICITACAO.formattedStart + ' - ' + filterRow.DTSOLICITACAO.formattedEnd : ScreenService.i18n("Todas");
		
		if(widget._filterInfo && widget._filterInfo[0] && widget._filterInfo[0].value === ""){
			widget._filterInfo[0].value = ScreenService.i18n("Todas");
		}
		// widget needs to be activated to show checked event
		widget.reload().then(function(success){
			widget.activate();
		});
	};

//validate checkbox for all/list
    this.selectTodosLista = function (field) {
		if(field.checked) {
			field.widget.getField(field.name.substring(2,field.name.length)).clearValue();
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = true;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = {};
		} else {
			field.widget.getField(field.name.substring(2,field.name.length)).readOnly = false;
			field.widget.getField(field.name.substring(2,field.name.length)).validations = { "required": {} };
		}
	};
	
	
	this.setTodas = function (field) {
		if(field.value()===null){
			field.setValue(" ");
			field.mask ={};
		}
	};
//validate filter (grid) confirmation
	this.filterSolicitaGrid = function(args) {
		var filterRow = angular.copy(args.e.preference.FILTER_ROW);

		// filterRow.CDFILIAL = getLocalVar('CDFILIAL');
		
		/* 
		Devido a execução assíncrona do 'then' e a necessidade do P_NRLISTAFIL,
		foi necessário forçar a inclusão do CUSTOM_FILTER_ROW para impedir que
		o filtro do Zeedhi use os dados do FILTER_ROW para executar o dataSource 
		(ocasionava erro na chamada caso passasse) e forçar a execução do filtro
		através do dataSourceFilter.A feta a forma de recuperar os dados no 
		this.setStripe
		*/
		
		if(Array.isArray(filterRow.NMFILIAL) && filterRow.NMFILIAL.length){
			filterRow.CDFILIAL = filterRow.NMFILIAL.join('_');
		}else{
			filterRow.CDFILIAL = 'T';
		}
		
		// args.e.preference.CUSTOM_FILTER_ROW = {};
		
		filterRow.NMGRUPFILI = filterRow.CDGRUPFILI ? filterRow.CDGRUPFILI : null;
		return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/setgrid','Row',filterRow).then(function(callback) {
		//	var DTSOLICITACAO = typeof filterRow.DTSOLICITACAO === "undefined" || typeof filterRow.DTSOLICITACAO.formattedStart === "undefined" ? true : false;
		//	var DTENTREGA = typeof filterRow.DTENTREGA === "undefined" || typeof filterRow.DTENTREGA.formattedStart === "undefined" ? true : false;
		
		var P_DTENTRINI = filterRow.DTENTREGA.start ?  filterRow.DTENTREGA.start : null ;
		var P_DTENTRFIM = filterRow.DTENTREGA.end ?  filterRow.DTENTREGA.end : null ;
		var P_DTSOLINI = filterRow.DTSOLICITACAO.start ?  filterRow.DTSOLICITACAO.start : null ;
		var P_DTSOLFIM = filterRow.DTSOLICITACAO.start ?  filterRow.DTSOLICITACAO.end : null ;
		var P_TENTREGA = (filterRow.DTENTREGA.start && filterRow.DTENTREGA.end) ?  null : 'T' ;
		var P_TSOLICITA = (filterRow.DTSOLICITACAO.start && filterRow.DTSOLICITACAO.end) ?  null : 'T' ;
			args.owner.dataSourceFilter = [
				{
					'name': 'P_NRLISTAFIL',
					'operator': '=',
					'value': callback.dataset.NrLista[0]
				},
				{
					'name': "P_DTENTRINI",
					'operator': '=',
					'value':  P_DTENTRINI
				},
				{
					'name': "P_DTENTRFIM",
					'operator': '=',
					'value': P_DTENTRFIM
				},
				{
					'name': "P_TENTREGA",
					'operator': '=',
					'value': P_TENTREGA 
				},
				{
					'name': "P_NRSOLICMP",
					'operator': '=',
					'value': Array.isArray(filterRow.NRSOLICITA) ? filterRow.NRSOLICITA.join('_') : null
				},
				{
					'name': "P_TNRSOLICMP",
					'operator': '=',
					'value': (filterRow.NRSOLICITA !== undefined && filterRow.NRSOLICITA.length > 0) ? '' : 'T'
				},
				{
					'name': "P_DTSOLINI",
					'operator': '=',
					'value': P_DTSOLINI
				},
				{
					'name': "P_DTSOLFIM",
					'operator': '=',
					'value': P_DTSOLFIM
				},
				{
					'name': "P_TSOLICITA",
					'operator': '=',
					'value': P_TSOLICITA
				},
				{
					'name': 'NRORG',
					'operator': '=',
					'value': getLocalVar('NRORG')
				}
			];
			
			args.owner.reload();
			
		}, function(err) {
			ScreenService.showMessage(err.data.error);
		});
		
	};
	
//create filter for 'Unidades Solicitantes' fields
	this.createDsFilterUS = function (field) {
		var grup;
		if(!field.widget.currentRow.CDGRUPFILI){
			field.dataSource.name = "cmp#/crud/filial_filioper_regiao";
            field.dataSourceFilter = [
            	{
            		"name": "P_CDOPERADOR",
            		"operator": "=",
                    "value": "@getLocalVar('CDOPERADOR')@"
                },
                {
                	"name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('NRORG')@"
                },
                {
                    "operator": "ORDER_BY",
                    "name": [
                        {
                            "name": "CDFILIAL",
                            "direction": "ASC"
                        }
                    ]
                }
            ];
		}
		else{
			grup = field.widget.currentRow.CDGRUPFILI;
			field.dataSource.name = "cmp#/crud/filial_agrup_oper";
            field.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            },
	            {
	                "name": "CDGRUPFILI", 
	                "operator": "=", 
	                "value": grup
	            }
        	];
		}
		
		 field.reload();
	};
//create filter for 'Solicitação' field
	this.createDsFilter = function (field) {
		
			field.dataSourceFilter = [
				{
					'name' : 'P_CDAGRUPFILI',
					'operator': '=',
					'value': field.widget.currentRow.CDGRUPFILI
				},
				{
					'name' : 'P_CDFILSOLI',
					'operator': '=',
					'value': field.widget.currentRow.T_NMFILIAL === 'L' ? field.widget.currentRow.NMFILIAL.join('_') : null
				},
				{
					'name' : 'P_TCDFILSOLI',
					'operator': '',
					'value': field.widget.currentRow.T_NMFILIAL === 'T' ? 'T' : null
				}
			];
			field.reload();
	
	};
	
	function confirmaAlteracoes(widget) {
		var rows = widget.getCheckedRows();
		
		rows[0].SYSDATE = moment().format("DD/MM/YYYY HH:mm:ss");
		rows[0].CDOPERADOR = getLocalVar('CDOPERADOR');
		
		General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/confirmaAlteracao', 'Row', rows).then(function() {
			widget.reload();
			widget.unSelectAll();
		}).catch(function(error) {
			ScreenService.showMessage(error.data.error);
		});
		
	}
	
	
//confirm grid action
	this.confirmGridAction = function(widget){
		
		ScreenService.confirmMessage("Confirmar alteração no(s) item(ns) da(s) solicitação(ões)?", 'question',
	        function(success) {
	            confirmaAlteracoes(widget);
	        },function(error){
	           
        });
	};
	
	//set DataSourceFilter on filial filter
	this.changeGrupFili = function(widget){
		var row = widget.currentRow;
        var CDGRUPFILI;
        var FILIAL = widget.getField('NMFILIAL');
        FILIAL.clearValue();
        widget.getField('NRSOLICITA').clearValue();
        if(widget.getField('GRUPFILI').value()){
            CDGRUPFILI = row.CDGRUPFILI;
            FILIAL.dataSource.name = "cmp#/crud/filial_agrup_oper";
            FILIAL.dataSourceFilter = [
	            {
	                "name": "NRORG", 
	                "operator": "=", 
	                "value": getLocalVar('NRORG')
	            },
	            {
	                "name": "CDOPERADOR", 
	                "operator": "=", 
	                "value": getLocalVar('CDOPERADOR')
	            },
	            {
	                "name": "CDGRUPFILI", 
	                "operator": "=", 
	                "value": CDGRUPFILI
	            }
        	];
        } else { 
        	FILIAL.dataSource.name = "cmp#/crud/filial_filioper_regiao";
            row.CDGRUPFILI = '';
            FILIAL.dataSourceFilter = [
            	{
            		"name": "P_CDOPERADOR",
            		"operator": "=",
                    "value": "@getLocalVar('CDOPERADOR')@"
                },
                {
                	"name": "NRORG",
                    "operator": "=",
                    "value": "@getLocalVar('NRORG')@"
                },
                {
                    "operator": "ORDER_BY",
                    "name": [
                        {
                            "name": "CDFILIAL",
                            "direction": "ASC"
                        }
                    ]
                }
            ];
        }
        
        CDGRUPFILI = CDGRUPFILI === 'T' ? null : CDGRUPFILI;
        widget.getField('NRSOLICITA').dataSourceFilter = [
        	{
                "name": "CDFILIAL", 
                "operator": "=", 
                "value": 'T'
            },
            {
                "name": "P_TCDFILSOLI", 
                "operator": "=", 
                "value": 'T'
            },
            {
                "name": "CDGRUPFILI", 
                "operator": "=", 
                "value": CDGRUPFILI
            }
        ];
        
        FILIAL.reload();
        widget.getField('NRSOLICITA').reload();
	};
	
	this.changeFilial = function(widget){
		var row = widget.currentRow;
        var CDGRUPFILI;
        var FILIAIS;
        var P_TCDFILSOLI;
        
        if(widget.getField('GRUPFILI').value()){
            CDGRUPFILI = row.CDGRUPFILI;
        }else{
            CDGRUPFILI = null;
        }
        
        if(widget.getField('NMFILIAL').value().length){
        	FILIAIS = widget.getField('NMFILIAL').value().join('_');
        	P_TCDFILSOLI = null;
        }else{
        	FILIAIS = 'T';
        	P_TCDFILSOLI = 'T';
        	CDGRUPFILI = CDGRUPFILI === 'T' ? null : CDGRUPFILI;
        }
        
        widget.getField('NRSOLICITA').dataSourceFilter = [
        	{
                "name": "CDFILIAL", 
                "operator": "=", 
                "value": FILIAIS
            },
            {
                "name": "P_TCDFILSOLI", 
                "operator": "=", 
                "value": P_TCDFILSOLI
            },
            {
                "name": "CDGRUPFILI", 
                "operator": "=", 
                "value": CDGRUPFILI
            }
        ];
        widget.getField('NRSOLICITA').clearValue();
        widget.getField('NRSOLICITA').reload();
	};
};

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp07400controle_de_alteracao_solicitacao_comprasController', cmp07400controle_de_alteracao_solicitacao_comprasController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/js/controllers/cmp09500_acompanhamento_de_solicitacao_de_comprasController.js
function cmp09500_acompanhamento_de_solicitacao_de_comprasController(validateEngine, General, ScreenService, templateManager, restEngine, ZhFilterPreferences, ZhUtil, maskEngine, MessageService) {
    let self = this;
    
    
    this.geraRelatorio = function(widget){
        ScreenService.openWindow('cmp_fornecimento_emissaoAutorizacaoFornecimento#sup00700_emissao_de_solicitacao_cotacao_af').then(function() {
            var widAlteracao = templateManager.container.getWidget('sup00700_emissao_de_solicitacao_cotacao_af_widget');
            widAlteracao.ABERTA_POR = 'Acompanhamento de Solicitação de Compras';
        });
    };
    
    
    this.filtrar = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;

        if (self.validaProduto(filterRow.CDARVPRODINI, filterRow.CDARVPRODFIN)) {
            const widget = args.owner;
            const row = {};
            
            if (filterRow.CDARVPRODFIN) {
                const pad = 'ZZZZZZZZZZ';
                const str = filterRow.CDARVPRODFIN;
                filterRow.CDARVPRODFIN = str + pad.substr(0, pad.length - str.length);
            }
        
            row.CDFILSOLI = filterRow.CDFILSOLI;
            row.CDPRODINI = filterRow.CDARVPRODINI ? filterRow.CDARVPRODINI : null;
            row.CDPRODFIN = filterRow.CDARVPRODFIN ? filterRow.CDARVPRODFIN : null;
            row.DTENTRINI = (!Util.isEmptyOrBlank(filterRow.DTPROGENTR.start)) ? filterRow.DTPROGENTR.start : null;
            row.DTENTRFIN = (!Util.isEmptyOrBlank(filterRow.DTPROGENTR.end)) ? filterRow.DTPROGENTR.end : null;
            row.DTSOLIINI = (!Util.isEmptyOrBlank(filterRow.DTHRLANCSOL.start)) ? filterRow.DTHRLANCSOL.start : null;
            row.DTSOLIFIN = (!Util.isEmptyOrBlank(filterRow.DTHRLANCSOL.end)) ? filterRow.DTHRLANCSOL.end : null;
            row.NRORG     = getLocalVar('NRORG');
            row.NRSOLI    = filterRow.NRSOLICMP ? filterRow.NRSOLICMP.join("_") : null;
            row.TCDPROD   = !filterRow.CDARVPRODINI && !filterRow.CDARVPRODFIN ? "T" : null;
            row.TDTENTR   = (row.DTENTRINI && row.DTENTRFIN) ? null : 'T';
            row.TDTSOLI   = (row.DTSOLIINI && row.DTSOLIFIN) ? null : 'T';
            row.TNRSOLI   = (!filterRow.NRSOLICMP) || (Util.isEmptyObject(filterRow.NRSOLICMP)) ? "T" : null;
            
            args.e.preference.CUSTOM_FILTER_ROW = {};
            widget.dataSourceFilter = [
                {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILSOLI  },
                {  'name': 'P_CDPRODINI',	'operator': '=',  'value': row.CDPRODINI  },
                {  'name': 'P_CDPRODFIN',	'operator': '=',  'value': row.CDPRODFIN  },
                {  'name': 'P_DTENTRINI',	'operator': '=',  'value': row.DTENTRINI  },
                {  'name': 'P_DTENTRFIN',	'operator': '=',  'value': row.DTENTRFIN  },
                {  'name': 'P_DTSOLIINI',   'operator': '=',  'value': row.DTSOLIINI  },
                {  'name': 'P_DTSOLIFIN',   'operator': '=',  'value': row.DTSOLIFIN  },
                {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG      },
                {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI     },
                {  'name': 'P_TCDPROD',	    'operator': '=',  'value': row.TCDPROD    },
                {  'name': 'P_TDTENTR',	    'operator': '=',  'value': row.TDTENTR    },
                {  'name': 'P_TDTSOLI',	    'operator': '=',  'value': row.TDTSOLI    },
                {  'name': 'P_TNRSOLI',	    'operator': '=',  'value': row.TNRSOLI    }
            ];
            
            widget.activate();
        }
        
        args.owner.activate();
    }; 
    
    this.setStripe = function(widget) {
        const appliedFilterRow = widget.appliedFilter.FILTER_ROW;
        
        widget._filterInfo = [
            {"label": ScreenService.i18n("Unidade "), "value": appliedFilterRow.NMFILIAL},
            {"label": ScreenService.i18n("Produto Inicial "), "value": appliedFilterRow.NMPRODINI},
            {"label": ScreenService.i18n("Produto Final "), "value": appliedFilterRow.NMPRODFIN}
        ];
        
        widget.container.getWidget("STRIPE").currentRow.UNIDADE = appliedFilterRow.CDFILSOLI + " - " + appliedFilterRow.NMFILIAL;
    };
    
    this.abrirDetalhes = function() {
        const widTabSwipe = templateManager.container.getWidget('tabSwipe');
        
        ScreenService.openSwipe(widTabSwipe).then(function(success) {
            const widItens = templateManager.container.getWidget("itens");
            widItens.activate();
            self.buscaItensSolicitacao(widItens);
        });
    };
    
    this.abrirSituacaoCotacao = function(widget) {
        const widCotacao = templateManager.container.getWidget('cotacao');
        
        ScreenService.openSwipe(widCotacao).then(function(success) {
            widCotacao.activate();
            self.buscaSituacaoCotacao(widCotacao);
        });
    };
    
    this.buscaItensSolicitacao = function(widget) {
        const currentRowWidget = widget.getParent().getParent().currentRow;
        const row = {};
        
        row.CDFILSOLI   = currentRowWidget.CDFILSOLI;
        row.CDFILLAN    = currentRowWidget.CDFILLAN;
        row.NRAUTOFORN  = currentRowWidget.NRAUTOFORN ? currentRowWidget.NRAUTOFORN : '';
        row.CDPRODINI   = currentRowWidget.CDPRODINI ? currentRowWidget.CDPRODINI : '';
        row.CDPRODFIN   = currentRowWidget.CDPRODFIN ? currentRowWidget.CDPRODFIN : '';
        row.DTENTR      = currentRowWidget.DTPROGENTR;
        row.DTSOLIINI   = currentRowWidget.DTSOLIINI ? currentRowWidget.DTSOLIINI : '';
        row.DTSOLIFIN   = currentRowWidget.DTSOLIFIN ? currentRowWidget.DTSOLIINI : '';
        row.DTSOLI      = (currentRowWidget.DTSOLIINI && currentRowWidget.DTSOLIFIN) ? '' : 'T';
        row.NRCOMPRA    = currentRowWidget.NRCOMPRA ? currentRowWidget.NRCOMPRA :  '';
        row.NRORG       = getLocalVar('NRORG');
        row.NRSOLI      = currentRowWidget.NRSOLICMP;
        row.TCDPROD     = (currentRowWidget.CDPRODINI && currentRowWidget.CDPRODFIN) ? '' : 'T';
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILSOLI   },
            {  'name': 'P_CDFILLAN',	'operator': '=',  'value': row.CDFILLAN    },
            {  'name': 'P_NRAUTOFORN',	'operator': '=',  'value': row.NRAUTOFORN  },
            {  'name': 'P_CDPRODINI',	'operator': '=',  'value': row.CDPRODINI   },
            {  'name': 'P_CDPRODFIN',	'operator': '=',  'value': row.CDPRODFIN   },
            {  'name': 'P_DTENTR',	    'operator': '=',  'value': row.DTENTR      },
            {  'name': 'P_DTSOLI',      'operator': '=',  'value': row.DTSOLI      },
            {  'name': 'P_DTSOLIINI',   'operator': '=',  'value': row.DTSOLIINI   },
            {  'name': 'P_DTSOLIFIN',   'operator': '=',  'value': row.DTSOLIFIN   },
            {  'name': 'P_NRCOMPRA',    'operator': '=',  'value': row.NRCOMPRA    },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       },
            {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI      },
            {  'name': 'P_TCDPROD',	    'operator': '=',  'value': row.TCDPROD     }
        ];
        
        widget.reload();
    };
    
    this.buscaSituacaoSolicitacao = function(widget) {
        const currentRowWidget = widget.getParent().getParent().currentRow;
        const row = {};
        
        row.CDDESTSOLI = currentRowWidget.CDDESTSOLI;
        row.CDFILLAN   = currentRowWidget.CDFILLAN;
        row.CDFILSOLI  = currentRowWidget.CDFILSOLI;
        row.NRORG      = getLocalVar('NRORG');
        row.NRSOLI     = currentRowWidget.NRSOLICMP;
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDDESTSOLI',	'operator': '=',  'value': row.CDDESTSOLI  },
            {  'name': 'P_CDFILLAN',	'operator': '=',  'value': row.CDFILLAN    },
            {  'name': 'P_CDFILSOLI',	'operator': '=',  'value': row.CDFILSOLI   },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       },
            {  'name': 'P_NRSOLI',	    'operator': '=',  'value': row.NRSOLI      }
        ];
        
        widget.reload();
    };
    
    this.buscaSituacaoCotacao = function(widget) {
        const currentRowWidget = widget.getParent().currentRow;
        const row = {};
        
        row.CDFILIAL     = currentRowWidget.CDFILLANC;
        row.CDPRODUTO    = currentRowWidget.CDPRODUTO;
        row.NRCOLEPRECO  = currentRowWidget.NRNOTAFISC;
        row.NRORG        = getLocalVar('NRORG');
        
        widget.dataSourceFilter = [
            {  'name': 'P_CDFILIAL',	'operator': '=',  'value': row.CDFILIAL    },
            {  'name': 'P_CDPRODUTO',	'operator': '=',  'value': row.CDPRODUTO   },
            {  'name': 'P_NRCOLEPRECO',	'operator': '=',  'value': row.NRCOLEPRECO },
            {  'name': 'P_NRORG',	    'operator': '=',  'value': row.NRORG       }
        ];
        
        widget.reload();
    };
    
    this.filtrarSolicitacao = function(widget) {
        const fieldNrSoliCmp = widget.getField("NRSOLICMP");
        const currentRowWidget = widget.currentRow;
        
        if (currentRowWidget.NMFILIAL && currentRowWidget.NMFILIAL.length !== 0) {
            const tdtSoli = !currentRowWidget.DTINI_SOL && !currentRowWidget.DTFIN_SOL ? "T" : null;
            const tdtEntr = !currentRowWidget.DTINI_ENT && !currentRowWidget.DTFIN_ENT ? "T" : null;

            currentRowWidget.NRSOLICMP = "";
            
            fieldNrSoliCmp.dataSourceFilter = [
                {  'name': 'P_DTSOLIINI',	'operator': '=',    'value': widget.currentRow.DTINI_SOL  },
                {  'name': 'P_DTSOLIFIN',	'operator': '=',    'value': widget.currentRow.DTFIN_SOL  },
                {  'name': 'P_TDTSOLI',		'operator': '=',    'value': tdtSoli                      },
                {  'name': 'P_DTENTRINI',	'operator': '=',    'value': widget.currentRow.DTINI_ENT  },
                {  'name': 'P_DTENTRFIN',	'operator': '=',    'value': widget.currentRow.DTFIN_ENT  },
                {  'name': 'P_TDTENTR',		'operator': '=',    'value': tdtEntr                      },
                {  'name': 'P_CDFILIAL',	'operator': '=',    'value': widget.currentRow.CDFILSOLI  }
            ];
            
            fieldNrSoliCmp.reload();
            fieldNrSoliCmp.readOnly = false;
        } else {
            fieldNrSoliCmp.validations  = {};
            fieldNrSoliCmp.readOnly = true;
            
            currentRowWidget.NRSOLICMP = "";
        }
    };
    
    this.readOnlyData = function(dtInicial, dtFinal) {
        if (!dtInicial.value() && !dtFinal.value()) {
            dtInicial.validations = {};
            dtFinal.validations   = {};
        } else {
            dtInicial.validations = {"required": true};
            dtFinal.validations   = {"required": true};
        }
    };
    
    this.filtrarDatasSolicitacaoEntrega = function(field) {
        if (field.name == 'DTHRLANCSOL' && field.value()) {
            if (field.value().formattedStart > field.value().formattedEnd) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                field.value().formattedStart = "";
                field.value().formattedEnd = "";
            }
        } else if (field.name == 'DTPROGENTR' && field.value()) {
            if(field.value().formattedStart > field.value().formattedEnd) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                field.value().formattedStart = "";
                field.value().formattedEnd = "";
            }    
        }
    };
    
    this.voltar = function(widget) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("itens").activate();
    };
    
    this.closeSwipe = function() {
        ScreenService.closeSwipe();
    };

    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        return true;
    };
    
    // var registeredValidations = validateEngine.getMappedValidations();
    
    // if (!registeredValidations.hasOwnProperty('validaProduto')) {
    //     validateEngine.registerValidation('validaProduto', validaProduto);
    // }

}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp09500_acompanhamento_de_solicitacao_de_comprasController', cmp09500_acompanhamento_de_solicitacao_de_comprasController);
});

// FILE: ./assets/modules/solicitacao/assets/modules/consolidacao/assets/js/controllers/sup00100_consolidacao_de_solicitacao_Controller.js
function sup00100_consolidacao_de_solicitacao_Controller(ScreenService, MessageService, General, localStorageEngine, Parametros, Sup03600PedidoColetaService) {

    var self = this;
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    self.validaProduto = function(prodInicial, prodFinal) {
        
        if (General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            return true;
        }
        MessageService.showMessageByCode("cmp#PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
        return false; 
    };
   
    this.ConsolidarSolicitacao = function(widget) {
        let row = widget.currentRow;
        
        if (widget.isValid()) {
            if (self.validaProduto(row.CDPRODINI, row.CDPRODFIN)) {
                
                prepareRow(row);
                
                General.callRestEngine('cmp_solicitacao_consolidacao#/validaFilial',"Row", row).then(function(res) {
                    ScreenService.showMessage(res.messages[0].message);
                });
            }
        }
    };
    
    function verifiyStringInArray(array, string) {
        if (Array.isArray(array) && array.indexOf(string) > -1) {
            return 'S';
        } else {
            return 'N';
        }
    }
    
    function prepareRow(row) {
        row.CONSISOL      = verifiyStringInArray(row.CONSIDERAR, "CONSISOL");
        row.CONSIAF       = verifiyStringInArray(row.CONSIDERAR, "CONSIAF");
        row.CDFILIALSOL   = verifyArrayIsValid(row.CDFILIALSOL);
        row.CDOPERADOR    = verifyArrayIsValid(row.CDOPERADOR);
        row.NRSOLICMP     = verifyArrayIsValid(row.NRSOLICMP);
        row.CHAVE         = verifyArrayIsValid(row.CHAVE);
        row.CDFILIAIS     = concatArrayForParams(row.CDFILIALSOL, null);
        row.CDFILIALPRINC = row.CDFILIALPRINC ? row.CDFILIALPRINC : '';
        row.CDFILIALEST   = row.CDFILIALEST   ? row.CDFILIALEST   : '';
        row.DATAINI       = row.INTERVAL_DT.start;
        row.DATAFIN       = row.INTERVAL_DT.end;
        row.DTPROCESS     = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY');
        row.CDFILIAL      = getLocalVar('CDFILIAL');
    }
    
    function verifyArrayIsValid(array, defaultReturn = null) {
        if (!Util.isEmptyOrBlank(array)) {
            return Array.isArray(array) ? array : defaultReturn;
        }
    
        return defaultReturn;
    }
    
    self.concatenaFilial = function(arrayFilial){
        var filiais = arrayFilial.join('_');
        return filiais;
    };
    
    this.setEstoque = function(field){
        var widget =  field.widget;
        if(widget.currentRow.CONSIDERAEST == "S"){
            widget.getField('NMFILIALEST').readOnly = false;
            widget.getField('NMFILIALEST').validations = {"required": true};
        }else{
            widget.getField('NMFILIALEST').readOnly = true;
            widget.getField('NMFILIALEST').validations = {};
        }  
    };
    
    this.controlaFields = function(widget){
        widget.currentRow.CDFILIALPRINC = getLocalVar('CDFILIAL');
        widget.currentRow.CDFILIALEST = getLocalVar('CDFILIAL');
        widget.getField('INTERVAL_DT').defaultValue = {
            "start": moment(new Date()).format("DD/MM/YYYY"),
            "end": moment(new Date()).format("DD/MM/YYYY") 
        };
        widget.applyDefaultValue();
        if(widget.currentRow.NMFILIALPRINC && widget.currentRow.INTERVAL_DT){
            widget.getField('SOLICITACAO').readOnly = false;
        }else{
            widget.getField('SOLICITACAO').readOnly = true;
        }
    };
    
    this.setDataFilterSolicitacao = function(field){
        var dataIni = field.widget.currentRow.INTERVAL_DT ? field.widget.currentRow.INTERVAL_DT.start : null;
        var dataFin = field.widget.currentRow.INTERVAL_DT ? field.widget.currentRow.INTERVAL_DT.end : null;
        field.dataSourceFilter = [
            {
                "name": "P_DATAINI",
                "operator": "=",
                "value": dataIni  
            },
            {
                "name": "P_DATAFIN",
                "operator": "=",
                "value": dataFin  
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": this.concatArrayForParams(field.widget.currentRow.CDFILIALSOL)
            },   
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')  
            }    
        ];
        field.reload().then(function(success){
            if(field.dataSource.data.length <= 0){
                MessageService.showMessageByCode("cmp#NAO_HA_DADOS_PER_UNI");
            }
        });
    };
    
    this.controlaFieldSolicitacao = function(widget){
        if(widget.currentRow.NMFILIALPRINC && widget.currentRow.INTERVAL_DT.start && widget.currentRow.INTERVAL_DT.end){
            widget.getField('SOLICITACAO').readOnly = false;
        }else{
            widget.getField('SOLICITACAO').readOnly = true;
        }
    };
    
    
    this.concatArrayForParams = function (arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue || 'T';
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('sup00100_consolidacao_de_solicitacao_Controller', sup00100_consolidacao_de_solicitacao_Controller);
});
